/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawDecomp.c,v 1.2 1994/05/26 19:48:54 vs Exp vs $ */

#include <stdio.h>
#include <ctype.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsFit.h>

#include "DrawDecomp.h"

/*	draws from PIXELmin -> PIXELmax ,CHNmin -> CHNmax 
 *	in each pixel column is drawn only one channel;
 *	all other channels which fall into the same column are omitted
 */


Boolean DrawDecomp(dest, ddecomp, x_scale, y_scale,
		   step_width, min_steps,
		   calibrated, modification, normalized)
     GowDestination dest;
     DrawDecomp_t ddecomp;
     GowScale x_scale;
     GowScale y_scale;
     int step_width;
     int min_steps;
     int calibrated;
     GowScaleModificationType modification;
     int normalized;
{
  DrawPeak_t peak= DrawDecompPeak(ddecomp);
  Fit_t fit= DrawDecompFit(ddecomp);
  Boolean visible= FALSE;
  int p;

  if (!FitTime(fit) || FitFitTyp(fit) != FIT_FTFIT) { return FALSE; }

  GowDComment(dest, "decomposition-start");

  for (p= 0; p< FitPeakNum(fit); p++) {
    if ((DrawPeakPar(peak)= FitPeakFunctionSetup(NULL, fit, FitPar(fit), p))) {
      DrawPeakFct(peak)= FitOptPeakFunction((FitOpt)DrawPeakPar(peak));
      DrawPeakChn(peak)= FitPosVal(fit,p);
      if (DrawPeak(dest, peak, x_scale, y_scale,
		   step_width, min_steps,
		   calibrated, modification, normalized)) {
	visible= TRUE; }
      FitPeakFunctionFinish(DrawPeakPar(peak)); } }

  GowDComment(dest, "decomposition-end");

  return visible;
}

void DrawDecompExpand(ddecomp,
		      x_scale, x_type, x_full,
		      y_scale, y_type, y_full,
		      calibrated, modification, normalized)
     DrawDecomp_t ddecomp;
     GowScale x_scale;
     GowScaleType x_type;
     int x_full;
     GowScale y_scale;
     GowScaleType y_type;
     int y_full;
     int calibrated;
     GowScaleModificationType modification;
     int normalized;
{
  double x_offset, x_range;

  if (y_full &&
      GowGetScaleOffset(x_scale, &x_offset) &&
      GowGetScaleRange(x_scale, &x_range)) {
    DrawPeak_t peak= DrawDecompPeak(ddecomp);
    Fit_t fit= DrawDecompFit(ddecomp);
    int p;

    if (!FitTime(fit) || FitFitTyp(fit) != FIT_FTFIT) { return; }

    for (p= 0; p< FitPeakNum(fit); p++) {
      if ((DrawPeakPar(peak)= FitPeakFunctionSetup(NULL, fit, FitPar(fit), p))) {
	DrawPeakFct(peak)= FitOptPeakFunction((FitOpt)DrawPeakPar(peak));
	DrawPeakChn(peak)= FitPosVal(fit,p);
	DrawPeakExpand(peak,
		       x_scale, x_type, x_full,
		       y_scale, y_type, y_full,
		       calibrated, modification, normalized);
	FitPeakFunctionFinish(DrawPeakPar(peak)); } } }
  return;
}
