/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/DrawHMark.c,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#include <stdio.h>
#include <ctype.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsTools.h>

#include "DrawHMark.h"

Boolean DrawHMark(dest, dmrk, x_scale, y_scale,
		  lft_frac, rgt_frac, cross)
     GowDestination dest;
     DrawHMrk_t dmrk;
     GowScale x_scale;
     GowScale y_scale;
     double lft_frac;
     double rgt_frac;
     double cross;
{
  PVec_t m= DrawHMrkMrk(dmrk);
  Val_t  s= DrawHMrkSgl(dmrk);
  DVec_t v= DrawHMrkVis(dmrk);
  DVecRec used;
  DVec_t u= &used;
  Boolean visible= FALSE;

  GowPixelFunc py;
  int xp_min, xp_max, yp_min, yp_max;
  int x1, x2, xd;
  XSegment *segs;

  if (!VecNum(m) && !VecNum(v) && (!s || !ValDefined(s))) {
    return FALSE; }		/* no HMark defined */

  GowDSet_gc(dest, DrawHMrkGCIdx(dmrk));

  py= GowGetScalePixelFunction(y_scale);
  xp_min= GowGetScaleLimitPixel(x_scale, GowClipSmall);
  xp_max= GowGetScaleLimitPixel(x_scale, GowClipLarge);
  yp_min= GowGetScaleLimitPixel(y_scale, GowToSmall);
  yp_max= GowGetScaleLimitPixel(y_scale, GowToLarge);
  VecInit(u, sizeof(double));

  lft_frac= ABS(lft_frac);
  rgt_frac= ABS(rgt_frac);

  x1= xp_max - (xp_max - xp_min) * lft_frac;
  x2= xp_min + (xp_max - xp_min) * rgt_frac;

  xd= (x1 + x2) / 2;

  if (!(segs= (XSegment *)Malloc(sizeof(XSegment) *
				 (1 + /* single */
				  2 * VecNum(m) + /* pair */
				  3 * VecNum(v))))) { /* delete-cross */
    return FALSE; }

  GowDStart_object(dest, "horizontal-mark");

  { XSegment *seg= segs;

    { int vi;
      for (vi= 0; vi< VecNum(v); vi++) {
	int y_1;
	if (py(x_scale, &x1, VecP(v)[vi]) == GowValid) {
	  seg->x1= x1; seg->y1= y_1; seg->x2= x2; seg->y2= y_1; seg++; } } }

    { int y_1;
      if (s && ValDefined(s) &&
	  py(y_scale, &y_1, ValValue(s)) == GowValid) {
	int vi;
	for (vi= 0; vi< VecNum(v) && ValValue(s) > VecP(v)[vi]; vi++) { ; }
	if ((vi == VecNum(v) || ValValue(s) != VecP(v)[vi]) &&
	    VecInsert(v, vi, 1)) {
	  VecP(v)[vi]= ValValue(s);
	  seg->x1= x1; seg->y1= y_1; seg->x2= x2; seg->y2= y_1; seg++; }
	if (VecInsert(u, 0, 1)) { VecP(u)[0]= ValValue(s); } } }

    { int mi, vi, bi, ui;
      for (mi= 0, vi= 0, bi= 0, ui= 0; mi< VecNum(m); mi++) {
	int y_1, y_2;
	GowScaleConversion yc1, yc2;

	switch (yc1= py(y_scale, &y_1, PVecX1(m,mi))) {
	case GowClipSmall: yc1= GowToSmall;
	case GowToSmall: y_1= yp_min; break;
	case GowClipLarge: yc1= GowToLarge;
	case GowToLarge: y_1= yp_max; break;
	case GowValid: break; }

	switch (yc2= py(y_scale, &y_2, PVecX2(m,mi))) {
	case GowClipSmall: yc2= GowToSmall;
	case GowToSmall: y_2= yp_min; break;
	case GowClipLarge: yc2= GowToLarge;
	case GowToLarge: y_2= yp_max; break;
	case GowValid: break; }

	if (yc1 == GowValid) {
	  while (vi< VecNum(v) && PVecX1(m,mi) > VecP(v)[vi]) { vi++; }
	  if ((vi == VecNum(v) || PVecX1(m,mi) != VecP(v)[vi]) &&
	      VecInsert(v, vi, 1)) {
	    VecP(v)[vi]= PVecX1(m,mi);
	    seg->x1= x1; seg->y1= y_1; seg->x2= x2; seg->y2= y_1; seg++; }
	  while (ui< VecNum(u) && PVecX1(m,mi) > VecP(u)[ui]) { ui++; }
	  if ((ui == VecNum(u) || PVecX1(m,mi) != VecP(u)[ui]) &&
	      VecInsert(u, ui, 1)) {
	    VecP(u)[ui]= PVecX1(m,mi); } }
	if (yc2 == GowValid) {
	  int vj, uj;
	  for (vj= vi; vj< VecNum(v) && PVecX2(m,mi) > VecP(v)[vj]; vj++) { ; }
	  if ((vj == VecNum(v) || PVecX2(m,mi) != VecP(v)[vj]) &&
	      VecInsert(v, vj, 1)) {
	    VecP(v)[vj]= PVecX2(m,mi);
	    seg->x1= x1; seg->y1= y_2; seg->x2= x2; seg->y2= y_2; seg++; }
	  for (uj= ui; uj< VecNum(u) && PVecX2(m,mi) > VecP(u)[uj]; uj++) { ; }
	  if ((uj == VecNum(u) || PVecX2(m,mi) != VecP(u)[uj]) &&
	      VecInsert(u, uj, 1)) {
	    VecP(u)[uj]= PVecX2(m,mi); } }
	if (yc1 == GowToLarge) { break; } } }

    if (cross != 0.0) {
      int ui= 0, vi= 0, cw;
      { int cx, cy;
	cx= (xp_max - xp_min) * cross; cx= ABS(cx);
	cy= (yp_max - yp_min) * cross; cy= ABS(cy);
	cw= MIN(cx, cy); }

      while (vi< VecNum(v) && ui< VecNum(u)) {
	if (VecP(u)[ui] == VecP(v)[vi]) { ui++; vi++; }
	else if (VecP(u)[ui] > VecP(v)[vi]) {
	  int y_1;
	  if (py(y_scale, &y_1, VecP(v)[vi]) == GowValid) {
	    seg->x1= xd-cw; seg->y1= y_1-cw;
	    seg->x2= xd+cw; seg->y2= y_1+cw; seg++;
	    seg->x1= xd+cw; seg->y1= y_1-cw;
	    seg->x2= xd-cw; seg->y2= y_1+cw; seg++; }
	  vi++; } }
      while (vi< VecNum(v)) {
	int y_1;
	if (py(y_scale, &y_1, VecP(v)[vi]) == GowValid) {
	  seg->x1= xd-cw; seg->y1= y_1-cw;
	  seg->x2= xd+cw; seg->y2= y_1+cw; seg++;
	  seg->x1= xd+cw; seg->y1= y_1-cw;
	  seg->x2= xd-cw; seg->y2= y_1+cw; seg++; }
	vi++; } }

    if (seg - segs > 0 && GowDSegments(dest, segs, seg - segs)) {
      visible= TRUE; } }

  GowDEnd_object(dest, "horizontal-mark");

  Free(segs);
  VecFree(u);
  return visible;
}

void DrawHMarkFree(dmrk)
     DrawHMrk_t dmrk;
{
  VecFree(DrawHMrkVis(dmrk));
}

void DrawHMarkInit(dmrk)
     DrawHMrk_t dmrk;
{
  DrawHMrkGCIdx(dmrk)= 0;
  DrawHMrkMrk(dmrk)= NULL;
  DrawHMrkSgl(dmrk)= NULL;
  VecInit(DrawHMrkVis(dmrk), sizeof(double));
}
