/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawLabel.h,v 1.2 1994/05/26 19:48:57 vs Exp vs $ */

#ifndef _DrawLabel_h
#define _DrawLabel_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowTypes.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>

typedef struct _LblRec {
  short int x;
  short int yl;
  short int yt;
  short int yb;
  char *txt;
  int gc;
  int fh;
  int status;
  int idx;
  struct _LblRec *next;
  struct _LblRec *prev;
} LblRec, *Lbl_t;

typedef struct _DrawLblFctRec {
  void *(*next)();
  void *(*prev)();
  int (*gc)();
  char *(*txt)();
  double (*pos)();
  Boolean (*calibrated)();
} DrawLblFctRec, *DrawLblFct_t;

#define DrawLblFctNext(p)	((p)->next)
#define DrawLblFctPrev(p)	((p)->prev)
#define DrawLblFctGC(p)		((p)->gc)
#define DrawLblFctTxt(p)	((p)->txt)
#define DrawLblFctPos(p)	((p)->pos)
#define DrawLblFctCalibrated(p)	((p)->calibrated)

typedef struct _DrawLblRec {
  int gc_idx;
  DrawLblFct_t fct;
  void *lbl;
  Lbl_t vis;
  Lbl_t cur;
  Cal_t cal;
  Spc_t spc;
  double *norm;

  DrawLblFct_t lib_fct;
  void *lib;

  Boolean pos_calib;
  Boolean pos_uncalib;
  Boolean string;
} DrawLblRec, *DrawLbl_t;

#define DrawLblGCIdx(p)		((p)->gc_idx)
#define DrawLblLbl(p)		((p)->lbl)
#define DrawLblFct(p)		((p)->fct)
#define DrawLblVis(p)		((p)->vis)
#define DrawLblCur(p)		((p)->cur)
#define DrawLblCal(p)		((p)->cal)
#define DrawLblSpc(p)		((p)->spc)
#define DrawLblNorm(p)		((p)->norm)
#define DrawLblLib(p)		((p)->lib)
#define DrawLblLibFct(p)	((p)->lib_fct)
#define DrawLblPosCalib(p)	((p)->pos_calib)
#define DrawLblPosUncalib(p)	((p)->pos_uncalib)
#define DrawLblString(p)	((p)->string)

#define DrawLblNext(p)		DrawLblFctNext(DrawLblFct(p))
#define DrawLblPrev(p)		DrawLblFctPrev(DrawLblFct(p))
#define DrawLblGC(p)		DrawLblFctGC(DrawLblFct(p))
#define DrawLblTxt(p)		DrawLblFctTxt(DrawLblFct(p))
#define DrawLblPos(p)		DrawLblFctPos(DrawLblFct(p))
#define DrawLblCalibrated(p)	DrawLblFctCalibrated(DrawLblFct(p))

#define DrawLblLibNext(p)	DrawLblFctNext(DrawLblLibFct(p))
#define DrawLblLibPrev(p)	DrawLblFctPrev(DrawLblLibFct(p))
#define DrawLblLibGC(p)		DrawLblFctGC(DrawLblLibFct(p))
#define DrawLblLibTxt(p)	DrawLblFctTxt(DrawLblLibFct(p))
#define DrawLblLibPos(p)	DrawLblFctPos(DrawLblLibFct(p))
#define DrawLblLibCalibrated(p)	DrawLblFctCalibrated(DrawLblLibFct(p))

#define ForAllVisibleLabels(dlbl,v) for (v= DrawLblVis(dlbl); v; v= v->next)

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawLabel P_((GowDestination dest, DrawLbl_t dlbl,
			     GowScale x_scale, GowScale y_scale,
			     double bot_frac, double top_frac, double cross,
			     double distance, double line,
			     int top_spectrum,
			     int chn_radius, double lib_radius,
			     int calibrated,
			     GowScaleModificationType modification,
			     int normalized));
extern void DrawLabelFree P_((DrawLbl_t dlbl));
extern void DrawLabelInit P_((DrawLbl_t dlbl));
extern int DrawLabelGetIndex P_((DrawLbl_t dlbl, int x, int y));
#undef P_

#endif				/* _DrawLabel_h */
