/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawPeakList.c,v 1.2 1994/05/26 19:48:58 vs Exp vs $ */

#include <stdio.h>
#include <ctype.h>

#include <tv/vsTypes.h>
#include <tv/vsFit.h>
#include <tv/vsFitIo.h>

#include "DrawPeakList.h"

/*	draws from PIXELmin -> PIXELmax ,CHNmin -> CHNmax 
 *	in each pixel column is drawn only one channel;
 *	all other channels which fall into the same column are omitted
 */


Boolean DrawPeakList(dest, dpeaks, x_scale, y_scale,
		     step_width, min_steps,
		     calibrated, modification, normalized)
     GowDestination dest;
     DrawPeakList_t dpeaks;
     GowScale x_scale;
     GowScale y_scale;
     int step_width;
     int min_steps;
     int calibrated;
     GowScaleModificationType modification;
     int normalized;
{
  DrawPeak_t peak= DrawPeakListPeak(dpeaks);
  Fio_t fio= DrawPeakListFio(dpeaks);
  FioPeaVec_t pea= FioPea(fio);
  Boolean visible= FALSE;
  FioCurPeak_t cur= NULL;

  GowDComment(dest, "peak-list-start");

  while ((cur= FioNextPeak(fio, 0.0, -1.0, cur))) {
    switch (FioCurPeakTyp(cur)) {
    case FIO_PBIN: {
      int peaIdx= FioCurPeakPeaIdx(cur);
      if ((DrawPeakPar(peak)= FioPeaPPar(pea,peaIdx))) {
	DrawPeakFct(peak)= FitOptPeakFunction(FioPeaPPar(pea,peaIdx));
	DrawPeakChn(peak)= FioPeaPChn(pea,peaIdx); } }
      break;
    case FIO_PSEA:{
      SeaPeak seaPeak= FioCurPeakSeaPeak(cur);
      DrawPeakPar(peak)= (void *)seaPeak;
      DrawPeakFct(peak)= SeaPeakFunction;
      DrawPeakChn(peak)= SeaPos(seaPeak); }
      break;
    default:
      continue; }

    if (DrawPeakPar(peak)) {
      if (DrawPeak(dest, peak, x_scale, y_scale,
		   step_width, min_steps,
		   calibrated, modification, normalized)) {
	visible= TRUE; } } }

  GowDComment(dest, "peak-list-end");

  return visible;
}

void DrawPeakListExpand(dpeaks,
			x_scale, x_type, x_full,
			y_scale, y_type, y_full,
			calibrated, modification, normalized)
     DrawPeakList_t dpeaks;
     GowScale x_scale;
     GowScaleType x_type;
     int x_full;
     GowScale y_scale;
     GowScaleType y_type;
     int y_full;
     int calibrated;
     GowScaleModificationType modification;
     int normalized;
{
  double x_offset, x_range;

  if (y_full &&
      GowGetScaleOffset(x_scale, &x_offset) &&
      GowGetScaleRange(x_scale, &x_range)) {
    DrawPeak_t peak= DrawPeakListPeak(dpeaks);
    Fio_t fio= DrawPeakListFio(dpeaks);
    FioPeaVec_t pea= FioPea(fio);
    FioCurPeak_t cur= NULL;

    while ((cur= FioNextPeak(fio, 0.0, -1.0, cur))) {
      switch (FioCurPeakTyp(cur)) {
      case FIO_PBIN: {
	int peaIdx= FioCurPeakPeaIdx(cur);
	if ((DrawPeakPar(peak)= (void *)FioPeaPPar(pea,peaIdx))) {
	  DrawPeakFct(peak)= FitOptPeakFunction(FioPeaPPar(pea,peaIdx));
	  DrawPeakChn(peak)= FioPeaPChn(pea,peaIdx); } }
	break;
      case FIO_PSEA: {
	SeaPeak seaPeak= FioCurPeakSeaPeak(cur);
	DrawPeakPar(peak)= (void *)seaPeak;
	DrawPeakFct(peak)= SeaPeakFunction;
	DrawPeakChn(peak)= SeaPos(seaPeak); }
	break;
      default:
	continue; }

      if (DrawPeakPar(peak)) {
	DrawPeakExpand(peak,
		       x_scale, x_type, x_full,
		       y_scale, y_type, y_full,
		       calibrated, modification, normalized); } } }
  return;
}
