/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawResid.c,v 1.2 1994/05/26 19:48:59 vs Exp vs $ */

#include <stdio.h>
#include <ctype.h>
#include <math.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsCal.h>
#include <tv/vsFit.h>
#include <tv/vsSpectra.h>

#include "DrawResid.h"

/*	draws from PIXELmin -> PIXELmax ,CHNmin -> CHNmax 
 *	in each pixel column is drawn every channel;
 */

static Boolean DrawResiduumAbs(dest, dres, x_scale, y_scale, chn_min, chn_max,
			       cal_s, cal_c, cal_efc, nrm)
     GowDestination dest;
     DrawResid_t dres;
     GowScale x_scale;
     GowScale y_scale;
     int chn_min;
     int chn_max;
     double (*cal_s)();
     double (*cal_c)();
     double (*cal_efc)();
     double nrm;
{
  int (*setup)()= DrawResidFctSetup(dres);
  int (*finish)()= DrawResidFctFinish(dres);
  double (*fct)()= DrawResidFct(dres);
  Cal_t cal= DrawResidCal(dres);
  Fit_t fit= DrawResidFit(dres);
  Spc_t spc= DrawResidSpc(dres);
  SpcReal_t *s= SpcBufReal(SpcSpc(spc));
  Boolean visible= FALSE;

  GowPixelFunc px, py;
  int xp_min, xp_max, yp_min, yp_max;
  double xu_min, xu_max, yu_min, yu_max;
  XPoint *pnts;

  GowDSet_gc(dest, DrawResidGCIdx(dres));

  px= GowGetScalePixelFunction(x_scale);
  py= GowGetScalePixelFunction(y_scale);
  GowGetScaleUserRange(x_scale, &xu_min, &xu_max);
  GowGetScaleUserRange(y_scale, &yu_min, &yu_max);
  xp_min= GowGetScaleLimitPixel(x_scale, GowClipSmall);
  xp_max= GowGetScaleLimitPixel(x_scale, GowClipLarge);
  yp_min= GowGetScaleLimitPixel(y_scale, GowClipSmall);
  yp_max= GowGetScaleLimitPixel(y_scale, GowClipLarge);

  chn_min= MAX(0, chn_min);
  chn_max= MIN(chn_max, SpcNum(spc));

  if (!setup(fit, FitPar(fit))) { return FALSE; }

  if (!(pnts= (XPoint *)Malloc(sizeof(XPoint) *
			       2 * (chn_max - chn_min + 4)))) {
    finish(fit); return FALSE; }

  { XPoint *pnt= pnts;
    int chn_start;
    int chn_end;

    int chn;
    int x_prev;
    int y_prev;
    GowScaleConversion y_prevc;

    { double tmp;

      tmp= cal_c(cal, xu_min); chn_start= MAX(chn_min, (int)tmp);
      tmp= cal_c(cal, xu_max); chn_end	= MIN((int)tmp + 2, chn_max); }

    chn= chn_start;

    { GowScaleConversion conv;
      while (chn< chn_end &&	/* get 1st valid x-0.5 */
	     ((conv= px(x_scale, &x_prev, cal_s(cal, (double)chn-0.5)))
	      == GowClipSmall || conv == GowToSmall)) {
	chn++; } }
    if (chn > chn_end || chn >= chn_max) { /* no valid x found */
      Free(pnts); finish(fit); return FALSE; }
    else if (chn > chn_start) {	/* spectrum starts out of user range */
      x_prev= xp_min;
      y_prevc= py(y_scale, &y_prev, nrm * cal_efc(cal, (double)chn-1.0) *
		  ((double)s[chn-1] - fct(fit, (double)chn-1.0))); }
    else {			/* spectrum starts within user range */
      y_prevc= py(y_scale, &y_prev, nrm * cal_efc(cal, (double)chn) *
		  ((double)s[chn] - fct(fit, (double)chn))); }

    switch (y_prevc) {
      case GowValid: break;
      case GowClipSmall: y_prevc= GowToSmall;
      case GowToSmall: y_prev= yp_min; break;
      case GowClipLarge: y_prevc= GowToLarge;
      case GowToLarge: y_prev= yp_max; break; }

    if (chn == chn_start || y_prevc != GowValid) { x_prev= -1; }

    GowDStart_object(dest, "residuum");

    { int x, y;
      GowScaleConversion yconv;

      while (chn < chn_end &&
	     px(x_scale, &x, cal_s(cal, (double)chn-0.5)) == GowValid) {
	yconv= py(y_scale, &y, nrm * cal_efc(cal, (double)chn) *
		  ((double)s[chn] - fct(fit, (double)chn)));

	switch (yconv) {	/* handle clipped as out of bounds */
	case GowValid: break;
	case GowClipSmall: yconv= GowToSmall;
	case GowToSmall: y= yp_min; break;
	case GowClipLarge: yconv= GowToLarge;
	case GowToLarge: y= yp_max; break; }

	{ /* draw always */
	  if (x_prev >= 0 &&	/* defined */
	      (y_prevc == GowValid || yconv != y_prevc)) { /* visible */
	    if (y_prevc == GowValid && pnt == pnts) {
	      pnt->x= x_prev; pnt->y= y_prev; pnt++; } /* 1st point */
	    pnt->x= x; pnt->y= y_prev; pnt++; } /* horizontal */

	  if (yconv == GowValid) {
	    pnt->x= x; pnt->y= y; pnt++; } /* vertical */
	  else {
	    if (y_prevc != yconv) { /* last point */
	      pnt->x= x; pnt->y= y; pnt++; }

	    if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
	      visible= TRUE; }
	    pnt= pnts; }

	  y_prev= y; y_prevc= yconv;
	  x_prev= x; }
	chn++; }

      if (y_prev >= 0 &&	/* defined */
	  (y_prevc == GowValid || y_prevc != yconv)) { /* visible */
	pnt->x= x_prev; pnt->y= y_prev; pnt++; } /* 1st point */

      if (yconv == GowValid) {
	pnt->x= x_prev; pnt->y= y; pnt++; /* vertical or 1st point */
	pnt->y= y;
	if (px(x_scale, &x, cal_s(cal, (double)chn+0.5)) == GowValid) {
	  pnt->x= x; }
	else { pnt->x= xp_max; }
	pnt++; } }

    if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
      visible= TRUE; }

    { SpcReal_t *ds= SpcBufReal(SpcDSpc(spc));
      int x, y;

      for (pnt= pnts, chn= chn_start; chn< chn_end; chn++) {
	if (px(x_scale, &x, cal_s(cal, (double)chn)) == GowValid) {
	  if (py(y_scale, &y,
		 nrm * cal_efc(cal, (double)chn) * sqrt((double)ds[chn])) ==
	      GowValid) {
	    pnt->x= x; pnt->y= y; pnt++; }
	  if (py(y_scale, &y,
		 - nrm * cal_efc(cal, (double)chn) * sqrt((double)ds[chn])) ==
	      GowValid) {
	    pnt->x= x; pnt->y= y; pnt++; } } } }

    if (pnt - pnts > 0 && GowDPoints(dest, pnts, pnt - pnts)) {
      visible= TRUE; } }

  GowDEnd_object(dest, "residuum");

  Free(pnts);
  finish(fit);
  return visible;
}

static Boolean DrawResiduumRel(dest, dres, x_scale, y_scale, chn_min, chn_max,
			       cal_s, cal_c, cal_efc, nrm)
     GowDestination dest;
     DrawResid_t dres;
     GowScale x_scale;
     GowScale y_scale;
     int chn_min;
     int chn_max;
     double (*cal_s)();
     double (*cal_c)();
     double (*cal_efc)();
     double nrm;
{
  int (*setup)()= DrawResidFctSetup(dres);
  int (*finish)()= DrawResidFctFinish(dres);
  double (*fct)()= DrawResidFct(dres);
  Cal_t cal= DrawResidCal(dres);
  Fit_t fit= DrawResidFit(dres);
  Spc_t spc= DrawResidSpc(dres);
  SpcReal_t *s= SpcBufReal(SpcSpc(spc));
  SpcReal_t *ds= SpcBufReal(SpcDSpc(spc));
  Boolean visible= FALSE;

  GowPixelFunc px, py;
  int xp_min, xp_max, yp_min, yp_max;
  double xu_min, xu_max, yu_min, yu_max;
  XPoint *pnts;

  GowDSet_gc(dest, DrawResidGCIdx(dres));

  px= GowGetScalePixelFunction(x_scale);
  py= GowGetScalePixelFunction(y_scale);
  GowGetScaleUserRange(x_scale, &xu_min, &xu_max);
  GowGetScaleUserRange(y_scale, &yu_min, &yu_max);
  xp_min= GowGetScaleLimitPixel(x_scale, GowClipSmall);
  xp_max= GowGetScaleLimitPixel(x_scale, GowClipLarge);
  yp_min= GowGetScaleLimitPixel(y_scale, GowClipSmall);
  yp_max= GowGetScaleLimitPixel(y_scale, GowClipLarge);

  if (!setup(fit, FitPar(fit))) { return FALSE; }

  chn_min= MAX(0, chn_min);
  chn_max= MIN(chn_max, SpcNum(spc));

  if (!(pnts= (XPoint *)Malloc(sizeof(XPoint) *
			       2 * (chn_max - chn_min + 4)))) {
    finish(fit); return FALSE; }

  { XPoint *pnt= pnts;
    int chn_start;
    int chn_end;
    int chn;
    int x_prev;
    int y_prev;
    GowScaleConversion y_prevc;

    { double tmp;

      tmp= cal_c(cal, xu_min); chn_start= MAX(chn_min, (int)tmp);
      tmp= cal_c(cal, xu_max); chn_end	= MIN((int)tmp + 2, chn_max); }

    chn= chn_start;

    { GowScaleConversion conv;
      while (chn< chn_end &&	/* get 1st valid x-0.5 */
	     ((conv= px(x_scale, &x_prev, cal_s(cal, (double)chn-0.5)))
	      == GowClipSmall || conv == GowToSmall)) {
	chn++; } }
    if (chn > chn_end || chn >= chn_max) { /* no valid x found */
      Free(pnts); finish(fit); return FALSE; }
    else if (chn > chn_start) {	/* spectrum starts out of user range */
      x_prev= xp_min;
      y_prevc= (ds[chn-1] == 0.0 ?
		GowToLarge :
		py(y_scale, &y_prev, nrm * cal_efc(cal, (double)chn-1.0) *
		   ((double)s[chn-1] - fct(fit, (double)chn-1)) /
		   sqrt(ds[chn-1]))); }
    else {			/* spectrum starts within user range */
      y_prevc= (ds[chn] == 0.0 ?
		GowToLarge :
		py(y_scale, &y_prev, nrm * cal_efc(cal, (double)chn) *
		   ((double)s[chn] - fct(fit, (double)chn)) /
		   sqrt(ds[chn]))); }

    switch (y_prevc) {
      case GowValid: break;
      case GowClipSmall: y_prevc= GowToSmall;
      case GowToSmall: y_prev= yp_min; break;
      case GowClipLarge: y_prevc= GowToLarge;
      case GowToLarge: y_prev= yp_max; break; }

    if (chn == chn_start || y_prevc != GowValid) { x_prev= -1; }

    { int x, y;
      GowScaleConversion yconv;

      while (chn < chn_end &&
	     px(x_scale, &x, cal_s(cal, (double)chn-0.5)) == GowValid) {
	yconv= (ds[chn] == 0.0 ?
		GowToLarge :
		py(y_scale, &y, nrm * cal_efc(cal, (double)chn) *
		   ((double)s[chn] - fct(fit, (double)chn)) /
		   sqrt(ds[chn])));

	switch (yconv) {	/* handle clipped as out of bounds */
	case GowValid: break;
	case GowClipSmall: yconv= GowToSmall;
	case GowToSmall: y= yp_min; break;
	case GowClipLarge: yconv= GowToLarge;
	case GowToLarge: y= yp_max; break; }

	{ /* draw always */
	  if (x_prev >= 0 &&	/* defined */
	      (y_prevc == GowValid || yconv != y_prevc)) { /* visible */
	    if (y_prevc == GowValid) {
	      pnt->x= x_prev; pnt->y= y_prev; pnt++; } /* 1st point */
	    pnt->x= x; pnt->y= y_prev; pnt++; } /* horizontal */

	  if (yconv == GowValid) {
	    pnt->x= x; pnt->y= y; pnt++; } /* vertical */
	  else {
	    if (y_prevc != yconv) { /* last point */
	      pnt->x= x; pnt->y= y; pnt++; }

	    if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
	      visible= TRUE; }
	    pnt= pnts; }

	  y_prev= y; y_prevc= yconv;
	  x_prev= x; }
	chn++; }

      if (y_prev >= 0 &&	/* defined */
	  (y_prevc == GowValid || y_prevc != yconv)) { /* visible */
	pnt->x= x_prev; pnt->y= y_prev; pnt++; } /* 1st point */

      if (yconv == GowValid) {
	pnt->x= x_prev; pnt->y= y; pnt++; /* vertical or 1st point */
	pnt->y= y;
	if (px(x_scale, &x, cal_s(cal, (double)chn+0.5)) == GowValid) {
	  pnt->x= x; }
	else { pnt->x= xp_max; }
	pnt++; } }

    if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
      visible= TRUE; } }

  Free(pnts);
  finish(fit);
  return visible;
}

static void DrawResiduumAbsExpand(dres,
				  x_scale, x_type, x_full,
				  y_scale, y_type, y_full,
				  chn_min, chn_max,
				  cal_s, cal_c, cal_efc, nrm)
     DrawResid_t dres;
     GowScale x_scale;
     GowScaleType x_type;
     int x_full;
     GowScale y_scale;
     GowScaleType y_type;
     int y_full;
     int chn_min;
     int chn_max;
     double (*cal_s)();
     double (*cal_c)();
     double (*cal_efc)();
     double nrm;
{
  Cal_t cal= DrawResidCal(dres);
  Fit_t fit= DrawResidFit(dres);
  Spc_t spc= DrawResidSpc(dres);
  double x_offset, x_range;

  if (x_full) {
    x_offset	= cal_s(cal, (double)chn_min - 0.5);
    x_range	= cal_s(cal, (double)chn_max + 0.5) - x_offset;
    GowExtendNewScaleOffsetRange(x_scale, x_offset, x_range); }
  else if (!GowGetScaleOffset(x_scale, &x_offset) ||
	   !GowGetScaleRange(x_scale, &x_range)) { return; }
  if (y_full) {
    int x_min;
    int x_max;

    { double tmp;
      tmp= cal_c(cal, x_offset);
      x_min= MAX(0, NINT(tmp));
      tmp= cal_c(cal, x_offset + x_range); 
      x_max= MIN(SpcNum(spc), NINT(tmp)+1); }

    x_min= MAX(chn_min, x_min);
    x_max= MIN(chn_max, x_max);

    if (chn_min >= chn_max) { return; }
    else if (y_type == GowLogarithmicScale) {
      return; }
    
    { double y_min, y_max;
      int chn;
      int (*setup)()= DrawResidFctSetup(dres);
      int (*finish)()= DrawResidFctFinish(dres);
      double (*fct)()= DrawResidFct(dres);
      SpcReal_t *s= SpcBufReal(SpcSpc(spc));
      SpcReal_t *ds= SpcBufReal(SpcDSpc(spc));

      if (!setup(fit, FitPar(fit))) { return; }

      y_min= y_max= (nrm * cal_efc(cal, x_min) *
		     (s[x_min] - fct(fit, (double)x_min)));
      for (chn= x_min; chn< x_max; chn++) {
	double tmp= (nrm * cal_efc(cal, (double)chn) *
		     (s[chn] - fct(fit,(double)chn)));

	if (tmp < y_min) { y_min= tmp; }
	else if (tmp > y_max) { y_max= tmp; }

	tmp= nrm * cal_efc(cal, (double)chn) * sqrt(ds[chn]);

	if (tmp < y_min) { y_min= tmp; }
	else if (tmp > y_max) { y_max= tmp; }
	if (-tmp < y_min) { y_min= -tmp; }
	else if (-tmp > y_max) { y_max= -tmp; } }

      GowExtendNewScaleOffsetRange(y_scale, y_min, y_max - y_min);
      finish(fit);
      return; } }
  return;
}

static void DrawResiduumRelExpand(dres,
				  x_scale, x_type, x_full,
				  y_scale, y_type, y_full,
				  chn_min, chn_max,
				  cal_s, cal_c, cal_efc, nrm)
     DrawResid_t dres;
     GowScale x_scale;
     GowScaleType x_type;
     int x_full;
     GowScale y_scale;
     GowScaleType y_type;
     int y_full;
     int chn_min;
     int chn_max;
     double (*cal_s)();
     double (*cal_c)();
     double (*cal_efc)();
     double nrm;
{
  Cal_t cal= DrawResidCal(dres);
  Fit_t fit= DrawResidFit(dres);
  Spc_t spc= DrawResidSpc(dres);
  double x_offset, x_range;

  if (x_full) {
    x_offset	= cal_s(cal, (double)chn_min - 0.5);
    x_range	= cal_s(cal, (double)chn_max + 0.5) - x_offset;
    GowExtendNewScaleOffsetRange(x_scale, x_offset, x_range); }
  else if (!GowGetScaleOffset(x_scale, &x_offset) ||
	   !GowGetScaleRange(x_scale, &x_range)) { return; }
  if (y_full) {
    int x_min;
    int x_max;

    { double tmp;
      tmp= CalC(cal, x_offset);
      x_min= MAX(0, NINT(tmp));
      tmp= CalC(cal, x_offset + x_range); 
      x_max= MIN(SpcNum(spc), NINT(tmp)+1); }

    x_min= MAX(chn_min, x_min);
    x_max= MIN(chn_max, x_max);

    if (x_min >= x_max) { return; }
    else if (y_type == GowLogarithmicScale) {
      return; }
    
    { double y_min, y_max;
      int chn;
      int (*setup)()= DrawResidFctSetup(dres);
      int (*finish)()= DrawResidFctFinish(dres);
      double (*fct)()= DrawResidFct(dres);
      SpcReal_t *s= SpcBufReal(SpcSpc(spc));
      SpcReal_t *ds= SpcBufReal(SpcDSpc(spc));

      if (!setup(fit, FitPar(fit))) { return; }

      y_min= y_max= (nrm * cal_efc(cal, (double)x_min) *
		     (s[x_min] - fct(fit, (double)x_min)));
      for (chn= x_min; chn< x_max; chn++) {
	double d= nrm * cal_efc(cal, (double)chn) * sqrt(ds[chn]);
	if (d > 0.0) {
	  double tmp= (nrm * cal_efc(cal, (double)chn) *
		       (s[chn] - fct(fit,(double)chn)) / d);

	  if (tmp < y_min) { y_min= tmp; }
	  else if (tmp > y_max) { y_max= tmp; } } }

      GowExtendNewScaleOffsetRange(y_scale, y_min, y_max - y_min);
      finish(fit);
      return; } }
  return;
}

Boolean DrawResiduum(dest, dres, x_scale, y_scale,
		     res_normalized,
		     calibrated, modification, normalized)
     GowDestination dest;
     DrawResid_t dres;
     GowScale x_scale;
     GowScale y_scale;
     int res_normalized;
     int calibrated;
     GowScaleModificationType modification;
     int normalized;
{
  double (*cal_s)();
  double (*cal_c)();
  double (*cal_efc)();
  double nrm= normalized ? *DrawResidNorm(dres) : 1.0;

  int chn_min, chn_max;

  { PVec_t mr= FitRegMrk(DrawResidFit(dres));
    if (!VecNum(mr)) { return FALSE; }
    chn_min= NINT(PVecX1(mr,0));
    chn_max= NINT(PVecX2(mr,VecNum(mr)-1)); }

  if (calibrated) { cal_s= CalP; cal_c= CalC; }
  else { cal_s= CalId; cal_c= CalId; }
  switch (modification) {
  case GowMmultiplied: cal_efc= cal_c; break;
  case GowMefficiency: cal_efc= CalEfc; break;
  case GowMnone:
  default: cal_efc= CalUnity; break; }

  return (res_normalized ?
	  DrawResiduumRel(dest, dres, x_scale, y_scale, chn_min, chn_max,
			  cal_s, cal_c, cal_efc, nrm) :
	  DrawResiduumAbs(dest, dres, x_scale, y_scale, chn_min, chn_max,
			  cal_s, cal_c, cal_efc, nrm));
}

void DrawResiduumExpand(dres,
			x_scale, x_type, x_full,
			y_scale, y_type, y_full,
			res_normalized,
			calibrated, modification, normalized)
     DrawResid_t dres;
     GowScale x_scale;
     GowScaleType x_type;
     int x_full;
     GowScale y_scale;
     GowScaleType y_type;
     int y_full;
     int res_normalized;
     int calibrated;
     GowScaleModificationType modification;
     int normalized;
{
  double (*cal_s)();
  double (*cal_c)();
  double (*cal_efc)();
  double nrm= normalized ? *DrawResidNorm(dres) : 1.0;
  int chn_min, chn_max;

  { PVec_t mr= FitRegMrk(DrawResidFit(dres));
    if (!VecNum(mr)) { return; }
    chn_min= NINT(PVecX1(mr,0));
    chn_max= NINT(PVecX2(mr,VecNum(mr)-1)); }

  if (calibrated) { cal_s= CalP; cal_c= CalC; }
  else { cal_s= CalId; cal_c= CalId; }
  switch (modification) {
  case GowMmultiplied: cal_efc= cal_c; break;
  case GowMefficiency: cal_efc= CalEfc; break;
  case GowMnone:
  default: cal_efc= CalUnity; break; }

  if (res_normalized) {
    DrawResiduumRelExpand(dres,
			  x_scale, x_type, x_full,
			  y_scale, y_type, y_full,
			  chn_min, chn_max,
			  cal_s, cal_c, cal_efc, nrm); }
  else {
    DrawResiduumAbsExpand(dres,
			  x_scale, x_type, x_full,
			  y_scale, y_type, y_full,
			  chn_min, chn_max,
			  cal_s, cal_c, cal_efc, nrm); }
}
