/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawResid.h,v 1.2 1994/05/26 19:49:00 vs Exp vs $ */

#ifndef _DrawResid_h
#define _DrawResid_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowTypes.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>

typedef enum {
  DrawResidAbs,
  DrawResidRel
} DrawResiduumType;

typedef struct {
  DrawResiduumType type;
  int gc_idx;
  Cal_t cal;
  Fit_t fit;
  Spc_t spc;
  int (*fct_setup)();
  int (*fct_finish)();
  double (*fct)();
  double *norm;
} DrawResidRec, *DrawResid_t;

#define DrawResidType(p)	((p)->type)
#define DrawResidGCIdx(p)	((p)->gc_idx)
#define DrawResidCal(p)		((p)->cal)
#define DrawResidFit(p)		((p)->fit)
#define DrawResidSpc(p)		((p)->spc)
#define DrawResidFctSetup(p)	((p)->fct_setup)
#define DrawResidFctFinish(p)	((p)->fct_finish)
#define DrawResidFct(p)		((p)->fct)
#define DrawResidNorm(p)	((p)->norm)

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawResiduum P_((GowDestination dest, DrawResid_t dres,
				GowScale x_scale, GowScale y_scale,
				int res_normalized,
				int calibrated,
				GowScaleModificationType modification,
				int normalized));
extern void DrawResiduumExpand P_((DrawResid_t dres,
				   GowScale x_scale, GowScaleType x_type,
				   int x_full,
				   GowScale y_scale, GowScaleType y_type,
				   int y_full,
				   int res_normalized,
				   int calibrated,
				   GowScaleModificationType modification,
				   int normalized));
#undef P_

#endif				/* _DrawResid_h */
