/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawSpectrum.c,v 1.4 1994/12/02 21:22:03 vs Exp vs $ */

#include <stdio.h>
#include <ctype.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsCal.h>
#include <tv/vsSpectra.h>

#include "DrawSpectrum.h"

#define ADD_PNT(X,Y) \
{ if (pnt - pnts <= 1) { pnt->x= X; pnt->y= Y; pnt++; }\
  else if (X == (pnt-1)->x && Y == (pnt-1)->y) { ; }\
  else if (Y == (pnt-1)->y && Y == (pnt-2)->y &&\
	   ((X <= (pnt-1)->x && (pnt-1)->x <= (pnt-2)->x) ||\
	    (X >= (pnt-1)->x && (pnt-1)->x >= (pnt-2)->x))) {\
    (pnt-1)->x= X; }\
  else if (X == (pnt-1)->x && X == (pnt-2)->x &&\
	   ((Y <= (pnt-1)->y && (pnt-1)->y <= (pnt-2)->y) ||\
	    (Y >= (pnt-1)->y && (pnt-1)->y >= (pnt-2)->y))) {\
    (pnt-1)->y= Y; }\
  else { pnt->x= X; pnt->y= Y; pnt++; }\
}

/*	draws from PIXELmin -> PIXELmax ,CHNmin -> CHNmax 
 *	in each pixel column is drawn each channel;
 */

static Boolean DrawSpectrumEach(dest, dspc, x_scale, y_scale, min_dx,
				cal_s, cal_c, cal_efc, nrm)
     GowDestination dest;
     DrawSpc_t dspc;
     GowScale x_scale;
     GowScale y_scale;
     int min_dx;
     double (*cal_s)();
     double (*cal_c)();
     double (*cal_efc)();
     double nrm;
{
  Spc_t spc= DrawSpcSpc(dspc);
  Cal_t cal= DrawSpcCal(dspc);
  SpcReal_t *s= SpcBufReal(SpcSpc(spc));
  Boolean visible= FALSE;

  GowPixelFunc px, py;
  int xp_min, xp_max, yp_min, yp_max;
  double xu_min, xu_max, yu_min, yu_max;
  XPoint *pnts;

  min_dx= MAX(1, min_dx);
  min_dx= MAX(GowDLinewidth(dest), min_dx);

  px= GowGetScalePixelFunction(x_scale);
  py= GowGetScalePixelFunction(y_scale);
  GowGetScaleUserRange(x_scale, &xu_min, &xu_max);
  GowGetScaleUserRange(y_scale, &yu_min, &yu_max);

  yp_min= GowGetScaleLimitPixel(y_scale, GowClipSmall);
  yp_max= GowGetScaleLimitPixel(y_scale, GowClipLarge);

  if (!(pnts= (XPoint *)Malloc(sizeof(XPoint) * 2 * (SpcNum(spc) + 4)))) {
    return FALSE; }

  { XPoint *pnt= pnts;
    int chn_start;
    int chn_end;
    int chn;
    int x_prev;
    int y_prev;
    int clipConv, minConv;
    int cmp_fac= 1;
    GowScaleConversion y_prevc;

    { double tmp_min, tmp_max;

      tmp_min= cal_c(cal, xu_min);
      tmp_max= cal_c(cal, xu_max);

      if (tmp_min > tmp_max) {
	chn_start= MAX(0, (int)tmp_max);
	chn_end= MIN((int)tmp_min + 2, SpcNum(spc));

	clipConv= GowClipLarge;
	minConv= GowToLarge;

	min_dx= -min_dx;
	cmp_fac= -1;
	xp_min= GowGetScaleLimitPixel(x_scale, GowClipLarge);
	xp_max= GowGetScaleLimitPixel(x_scale, GowClipSmall); }
      else {
	chn_start= MAX(0, (int)tmp_min);
	chn_end= MIN((int)tmp_max + 2, SpcNum(spc));

	clipConv= GowClipSmall;
	minConv= GowToSmall;

	xp_min= GowGetScaleLimitPixel(x_scale, GowClipSmall);
	xp_max= GowGetScaleLimitPixel(x_scale, GowClipLarge); } }

    chn= chn_start;

    { GowScaleConversion conv;
      while (chn< chn_end &&	/* get 1st valid x-0.5 */
	     ((conv= px(x_scale, &x_prev, cal_s(cal, (double)chn-0.5)))
	      == clipConv || conv == minConv)) {
	chn++; } }
    if (chn > chn_end || chn >= SpcNum(spc)) { /* no valid x found */
      Free(pnts); return FALSE; }
    else if (chn > chn_start) {	/* spectrum starts out of user range */
      x_prev= xp_min;
      y_prevc= py(y_scale, &y_prev,
		  nrm * cal_efc(cal, (double)chn-1.0) * (double)s[chn-1]); }
    else {			/* spectrum starts within user range */
      y_prevc= py(y_scale, &y_prev,
		  nrm * cal_efc(cal, (double)chn) * (double)s[chn]); }

    switch (y_prevc) {
      case GowValid: break;
      case GowClipSmall: y_prevc= GowToSmall;
      case GowToSmall: y_prev= yp_min; break;
      case GowClipLarge: y_prevc= GowToLarge;
      case GowToLarge: y_prev= yp_max; break; }

    if (chn == chn_start || y_prevc != GowValid) { x_prev= -1; }

    { int x, y;
      GowScaleConversion yconv;

      while (chn < chn_end &&
	     px(x_scale, &x, cal_s(cal, (double)chn-0.5)) == GowValid) {
	yconv= py(y_scale, &y,
		  nrm * cal_efc(cal, (double)chn) * (double)s[chn]);

	switch (yconv) {	/* handle clipped as out of bounds */
	case GowValid: break;
	case GowClipSmall: yconv= GowToSmall;
	case GowToSmall: y= yp_min; break;
	case GowClipLarge: yconv= GowToLarge;
	case GowToLarge: y= yp_max; break; }

	if (x_prev >= 0 &&	/* defined */
	    (y_prevc == GowValid || yconv != y_prevc)) { /* visible */
	  if (y_prevc == GowValid) {
	    ADD_PNT(x_prev, y_prev); } /* 1st point */
	  ADD_PNT(x, y_prev); } /* horizontal */

	if (yconv == GowValid) { ADD_PNT(x, y); } /* vertical */
	else {
	  if (y_prevc != yconv) { ADD_PNT(x,y); } /* last point */

	  if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
	    visible= TRUE; }
	  pnt= pnts; }

	y_prev= y; y_prevc= yconv;
	x_prev= x;
	chn++; }

      if (y_prev >= 0 &&	/* defined */
	  (y_prevc == GowValid || y_prevc != yconv)) { /* visible */
	ADD_PNT(x_prev, y_prev); } /* 1st point */

      if (yconv == GowValid) {
	ADD_PNT(x_prev, y);	/* vertical or 1st point */

	if (px(x_scale, &x, cal_s(cal, (double)chn+0.5)) == GowValid) {
	  ADD_PNT(x, y); }
	else { ADD_PNT(xp_max, y); } } }

    if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
      visible= TRUE; } }

  Free(pnts);
  return FALSE;
}

/*	draws from PIXELmin -> PIXELmax ,CHNmin -> CHNmax 
 *	in each pixel column is drawn only one channel;
 *	all other channels which fall into the same column are omitted
 */

static Boolean DrawSpectrumFirstFound(dest, dspc, x_scale, y_scale, min_dx,
				      cal_s, cal_c, cal_efc, nrm)
     GowDestination dest;
     DrawSpc_t dspc;
     GowScale x_scale;
     GowScale y_scale;
     int min_dx;
     double (*cal_s)();
     double (*cal_c)();
     double (*cal_efc)();
     double nrm;
{
  Spc_t spc= DrawSpcSpc(dspc);
  Cal_t cal= DrawSpcCal(dspc);
  SpcReal_t *s= SpcBufReal(SpcSpc(spc));
  Boolean visible= FALSE;

  GowPixelFunc px, py;
  int xp_min, xp_max, yp_min, yp_max;
  double xu_min, xu_max, yu_min, yu_max;
  XPoint *pnts;

  min_dx= MAX(1, min_dx);
  min_dx= MAX(GowDLinewidth(dest), min_dx);

  px= GowGetScalePixelFunction(x_scale);
  py= GowGetScalePixelFunction(y_scale);
  GowGetScaleUserRange(x_scale, &xu_min, &xu_max);
  GowGetScaleUserRange(y_scale, &yu_min, &yu_max);

  yp_min= GowGetScaleLimitPixel(y_scale, GowClipSmall);
  yp_max= GowGetScaleLimitPixel(y_scale, GowClipLarge);

  if (!(pnts= (XPoint *)Malloc(sizeof(XPoint) * 2 * (SpcNum(spc) + 4)))) {
    return FALSE; }

  { XPoint *pnt= pnts;
    int chn_start;
    int chn_end;
    int chn;
    int x_prev, x_next;
    int y_prev;
    int clipConv, minConv;
    int cmp_fac= 1;
    GowScaleConversion y_prevc;

    { double tmp_min, tmp_max;

      tmp_min= cal_c(cal, xu_min);
      tmp_max= cal_c(cal, xu_max);

      if (tmp_min > tmp_max) {
	chn_start= MAX(0, (int)tmp_max);
	chn_end= MIN((int)tmp_min + 2, SpcNum(spc));

	clipConv= GowClipLarge;
	minConv= GowToLarge;

	min_dx= -min_dx;
	cmp_fac= -1;
	xp_min= GowGetScaleLimitPixel(x_scale, GowClipLarge);
	xp_max= GowGetScaleLimitPixel(x_scale, GowClipSmall); }
      else {
	chn_start= MAX(0, (int)tmp_min);
	chn_end= MIN((int)tmp_max + 2, SpcNum(spc));

	clipConv= GowClipSmall;
	minConv= GowToSmall;

	xp_min= GowGetScaleLimitPixel(x_scale, GowClipSmall);
	xp_max= GowGetScaleLimitPixel(x_scale, GowClipLarge); } }

    chn= chn_start;

    { GowScaleConversion conv;
      while (chn< chn_end &&	/* get 1st valid x-0.5 */
	     ((conv= px(x_scale, &x_prev, cal_s(cal, (double)chn-0.5)))
	      == clipConv || conv == minConv)) {
	chn++; } }
    if (chn > chn_end || chn >= SpcNum(spc)) { /* no valid x found */
      Free(pnts); return FALSE; }
    else if (chn > chn_start) {	/* spectrum starts out of user range */
      x_prev= xp_min;
      y_prevc= py(y_scale, &y_prev,
		  nrm * cal_efc(cal, (double)chn-1.0) * (double)s[chn-1]); }
    else {			/* spectrum starts within user range */
      y_prevc= py(y_scale, &y_prev,
		  nrm * cal_efc(cal, (double)chn) * (double)s[chn]); }

    switch (y_prevc) {
      case GowValid: break;
      case GowClipSmall: y_prevc= GowToSmall;
      case GowToSmall: y_prev= yp_min; break;
      case GowClipLarge: y_prevc= GowToLarge;
      case GowToLarge: y_prev= yp_max; break; }

    if (chn == chn_start || y_prevc != GowValid) { x_prev= -1; }

    x_next= x_prev + min_dx; /* min. distance between 2 vertical lines */

    { int x, y;
      GowScaleConversion yconv;

      while (chn < chn_end &&
	     px(x_scale, &x, cal_s(cal, (double)chn-0.5)) == GowValid) {
	yconv= py(y_scale, &y,
		  nrm * cal_efc(cal, (double)chn) * (double)s[chn]);

	switch (yconv) {	/* handle clipped as out of bounds */
	case GowValid: break;
	case GowClipSmall: yconv= GowToSmall;
	case GowToSmall: y= yp_min; break;
	case GowClipLarge: yconv= GowToLarge;
	case GowToLarge: y= yp_max; break; }

	if (x_next * cmp_fac <=
	    x * cmp_fac) {	/* draw if pixel column changes */
	  if (x_prev >= 0 &&	/* defined */
	      (y_prevc == GowValid || yconv != y_prevc)) { /* visible */
	    if (y_prevc == GowValid) {
	      ADD_PNT(x_prev, y_prev); } /* 1st point */
	    ADD_PNT(x, y_prev); } /* horizontal */
	  x_next= x;

	  if (yconv == GowValid) { ADD_PNT(x, y); } /* vertical */
	  else {
	    if (y_prevc != yconv) { ADD_PNT(x,y); } /* last point */

	    if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
	      visible= TRUE; }
	    pnt= pnts; }

	  y_prev= y; y_prevc= yconv;
	  x_prev= x; x_next= x_prev + min_dx; }
	chn++; }

      if (y_prev >= 0 &&	/* defined */
	  (y_prevc == GowValid || y_prevc != yconv)) { /* visible */
	ADD_PNT(x_prev, y_prev); } /* 1st point */

      if (yconv == GowValid) {
	ADD_PNT(x_prev, y);	/* vertical or 1st point */

	if (px(x_scale, &x, cal_s(cal, (double)chn+0.5)) == GowValid) {
	  ADD_PNT(x, y); }
	else { ADD_PNT(xp_max, y); } } }

    if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
      visible= TRUE; } }

  Free(pnts);
  return FALSE;
}

/*	draws from PIXELmin -> PIXELmax ,CHNmin -> CHNmax 
 *	if more than one channel must be drawn per pixel column
 *	two pixel columns are used: in the first one the minimum
 *	of all channels within these two columns is drawn in the
 *	next one the maximum
 */

static Boolean DrawSpectrumMinMax(dest, dspc, x_scale, y_scale, min_dx,
				  cal_s, cal_c, cal_efc, nrm)
     GowDestination dest;
     DrawSpc_t dspc;
     GowScale x_scale;
     GowScale y_scale;
     int min_dx;
     double (*cal_s)();
     double (*cal_c)();
     double (*cal_efc)();
     double nrm;
{
  Spc_t spc= DrawSpcSpc(dspc);
  Cal_t cal= DrawSpcCal(dspc);
  SpcReal_t *s= SpcBufReal(SpcSpc(spc));
  Boolean visible= FALSE;

  GowPixelFunc px, py;
  int xp_min, xp_max, yp_min, yp_max;
  int cmp_fac= 1;
  double xu_min, xu_max, yu_min, yu_max;
  XPoint *pnts;
  GowScaleDirection y_direction;

  if (SpcNum(spc) == 0) { return FALSE; } /* no spectrum defined */

  min_dx= MAX(1, min_dx);
  min_dx= MAX(GowDLinewidth(dest), min_dx);

  px= GowGetScalePixelFunction(x_scale);
  py= GowGetScalePixelFunction(y_scale);
  GowGetScaleUserRange(x_scale, &xu_min, &xu_max);
  GowGetScaleUserRange(y_scale, &yu_min, &yu_max);

  yp_min= GowGetScaleLimitPixel(y_scale, GowClipSmall);
  yp_max= GowGetScaleLimitPixel(y_scale, GowClipLarge);
  y_direction= GowGetScaleDirection(y_scale);

  { XPoint *pnt;
    int chn_start;
    int chn_end;
    int chn;
    int x_prev, x_next;
    int y_min, y_max, y_prev;
    int minmax= FALSE;
    int clipConv, minConv;
    GowScaleConversion y_minc, y_maxc, y_prevc;

    { double tmp_min, tmp_max;

      tmp_min= cal_c(cal, xu_min);
      tmp_max= cal_c(cal, xu_max);

      if (tmp_min > tmp_max) {
	chn_start= MAX(0, (int)tmp_max);
	chn_end= MIN((int)tmp_min + 2, SpcNum(spc));

	clipConv= GowClipLarge;
	minConv= GowToLarge;

	min_dx= -min_dx;
	cmp_fac= -1;

	xp_min= GowGetScaleLimitPixel(x_scale, GowClipLarge);
	xp_max= GowGetScaleLimitPixel(x_scale, GowClipSmall); }
      else {
	chn_start= MAX(0, (int)tmp_min);
	chn_end= MIN((int)tmp_max + 2, SpcNum(spc));

	clipConv= GowClipSmall;
	minConv= GowToSmall;

	xp_min= GowGetScaleLimitPixel(x_scale, GowClipSmall);
	xp_max= GowGetScaleLimitPixel(x_scale, GowClipLarge); } }

    if (!(pnts= (XPoint *)Malloc(sizeof(XPoint) * 
				 4 * (ABS(xp_max - xp_min) + 4)))) {
      return FALSE; }

    pnt= pnts;

    chn= chn_start;

    { GowScaleConversion conv;
      while (chn< chn_end &&	/* get 1st valid x-0.5 */
	     ((conv= px(x_scale, &x_prev, cal_s(cal, (double)chn-0.5)))
	      == clipConv || conv == minConv)) {
	chn++; } }
    if (chn > chn_end || chn >= SpcNum(spc)) { /* no valid x found */
      Free(pnts); return FALSE; }
    else if (chn > chn_start) {	/* spectrum starts out of user range */
      x_prev= xp_min;
      y_prevc= py(y_scale, &y_prev,
		  nrm * cal_efc(cal, (double)chn-1.0) * (double)s[chn-1]); }
    else {			/* spectrum starts within user range */
      y_prevc= py(y_scale, &y_prev,
		  nrm * cal_efc(cal, (double)chn) * (double)s[chn]); }

    switch (y_prevc) {
      case GowValid: break;
      case GowClipSmall: y_prevc= GowToSmall;
      case GowToSmall: y_prev= yp_min; break;
      case GowClipLarge: y_prevc= GowToLarge;
      case GowToLarge: y_prev= yp_max; break; }

    y_min= y_max= y_prev;
    if (chn == chn_start || y_prevc != GowValid) { y_prev= -1; }
    y_minc= y_maxc= y_prevc;

    x_next= x_prev + min_dx; /* min. distance between 2 vertical lines */

    { int x;
      while (chn < chn_end &&
	     px(x_scale, &x, cal_s(cal, (double)chn-0.5)) == GowValid) {
	int y;
	GowScaleConversion yconv;

	yconv= py(y_scale, &y,
		  nrm * cal_efc(cal, (double)chn) * (double)s[chn]);

	switch (yconv) {	/* handle clipped as out of bounds */
	case GowValid: break;
	case GowClipSmall: yconv= GowToSmall;
	case GowToSmall: y= yp_min; break;
	case GowClipLarge: yconv= GowToLarge;
	case GowToLarge: y= yp_max; break; }

	if (x_next * cmp_fac > x * cmp_fac) {
	  if (!minmax) {
	    minmax= TRUE;
	    x_next= x_next + min_dx; } /* needs 2 pixel columns now */
	  switch (yconv) {
	  case GowValid:
	    switch (y_direction) {
	    case GowNormalScaleDirection:
	      y_min= MIN(y_min, y);
	      y_max= MAX(y_max, y);
	      break;
	    case GowInvertedScaleDirection: 
	      y_min= MAX(y_min, y);
	      y_max= MIN(y_max, y);
	      break; }
	    if (y_minc != GowToSmall) { y_minc= yconv; }
	    if (y_maxc != GowToLarge) { y_maxc= yconv; }
	    break;
	  case GowClipSmall:
	  case GowToSmall: y_min= y; y_minc= yconv; break;
	  case GowClipLarge:
	  case GowToLarge: y_max= y; y_minc= yconv; break; } }
	else {			/* draw if pixel column changes */
	  if (y_prev >= 0 &&	/* defined */
	      (y_prevc == GowValid || y_minc != y_prevc)) { /* visible */
	    ADD_PNT(x_prev, y_prev); } /* 1st point */

	  if (minmax) {
	    minmax= FALSE;
	    if (y_minc == GowValid) {
	      ADD_PNT(x_prev, y_min); /* vertical or 1st point */
	      ADD_PNT(x_prev + min_dx, y_min); } /* horiz. min */
	    else {
	      if (pnt != pnts) {
		ADD_PNT(x_prev, y_min); /* vertical last point */
		if (GowDLines(dest, pnts, pnt - pnts)) { visible= TRUE; }
		pnt= pnts; }

	      if (y_minc != y_maxc) { /* vertical 1st point */
		ADD_PNT(x_prev + min_dx, y_min); } }
	    x_prev += min_dx;
	    y_prev= y_min; y_prevc= y_minc; }
	  else { x_next= x; }

	  if (y_maxc == GowValid) { /* !minmax => y_min == y_max */
	    ADD_PNT(x_prev, y_max); /* vertical */
	    ADD_PNT(x_next, y_max); } /* horiz. max */
	  else {
	    if (y_prev >= 0 && y_prevc != y_maxc) { /* last point */
	      ADD_PNT(x_prev, y_max); }

	    if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
	      visible= TRUE; }
	    pnt= pnts; }
	  y_prev= y_max;	/* not yet drawn */
	  y_prevc= y_maxc;
	  x_prev= x_next; x_next= x_prev + min_dx;
	  y_min= y_max= y;
	  y_minc= y_maxc= yconv; }
	chn++; } }

    if (y_prev >= 0 &&	/* defined */
	(y_prevc == GowValid || y_minc != y_prevc)) { /* visible */
      ADD_PNT(x_prev, y_prev); } /* 1st point */

    if (y_minc == GowValid) { /* !minmax => y_min == y_max */
      int x;

      ADD_PNT(x_prev, y_min); /* vertical or 1st point */

      if (px(x_scale, &x, cal_s(cal, (double)chn+0.5)) == GowValid) {
	ADD_PNT(x, y_min); }
      else { ADD_PNT(xp_max, y_min); } }
    else if (pnt != pnts) {
      ADD_PNT(x_prev, y_min); } /* last point out of bounds */

    if (pnt - pnts > 1 && GowDLines(dest, pnts, pnt - pnts)) {
      visible= TRUE; } }
  Free(pnts);
  return visible;
}
/* ARGSUSED */
Boolean DrawSpectrum(dest, dspc, x_scale, y_scale,
		     min_dx, min_steps, compress, line_space,
		     calibrated, modification, normalized)
     GowDestination dest;
     DrawSpc_t dspc;
     GowScale x_scale;
     GowScale y_scale;
     int min_dx;
     int min_steps;		/* currently unused */
     DrawCompressMode compress;
     double line_space;
     int calibrated;
     GowScaleModificationType modification;
     int normalized;
{
  Spc_t spc= DrawSpcSpc(dspc);
  double (*cal_s)();
  double (*cal_c)();
  double (*cal_efc)();
  double nrm= normalized ? *DrawSpcNorm(dspc) : 1.0;
  int ret_val;

  if (SpcNum(spc) == 0) { return FALSE; } /* no spectrum defined */

  if (calibrated) { cal_s= CalP; cal_c= CalC; }
  else { cal_s= CalId; cal_c= CalId; }
  switch (modification) {
  case GowMmultiplied: cal_efc= cal_c; break;
  case GowMefficiency: cal_efc= CalEfc; break;
  case GowMnone:
  default: cal_efc= CalUnity; break; }

  GowDStart_object(dest, "spectrum");

  GowDSet_gc(dest, DrawSpcGCIdx(dspc));

  if (DrawSpcLine(dspc) && line_space > 0.0) {
    GowDMove(dest,
	     (int)(GowGetScaleLimitPixel(x_scale, GowToLarge) -
		   GowGetScaleDirection(x_scale) * GowDFontwidth(dest)),
	     (int)(GowGetScaleLimitPixel(y_scale, GowToLarge) -
		   GowGetScaleDirection(y_scale) *
		   line_space * DrawSpcLine(dspc) * GowDFontheight(dest)));
    GowDAlabel(dest, 'r', 'b', DrawSpcName(dspc)); }

  switch (compress) {
  case DrawFirstFound:
    ret_val= DrawSpectrumFirstFound(dest, dspc, x_scale, y_scale, min_dx,
				    cal_s, cal_c, cal_efc, nrm);
    break;
  case DrawEach:
    ret_val= DrawSpectrumEach(dest, dspc, x_scale, y_scale, min_dx,
			      cal_s, cal_c, cal_efc, nrm);
    break;
  case DrawMinMax:
  default:
    ret_val=DrawSpectrumMinMax(dest, dspc, x_scale, y_scale, min_dx,
			       cal_s, cal_c, cal_efc, nrm);
    break;}

  GowDStart_object(dest, "spectrum");
  return ret_val;
}

void DrawSpectrumExpand(dspc,
			x_scale, x_type, x_full,
			y_scale, y_type, y_full,
			calibrated, modification, normalized)
     DrawSpc_t dspc;
     GowScale x_scale;
     GowScaleType x_type;
     int x_full;
     GowScale y_scale;
     GowScaleType y_type;
     int y_full;
     int calibrated;
     GowScaleModificationType modification;
     int normalized;
{
  Spc_t spc= DrawSpcSpc(dspc);
  Cal_t cal= DrawSpcCal(dspc);
  SpcReal_t *s= SpcBufReal(SpcSpc(spc));
  double x_offset, x_range;
  double (*cal_s)();
  double (*cal_c)();
  double (*cal_efc)();
  double nrm= normalized ? *DrawSpcNorm(dspc) : 1.0;

  if (calibrated) { cal_s= CalP; cal_c= CalC; }
  else { cal_s= CalId; cal_c= CalId; }
  switch (modification) {
  case GowMmultiplied: cal_efc= cal_c; break;
  case GowMefficiency: cal_efc= CalEfc; break;
  case GowMnone:
  default: cal_efc= CalUnity; break; }

  if (SpcNum(spc) == 0) { return; }
  else if (x_full) {
    double s_min, s_max;
    s_min= cal_s(cal, -0.5);
    s_max= cal_s(cal, (double)SpcNum(spc) - 0.5);
    if (s_min > s_max) { x_offset= s_max; x_range= s_min - s_max; }
    else { x_offset= s_min; x_range= s_max - s_min; }
    GowExtendNewScaleOffsetRange(x_scale, x_offset, x_range); }
  else if (!GowGetScaleOffset(x_scale, &x_offset) ||
	   !GowGetScaleRange(x_scale, &x_range)) { return; }
  if (y_full) {
    int x_min;
    int x_max;

    { double tmp;
      tmp= cal_c(cal, x_offset); x_min= NINT(tmp);
      tmp= cal_c(cal, x_offset + x_range); x_max= NINT(tmp); }
    if (x_min > x_max) {
      int tmp= x_min;
      x_min= MAX(0, x_max);
      x_max= MIN(SpcNum(spc), tmp+1); }
    else {
      x_min= MAX(0, x_min);
      x_max= MIN(SpcNum(spc), x_max+1); }

    if (x_min >= x_max) { return; }
    else if (y_type == GowLogarithmicScale) {
      double y_min, y_max;
      Boolean found= FALSE;
      int chn;

      for (chn= x_min; chn< x_max; chn++) {
	double tmp= s[chn] * nrm * cal_efc(cal, (double)chn);

	if (tmp > 0) {
	  if (found) {
	    if (tmp < y_min) { y_min= tmp; }
	    else if (tmp > y_max) { y_max= tmp; } }
	  else { y_min= y_max= tmp; found= TRUE; } } }
      if (found) {
	GowExtendNewScaleOffsetRange(y_scale, y_min, y_max - y_min); }
      return; }
    else {
      double y_min, y_max;
      int chn;

      y_min= y_max= s[x_min] * nrm * cal_efc(cal, (double)x_min);
      for (chn= x_min; chn< x_max; chn++) {
	double tmp= s[chn] * nrm * cal_efc(cal, (double)chn);

	if (tmp < y_min) { y_min= tmp; }
	else if (tmp > y_max) { y_max= tmp; } }
      GowExtendNewScaleOffsetRange(y_scale, y_min, y_max - y_min);
      return; } }
  return;
}
