/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawVMark.c,v 1.2 1994/05/26 19:49:01 vs Exp vs $ */

#include <stdio.h>
#include <ctype.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsCal.h>
#include <tv/vsTools.h>

#include "DrawVMark.h"

#define ClippedX(px, scale, xc, xp, xu) \
  switch (xc= px(scale, &xp, xu)) {\
  case GowClipSmall: xc= GowToSmall;\
  case GowToSmall: xp= xp_min; break;\
  case GowClipLarge: xc= GowToLarge;\
  case GowToLarge: xp= xp_max; break;\
  case GowValid: break; }



Boolean DrawVMark(dest, dmrk, x_scale, y_scale,
		  bot_frac, top_frac, cross, bar_position, calibrated)
     GowDestination dest;
     DrawVMrk_t dmrk;
     GowScale x_scale;
     GowScale y_scale;
     double bot_frac;
     double top_frac;
     double cross;
     int bar_position;
     int calibrated;
{
  PVec_t m= DrawVMrkMrk(dmrk);
  Val_t  s= DrawVMrkSgl(dmrk);
  DVec_t v= DrawVMrkVis(dmrk);
  PVec_t b= DrawVMrkBar(dmrk);
  DVecRec used;
  DVec_t u= &used;
  Cal_t cal= DrawVMrkCal(dmrk);
  Boolean visible= FALSE;

  GowPixelFunc px;
  int xp_min, xp_max, yp_min, yp_max;
  int y_1, y_2, yd;
  XSegment *segs;
  double (*cal_s)();

  if (DrawVMrkCalibrated(dmrk) == calibrated) {
    cal_s= CalId; }
  else { cal_s= calibrated ? CalP : CalC; }

  if (!VecNum(m) && !VecNum(v) && (!s || !ValDefined(s))) {
    return FALSE; }		/* no VMark defined */

  GowDSet_gc(dest, DrawVMrkGCIdx(dmrk));

  px= GowGetScalePixelFunction(x_scale);
  xp_min= GowGetScaleLimitPixel(x_scale, GowClipSmall);
  xp_max= GowGetScaleLimitPixel(x_scale, GowClipLarge);
  yp_min= GowGetScaleLimitPixel(y_scale, GowToSmall);
  yp_max= GowGetScaleLimitPixel(y_scale, GowToLarge);
  VecInit(u, sizeof(double));

  top_frac= ABS(top_frac);
  bot_frac= ABS(bot_frac);

  switch (bar_position) {
  case DrawTopBar:
    y_1= yp_max - (yp_max - yp_min) * top_frac;
    y_2= yp_min + (yp_max - yp_min) * bot_frac;
    break;
  case DrawBottomBar:
  case DrawNoBar:
  default:
    y_1= yp_min + (yp_max - yp_min) * bot_frac;
    y_2= yp_max - (yp_max - yp_min) * top_frac;
    break; }

  yd= (y_1 + y_2) / 2;

  if (!(segs= (XSegment *)Malloc(sizeof(XSegment) *
				 (1 + /* single */
				  VecNum(b) + /* bar */
				  3 * VecNum(m) + /* pair */
				  3 * VecNum(v))))) { /* delete-cross */
    return FALSE; }

  GowDStart_object(dest, "vertical-mark");

  { XSegment *seg= segs;

    { int vi;
      for (vi= 0; vi< VecNum(v); vi++) {
	int x1;
	if (px(x_scale, &x1, VecP(v)[vi]) == GowValid) {
	  seg->x1= x1; seg->y1= y_1; seg->x2= x1; seg->y2= y_2; seg++; } } }

    if (bar_position != DrawNoBar) {
      int bi;
      for (bi= 0; bi< VecNum(b); bi++) {
	int x1, x2;
	GowScaleConversion xc1, xc2;

	ClippedX(px, x_scale, xc1, x1, PVecX1(b,bi));
	ClippedX(px, x_scale, xc2, x2, PVecX2(b,bi));
	seg->x1= x1; seg->y1= y_1; seg->x2= x2; seg->y2= y_1; seg++; } }

    { int x1;
      double xs;
      if (s && ValDefined(s) &&
	  px(x_scale, &x1, (xs= cal_s(cal, ValValue(s)))) == GowValid) {
	int vi;
	for (vi= 0; vi< VecNum(v) && xs > VecP(v)[vi]; vi++) { ; }
	if ((vi == VecNum(v) || xs != VecP(v)[vi]) &&
	    VecInsert(v, vi, 1)) {
	  VecP(v)[vi]= xs;
	  seg->x1= x1; seg->y1= y_1; seg->x2= x1; seg->y2= y_2; seg++; }
	if (VecInsert(u, 0, 1)) { VecP(u)[0]= xs; } } }

    { int mi, vi, bi, ui;
      for (mi= 0, vi= 0, bi= 0, ui= 0; mi< VecNum(m); mi++) {
	int x1, x2;
	GowScaleConversion xc1, xc2;
	double xs1, xs2;

	ClippedX(px, x_scale, xc1, x1, (xs1= cal_s(cal, PVecX1(m,mi))));
	ClippedX(px, x_scale, xc2, x2, (xs2= cal_s(cal, PVecX2(m,mi))));

	if (xc1 == GowValid) {
	  while (vi< VecNum(v) && xs1 > VecP(v)[vi]) { vi++; }
	  if ((vi == VecNum(v) || xs1 != VecP(v)[vi]) &&
	      VecInsert(v, vi, 1)) {
	    VecP(v)[vi]= xs1;
	    seg->x1= x1; seg->y1= y_1; seg->x2= x1; seg->y2= y_2; seg++; }
	  while (ui< VecNum(u) && xs1 > VecP(u)[ui]) { ui++; }
	  if ((ui == VecNum(u) || xs1 != VecP(u)[ui]) &&
	      VecInsert(u, ui, 1)) {
	    VecP(u)[ui]= xs1; } }
	if (xc2 == GowValid) {
	  int vj, uj;
	  for (vj= vi; vj< VecNum(v) && xs2 > VecP(v)[vj]; vj++) { ; }
	  if ((vj == VecNum(v) || xs2 != VecP(v)[vj]) &&
	      VecInsert(v, vj, 1)) {
	    VecP(v)[vj]= xs2;
	    seg->x1= x2; seg->y1= y_1; seg->x2= x2; seg->y2= y_2; seg++; }
	  for (uj= ui; uj< VecNum(u) && xs2 > VecP(u)[uj]; uj++) { ; }
	  if ((uj == VecNum(u) || xs2 != VecP(u)[uj]) &&
	      VecInsert(u, uj, 1)) {
	    VecP(u)[uj]= xs2; } }
	if (bar_position != DrawNoBar &&
	    (xc1 == GowValid || xc1 != xc2)) {
	  while (bi< VecNum(b) && xs1 > PVecX1(b,bi)) { bi++; }
	  if ((bi == VecNum(b) ||
	       xs1 != PVecX1(b,bi) || xs2 != PVecX2(b,bi)) &&
	      VecInsert(b, bi, 1)) {
	    PVecX1(b,bi)= xs1; PVecX2(b,bi)= xs2;
	    seg->x1= x1; seg->y1= y_1; seg->x2= x2; seg->y2= y_1; seg++; }
	if (xc1 == GowToLarge) { break; } } } }

    if (cross != 0.0) {
      int ui= 0, vi= 0, cw;
      { int cx, cy;
	cx= (xp_max - xp_min) * cross; cx= ABS(cx);
	cy= (yp_max - yp_min) * cross; cy= ABS(cy);
	cw= MIN(cx, cy); }

      while (vi< VecNum(v) && ui< VecNum(u)) {
	if (VecP(u)[ui] == VecP(v)[vi]) { ui++; vi++; }
	else if (VecP(u)[ui] > VecP(v)[vi]) {
	  int x1;
	  if (px(x_scale, &x1, VecP(v)[vi]) == GowValid) {
	    seg->x1= x1-cw; seg->y1= yd-cw;
	    seg->x2= x1+cw; seg->y2= yd+cw; seg++;
	    seg->x1= x1+cw; seg->y1= yd-cw;
	    seg->x2= x1-cw; seg->y2= yd+cw; seg++; }
	  vi++; } }
      while (vi< VecNum(v)) {
	int x1;
	if (px(x_scale, &x1, VecP(v)[vi]) == GowValid) {
	  seg->x1= x1-cw; seg->y1= yd-cw;
	  seg->x2= x1+cw; seg->y2= yd+cw; seg++;
	  seg->x1= x1+cw; seg->y1= yd-cw;
	  seg->x2= x1-cw; seg->y2= yd+cw; seg++; }
	vi++; } }

    if (seg - segs > 0 && GowDSegments(dest, segs, seg - segs)) {
      visible= TRUE; } }

  GowDEnd_object(dest, "vertical-mark");

  Free(segs);
  VecFree(u);
  return visible;
}

void DrawVMarkFree(dmrk)
     DrawVMrk_t dmrk;
{
  VecFree(DrawVMrkVis(dmrk));
  VecFree(DrawVMrkBar(dmrk));
}

void DrawVMarkInit(dmrk)
     DrawVMrk_t dmrk;
{
  DrawVMrkGCIdx(dmrk)= 0;
  DrawVMrkMrk(dmrk)= NULL;
  DrawVMrkSgl(dmrk)= NULL;
  VecInit(DrawVMrkVis(dmrk), sizeof(double));
  VecInit(DrawVMrkBar(dmrk), sizeof(Pair_t));
  DrawVMrkCal(dmrk)= NULL;
  DrawVMrkCalibrated(dmrk)= FALSE;
}
