/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowDest.c,v 1.2 1994/05/26 19:49:06 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <Gow/GowDestX11.h>
#include <Gow/GowDestXfig.h>
#include <Gow/GowDestUnix.h>

#include <tv/vsAlloc.h>

#include "GowDestP.h"

/* ---------------------------------------------------------------------- */
static void ResetGC();
/* ---------------------------------------------------------------------- */
GowDestination GowCreateDestination(w)
     Widget w;
{
  GowDestination d;

  if ((d= (GowDestination)Malloc(sizeof(GowDestinationRec)))) {
    d->fct		= NULL;

    d->widget		= NULL;
    d->drawable		= (Drawable)NULL;
    d->display		= NULL;

    d->fp		= NULL;

    ResetGC(d);

    GowCreateX11Destination(d, w);

    d->type		= 'X'; }
  return d;
}
/* ---------------------------------------------------------------------- */
void GowDestroyDestination(d)
     GowDestination d;
{
  if (d) {
    GowDestroyX11Destination(d);
    Free(d); }
}
/* ---------------------------------------------------------------------- */
Boolean GowChangeX11Geometry(d)
     GowDestination d;
{
  GowChangeX11Destination(d);
  return TRUE;
}
/* ---------------------------------------------------------------------- */
GowDestFile GowCreatePlotDestination(file, x, y, fontscale, type, geo)
     char *file;
     int x, y;
     double fontscale;
     int type;
     GowDestGeometry geo;
{
  switch (type) {
  case 'x':			/* xfig */
    return GowCreateXfigDestination(file, x, y, fontscale, geo);
  case 'u':			/* unix */
    return GowCreateUnixDestination(file, x, y, fontscale, geo);
  default:
    return NULL; }
  return NULL;
}
/* ---------------------------------------------------------------------- */
Boolean GowDestroyPlotDestination(fp, type)
     GowDestFile fp;
     int type;
{
  switch (type) {
  case 'x':			/* xfig */
    return GowDestroyXfigDestination(fp);
  case 'u':			/* unix */
    return GowDestroyUnixDestination(fp);
  default:
    return FALSE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
Boolean GowSetupPlotDestination(d, type, fp, geo)
     GowDestination d;
     int type;
     GowDestFile fp;
     GowDestGeometry geo;
{
  if (!d || !fp || !geo) { return FALSE; }
  d->plot	= geo;
  d->fp		= fp;
  ResetGC(d);
  switch (type) {
  case 'x':	GowSetupXfigDestination(d); break;
  case 'u':	GowSetupUnixDestination(d); break;
  default:
    GowSetupX11Destination(d);
    d->type	= 'X';		/* reset to X11-destination */
    return FALSE; }
  d->type	= type;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
void GowFinishPlotDestination(d)
     GowDestination d;
{
  if (d) {
    switch (d->type) {
    case 'x':	GowFinishXfigDestination(d); break;
    case 'u':	GowFinishUnixDestination(d); break;
    default:	break; }
    d->fp	= NULL;
    d->plot	= NULL;
    ResetGC(d);
    GowSetupX11Destination(d);
    d->type	= 'X'; }
}
/* ---------------------------------------------------------------------- */
Boolean GowConfigureGeometry(geo, root, type,
			     x_normal_offset, y_normal_offset,
			     x_range, y_range)
     GowDestGeometry geo, root;
     int type;
     int x_normal_offset, y_normal_offset;
     int x_range, y_range;
{
  if (x_range <= 1 || y_range <= 1) { return FALSE; }

  geo->x_range= x_range;
  geo->y_range= y_range;
  geo->x_offset= (root->x_offset +
		  ((root->x_direction > 0) ? x_normal_offset :
		   (root->x_range - x_normal_offset - x_range)));
  geo->y_offset= (root->y_offset +
		  ((root->y_direction > 0) ? y_normal_offset :
		   (root->y_range - y_normal_offset - y_range)));
  geo->x_direction= root->x_direction;
  geo->y_direction= root->y_direction;
  geo->fontscale= root->fontscale;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
Boolean GowDAlabel(d, x_justify, y_justify, label)
     GowDestination d;
     int x_justify, y_justify;
     char *label;
     
{
  if (!strlen(label)) { return FALSE; }
  else { return ((d)->fct->alabel(d, x_justify, y_justify, label)); }
}
/* ---------------------------------------------------------------------- */
Boolean GowDArc(d, x_center, y_center, x_start, y_start, x_end, y_end)
     GowDestination d;
     int x_center, y_center;
     int x_start, y_start;
     int x_end, y_end;
{
  return ((d)->fct->arc(d, x_center, y_center,
			x_start, y_start, x_end, y_end));
}
/* ---------------------------------------------------------------------- */
Boolean GowDCircle(d, x, y, r)
     GowDestination d;
     int x, y, r;
{
  return ((d)->fct->circle(d, x, y, r));
}
/* ---------------------------------------------------------------------- */
Boolean GowDComment(d, label)
     GowDestination d;
     char *label;
{
  return ((d)->fct->comment(d, label));
}
/* ---------------------------------------------------------------------- */
Boolean GowDCont(d, x, y)
     GowDestination d;
     int x, y;
{
  return ((d)->fct->cont(d, x, y));
}
/* ---------------------------------------------------------------------- */
Boolean GowDLabel(d, label)
     GowDestination d;
     char *label;
{
  return ((d)->fct->label(d, label));
}
/* ---------------------------------------------------------------------- */
Boolean GowDLine(d, x_start, y_start, x_end, y_end)
     GowDestination d;
     int x_start, y_start, x_end, y_end;
{
  return ((d)->fct->line(d, x_start, y_start, x_end, y_end));
}
/* ---------------------------------------------------------------------- */
Boolean GowDLines(d, xy, num)
     GowDestination d;
     XPoint *xy;
     int num;
{
  return ((d)->fct->lines(d, xy, num));
}
/* ---------------------------------------------------------------------- */
Boolean GowDMove(d, x, y)
     GowDestination d;
     int x, y;
{
  return ((d)->fct->move(d, x, y));
}
/* ---------------------------------------------------------------------- */
Boolean GowDPoint(d, x, y)
     GowDestination d;
     int x, y;
{
  return ((d)->fct->point(d, x, y));
}
/* ---------------------------------------------------------------------- */
Boolean GowDPoints(d, xy, num)
     GowDestination d;
     XPoint *xy;
     int num;
{
  return ((d)->fct->points(d, xy, num));
}
/* ---------------------------------------------------------------------- */
Boolean GowDSegments(d, s, num)
     GowDestination d;
     XSegment *s;
     int num;
{
  return ((d)->fct->segments(d, s, num));
}
/* ---------------------------------------------------------------------- */
Boolean GowDStart_object(d, label)
     GowDestination d;
     char *label;
{
  return ((d)->fct->start_object(d, label));
}
/* ---------------------------------------------------------------------- */
Boolean GowDEnd_object(d, label)
     GowDestination d;
     char *label;
{
  return ((d)->fct->end_object(d, label));
}
/* ---------------------------------------------------------------------- */
Boolean GowDSet_angle360(d, angle)
     GowDestination d;
     int angle;
{
  if ((d)->fct->set_angle360(d, angle)) {
    d->angle= angle;
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
Boolean GowDSet_gc(d, idx)
     GowDestination d;
     int idx;
{
  (d)->linewidth= -1;
  (d)->fontwidth= -1;
  (d)->fontheight= -1;
  return ((d)->fct->set_gc(d, idx));
}
/* ---------------------------------------------------------------------- */
void GowDText_extents(d, text, height, width)
     GowDestination d;
     char *text;
     int *height, *width;
{
  ((d)->fct->text_extents(d, text, height, width));
}
/* ---------------------------------------------------------------------- */
int  GowDLinewidth(d)
     GowDestination d;
{
  if ((d)->linewidth <= 0) {
    return ((d)->linewidth= (d)->fct->linewidth(d)); }
  else { return (d)->linewidth; }
}
/* ---------------------------------------------------------------------- */
int GowDFontwidth(d)
     GowDestination d;
{
  if ((d)->fontwidth <= 0) {
    (d)->fontwidth= (((d)->type == 'X') ? (d)->fct->fontwidth(d) :
		     ((d)->fct->fontwidth(d) * (d)->plot->fontscale)); }
  return (d)->fontwidth;
}
/* ---------------------------------------------------------------------- */
int GowDFontheight(d)
     GowDestination d;
{
  if ((d)->fontheight <= 0) {
    (d)->fontheight= (((d)->type == 'X') ? (d)->fct->fontheight(d) :
		      ((d)->fct->fontheight(d) * (d)->plot->fontscale)); }
  return (d)->fontheight;
}
/* ---------------------------------------------------------------------- */
int GowDXOffset(d)
     GowDestination d;
{
  return (((d)->type == 'X') ? (d)->x11.x_offset : (d)->plot->x_offset);
}
/* ---------------------------------------------------------------------- */
int GowDXRange(d)
     GowDestination d;
{
  return (((d)->type == 'X') ? (d)->x11.x_range : (d)->plot->x_range);
}
/* ---------------------------------------------------------------------- */
int GowDXDirection(d)
     GowDestination d;
{
  return (((d)->type == 'X') ? (d)->x11.x_direction : (d)->plot->x_direction);
}
/* ---------------------------------------------------------------------- */
int GowDYOffset(d)
     GowDestination d;
{
  return (((d)->type == 'X') ? (d)->x11.y_offset : (d)->plot->y_offset);
}
/* ---------------------------------------------------------------------- */
int GowDYRange(d)
     GowDestination d;
{
  return (((d)->type == 'X') ? (d)->x11.y_range : (d)->plot->y_range);
}
/* ---------------------------------------------------------------------- */
int GowDYDirection(d)
     GowDestination d;
{
  return (((d)->type == 'X') ? (d)->x11.y_direction : (d)->plot->y_direction);
}
/* ---------------------------------------------------------------------- */
static void ResetGC(d)
     GowDestination d;
{
  d->num_gcs		= 0;
  d->gcs		= NULL;

  d->actual_gc		= NULL;
  d->actual_idx		= -1;
  d->linewidth		= -1;
  d->fontheight		= -1;
  d->fontwidth		= -1;
}
/* ---------------------------------------------------------------------- */

#endif				/* HAS_XT_GRAPHIC */
