/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowDest.h,v 1.2 1994/05/26 19:49:06 vs Exp vs $ */

#ifndef _GowDest_h
#define _GowDest_h

#include <Gow/GowConfig.h>

typedef struct _GowDestinationRec	*GowDestination;
typedef void				*GowGC;
typedef void				*GowDestFile;

typedef struct {
  int		x_offset;	/* lower left corner of associated window */
  int		y_offset;
  int		x_range;	/* width of associated destination */
  int		y_range;	/* height of associated destination */
  int		x_direction;
  int		y_direction;
  double	fontscale;
} GowDestGeometryRec, *GowDestGeometry;  

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

/* GowDest.c */
extern GowDestination	GowCreateDestination P_((Widget w));
extern void		GowDestroyDestination P_((GowDestination d));
extern Boolean		GowChangeX11Geometry P_((GowDestination d));
extern GowDestFile	GowCreatePlotDestination P_((char *file,
						     int x, int y,
						     double fontscale,
						     int type,
						     GowDestGeometry geo));
extern Boolean		GowDestroyPlotDestination P_((GowDestFile fp,
						      int type));
extern Boolean		GowSetupPlotDestination P_((GowDestination d,
						    int type, GowDestFile fp,
						    GowDestGeometry geo));
extern void		GowFinishPlotDestination P_((GowDestination d));
extern Boolean		GowConfigureGeometry P_((GowDestGeometry geo,
						 GowDestGeometry root,
						 int type,
						 int x_normal_offset,
						 int y_normal_offset,
						 int x_range, int y_range));

				/* basic draw functions */
extern Boolean GowDAlabel P_((GowDestination d,
			      int x_justify, int y_justify, char *label));
extern Boolean GowDArc P_((GowDestination d,
			   int x_center, int y_center,
			   int x_start, int y_start, int x_end, int y_end));
extern Boolean GowDCircle P_((GowDestination d, int x, int y, int r));
extern Boolean GowDComment P_((GowDestination d, char *label));
extern Boolean GowDCont P_((GowDestination d, int x, int y));
extern Boolean GowDLabel P_((GowDestination d, char *label));
extern Boolean GowDLine P_((GowDestination d,
			    int x_start, int y_start, int x_end, int y_end));
extern Boolean GowDLines P_((GowDestination d, XPoint *xy, int num));
extern Boolean GowDMove P_((GowDestination d, int x, int y));
extern Boolean GowDPoint P_((GowDestination d, int x, int y));
extern Boolean GowDPoints P_((GowDestination d, XPoint *xy, int num));
extern Boolean GowDSegments P_((GowDestination d, XSegment *s, int num));
extern Boolean GowDStart_object P_((GowDestination d, char *label));
extern Boolean GowDEnd_object P_((GowDestination d, char *label));
extern Boolean GowDSet_angle360 P_((GowDestination d, int angle));
extern Boolean GowDSet_gc P_((GowDestination d, int idx));
extern void GowDText_extents P_((GowDestination d,
				 char *text, int *height, int *width));
extern int GowDLinewidth P_((GowDestination d));
extern int GowDFontwidth P_((GowDestination d));
extern int GowDFontheight P_((GowDestination d));
extern int GowDXOffset P_((GowDestination d));
extern int GowDXRange P_((GowDestination d));
extern int GowDXDirection P_((GowDestination d));
extern int GowDYOffset P_((GowDestination d));
extern int GowDYRange P_((GowDestination d));
extern int GowDYDirection P_((GowDestination d));

#undef P_

#endif				/* _GowDest_h */
