/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowDestP.h,v 1.2 1994/05/26 19:49:07 vs Exp vs $ */

#ifndef _GowDestP_h
#define _GowDestP_h

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <Gow/GowDest.h>


#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

typedef Boolean	(*GowAlabelFunc) P_((GowDestination d,
				     int x_justify, int y_justify,
				     char *label));
typedef Boolean	(*GowArcFunc) P_((GowDestination dest,
				  int x_center, int y_center,
				  int x_start, int y_start,
				  int x_end, int y_end));
typedef Boolean	(*GowCircleFunc) P_((GowDestination dest,
				     int x, int y, int r));
typedef Boolean	(*GowLineFunc) P_((GowDestination dest,
				   int X1, int Y1, int X2, int Y2));
typedef Boolean	(*GowPointFunc) P_((GowDestination dest, int x, int y));
typedef Boolean	(*GowPointsFunc) P_((GowDestination dest,
				     XPoint *xy, int num));
typedef Boolean	(*GowSegmentsFunc) P_((GowDestination dest,
				       XSegment *s, int num));
typedef Boolean	(*GowTextFunc) P_((GowDestination dest, char *text));
typedef Boolean	(*GowSetAngle360Func) P_((GowDestination dest, int angle));
typedef Boolean	(*GowSetGCFunc) P_((GowDestination dest, int idx));
typedef void	(*GowTextExtentsProc) P_((GowDestination dest,
					  char *text,
					  int *height, int *width));
typedef int	(*GowIntValueFunc) P_((GowDestination dest));

#undef P_

typedef struct _GowDestFuncsRec {
  GowAlabelFunc		alabel;	/* basic draw functions */
  GowArcFunc		arc;
  GowCircleFunc		circle;
  GowTextFunc		comment;
  GowPointFunc		cont;
  GowTextFunc		label;
  GowLineFunc		line;
  GowPointsFunc		lines;
  GowPointFunc		move;
  GowPointFunc		point;
  GowPointsFunc		points;
  GowSegmentsFunc	segments;

  GowTextFunc		start_object;
  GowTextFunc		end_object;

  GowSetAngle360Func	set_angle360;
  GowSetGCFunc		set_gc;
  GowTextExtentsProc	text_extents;

  GowIntValueFunc	linewidth;
  GowIntValueFunc	fontheight;
  GowIntValueFunc	fontwidth;
} GowDestFuncsRec, *GowDestFuncs;

typedef void		*GowGCs;

typedef struct _GowDestinationRec {
  GowDestFuncs		fct;

  Widget		widget;
  Drawable		drawable;
  Display		*display;

  GowDestFile		fp;

  int			num_gcs;
  GowGCs		gcs;

  GowGC			actual_gc;
  int			actual_idx;
  int			linewidth;
  int			fontheight;
  int			fontwidth;

  int			angle;

  int			actual_x;
  int			actual_y;

  char			type;

  GowDestGeometryRec	x11;

  GowDestGeometry	plot;

} GowDestinationRec;

#endif				/* HAS_XT_GRAPHIC */

#endif				/* _GowDestP_h */
