/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowDestUnix.c,v 1.2 1994/05/26 19:49:07 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <math.h>
#include <stdio.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include "GowDestP.h"
#include "GowGCsUnixP.h"
#include "GowDestUnix.h"

				/* basic draw functions */
#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

/* GowDestUnix.c */
static Boolean Alabel P_((GowDestination d,
			  int x_justify, int y_justify, char *label));
static Boolean Arc P_((GowDestination d, int center_x, int center_y,
		       int start_x, int start_y, int end_x, int end_y));
static Boolean Circle P_((GowDestination d, int x, int y, int r));
static Boolean Comment P_((GowDestination d, char *comment));
static Boolean Cont P_((GowDestination d, int x, int y));
static Boolean Label P_((GowDestination d, char *label));
static Boolean Line P_((GowDestination d,
			int x_start, int y_start, int x_end, int y_end));
static Boolean Lines P_((GowDestination d, XPoint *points, int npoints));
static Boolean Move P_((GowDestination d, int x, int y));
static Boolean Point P_((GowDestination d, int x, int y));
static Boolean Points P_((GowDestination d, XPoint *points, int npoints));
static Boolean Segments P_((GowDestination d,
			    XSegment *segments, int nsegments));
static Boolean Set_angle360 P_((GowDestination d, int angle));
static Boolean Set_gc P_((GowDestination d, int idx));
static void Text_extents P_((GowDestination d, char *label,
			     int *height, int *width));
static int Linewidth P_((GowDestination d));
static int Fontheight P_((GowDestination d));
static int Fontwidth P_((GowDestination d));

#undef P_

static GowDestFuncsRec fct= {
  Alabel,
  Arc,
  Circle,
  Comment,
  Cont,
  Label,
  Line,
  Lines,
  Move,
  Point,
  Points,
  Segments,

  Comment,			/* start_object */
  Comment,			/* end_object */

  Set_angle360,
  Set_gc,
  Text_extents,

  Linewidth,
  Fontheight,
  Fontwidth };

/* ---------------------------------------------------------------------- */
#define PUT1SHORTF(f,v) \
	{ short s= v; fwrite(&s, sizeof(short), 1, f); }
#define PUT2SHORTF(f,v1,v2) \
	{ short s[2]; s[0]= v1; s[1]= v2; fwrite(s, sizeof(short), 2, f); }
#define PUTCHARF(f,c)	{ fputc(c, f); }
#define PUTTEXTF(f,t)	{ fprintf(f, "%s\n", t); }
/* ---------------------------------------------------------------------- */
GowDestFile GowCreateUnixDestination(file, x, y, fontscale, geo)
     char *file;
     int x, y;
     double fontscale;
     GowDestGeometry geo;
{
  FILE *fp= NULL;
  if (x != 0.0 && y != 0.0) {
    if (x > 32000 || y > 32000) {
      if (x > y) { y= (int)((double)y / (double)x * 32000.0); x= 32000; }
      else { x= ((double)x / (double)y * 32000.0); y= 32000; } }

    if ((fp= fopen(file, "w"))) {
      PUTCHARF(fp, 's'); PUT2SHORTF(fp, 0, 0); PUT2SHORTF(fp, x, y);
      geo->x_offset	= 0;
      geo->x_range	= x;
      geo->x_direction	= 1;
      geo->y_offset	= 0;
      geo->y_range	= y;
      geo->y_direction	= 1;
      geo->fontscale	= fontscale; } }
  return (GowDestFile)fp;
}
/* ---------------------------------------------------------------------- */
Boolean GowDestroyUnixDestination(fp)
     GowDestFile fp;
{
  return (fclose((FILE *)fp) != EOF);
}
/* ---------------------------------------------------------------------- */
void GowSetupUnixDestination(d)
     GowDestination d;
{
  d->fct= &fct;
  return;
}
/* ---------------------------------------------------------------------- */
void GowFinishUnixDestination(d)
     GowDestination d;
{
  return;
}
/* ---------------------------------------------------------------------- */
/*
 * Functions of standard interface for drawing (GowDestination)
 */
/* ---------------------------------------------------------------------- */
#define PUT1SHORT(d,v)		PUT1SHORTF((FILE *)d->fp, v)
#define PUT2SHORT(d,v1,v2)	PUT2SHORTF((FILE *)d->fp, v1, v2)
#define PUTCHAR(d,c)		PUTCHARF((FILE *)d->fp, c)
#define PUTTEXT(d,t)		PUTTEXTF((FILE *)d->fp, t)
/* ---------------------------------------------------------------------- */
static Boolean Alabel(d, x_justify, y_justify, label)
     GowDestination d;
     int x_justify;
     int y_justify;
     char *label;
{
  int width, height;

  Text_extents(d, label, &height, &width);

  PUTCHAR(d, 'T');
  PUTCHAR(d, x_justify);
  PUTCHAR(d, y_justify);
  PUTTEXT(d, label);

  d->actual_x += width;
  /* d->actual_y= unchanged */

  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Arc(d, center_x, center_y, start_x, start_y, end_x, end_y)
     GowDestination d;
     int center_x, center_y;
     int start_x, start_y;
     int end_x, end_y;
{
  PUTCHAR(d, 'a');
  PUT2SHORT(d, center_x, center_y);
  PUT2SHORT(d, start_x, start_y);
  PUT2SHORT(d, end_x, end_y);

  d->actual_x= center_x;
  d->actual_x= center_y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Circle(d, x, y, r)
     GowDestination d;
     int x, y, r;
{
  PUTCHAR(d, 'c');
  PUT2SHORT(d, x, y);
  PUT1SHORT(d, r);

  d->actual_x= x;
  d->actual_x= y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Comment(d, comment)
     GowDestination d;
     char *comment;
{
  return FALSE;			/* do nothing */
}
/* ---------------------------------------------------------------------- */
static Boolean Cont(d, x, y)
     GowDestination d;
     int x, y;
{
  PUTCHAR(d, 'n');
  PUT2SHORT(d, x, y);
  d->actual_x = x;
  d->actual_y = y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Label(d, label)
     GowDestination d;
     char *label;
{
  return Alabel(d, 'l', 'c', label);
}
/* ---------------------------------------------------------------------- */
static Boolean Line(d, x_start, y_start, x_end, y_end)
     GowDestination d;
     int x_start, y_start, x_end, y_end;
{
  PUTCHAR(d, 'l');
  PUT2SHORT(d, x_start, y_start);
  PUT2SHORT(d, x_end, y_end);

  d->actual_x = x_end;
  d->actual_y = y_end;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Lines(d, points, npoints)
     GowDestination d;
     XPoint *points;
     int npoints;
{
  if (!npoints) { return FALSE; }
  Move(d, points[0].x, points[0].y);
  { int i;
    for (i= 1; i< npoints; i++) { Cont(d, points[i].x, points[i].y); } }
  d->actual_x = points[npoints-1].x;
  d->actual_y = points[npoints-1].y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Move(d, x, y)
     GowDestination d;
     int x, y;
{
  PUTCHAR(d, 'm');
  PUT2SHORT(d, x, y);
  d->actual_x = x;
  d->actual_y = y;
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static Boolean Point(d, x, y)
     GowDestination d;
     int x, y;
{
#if 0
  PUTCHAR(d, 'p');		/* bug in plot2ps */
  PUT2SHORT(d, x, y);
#endif
  PUTCHAR(d, 'm');		/* move */
  PUT2SHORT(d, x, y);
  PUTCHAR(d, 'n');		/* cont */
  PUT2SHORT(d, x+1, y);
  d->actual_x = x;
  d->actual_y = y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Points(d, points, npoints)
     GowDestination d;
     XPoint *points;
     int npoints;
{
  if (!npoints) { return FALSE; }
  { int i;
    for (i= 0; i< npoints; i++) { Point(d, points[i].x, points[i].y); } }
  d->actual_x = points[npoints-1].x;
  d->actual_y = points[npoints-1].y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Segments(d, segments, nsegments)
     GowDestination d;
     XSegment *segments;
     int nsegments;
{
  if (!nsegments) { return FALSE; }
  { int i;
    for (i= 0; i< nsegments; i++) {
      Line(d,
	   segments[i].x1, segments[i].y1,
	   segments[i].x2, segments[i].y2); } }
  d->actual_x = segments[nsegments-1].x2;
  d->actual_y = segments[nsegments-1].y2;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static void Set_color(d, color)
     GowDestination d;
     GowUnixColor color;
{
  PUTCHAR(d, 'C');
  PUT1SHORT(d, color->r); PUT1SHORT(d, color->g); PUT1SHORT(d, color->b); 
}
/* ---------------------------------------------------------------------- */
static void Set_fontname(d, fontname)
     GowDestination d;
     char *fontname;
{
  PUTCHAR(d, 'F');
  PUTTEXT(d, fontname);
}
/* ---------------------------------------------------------------------- */
static void Set_fontsize(d, fontsize)
     GowDestination d;
     GowLineStyle fontsize;
{
  PUTCHAR(d, 'S');
  PUT1SHORT(d, fontsize);
}
/* ---------------------------------------------------------------------- */
static void Set_Linestyle(d, linestyle)
     GowDestination d;
     GowLineStyle linestyle;
{
  char *line;
  switch (linestyle) {
  case GowLineLongdashed:	line= "longdashed"; break;
  case GowLineDisconnected:	line= "disconnected"; break;
  case GowLineDotted:		line= "dotted"; break;
  case GowLineOdddashed:	/* not supported */
  case GowLineDotdashed:	line= "dotdashed"; break;
  case GowLineShortdashed:	line= "shortdashed"; break;
  case GowLineSolid:
  default:			line= "solid"; break; }
  PUTCHAR(d, 'f');
  PUTTEXT(d, line);
}
/* ---------------------------------------------------------------------- */
static Boolean Set_angle360(d, angle)
     GowDestination d;
     int angle;
{
  PUTCHAR(d, 'r');
  PUT2SHORT(d, 0, 0);		/* currently unused */
  PUT1SHORT(d, angle);
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Set_gc(d, idx)
     GowDestination d;
     int idx;
{
  if (d->gcs) {
    UnixGC new, old= d->actual_gc;

    d->actual_idx	= idx % d->num_gcs;
    new			= ((UnixGC)d->gcs) + d->actual_idx;
    d->actual_gc	= (GowGC)new;

    if (!new || new == old) { return TRUE; }

    if (!old || old->color != new->color) { Set_color(d, new->color); }
    if (!old || strcmp(old->fontname, new->fontname)) {
      Set_fontname(d, new->fontname); }
    if (!old || old->fontsize != new->fontsize) {
      Set_fontsize(d, new->fontsize); }
    if (!old || old->linestyle != new->linestyle) {
      Set_Linestyle(d, new->linestyle); }

    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static void Text_extents(d, label, height, width)
     GowDestination d;
     char *label;
     int *height, *width;
{
  int sl= strlen(label);

  if (sl) { *height= Fontheight(d); *width= sl * Fontwidth(d); }
  else { *height= *width= 0; }
  return;
}
/* ---------------------------------------------------------------------- */
static int Linewidth(d)
     GowDestination d;
{
  return 0;
}
/* ---------------------------------------------------------------------- */
static int Fontheight(d)
     GowDestination d;
{
  return ((UnixGC)d->actual_gc)->fontsize;
}
/* ---------------------------------------------------------------------- */
static int Fontwidth(d)
     GowDestination d;
{
  return ((UnixGC)d->actual_gc)->fontsize;
}
/* ---------------------------------------------------------------------- */

#endif				/* HAS_XT_GRAPHIC */
