/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowDestWidget.c,v 1.2 1994/05/26 19:49:08 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <math.h>
#include <stdio.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#ifdef HAS_XAW3D
#include <X11/Xaw3d/XawInit.h>
#include <X11/Xaw3d/Cardinals.h>
#include <X11/Xaw3d/Label.h>
#else
#include <X11/Xaw/XawInit.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Label.h>
#endif

#include <X11/Xmu/Initer.h>
#include <X11/Xmu/CharSet.h>

#include "GowDestWidgetP.h"

#define Offset(field) \
  XtOffsetOf(GowDestinationWidgetRec, destination_widget.field)

static XtResource resources[] = { 
  { XtNbackingStore, XtCBackingStore, XtRBackingStore, sizeof(int),
    Offset(backing_store), 
    XtRImmediate, (XtPointer)(Always + WhenMapped + NotUseful)},
  { XtNcursor, XtCCursor, XtRCursor, sizeof(Cursor),
    Offset(cursor),
    XtRString, "crosshair" },
};

#undef Offset

/*
 * Default Translations
 */

/* none */

/*
 * Semi Public function definitions. 
 */

static void Realize(), Resize();
static void ClassInitialize(), ClassPartInitialize();
static void Initialize(), Destroy();
static Boolean SetValues();
static XtGeometryResult GeometryManager();

/* these Core methods not needed:
 *
 */

/*
 * Action Routine Definitions
 */

/* 
 * Private Function Definitions.
 */


/*
 * Actions list
 */

static CompositeClassExtensionRec extension_rec = {
    /* next_extension */  NULL,
    /* record_type */     NULLQUARK,
    /* version */         XtCompositeExtensionVersion,
    /* record_size */     sizeof(CompositeClassExtensionRec),
    /* accepts_objects */ TRUE,
};

#define SUPERCLASS (&compositeClassRec)
    
GowDestinationWidgetClassRec gowDestinationWidgetClassRec = {
  {				/* core_class */
    /* superclass         */    (WidgetClass) SUPERCLASS,
    /* class_name         */    "GowDestinationWidget",
    /* size               */    sizeof(GowDestinationWidgetRec),
    /* class_initialize   */	ClassInitialize,
    /* class_part_initialize*/	ClassPartInitialize,
    /* Class init'ed      */	FALSE,
    /* initialize         */    Initialize,
    /* initialize_hook    */	NULL,
    /* realize            */    Realize,
    /* actions            */    NULL,
    /* num_actions        */    0,
    /* resources          */    resources,
    /* resource_count     */	XtNumber(resources),
    /* xrm_class          */    NULLQUARK,
    /* compress_motion    */    TRUE, 
    /* compress_exposure  */    TRUE,
    /* compress_enterleave*/ 	TRUE,
    /* visible_interest   */    FALSE,
    /* destroy            */    Destroy,
    /* resize             */    Resize,
    /* expose             */    NULL,
    /* set_values         */    SetValues,
    /* set_values_hook    */	NULL,
    /* set_values_almost  */	XtInheritSetValuesAlmost,  
    /* get_values_hook    */	NULL,			
    /* accept_focus       */    NULL,
    /* intrinsics version */	XtVersion,
    /* callback offsets   */    NULL,
    /* tm_table		  */    NULL,
    /* query_geometry	  */    NULL,
    /* display_accelerator*/    NULL,
    /* extension	  */    NULL
  },
  {				/* composite_class */
    /* geometry_manager   */    GeometryManager,
    /* change_managed     */    NULL,
    /* insert_child	  */	XtInheritInsertChild,
    /* delete_child	  */	XtInheritDeleteChild,
    /* extension	  */    NULL
  }
};

WidgetClass gowDestinationWidgetClass
  = (WidgetClass)&gowDestinationWidgetClassRec;

/************************************************************
 *
 * Semi-Public Functions.
 *
 ************************************************************/

/*      Function Name: ClassInitialize
 *      Description: Class Initialize routine, called only once.
 *      Arguments: none.
 *      Returns: none.
 */

static void
ClassInitialize()
{
  XawInitializeWidgetSet();
  XtAddConverter( XtRString, XtRBackingStore, XmuCvtStringToBackingStore,
		 NULL, 0 );
}

/*      Function Name: ClassPartInitialize
 *      Description: Class Part Initialize routine, called for every
 *                   subclass.  Makes sure that the subclasses pick up 
 *                   the extension record.
 *      Arguments: wc - the widget class of the subclass.
 *      Returns: none.
 */

static void
ClassPartInitialize(wc)
WidgetClass wc;
{
  GowDestinationWidgetClass gowc = (GowDestinationWidgetClass)wc;

/*
 * Make sure that our subclass gets the extension rec too.
 */

  extension_rec.next_extension = gowc->composite_class.extension;
  gowc->composite_class.extension = (XtPointer) &extension_rec;
}
/*      Function Name: Initialize
 *      Description: Initializes the gow widget
 *      Arguments: request - the widget requested by the argument list.
 *                 new     - the new widget with both resource and non
 *                           resource values.
 *      Returns: none.
 */

/* ARGSUSED */
static void
Initialize(request, new, args, num_args)
Widget request, new;
ArgList args;
Cardinal *num_args;
{
  GowDestinationWidget gow = (GowDestinationWidget)new;

  if (new->core.width == 0) { new->core.width = DEFAULT_WIDTH; }
  if (new->core.height == 0) { new->core.height = DEFAULT_HEIGHT; }
  
  gow->destination_widget.destination= NULL;
}

/*      Function Name: Destroy
 *      Description: Destroys the gow widget
 *      Arguments: w - the widget to destroy.
 *      Returns: none.
 */

/* ARGSUSED */
static void
Destroy(w)
Widget w;
{
  GowDestinationWidget gow = (GowDestinationWidget)w;
  GowDestroyDestination(gow->destination_widget.destination);
}

/*      Function Name: Realize
 *      Description: Realizes the widget.
 *      Arguments: w - the gow widget.
 *                 mask - value mask for the window to create.
 *                 attrs - attributes for the window to create.
 *      Returns: none
 */

static void
Realize(w, mask, attrs)
Widget w;
XtValueMask *mask;
XSetWindowAttributes *attrs;
{
  GowDestinationWidget gow = (GowDestinationWidget) w;

  if ((gow->destination_widget.backing_store == Always) ||
      (gow->destination_widget.backing_store == NotUseful) ||
      (gow->destination_widget.backing_store == WhenMapped)) {
    *mask |= CWBackingStore;
    attrs->backing_store = gow->destination_widget.backing_store; }
  else {
    *mask &= ~CWBackingStore; }

  if ((attrs->cursor = gow->destination_widget.cursor) != None) {
    *mask |= CWCursor; }

  (*SUPERCLASS->core_class.realize)(w, mask, attrs);

  gow->destination_widget.destination = GowCreateDestination(w);
  GowChangeX11Geometry(gow->destination_widget.destination);
}

/*      Function Name: Resize
 *      Description: Handle the menu being resized bigger.
 *      Arguments: w - the gow widget.
 *      Returns: none.
 */

static void
Resize(w)
Widget w;
{
  GowDestinationWidget gow= (GowDestinationWidget)w;
  GowChangeX11Geometry(gow->destination_widget.destination);
}

/*      Function Name: SetValues
 *      Description: Relayout the menu when one of the resources is changed.
 *      Arguments: current - current state of the widget.
 *                 request - what was requested.
 *                 new - what the widget will become.
 *      Returns: none
 */

/* ARGSUSED */
static Boolean
SetValues(current, request, new, args, num_args)
Widget current, request, new;
ArgList args;
Cardinal *num_args;
{
  Boolean geo_change = FALSE;
  GowDestinationWidget nw= (GowDestinationWidget)new;
  GowDestinationWidget ow= (GowDestinationWidget)current;

  if (!XtIsRealized(new)) { return FALSE; }

  geo_change= ((nw->core.width != ow->core.width) ||
	       (nw->core.height != ow->core.height));

  if (nw->destination_widget.cursor != ow->destination_widget.cursor) {
    XDefineCursor(XtDisplay(new), XtWindow(new),
		  nw->destination_widget.cursor); }

  return geo_change;
}

/************************************************************
 *
 * Geometry Management routines.
 *
 ************************************************************/

/*	Function Name: GeometryManager
 *	Description: This is the Gow Widget's Geometry Manager.
 *	Arguments: w - the Menu Entry making the request.
 *                 request - requested new geometry.
 *                 reply - the allowed geometry.
 *	Returns: XtGeometry{Yes, No, Almost}.
 */

static XtGeometryResult
GeometryManager(w, request, reply)
Widget w;
XtWidgetGeometry * request, * reply;
{
  XtGeometryMask mode = request->request_mode;

  if (!(mode & CWWidth) && !(mode & CWHeight)) { return XtGeometryNo; }
  else {
    if (mode & CWWidth) { w->core.width = request->width; }
    if (mode & CWHeight) { w->core.height = request->height; }
    return XtGeometryYes; }
}

/************************************************************
 *
 * Global Action Routines.
 * 
 * These actions routines will be added to the application's
 * global action list. 
 * 
 ************************************************************/

/************************************************************
 *
 * Widget Action Routines.
 * 
 ************************************************************/

/************************************************************
 *
 * Public Functions.
 *
 ************************************************************/

/************************************************************
 *
 * Private Functions.
 *
 ************************************************************/

#endif				/* HAS_XT_GRAPHIC */
