/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowDestXfig.c,v 1.2 1994/05/26 19:49:10 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <math.h>
#include <stdio.h>

#include <tv/vsAlloc.h>

#include "GowDestP.h"
#include "GowGCsXfigP.h"
#include "GowDestXfig.h"

typedef struct _GowDestFileXfigRec {
  FILE *fp;
  Boolean cont_called;
} GowDestFileXfigRec, *GowDestFileXfig;

				/* basic draw functions */
#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

/* GowDestXfig.c */
/* X functions replacements */
static void    XfigContDrawLine P_((GowDestFileXfig fp, XfigGC gc,
				    int start_x, int start_y,
				    int end_x, int end_y));
static void    XfigDrawLines P_((GowDestFileXfig fp, XfigGC gc,
				 XPoint *points, int npoints));
static void    XfigDrawLine P_((GowDestFileXfig fp, XfigGC gc,
				int start_x, int start_y,
				int end_x, int end_y));
static void    XfigDrawPoint P_((GowDestFileXfig fp, XfigGC gc,
				 int x, int y));
static void    XfigDrawPoints P_((GowDestFileXfig fp, XfigGC gc,
				 XPoint *points, int npoints));
static void    XfigDrawString P_((GowDestFileXfig fp, XfigGC gc,
				  int x, int y,
				  int angle, int x_justify, char *label));
static void    XfigDrawArc P_((GowDestFileXfig fp, XfigGC gc, 
			       int center_x, int center_y, 
			       int start_x, int start_y, 
			       int end_x, int end_y));
static void    XfigFinishDrawLines  P_((GowDestFileXfig fp));

static Boolean Alabel P_((GowDestination d,
			  int x_justify, int y_justify, char *label));
static Boolean Arc P_((GowDestination d, int center_x, int center_y,
		       int start_x, int start_y, int end_x, int end_y));
static Boolean Circle P_((GowDestination d, int x, int y, int r));
static Boolean Comment P_((GowDestination d, char *comment));
static Boolean Cont P_((GowDestination d, int x, int y));
static Boolean Label P_((GowDestination d, char *label));
static Boolean Line P_((GowDestination d,
			int x_start, int y_start, int x_end, int y_end));
static Boolean Lines P_((GowDestination d, XPoint *points, int npoints));
static Boolean Move P_((GowDestination d, int x, int y));
static Boolean Point P_((GowDestination d, int x, int y));
static Boolean Points P_((GowDestination d, XPoint *points, int npoints));
static Boolean Segments P_((GowDestination d,
			    XSegment *segments, int nsegments));
static Boolean Set_angle360 P_((GowDestination d, int angle));
static Boolean Set_gc P_((GowDestination d, int idx));
static void Text_extents P_((GowDestination d, char *label,
			     int *height, int *width));
static int Linewidth P_((GowDestination d));
static int Fontheight P_((GowDestination d));
static int Fontwidth P_((GowDestination d));

#undef P_

static GowDestFuncsRec fct= {
  Alabel,
  Arc,
  Circle,
  Comment,
  Cont,
  Label,
  Line,
  Lines,
  Move,
  Point,
  Points,
  Segments,

  Comment,			/* start_object */
  Comment,			/* end_object */

  Set_angle360,
  Set_gc,
  Text_extents,

  Linewidth,
  Fontheight,
  Fontwidth };

#define XFIG_FILE(d) ((GowDestFileXfig)d->fp)
#define XFIG_CONT_CALLED(d) (((GowDestFileXfig)d->fp)->cont_called)
#define XFIG_FINISH_CONT(d) \
  { if (XFIG_CONT_CALLED(d)) {\
      XfigFinishDrawLines ((GowDestFileXfig)d->fp);\
      XFIG_CONT_CALLED(d) = FALSE; } }

/* ---------------------------------------------------------------------- */
/* The very basic Xfig draw function: XfigDrawLines                       */
/* ---------------------------------------------------------------------- */
static int Linestyle(gc)
     XfigGC gc;
{
  switch (gc->line_style) {
  case GowLineDisconnected:
  case GowLineDotdashed:
  case GowLineDotted:
    return 2;			/* dotted */
  case GowLineLongdashed:
  case GowLineShortdashed:
  case GowLineOdddashed:
    return 1;			/* dashed */
  case GowLineSolid:
  default:
    return 0; }			/* solid */
}

static void XfigContDrawLine (fp, gc, start_x, start_y, end_x, end_y)
     GowDestFileXfig fp;
     XfigGC gc;
     int start_x, start_y;
     int end_x, end_y;
{
  if (!fp->cont_called) {
    /*    fprintf (fp->fp, "\n2 1 %d %d %d 1 0 %d 0.000 -1 0 0\n",  xfig2..*/
    fprintf (fp->fp, "\n2 1 %d %d %d %d 100 -1 -1 0.000 0 0 -1 0 0 2\n",
	     /* object code*/
	     /* sub_type */
	     Linestyle(gc),
	     gc->line_width,
	     gc->color,
	     gc->color /* 3.1 fill color */
	     /* depth */
	     /* pen */ /* 3.1 i don't know */
	     /*gc->fill_style*/
	     /* style_val */ /* 3.1 dash length */
	     /* 3.1 join style */
	     /* 3.1 cap style */
	     /* radius */ /* 3.1 i don't know */
	     /* forward_arrow */
	     /* backward_arrow */
	     /* 3.1 number of points */);
    fprintf(fp->fp, " %d %d", start_x * 15, start_y * 15);
    fp->cont_called= TRUE;
  }
  fprintf(fp->fp, " %d %d", end_x * 15, end_y * 15);
}

static void XfigDrawLines (fp,  gc, points, npoints)
     GowDestFileXfig fp;
     XfigGC gc;
     XPoint *points;
     int npoints;
{
  int i;
  
  /*  fprintf (fp->fp, "\n2 1 %d %d %d 1 0 %d 0.000 -1 0 0\n",*/
  fprintf (fp->fp, "\n2 1 %d %d %d %d 100 -1 -1 0.000 0 0 -1 0 0 %d\n",
	   /* object code*/
	   /* sub_type */
	   Linestyle(gc),
	   gc->line_width,
	   gc->color,
	   gc->color, /* 3.1 fill color */
	   /* depth */
	   /* pen */ /* 3.1 i don't know */
	   /*gc->fill_style,*/
	   /* style_val */ /* 3.1 dash length */
	   /* 3.1 join style */
	   /* 3.1 cap style */
	   /* radius */ /* 3.1 i don't know */
	   /* forward_arrow */
	   /* backward_arrow */
	   npoints);

  for (i=0; i<npoints; i++){
   fprintf (fp->fp, " %d %d", points[i].x * 15, points[i].y * 15);}

  XfigFinishDrawLines (fp);
}

static void XfigFinishDrawLines (fp)
     GowDestFileXfig fp;
{
  /* 3.1 lines are finish by a newline
   * fprintf(fp->fp," 9999 9999\n");
   */
   fprintf(fp->fp,"\n");
}

static void XfigDrawLine (fp, gc, start_x, start_y, end_x, end_y)
     GowDestFileXfig fp;
     XfigGC gc;
     int start_x, start_y;
     int end_x, end_y;
{
  XPoint point[2];

  point[0].x = start_x;
  point[0].y = start_y;

  point[1].x = end_x;
  point[1].y = end_y;

  XfigDrawLines (fp, gc, point, 2);
}
       
static void XfigDrawPoint (fp, gc, x, y)
     GowDestFileXfig fp;
     XfigGC gc;
     int x, y;
{
  XPoint point;

  point.x = x;
  point.y = y;

  XfigDrawLines (fp, gc, &point, 1);
}
       
static void XfigDrawPoints (fp,  gc, points, npoints)
     GowDestFileXfig fp;
     XfigGC gc;
     XPoint *points;
     int npoints;
{
  int i;
  for (i=0; i<npoints; i++){
    XfigDrawPoint (fp, gc, points[i].x, points[i].y);}
}

static void XfigDrawString (fp, gc, x, y, x_justify, text_angle, label)
     GowDestFileXfig fp;
     XfigGC gc;
     int x, y;
     int x_justify;
     int text_angle;
     char *label;
{
  /*
   * Compatible with xfig 3.1
   */
  fprintf (fp->fp, "\n4 %d %d 100 0 %d %d %f 4 10 10 %d %d %s\\001\n",
	   /* object code */
	   x_justify,
	   gc->color,
	   /* depth */
	   /* pen */
	   gc->font,
	   gc->font_size,
	   (double)text_angle,
	   /* font_flags */
	   /* height */
	   /* length */
	   x * 15,
	   y * 15,
	   label);
}

static void XfigDrawArc (fp, gc, 
			 center_x, center_y, 
			 start_x, start_y, 
			 end_x, end_y)
     GowDestFileXfig fp;
     XfigGC gc;
     int center_x, center_y;
     int start_x, start_y;
     int end_x, end_y;
{
  
  fprintf (fp->fp,
	   "\n5 1 %d %d %d %d 100 -1 -1 0.000 0 0 0 %f %f %d %d %d %d %d %d\n",
	   /* object code (always 5)*/
	   /* sub type (always 1)*/
	   Linestyle(gc),
	   gc->line_width,
	   gc->color,
	   gc->color, /* 3.1 fill color */
	   /* depth */
	   /* pen */
	   /*gc->fill_style,*/
	   /* style_val */
	   /* direction (0 : clockwise, 1 : counterclockwise) */
	   /* forward arrow (0: no forward arrow, 1: on)*/
	   /* backward arrow */
	   (float)center_x * 15,
	   (float)center_y * 15,
	   start_x * 15,
	   start_y * 15,
	   start_x * 15,
	   start_y * 15,
	   end_x * 15,
	   end_y * 15);
}
/* ---------------------------------------------------------------------- */
GowDestFile GowCreateXfigDestination(file, x, y, fontscale, geo)
     char *file;
     int x, y;
     double fontscale;
     GowDestGeometry geo;
{
  GowDestFileXfig fp= NULL;
  if (x != 0 && y != 0) {
    if (x > 8192 || y > 8192) {
      if (x > y) {
	y= (int)((double)y / (double)x * 8192.0); x= 8192;
      }
      else {
	x= ((double)x / (double)y * 8192.0); y= 8192;
      }
    }

    if ((fp= (GowDestFileXfig)Malloc(sizeof(GowDestFileXfigRec)))) {
      if ((fp->fp= fopen(file, "w"))) {
	/*	fprintf(fp->fp,"#FIG 2.1\n80 1\n");*/
	fprintf(fp->fp,"#FIG 3.2\nLandscape\nCenter\nMetric\nA4\n70.00\nSingle\n-2\n1200 2\n");
	geo->x_offset	= 0;
	geo->x_range	= x;
	geo->x_direction= 1;
	geo->y_offset	= 25;
	geo->y_range	= y;
	geo->y_direction= -1;
	geo->fontscale	= fontscale;
      }
      else {
	Free(fp);
      }
    }
  }
  return (GowDestFile)fp;
}
/* ---------------------------------------------------------------------- */
Boolean GowDestroyXfigDestination(fp)
     GowDestFile fp;
{
  Boolean ret_val= TRUE;
  GowDestFileXfig xf= (GowDestFileXfig)fp;
  if (xf) {
    if (xf->fp) {
      ret_val= (fclose(xf->fp) != EOF); }
    else { ret_val= FALSE; }
    Free(xf); }
  return ret_val;
}
/* ---------------------------------------------------------------------- */
void GowSetupXfigDestination(d)
     GowDestination d;
{
  d->fct= &fct;
  XFIG_CONT_CALLED(d)= FALSE;
  return;
}
/* ---------------------------------------------------------------------- */
void GowFinishXfigDestination(d)
     GowDestination d;
{
  XFIG_FINISH_CONT(d);
}
/* ---------------------------------------------------------------------- */
/*
 * Functions of standard interface for drawing (GowDestination)
 */
/* ---------------------------------------------------------------------- */
static Boolean Alabel(d, x_justify, y_justify, label)
     GowDestination d;
     int x_justify;
     int y_justify;
     char *label;
{
  int width, height;
  Position x= d->actual_x;
  Position y= d->actual_y;

  XFIG_FINISH_CONT(d);

  switch (x_justify) {/* umsetzen auf Xfig codes fuer textausrichtung */
  case 'l': x_justify = 0; break;
  case 'c': x_justify = 1; break;
  case 'r': x_justify = 2; break;
  default:  return FALSE; }

  height = GowDFontheight(d);
  width = height * strlen(label); /* Problem bei proportionalfonts !!! */

  switch (y_justify) {
  case 'b': break;
  case 'c': y += height / 2; break;
  case 't': y += height; break;
  default:  return FALSE; }

  XfigDrawString(XFIG_FILE(d), ((XfigGC)d->actual_gc), 
		 x, y, x_justify, 0/*d->angle*/, label);

  d->actual_x = x + width;
  /* d->actual_y = unchanged */

  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Arc(d, center_x, center_y, start_x, start_y, end_x, end_y)
     GowDestination d;
     int center_x, center_y;
     int start_x, start_y;
     int end_x, end_y;
{
  XFIG_FINISH_CONT(d);

  XfigDrawArc(XFIG_FILE(d), (XfigGC)d->actual_gc,
	      center_x, center_y,
	      start_x, start_y,
	      end_x, end_y);
  d->actual_x= center_x;
  d->actual_x= center_y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Circle(d, x, y, r)
     GowDestination d;
     int x, y, r;
{
  XFIG_FINISH_CONT(d);

  XfigDrawArc(XFIG_FILE(d), ((XfigGC)d->actual_gc),
	      x, y,
	      x - r, y, 
	      x - r, y); 
  d->actual_x= x;
  d->actual_x= y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Comment(d, comment)
     GowDestination d;
     char *comment;
{
  XFIG_FINISH_CONT(d);

  fprintf (XFIG_FILE(d)->fp,"\n#%s\n",comment);
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Cont(d, x, y)
     GowDestination d;
     int x, y;
{
  XFIG_FINISH_CONT(d);

  XfigContDrawLine(XFIG_FILE(d), ((XfigGC)d->actual_gc),
		   d->actual_x, d->actual_y, x, y);
  d->actual_x = x;
  d->actual_y = y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Label(d, label)
     GowDestination d;
     char *label;
{
  return Alabel(d, 'l', 'c', label);
}
/* ---------------------------------------------------------------------- */
static Boolean Line(d, x_start, y_start, x_end, y_end)
     GowDestination d;
     int x_start, y_start, x_end, y_end;
{
  XFIG_FINISH_CONT(d);

  XfigDrawLine(XFIG_FILE(d), ((XfigGC)d->actual_gc),
	       x_start, y_start, x_end, y_end);
  d->actual_x = x_end;
  d->actual_y = y_end;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Lines(d, points, npoints)
     GowDestination d;
     XPoint *points;
     int npoints;
{
  if (!npoints) { return FALSE; }
  XFIG_FINISH_CONT(d);

  XfigDrawLines(XFIG_FILE(d), ((XfigGC)d->actual_gc),
		points, npoints);
  d->actual_x = points[npoints-1].x;
  d->actual_y = points[npoints-1].y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Move(d, x, y)
     GowDestination d;
     int x, y;
{
  d->actual_x = x;
  d->actual_y = y;
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static Boolean Point(d, x, y)
     GowDestination d;
     int x, y;
{
  XFIG_FINISH_CONT(d);

  XfigDrawPoint(XFIG_FILE(d), ((XfigGC)d->actual_gc), x, y);
  d->actual_x = x;
  d->actual_y = y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Points(d, points, npoints)
     GowDestination d;
     XPoint *points;
     int npoints;
{
  if (!npoints) { return FALSE; }
  XFIG_FINISH_CONT(d);

  XfigDrawPoints(XFIG_FILE(d), ((XfigGC)d->actual_gc),
	     points, npoints);
  d->actual_x = points[npoints-1].x;
  d->actual_y = points[npoints-1].y;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Segments(d, segments, nsegments)
     GowDestination d;
     XSegment *segments;
     int nsegments;
{
  int i;
  if (!nsegments) { return FALSE; }

  XFIG_FINISH_CONT(d);

  for (i=0;i<nsegments;i++){
    XfigDrawLine (XFIG_FILE(d), ((XfigGC)d->actual_gc),
		  segments[i].x1, segments[i].y1,
		  segments[i].x2, segments[i].y2);}
  d->actual_x = segments[nsegments-1].x2;
  d->actual_y = segments[nsegments-1].y2;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Set_angle360(d, angle)
     GowDestination d;
     int angle;
{
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean Set_gc(d, idx)
     GowDestination d;
     int idx;
{
  if (d->gcs) {
    d->actual_idx	= idx % d->num_gcs;
    d->actual_gc	= (GowGC)(((XfigGC)d->gcs) + d->actual_idx);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static void Text_extents(d, label, height, width)
     GowDestination d;
     char *label;
     int *height, *width;
{
  if (d->actual_gc) {
    *height = ((XfigGC)d->actual_gc)->font_size;
    *width = strlen (label) * *height;}
  else { *height= *width= 0; }
  return;
}
/* ---------------------------------------------------------------------- */
static int Linewidth(d)
     GowDestination d;
{
  return ((XfigGC)d->actual_gc)->line_width;
}
/* ---------------------------------------------------------------------- */
static int Fontheight(d)
     GowDestination d;
{
  return ((XfigGC)d->actual_gc)->font_size;
}
/* ---------------------------------------------------------------------- */
static int Fontwidth(d)
     GowDestination d;
{
  return ((XfigGC)d->actual_gc)->font_size;
}
/* ---------------------------------------------------------------------- */

#endif				/* HAS_XT_GRAPHIC */
