/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowFramWidget.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _GowFramWidget_h
#define _GowFramWidget_h

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Constraint.h>
#include <X11/Xmu/Converters.h>
#include <X11/Xfuncproto.h>

#include <Gow/GowConfig.h>
#include <Gow/GowDest.h>

/****************************************************************
 *
 * Vertical Paned Widget (SubClass of CompositeClass)
 *
 ****************************************************************/

/* RESOURCES:

 Name		         Class		   RepType	    Default Value
 ----		         -----		   -------	    -------------
 leftFrame	         Frame	           Int		    0
 rightFrame	         Frame	           Int		    0
 bottomFrame	         Frame	           Int		    0
 topFrame	         Frame	           Int		    0
 ticLong 		 Tic	           Float	    0.5
 ticMedium 		 Tic	           Float	    0.5
 ticShort 		 Tic	           Float	    0.5
 ticSpace		 Tic	           Float	    0.75
 ticLabel		 TicLabel          Float	    5.0 ( >= 1.0 )
 ticTic			 TicTic	           Float	    1.0 ( > 0.0 )

*/

/* New Fields */
#define XtNleftFrame			"leftFrame"
#define XtNrightFrame			"rightFrame"
#define XtNbottomFrame			"bottomFrame"
#define XtNtopFrame			"topFrame"

#define XtNleftAxis			"leftAxis"
#define XtNrightAxis			"rightAxis"
#define XtNbottomAxis			"bottomAxis"
#define XtNtopAxis			"topAxis"

#define XtNticLong			"ticLong"
#define XtNticMedium			"ticMedium"
#define XtNticShort			"ticShort"
#define XtNticSpace			"ticSpace"
#define XtNticLabel			"ticLabel"
#define XtNticTic			"ticTic"

#define XtCXFrame		"XFrame"
#define XtCYFrame		"YFrame"
#define XtCTic			"Tic"
#define XtCTicSpace		"TicSpace"
#define XtCTicLabel		"TicLabel"
#define XtCTicTic		"TicTic"

#define XtCAxis			"Axis"

/* Class record constant */
extern WidgetClass gowFrameWidgetClass;

typedef struct _GowFrameWidgetClassRec	*GowFrameWidgetClass;
typedef struct _GowFrameWidgetRec	*GowFrameWidget;

/************************************************************
 *
 *  Public Procedures 
 *
 ************************************************************/

_XFUNCPROTOBEGIN

extern void GowFrameRedisplay(
#if NeedFunctionPrototypes
     Widget			/* w */,
     int			/* type */
#endif
);

extern void GowFrameWidgetPlot(
#if NeedFunctionPrototypes
     Widget			/* w */,
     GowDestFile		/* fp */,
     int			/* type */,
     GowDestGeometry		/* geo */
#endif
);

_XFUNCPROTOEND

#endif /* _GowFramWidget_h */
/* DON'T ADD STUFF AFTER THIS #endif */
