/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowGCs.c,v 1.2 1994/05/26 19:49:14 vs Exp vs $ */

/*
 * GowGCs.c - gow GCs.
 *
 */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <tv/vsAlloc.h>

#include "GowDestP.h"
#include "GowGCsX11P.h"
#include "GowGCsUnixP.h"
#include "GowGCsXfigP.h"
#include "GowGCsP.h"

static int max_num_gcs= 0;	/* min. number of gc-resources */

GowDestGCs GowCreateGCs(w, num)
     Widget w;
     int num;
{
  GowDestGCs gcs;

  num= GowInitializeGCs(num);

  if (num && (gcs= (GowDestGCs)Calloc(1, sizeof(GowDestGCsRec)))) {
    gcs->widget	= w;
    gcs->num	= num;
    return gcs; }

  return NULL;
}

void GowDestroyGCs(gcs)
     GowDestGCs gcs;
{
  if (gcs) {
    GowDestroyGCsX11(gcs->widget, gcs->x11, gcs->num);
    GowDestroyGCsUnix(gcs->widget, gcs->unix_plot, gcs->num);
    GowDestroyGCsXfig(gcs->widget, gcs->xfig, gcs->num);
    Free(gcs); }
}

Boolean GowUseGCs(dest, gcs)
     GowDestination dest;
     GowDestGCs gcs;
{
  dest->num_gcs= 0;

  if (!gcs || !dest) { return FALSE; }

  if (gcs->num > max_num_gcs) { gcs->num= GowInitializeGCs(gcs->num); }

  switch (dest->type) {
  case 'X':			/* X11 */
    if (gcs->x11 ||
	(gcs->x11= GowCreateGCsX11(gcs->widget, gcs->num))) {
      dest->gcs= (GowGCs)gcs->x11; dest->num_gcs= gcs->num; }
    break;
  case 'u':			/* unix-plot */
    if (gcs->unix_plot ||
	(gcs->unix_plot= GowCreateGCsUnix(gcs->widget, gcs->num))) {
      dest->gcs= (GowGCs)gcs->unix_plot; dest->num_gcs= gcs->num; }
    break;
  case 'x':			/* xfig */
    if (gcs->xfig ||
	(gcs->xfig= GowCreateGCsXfig(gcs->widget, gcs->num))) {
      dest->gcs= (GowGCs)gcs->xfig; dest->num_gcs= gcs->num; }
    break;
  default: break; }

  return (dest->num_gcs > 0);
}

int GowInitializeGCs(num)
     int num;
{
  if (num > max_num_gcs &&
      GowInitializeGCsX11(num) &&
      GowInitializeGCsUnix(num) &&
      GowInitializeGCsXfig(num)) {
    max_num_gcs= num; }
  return ((num < max_num_gcs) ? num : max_num_gcs);
}
#endif				/* HAS_XT_GRAPHIC */
