/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowGCsUnix.c,v 1.2 1994/05/26 19:49:17 vs Exp vs $ */

/*
 * GowGCs.c - gow GCs.
 *
 */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <tv/vsAlloc.h>

#include "GowGCsX11P.h"
#include "GowGCsUnixP.h"

static void _CvtStringToUnixColor();
static Boolean InitializeResources();

#define MAXNAMELEN		256
static int max_num_gcs= 0;
static XtResourceList gc_resource_list= NULL;

#define SetGCResources(i) {\
  sprintf(NunixColor, "%s%d", XtNunixColor, i); \
  sprintf(NunixFontname, "%s%d", XtNunixFontname, i); \
  sprintf(NunixFontsize, "%s%d", XtNunixFontsize, i); \
  sprintf(NunixLinestyle, "%s%d", XtNunixLinestyle, i); }

#define Offset(field) XtOffsetOf(UnixGCRec,field) 

static XtResource gc_resources[] = {
  {NULL, XtCUnixColor, XtRUnixColor, sizeof (GowUnixColor),
     Offset(color), XtRString, (XtPointer) "0,0,0"}, /* black */
  {NULL, XtCUnixFontname, XtRString, sizeof (String),
     Offset(fontname), XtRString, (XtPointer) "helvetica"},
  {NULL, XtCUnixFontsize, XtRDimension, sizeof (Dimension),
     Offset(fontsize), XtRImmediate, (XtPointer)70},
  {NULL, XtCUnixLinestyle, XtRLineStyle, sizeof(GowLineStyle),
     Offset(linestyle), XtRImmediate, (XtPointer) GowLineSolid },
};

#undef Offset

/* ---------------------------------------------------------------------- */
GowGCsUnix GowCreateGCsUnix(w, num)
     Widget w;
     int num;
{
  UnixGC gcs;

  if ((!gc_resource_list && !InitializeResources(num)) ||
      num > max_num_gcs) {
    return NULL; }
  else if ((gcs= (GowGCsUnix)Calloc(num, sizeof(UnixGCRec)))) {
    XtGetSubresources(XtParent(w), gcs, XtName(w),
		      w->core.widget_class->core_class.class_name,
		      gc_resource_list, num * XtNumber(gc_resources),
		      NULL, 0);
    return (GowGCsUnix)gcs; }
  return NULL;
}
/* ---------------------------------------------------------------------- */
void GowDestroyGCsUnix(w, gcs, num)
     Widget w;
     GowGCsUnix gcs;
     int num;
{
  if (gcs) {
    int i;
    for (i= 0; i< num; i++) {
    Free(gcs->color); }		/* that depends on allocation in
				   _CvtStringToUnixColor !!! and no
				   shared use */
    Free(gcs); }
}
/* ---------------------------------------------------------------------- */
Boolean GowInitializeGCsUnix(num)
     int num;
{
  if (gc_resource_list) {
    if (num > max_num_gcs) { return FALSE; } }
  else if (num > max_num_gcs) { max_num_gcs= num; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean InitializeResources(num)
     int num;
{
  if (num > max_num_gcs) { max_num_gcs= num; }

  if (!(gc_resource_list=
	(XtResourceList)Calloc(max_num_gcs, sizeof(gc_resources)))) {
    return FALSE; }
  else {
    int i;
    XtResourceList gc_i;
    extern void _XtCompileResourceList();
    char NunixColor[MAXNAMELEN];
    char NunixFontname[MAXNAMELEN];
    char NunixFontsize[MAXNAMELEN];
    char NunixLinestyle[MAXNAMELEN];

    XtAddConverter(XtRString, XtRLineStyle,
		   GowCvtStringToLineStyle, NULL, 0 );
    XtAddConverter(XtRString, XtRUnixColor,
		   _CvtStringToUnixColor, NULL, 0 );

    gc_resources[0].resource_name= NunixColor;
    gc_resources[1].resource_name= NunixFontname;
    gc_resources[2].resource_name= NunixFontsize;
    gc_resources[3].resource_name= NunixLinestyle;

    for (i = 0, gc_i= gc_resource_list;
	 i < max_num_gcs;
	 i++, gc_i += XtNumber(gc_resources)) {

      SetGCResources(i);

      memcpy(gc_i, gc_resources, sizeof(gc_resources));

      { int g;			/* compile resources of each gc in place */

	for (g= 0; g< XtNumber(gc_resources); g++) {
	  int value_offset= i * sizeof(UnixGCRec);

	  if (!(gc_i[g].resource_name=
		Strdup(gc_resources[g].resource_name))) {
	    for (g--; g>= 0; g--) { Free(gc_i[g].resource_name); }
	    for (i--, gc_i -= XtNumber(gc_resources); i>= 0;
		 i--, gc_i -= XtNumber(gc_resources)) {
	      for (g= 0; g< XtNumber(gc_resources); g++) {
		Free(gc_i[g].resource_name); } }
	    Free(gc_resource_list);
	    return FALSE; }
	      
	  gc_i[g].resource_offset
	    = gc_resources[g].resource_offset + value_offset; } }

      _XtCompileResourceList(gc_i, XtNumber(gc_resources)); }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
#define	done(address, type) \
	{ toVal->size = sizeof(type); \
	  toVal->addr = (caddr_t) address; \
	  return; \
	}

/* ARGSUSED */
static void _CvtStringToUnixColor(args, num_args, fromVal, toVal)
    XrmValuePtr args;		/* unused */
    Cardinal    *num_args;      /* unused */
    XrmValuePtr fromVal;
    XrmValuePtr toVal;
{
  static GowUnixColor color;
  if ((color= (GowUnixColor)Malloc(sizeof(GowUnixColorRec))) &&
      sscanf((char *)fromVal->addr,
	     "%hd,%hd,%hd", &color->r, &color->g, &color->b) == 3) {
    done(&color, GowUnixColor); }
  Free(color);
  XtStringConversionWarning(fromVal->addr, "UnixColor");
  toVal->addr = NULL;
  toVal->size = 0;
}
/* ---------------------------------------------------------------------- */
#endif				/* HAS_XT_GRAPHIC */
