/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowGCsXfig.c,v 1.2 1994/05/26 19:49:20 vs Exp vs $ */

/*
 * GowGCs.c - gow GCs.
 *
 */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <tv/vsAlloc.h>

#include "GowGCsX11P.h"
#include "GowGCsXfigP.h"

static Boolean InitializeResources();

#define MAXNAMELEN		256
static int max_num_gcs= 0;
static XtResourceList gc_resource_list= NULL;

#define SetGCResources(i) {\
  sprintf(NxfigLinestyle, "%s%d", XtNxfigLinestyle, i); \
  sprintf(NxfigLinewidth, "%s%d", XtNxfigLinewidth, i); \
  sprintf(NxfigColor, "%s%d", XtNxfigColor, i); \
  sprintf(NxfigFont, "%s%d", XtNxfigFont, i); \
  sprintf(NxfigFontsize, "%s%d", XtNxfigFontsize, i); \
  sprintf(NxfigFillstyle, "%s%d", XtNxfigFillstyle, i); }

#define Offset(field) XtOffsetOf(XfigGCRec,field) 

static XtResource gc_resources[] = {
  {NULL, XtCXfigLinestyle, XtRLineStyle, sizeof(GowLineStyle),
     Offset(line_style), XtRImmediate, (XtPointer) GowLineSolid },
  {NULL, XtCXfigLinewidth, XtRDimension, sizeof(Dimension),
     Offset(line_width), XtRImmediate, (XtPointer) 1 },
  {NULL, XtCXfigColor, XtRDimension, sizeof (Dimension),
     Offset(color), XtRImmediate, (XtPointer) 0}, /* black */
  {NULL, XtCXfigFont, XtRDimension, sizeof (Dimension),
     Offset(font), XtRImmediate, (XtPointer) 0},
  {NULL, XtCXfigFontsize, XtRDimension, sizeof (Dimension),
     Offset(font_size), XtRImmediate, (XtPointer)70},
  {NULL, XtCXfigFillstyle, XtRDimension, sizeof(Dimension),
     Offset(fill_style), XtRImmediate, (XtPointer) 0 },
};

#undef Offset

/* ---------------------------------------------------------------------- */
GowGCsXfig GowCreateGCsXfig(w, num)
     Widget w;
     int num;
{
  XfigGC gcs;

  if ((!gc_resource_list && !InitializeResources(num)) ||
      num > max_num_gcs) {
    return NULL; }
  else if ((gcs= (XfigGC)Calloc(num, sizeof(XfigGCRec)))) {
    XtGetSubresources(XtParent(w), gcs, XtName(w),
		      w->core.widget_class->core_class.class_name,
		      gc_resource_list, num * XtNumber(gc_resources),
		      NULL, 0);
    { int i;
      XfigGC gc;
      for (i= 0, gc= gcs; i< num; i++) {
	gc->line_width= (gc->line_width < 1) ? 1 : gc->line_width; } }
    return (GowGCsXfig)gcs; }
  return NULL;
}
/* ---------------------------------------------------------------------- */
void GowDestroyGCsXfig(w, gcs, num)
     Widget w;
     GowGCsXfig gcs;
     int num;
{
  if (gcs) { Free(gcs); }
}
/* ---------------------------------------------------------------------- */
Boolean GowInitializeGCsXfig(num)
     int num;
{
  if (gc_resource_list) {
    if (num > max_num_gcs) { return FALSE; } }
  else if (num > max_num_gcs) { max_num_gcs= num; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Boolean InitializeResources(num)
     int num;
{
  if (num > max_num_gcs) { max_num_gcs= num; }

  if (!(gc_resource_list=
	(XtResourceList)Calloc(max_num_gcs, sizeof(gc_resources)))) {
    return FALSE; }
  else {
    int i;
    XtResourceList gc_i;
    extern void _XtCompileResourceList();
    char NxfigLinestyle[MAXNAMELEN];
    char NxfigLinewidth[MAXNAMELEN];
    char NxfigColor[MAXNAMELEN];
    char NxfigFont[MAXNAMELEN];
    char NxfigFontsize[MAXNAMELEN];
    char NxfigFillstyle[MAXNAMELEN];

    XtAddConverter(XtRString, XtRLineStyle,
		   GowCvtStringToLineStyle, NULL, 0 );

    gc_resources[0].resource_name= NxfigLinestyle;
    gc_resources[1].resource_name= NxfigLinewidth;
    gc_resources[2].resource_name= NxfigColor;
    gc_resources[3].resource_name= NxfigFont;
    gc_resources[4].resource_name= NxfigFontsize;
    gc_resources[5].resource_name= NxfigFillstyle;

    for (i = 0, gc_i= gc_resource_list;
	 i < max_num_gcs;
	 i++, gc_i += XtNumber(gc_resources)) {

      SetGCResources(i);

      memcpy(gc_i, gc_resources, sizeof(gc_resources));

      { int g;			/* compile resources of each gc in place */

	for (g= 0; g< XtNumber(gc_resources); g++) {
	  int value_offset= i * sizeof(XfigGCRec);

	  if (!(gc_i[g].resource_name=
		Strdup(gc_resources[g].resource_name))) {
	    for (g--; g>= 0; g--) { Free(gc_i[g].resource_name); }
	    for (i--, gc_i -= XtNumber(gc_resources); i>= 0;
		 i--, gc_i -= XtNumber(gc_resources)) {
	      for (g= 0; g< XtNumber(gc_resources); g++) {
		Free(gc_i[g].resource_name); } }
	    Free(gc_resource_list);
	    return FALSE; }
	      
	  gc_i[g].resource_offset
	    = gc_resources[g].resource_offset + value_offset; } }

      _XtCompileResourceList(gc_i, XtNumber(gc_resources)); }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
#endif				/* HAS_XT_GRAPHIC */
