/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowHMark.c,v 1.2 1994/05/26 19:49:21 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <X11/Xmu/Initer.h>
#include <X11/Xmu/CharSet.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowVsWidgetP.h>

#include "GowHMarkP.h"

/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

static Boolean RedisplayHMark();
static void FreeHMark();

#define SUPERCLASS		(&gowObjectClassRec)

GowObjectClassRec gowHMarkObjectClassRec = {
  {
/* core_class fields */	
    /* superclass	  	*/	(WidgetClass) SUPERCLASS,
    /* class_name	  	*/	"HMark",
    /* widget_size	  	*/	sizeof(GowHMarkObjectRec),
    /* class_initialize   	*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited       	*/	FALSE,
    /* initialize	  	*/	NULL,
    /* initialize_hook		*/	NULL,
    /* realize		  	*/	NULL,
    /* actions		  	*/	NULL,
    /* num_actions  		*/	0,
    /* resources	  	*/	NULL,
    /* num_resources	  	*/	0,
    /* xrm_class	  	*/	NULLQUARK,
    /* compress_motion	  	*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest	  	*/	FALSE,
    /* destroy		  	*/	FreeHMark,
    /* resize		  	*/	NULL,
    /* expose		  	*/	XtInheritExpose,
    /* set_values	  	*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus	 	*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private   	*/	NULL,
    /* tm_table		   	*/	NULL,
    /* query_geometry		*/	NULL,
    /* display_accelerator	*/	NULL,
    /* extension		*/	NULL
  },
/* gow_object_class fields */
  {
    /* EraseObject		*/	FreeHMark,
    /* InsertSubobject		*/	XtInheritInsertSubobject,
    /* CreateDrawdata		*/	XtInheritCreateDrawdata,
    /* DestroyDrawdata		*/	XtInheritDestroyDrawdata,
    /* InsertHere		*/	XtInheritInsertHere,
    /* ExposeSubobject		*/	RedisplayHMark,
    /* ExpandFullScale		*/	NULL,
    /* uses_rectangles		*/	FALSE
  }
};

WidgetClass gowHMarkObjectClass = (WidgetClass)&gowHMarkObjectClassRec;

/* ARGSUSED */
static Boolean RedisplayHMark(dest, x_scale, y_scale, data, region)
     GowDestination dest;
     GowScale x_scale;
     GowScale y_scale;
     GowAppDrawdata data;
     Region region;
{
  GowHMark gm= (GowHMark)data;
  GowHMarkObject goo= (GowHMarkObject)gm->goo;

  return DrawHMark(dest, &gm->mrk, x_scale, y_scale,
		   goo->gow_mark.lower_fraction,
		   goo->gow_mark.upper_fraction,
		   goo->gow_mark.cross_fraction);
}

static void FreeHMark(w)
     Widget w;
{
  GowObject goo = (GowObject)w;
  GowWidget gow= (GowWidget)goo->object.parent;
  GowSubobject sub;
  Boolean gow_update= FALSE;

  ForAllSubobjects(goo, sub) {
    DrawHMarkFree(&((GowHMark)sub->drawdata)->mrk);
    if (sub->status == GowDrawSubobj) {
      gow_update= goo->gow_object.needs_update= TRUE; }
    sub->visible	= FALSE;
    sub->drawn		= FALSE; }
  if (gow_update) { gow->gow_widget.needs_update= TRUE; }
}

#endif				/* HAS_XT_GRAPHIC */
