/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowLabel.c,v 1.2 1994/05/26 19:49:22 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <X11/Xmu/Initer.h>
#include <X11/Xmu/CharSet.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowVsWidgetP.h>
#include <Gow/GowMarkP.h>

#include "GowLabelP.h"

/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

static Boolean SetValues();
static Boolean RedisplayLabel();
static void FreeLabel();

#define Offset(field) XtOffsetOf(GowLabelObjectRec,gow_label.field)

static float perc= 1.0;

static XtResource resources[] = {
  { XtNlabelDistance, XtCLabelDistance, XtRFloat,
    sizeof (float),
    Offset(label_distance), XtRFloat, (XtPointer) &perc},
  { XtNlabelLine, XtCLabelLine, XtRFloat,
    sizeof (float),
    Offset(label_line), XtRFloat, (XtPointer) &perc},
  { XtNlibraryRadius, XtCLibraryRadius, XtRFloat,
    sizeof (float),
    Offset(library_radius), XtRFloat, (XtPointer) &perc},
  { XtNtopSpectrum, XtCTopSpectrum, XtRBoolean,
    sizeof (Boolean),
    Offset(top_spectrum), XtRImmediate, (XtPointer) TRUE},
  { XtNchannelRadius, XtCChannelRadius, XtRInt,
    sizeof (int),
    Offset(channel_radius), XtRImmediate, (XtPointer) 2},
};

#undef Offset

#define SUPERCLASS		(&gowMarkObjectClassRec)

GowObjectClassRec gowLabelObjectClassRec = {
  {
/* core_class fields */	
    /* superclass	  	*/	(WidgetClass) SUPERCLASS,
    /* class_name	  	*/	"VLabel",
    /* widget_size	  	*/	sizeof(GowLabelObjectRec),
    /* class_initialize   	*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited       	*/	FALSE,
    /* initialize	  	*/	NULL,
    /* initialize_hook		*/	NULL,
    /* realize		  	*/	NULL,
    /* actions		  	*/	NULL,
    /* num_actions  		*/	0,
    /* resources	  	*/	resources,
    /* num_resources	  	*/	XtNumber(resources),
    /* xrm_class	  	*/	NULLQUARK,
    /* compress_motion	  	*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest	  	*/	FALSE,
    /* destroy		  	*/	FreeLabel,
    /* resize		  	*/	NULL,
    /* expose		  	*/	XtInheritExpose,
    /* set_values	  	*/	SetValues,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus	 	*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private   	*/	NULL,
    /* tm_table		   	*/	NULL,
    /* query_geometry		*/	NULL,
    /* display_accelerator	*/	NULL,
    /* extension		*/	NULL
  },
/* gow_object_class fields */
  {
    /* EraseObject		*/	FreeLabel,
    /* InsertSubobject		*/	XtInheritInsertSubobject,
    /* CreateDrawdata		*/	XtInheritCreateDrawdata,
    /* DestroyDrawdata		*/	XtInheritDestroyDrawdata,
    /* InsertHere		*/	XtInheritInsertHere,
    /* ExposeSubobject		*/	RedisplayLabel,
    /* ExpandFullScale		*/	NULL,
    /* uses_rectangles		*/	FALSE
  }
};

WidgetClass gowLabelObjectClass = (WidgetClass)&gowLabelObjectClassRec;

/*      Function Name: SetValues
 *      Description: checks changes of num_gcs on validity.
 *      Arguments: current - current state of the widget.
 *                 request - what was requested.
 *                 new - what the widget will become.
 *      Returns: TRUE - redisplay, FALSE - do nothing
 */

/* ARGSUSED */
static Boolean
SetValues(current, request, new)
Widget current, request, new;
{
  GowLabelObject goo = (GowLabelObject)new;
  GowLabelObject old_goo = (GowLabelObject)current;

  return GowSetValuesReturn(new,
			    (goo->gow_label.label_distance !=
			     old_goo->gow_label.label_distance ||
			     goo->gow_label.label_line !=
			     old_goo->gow_label.label_line ||
			     goo->gow_label.channel_radius !=
			     old_goo->gow_label.channel_radius ||
			     goo->gow_label.top_spectrum !=
			     old_goo->gow_label.top_spectrum));
}

/* ARGSUSED */
static Boolean RedisplayLabel(dest, x_scale, y_scale, data, region)
     GowDestination dest;
     GowScale x_scale;
     GowScale y_scale;
     GowAppDrawdata data;
     Region region;
{
  GowLabel gl= (GowLabel)data;
  GowLabelObject goo= (GowLabelObject)gl->goo;
  GowVsWidget gow= (GowVsWidget)gl->gow;

  return DrawLabel(dest, &gl->lbl, x_scale, y_scale,
		   goo->gow_mark.lower_fraction,
		   goo->gow_mark.upper_fraction,
		   goo->gow_mark.cross_fraction,
		   goo->gow_label.label_distance,
		   goo->gow_label.label_line,
		   goo->gow_label.top_spectrum,
		   goo->gow_label.channel_radius,
		   goo->gow_label.library_radius,
		   gow->vs_widget.x_scale_calibrated,
		   gow->vs_widget.y_scale_modification,
		   gow->vs_widget.spectra_normalized);
}

static void FreeLabel(w)
     Widget w;
{
  GowObject goo = (GowObject)w;
  GowWidget gow= (GowWidget)goo->object.parent;
  GowSubobject sub;
  Boolean gow_update= FALSE;

  ForAllSubobjects(goo, sub) {
    DrawLabelFree(&((GowLabel)sub->drawdata)->lbl);
    if (sub->status == GowDrawSubobj) {
      gow_update= goo->gow_object.needs_update= TRUE; }
    sub->visible	= FALSE;
    sub->drawn		= FALSE; }
  if (gow_update) { gow->gow_widget.needs_update= TRUE; }
}

#endif				/* HAS_XT_GRAPHIC */
