/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowMark.c,v 1.2 1994/05/26 19:49:24 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <X11/Xmu/Initer.h>
#include <X11/Xmu/CharSet.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowVsWidgetP.h>

#include "GowMarkP.h"

/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

static void Initialize();
static Boolean SetValues();

#define Offset(field) XtOffsetOf(GowMarkObjectRec,gow_mark.field)

static float zero= 0.0;
static float perc= 0.01;

static XtResource resources[] = {
  { XtNlowerFraction, XtCLowerFraction, XtRFloat,
    sizeof (float),
    Offset(lower_fraction), XtRFloat, (XtPointer) &zero},
  { XtNupperFraction, XtCUpperFraction, XtRFloat,
    sizeof (float),
    Offset(upper_fraction), XtRFloat, (XtPointer) &zero},
  { XtNcrossFraction, XtCCrossFraction, XtRFloat,
    sizeof (float),
    Offset(cross_fraction), XtRFloat, (XtPointer) &perc},
};

#undef Offset

#define SUPERCLASS		(&gowObjectClassRec)

GowObjectClassRec gowMarkObjectClassRec = {
  {
/* core_class fields */	
    /* superclass	  	*/	(WidgetClass) SUPERCLASS,
    /* class_name	  	*/	"Mark",
    /* widget_size	  	*/	sizeof(GowMarkObjectRec),
    /* class_initialize   	*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited       	*/	FALSE,
    /* initialize	  	*/	Initialize,
    /* initialize_hook		*/	NULL,
    /* realize		  	*/	NULL,
    /* actions		  	*/	NULL,
    /* num_actions  		*/	0,
    /* resources	  	*/	resources,
    /* num_resources	  	*/	XtNumber(resources),
    /* xrm_class	  	*/	NULLQUARK,
    /* compress_motion	  	*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest	  	*/	FALSE,
    /* destroy		  	*/	NULL,
    /* resize		  	*/	NULL,
    /* expose		  	*/	XtInheritExpose,
    /* set_values	  	*/	SetValues,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus	 	*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private   	*/	NULL,
    /* tm_table		   	*/	NULL,
    /* query_geometry		*/	NULL,
    /* display_accelerator	*/	NULL,
    /* extension		*/	NULL
  },
/* gow_object_class fields */
  {
    /* EraseObject		*/	NULL,
    /* InsertSubobject		*/	XtInheritInsertSubobject,
    /* CreateDrawdata		*/	XtInheritCreateDrawdata,
    /* DestroyDrawdata		*/	XtInheritDestroyDrawdata,
    /* InsertHere		*/	XtInheritInsertHere,
    /* ExposeSubobject		*/	NULL,
    /* ExpandFullScale		*/	NULL,
    /* uses_rectangles		*/	FALSE
  }
};

WidgetClass gowMarkObjectClass = (WidgetClass)&gowMarkObjectClassRec;

/*	Function Name: Initialize
 *	Description: Initializes the GowMarkObject.
 *	Arguments: request, new - the requested and new values for the object
 *                                instance.
 *	Returns: none.
 *
 */

/* ARGSUSED */
static void
Initialize(request, new)
Widget request, new;
{
  GowMarkObject goo= (GowMarkObject)new;

  if (goo->gow_mark.lower_fraction < 0.0 ||
      goo->gow_mark.lower_fraction > 1.0) {
    goo->gow_mark.lower_fraction= 0.0; }
  if (goo->gow_mark.upper_fraction < 0.0 ||
      goo->gow_mark.upper_fraction > 1.0) {
    goo->gow_mark.upper_fraction= 0.0; }
  if (goo->gow_mark.cross_fraction < 0.0 ||
      goo->gow_mark.cross_fraction > 0.5) {
    goo->gow_mark.cross_fraction= 0.01; }
}

/*      Function Name: SetValues
 *      Description: checks changes of num_gcs on validity.
 *      Arguments: current - current state of the widget.
 *                 request - what was requested.
 *                 new - what the widget will become.
 *      Returns: TRUE - redisplay, FALSE - do nothing
 */

/* ARGSUSED */
static Boolean
SetValues(current, request, new)
Widget current, request, new;
{
  GowMarkObject goo = (GowMarkObject)new;
  GowMarkObject old_goo = (GowMarkObject)current;
				/* only for initialization */
  if (goo->gow_mark.lower_fraction < 0.0 ||
      goo->gow_mark.lower_fraction > 1.0) {
    goo->gow_mark.lower_fraction= old_goo->gow_mark.lower_fraction; }
  if (goo->gow_mark.upper_fraction < 0.0 ||
      goo->gow_mark.upper_fraction > 1.0) {
    goo->gow_mark.upper_fraction= old_goo->gow_mark.upper_fraction; }
  if (goo->gow_mark.cross_fraction < 0.0 ||
      goo->gow_mark.cross_fraction > 1.0) {
    goo->gow_mark.cross_fraction= old_goo->gow_mark.cross_fraction; }

  return GowSetValuesReturn(new,
			    (goo->gow_mark.lower_fraction !=
			     old_goo->gow_mark.lower_fraction ||
			     goo->gow_mark.upper_fraction !=
			     old_goo->gow_mark.upper_fraction ||
			     goo->gow_mark.cross_fraction !=
			     old_goo->gow_mark.cross_fraction));
}

#endif				/* HAS_XT_GRAPHIC */
