/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowPaneGeo.c,v 1.1 1994/05/26 19:49:26 vs Exp vs $ */

#define _GowPaneGeo_c

#include <X11/IntrinsicP.h>
#include <X11/CompositeP.h>
#include <X11/StringDefs.h>

#ifdef HAS_XAW3D
#include <X11/Xaw3d/PanedP.h>
#include <X11/Xaw3d/Grip.h>
#else
#include <X11/Xaw/PanedP.h>
#include <X11/Xaw/Grip.h>
#endif

#include <X11/Intrinsic.h>

#include <Gow/GowCutWidget.h>
#include <Gow/GowFramWidget.h>
#include <Gow/GowWidget.h>

#include "GowPaneGeo.h"

#define PaneInfo(w)	((Pane)(w)->core.constraints)
#define IsPane(w)	((w)->core.widget_class != gripWidgetClass)
#define ForAllPanes(pw, childP) \
  for ( (childP) = (pw)->composite.children ; \
        (childP) < (pw)->composite.children + (pw)->paned.num_panes ; \
        (childP)++ )

static Boolean ValidWidget(w)
     Widget w;
{
  return (XtIsManaged(w) &&
	  (XtIsSubclass(w, panedWidgetClass) ||
	   XtIsSubclass(w, gowCutWidgetClass) ||
	   XtIsSubclass(w, gowFrameWidgetClass) ||
	   XtIsSubclass(w, gowWidgetClass)));
}

XtGeometryResult GowQueryPaneGeometry(widget, request, reply)
     Widget widget;
     XtWidgetGeometry *request, *reply;
{
  PanedWidget pw;
  int total= 0, total_valid= 0, elastic= 0;

  pw= (PanedWidget)XtParent(widget);

  if (!XtIsSubclass((Widget)pw, panedWidgetClass) ||
      !pw->core.height ||
      !(XtIsSubclass(widget, gowCutWidgetClass) ||
	XtIsSubclass(widget, gowFrameWidgetClass) ||
	XtIsSubclass(widget, gowWidgetClass))) {
    return XtGeometryYes; }

  { Widget *child;
    ForAllPanes(pw, child) {
      Widget w= *child;

      if (!IsPane(w)) { continue; }
      else if (XtIsManaged(w)) { total += w->core.height; }

      if (ValidWidget(w) && !PaneInfo(w)->skip_adjust) {
	total_valid += w->core.height;
	
	if (XtIsSubclass(w, gowCutWidgetClass)) {
	  CompositeWidget cw= (CompositeWidget)w;
	  if (cw->composite.num_children &&
	      ValidWidget(cw->composite.children[0])) {
	    w= cw->composite.children[0]; } }
	if (XtIsSubclass(w, gowFrameWidgetClass)) {
	  CompositeWidget cw= (CompositeWidget)w;
	  if (cw->composite.num_children &&
	      ValidWidget(cw->composite.children[0])) {
	    w= cw->composite.children[0]; } }
	if (XtIsSubclass(w, panedWidgetClass) ||
	    XtIsSubclass(w, gowWidgetClass)) {
	  elastic += w->core.height; } } } }

  { int new;
    if (total - total_valid > pw->core.height) {
      double tmp= ((double)widget->core.height
		   * (double)pw->core.height
		   / (double)total);
      new= NINT(tmp); }
    else if (total - elastic > pw->core.height) {
      double tmp= ((double)widget->core.height
		   * (double)(pw->core.height - (total - total_valid))
		   / (double)total_valid);
      new= NINT(tmp); }
    else if (PaneInfo(widget)->skip_adjust) { return XtGeometryNo; }
    else {
      Widget w= widget;
      if (XtIsSubclass(w, gowCutWidgetClass)) {
	CompositeWidget cw= (CompositeWidget)w;
	if (cw->composite.num_children &&
	    ValidWidget(cw->composite.children[0])) {
	  w= cw->composite.children[0]; } }
      if (XtIsSubclass(w, gowFrameWidgetClass)) {
	CompositeWidget cw= (CompositeWidget)w;
	if (cw->composite.num_children &&
	    ValidWidget(cw->composite.children[0])) {
	  w= cw->composite.children[0]; } }
      { double tmp= ((double)w->core.height
		     * (double)(pw->core.height - (total - elastic))
		     / (double)elastic);
	new= (widget->core.height - w->core.height) + NINT(tmp); } }
    if (new == widget->core.height) { return XtGeometryNo; }
    else {
      reply->height= new; reply->request_mode |= CWHeight;
      return XtGeometryAlmost; } }
}				/* QueryGeometry */
