/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowPaned.c,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#ifdef HAS_XAW3D
#include <X11/Xaw3d/PanedP.h>
#else
#include <X11/Xaw/PanedP.h>
#endif

#include <Gow/GowPlot.h>

#include "GowPaned.h"

#define ForAllChildren(pw, childP) \
  for ( (childP) = (pw)->composite.children ; \
        (childP) < (pw)->composite.children + (pw)->composite.num_children ; \
        (childP)++ )

void GowPanedPlot(w, fp, type, geo)
     Widget w;
     GowDestFile fp;
     int type;
     GowDestGeometry geo;
{
  PanedWidget pw= (PanedWidget)w;

  if (XtIsRealized(w) && pw->composite.num_children) {
    int total= 0;

    { Widget *child;
      ForAllChildren(pw, child) {
	if (GowValidPlotWidget(*child)) {
	  total += (*child)->core.height;
	}
      }
    }

    { Widget *child;
      int pos= geo->y_range;
      int width= geo->x_range;
      double fac= (double)pos / (double)total;
      GowDestGeometryRec geometry;
      ForAllChildren(pw, child) {
	if (GowValidPlotWidget(*child)) {
	  int height= (int)(fac * (double)(*child)->core.height);
	  pos -= height;
	  if (GowConfigureGeometry(&geometry, geo, type,
				   0, pos, width, height)) {
	    GowPlotWidget(*child, fp, type, &geometry);
	  }
	}
      }
    }
  }
}
