/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowPeakList.c,v 1.2 1994/05/26 19:49:40 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowVsWidgetP.h>

#include "GowPeakListP.h"

/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

static Boolean RedisplayPeakList();
static void ExpandPeakList();
#define SUPERCLASS		(&gowObjectClassRec)

GowObjectClassRec gowPeakListObjectClassRec = {
  {
/* core_class fields */	
    /* superclass	  	*/	(WidgetClass) SUPERCLASS,
    /* class_name	  	*/	"Peaklistfunction",
    /* widget_size	  	*/	sizeof(GowPeakListObjectRec),
    /* class_initialize   	*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited       	*/	FALSE,
    /* initialize	  	*/	NULL,
    /* initialize_hook		*/	NULL,
    /* realize		  	*/	NULL,
    /* actions		  	*/	NULL,
    /* num_actions  		*/	0,
    /* resources	  	*/	NULL,
    /* num_resources	  	*/	0,
    /* xrm_class	  	*/	NULLQUARK,
    /* compress_motion	  	*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest	  	*/	FALSE,
    /* destroy		  	*/	NULL,
    /* resize		  	*/	NULL,
    /* expose		  	*/	XtInheritExpose,
    /* set_values	  	*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus	 	*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private   	*/	NULL,
    /* tm_table		   	*/	NULL,
    /* query_geometry		*/	NULL,
    /* display_accelerator	*/	NULL,
    /* extension		*/	NULL
  },
/* gow_object_class fields */
  {
    /* EraseObject		*/	XtInheritEraseObject,
    /* InsertSubobject		*/	XtInheritInsertSubobject,
    /* CreateDrawdata		*/	XtInheritCreateDrawdata,
    /* DestroyDrawdata		*/	XtInheritDestroyDrawdata,
    /* InsertHere		*/	XtInheritInsertHere,
    /* ExposeSubobject		*/	RedisplayPeakList,
    /* ExpandFullScale		*/	ExpandPeakList,
    /* uses_rectangles		*/	FALSE
  }
};

WidgetClass gowPeakListObjectClass = (WidgetClass)&gowPeakListObjectClassRec;

/* ARGSUSED */
static Boolean RedisplayPeakList(dest, x_scale, y_scale, data, region)
     GowDestination dest;
     GowScale x_scale;
     GowScale y_scale;
     GowAppDrawdata data;
     Region region;
{
  GowPeakList gp= (GowPeakList)data;
  GowPeakListObject goo= (GowPeakListObject)gp->goo;
  GowVsWidget gow= (GowVsWidget)gp->gow;

  return DrawPeakList(dest, &gp->peaks, x_scale, y_scale,
		      goo->gow_object.x_step_width,
		      goo->gow_object.x_min_steps,
		      gow->vs_widget.x_scale_calibrated,
		      gow->vs_widget.y_scale_modification,
		      gow->vs_widget.spectra_normalized);
}

/* ARGSUSED */
static void ExpandPeakList(data,
			   x_scale, x_type, x_full,
			   y_scale, y_type, y_full)
     GowAppData data;
     GowScale x_scale;
     GowScaleType x_type;
     int x_full;
     GowScale y_scale;
     GowScaleType y_type;
     int y_full;
{
  GowPeakList gp= (GowPeakList)data;
  GowVsWidget gow= (GowVsWidget)gp->gow;

  DrawPeakListExpand(&gp->peaks,
		     x_scale, x_type, x_full,
		     y_scale, y_type, y_full,
		     gow->vs_widget.x_scale_calibrated,
		     gow->vs_widget.y_scale_modification,
		     gow->vs_widget.spectra_normalized);
  return;
}

#endif				/* HAS_XT_GRAPHIC */
