/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowPlot.c,v 1.2 1994/05/26 19:49:41 vs Exp vs $ */

#define _GowPlot_c

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#ifdef HAS_XAW3D
#include <X11/Xaw3d/Paned.h>
#else
#include <X11/Xaw/Paned.h>
#endif

#include <Gow/GowPaned.h>
#include <Gow/GowCutWidget.h>
#include <Gow/GowFramWidget.h>
#include <Gow/GowWidget.h>

#include "GowPlot.h"

Boolean GowPlot(w, file, type, x, y, fontscale)
     Widget w;
     char *file, *type;
     int x, y;
     double fontscale;
{
  char c= ('A' <= *type && *type <= 'Z') ? (*type - 'A' + 'a') : *type;
  GowDestFile fp;
  GowDestGeometryRec geometry;

  XSync(XtDisplay(w), FALSE);

  if (!GowValidPlotWidget(w)) {
    return FALSE;
  }

  if (!(fp= GowCreatePlotDestination(file, x, y, fontscale, c, &geometry))) {
    return FALSE;
  }

  GowPlotWidget(w, fp, c, &geometry);

  return GowDestroyPlotDestination(fp, c);
}

void GowPlotWidget(w, fp, type, geometry)
     Widget w;
     GowDestFile fp;
     int type;
     GowDestGeometry geometry;
{
  if (XtIsSubclass(w, panedWidgetClass)) {
    GowPanedPlot(w, fp, type, geometry); }
  else if (XtIsSubclass(w, gowCutWidgetClass)) {
    GowCutWidgetPlot(w, fp, type, geometry); }
  else if (XtIsSubclass(w, gowFrameWidgetClass)) {
    GowFrameWidgetPlot(w, fp, type, geometry); }
  else if (XtIsSubclass(w, gowWidgetClass)) {
    GowWidgetPlot(w, fp, type, geometry); }
}

Boolean GowValidPlotWidget(w)
     Widget w;
{
  return (XtIsRealized(w) && XtIsManaged(w) &&
	  (XtIsSubclass(w, panedWidgetClass) ||
	   XtIsSubclass(w, gowCutWidgetClass) ||
	   XtIsSubclass(w, gowFrameWidgetClass) ||
	   XtIsSubclass(w, gowWidgetClass)));
}
