/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowResid.c,v 1.2 1994/05/26 19:49:42 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowVsWidgetP.h>

#include "GowResidP.h"

/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

static Boolean SetValues();
static Boolean RedisplayResiduum();
static void ExpandResiduum();

#define Offset(field) XtOffsetOf(GowResiduumObjectRec,gow_residuum.field)

static XtResource resources[] = {
  { XtNnormalized, XtCNormalized, XtRBoolean,
    sizeof (Boolean),
    Offset(normalized), XtRImmediate, (XtPointer) FALSE},
};

#undef Offset

#define SUPERCLASS		(&gowObjectClassRec)

GowObjectClassRec gowResiduumObjectClassRec = {
  {
/* core_class fields */	
    /* superclass	  	*/	(WidgetClass) SUPERCLASS,
    /* class_name	  	*/	"Residuum",
    /* widget_size	  	*/	sizeof(GowResiduumObjectRec),
    /* class_initialize   	*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited       	*/	FALSE,
    /* initialize	  	*/	NULL,
    /* initialize_hook		*/	NULL,
    /* realize		  	*/	NULL,
    /* actions		  	*/	NULL,
    /* num_actions  		*/	0,
    /* resources	  	*/	resources,
    /* num_resources	  	*/	XtNumber(resources),
    /* xrm_class	  	*/	NULLQUARK,
    /* compress_motion	  	*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest	  	*/	FALSE,
    /* destroy		  	*/	NULL,
    /* resize		  	*/	NULL,
    /* expose		  	*/	XtInheritExpose,
    /* set_values	  	*/	SetValues,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus	 	*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private   	*/	NULL,
    /* tm_table		   	*/	NULL,
    /* query_geometry		*/	NULL,
    /* display_accelerator	*/	NULL,
    /* extension		*/	NULL
  },
/* gow_object_class fields */
  {
    /* EraseObject		*/	XtInheritEraseObject,
    /* InsertSubobject		*/	XtInheritInsertSubobject,
    /* CreateDrawdata		*/	XtInheritCreateDrawdata,
    /* DestroyDrawdata		*/	XtInheritDestroyDrawdata,
    /* InsertHere		*/	XtInheritInsertHere,
    /* ExposeSubobject		*/	RedisplayResiduum,
    /* ExpandFullScale		*/	ExpandResiduum,
    /* uses_rectangles		*/	FALSE
  }
};

WidgetClass gowResiduumObjectClass = (WidgetClass)&gowResiduumObjectClassRec;

/*      Function Name: SetValues
 *      Description: checks changes of num_gcs on validity.
 *      Arguments: current - current state of the widget.
 *                 request - what was requested.
 *                 new - what the widget will become.
 *      Returns: TRUE - redisplay, FALSE - do nothing
 */

/* ARGSUSED */
static Boolean
SetValues(current, request, new)
Widget current, request, new;
{
  GowResiduumObject goo = (GowResiduumObject)new;
  GowResiduumObject old_goo = (GowResiduumObject)current;
				/* only for initialization */
  return GowSetValuesReturn(new,
			    (goo->gow_residuum.normalized !=
			     old_goo->gow_residuum.normalized));
}

/* ARGSUSED */
static Boolean RedisplayResiduum(dest, x_scale, y_scale, data, region)
     GowDestination dest;
     GowScale x_scale;
     GowScale y_scale;
     GowAppDrawdata data;
     Region region;
{
  GowResid gr= (GowResid)data;
  GowResiduumObject goo= (GowResiduumObject)gr->goo;
  GowVsWidget gow= (GowVsWidget)gr->gow;

  return DrawResiduum(dest, &gr->res, x_scale, y_scale,
		      (int)goo->gow_residuum.normalized,
		      gow->vs_widget.x_scale_calibrated,
		      gow->vs_widget.y_scale_modification,
		      gow->vs_widget.spectra_normalized);
}

/* ARGSUSED */
static void ExpandResiduum(data,
			   x_scale, x_type, x_full,
			   y_scale, y_type, y_full)
     GowAppData data;
     GowScale x_scale;
     GowScaleType x_type;
     int x_full;
     GowScale y_scale;
     GowScaleType y_type;
     int y_full;
{
  GowResid gr= (GowResid)data;
  GowResiduumObject goo= (GowResiduumObject)gr->goo;
  GowVsWidget gow= (GowVsWidget)gr->gow;

  DrawResiduumExpand(&gr->res,
		     x_scale, x_type, x_full,
		     y_scale, y_type, y_full,
		     (int)goo->gow_residuum.normalized,
		     gow->vs_widget.x_scale_calibrated,
		     gow->vs_widget.y_scale_modification,
		     gow->vs_widget.spectra_normalized);
}

#endif				/* HAS_XT_GRAPHIC */
