/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowScale.h,v 1.2 1994/05/26 19:49:44 vs Exp vs $ */

#ifndef _GowScale_h
#define _GowScale_h

#include <sys/param.h>

#include <Gow/GowConfig.h>

typedef struct _GowScaleRec		*GowScale;

typedef enum {			/* scale function types */
  GowLinearScale,
  GowLogarithmicScale,
  GowSquaredScale
} GowScaleType;

				/* scale direction */
#define GowNormalScaleDirection		1
#define GowInvertedScaleDirection	(-1)

typedef int GowScaleDirection;

typedef enum {			/* values types for new scale */
  GowLeaveScale,
  GowFullScale,
  GowFifoValue,
  GowMinValue,
  GowMaxValue,
  GowOffsetValue,
  GowRangeValue,
  GowExplicitScale
} GowScaleValue;

typedef enum {
  GowClipSmall,
  GowToSmall,
  GowClipLarge,
  GowToLarge,
  GowValid
} GowScaleConversion;

#ifndef MAX
# define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#endif				/* MAX */

#ifndef MIN
# define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#endif				/* MIN */

#ifndef ABS
# define ABS(a)		(((a) < (0)) ? -(a) : (a))
#endif				/* ABS */

#ifndef NINT
# define NINT(x)	((int)((x < 0.) ? (x - .5) : (x + .5)))
#endif				/* NINT */

#define SIGNIF_RANGE		1.0e-10

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

typedef GowScaleConversion	(*GowPixelFunc) P_((GowScale, int *, double));
typedef GowScaleConversion	(*GowUserFunc) P_((GowScale, int, double *));
typedef void		(*GowScaleNotifyProc) P_((Widget widget,
						  GowScale scale));
typedef void		(*GowScaleDelayProc) P_((Widget widget,
						 int delay_output));
typedef void		(*GowScaleInheritProc) P_((Widget widget,
						   GowScale const_scale,
						   GowScale full_scale));

/* GowScale.c */
#ifdef HAS_XT_GRAPHIC
extern void GowDeleteScaleWidget P_((GowScale scale, Widget w));
extern Boolean GowInsertScaleWidget P_((GowScale scale, Widget w,
					GowScaleNotifyProc notify,
					GowScaleDelayProc delay,
					GowScaleInheritProc inherit));
#endif				/* HAS_XT_GRAPHIC */
extern GowScale GowCreateScale P_((void));
extern void GowDelayScaleUpdate P_((GowScale scale,
				    int delay_output));
extern void GowInheritFullScale P_((GowScale const_scale,
				    GowScale full_scale));
extern void GowDestroyScale P_((GowScale scale));
extern void GowExtendNewScaleOffsetRange P_((GowScale scale,
					     double offset, double range));
extern void GowExtendNewScaleRange P_((GowScale scale, double range));
extern GowScaleDirection GowGetScaleDirection P_((GowScale scale));
extern int GowGetScaleLimitPixel P_((GowScale scale, int conversion));
extern Boolean GowGetScaleOffset P_((GowScale scale, double *offset));
extern Boolean GowGetScaleRange P_((GowScale scale, double *range));
extern GowScaleType GowGetScaleType P_((GowScale scale));
extern GowScaleType GowGetNewScaleType P_((GowScale scale));
extern Boolean GowNewScaleFull P_((GowScale scale));
extern GowPixelFunc GowGetScalePixelFunction P_((GowScale scale));
extern GowUserFunc GowGetScaleUserFunction P_((GowScale scale));
extern void GowGetScalePixelRange P_((GowScale scale,
				      int *pixel_min, int *pixel_max));
extern void GowGetScaleUserRange P_((GowScale scale,
				     double *user_min, double *user_max));
extern Boolean GowInitializeScale P_((GowScale scale,
				      GowScaleDirection direction,
				      int offset, int range,
				      double clip_min, double clip_max));
extern void GowResetNewScale P_((GowScale scale));
extern void GowResetNewScaleOffsetRange P_((GowScale scale));
extern void GowNewScaleType P_((GowScale scale, int type));
extern void GowNewScaleValue P_((GowScale scale,
				 double value, int value_type));
extern Boolean GowValidScale P_((GowScale scale));
extern Boolean GowStretchScale P_((GowScale scale, double center, double fac));
extern Boolean GowNewScale P_((GowScale scale));

#undef P_

#endif				/* _GowScale_h */
