/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowScaleP.h,v 1.2 1994/05/26 19:49:44 vs Exp vs $ */

#ifndef _GowScaleP_h
#define _GowScaleP_h

#include <Gow/GowScale.h>

/* instance record for scales of a GowObject */

typedef struct _GowScaleNotifyRec {
  Widget	widget;
  GowScaleNotifyProc	notify;
  GowScaleDelayProc	delay;
  GowScaleInheritProc	inherit;
  int			delaycount;
  int			linkcount;
} GowScaleNotifyRec;

#define ForAllWidgets(scale, entry) \
  for ((entry)= (scale)->widgets; \
       (entry) < (scale)->widgets + scale->num_widgets; \
       (entry)++)

typedef struct _GowScaleRec {
  GowScaleNotifyRec
		*widgets;	/* list of referencing gow widgets */
  Cardinal	num_widgets;	/* number of gow widgets */
  Cardinal	num_slots;	/* number of slots in gow widget array */
  GowScaleDirection direction;	/* direction of scale */

  double	offset;		/* offset of user coordinates */
  double	range;		/* range of user coordinates */

  double	new_offset;	/* offset from full scale */
  double	new_range;	/* range from full scale */
  double	new_value[2];	/* new values for expand */

  Boolean	offset_defined;	/* offset status (undefined/value) */
  Boolean	range_defined;	/* range status (undefined/value) */
  GowScaleType	type;		/* scale function type (lin/log) */

  int		new_value_type;	/* origin of actual values */
  Boolean	new_offset_defined; /* full scale offset status */
  Boolean	new_range_defined; /* full scale range status */
  GowScaleType	new_type;	/* new scale function type (lin/log) */
  int		num_new_values;	/* 0 <= number of new values <= 2 */
				/* (full/leave) */
  Boolean	being_destroyed; /* scale marked for destroy */
  Boolean	error_printed;	/* print initialization error only once */

  char		*error;		/* error message from initialization */

  GowPixelFunc	pixel;		/* function user -> pixel */
  GowUserFunc	user;		/* function pixel -> user */
  double	user_min;	/* user coordinate limits */
  double	user_max;
  double	user_offset;	/* intermediate function parameters */
  double	user_factor;
  double	user_factor_inv;
  int		pixel_offset;
  int		pixel_min;	/* pixel limits */
  int		pixel_max;
  int		clip_min;	/* pixel clip limits */
  int		clip_max;
} GowScaleRec;

#endif				/* _GowScaleP_h */
