/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowSpectrum.c,v 1.3 1994/09/20 14:47:29 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#ifdef HAS_XAW3D
#include <X11/Xaw3d/XawInit.h>
#include <X11/Xaw3d/Cardinals.h>
#include <X11/Xaw3d/Label.h>
#else
#include <X11/Xaw/XawInit.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Label.h>
#endif

#include <X11/Xmu/Initer.h>
#include <X11/Xmu/CharSet.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowVsWidgetP.h>

#include "GowSpectrumP.h"

/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

static void ClassInitialize();
static Boolean SetValues();
static Boolean RedisplaySpectrum();
static void ExpandSpectrum();
static void _CvtStringToCompressMode();

#define Offset(field) XtOffsetOf(GowSpectrumObjectRec,gow_spectrum.field)

static float def_space= 1.5;
static XtResource resources[] = {
  { XtNcompressMode, XtCCompressMode, XtRCompressMode,
    sizeof (DrawCompressMode),
    Offset(compress), XtRImmediate, (XtPointer) DrawMinMax},
  { XtNlineSpace, XtCLineSpace, XtRFloat,
    sizeof (float), Offset(line_space), XtRFloat, (XtPointer)&def_space},
};

#undef Offset

#define SUPERCLASS		(&gowObjectClassRec)

GowObjectClassRec gowSpectrumObjectClassRec = {
  {
/* core_class fields */	
    /* superclass	  	*/	(WidgetClass) SUPERCLASS,
    /* class_name	  	*/	"Spectrum",
    /* widget_size	  	*/	sizeof(GowSpectrumObjectRec),
    /* class_initialize   	*/	ClassInitialize,
    /* class_part_initialize	*/	NULL,
    /* class_inited       	*/	FALSE,
    /* initialize	  	*/	NULL,
    /* initialize_hook		*/	NULL,
    /* realize		  	*/	NULL,
    /* actions		  	*/	NULL,
    /* num_actions  		*/	0,
    /* resources	  	*/	resources,
    /* num_resources	  	*/	XtNumber(resources),
    /* xrm_class	  	*/	NULLQUARK,
    /* compress_motion	  	*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest	  	*/	FALSE,
    /* destroy		  	*/	NULL,
    /* resize		  	*/	NULL,
    /* expose		  	*/	XtInheritExpose,
    /* set_values	  	*/	SetValues,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus	 	*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private   	*/	NULL,
    /* tm_table		   	*/	NULL,
    /* query_geometry		*/	NULL,
    /* display_accelerator	*/	NULL,
    /* extension		*/	NULL
  },
/* gow_object_class fields */
  {
    /* EraseObject		*/	XtInheritEraseObject,
    /* InsertSubobject		*/	XtInheritInsertSubobject,
    /* CreateDrawdata		*/	XtInheritCreateDrawdata,
    /* DestroyDrawdata		*/	XtInheritDestroyDrawdata,
    /* InsertHere		*/	XtInheritInsertHere,
    /* ExposeSubobject		*/	RedisplaySpectrum,
    /* ExpandFullScale		*/	ExpandSpectrum,
    /* uses_rectangles		*/	FALSE
  }
};

WidgetClass gowSpectrumObjectClass = (WidgetClass)&gowSpectrumObjectClassRec;

/*      Function Name: ClassInitialize
 *      Description: Class Initialize routine, called only once.
 *      Arguments: none.
 *      Returns: none.
 */

static XrmQuark	XtQMinMax, XtQFirstFound, XtQEach;

static void
ClassInitialize()
{
  XawInitializeWidgetSet();
  XtAddConverter( XtRString, XtRBackingStore, XmuCvtStringToBackingStore,
		 NULL, 0 );
  XawInitializeWidgetSet();
  XtQMinMax		= XrmPermStringToQuark(GowEminmax);
  XtQFirstFound		= XrmPermStringToQuark(GowEfirstfound);
  XtQEach		= XrmPermStringToQuark(GowEeach);

  XtAddConverter( XtRString, XtRCompressMode,
		   _CvtStringToCompressMode, NULL, 0 );
}

#define	done(address, type) \
	{ toVal->size = sizeof(type); \
	  toVal->addr = (caddr_t) address; \
	  return; \
	}

/* ARGSUSED */
static void _CvtStringToCompressMode(args, num_args, fromVal, toVal)
    XrmValuePtr args;		/* unused */
    Cardinal    *num_args;      /* unused */
    XrmValuePtr fromVal;
    XrmValuePtr toVal;
{
    static DrawCompressMode compress;
    XrmQuark q;
    char lowerName[1000];

    XmuCopyISOLatin1Lowered (lowerName, (char*)fromVal->addr);
    q = XrmStringToQuark(lowerName);
    if (q == XtQMinMax) {
      compress = DrawMinMax;
      done(&compress, DrawCompressMode); }
    if (q == XtQFirstFound) {
      compress = DrawFirstFound;
      done(&compress, DrawCompressMode); }
    if (q == XtQEach) {
      compress = DrawEach;
      done(&compress, DrawCompressMode); }
    XtStringConversionWarning(fromVal->addr, "compressMode");
    toVal->addr = NULL;
    toVal->size = 0;
}

/*      Function Name: SetValues
 *      Description: checks changes of num_gcs on validity.
 *      Arguments: current - current state of the widget.
 *                 request - what was requested.
 *                 new - what the widget will become.
 *      Returns: TRUE - redisplay, FALSE - do nothing
 */

/* ARGSUSED */
static Boolean
SetValues(current, request, new)
Widget current, request, new;
{
  GowSpectrumObject goo = (GowSpectrumObject)new;
  GowSpectrumObject old_goo = (GowSpectrumObject)current;
				/* only for initialization */
  return GowSetValuesReturn(new,
			    (goo->gow_spectrum.compress !=
			     old_goo->gow_spectrum.compress));
}

/* ARGSUSED */
static Boolean RedisplaySpectrum(dest, x_scale, y_scale, data, region)
     GowDestination dest;
     GowScale x_scale;
     GowScale y_scale;
     GowAppDrawdata data;
     Region region;
{
  GowSpc gs= (GowSpc)data;
  GowSpectrumObject goo= (GowSpectrumObject)gs->goo;
  GowVsWidget gow= (GowVsWidget)gs->gow;

  return DrawSpectrum(dest, &gs->spc, x_scale, y_scale,
		      goo->gow_object.x_step_width,
		      goo->gow_object.x_min_steps,
		      goo->gow_spectrum.compress,
		      goo->gow_spectrum.line_space,
		      gow->vs_widget.x_scale_calibrated,
		      gow->vs_widget.y_scale_modification,
		      gow->vs_widget.spectra_normalized);
}

/* ARGSUSED */
static void ExpandSpectrum(data,
			   x_scale, x_type, x_full,
			   y_scale, y_type, y_full)
     GowAppData data;
     GowScale x_scale;
     GowScaleType x_type;
     int x_full;
     GowScale y_scale;
     GowScaleType y_type;
     int y_full;
{
  GowSpc gs= (GowSpc)data;
  GowVsWidget gow= (GowVsWidget)gs->gow;

  DrawSpectrumExpand(&gs->spc,
		     x_scale, x_type, x_full,
		     y_scale, y_type, y_full,
		     gow->vs_widget.x_scale_calibrated,
		     gow->vs_widget.y_scale_modification,
		     gow->vs_widget.spectra_normalized);
}

#endif				/* HAS_XT_GRAPHIC */
