/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowVMark.c,v 1.2 1994/05/26 19:49:46 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <stdio.h>
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <X11/Xmu/Initer.h>
#include <X11/Xmu/CharSet.h>

#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowVsWidgetP.h>

#include "GowVMarkP.h"

/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

static Boolean SetValues();
static Boolean RedisplayVMark();
static void FreeVMark();
static void ClassInitialize();
static void _CvtStringToVBarPosition();

#define Offset(field) XtOffsetOf(GowVMarkObjectRec,gow_v_mark.field)

static XtResource resources[] = {
  { XtNvBarPosition, XtCVBarPosition, XtRVBarPosition,
    sizeof (DrawVBarPosition),
    Offset(bar_position), XtRImmediate, (XtPointer) DrawNoBar},
};

#undef Offset

#define SUPERCLASS		(&gowMarkObjectClassRec)

GowObjectClassRec gowVMarkObjectClassRec = {
  {
/* core_class fields */	
    /* superclass	  	*/	(WidgetClass) SUPERCLASS,
    /* class_name	  	*/	"VMark",
    /* widget_size	  	*/	sizeof(GowVMarkObjectRec),
    /* class_initialize   	*/	ClassInitialize,
    /* class_part_initialize	*/	NULL,
    /* class_inited       	*/	FALSE,
    /* initialize	  	*/	NULL,
    /* initialize_hook		*/	NULL,
    /* realize		  	*/	NULL,
    /* actions		  	*/	NULL,
    /* num_actions  		*/	0,
    /* resources	  	*/	resources,
    /* num_resources	  	*/	XtNumber(resources),
    /* xrm_class	  	*/	NULLQUARK,
    /* compress_motion	  	*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest	  	*/	FALSE,
    /* destroy		  	*/	FreeVMark,
    /* resize		  	*/	NULL,
    /* expose		  	*/	XtInheritExpose,
    /* set_values	  	*/	SetValues,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus	 	*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private   	*/	NULL,
    /* tm_table		   	*/	NULL,
    /* query_geometry		*/	NULL,
    /* display_accelerator	*/	NULL,
    /* extension		*/	NULL
  },
/* gow_object_class fields */
  {
    /* EraseObject		*/	FreeVMark,
    /* InsertSubobject		*/	XtInheritInsertSubobject,
    /* CreateDrawdata		*/	XtInheritCreateDrawdata,
    /* DestroyDrawdata		*/	XtInheritDestroyDrawdata,
    /* InsertHere		*/	XtInheritInsertHere,
    /* ExposeSubobject		*/	RedisplayVMark,
    /* ExpandFullScale		*/	NULL,
    /* uses_rectangles		*/	FALSE
  }
};

WidgetClass gowVMarkObjectClass = (WidgetClass)&gowVMarkObjectClassRec;

static XrmQuark	XtQTopBar, XtQBottomBar, XtQNoBar;

static void
ClassInitialize()
{
  XtQTopBar		= XrmPermStringToQuark(GowEtop);
  XtQBottomBar		= XrmPermStringToQuark(GowEbottom);
  XtQNoBar		= XrmPermStringToQuark(GowEnone);

  XtAddConverter(XtRString, XtRVBarPosition,
		 _CvtStringToVBarPosition, NULL, 0 );
}

#define	done(address, type) \
	{ toVal->size = sizeof(type); \
	  toVal->addr = (caddr_t) address; \
	  return; \
	}

/* ARGSUSED */
static void _CvtStringToVBarPosition(args, num_args, fromVal, toVal)
    XrmValuePtr args;		/* unused */
    Cardinal    *num_args;      /* unused */
    XrmValuePtr fromVal;
    XrmValuePtr toVal;
{
    static DrawVBarPosition bar_position;
    XrmQuark q;
    char lowerName[1000];

    XmuCopyISOLatin1Lowered (lowerName, (char*)fromVal->addr);
    q = XrmStringToQuark(lowerName);
    if (q == XtQTopBar) {
      bar_position = DrawTopBar;
      done(&bar_position, DrawVBarPosition); }
    if (q == XtQBottomBar) {
      bar_position = DrawBottomBar;
      done(&bar_position, DrawVBarPosition); }
    if (q == XtQNoBar) {
      bar_position = DrawNoBar;
      done(&bar_position, DrawVBarPosition); }
    XtStringConversionWarning(fromVal->addr, "vBarPosition");
    toVal->addr = NULL;
    toVal->size = 0;
}

/*      Function Name: SetValues
 *      Description: checks changes of num_gcs on validity.
 *      Arguments: current - current state of the widget.
 *                 request - what was requested.
 *                 new - what the widget will become.
 *      Returns: TRUE - redisplay, FALSE - do nothing
 */

/* ARGSUSED */
static Boolean
SetValues(current, request, new)
Widget current, request, new;
{
  GowVMarkObject goo = (GowVMarkObject)new;
  GowVMarkObject old_goo = (GowVMarkObject)current;

  return GowSetValuesReturn(new,
			    (goo->gow_v_mark.bar_position !=
			     old_goo->gow_v_mark.bar_position));
}

/* ARGSUSED */
static Boolean RedisplayVMark(dest, x_scale, y_scale, data, region)
     GowDestination dest;
     GowScale x_scale;
     GowScale y_scale;
     GowAppDrawdata data;
     Region region;
{
  GowVMark gm= (GowVMark)data;
  GowVMarkObject goo= (GowVMarkObject)gm->goo;
  GowVsWidget gow= (GowVsWidget)gm->gow;

  return DrawVMark(dest, &gm->mrk, x_scale, y_scale,
		   goo->gow_mark.lower_fraction,
		   goo->gow_mark.upper_fraction,
		   goo->gow_mark.cross_fraction,
		   (int)goo->gow_v_mark.bar_position,
		   gow->vs_widget.x_scale_calibrated);
}

static void FreeVMark(w)
     Widget w;
{
  GowObject goo = (GowObject)w;
  GowWidget gow= (GowWidget)goo->object.parent;
  GowSubobject sub;
  Boolean gow_update= FALSE;

  ForAllSubobjects(goo, sub) {
    DrawVMarkFree(&((GowVMark)sub->drawdata)->mrk);
    if (sub->status == GowDrawSubobj) {
      gow_update= goo->gow_object.needs_update= TRUE; }
    sub->visible	= FALSE;
    sub->drawn		= FALSE; }
  if (gow_update) { gow->gow_widget.needs_update= TRUE; }
}

#endif				/* HAS_XT_GRAPHIC */
