/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowVsWidget.c,v 1.2 1994/05/26 19:49:48 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <math.h>
#include <stdio.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#ifdef HAS_XAW3D
#include <X11/Xaw3d/XawInit.h>
#include <X11/Xaw3d/Cardinals.h>
#include <X11/Xaw3d/Label.h>
#else
#include <X11/Xaw/XawInit.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Label.h>
#endif

#include <X11/Xmu/Initer.h>
#include <X11/Xmu/CharSet.h>

#include <tv/vsAlloc.h>

#include "GowVsWidgetP.h"
#include "GowObjectP.h"

#define Offset(field) XtOffsetOf(GowVsWidgetRec, vs_widget.field)

static XtResource resources[] = { 
  { XtNxScaleCalibrated, XtCScaleCalibrated, XtRBoolean, sizeof(Boolean),
    Offset(x_scale_calibrated),
    XtRImmediate, (XtPointer) FALSE },
  { XtNspectraNormalized, XtCSpectraNormalized, XtRBoolean, sizeof(Boolean),
    Offset(spectra_normalized),
    XtRImmediate, (XtPointer) FALSE },
  { XtNyScaleModification, XtCScaleModification, XtRScaleModification,
    sizeof(GowScaleModificationType),
    Offset(y_scale_modification),
    XtRImmediate, (XtPointer) GowMefficiency },
};

#undef Offset

/*
 * Default Translations
 */

/* none */

/*
 * Semi Public function definitions. 
 */

static void ClassInitialize(), Initialize();
static Boolean SetValues();

/* these Core methods not needed:
 *
 */

/*
 * Action Routine Definitions
 */


/* 
 * Private Function Definitions.
 */

static void _CvtStringToScaleModification();

/*
 * Actions list
 */

#define SUPERCLASS (&gowWidgetClassRec)
    
GowWidgetClassRec gowVsWidgetClassRec = {
  {				/* core_class */
    /* superclass         */    (WidgetClass) SUPERCLASS,
    /* class_name         */    "GowVsWidget",
    /* size               */    sizeof(GowVsWidgetRec),
    /* class_initialize   */	ClassInitialize,
    /* class_part_initialize*/	NULL,
    /* Class init'ed      */	FALSE,
    /* initialize         */    Initialize,
    /* initialize_hook    */	NULL,
    /* realize            */    XtInheritRealize,
    /* actions            */    NULL,
    /* num_actions        */    0,
    /* resources          */    resources,
    /* resource_count     */	XtNumber(resources),
    /* xrm_class          */    NULLQUARK,
    /* compress_motion    */    TRUE, 
    /* compress_exposure  */    TRUE,
    /* compress_enterleave*/ 	TRUE,
    /* visible_interest   */    FALSE,
    /* destroy            */    NULL,
    /* resize             */    XtInheritResize,
    /* expose             */    XtInheritExpose,
    /* set_values         */    SetValues,
    /* set_values_hook    */	NULL,
    /* set_values_almost  */	XtInheritSetValuesAlmost,  
    /* get_values_hook    */	NULL,			
    /* accept_focus       */    NULL,
    /* intrinsics version */	XtVersion,
    /* callback offsets   */    NULL,
    /* tm_table		  */    NULL,
    /* query_geometry	  */    XtInheritQueryGeometry,
    /* display_accelerator*/    NULL,
    /* extension	  */    NULL
  },
  {				/* composite_class */
    /* geometry_manager   */    XtInheritGeometryManager,
    /* change_managed     */    XtInheritChangeManaged,
    /* insert_child	  */	XtInheritInsertChild,
    /* delete_child	  */	XtInheritDeleteChild,
    /* extension	  */    NULL
  },
  {				/* gow_widget_class */
    /* UpdateWidget	  */	XtInheritUpdateWidget,
    /* EraseWidget	  */	XtInheritEraseWidget,
    /* Shell extension	  */    NULL
  }
};

WidgetClass gowVsWidgetClass = (WidgetClass)&gowVsWidgetClassRec;

/************************************************************
 *
 * Semi-Public Functions.
 *
 ************************************************************/

static XrmQuark	XtQEfficiency, XtQMultiplied, XtQNone;

static void ClassInitialize()
{
    XawInitializeWidgetSet();
    XtQEfficiency	= XrmPermStringToQuark(GowEefficiency);
    XtQMultiplied	= XrmPermStringToQuark(GowEmultiplied);
    XtQNone		= XrmPermStringToQuark(GowEnone);

    XtAddConverter( XtRString, XtRScaleModification,
		   _CvtStringToScaleModification, NULL, 0 );
}

/*      Function Name: Initialize
 *      Description: Initializes the gow widget
 *      Arguments: request - the widget requested by the argument list.
 *                 new     - the new widget with both resource and non
 *                           resource values.
 *      Returns: none.
 */

/* ARGSUSED */
static void
Initialize(request, new, args, num_args)
Widget request, new;
ArgList args;
Cardinal *num_args;
{
  if (new->core.width == 0) { new->core.width = DEFAULT_WIDTH; }
  if (new->core.height == 0) { new->core.height = DEFAULT_HEIGHT; }
}

/*      Function Name: SetValues
 *      Description: Relayout the menu when one of the resources is changed.
 *      Arguments: current - current state of the widget.
 *                 request - what was requested.
 *                 new - what the widget will become.
 *      Returns: none
 */

/* ARGSUSED */
static Boolean
SetValues(current, request, new, args, num_args)
Widget current, request, new;
ArgList args;
Cardinal *num_args;
{
  GowVsWidget gow_old = (GowVsWidget) current;
  GowVsWidget gow_new = (GowVsWidget) new;
  Boolean ret_val = FALSE;

  if (!XtIsRealized(new)) { return FALSE; }

  ret_val= ((gow_old->vs_widget.x_scale_calibrated !=
	     gow_new->vs_widget.x_scale_calibrated) ||
	    (gow_old->vs_widget.spectra_normalized !=
	     gow_new->vs_widget.spectra_normalized) ||
	    (gow_old->vs_widget.y_scale_modification !=
	     gow_new->vs_widget.y_scale_modification));

  if (ret_val) {
    gow_new->gow_widget.needs_redisplay= TRUE;
    if (!gow_new->gow_widget.set_values_expose) {
      return (gow_new->gow_widget.set_values_expose= TRUE); } }
  return FALSE;
}

/****************************************************************
 *
 * Private Procedures
 *
 ****************************************************************/

#define	done(address, type) \
	{ toVal->size = sizeof(type); \
	  toVal->addr = (caddr_t) address; \
	  return; \
	}

/* ARGSUSED */
static void _CvtStringToScaleModification(args, num_args, fromVal, toVal)
    XrmValuePtr args;		/* unused */
    Cardinal    *num_args;      /* unused */
    XrmValuePtr fromVal;
    XrmValuePtr toVal;
{
    static GowScaleModificationType modType;
    XrmQuark q;
    char lowerName[1000];

    XmuCopyISOLatin1Lowered (lowerName, (char*)fromVal->addr);
    q = XrmStringToQuark(lowerName);
    if (q == XtQEfficiency) {
	modType = GowMefficiency;
	done(&modType, GowScaleModificationType);
    }
    if (q == XtQMultiplied) {
	modType = GowMmultiplied;
	done(&modType, GowScaleModificationType);
    }
    if (q == XtQNone) {
	modType = GowMnone;
	done(&modType, GowScaleModificationType);
    }
    XtStringConversionWarning(fromVal->addr, "scaleModificationType");
    toVal->addr = NULL;
    toVal->size = 0;
}

#endif				/* HAS_XT_GRAPHIC */
