/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowWidgetP.h,v 1.2 1994/05/26 19:49:50 vs Exp vs $ */

#ifndef _GowWidgetP_h
#define _GowWidgetP_h

#include <Gow/GowDestWidgetP.h>
#include <Gow/GowWidget.h>

/****************************************************************
 *
 * GowWidget widget private
 *
 ****************************************************************/

#define DEFAULT_WIDTH  1024   /* take Tek screen width as default */
#define DEFAULT_HEIGHT  780   /* take Tek screen height as default */

#define ForAllObjects(gow, childP) \
  for ( (childP) = (GowObject *) (gow)->composite.children; \
        (childP) < (GowObject *) ((gow)->composite.children + \
				 (gow)->composite.num_children); \
        (childP)++)

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

typedef Boolean		(*GowWidgetFunc) P_((Widget w));

#undef P_

typedef struct _GowWidgetClassPart {
  XtExposeProc	UpdateWidget;	/* draw only extensions of GowObjects */
  XtWidgetProc	EraseWidget;	/* notify GowObjects on erase */

  XtPointer extension;		/* For future needs. */
} GowWidgetClassPart;

typedef struct _GowWidgetClassRec {
  CoreClassPart		core_class;
  CompositeClassPart	composite_class;
  GowWidgetClassPart	gow_widget_class;
} GowWidgetClassRec;

extern GowWidgetClassRec gowWidgetClassRec;

typedef enum {
  CrossHairCursor,
  ExpandRectangleCursor,
  ExpandVerticalCursor,
  ExpandHorizontalCursor,
  DopplerCursor
} GowCursorType;

typedef struct _GowWidgetPart {

  /* resources */

  GowDelayOutput delay_output;	/* output suspended */
  XtCallbackList delay_callbacks; /* callbacklist when delay is switched off */
  XtCallbackList scale_callbacks; /* callbacklist when scale is changed */
  Pixel		cursor_foreground;
  Pixel		cursor_background;
  Dimension	cursor_linewidth;
  Boolean	cursor_show;
  GowScale	x_scale;
  GowScale	y_scale;
  int		inheritable_scale;
  float		x_clip_min;
  float		x_clip_max;
  float		y_clip_min;
  float		y_clip_max;

  /* private state */

  int		set_values_expose; /* avoid multiple expose by SetValues */
  int		delaycount;	/* accumulated delay calls */
  Boolean	needs_update;	/* requests when output was suspended */
  Boolean	needs_erase;
  Boolean	needs_redisplay;
  Boolean	needs_expand_x;
  Boolean	needs_expand_y;
  Boolean	local_full_x;
  Boolean	local_full_y;
  Boolean	recursive_redisplay; /* avoid recursive call to redisplay */
  Boolean	cursor_drawn;	/* cursor drawn */
  GowCursorType	cursor_type;	/* cursor type */
  int               cursor_crosshair_type; /* DopplerCursor oder CrossHairCursor */
  double         cursor_doppler_factor;
  GC		cursor_gc;	/* cursor GC */
  Display	*cursor_display;/* speed up event handler */
  Window	cursor_window;/* speed up event handler */
  int		cursor_rectangle_x; /* starting corner of rectangle */
  int		cursor_rectangle_y;
  XRectangle	cursor_rectangle;
  XSegment	cursor_segments[2];
  XSegment	*cursor_grid;
  float		cursor_grid_offset;
  int		cursor_grid_max;
  int		cursor_grid_num;

} GowWidgetPart;

typedef struct _GowWidgetRec {
  CorePart			core;
  CompositePart 		composite;
  GowDestinationWidgetPart	destination_widget;
  GowWidgetPart			gow_widget;
} GowWidgetRec;

/************************************************************
 *
 * Private declarations.
 *
 ************************************************************/

#define XtInheritUpdateWidget	((XtExposeProc) _XtInherit)
#define XtInheritEraseWidget	((XtWidgetProc) _XtInherit)

#define XtRDelayOutput		"DelayOutput"

#endif /* _GowWidgetP_h */
