/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsAlloc.h,v 1.2 1994/05/26 19:50:00 vs Exp vs $ */
/* =========================================================================
 *                    vsalloc.h
 * -------------------------------------------------------------------------
 */
#ifndef _vsAlloc_h
#define _vsAlloc_h

#include <sys/types.h>

#include <tv/vsConfig.h>

#include <malloc.h>

#ifdef _vsAlloc_c
# undef ALC_PROTOCOL
#endif

typedef void Alc_t;

typedef size_t Alc_size_t;

#if defined(ALC_PROTOCOL) || defined(_vsAlloc_c)
# define AlcPos__		__FILE__, __LINE__
# define AlcCheck()		AlcPCheck(AlcPos__)
# define AlcDumpMap(f,m)	AlcPDumpMap(AlcPos__, f, m)
# define AlcDumpAllocated(f,m)	AlcPDumpAllocated(AlcPos__, f, m)
# define AlcError(e)		AlcPError(e)
# define AlcOpen(f,m,s)		AlcPOpen(AlcPos__, f, m, s)
# define AlcClose()		AlcPClose(AlcPos__)
# define AlcProtocol(s)		AlcPProtocol(AlcPos__, s)
# define Free(p)		{ AlcPFree(AlcPos__, p); p = NULL; }
# define Malloc(s)		AlcPMalloc(AlcPos__, s)
# define Calloc(s,se)		AlcPCalloc(AlcPos__, s,se)
# define Realloc(p,s)		AlcPRealloc(AlcPos__, p,s)
# define Strdup(p)		AlcPStrdup(AlcPos__, p)
# define Strndup(p,s)		AlcPStrndup(AlcPos__, p,s)
#else				/* ALC_PROTOCOL */
# define AlcCheck()
# define AlcDumpMap(f,m)
# define AlcDumpAllocated(f,m)
# define AlcError(e)		"error handling only in protocol mode"
# define AlcOpen(f,m,s)
# define AlcClose()
# define AlcProtocol(s)
# define Free(p)		{ if (p != NULL) { free(p); p = NULL; } }
# define Malloc(s)		((s == 0) ? NULL : malloc((Alc_size_t)(s)))
# define Calloc(s,se)		Alc_Calloc((Alc_size_t)(s),(Alc_size_t)(se))
# define Realloc(p,s)		Alc_Realloc(p,(Alc_size_t)(s))
# define Strdup(p)		Alc_Strdup(p)
# define Strndup(p,s)		Alc_Strndup(p,s)
#endif				/* ALC_PROTOCOL */

#define ALCNOERR	0 /* vsalloc: no error */
#define ALCFREED	1 /* vsalloc: parameter is already free'd */
#define ALCFIND		2 /* vsalloc: could not find pointer in alloc table */
#define ALCTABLE	3 /* vsalloc: alloc table is full */
#define ALCRQST		4 /* vsalloc: memory request failed */
#define ALCMAG1ST	5 /* vsalloc: lost 1st magic number */
#define ALCMAGLST	6 /* vsalloc: lost last magic number */
#define ALCFILE		7 /* vsalloc: could not open file */
#define ALCWRITE	8 /* vsalloc: could not write file */
#define ALCNAME		9 /* vsalloc: illegal file name */
#define ALCALLOC       10 /* vsalloc: could not create alloc table */

#ifdef _vsAlloc_c
int AlcErrNo= ALCNOERR;
#else
extern int AlcErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsAllocF.h>

#undef P_
/* =========================================================================
 *                     end of vsalloc.h
 * =========================================================================
 */
#endif				/* _vsAlloc_h */
