/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsCut.h,v 1.2 1994/05/26 19:50:08 vs Exp vs $ */
#ifndef _vsCut_h
#define _vsCut_h

#include <tv/vsConfig.h>
#include <tv/vsTypes.h>

#define CUT_WGAT	1
#define CUT_WFIT	2

typedef struct {
  double x1;
  double x2;
  double fac;
} Gate_t;

#define GateX1(g)		((g)->x1)
#define GateX2(g)		((g)->x2)
#define GateFac(g)		((g)->fac)

typedef struct _GVecRec {	/* vector of double's */
  VecCorePart	core;
  Gate_t	*p;
} GVecRec, *GVec_t;

#define GVecX1(g,i)		GateX1(VecP(g)+i)
#define GVecX2(g,i)		GateX2(VecP(g)+i)
#define GVecFac(g,i)		GateFac(VecP(g)+i)
#define NGVecX1(g,i)		NINT(GVecX1(g,i))
#define NGVecX2(g,i)		NINT(GVecX2(g,i))

typedef struct {
  int idx1;
  int idx2;
  Pair_t gate;
  time_t time;
} CDirEntry_t;

#define CDirEntryIdx1(p)	((p)->idx1)
#define CDirEntryIdx2(p)	((p)->idx2)
#define CDirEntryGate(p)	(&(p)->gate)
#define CDirEntryTime(p)	((p)->time)

#define CDirEntryGateX1(p)	PairX1(CDirEntryGate(p))
#define CDirEntryGateX2(p)	PairX2(CDirEntryGate(p))

typedef struct {
  VecCorePart core;
  CDirEntry_t *p;		/* vector */
} CDirEntryVecRec, *CDirEntryVec_t;

typedef struct _CDIRRec {
  time_t modifTime;
  char *path;
  char *gateExpr;
  CDirEntryVecRec e;
} CDIRRec;

#define CDirModifTime(p)	((p)->modifTime)
#define CDirPath(p)		((p)->path)
#define CDirGateExpr(p)		((p)->gateExpr)
#define CDirE(p)		(&(p)->e)

#define CDirNum(p)		VecNum(CDirE(p))
#define CDirP(p)		VecP(CDirE(p))

#define CDirIdx1(p,i)		CDirEntryIdx1(CDirP(p)+i)
#define CDirIdx2(p,i)		CDirEntryIdx2(CDirP(p)+i)
#define CDirGate(p,i)		CDirEntryGate(CDirP(p)+i)
#define CDirTime(p,i)		CDirEntryTime(CDirP(p)+i)

#define CDirGateX1(p,i)		CDirEntryGateX1(CDirP(p)+i)
#define CDirGateX2(p,i)		CDirEntryGateX2(CDirP(p)+i)

typedef struct {		/* basics */
  int exists;
  int weight;
  int idx1;
  int idx2;
  time_t time;
} CutB_t;

typedef struct _CutRec {
  CutB_t b;
  Spc_t spc;
  GVecRec gate;
  GVecRec bgGate;
  char *file;
} CutRec;

#define CutB(p)			(&(p)->b)
#define CutSpc(p)		((p)->spc)
#define CutGate(p)		(&(p)->gate)
#define CutBgGate(p)		(&(p)->bgGate)
#define CutFile(p)		((p)->file)

#define CutExists(p)		(CutB(p)->exists)
#define CutWeight(p)		(CutB(p)->weight)
#define CutIdx1(p)		(CutB(p)->idx1)
#define CutIdx2(p)		(CutB(p)->idx2)
#define CutTime(p)		(CutB(p)->time)

				/* error codes for CutErrNo */
#define CUTNOERR	 0 /* "vsCut: no error" */
#define CUTPOINT	 1 /* "vsCut: illegal NULL-pointer" */
#define CUTALLOC	 2 /* "vsCut: can not allocate temporary arrays" */
#define CUTNOMRK	 3 /* "vsCut: not enough marker for normalization" */
#define CUTSPCBUF	 4 /* "vsCut: no spectrum buffer defined" */
#define CUTNOMTX	 5 /* "vsCut: no matrix file open" */
#define CUTNOGATE	 6 /* "vsCut: no gate marker defined" */
#define CUTCRESPC	 7 /* "vsCut: no gate spectra created" */
#define CUT0BG		 9 /* "vsCut: bg peak integral == 0.0" */
#define CUTWEIGHT	 9 /* "vsCut: illegal weight type for cut" */
#define CUTINSRT	10 /* "vsCut: can not insert new CDIR-entry" */
#define CUTNOENTRY	11 /* "vsCut: no further CDIR-entry found" */
#define CUTPROJ		12 /* "vsCut: can not create gate spectrum" */
#define CUTOPGATE	13 /* "vsCut: can not open gate file" */
#define CUTRDGATE	14 /* "vsCut: can not read gate file" */
#define CUTWRGATE	15 /* "vsCut: can not write gate file" */
#define CUTOPSPC	16 /* "vsCut: can not write cut spectra" */
#define CUTRDSPC	17 /* "vsCut: can not read cut spectra" */
#define CUTWRSPC	18 /* "vsCut: can not write cut spectra" */
#define CUTILLFAC	19 /* "vsCut: factors not correct defined", */

#define CutsetErrNo(n)		{ CutErrNo= n; }

#ifdef _vsCut_c
int CutErrNo= CUTNOERR;
#else
extern int CutErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsCutF.h>

#undef P_

#endif				/* _vsCut_h */
