/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsFitFmt.h,v 1.2 1994/12/02 21:22:38 vs Exp vs $ */ 
/* -------------------------------------------------------------------------
 *                    vsFitFmt.h
 */
#ifndef _vsFitFmt_h
#define _vsFitFmt_h

#include <tv/vsConfig.h>
#include <tv/vsTypes.h>

typedef enum {
  FmtEng,
  FmtSci,
  FmtPar,
  FmtFix,
  FmtNrm,
} ParamFmt;

#define FMT_FIT		0
#define FMT_INT		1
#define FMT_PKF		2
#define FMT_PKS		3
#define FMT_PKI		4
#define FMT_LSF		5
#define FMT_LSS		6
#define FMT_BGPOL	7
#define FMT_BGEXP	8
#define FMT_MRK		9

#define FMT_NUM		10

#define FMTNOERR	0 /* vsFitFmt: no error */
#define FMTILLDBL	1 /* vsFitFmt: illegal double format specified */
#define FMTILLINT	2 /* vsFitFmt: illegal integer format specified */
#define FMTILLSTR	3 /* vsFitFmt: illegal string format specified */
#define FMTILLCHR	4 /* vsFitFmt: illegal character fond in format */
#define FMTSETUP	5 /* vsFitFmt: can not setup fit function */
#define FMTNOQUO	6 /* vsFitFmt: no quoted string found */
#define FMTOVER		7 /* vsFitFmt: internal overflow during format scan */
#define FMTOPEN		8 /* vsFitFmt: can not open format file */
#define FMTPOINT	9 /* vsFitFmt: illegal NULL-pointer */
#define FMTALLOC	10 /*vsFitFmt: can not allocate format string */

#ifdef _vsFitFmt_c
int FmtErrNo= FMTNOERR;
#else
extern int FmtErrNo;
#endif

#define FmtsetErrNo(e)	{ FmtErrNo= e; }

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

typedef int (*FmtPrintFunc) P_((char *fmt, char *s));

#include <tv/vsFitFmtF.h>

#undef P_

#endif				/* _vsFitFmt_h */
