/* vsFitFmt.c */
static char *ParseSeaPeak P_((FmtPrintFunc pfct, char *fmt, FmtArgs args, SeaPeak sp));
static char *ParseIntegration P_((FmtPrintFunc pfct, char **fmt, FmtArgs args, Fit_t fp));
static char *ParseIntCommon P_((FmtPrintFunc pfct, FmtArgs args, char **f, Fit_t fp));
static char *ParseIntPeaks P_((FmtPrintFunc pfct, char **fmt, FmtArgs args, char **f, Fit_t fp));
static char *ParseIntPeak P_((FmtPrintFunc pfct, char **fmt, FmtArgs args, Fit_t fp, FitInt_t *ip, char *title));
static char *ParseFit P_((FmtPrintFunc pfct, char **fmt, FmtArgs args, Fit_t fp));
static char *ParseFitCommon P_((FmtPrintFunc pfct, FmtArgs args, char **f, Fit_t fp));
static char *ParseDate P_((FmtPrintFunc pfct, char **f, Fit_t fp));
static char *ParseExponent P_((FmtPrintFunc pfct, char **f, Fit_t fp));
static char *ParseMeasure P_((FmtPrintFunc pfct, char **f, Fit_t fp));
static char *ParseFreedom P_((FmtPrintFunc pfct, char **f, Fit_t fp));
static char *PrintFreedom P_((FmtPrintFunc pfct, char **f, FitStat_t *fs));
static char *ParseIteration P_((FmtPrintFunc pfct, char **f, Fit_t fp));
static char *ParseFitPeaks P_((FmtPrintFunc pfct, char **fmt, FmtArgs args, Fit_t fp));
static char *ParseFitPeak P_((FmtPrintFunc pfct, char *fmt, FmtArgs args, Fit_t fp, int idx));
static char *ParseMeasureStat P_((FmtPrintFunc pfct, char **f, FitStat_t *fs));
static char *ParseIterationStat P_((FmtPrintFunc pfct, char **f, FitStat_t *fs));
static char *PrintMeasureType P_((FmtPrintFunc pfct, char **f, int t));
static char *PrintFunction P_((FmtPrintFunc pfct, char **f, Fit_t fp));
static char *ParseParam P_((FmtPrintFunc pfct, char **f, Fit_t fp, ParV_t *p, double val, double err));
static char *ParseValErr P_((FmtPrintFunc pfct, char **f, double val, double err, char *val_string));
static char *ParseCorr P_((FmtPrintFunc pfct, char **f, ParV_t *p, Fit_t fp));
static char *PrintStatus P_((FmtPrintFunc pfct, char **f, ParV_t *p));
static char *ParseBgPol P_((FmtPrintFunc pfct, char **fmt, Fit_t fp));
static char *ParseBgExp P_((FmtPrintFunc pfct, char **fmt, Fit_t fp));
static char *ParseFile P_((FmtPrintFunc pfct, FmtArgs args, char **f));
static char *ParseMark P_((FmtPrintFunc pfct, char **fmt, FmtArgs args, char **f, Fit_t fp));
static char *ParseMarkNum P_((FmtPrintFunc pfct, char **f, Fit_t fp));
static double Id2 P_((Cal_t cal, double p, double w));
static double Id3 P_((Cal_t cal, double p, double w, double dw));
static void InitArgs P_((FmtArgs args, char *file, int idx, Cal_t cal, int data_calibrated, int output_calibrated));
static char *PrintDate P_((FmtPrintFunc pfct, char **f, time_t *t));
static void SprintVal P_((double val, double d_val, double pval, ParamFmt fmtTyp, int nfrac, char *fix_fmt, char *item));
static int LegalDoubleFmt P_((char *fmt));
static int LegalIntFmt P_((char *fmt));
static int LegalStringFmt P_((char *fmt));
static int LegalFmt P_((char *fmt, char *typ, int err));
static int GetQuotedString P_((char **f, char *fmt, int fl));
static char *GetDoubleFmt P_((char **f, char *fmt, int fl));
static char *GetIntFmt P_((char **f, char *fmt, int fl));
static char *GetStringFmt P_((char **f, char *fmt, int fl));
static char *PrintFormInt P_((FmtPrintFunc pfct, char **f, int v));
static char *PrintFormInt2 P_((FmtPrintFunc pfct, char **f, int v));
static char *PrintFormDouble P_((FmtPrintFunc pfct, char **f, double v));
static char *PrintFormDouble2 P_((FmtPrintFunc pfct, char **f, double v));
static char *PrintFormString P_((FmtPrintFunc pfct, char **f, char *s));
static char *PrintFormString2 P_((FmtPrintFunc pfct, char **f, char *s));
static char *PrintQuotedItem P_((FmtPrintFunc pfct, char **f));
static char *PrintFormVal P_((FmtPrintFunc pfct, char **f, int print_val, double val, double err, char *val_string));
static char *GetValFormat P_((char **f, char *fmt, ParamFmt *pf, int *fl));
