/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsFitInt.c,v 1.2 1994/09/20 14:47:50 vs Exp vs $ */

# define _vsFitInt_c

#include "vsTypes.h"

#include "vsFit.h"
#include "vsSpectra.h"

#include "vsFitInt.h"
#include "vsFitIntP.h"

/* ---------------------------------------------------------------------- */

/* ================ */
/* integrate region */
/* ================ */

int FIIntegrateRegion(fp, sp)
     Fit_t fp;
     Spc_t sp;
{
  SpcReal_t *s= SpcBufReal(SpcSpc(sp));
  SpcReal_t *ds= SpcBufReal(SpcDSpc(sp));
  int l, r;
  PVec_t bgMp= FitBgMrk(fp);
  double sum= 0.0;
  double dSum= 0.0;

  FitFitTyp(fp) = FIT_FTINT;

  FitIntReset(FitIntegral(fp));
  FitIntReset(FitBgIntegral(fp));
  FitIntReset(FitSubIntegral(fp));

  l= NPVecX1(FitRegMrk(fp),0);
  r= NPVecX2(FitRegMrk(fp),0)+1;
  l= MAX(0, MIN(l, SpcNum(sp)));
  r= MAX(0, MIN(r, SpcNum(sp)));
				/* sum, dSum */
  { int i; for (i= l; i< r; i++) { sum += s[i]; dSum += ds[i]; } }
  FitIntI(FitIntegral(fp))= sum;
  FitIntDI(FitIntegral(fp))= sqrt(dSum);

  if (sum != 0.0) {
    double mom1= 0.0;
    double dMom1= 0.0;
    double mom2= 0.0;
    double dMom2= 0.0;
    double mom3= 0.0;
    double dMom3= 0.0;
				/* mom1 */
    { int i; for (i= l; i< r; i++) { mom1 += (double)i * s[i]; } }
    FitIntM1(FitIntegral(fp))= mom1 /= sum;

    { int i;			/* dMom1, mom2 */
      for (i= l; i< r; i++) {
	double dlt= (double)i - mom1;
	dlt *= dlt;
	dMom1 += dlt * ds[i]; mom2 += dlt * s[i]; } }
    FitIntDM1(FitIntegral(fp))= sqrt(dMom1) / ABS(sum);
    FitIntM2(FitIntegral(fp))= mom2 /= sum;

    { int i;			/* dMom2, mom3 */
      for (i= l; i< r; i++) {
	double dlt= (double)i - mom1;
	double dDlt= dlt * dlt;

	dlt= dDlt * dlt;
	dDlt= dDlt - mom2;
	dDlt *= dDlt;
	dMom2 += dDlt * ds[i]; mom3 += dlt * s[i]; } }
    FitIntDM2(FitIntegral(fp))= sqrt(dMom2) / ABS(sum);
    FitIntM3(FitIntegral(fp))= mom3 /= ABS(sum);

    { int i;			/* dMom3 */
      for (i= l; i< r; i++) {
	double dlt= (double)i - mom1;
	double dlt2 = dlt * dlt;
	dlt= dlt * (dlt2 - 3.0 * mom2) - mom3;
	dlt *= dlt;
	dMom3 += dlt * ds[i]; } }
    FitIntDM3(FitIntegral(fp))= sqrt(dMom3) / ABS(sum); }

  if (FitBgTime(fp)) {
    double bgSum= 0.0;
    double dBgSum= 0.0;

    if (!FitBgFunctionSetup(fp, NULL)) { return FALSE; }
    { int i;
      for (i= l; i< r; i++) {
	bgSum += FitBgFunction(fp, (double)i);
	dBgSum += FitDBg2Function(fp, (double)i); } }
    sum -= bgSum;
    dSum += dBgSum;
    FitIntI(FitBgIntegral(fp))= bgSum;
    FitIntDI(FitBgIntegral(fp))= sqrt(dBgSum);
    FitIntI(FitSubIntegral(fp))= sum;
    FitIntDI(FitSubIntegral(fp))= sqrt(dSum);

    if (sum != 0.0 || bgSum != 0.0) {
      double mom1= 0.0;
      double dMom1= 0.0;
      double mom2= 0.0;
      double dMom2= 0.0;
      double mom3= 0.0;
      double dMom3= 0.0;
      double bgMom1= 0.0;
      double dBgMom1= 0.0;
      double bgMom2= 0.0;
      double dBgMom2= 0.0;
      double bgMom3= 0.0;
      double dBgMom3= 0.0;

      { int i; for (i= l; i< r; i++) { /* mom1, bgMom1 */
	double b= FitBgFunction(fp, (double)i);
        mom1 += (double)i * (s[i] - b);	bgMom1 += (double)i * b; } }
      if (bgSum != 0.0) {
	FitIntM1(FitBgIntegral(fp))= bgMom1 /= ABS(bgSum); }
      if (sum != 0.0) {
	FitIntM1(FitSubIntegral(fp))= mom1 /= ABS(sum); }

      { int i;			/* mom2, dMom1, bgMom2, dBgMom1 */
	for (i= l; i< r; i++) {
	  double dlt= (double)i - mom1;
	  double dltb= (double)i - bgMom1;
	  double b;
	  double db;

	  b= FitBgFunction(fp, (double)i);
	  db= FitDBg2Function(fp, (double)i);

	  dlt *= dlt;
	  mom2 += dlt * (s[i] - b);
	  dMom1 += dlt * (ds[i] + db);

	  dltb *= dltb;
	  bgMom2 += dltb * b;
	  dBgMom1 += dltb * db; } }
      if (bgSum != 0.0) {
	FitIntDM1(FitBgIntegral(fp))= sqrt(dBgMom1) / ABS(bgSum);
	FitIntM2(FitBgIntegral(fp))= bgMom2 /= ABS(bgSum); }
      if (sum != 0.0) {
	FitIntDM1(FitSubIntegral(fp))= sqrt(dMom1) / ABS(sum);
	FitIntM2(FitSubIntegral(fp))= mom2 /= ABS(sum); }

      { int i;			/* mom3, dMom2, bgMom3, dBgmom2 */
	for (i= l; i< r; i++) {
	  double dlt= (double)i - mom1;
	  double dDlt= dlt * dlt;
	  double dltb= (double)i - bgMom1;
	  double dDltb= dltb * dltb;
	  double b;
	  double db;

	  b= FitBgFunction(fp, (double)i);
	  db= FitDBg2Function(fp, (double)i);

	  dlt= dDlt * dlt;
	  dDlt= dDlt - mom2;
	  dDlt *= dDlt;
	  dMom2 += dDlt * (ds[i] + db); mom3 += dlt * (s[i] - b);

	  dltb= dDltb * dltb;
	  dDltb= dDltb - mom2;
	  dDltb *= dDltb;
	  dBgMom2 += dDltb * db; bgMom3 += dltb * b; } }
      if (bgSum != 0.0) {
	FitIntDM2(FitBgIntegral(fp))= sqrt(dBgMom2) / ABS(bgSum);
	FitIntM3(FitBgIntegral(fp))= bgMom3 /= ABS(bgSum); }
      if (sum != 0.0) {
	FitIntDM2(FitSubIntegral(fp))= sqrt(dMom2) / ABS(sum);
	FitIntM3(FitSubIntegral(fp))= mom3 /= ABS(sum); }

      { int i;			/* dMom3, dBgMom3 */
	for (i= l; i< r; i++) {
	  double dlt= (double)i - mom1;
	  double dlt2 = dlt * dlt;
	  double dltb= (double)i - bgMom1;
	  double dltb2 = dltb * dltb;
	  double db= FitDBg2Function(fp, (double)i);

	  dlt = dlt * (dlt2 - 3.0 * mom2) - mom3;
	  dlt *= dlt;
	  dMom3 += dlt * (ds[i] + db);

	  dltb = dltb * (dltb2 - 3.0 * bgMom2) - bgMom3;
	  dltb *= dltb;
	  dBgMom3 += dltb * db; } }
      if (bgSum != 0.0) {
	FitIntDM3(FitBgIntegral(fp))= sqrt(dBgMom3) / ABS(bgSum); }
      if (sum != 0.0) {
	FitIntDM3(FitSubIntegral(fp))= sqrt(dMom3) / ABS(sum); } } }
  else if (VecNum(FitBgMrk(fp)) != 0) {
    double bgF= 0.0;
    double dBgF= 0.0;
    double bgSum= 0.0;
    double dBgSum= 0.0;
    { int i;
      int bgChn= 0;
      for (i= 0; i < VecNum(bgMp); i++) {
	int bl= NPVecX1(bgMp,i);
	int br= NPVecX2(bgMp,i)+1;
	bl= MAX(0, MIN(bl, SpcNum(sp)));
	br= MAX(0, MIN(br, SpcNum(sp)));

	bgChn += br-bl;
	{ int j; for (j= bl; j< br; j++) { bgF += s[j]; dBgF += ds[j]; } } }
      if (bgChn > 0) {
	bgF /= bgChn;
	dBgF /= (bgChn * bgChn); } }

    bgSum= bgF * (r-l);		/* bgSum, dBgSum */
    dBgSum= dBgF * (r-l);

    sum -= bgSum;		/* sum, dSum */
    dSum += dBgSum;
    FitIntI(FitBgIntegral(fp))= bgSum;
    FitIntDI(FitBgIntegral(fp))= sqrt(dBgSum);
    FitIntI(FitSubIntegral(fp))= sum;
    FitIntDI(FitSubIntegral(fp))= sqrt(dSum);

    if (sum != 0.0 || bgSum != 0.0) {
      double mom1= 0.0;
      double dMom1= 0.0;
      double mom2= 0.0;
      double dMom2= 0.0;
      double mom3= 0.0;
      double dMom3= 0.0;
      double bgMom1= 0.0;
      double dBgMom1= 0.0;
      double bgMom2= 0.0;
      double dBgMom2= 0.0;
      double bgMom3= 0.0;
      double dBgMom3= 0.0;

      { int i; for (i= l; i< r; i++) { /* mom1, bgMom1 */
	double b= bgF;
        mom1 += (double)i * (s[i] - b);	bgMom1 += (double)i * b; } }
      if (bgSum != 0.0) {
	FitIntM1(FitBgIntegral(fp))= bgMom1 /= ABS(bgSum); }
      if (sum != 0.0) {
	FitIntM1(FitSubIntegral(fp))= mom1 /= ABS(sum); }

      { int i;			/* mom2, dMom1, bgMom2, dBgMom1 */
	for (i= l; i< r; i++) {
	  double dlt= (double)i - mom1;
	  double dltb= (double)i - bgMom1;
	  double b= bgF;
	  double db= dBgF;

	  dlt *= dlt;
	  mom2 += dlt * (s[i] - b);
	  dMom1 += dlt * (ds[i] + db);

	  dltb *= dltb;
	  bgMom2 += dltb * b;
	  dBgMom1 += dltb * db; } }
      if (bgSum != 0.0) {
	FitIntDM1(FitBgIntegral(fp))= sqrt(dBgMom1) / ABS(bgSum);
	FitIntM2(FitBgIntegral(fp))= bgMom2 /= ABS(bgSum); }
      if (sum != 0.0) {
	FitIntDM1(FitSubIntegral(fp))= sqrt(dMom1) / ABS(sum);
	FitIntM2(FitSubIntegral(fp))= mom2 /= ABS(sum); }

      { int i;			/* mom3, dMom2, bgMom3, dBgmom2 */
	for (i= l; i< r; i++) {
	  double dlt= (double)i - mom1;
	  double dDlt= dlt * dlt;
	  double dltb= (double)i - bgMom1;
	  double dDltb= dltb * dltb;
	  double b= bgF;
	  double db= dBgF;

	  dlt= dDlt * dlt;
	  dDlt= dDlt - mom2;
	  dDlt *= dDlt;
	  dMom2 += dDlt * (ds[i] + db); mom3 += dlt * (s[i] - b);

	  dltb= dDltb * dltb;
	  dDltb= dDltb - mom2;
	  dDltb *= dDltb;
	  dBgMom2 += dDltb * db; bgMom3 += dltb * b; } }
      if (bgSum != 0.0) {
	FitIntDM2(FitBgIntegral(fp))= sqrt(dBgMom2) / ABS(bgSum);
	FitIntM3(FitBgIntegral(fp))= bgMom3 /= ABS(bgSum); }
      if (sum != 0.0) {
	FitIntDM2(FitSubIntegral(fp))= sqrt(dMom2) / ABS(sum);
	FitIntM3(FitSubIntegral(fp))= mom3 /= ABS(sum); }

      { int i;			/* dMom3, dBgMom3 */
	for (i= l; i< r; i++) {
	  double dlt= (double)i - mom1;
	  double dlt2 = dlt * dlt;
	  double dltb= (double)i - bgMom1;
	  double dltb2 = dltb * dltb;
	  double db= dBgF;

	  dlt = dlt * (dlt2 - 3.0 * mom2) - mom3;
	  dlt *= dlt;
	  dMom3 += dlt * (ds[i] + db);

	  dltb = dltb * (dltb2 - 3.0 * bgMom2) - bgMom3;
	  dltb *= dltb;
	  dBgMom3 += dltb * db; } }
      if (bgSum != 0.0) {
	FitIntDM3(FitBgIntegral(fp))= sqrt(dBgMom3) / ABS(bgSum); }
      if (sum != 0.0) {
	FitIntDM3(FitSubIntegral(fp))= sqrt(dMom3) / ABS(sum); } } }

  FitTime(fp)= time(NULL);

  return TRUE;
}
/* ---------------------------------------------------------------------- */
