/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsFitIo.h,v 1.3 1994/12/08 20:44:19 vs Exp vs $ */
#ifndef _vsFitIo_h
#define _vsFitIo_h

#include <tv/vsConfig.h>
#include <tv/vsTypes.h>
#include <tv/vsPar.h>
#include <tv/vsRecord.h>
#include <tv/vsSearch.h>

#define FIO_RFILTYP		2111

#define FIO_VERSION		1

#define FIO_HEAD		1 /* wird nirgendwo verwendet */
#define FIO_SEA			2
#define FIO_TOC			3
#define FIO_BIN			4
#define FIO_BINMRK		5
#define FIO_PEA			6
#define FIO_FIT			7

#define FIO_PSEA		1
#define FIO_PBIN		2
#define FIO_PNONE		3

typedef struct {
  int typ;
  unsigned int pos;
  time_t time;
} FioToc_t;

#define FioTocTyp(p)		((p)->typ)
#define FioTocPos(p)		((p)->pos)
#define FioTocTime(p)		((p)->time)

typedef struct {		/* toc of fit records */
  VecCorePart	core;
  FioToc_t	*p;
} FioTocVecRec, *FioTocVec_t;

#define FioTocPTyp(p,i)		FioTocTyp(VecP(p)+i)
#define FioTocPPos(p,i)		FioTocPos(VecP(p)+i)
#define FioTocPTime(p,i)	FioTocTime(VecP(p)+i)

typedef struct {
  int tocIdx;
  time_t time;
} Bin_t;

#define BinTocIdx(p)		((p)->tocIdx)
#define BinTime(p)		((p)->time)

typedef struct {		/* bin table */
  VecCorePart	core;
  Bin_t		*p;
} BinVecRec, *BinVec_t;

#define BinPTocIdx(p,i)		BinTocIdx(VecP(p)+i)
#define BinPTime(p,i)		BinTime(VecP(p)+i)

typedef struct {
  FitOpt par;
  float chn;
  int binIdx;
  int peakIdx;
  int fullPeaks;
} FioPea_t;

#define FioPeaPar(p)		((p)->par)
#define FioPeaChn(p)		((p)->chn)
#define FioPeaBinIdx(p)		((p)->binIdx)
#define FioPeaPeakIdx(p)	((p)->peakIdx)

typedef struct {		/* list of peaks out of bins */
  VecCorePart	core;
  FioPea_t	*p;
} FioPeaVecRec, *FioPeaVec_t;

#define FioPeaPPar(p,i)		FioPeaPar(VecP(p)+i)
#define FioPeaPChn(p,i)		FioPeaChn(VecP(p)+i)
#define FioPeaPBinIdx(p,i)	FioPeaBinIdx(VecP(p)+i)
#define FioPeaPPeakIdx(p,i)	FioPeaPeakIdx(VecP(p)+i)

typedef struct _FioCurPeakRec {
  int typ;
  int peaIdx;
  SeaPeak seaPeak;
} FioCurPeakRec, *FioCurPeak_t;

#define FioCurPeakTyp(p)	((p)->typ)
#define FioCurPeakPeaIdx(p)	((p)->peaIdx)
#define FioCurPeakSeaPeak(p)	((p)->seaPeak)

typedef struct _FioRec {	/* tail info about fit data file */
  FioTocVecRec	toc;
  BinVecRec	bin;
  PVecRec	binMrk;
  FioPeaVecRec	pea;
  SeaPeakList	sea;
  FioCurPeakRec	cur;
  int		writeTail;
  int		fullPeaks;
  RFILE		*rfp;
} FioRec;

				/* access macros for Fio_t */
#define FioToc(p)		(&(p)->toc)
#define FioBin(p)		(&(p)->bin)
#define FioBinMrk(p)		(&(p)->binMrk)
#define FioPea(p)		(&(p)->pea)
#define FioSea(p)		((p)->sea)
#define FioCur(p)		(&(p)->cur)
#define FioWriteTail(p)		((p)->writeTail)
#define FioFullPeaks(p)		((p)->fullPeaks)
#define FioRfp(p)		((p)->rfp)

#define FIONOERR	 0 /* "vsFitIo: no error" */
#define FIOPOINT	 1 /* "vsFitIo: illegal NULL-pointer" */
#define FIOALLOC	 2 /* "vsFitIo: memory allocation failed" */
#define FIOOPEN		 3 /* "vsFitIo: could not open data file" */
#define FIOFILTYP	 4 /* "vsFitIo: illegal data file type" */
#define FIOREAD		 5 /* "vsFitIo: could not read data file" */
#define FIOWRITE	 6 /* "vsFitIo: could not write data file" */
#define FIOTOCIDX	 7 /* "vsFitIo: illegal toc index" */
#define FIORECTYP	 8 /* "vsFitIo: illegal record type in data file" */
#define FIOCOMP		 9 /* "vsFitIo: could not compress data record" */
#define FIOUNCOMP	10 /* "vsFitIo: could not uncompress data record" */
#define FIOVERS		11 /* "vsFitIo: could not handle compress version" */
#define FIOINTERN	12 /* "vsFitIo: severe internal error" */
#define FIOPEAINS	13 /* "vsFitIo: could not insert peak" */
#define FIORDONLY	14 /* "vsFitIo: data file is read only" */
#define FIONOPEAK	15 /* "vsFitIo: no peak found", */
#define FIOPKTYP	16 /* "vsFitIo: illegal peak function typ", */
#define FIOBGSTO	17 /* "vsFitIo: bg-dimensions exceed available arraysize" */

#define FiosetErrNo(e)	{ FioErrNo= e; }

#ifdef _vsFitIo_c
int FioErrNo=FIONOERR;
#else
extern int FioErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsFitIoF.h>

#undef P_

#endif				/* _vsFitIo_h */
