/* $Header: /usr/files/home/Gamma/vs/tv/edit/tv/RCS/vsKey.h,v 1.1 1993/09/17 14:55:08 vs Exp vs $ */

#ifndef _vsKey_h
#define _vsKey_h

#include <string.h>

#include <tv/vsConfig.h>

#define KTKEYFOUND		1
#define KTILLKEY		2
#define KTINCOMPL		3

typedef struct _KeyRec {	/* key */
  char *sequence;		/* key sequence */
  char *alias;			/* alias */
  struct _KeyRec *next;		/* next entry */
} KeyRec, *Key_t;

#define KeySequence(kp)		((kp)->sequence)
#define KeyAlias(kp)		((kp)->alias)
#define KeyNext(kp)		((kp)->next)

typedef struct _KeytableRec {	/* keytable */
  char *title;
  char *file;
  Key_t first;
  Key_t next;
} KeytableRec;

#define KeytableTitle(kp)	((kp)->title)
#define KeytableFile(kp)	((kp)->file)
#define KeytableFirst(kp)	((kp)->first)
#define KeytableNext(kp)	((kp)->next)

/* error codes */
#define KTNOERR		0 /* "vsKey: no error", */
#define KTPOINT		1 /* "vsKey: illegal NULL-pointer", */
#define KTOPEN		2 /* "vsKey: can not open keytable file", */
#define KTREAD		3 /* "vsKey: can not read keytable", */
#define KTWRITE		4 /* "vsKey: can not write keytable", */
#define KTALLOC		5 /* "vsKey: can not allocate buffer", */
#define KTSCAN		6 /* "vsKey: scan error on keytable file", */
#define KTBUFEND	7 /* "vsKey: buffer overflow", */
#define KTFIND		8 /* "vsKey: can not find keysequence", */


#define KTsetErrNo(n)		{ KTErrNo= n; }

#ifdef _vsKey_c
int KTErrNo= KTNOERR;
#else
extern int KTErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsKeyF.h>

#undef P_

#endif				/* _vsKey_h */
