/* $Header: /usr/files/home/Gamma/vs/tv/edit/tv/RCS/vsMark.c,v 1.1 1993/09/17 14:55:08 vs Exp vs $ */
#define _vsMark_c

#include "vsTypes.h"

#include "vsTools.h"

#include "vsMark.h"
#include "vsMarkP.h"

#define SORT(p,i) {\
  if (PVecX1(p,i) > PVecX2(p,i)) {\
    double t= PVecX1(p,i); PVecX1(p,i)= PVecX2(p,i); PVecX2(p,i)= t; } }

/* ====================================================================== */
int MrkCompress(mp)
     PVec_t mp;
{
  if (mp == NULL) { MrksetErrNo(MRKPOINT); return FALSE; }
  else {
    int i;
    for (i= VecNum(mp)-2; i >= 0; i--) {
      if (PVecX2(mp,i)+1 >= PVecX1(mp,i+1)) {
	PVecX2(mp,i)= MAX(PVecX2(mp,i), PVecX2(mp,i+1));
	VecDelete(mp,i+1,1); } }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
double MrkRange(mp)
     PVec_t mp;
{
  int i;
  double range= 0.0;
  for (i= 0; i< VecNum(mp); i++) {
    range += NPVecX2(mp,i) - NPVecX1(mp,i); }
  return (range + VecNum(mp));
}
/* ---------------------------------------------------------------------- */
int MrkDelete(mp, dp)
     PVec_t mp;
     PVec_t dp;
{
  if (mp == NULL || dp == NULL) { MrksetErrNo(MRKPOINT); return FALSE; }
  else {
    int m;
    int d;
    for (m= VecNum(mp)-1, d= VecNum(dp)-1; m >= 0 && d >= 0; ) {
      if (PVecX2(mp,m) < PVecX1(dp,d)) {	/* mmm     */
	d--; }					/*     ddd */
      else if (PVecX2(dp,d) < PVecX1(mp,m)) {	/* ddd      */
	m--; }					/*     mmm */
      else {			/* delete any overlapping region */
	VecDelete(mp, m, 1); m--; } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
char *MrkError(err_no)
     int err_no;
{
  static char *errors[] = {
  /* MRKPOINT:  */ "vsMark: illegal NULL-pointer",
  /* default:   */ "vsMark: undefined error code", };

  if (err_no < sizeof(errors)) { return errors[err_no]; }
  else { return errors[sizeof(errors)-1]; }
}
/* ---------------------------------------------------------------------- */
int MrkInsert(t, x1, x2)
     PVec_t t;
     double x1;
     double x2;
{
  if (x1 > x2) { double tmp= x1; x1= x2; x2= tmp; }
  { int i;
    for (i= 0; i< VecNum(t); i++) { if (x1 < PVecX1(t,i)) { break; } }

    if (!VecInsert(t, i, 1)) { return FALSE; }
    else { PVecX1(t,i)= x1; PVecX2(t,i)= x2; return TRUE; } }
}
/* ---------------------------------------------------------------------- */
int MrkOr(t, f)
     PVec_t t;
     PVec_t f;
{
  if (t == NULL || f  == NULL) { MrksetErrNo(MRKPOINT); return FALSE; }
  else if (!VecRealloc(t, VecNum(f)+VecNum(t))) { return FALSE; }
  else {
    int i;
    for (i= 0; i< VecNum(f); i++) {
      MrkInsert(t, PVecX1(f,i), PVecX2(f,i)); }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int MrkXor(ma, mb)
     PVec_t ma;
     PVec_t mb;
{
  if (!MrkCompress(ma) || !MrkCompress(mb)) { return FALSE; }
  else {
    int ia= 0;
    int ib= 0;

    while (ia < VecNum(ma) && ib < VecNum(mb)) {
      if (PVecX1(ma,ia) < PVecX1(mb,ib)) {
				/* X1aaa....... */
				/*   ....X1bbb  */
	if (PVecX2(ma,ia) < PVecX1(mb,ib)) {
				/* aaaX2 X1bbb */
	  ia++; }
	else {
				/* aaaaa.....  */
				/*   X1bbbb    */
	  if (!VecInsert(ma, ia+1, 1)) { return FALSE; }
	  else {
	    PVecX1(ma,ia+1)= PVecX1(mb,ib);
	    PVecX2(ma,ia+1)= PVecX2(ma,ia);
	    PVecX2(ma,ia)= PVecX1(mb,ib) - 1.0;
	    SORT(ma,ia); SORT(ma,ia+1);
	    ia++; } } }
      else if (PVecX2(mb,ib) < PVecX1(ma,ia)) {
				/* bbbX2 X1aaa */
	ib++; }
      else if (PVecX1(mb,ib) < PVecX1(ma,ia)) {
				/*   X1aaa   */
				/* bbbbb.... */
	if (!VecInsert(mb, ib+1, 1)) { return FALSE; }
	else {
	  PVecX1(mb,ib+1)= PVecX1(ma,ia);
	  PVecX2(mb,ib+1)= PVecX2(mb,ib);
	  PVecX2(mb,ib)= PVecX1(ma,ia) - 1.0;
	  SORT(mb,ib); SORT(mb,ib+1);
	  ib++; } }
      else if (PVecX2(ma,ia) < PVecX2(mb,ib)) {
				/* aaaX2   */
				/* bbbbbX2 */
	PVecX1(mb,ib)= PVecX2(ma,ia)+1.0;
	SORT(mb,ib);
	VecDelete(ma,ia,1); }
      else if (PVecX2(mb,ib) < PVecX2(ma,ia)) {
				/* aaaaaX2 */
				/* bbbX2   */
	PVecX1(ma,ia)= PVecX2(mb,ib)+1.0;
	SORT(ma,ia);
	VecDelete(mb,ib,1); }
      else {
				/* aaaaa */
				/* bbbbb */
	VecDelete(ma,ia,1);
	VecDelete(mb,ib,1); } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int MrkAndNot(ma, mb)
     PVec_t ma;
     PVec_t mb;
{
  if (!ma || !mb) { MrksetErrNo(MRKPOINT); return FALSE;}
  else {
    int ia= 0;
    int ib= 0;

    while (ia < VecNum(ma) && ib < VecNum(mb)) {
      if (PVecX1(ma,ia) < PVecX1(mb,ib)) {
				/* X1aaa....... */
				/*   ....X1bbb  */
	if (PVecX2(ma,ia) < PVecX1(mb,ib)) {
				/* aaaX2 X1bbb */
	  ia++; }
	else {
				/* aaaaa.....  */
				/*   X1bbbb    */
	  if (!VecInsert(ma, ia+1, 1)) { return FALSE; }
	  else {
	    PVecX1(ma,ia+1)= PVecX1(mb,ib);
	    PVecX2(ma,ia+1)= PVecX2(ma,ia);
	    PVecX2(ma,ia)= PVecX1(mb,ib) - 1.0;
	    SORT(ma,ia); SORT(ma,ia+1);
	    ia++; } } }
      else if (PVecX2(mb,ib) < PVecX1(ma,ia)) {
				/* bbbX2 X1aaa */
	ib++; }
      else if (PVecX1(mb,ib) < PVecX1(ma,ia)) {
				/*   X1aaa   */
				/* bbbbb.... */
	ib++; }
      else if (PVecX2(ma,ia) < PVecX2(mb,ib)) {
				/* aaaX2   */
				/* bbbbbX2 */
	VecDelete(ma,ia,1); }
      else if (PVecX2(mb,ib) < PVecX2(ma,ia)) {
				/* aaaaaX2 */
				/* bbbX2   */
	PVecX1(ma,ia)= PVecX2(mb,ib)+1.0;
	SORT(ma,ia); }
      else {
				/* aaaaa */
				/* bbbbb */
	VecDelete(ma,ia,1); } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
