/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsPar.h,v 1.2 1994/12/02 21:22:48 vs Exp vs $ */
#ifndef _vsPar_h
#define _vsPar_h

#include <tv/vsConfig.h>
#include <tv/vsTypes.h>
				/* mode */
#define PAR_MUNDEF	0
#define PAR_MFREE	1
#define PAR_MHOLD	2
#define PAR_MCORR	3

#define ILLEGAL_MODE(m) ((m) != PAR_MFREE && (m) != PAR_MHOLD && (m) != PAR_MCORR) 
				/* status */
#define PAR_SUNDEF	0
#define PAR_SUSED	1
#define PAR_SSUSP	2
#define PAR_SDELD	3

#define ILLEGAL_STAT(s) ((s) != PAR_SUSED && (s) != PAR_SSUSP && (s) != PAR_SDELD)
				/* par sort field */
#define PAR_VVAL	0
#define PAR_VERR	1
#define PAR_VSTART	2

#define ParMfree(pp,i)		(ParMode(pp,i) == PAR_MFREE)
#define ParMhold(pp,i)		(ParMode(pp,i) == PAR_MHOLD)
#define ParMcorr(pp,i)		(ParMode(pp,i) == PAR_MCORR)

#define ParSused(pp,i)		(ParStat(pp,i) == PAR_SUSED)
#define ParSdeld(pp,i)		(ParStat(pp,i) == PAR_SDELD)
#define ParSsusp(pp,i)		(ParStat(pp,i) == PAR_SSUSP)

#define ParVMfree(pp)		(ParVMode(pp) == PAR_MFREE)
#define ParVMhold(pp)		(ParVMode(pp) == PAR_MHOLD)
#define ParVMcorr(pp)		(ParVMode(pp) == PAR_MCORR)

#define ParVSused(pp)		(ParVStat(pp) == PAR_SUSED)
#define ParVSdeld(pp)		(ParVStat(pp) == PAR_SDELD)
#define ParVSsusp(pp)		(ParVStat(pp) == PAR_SSUSP)

				/* function-macros */
#define ParCorrel(pp,cp) \
{\
  int ucp= ParCorrIndex(pp,cp);\
  ParVal(pp,cp) = ParVal(pp,ucp) * ParCorr(pp,cp)[1] + ParCorr(pp,cp)[0];\
  ParErr(pp,cp) = ParErr(pp,ucp) * ParCorr(pp,cp)[1];\
}

#define ParVCmp(p1,p2) (memcmp((void *)p1, (void *)p2, sizeof(ParV_t)))

/* ====================================================================== */
				/* vsPar.h */
#define PAR_COR	  2		/* max. number of coefficients in correlation*/

typedef struct {		/* parameter value struct */
  double val;			/* value */
  double err;			/* error */
  double userVal;		/* user value */
  double corr[PAR_COR];		/* correlations (linear) */
  int mode;			/* parameter mode (correlated,free,hold) */
  int stat;			/* parameter status (suspended,deleted,used) */
  int userStat;			/* user defined status */
  int userTyp;			/* user defined type */
  int corrIndex;		/* index of correlated parameter */
} ParV_t;

#define ParVVal(pp)		((pp)->val)
#define ParVErr(pp)		((pp)->err)
#define ParVUserVal(pp)		((pp)->userVal)
#define ParVCorr(pp)		((pp)->corr)
#define ParVMode(pp)		((pp)->mode)
#define ParVStat(pp)		((pp)->stat)
#define ParVUserStat(pp)	((pp)->userStat)
#define ParVUserTyp(pp)		((pp)->userTyp)
#define ParVCorrIndex(pp)	((pp)->corrIndex)

typedef struct _ParVecRec {	/* vector of ParV_t's */
  VecCorePart	core;
  ParV_t	*p;
} ParVecRec, *ParVec_t;

typedef struct _ParRec {	/* parameter vector struct */
  ParVecRec par;		/* parameter values */
  IVecRec fr;			/* indices of free parameters (managed by vsPar.c:ParIndex() )*/
  IVecRec hld;			/* indices of held parameters */
  IVecRec cor;			/* indices of parameters correlated to free */
  IVecRec corFr;		/* indices of parent parameters in *free */
  int modeCounted;		/* index vector setup done */
  int maxUsed;			/* index of last used parameter */
} ParRec;

#define ParPar(pp)		(&(pp)->par)
#define ParFr(pp)		(&(pp)->fr)
#define ParHld(pp)		(&(pp)->hld)
#define ParCor(pp)		(&(pp)->cor)
#define ParCorFr(pp)		(&(pp)->corFr)

#define ParNum(pp)		VecNum(ParPar(pp))
#define ParNumFree(pp)		VecNum(ParFr(pp))
#define ParNumHold(pp)		VecNum(ParHld(pp))
#define ParNumCorr(pp)		VecNum(ParCor(pp))
#define ParNumCoFr(pp)		VecNum(ParCorFr(pp))
#define ParMaxUsed(pp)		((pp)->maxUsed)
#define ParModeCounted(pp)	((pp)->modeCounted)

#define ParIfree(pp,i)		(VecP(ParFr(pp))[i])
#define ParIhold(pp,i)		(VecP(ParHld(pp))[i])
#define ParIcorr(pp,i)		(VecP(ParCor(pp))[i])
#define ParIcofr(pp,i)		(VecP(ParCorFr(pp))[i])

#define ParP(pp)		VecP(ParPar(pp))
#define ParV(pp,i)		(ParP(pp)+i)
#define ParVal(pp,i)		ParVVal(ParV(pp,i))
#define ParErr(pp,i)		ParVErr(ParV(pp,i))
#define ParUserVal(pp,i)	ParVUserVal(ParV(pp,i))
#define ParCorr(pp,i)		ParVCorr(ParV(pp,i))
#define ParMode(pp,i)		ParVMode(ParV(pp,i))
#define ParStat(pp,i)		ParVStat(ParV(pp,i))
#define ParUserStat(pp,i)	ParVUserStat(ParV(pp,i))
#define ParUserTyp(pp,i)	ParVUserTyp(ParV(pp,i))
#define ParCorrIndex(pp,i)	ParVCorrIndex(ParV(pp,i))

#define PARNOERR	 0 /* vsPar: no error */
#define PARPOINT	 1 /* vsPar: illegal NULL-pointer */
#define PARALLOC	 2 /* vsPar: memory allocation failed */
#define PARILLIDX	 3 /* vsPar: illegal index */
#define PARILLMOD	 4 /* vsPar: illegal parameter mode */
#define PARILLSTT	 5 /* vsPar: illegal parameter status */
#define PARCORCYC	 6 /* vsPar: cyclic correlation not accepted */
#define PARCORZER	 7 /* vsPar: no correlation defined */
#define PARCORIDX	 8 /* vsPar: illegal index(uncorrelated parameter) */
#define PARCORDEL	 9 /* vsPar: no corr's to deleted parameters */
#define PARCORSUS	10 /* vsPar: no corr's to suspended parameters */
#define PARCOREX	11 /* vsPar: parameter in correlation in use */
#define PARSRTLEN	12 /* vsPar: illegal number of sort elements */
#define PARMEMBER	13 /* vsPar: illegal member of ParV_t specified */

#ifdef _vsPar_c
int ParErrNo=PARNOERR;
#else
extern int ParErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsParF.h>

#undef P_

#endif				/* _vsPar_h */
