/* $Header: /usr/files/home/Gamma/vs/tv/edit/tv/RCS/vsPattern.c,v 1.1 1993/09/17 14:55:08 vs Exp vs $ */
#define _vsPattern_c

#include "vsTypes.h"
#include "vsAlloc.h"

#include "vsTools.h"

#include "vsPattern.h"
/* ---------------------------------------------------------------------- */
char *PatError(err_no)
     int err_no;
{
  static char *errors[] = {
  /* PATNOERR: */ "vsPattern: no error",
  /* PATPOINT: */ "vsPattern: illegal NULL-pointer",
  /* PATALLOC: */ "vsPattern: could not allocate pattern record",
  /* PATFOUND: */ "vsPattern: could not find pattern",
  /* PATNOPAT: */ "vsPattern: no pattern defined",
  /* default:  */ "vsPattern: undefined error code", };

  if (err_no < sizeof(errors)) { return errors[err_no]; }
  else { return errors[sizeof(errors)-1]; }
}
/* ---------------------------------------------------------------------- */
int PatInit(pp)
     PatVec_t pp;
{
  return VecInit(pp, sizeof(Pat_t));
}
/* ---------------------------------------------------------------------- */
int PatRealloc(pp, size)
     PatVec_t pp;
     int size;
{
  if (VecRealloc(pp,size)) {
    int i;
    for (i= VecNum(pp); i< size; i++) {
      PatVecPatt(pp,i)= NULL; }
    VecNum(pp)= VecSiz(pp)/VecTypSiz(pp);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int PatFree(pp)
     PatVec_t pp;
{
  if (pp == NULL) { PatErrNo= PATPOINT; return FALSE; }
  else {
    int i;
    for (i= 0; i< VecNum(pp); i++) { Free(PatVecPatt(pp,i)); }
    return VecFree(pp); }
}
/* ---------------------------------------------------------------------- */
int PatSet(pp, patt, expr)
     PatVec_t pp;
     char *patt;
     char *expr;
{
  if (pp == NULL || patt == NULL || expr == NULL) {
    PatErrNo= PATPOINT; return FALSE; }
  else if (!*patt) { PatErrNo= PATNOPAT; return FALSE; }
  else if (!*expr) { return PatDel(pp, patt); }
  else {
    int i;
    int unused= -1;		/* unused or new pattern matched old one */
    int size;
    char *s;
    int sp= strlen(patt);
    size= sp + strlen(expr) + 2;
    for (i= VecNum (pp) - 1; i >= 0; i--) {
      if (PatVecPatt(pp,i) == NULL) { unused = i; }
      else if (!strcmp(PatVecPatt(pp,i), patt)) { unused= i; break; } }

    if (unused < 0) {
      if (!PatRealloc(pp, VecNum(pp)+1)) { return FALSE; }
      else { unused= VecNum(pp)-1; } }

    if (NULL == (s= (char *)Malloc(size * sizeof(char)))) {
      PatErrNo= PATALLOC; return FALSE; }
    else {
      Free(PatVecPatt(pp,unused));
      PatVecPatt(pp,unused)= s;
      strcpy(PatVecPatt(pp,unused), patt);
      PatVecExpr(pp,unused)= PatVecPatt(pp,unused) + sp + 1;
      strcpy(PatVecExpr(pp,unused), expr);
      return TRUE; } }
}
/* ---------------------------------------------------------------------- */
int PatDel(pp, patt)
     PatVec_t pp;
     char *patt;
{
  if (pp == NULL || patt == NULL) {
    PatErrNo= PATPOINT; return FALSE; }
  else {
    int i;
    for (i= 0; i < VecNum(pp); i++) {
      if (!strcmp(PatVecPatt(pp,i), patt)) {
	Free(PatVecPatt(pp,i));
	return TRUE; } }
    PatErrNo= PATFOUND;
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
char *PatGet(pp, patt)
     PatVec_t pp;
     char *patt;
{
  if (pp == NULL || patt == NULL) {
    PatErrNo= PATPOINT; return ""; }
  else {
    int i;
    for (i= 0; i < VecNum(pp); i++) {
      if (PatVecPatt(pp,i) && !strcmp(PatVecPatt(pp,i), patt)) {
	return PatVecExpr(pp,i); } }
    PatErrNo= PATFOUND;
    return ""; }
}
/* ---------------------------------------------------------------------- */
