/* $Header: /usr/files/home/Gamma/vs/tv/edit/tv/RCS/vsRecal.h,v 1.1 1993/09/17 14:55:08 vs Exp vs $ */
#ifndef _vsRecal_h
#define _vsRecal_h

#include <tv/vsConfig.h>
#include <tv/vsTypes.h>
				/* recalibration types */
#define RCL_TUNDEF		1
#define RCL_TPAIR		2
#define RCL_TPOLYNOM		3
#define RCL_TSQUARE		4
#define RCL_TCOM		5

typedef struct {		/* recalibration struct */
  double x1;
  double x2;
  double xChn;
  double chiChn;
  double xRcl;
  double dRcl;
  double chiRcl;
  double xRev;
  double dRev;
  double chiRev;
  double xCoM;
  double dCoM;
  double chiCoM;
} RclPair_t;

#define RclPairX1(p)  		((p)->x1)
#define RclPairX2(p)  		((p)->x2)
#define RclPairXChn(p)  	((p)->xChn)
#define RclPairChiChn(p)	((p)->chiChn)
#define RclPairXRcl(p)  	((p)->xRcl)
#define RclPairDRcl(p)  	((p)->dRcl)
#define RclPairChiRcl(p)	((p)->chiRcl)
#define RclPairXRev(p)  	((p)->xRev)
#define RclPairDRev(p)  	((p)->dRev)
#define RclPairChiRev(p)	((p)->chiRev)
#define RclPairXCoM(p)  	((p)->xCoM)
#define RclPairDCoM(p)  	((p)->dCoM)
#define RclPairChiCoM(p)  	((p)->chiCoM)

typedef struct {		/* vector of RclPair_t's */
  VecCorePart	core;
  RclPair_t *p;
} RclPairVecRec, *RclPairVec_t;

#define RclPairVecX1(p,i)	RclPairX1(VecP(p)+i)
#define RclPairVecX2(p,i)	RclPairX2(VecP(p)+i)
#define RclPairVecXChn(p,i)	RclPairXChn(VecP(p)+i)
#define RclPairVecChiChn(p,i)	RclPairChiChn(VecP(p)+i)
#define RclPairVecXRcl(p,i)	RclPairXRcl(VecP(p)+i)
#define RclPairVecDRcl(p,i)	RclPairDRcl(VecP(p)+i)
#define RclPairVecChiRcl(p,i)	RclPairChiRcl(VecP(p)+i)
#define RclPairVecXRev(p,i)	RclPairXRev(VecP(p)+i)
#define RclPairVecDRev(p,i)	RclPairDRev(VecP(p)+i)
#define RclPairVecChiRev(p,i)	RclPairChiRev(VecP(p)+i)
#define RclPairVecXCoM(p,i)	RclPairXCoM(VecP(p)+i)
#define RclPairVecDCoM(p,i)	RclPairDCoM(VecP(p)+i)
#define RclPairVecChiCoM(p,i)	RclPairChiCoM(VecP(p)+i)

typedef struct _RclRec {	/* recalibration struct */
  int typ;			/* recalibration type */
  RclPairVecRec pair;		/* pair recalibration */
  DVecRec poly;			/* polynom recalibration */
} RclRec;

				/* access macros for Rcl_t */
#define RclTyp(rp)		((rp)->typ)
#define RclPair(rp)		(&(rp)->pair)
#define RclPoly(rp)		(&(rp)->poly)

#define RclPairNum(rp)		VecNum(RclPair(rp))
#define RclPolyNum(rp)		VecNum(RclPoly(rp))
#define RclPolyP(rp)		VecP(RclPoly(rp))

#define RCLNOERR	 0 /* "vsRecal: no error" */
#define RCLPOINT	 1 /* "vsRecal: illegal NULL-pointer" */
#define RCLGRAD		 2 /* "vsRecal: zero gradient - spectrum zeroed" */
#define RCLNOMARK	 3 /* "vsRecal: no (valid) recalibration marker specified" */
#define RCLMAXRES	 4 /* "vsRecal: maximum resolution exceeded" */
#define RCLALLOC	 5 /* "vsRecal: can not extend recalibration data" */
#define RCLEQPAIR	 6 /* "vsRecal: equal recalibration marker" */
#define RCLTYP		 7 /* "vsRecal: illegal recalibration typ" */
#define RCLNORES	 8 /* "vsRecal: undefined resolution" */
#define RCLNONORM	 9 /* "vsRecal: undefined normalization factor" */

#define RclsetErrNo(n)		{ RclErrNo= n; }

#ifdef _vsRecal_c
int RclErrNo= RCLNOERR;
#else
extern int RclErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsRecalF.h>

#undef P_

#endif				/* _vsRecal_h */
