/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsSpectra.h,v 1.2 1994/05/26 19:50:32 vs Exp vs $ */
#ifndef _vsSpectra_h
#define _vsSpectra_h

#include <tv/vsConfig.h>
#include <tv/vsTypes.h>
#include <mfile.h>

/* Maximum resolution of spectra */
#define SPC_MR		65536
/*#define SPC_MR		16384*/

#ifdef _vsSpectra_c
int SpcMaxRes= SPC_MR;
int SpcSharedMemory= FALSE;
#else
extern int SpcMaxRes;
extern int SpcSharedMemory;
#endif

#define SPC_INT		0
#define SPC_FLT		1
#define SPC_DBL		2
#define SPC_REAL	3

#define SPC_FMTLEN		 64

typedef struct {
  int typ;
  int shm;
  DVecRec b;
} SpcBuf_t;

#define SpcBufTyp(sbp)		((sbp)->typ)
#define SpcBufShm(sbp)		((sbp)->shm)
#define SpcBufB(sbp)		(&(sbp)->b)
#define SpcBufSiz(sbp)		VecSiz(SpcBufB(sbp))
#define SpcBufNum(sbp)		VecNum(SpcBufB(sbp))
#define SpcBufReal(sbp)		((SpcReal_t *)VecP(SpcBufB(sbp)))
#define SpcBufDbl(sbp)		((double *)VecP(SpcBufB(sbp)))
#define SpcBufFlt(sbp)		((float *)VecP(SpcBufB(sbp)))
#define SpcBufInt(sbp)		((int *)VecP(SpcBufB(sbp)))

typedef struct _SpcRec {
  int typ;
  char *file;
  char format[SPC_FMTLEN];
  SpcBuf_t spc;
  SpcBuf_t dSpc;
} SpcRec;

#define SpcTyp(sp)		((sp)->typ)
#define SpcFile(sp)		((sp)->file)
#define SpcFormat(sp)		((sp)->format)
#define SpcSpc(sp)		(&(sp)->spc)
#define SpcDSpc(sp)		(&(sp)->dSpc)
#define SpcNum(sp)		(SpcBufNum(SpcSpc(sp)))
#define SpcDNum(sp)		(SpcBufNum(SpcDSpc(sp)))

typedef struct _SpcFileRec {
  MFILE *mfp;
  char mode[8];
  minfo info;
  char format[SPC_FMTLEN];
} SpcFileRec;

#define SpcFileMfp(p)		((p)->mfp)
#define SpcFileMode(p)		((p)->mode)
#define SpcFileInfo(p)		(&(p)->info)
#define SpcFileFormat(p)	((p)->format)

#define SpcFileColumns(p)	(SpcFileInfo(p)->columns)
#define SpcFileLevels(p)	(SpcFileInfo(p)->levels)
#define SpcFileLines(p)		(SpcFileInfo(p)->lines)
#define SpcFileName(p)		(SpcFileInfo(p)->name)
#define SpcFileFiletype(p)	(SpcFileInfo(p)->filetype)

#define SPCNOERR	 0 /* vsSpectra: no error */
#define SPCPOINT	 1 /* vsSpectra: illegal NULL-pointer */
#define SPCOPEN		 2 /* vsSpectra: could not open spectrafile */
#define SPCGTINF	 3 /* vsSpectra: could not get mfile info */
#define SPCINVAL	 4 /* vsSpectra: unknown or invalid filetype */
#define SPCSTFMT	 5 /* vsSpectra: could not set mfile info */
#define SPCSTINF	 6 /* vsSpectra: could not set mfile info */
#define SPCMRES		 7 /* vsSpectra: maximal resolution exceeded */
#define SPCWRITE	 8 /* vsSpectra: could not write SPCibrationfile */
#define SPCLEV		 9 /* vsSpectra: illegal level specified */
#define SPC0READ	10 /* vsSpectra: nothing read from file */
#define SPCTYP		11 /* vsSpectra: spectrum type not implemented */
#define SPCILRES	12 /* vsSpectra: illegal resolution specified */
#define SPCFIXED	13 /* vsSpectra: fixed buffer can not be freed */
#define SPCDRES		14 /* vsSpectra: different resolutions */
#define SPCDTYP		15 /* vsSpectra: different buffer types */
#define SPCWRTLV	16 /* vsSpectra: can not write specified level */
#define SPCALLOC	17 /* "vsSpectra: can not allocate tmp-buffer" */
#define SPCLIN		18 /* "vsSpectra: illegal line specified" */
#define SPCTYPSIZ	19 /* "vsSpectra: internal error: incompatible size of SpcReal_t" */
#define SPCNOFIL	20 /* "vsSpectra: internal error: no MFILE open" */
#define SPCSHMALC	21 /* "vsSpectra: shared memory allocation error", */

#define SpcsetErrNo(n)		{ SpcErrNo= n; }

#ifdef _vsSpectra_c
int SpcErrNo = SPCNOERR;
#else
extern int SpcErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsSpectraF.h>

#undef P_

#endif				/* _vsSpectra_h */
