/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsTools.c,v 1.2 1994/05/26 19:50:34 vs Exp vs $ */
#define _vsTools_c

#include "vsTypes.h"
#include "vsAlloc.h"
#include "vsTools.h"
#include "vsToolsP.h"

#define TLSMAXBUFLEN		1024

/* ====================================================================== */
char *TlsError(err_no)
     int err_no;
{
  static char *errors[] = {
  /* TLSNOERR */ "vsTools: no error",
  /* TLSPOINT */ "vsTools: illegal NULL-pointer",
  /* TLSALLOC */ "vsTools: can not allocate array",
  /* TLSFIXED */ "vsTools: can not change fixed array",
  /* TLSBUF   */ "vsTools: illegal buffer specification",
  /* TLSWRITE */ "vsTools: can not write file",
  /* TLSREAD  */ "vsTools: can not read file",
  /* TLSOPEN  */ "vsTools: can not open file",
  /* default  */ "vsTools: undefined error code", };

  if (err_no < sizeof(errors)) { return errors[err_no]; }
  else { return errors[sizeof(errors)-1]; }
}
/* ====================================================================== */
				/* polynom value by horner */

double TlsHorner(pol, polNum, x)
     double *pol;
     int polNum;
     double x;
{
  double sum = 0.0;
  int i;
  for (i = --polNum; i >= 0; i--) { sum = sum * x + pol[i]; }
  return sum;
}
/* ====================================================================== */
				/* vector operations */

int TlsVecFRead(fp, title, vp, bufferScan)
     FILE *fp;
     char *title;
     Vec_t vp;
     pfi_t bufferScan;
{
  char buffer[TLSMAXBUFLEN];
  long lastLine;
  int titleSearch= (title && *title);
  int titleFound= !titleSearch;

  /*  printf("TlsVecFRead\n");*/

  VecNum(vp)= 0;
  /* So wie ich (OS) das verstehe , passiert hier folgendes: 
     Suche nach dem Titel (z.B. fit-bg-marker)
     Wenn er drin steht, dann stell den filepointer dahinter
     Wenn nicht, dann zurueck zum Anfang
     danach marker einlesen

     Titel nuetzt wohl, wenn mehrere marker typen in einem file versammelt sind
*/
  if (strcmp (title,"")){	/* gibt's ueberhaupt was zu suchen (z.B. RecRead liefert hier n "" an ... */

    /* find title */
    while (fgets(buffer, TLSMAXBUFLEN, fp) && !titleFound) {
      /*      printf("Scanning %s\n", buffer);*/
      if (*buffer == '#' && buffer[1] == '\n') {
	continue;
      }
      else if (*buffer == '\n') {
	continue;
      }
      else if (*buffer == '#' && !titleFound) {
	buffer[strlen(buffer)-1]= '\0';
	if (titleSearch && !strcmp(buffer+1, title)) {
	  /*	  printf("Found title %s\n", buffer+1);*/
	  titleFound= TRUE;
	  break;
	}
      }
    }
    
    lastLine= ftell(fp);
    
    if (!titleFound && lastLine) { /* scan file from beginning */
      /*      printf("rewinding\n");*/
      rewind(fp);
    }

  }

/* while schleife war vor OS eine do while schleife */
  while (fgets(buffer, TLSMAXBUFLEN, fp)){
    char* p = buffer;
    /*    printf("Scanning %s\n", p);*/
    while (*p == ' ') {
      p++; /* remove leading blanks */
    }
    if (*p == '#') {
      fseek(fp, lastLine, SEEK_SET);
      /*      printf("New category\n");*/
      /*      return TRUE;*/
      break;
    }
    else if (*p == '\n') {
      continue;
    }
    else if (!VecRealloc(vp, VecNum(vp)+1)) {
      TlssetErrNo(TLSALLOC);
      return FALSE;
    }
    else if (!bufferScan(p, VecP(vp), VecNum(vp))) {
      TlssetErrNo(TLSREAD);
      return FALSE;
    }
    else {
      VecNum(vp)++;
      lastLine= ftell(fp);
    }
  }
  return TRUE;
}
/* ------------------------------------------------------------------------- */
int TlsVecFWrite(fp, title, vp, fpPrint)
     FILE *fp;
     char *title;
     Vec_t vp;
     pfi_t fpPrint;
{
  if (title && *title && fprintf(fp, "#%s\n", title) == EOF) {
    TlssetErrNo(TLSWRITE);
    return FALSE;
  }
  else {
    int i;
    for (i = 0; i < VecNum(vp); i++) {
      if (!fpPrint(fp, VecP(vp), i)) {
	TlssetErrNo(TLSWRITE);
	return FALSE;
      }
    }
    return TRUE
      ; }
}
/* ------------------------------------------------------------------------- */
int TlsVecRead(file, title, vp, bufferScan)
     char *file;
     char *title;
     Vec_t vp;
     pfi_t bufferScan;
{
  FILE *fp;

  VecNum(vp)= 0;
  if ((fp= fopen(file, "r"))) {
    int local_stat= TlsVecFRead(fp, title, vp, bufferScan);
    fclose(fp);
    return local_stat; }
  else { TlssetErrNo(TLSOPEN); return FALSE; }
}
/* ------------------------------------------------------------------------- */
int TlsVecWrite(file, mode, title, vp, fpPrint)
     char *file;
     char *mode;
     char *title;
     Vec_t vp;
     pfi_t fpPrint;
{
  FILE *fp;
  if ((fp = fopen(file, mode))) {
    if (!TlsVecFWrite(fp, title, vp, fpPrint)) { return FALSE; }
    else if (fclose(fp) == EOF) { TlssetErrNo(TLSWRITE); return FALSE; }
    else { return TRUE; } }
  else { TlssetErrNo(TLSOPEN); return FALSE; }
}
/* ------------------------------------------------------------------------- */
int TlsPrintDVec(fp, dp, idx)
     FILE *fp;
     double *dp;
     int idx;
{
  return (fprintf(fp, "%f\n", dp[idx]) != EOF);
}
/* ------------------------------------------------------------------------- */
int TlsScanDVec(buffer, dp, idx)
     char *buffer;
     double *dp;
     int idx;
{
  return (sscanf(buffer, "%lfg", dp + idx) == 1);
}
/* ------------------------------------------------------------------------- */
int TlsPrintPVec(fp, pp, idx)
     FILE *fp;
     Pair_t *pp;
     int idx;
{
  return (fprintf(fp, "%f %f\n", PairX1(pp + idx), PairX2(pp + idx)) != EOF);
}
/* ------------------------------------------------------------------------- */
int TlsScanPVec(buffer, pp, idx)
     char *buffer;
     Pair_t *pp;
     int idx;
{
  return (sscanf(buffer, "%lf%lf",
		 &PairX1(pp + idx), &PairX2(pp + idx)) == 2);
}
/* ------------------------------------------------------------------------- */
int TlsVecAlloc(vp, siz)
     Vec_t vp;
     int siz;
{
  if (vp == NULL) { TlsErrNo = TLSPOINT; return FALSE; }
  else if (siz * VecTypSiz(vp) <= VecSiz(vp)) { ; }
  else if (VecFixed(vp)) {
    TlssetErrNo(TLSFIXED); return FALSE; }
  else {
    double *dp;
    if (NULL == (dp= (double *)Malloc((size_t)(siz * VecTypSiz(vp))))) {
      TlsErrNo = TLSALLOC; return FALSE; }
    else { Free(VecP(vp)); VecP(vp) = dp; VecSiz(vp) = siz * VecTypSiz(vp); } }
  VecReset(vp);
  return TRUE; 
}
/* ---------------------------------------------------------------------- */
int TlsVecClear(vp)
     Vec_t vp;
{
  if (vp == NULL) { TlsErrNo = TLSPOINT; return FALSE; }
  else if (VecSiz(vp) > 0) {
    memset((void *)VecP(vp), 0, (size_t)VecSiz(vp)); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int TlsVecCmp(t, f)
     Vec_t t;
     Vec_t f;
{
  if (t == NULL || f == NULL) { TlssetErrNo(TLSPOINT); return -1; }
  else {
    int st= VecTypSiz(t) * VecNum(t);
    int sf= VecTypSiz(f) * VecNum(f);
    if (st != sf) { return (st - sf); }
    else { return memcmp((void *)VecP(t), (void *)VecP(f), (size_t)st); } }
}
/* ---------------------------------------------------------------------- */
int TlsVecCopy(t, f)
     Vec_t t;
     Vec_t f;
{
  if (t == NULL || f  == NULL) { TlssetErrNo(TLSPOINT); return FALSE; }
  else {
    VecReset(t);
    VecTypSiz(t)= VecTypSiz(f);
    if (!VecAlloc(t, VecNum(f))) { return FALSE; }
    else {
      memcpy((void *)VecP(t), (void *)VecP(f),
	     (size_t)(VecNum(f) * VecTypSiz(f)));
      VecNum(t)= VecNum(f);
      return TRUE; } }
}
/* ---------------------------------------------------------------------- */
int TlsVecDelete(vp, idx, num)
     Vec_t vp;
     int idx;
     int num;
{
  if (vp == NULL) { TlssetErrNo(TLSPOINT); return FALSE; }
  else if (idx > VecNum(vp)-1) { return TRUE; }

  if (idx < VecNum(vp)-num) {
    char *p= (char *)VecP(vp);
    memmove((void *)(p + idx * VecTypSiz(vp)),
	    (void *)(p + (idx + num) * VecTypSiz(vp)),
	    (size_t)((VecNum(vp) - idx - num) * VecTypSiz(vp)));
    VecNum(vp) -= num; }
  else { VecNum(vp)= MAX(0, idx); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int TlsVecFree(vp)
     Vec_t vp;
{
  if (vp == NULL) { TlssetErrNo(TLSPOINT); return FALSE; }
  else if (VecFixed(vp)) {
    TlssetErrNo(TLSFIXED); return FALSE; }
  else {
    Free(VecP(vp));
    VecSiz(vp)= 0;
    VecReset(vp);
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int TlsVecInit(vp, typSiz)
     Vec_t vp;
     int typSiz;
{
  if (vp == NULL) { TlssetErrNo(TLSPOINT); return FALSE; }
  else {
    VecP(vp)= NULL;
    VecFixed(vp)= FALSE;
    VecTypSiz(vp)= typSiz;
    VecSiz(vp)= 0;
    VecReset(vp);
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int TlsVecInsert(vp, idx, num)
     Vec_t vp;
     int idx;
     int num;
{
  if (!VecRealloc(vp, MAX(VecNum(vp), idx) + num)) { return FALSE; }
  else if (idx >= VecNum(vp)) { VecNum(vp)= idx + num; }
  else {
    char *p= (char *)VecP(vp);
    memmove((void *)(p + (idx + num) * VecTypSiz(vp)),
	    (void *)(p + idx * VecTypSiz(vp)),
	    (size_t)((VecNum(vp) - idx) * VecTypSiz(vp)));
    VecNum(vp) += num; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int TlsVecRealloc(vp, siz)
     Vec_t vp;
     int siz;
{
  if (vp == NULL) {
    TlssetErrNo(TLSPOINT);
    return FALSE;
  }
  else if (siz * VecTypSiz(vp) <= VecSiz(vp)) {
    return TRUE;
  }
  else if (VecFixed(vp)) {
    TlssetErrNo(TLSFIXED);
    return FALSE;
  }
  else {
    double *dp;
    if (NULL ==
	(dp= (double *)Realloc(VecP(vp), (size_t)(siz * VecTypSiz(vp))))) {
      TlssetErrNo(TLSALLOC);
      return FALSE;
    }
    else {
      VecP(vp) = dp;
      VecSiz(vp) = siz * VecTypSiz(vp);
      return TRUE;
    }
  }
}
/* ---------------------------------------------------------------------- */
int TlsVecReset(vp)
     Vec_t vp;
{
  if (vp == NULL) { TlssetErrNo(TLSPOINT); return FALSE; }
  else { VecNum(vp)= 0; return TRUE; }
}
/* ---------------------------------------------------------------------- */
int TlsVecSet(vp, buf, typSiz, siz, num)
     Vec_t vp;
     void *buf;
     int typSiz;
     int siz;
     int num;
{
  if (vp == NULL) { TlssetErrNo(TLSPOINT); return FALSE; }
  else if (siz < 0 || buf == NULL) {
    TlssetErrNo(TLSBUF); return FALSE; }
  else {
    VecP(vp) = buf;
    VecNum(vp) = num;
    VecTypSiz(vp) = typSiz;
    VecSiz(vp) = siz;
    VecFixed(vp)= TRUE;
    return TRUE; }
}

/* ====================================================================== */
