/* $Header: /usr/files/home/Gamma/vs/tv/edit/tv/RCS/vsTools.h,v 1.1 1993/09/17 14:55:08 vs Exp vs $ */
#ifndef _vsTools_h
#define _vsTools_h

#include <tv/vsConfig.h>
#include <tv/vsTypes.h>

#define VecFRead(fp,title,pp,scan) \
  TlsVecFRead(fp, title, (Vec_t)pp, scan)
#define VecFWrite(fp,title,pp,print) \
  TlsVecFWrite(fp, title, (Vec_t)pp, print)
#define VecRead(f,title,pp,scan) \
  TlsVecRead(f, title, (Vec_t)pp, scan)
#define VecWrite(f,m,title,pp,print) \
  TlsVecWrite(f, m, title, (Vec_t)pp, print)
#define Horner(pol,polNum,x)	TlsHorner(pol,polNum,x)
#define VecAlloc(vp,siz)	TlsVecAlloc((Vec_t)(vp), siz)
#define VecClear(vp)		TlsVecClear((Vec_t)(vp))
#define VecCmp(t,f)		TlsVecCmp((Vec_t)(t), (Vec_t)(f))
#define VecCopy(t,f)		TlsVecCopy((Vec_t)(t), (Vec_t)(f))
#define VecDelete(vp,idx,num)	TlsVecDelete((Vec_t)(vp), idx, num)
#define VecFree(vp)		TlsVecFree((Vec_t)(vp))
#define VecInit(vp,typSiz)	TlsVecInit((Vec_t)(vp), typSiz)
#define VecInsert(vp,idx,num)	TlsVecInsert((Vec_t)(vp), idx, num)
#define VecReset(vp)		TlsVecReset((Vec_t)(vp))
#define VecRealloc(vp,siz)	TlsVecRealloc((Vec_t)(vp), siz)
#define VecSet(vp,buf,typSiz,siz,num) \
	TlsVecSet((Vec_t)(vp), (void *)buf, typSiz, siz, num)

				/* standard setup for fixed vectors */

#define VecSETUP(s,p)	{{ TRUE, sizeof(s), sizeof(p), sizeof(p)/sizeof(s)}, p}
#define VecINIT(s)	{ { FALSE, sizeof(s), 0, 0 }, NULL }

#define TLSNOERR	0 /* "vsTools: no error" */
#define TLSPOINT	1 /* "vsTools: illegal NULL-pointer" */
#define TLSALLOC	2 /* "vsTools: can not allocate array" */
#define TLSFIXED	3 /* "vsTools: can not change fixed array" */
#define TLSBUF		4 /* "vsTools: illegal buffer specification" */
#define TLSWRITE	5 /* "vsTools: can not write file" */
#define TLSREAD		6 /* "vsTools: can not read file" */
#define TLSOPEN		7 /* "vsTools: can not open file" */

#define TlssetErrNo(n)		{ TlsErrNo= n; }

#ifdef _vsTools_c
int TlsErrNo= TLSNOERR;
#else
extern int TlsErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsToolsF.h>

#undef P_

#endif				/* _vsTools_h */
