/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsTypes.h,v 1.3 1994/12/02 21:23:23 vs Exp vs $ */
#ifndef _vsTypes_h
#define _vsTypes_h

#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <stdio.h>
/*#include <unistd.h>*/
#include <math.h>
/*#include <limits.h> use ??? (os@ikp) */
#include <sys/types.h>
#include <sys/param.h>

#include <tv/vsConfig.h>

#ifndef TRUE
# define TRUE	1
# define FALSE	0
#endif

#ifndef NULL
# define NULL	0
#endif

#define IOBUFLEN		2048

#ifndef ABS
# define ABS(x)			(((x) < 0) ? -(x) : (x))
#endif
#ifndef MIN
# define MIN(x,y)		(((x) < (y)) ? (x) : (y))
#endif
#ifndef MAX
# define MAX(x,y)		(((x) > (y)) ? (x) : (y))
#endif
#ifndef NINT
# define NINT(x)		((int)((x < 0.) ? (x - .5) : (x + .5)))
#endif

typedef int (*pfi_t)();
typedef void (*pfv_t)();
typedef double (*pfd_t)();

/* ====================================================================== */
/* types which are used in tv library modules */
/* ====================================================================== */

typedef struct {
  double value;
  int defined;
} ValRec, *Val_t;

#define ValDefined(m)		((m)->defined)
#define ValValue(m)		((m)->value)

typedef struct {		/* pair of doubles */
  double x1;			/* [x1,x2] */
  double x2;
} Pair_t;

#define PairX1(p)	((p)->x1)
#define PairX2(p)	((p)->x2)

typedef struct {		/* quadruplet of doubles */
  double x1;			/* [x1,x2] */
  double x2;
  double y1;			/* [y1,y2] */
  double y2;
} Quad_t;

#define QuadX1(p)	((p)->x1)
#define QuadX2(p)	((p)->x2)
#define QuadY1(p)	((p)->y1)
#define QuadY2(p)	((p)->y2)

typedef struct _VecCorePart {
  int fixed;			/* not allocated by vsTools, TRUE => const (no free, realloc ...) */
  int typSiz;			/* sizeof(typ) */
  int siz;			/* allocated number of elements (0 if fixed) */
  int num;			/* number of used elements */
} VecCorePart;  

typedef struct _VecRec {	/* vector of anything */
  VecCorePart	core;
  void		*p;
} VecRec, *Vec_t;

typedef struct _DVecRec {	/* vector of double's */
  VecCorePart	core;
  double	*p;
} DVecRec, *DVec_t;

typedef struct _IVecRec {	/* vector of int's */
  VecCorePart	core;
  int		*p;
} IVecRec, *IVec_t;

typedef struct _FVecRec {	/* vector of float's */
  VecCorePart	core;
  float		*p;
} FVecRec, *FVec_t;

typedef struct {		/* vector of Pair_t's */
  VecCorePart	core;
  Pair_t	*p;
} PVecRec, *PVec_t;

typedef struct {		/* vector of Quad_t's */
  VecCorePart	core;
  Quad_t	*p;
} QVecRec, *QVec_t;

/* access macros for all *Vec_t */

#define VecFixed(vp)		((vp)->core.fixed)
#define VecTypSiz(vp)		((vp)->core.typSiz)
#define VecSiz(vp)		((vp)->core.siz)
#define VecNum(vp)		((vp)->core.num)
#define VecP(vp)		((vp)->p)

#define PVecX1(vp,i)		PairX1(VecP(vp)+i)
#define PVecX2(vp,i)		PairX2(VecP(vp)+i)

#define NPVecX1(vp,i)		NINT(PVecX1(vp,i))
#define NPVecX2(vp,i)		NINT(PVecX2(vp,i))

#define QVecX1(vp,i)		QuadX1(VecP(vp)+i)
#define QVecX2(vp,i)		QuadX2(VecP(vp)+i)
#define QVecY1(vp,i)		QuadY1(VecP(vp)+i)
#define QVecY2(vp,i)		QuadY2(VecP(vp)+i)

/* ====================================================================== */
				/* vsCal.h */

typedef struct _CalRec		*Cal_t;

/* ====================================================================== */
				/* vsPar.h */

typedef struct _ParRec		*Par_t;

/* ====================================================================== */
				/* vsCurFit.h */

typedef struct _CurRec		*Cur_t;

/* ====================================================================== */
				/* vsKey.h */

typedef struct _KeytableRec		*Keytable_t;

/* ====================================================================== */
				/* vsRecal.h */

typedef struct _RclRec		*Rcl_t;

/* ====================================================================== */
				/* vsFit.h */

typedef struct _FitRec		*Fit_t;
typedef struct _FitOptRec	*FitOpt;

/* ====================================================================== */
				/* vsRecord.h */

typedef struct _RecRec		*Rec_t;
typedef struct _RFILERec	RFILE;

/* ====================================================================== */
				/* vsFitIo.h */

typedef struct _FioRec		*Fio_t;

/* ====================================================================== */
				/* vsSearch.h */

typedef struct _SeaPeakRec	*SeaPeak;

/* ====================================================================== */
				/* vsSpectra.h */

typedef double			SpcReal_t;
typedef struct _SpcRec		*Spc_t;
typedef struct _SpcFileRec	*SpcFile_t;

/* ====================================================================== */
				/* vsCut.h */

typedef struct _CDIRRec		CDIR;
typedef struct _CutRec		*Cut_t;

/* ====================================================================== */
				/* vsUserFace.h */

typedef struct Men_t_		Men_t;
typedef struct UF_t_		UF_t;

/* ====================================================================== */

#endif				/* _vsTypes_h */
