#include <errno.h>
#include <limits.h>
#include <fcntl.h>
/* --- TCP includes --- */
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#if 0
/* --- UDP (via sysdep (c) by IKP) includes --- */
#if defined(__STDC__)
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#error Adjust this includes and add check for them(VsNet.c)
#include <local/sysdep/types.h>
#include <local/sysdep/error.h>
#include <local/sysdep/connection.h>
#include <local/sysdep/transerr.h>
#endif /* 0 */

/*
 prompt
 locked read ?
 root + rootprompt?
 locked prompt ?
 operating bei verschiedenen Zeilenende/loop/single ...
 VsFace
 */

/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsUserFace.c,v 1.5 1994/12/08 20:44:38 vs Exp vs $ */

#define _vsUserFace_c


				/* ==================== */
				/* system include files */
				/* ==================== */

				/* ======================== */
				/* vs library include files */
				/* ======================== */
#include "vsAlloc.h"
#include "vsTypes.h"

#include "vsPath.h"
#include "vsTools.h"
#include "vsUserFace.h"
#include "vsUserFaceP.h"
				/* =============== */
				/* macro functions */
				/* =============== */

#define UFisSign(c)		((c) == '+' || (c) == '-')
#define UFisOctDigit(c)		((c) >= '0' && (c) <= '7')
#define UFisDecDigit(c)		((c) >= '0' && (c) <= '9')
#define UFisHexDigit(c)		(UFisDecDigit(c) || \
				 ((c) >= 'a' && (c) <= 'f') || \
				 ((c) >= 'A' && (c) <= 'F'))
#define UFgetDigit(c)		(((c)>= 'a' && (c)<= 'f')?(10 + (c) - 'a') : \
				 (((c)>= 'A' && (c)<= 'F')?(10 + (c) - 'A') : \
				  ((c) - '0')))
#define UFappendDigit(n,b,c)	((n) = (n) * (b) + UFgetDigit(c))
#define UFappendFraction(n,p,c)	((n) = (n) + (p) * UFgetDigit(c))

#define UFBufferClear(up,b)	{ *UFBufferB(up,b)= '\0'; \
				    UFBufferP(up,b)= UFBufferB(up,b); \
				      UFBufferA(up,b)= NULL; }

#define UFshiftBufferEnd(b,bl)	{(bl) -=strlen(b);(b) +=strlen(b);*(b)= '\0';}
#define UFappendBuffer(b,bl,c)	{ if ((bl) >= 1){ *(b)++ = (c); if (c) { bl--; *(b) = '\0'; } } }

#define UFstopTyp(up,c)		(((c) == '\0') ? UFSSTRINGEND : \
				 (strchr(UFQueueBreak(up), c) ? UFSQBREAK : \
				  (strchr(UFWhiteSpace(up), c) ? \
				   UFSWHITESPACE : \
				   UFSUNEXPECTED)))

#define UFoverflow(up,f)	{ UFPrintE(up, "%s-error: fatal internal buffer overflow\n", f); UFReset(up); UFsetErrNo(UFBUFEXC); }

				/* ======================================== */
				/* static and external function definitions */
				/* alphabetically ordered */
				/* ====================== */

/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS4 */
int UFIntRead(UF_t *up, int unexpected, int *number, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UFIntRead(va_alist)
     /* UF_t *up, int unexpected, int *number, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { UF_t *up= va_arg(ap, UF_t *);
    int unexpected= va_arg(ap, int);
    int *number= va_arg(ap, int *);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFIntReadV(up, unexpected, number, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
int UFIntReadV(up, unexpected, number, fmt, ap)
     UF_t *up;
     int unexpected;
     int *number;
     char *fmt;
     va_list ap;
{
  int uStat;
  char buffer[UFMAXBUFLEN];

  do {
    UFSkipTo(up, UFQueueBreak(up));
    uStat= UFLockedReadV(up, fmt, ap);

    if (UFQuestionSkip(up)) {
      UFPrintM(up, "expecting integer number:\n");
      UFPrintM(up, "  hexadecimal (base 16): 0x...\n");
      UFPrintM(up, "  octal (base 8): 0...\n");
      UFPrintM(up, "  else decimal (base 10)\n");
      if (unexpected) {
      UFPrintM(up, "  conversion stopped by any unexpected character\n"); }
      UFPrintM(up, "  white space:   \"%s\"\n",
	       UFItemSPrint(UFWhiteSpace(up), buffer, UFMAXBUFLEN, '"'));
      UFPrintM(up, "  break:        \"%s\"\n",
	       UFItemSPrint(UFQueueBreak(up), buffer, UFMAXBUFLEN, '"')); }
    else if (uStat == UFUTEXT) {
      return UFIntGet(up, &UFBufferP(up,UFBufIdx(up)), unexpected, number); }
    else { return FALSE; }
  } while (TRUE);
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS4 */
int UFItemRead(UF_t *up, char *buffer, int bufLen, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UFItemRead(va_alist)
     /* UF_t *up, char *buffer, int bufLen, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { UF_t *up= va_arg(ap, UF_t *);
    char *buffer= va_arg(ap, char *);
    int bufLen= va_arg(ap, int);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFItemReadV(up, buffer, bufLen, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
static int UFItemReadP(up, buffer, bufLen, opening, closing, fmt, ap)
     UF_t *up;
     char *buffer;
     int bufLen;
     char opening;
     char closing;
     char *fmt;
     va_list ap;
{
  char *b= buffer;
  int bl= bufLen;
  int i;
  char *q;

  while ((i= UFBufIdx(up)) >= 0) {
    char *p= UFBufferP(up,i);
    while (*p && bl > 1 && *p != closing) {
      if (*p == opening) {	/* copy inner parentheses */
	UFappendBuffer(b,bl,opening);
	if (!UFItemReadP(up, b, bl, opening, closing, fmt, ap)) {
	  return FALSE; }
	else {
	  UFshiftBufferEnd(b,bl);
	  UFappendBuffer(b,bl,closing); } }
      else if ((q= strchr(UFQuotes(up), *p))) { /* copy quoted items */
	UFappendBuffer(b,bl,*q);
	if (!UFItemReadQ(up, b, bl, *q, fmt, ap)) {
	  return FALSE; }
	else {
	  UFshiftBufferEnd(b,bl);
	  UFappendBuffer(b,bl,*q); } }
      else if (UFstopTyp(up,*p) != UFSUNEXPECTED) {
	UFappendBuffer(b,bl,*p); p++; }	/* copy whitespace etc. */
      else if (!UFItemCopy(up, &p, b, bl)) { /* copy other items */
	return FALSE; }
      else { UFshiftBufferEnd(b,bl); } }

    if (bl <= 1) {
      UFoverflow(up,"UFItemReadParenthized"); return FALSE; }
    else if (*p == closing) {
      UFBufferP(up,UFBufIdx(up))= ++p; /* skip parenthesis */
      *b= '\0'; return TRUE; }
    else {			/* *p == '\0' */
      if (UFLockedReadV(up, fmt, ap) != UFUTEXT) { break; } } }
  if (i < 0) { UFsetErrNo(UFNOBUF); } /* no closing parenthesis found */
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int UFItemReadQ(up, buffer, bufLen, quote, fmt, ap)
     UF_t *up;
     char *buffer;
     int bufLen;
     char quote;
     char *fmt;
     va_list ap;
{
  char *b= buffer;
  int bl= bufLen;
  int i;

  while ((i= UFBufIdx(up)) >= 0) {
    char *p= UFBufferP(up,i);
    while (*p && bl > 1 && UFUnquoteChar(&p, &b, &bl, quote)) { ; }

    if (bl <= 1) {
      UFoverflow(up,"UFItemReadQuoted"); return FALSE; }
    else if (*p == quote) {
      UFBufferP(up,UFBufIdx(up))= ++p; /* skip quote */
      *b= '\0'; return TRUE; }
    else {			/* *p == '\0' */
      int status;
      UFBufferP(up,UFBufIdx(up))= p; /* already read */
      status= UFLockedReadV(up, fmt, ap);
      if (status != UFUTEXT) { break; } } }
  if (i < 0) { UFsetErrNo(UFNOBUF); }
  return FALSE;			/* quote not found */
}
/* ---------------------------------------------------------------------- */
int UFItemReadV(up, buffer, bufLen, fmt, ap)
     UF_t *up;
     char *buffer;
     int bufLen;
     char *fmt;
     va_list ap;
{
  /*  printf("UFItemReadV\n");*/
  if (!buffer) {
    UFsetErrNo(UFPOINT); UFItemTyp(up)= UFIERROR; return FALSE; }
  else if (bufLen <= 0) {
    UFsetErrNo(UFBUFEXC); UFItemTyp(up)= UFIERROR; return FALSE; }
  else {
    int status= FALSE;
    int uStat;
    int q, o, c;
    char s[UFMAXBUFLEN];

    do {
      UFSkipTo(up, UFQueueBreak(up));
      uStat= UFLockedReadV(up, fmt, ap);

      if (UFQuestionSkip(up)) {
	UFPrintM(up, "expecting text item:\n");
	UFPrintM(up, "  quoted:        \"%s\"\n",
		 UFItemSPrint(UFQuotes(up), s, UFMAXBUFLEN, '"'));
	UFPrintM(up, "  parenthesized: \"%s\" ",
		 UFItemSPrint(UFOParentheses(up), s, UFMAXBUFLEN, '"'));
	UFPrintM(up,		     "\"%s\"\n",
		 UFItemSPrint(UFCParentheses(up), s, UFMAXBUFLEN, '"'));
	UFPrintM(up, "  white space:   \"%s\"\n",
		 UFItemSPrint(UFWhiteSpace(up), s, UFMAXBUFLEN, '"'));
	UFPrintM(up, "  break:        \"%s\"\n",
		 UFItemSPrint(UFQueueBreak(up), s, UFMAXBUFLEN, '"')); }
      else {
	switch (uStat) {
	case UFUTEXT:
	  if ((q= UFSkipTo(up, UFQuotes(up)))) {
	    status= UFItemReadQ(up, buffer, bufLen, q, fmt, ap);
	    UFItemTyp(up)= UFIQUOTES;
	    UFQuote(up)= q; }
	  else if ((o= UFSkipTo(up, UFOParentheses(up)))) {
	    char *op= strchr(UFOParentheses(up), o);
	    c= UFCParentheses(up)[op - UFOParentheses(up)];
	    status= UFItemReadP(up, buffer, bufLen, o, c, fmt, ap);
	    UFItemTyp(up)= UFIPARENTHESES;
	    UFOParenthesis(up)= o;
	    UFCParenthesis(up)= c; }
	  else {
	    status= UFItemCopy(up, &UFBufferP(up,UFBufIdx(up)),
			       buffer, bufLen);
	    UFItemTyp(up)= UFITEXT; }
	  break;
	case UFUERROR:
	  UFItemTyp(up)= UFIERROR;
	  break;
	default:
	  UFItemTyp(up)= UFINONE; }

	return status; }
    } while (TRUE); }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS2 */
static int UFLockedRead(UF_t *up, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
static int UFLockedRead(va_alist)
     /* UF_t *up, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { UF_t *up= va_arg(ap, UF_t *);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFLockedReadV(up, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
static int UFLockedReadV(up, fmt, ap)
     UF_t *up;
     char *fmt;
     va_list ap;
{
  int status= FALSE;
  char pmt[UFMAXBUFLEN];

  /*  printf("UFLockedReadV\n");*/
  UFPrintVarArgs(pmt, UFMAXBUFLEN, fmt, ap, status);
  if (status) {
    while (UFUpdateBuffer(up) == UFUREQINP && UFInputLoop(up)) {
      UFMenLocked(up)	= MenStatInFunction(UFMenu(up,UFMenIdx(up)));
      UFLockedPrompt(up)= (fmt ? pmt : NULL);
      UFInputLoop(up)(up);
    }
    UFMenLocked(up)	= FALSE;
    UFLockedPrompt(up)	= NULL;
  }

  return UFUpdateStat(up);
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS2 */
int UFPrintE(UF_t *up, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UFPrintE(va_alist)
     /* UF_t *up, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { UF_t *up= va_arg(ap, UF_t *);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFPrintEV(up, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
int UFPrintEV(up, fmt, ap)
     UF_t *up;
     char *fmt;
     va_list ap;
{
  char line[UFMAXBUFLEN];
  int status= TRUE;

  UFPrintVarArgs(line, UFMAXBUFLEN, fmt, ap, status);
  if (UFOutFile(up)) { fputs(line, UFOutFile(up)); fflush(UFOutFile(up)); }
  if (UFStdErr(up)) { fputs(line, UFStdErr(up)); }

  if (UFPrint(up)) { return UFPrint(up) (UFPrintStdErr(up), line); }
  else { return UFTermPrint(up, stderr, FALSE, line); }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS2 */
int UFPrintM(UF_t *up, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UFPrintM(va_alist)
     /* UF_t *up, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { UF_t *up= va_arg(ap, UF_t *);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFPrintMV(up, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
int UFPrintMV(up, fmt, ap)
     UF_t *up;
     char *fmt;
     va_list ap;
{
  char line[UFMAXBUFLEN];
  int status= TRUE;

  UFPrintVarArgs(line, UFMAXBUFLEN, fmt, ap, status);
  if (UFOutFile(up)) { fputs(line, UFOutFile(up)); }
  if (UFStdOut(up)) { fputs(line, UFStdOut(up)); }

  if (UFSockOut(up)) { UFSockOut(up) (line); }

  if (UFPrint(up)) { return UFPrint(up) (UFPrintStdOut(up), line); }
  else { return UFTermPrint(up, stdout, FALSE, line); }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS2 */
int UFPrintP(UF_t *up, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UFPrintP(va_alist)
     /* UF_t *up, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { UF_t *up= va_arg(ap, UF_t *);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFPrintPV(up, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
int UFPrintPV(up, fmt, ap)
     UF_t *up;
     char *fmt;
     va_list ap;
{
  char line[UFMAXBUFLEN];
  int status= TRUE;

  UFPrintVarArgs(line, UFMAXBUFLEN, fmt, ap, status);
  if (UFOutFile(up)) { fputs(line, UFOutFile(up)); }
  if (UFStdOut(up)) { fputs(line, UFStdOut(up)); }

  if (UFPrintPaged(up)) { return UFPrintPaged(up) (UFPrintStdOut(up), line); }
  else { return UFTermPrint(up, stdout, FALSE, line); }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS5 */
int UFRealRead(UF_t *up, int unexpected, 
	       double *number, double *precision, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UFRealRead(va_alist)
     /* UF_t *up, int unexpected, 
	double *number, double *precision, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { UF_t *up= va_arg(ap, UF_t *);
    int unexpected= va_arg(ap, int);
    double *number= va_arg(ap, double *);
    double *precision= va_arg(ap, double *);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFRealReadV(up, unexpected, number, precision, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
int UFRealReadV(up, unexpected, number, precision, fmt, ap)
     UF_t *up; int unexpected;
     double *number;
     double *precision;
     char *fmt;
     va_list ap;
{
  int uStat;
  char buffer[UFMAXBUFLEN];

  /*  printf("UFRealReadV\n");*/
  do {
    UFSkipTo(up, UFQueueBreak(up));
    uStat= UFLockedReadV(up, fmt, ap);

    if (UFQuestionSkip(up)) {
      UFPrintM(up, "expecting real number:\n");
      if (unexpected) {
      UFPrintM(up, "  conversion stopped by any unexpected character\n"); }
      UFPrintM(up, "  white space:   \"%s\"\n",
	       UFItemSPrint(UFWhiteSpace(up), buffer, UFMAXBUFLEN, '"'));
      UFPrintM(up, "  break:        \"%s\"\n",
	       UFItemSPrint(UFQueueBreak(up), buffer, UFMAXBUFLEN, '"')); }
    else if (uStat == UFUTEXT) {
      return UFRealGet(up, &UFBufferP(up,UFBufIdx(up)), unexpected,
		       number, precision); }
    else { return FALSE; }
  } while (TRUE);
}
/* ---------------------------------------------------------------------- */
static int UFAlias(up)
     UF_t *up;
{
  char name[UFMAXBUFLEN];
  char alias[UFMAXBUFLEN];
  char args[UFMAXBUFLEN];
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFMenIdx(up) < 0) {
    UFsetErrNo(UFNOMENU); return FALSE; }
  else if (UFNoArgs(up)) { return UFAliasShow(up, NULL); }
  else if (UFItemRead(up, name, UFMAXBUFLEN, "name to alias")) {
    if (UFNoArgs(up)) { return UFAliasShow(up, name); }
    else if (UFItemRead(up, alias, UFMAXBUFLEN, "alias")) {
      if (UFNoArgs(up) ||
	  !UFItemRead(up, args, UFMAXBUFLEN, "arg-definition")) {
	*args= '\0'; }

      return UFAliasInsert(MenAt(MenStatMenu(UFMenu(up,UFMenIdx(up)))),
			   name, alias, args); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int UFUnalias(up)
     UF_t *up;
{
  char name[UFMAXBUFLEN];
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFMenIdx(up) < 0) {
    UFsetErrNo(UFNOMENU); return FALSE; }
  else if (UFItemRead(up, name, UFMAXBUFLEN, "name to unalias")) {
    return UFAliasDelete(MenAt(MenStatMenu(UFMenu(up,UFMenIdx(up)))), name); }
  else {
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int UFAliasDelete(at, name)
     CmdVec_t at;
     char *name;
{
  int i;
  Cmd_t *cp;

  for (i= 0, cp= VecP(at); i < VecNum(at); i++, cp++) {
    if (!strcmp(CmdCommand(cp), name)) {
      Free(CmdCommand(cp));
      VecDelete(at, i, 1); return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int UFAliasInsert(at, name, alias, args)
     CmdVec_t at;
     char *name;
     char *alias;
     char *args;
{
  char *entry;
  int namlen= strlen(name);

  if ((entry= (char *)Malloc((namlen+strlen(alias)+strlen(args)+3) *
			     sizeof(char)))) {
    int i;
    Cmd_t *cp;
    UFAliasDelete(at, name);
    for (i= 0, cp= VecP(at);
	 i < VecNum(at) && *CmdCommand(cp) < *name;
	 i++, cp++) { ; }
    if (VecInsert(at, i, 1)) {
      cp= VecP(at) + i;

      CmdEntry(cp)= UFECMD;
      CmdAbbreviation(cp)= 0;
      CmdCommand(cp)= entry;
      CmdTyp(cp)= UFOSTRING;
      CmdMenu(cp)= NULL;
      CmdFunction(cp)= NULL;
      strcpy(CmdCommand(cp), name); /* command */

      CmdString(cp)= entry+namlen+1; /* alias */
      strcpy(CmdString(cp), alias);

      if (*args) {		/* arg-definition */
	CmdArgs(cp)= CmdString(cp) + strlen(alias) + 1;
	strcpy(CmdArgs(cp), args); }
      else { CmdArgs(cp)= "<no alias arg-definition>"; }

      if ((CmdUnexpected(cp)= (namlen > 1 &&
			       name[namlen-1] == '.' &&
			       name[namlen-2] != '\\'))) {
	CmdCommand(cp)[namlen-1]= '\0'; }
      return TRUE; }
    else { Free(entry); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int UFAliasShow(up, name)
     UF_t *up;
     char *name;
{
  CmdVec_t at= MenAt(MenStatMenu(UFMenu(up,UFMenIdx(up))));
  int i;
  int printed= FALSE;
  Cmd_t *cp;

  if (!name && VecNum(at)) { UFPrintM(up, "aliases in menu:\n"); }

  for (i= 0, cp= VecP(at); i < VecNum(at); i++, cp++) {
    if (!name || !strcmp(CmdCommand(cp), name)) {
      printed= TRUE;
      UFPrintM(up, "%s%s=\"%s\"\n", CmdCommand(cp),
	       (CmdUnexpected(cp) ? "." : ""), CmdString(cp));
      if (name) { return TRUE; } } }
  if (!printed) {
    if (name) {
      UFPrintM(up, "warning: no alias defined for '%s' in menu\n", name); }
    else {
      UFPrintM(up, "warning: no aliases defined in menu\n"); }
    return FALSE; }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
static int UFArgCopy(up, bufIdx, arg, argLen, buffer, bufLen)
     UF_t *up;
     int bufIdx;
     char *arg;
     int argLen;
     char *buffer;
     int bufLen;
{
  int argIdx= 0;
  if (!strcmp(arg, "*") ||
      (sscanf(arg, "%d", &argIdx) == 1 && argIdx > 0)) { /* arg */
    if (bufIdx < 0 || !UFBufferA(up,bufIdx)) { /* no arg buffer defined */
      return TRUE; }
    else {
      char *a= UFBufferA(up,bufIdx);
      argIdx--;			/* *a points behind command (c.f. UFCmd) */
      while (*a) {
	if (UFSkipToTest(up, a, UFQueueBreak(up)) ||
	    UFStringEmpty(up, a)) { /* no more args */
	  break; }
	else if (UFItemGetV(up, &a, buffer, bufLen)) {
	  char *b= buffer;
	  if (UFArgGet(up, &b, arg, argLen)) {
	    if (!UFArgCopy(up, bufIdx-1, arg, argLen, buffer, bufLen)) {
	      return FALSE; } }
	  if (argIdx == 0) {	/* arg found */
	    UFshiftBufferEnd(buffer,bufLen);
	    UFappendBuffer(buffer,bufLen,' ');
	    break; }
	  argIdx--; } }
      if (a > UFBufferP(up,bufIdx)) { UFBufferP(up,bufIdx)= a; }
      return TRUE; } }
  else {			/* environment variable */
    extern char *getenv();
    char *e= getenv(arg);
    if (!e) {
      return TRUE; }	/* variable not defined */
    else if (strlen(e) > bufLen) {
      UFoverflow(up,"UFCopyArg");
      return FALSE; }
    else {
      strcpy(buffer, e);
      return TRUE; } }
}
/* ---------------------------------------------------------------------- */
static int UFArgGet(up, bp, arg, argLen)
     UF_t *up;
     char **bp;
     char *arg;
     int argLen;
{
  char *a;
  if ((a= UFSkipToTest(up, *bp, "$"))) {
    if (a[1] == '(') {
      int i;
      a += 2;
      for (i= 0; *a && i< argLen-1 && *a != ')'; ) { arg[i++]= *a++; }
      if (*a++ == ')' && UFstopTyp(up,*a) != UFSUNEXPECTED) {
	*bp= a; arg[i]= '\0'; return TRUE; } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int UFBufferNext(up, bufTyp, filIdx)
     UF_t *up;
     int bufTyp;
     int filIdx;
{
  int old= UFBufIdx(up);
  int new= old+1;

  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (new >= UFBufNum(up)) {
    UFReset(up); UFsetErrNo(UFBUFNUM); return FALSE; }
  else if (bufTyp == UFBFILE && (filIdx < 0 || filIdx >= UFFilNum(up))) {
    UFsetErrNo(UFNOFILE); return FALSE; }

  if (old >= 0) {
    int len= strlen(UFBufferP(up,old)) + 1;
    UFBufferB(up,new)= UFBufferP(up,old) + len;
    UFBufferLen(up,new)= UFBufferLen(up,old) - len; }
  else {
    new= 0;
    UFBufferLen(up,new)= UFBufSiz(up); }

  UFBufIdx(up)= new;

  UFBufferP(up,new)= UFBufferB(up,new);
  *UFBufferB(up,new)= '\0';
  UFBufferA(up,new)= NULL;
  UFBufferFilIdx(up,new)= filIdx;
  UFBufferTyp(up,new)= bufTyp;

  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int UFBufferPrev(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  if (UFBufIdx(up) > 0) {
/* DUKE (-e)  if (UFBufIdx(up) >= 0) { so nicht ! */
    int b= UFBufIdx(up);
    switch(UFBufferTyp(up,b)) {
    case UFBFILE: UFFileClose(up); break;
    case UFBTERM:
    case UFBSCRATCH:
    default: break; }

    UFBufIdx(up)--; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int UFBufferSet(up, buffer)
     UF_t *up;
     char *buffer;
{
  if (!up) { UFsetErrNo(UFPOINT); }
  else if (!buffer) { UFsetErrNo(UFPOINT); UFUpdateStat(up)= UFUERROR; }
  else {
    if (UFCmdFile(up)) { fputs(buffer, UFCmdFile(up)); } 
    if (UFOutFile(up)) { fputs(buffer, UFOutFile(up)); } 
    if (UFStdOut(up)) { fputs(buffer, UFStdOut(up)); } 

    if (UFBufIdx(up) >= 0) { UFBufferClear(up,UFBufIdx(up)); }
    if ((UFBufIdx(up) < 0 || UFBufferTyp(up,UFBufIdx(up)) != UFBTERM) &&
	!UFBufferNext(up, UFBSCRATCH, -1)) { ; }
    else if (*buffer == '\003') { UFUpdateStat(up)= UFUCANCEL; } /* ctrl-c */
    else if (*buffer == '\004') { UFUpdateStat(up)= UFUEOF; } /* ctrl-d */
    else if (strlen(buffer) > UFBufferLen(up,UFBufIdx(up))) {
      UFsetErrNo(UFBUFEXC);  UFUpdateStat(up)= UFUERROR; }
    else {
      strcpy(UFBufferB(up,UFBufIdx(up)), buffer);
      UFUpdateStat(up)= UFUTEXT; } }

  if (UFUpdateStat(up) == UFUERROR) { UFReset(up); }
  return UFUpdateStat(up);
}
/* ---------------------------------------------------------------------- */
int UFClose(up)
     UF_t *up;
{
  if (up) {
    if (UFBuffers(up)) { Free(UFBufferB(up,0)); Free(UFBuffers(up)); }
    Free(UFFiles(up));
    Free(up); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Cmd_t *UFCmd(up, mp)
     UF_t *up;
     Men_t *mp;
{
  static Cmd_t aliasCmd[]= {
    { UFECMD, FALSE, 5, { UFOFACEFCT, UFAlias, NULL, NULL },
	"alias", "[<name to alias> [<alias> [<arg-definition>]]]" },
    { UFECMD, FALSE, 7, { UFOFACEFCT, UFUnalias, NULL, NULL },
	"unalias", "<name to unalias>" },
  };

  static CmdVecRec aliasCmdVec
    = { { TRUE, sizeof(Cmd_t), sizeof(aliasCmd), 2 }, aliasCmd };

  static Cmd_t rootCmd[]= {
    { UFECMD, TRUE, 0, { UFOMENU, NULL, NULL, NULL },
	NULL, "<any root menu command>" },
  };

  static CmdVecRec rootCmdVec
    = { { TRUE, sizeof(Cmd_t), sizeof(rootCmd), 1 }, rootCmd };

  Cmd_t *best= NULL;
  char *bestStop= NULL;
  int bestLen= 0;
  int men= UFMenIdx(up);

  if (men >= 0 &&		/* not in root menu */
      !MenStatInFunction(UFMenu(up,men))) { /* not in function */
    CmdCommand(rootCmd)= MenStatPrompt(UFMenu(up,0));
    CmdMenu(rootCmd)= MenStatMenu(UFMenu(up,0));
    CmdAbbreviation(rootCmd)= strlen(CmdCommand(rootCmd));
    if (UFCmdTest(up, UFBufferP(up,UFBufIdx(up)), &rootCmdVec,
		  &best, &bestStop, &bestLen)) {
      UFBufferP(up, UFBufIdx(up))= bestStop;
      UFBufferA(up, UFBufIdx(up))= bestStop;
      return best; } }

  if (mp &&
      (UFCmdTest(up, UFBufferP(up,UFBufIdx(up)), &aliasCmdVec,
		 &best, &bestStop, &bestLen) |
       UFCmdTest(up, UFBufferP(up,UFBufIdx(up)), MenAt(mp),
		 &best, &bestStop, &bestLen) |
       UFCmdTest(up, UFBufferP(up,UFBufIdx(up)), MenCt(mp),
		 &best, &bestStop, &bestLen))) {
    UFBufferP(up, UFBufIdx(up))= bestStop;
    UFBufferA(up, UFBufIdx(up))= bestStop;
    return best; }
  return NULL;  
}
/* ---------------------------------------------------------------------- */
static int UFCmdTest(up, buffer, tp, best, bestStop, bestLen)
     UF_t *up;
     char *buffer;
     CmdVec_t tp;
     Cmd_t **best;
     char **bestStop;
     int *bestLen;
{
  if (tp) {
    int i;
    Cmd_t *cp= VecP(tp);

    for (i= 0; i< VecNum(tp); i++, cp++) {
      char *c= CmdCommand(cp);
      char *b= buffer;
      int e= 0;

      if (CmdEntry(cp) != UFECMD) { continue; }

      while (*c && *b) {
	if (*c == *b) {
	  e++; c++; b++; }
	else if (e == 0 && strchr(UFWhiteSpace(up), *b)) {
	  b++; }		/* skip leading white space */
	else { break; } }

      if (e == 0 ||
	  e < *bestLen ||
	  (CmdAbbreviation(cp) > 0 && CmdAbbreviation(cp) > e) ||
	  (!CmdUnexpected(cp) && UFstopTyp(up,*b) == UFSUNEXPECTED)) {
	continue; }
      else if ((e == *bestLen &&
		strlen(CmdCommand(cp)) == e &&
		strlen(CmdCommand(*best)) != e) ||
	       e > *bestLen) {
	if (CmdTyp(cp) == UFOSTRING) {
	  int bi;
	  int cont;
	  for (bi= UFBufIdx(up), cont= FALSE; bi >= 0; bi--) {
	    if (!strcmp(CmdString(cp), UFBufferB(up,bi))) {
	      cont= TRUE; break; } } /* avoid recursive aliases */
	  if (cont) { continue; } }
	*best= cp;
	*bestLen= e;
	*bestStop= b;
	if (strlen(CmdCommand(cp)) == e && strchr(UFWhiteSpace(up), *b)) {
	  break; } } } }
  if (*best) { return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
char *UFError(err_no)
     int err_no;
{
  static char *errors[] = {
  /* UFNOERR   */ "vsUserFace: no error",
  /* UFPOINT   */ "vsUserFace: illegal NULL-pointer",
  /* UFALLOC   */ "vsUserFace: memory allocation failed",
  /* UFBUFEXC  */ "vsUserFace: maximal buffer length exceeded",
  /* UFBUFNUM  */ "vsUserFace: maximal buffer number exceeded",
  /* UFFILNUM  */ "vsUserFace: maximal file number exceeded",
  /* UFMENNUM  */ "vsUserFace: maximal menu number exceeded",
  /* UFPARVAL  */ "vsUserFace: illegal setup parameter value",
  /* UFOPTYP   */ "vsUserFace: illegal operation type",
  /* UFNOBUF   */ "vsUserFace: no buffer for update available",
  /* UFEOS     */ "vsUserFace: unexpected end of string found",
  /* UFCMDOPEN */ "vsUserFace: command input file not opened",
  /* UFNOTERM  */ "vsUserFace: no terminal read defined",
  /* UFNOFILE  */ "vsUserFace: no legal file specified",
  /* UFPRINT   */ "vsUserFace: internal print failed",
  /* UFNOMENU  */ "vsUserFace: no menu specified",
  /* UFLOCKED  */ "vsUserFace: locked -- waiting for input",
  /* default   */ "vsUserFace: undefined error code", };

  if (err_no < sizeof(errors)) { return errors[err_no]; }
  else { return errors[sizeof(errors)-1]; }
}
/* ---------------------------------------------------------------------- */
int UFExecuteShell(up)
     UF_t *up;
{
  char s[UFMAXBUFLEN];
  if (UFItemRead(up, s, UFMAXBUFLEN, "shell command")) {
    FILE *pp;
    extern int errno;
    errno = 0;
    if ((pp= popen(s, "r"))) {
      while (fgets(s, UFMAXBUFLEN, pp)) {
	UFPrintP(up, s); }
      pclose(pp);
      return TRUE; }
    else {
      UFPrintM(up, "error: can't execute shell command '%s'\n", s);
      if (errno != 0) {
	UFPrintM(up, "system: %s\n", strerror(errno)); } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int UFFileClose(up)
     UF_t *up;
     
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFFilIdx(up) < 0) { return TRUE; }

  while (UFBufferFilIdx(up,UFBufIdx(up)) < 0) { UFBufferPrev(up); }
  if (UFFileProtocol(up,UFFilIdx(up))) {
    UFPrintM(up, "closing command input file '%s' after line %d\n",
	     PthShort(UFFileName(up,UFFilIdx(up))),
	     UFFileLine(up,UFFilIdx(up))); }
  if (UFCmdFile(up)) {
    fprintf(UFCmdFile(up), "# closing command input file '%s' after line %d\n",
	    PthShort(UFFileName(up,UFFilIdx(up))),
	    UFFileLine(up,UFFilIdx(up))); }
  fclose(UFFileFp(up,UFFilIdx(up)));
  Free(UFFileName(up,UFFilIdx(up)));
  UFFilIdx(up)--;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int UFFileCloseCmd(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  return UFFileCloseIntern(up, &UFCmdFile(up), &UFCmdFileName(up));
}
/* ---------------------------------------------------------------------- */
int UFFileCloseOut(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  return UFFileCloseIntern(up, &UFOutFile(up), &UFOutFileName(up));
}
/* ---------------------------------------------------------------------- */
static int UFFileCloseIntern(up, file, filename)
     UF_t *up;
     FILE **file;
     char **filename;
{
  if (*file) {
    fclose (*file); *file= NULL;
    Free(*filename); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int UFFileOpen(up, file, protocol, autoEof)
     UF_t *up;
     char *file;
     int protocol;
     int autoEof;
{
  FILE *fp;
  extern char *getenv();
  char *path;
  char *searchPath;
  
  printf ("Looking for %s in %s\n", file, UFStdPth(up));

  if (
      (
       (
	UFPath(up) &&
	(searchPath= getenv(UFPath(up))) && 
	strlen (searchPath) != 0
	) ||
       (searchPath= UFStdPth(up)) ||
       (searchPath= getenv("PATH"))
       )
      &&
      (path= PthFind(file, searchPath)) 
      &&
      *path) { ; }
  else if ((path= PthExpand(file)) && *path) { ; }
  else { path= file; }

  if (!up) { UFsetErrNo(UFPOINT); }
  else if (UFFilIdx(up) + 1 >= UFFilNum(up)) {
    UFReset(up); UFsetErrNo(UFFILNUM); }
  else if (!(fp= fopen(path, "r"))) {
    UFsetErrNo(UFCMDOPEN); }
  else {
    int f;
    f= ++UFFilIdx(up);
    UFFileFp(up,f)= fp;
    UFFileName(up,f)= Strdup(path);
    UFFileProtocol(up,f)= protocol;
    UFFileAutoEof(up,f)= autoEof;
    UFFileLine(up,f)= 0;
    if (UFBufferNext(up, UFBFILE, f)) {
      if (UFFileProtocol(up,UFFilIdx(up))) {
	UFPrintM(up, "opening command input file(%d) '%s'\n",
		 UFFilIdx(up), PthShort(UFFileName(up,UFFilIdx(up)))); }
      if (UFCmdFile(up)) {
	fprintf(UFCmdFile(up), "# opening command input file '%s'\n",
		PthShort(UFFileName(up,UFFilIdx(up)))); }
      if (UFBufIdx(up) > 0) {
	/* DUKE (-e)      if (UFBufIdx(up) >= 0) { wahrscheinlich so nicht... */
	UFBufferA(up,UFBufIdx(up)-1)= UFBufferP(up,UFBufIdx(up)-1); }
      return TRUE; }
    else { fclose(fp); UFFilIdx(up)--; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int UFFileResume(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else {
    int i= UFBufIdx(up);

    if (UFCmdFile(up)) {
      fprintf(UFCmdFile(up), "# resuming command file input\n"); }
    while (i > 0) {
    /* DUKE (-e)       while (i >= 0) { so nicht */
      switch (UFBufferTyp(up,i)) {
      case UFBFILE:
	while (UFBufferTyp(up,UFBufIdx(up)) != UFBFILE) {
	  /*printf ("Hier kann er nie hinkommen oder os ist dumm\n");*/
				/* Kommt doch hierher */
	  UFBufferPrev(up); }
	return TRUE;
      default: i--; } }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int UFFileOpenCmd(up, name, mode)
     UF_t *up;
     char *name;
     char *mode;
{
  if (!up || !name || !mode) { UFsetErrNo(UFPOINT); return FALSE; }
  return UFFileOpenIntern(up, name, mode, &UFCmdFile(up), &UFCmdFileName(up));
}
/* ---------------------------------------------------------------------- */
int UFFileOpenOut(up, name, mode)
     UF_t *up;
     char *name;
     char *mode;
{
  if (!up || !name || !mode) { UFsetErrNo(UFPOINT); return FALSE; }
  return UFFileOpenIntern(up, name, mode, &UFOutFile(up), &UFOutFileName(up));
}
/* ---------------------------------------------------------------------- */
static int UFFileOpenIntern(up, name, mode, file, filename)
     UF_t *up;
     char *name;
     char *mode;
     FILE **file;
     char **filename;
{
  char *path;

  if ((path= PthExpand(name)) && *path) {
    FILE *fp;

    UFFileCloseIntern(up, file, filename); /* close 1st (if it's reopened) */
    if ((fp= fopen(path, mode))) {
      *filename= Strdup(path);
      *file= fp;
      return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int UFFileSuspend(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else {
    int i= UFBufIdx(up);

    if (UFCmdFile(up)) {
      fprintf(UFCmdFile(up), "# suspending command file input\n"); }
    while (i >= 0) {
      switch (UFBufferTyp(up,i)) {
      case UFBTERM: return TRUE;
      case UFBFILE: return UFBufferNext(up, UFBTERM, -1);
      case UFBSCRATCH: i--; } }
    UFsetErrNo(UFNOBUF);
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int UFInit(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }

  UFKeyProtocol(up)= TRUE;

  strcpy(UFQueueBreak(up), "\n;");
  strcpy(UFWhiteSpace(up), " \t");
  strcpy(UFComment(up), "#");
  strcpy(UFShell(up), "%");
  strcpy(UFConditional(up), "!");
  strcpy(UFOParentheses(up), "([{");
  strcpy(UFCParentheses(up), ")]}");
  strcpy(UFQuotes(up), "\"'");
  strcpy(UFFile(up), "@");
  strcpy(UFQuestion(up), "?");
  strcpy(UFStdPth(up), TVSTDPATH);

  return UFInitHist(up);
}
/* ---------------------------------------------------------------------- */
static int UFInitHist(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  UFUpdateStat(up)= UFUQBREAK;
  UFItemTyp(up)= UFINONE;

  UFOParenthesis(up)= '\0';
  UFCParenthesis(up)= '\0';
  UFQuote(up)= '\0';
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static Cmd_t *UFIntCmd(up, mp)
     UF_t *up;
     Men_t *mp;
{
  Cmd_t *cp;
  if ((cp= UFSpecialCmd(mp, UFEINT))) {
    int i;
    char *stp;
    if (UFIntTest(up, UFBufferP(up,UFBufIdx(up)), CmdUnexpected(cp),
		  &i, &stp)) {
      return cp; } }
  return NULL;
}
/* ---------------------------------------------------------------------- */
int UFIntGet(up, bp, unexpected, number)
     UF_t *up;
     char **bp;
     int unexpected;
     int *number;
{
  char *stp;
  if (!up || !bp || !*bp || !number) {
    UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFIntTest(up, *bp, unexpected, number, &stp)) {
    *bp= stp; UFItemTyp(up)= UFIINT; return TRUE; }
  else {
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int UFIntTest(up, buffer, unexpected, i, stp)
     UF_t *up;
     char *buffer;
     int unexpected;
     int *i;
     char **stp;
{
  char *b=buffer;
  int digitCount= 0;
  int sign= 1;
  int base;
  int tmp= 0;

  while (!UFisSign(*b) && !UFisDecDigit(*b)) {
    if (*b && strchr(UFWhiteSpace(up), *b)) { b++; }
    else { return FALSE; } }

  if (UFisSign(*b)) {
    if (*b++ == '-') { sign = -1; } }

  if (*b == '0') {
    b++;
    if (*b == 'x' || *b == 'X') {
      base= 16;
      b++; }
    else { base= 8; digitCount++; } }
  else { base= 10; digitCount++; }

  while (*b) {
    if ((base == 8 && !UFisOctDigit(*b)) ||
	(base == 10 && !UFisDecDigit(*b)) ||
	(base == 16 && !UFisHexDigit(*b))) {
      break; }
    UFappendDigit(tmp,base,*b); digitCount++; b++; }

  if (digitCount == 0 ||	/* no valid digits found */
      ((base == 10 || tmp == 0) && /* do not accept floating point */
       (*b == '.' ||
	((*b == 'e' || *b == 'E') && UFisDecDigit(*(b+1))))) ||
      (!unexpected && UFstopTyp(up,*b) == UFSUNEXPECTED)) {
    return FALSE; }

  *i= tmp * sign;
  *stp= b;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int UFItemCopy(up, bp, buffer, bufLen)
     UF_t *up;
     char **bp;
     char *buffer;
     int bufLen;
{
  char *b= buffer;
  int bl= bufLen;
  char *p= *bp;

  while (*p && strchr(UFWhiteSpace(up), *p)) {
    p++; }			/* skip leading white space */

  while (bl > 0 && UFstopTyp(up,*p) == UFSUNEXPECTED) {
    UFappendBuffer(b,bl,*p); p++; }

  if (bl < 1) { UFoverflow(up,"UFItemCopy"); return FALSE; }
  else { *b= '\0'; *bp= p; return TRUE; }
}
/* ---------------------------------------------------------------------- */
int UFItemGet(up, bp, buffer, bufLen)
     UF_t *up;
     char **bp;
     char *buffer;
     int bufLen;
{
  int stat= FALSE;
  char *p;

  if (!up || !bp || !*bp || !buffer) {
    UFsetErrNo(UFPOINT); UFItemTyp(up)= UFIERROR; return FALSE; }
  else if (bufLen <= 0) {
    UFoverflow(up,"UFItemGet"); return FALSE; }

  if ((p= UFSkipToTest(up, *bp, UFQuotes(up)))) {
    char q= *p;
    stat= UFItemGetQ(up, &p, buffer, bufLen, q);
    UFItemTyp(up)= UFIQUOTES;
    UFQuote(up)= q; }
  else if ((p= UFSkipToTest(up, *bp, UFOParentheses(up)))) {
    char c;
    char o= *p;
    char *op= strchr(UFOParentheses(up), *p);
    c= UFCParentheses(up)[op - UFOParentheses(up)];
    stat= UFItemGetP(up, &p, buffer, bufLen, o, c);
    UFItemTyp(up)= UFIPARENTHESES;
    UFOParenthesis(up)= o;
    UFCParenthesis(up)= c; }
  else {
    p= *bp;
    stat= UFItemCopy(up, &p, buffer, bufLen);
    UFItemTyp(up)= *buffer ? UFITEXT : UFINONE; }

  return stat;
}
/* ---------------------------------------------------------------------- */
static int UFItemGetP(up, bp, buffer, bufLen, opening, closing)
     UF_t *up;
     char **bp;
     char *buffer;
     int bufLen;
     char opening;
     char closing;
{
  char *b= buffer;
  int bl= bufLen;
  char *q;
  char *p= *bp;

  while (*p && bl > 1 && *p != closing) {
    if (*p == opening) {	/* copy inner parentheses */
      UFappendBuffer(b,bl,opening);
      if (!UFItemGetP(up, &p, b, bl, opening, closing)) { return FALSE; }
      else {
	UFshiftBufferEnd(b,bl);
	UFappendBuffer(b,bl,closing); } }
    else if ((q= strchr(UFQuotes(up), *p))) { /* copy quoted items */
      UFappendBuffer(b,bl,*q);
      if (!UFItemGetQ(up, &p, b, bl, *q)) { return FALSE; }
      else {
	UFshiftBufferEnd(b,bl);
	UFappendBuffer(b,bl,*q); } }
    else if (UFstopTyp(up,*p) != UFSUNEXPECTED) {
      UFappendBuffer(b,bl,*p); p++; }	/* copy whitespace etc. */
    else if (!UFItemCopy(up, &p, b, bl)) { /* copy other items */
      return FALSE; }
    else { UFshiftBufferEnd(b,bl); } }

  if (bl < 1) {
    UFoverflow(up,"UFItemGetParenthized"); return FALSE; }
  else if (*p == closing) {
    *bp= ++p;			/* skip parenthesis */
    *b= '\0'; return TRUE; }
  else { UFsetErrNo(UFEOS); return FALSE; } /* closing parenthesis not found */
}
/* ---------------------------------------------------------------------- */
int UFQuoteChar(src, dst, dlen, quote)
     int src;
     char **dst;
     int *dlen;
     int quote;
{
  char *b= *dst;
  int bl= *dlen;
  if (!src) { return FALSE; }
  if (' ' <= src && src <= '~' && src != '"' &&
      src != '\\' && src != quote) {
    UFappendBuffer(b,bl,src); }
  else {
    UFappendBuffer(b,bl,'\\');
    switch (src) {
    case '\b':	UFappendBuffer(b,bl,'b'); break;
    case '\f':	UFappendBuffer(b,bl,'f'); break;
    case '\n':	UFappendBuffer(b,bl,'n'); break;
    case '\r':	UFappendBuffer(b,bl,'r'); break;
    case '\t':	UFappendBuffer(b,bl,'t'); break;
    case '\\':	UFappendBuffer(b,bl,'\\'); break;
    case '\'':	UFappendBuffer(b,bl,'\''); break;
    case  '"':	UFappendBuffer(b,bl,'"'); break;
    default:
      if (src == quote) { UFappendBuffer(b,bl,src); }
      else { sprintf(b, "%03o", src); b += strlen(b); break; } } }
  *dst= b; *dlen= bl;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int UFUnquoteChar(src, dst, dlen, quote)
     char **src;
     char **dst;
     int *dlen;
     int quote;
{
  char *p= *src;
  char *b= *dst;
  int bl= *dlen;
  int c= *p;

  if (*p == quote) { return FALSE; }
  else if (*p == '\\') {
    switch (*(++p)) {
    case  'b': 	c= '\b'; break;
    case  'f':	c= '\f'; break;
    case  'n':	c= '\n'; break;
    case  'r':	c= '\r'; break;
    case  't':	c= '\t'; break;
    case '\\':	c= '\\'; break;
    case  '"':	c= '"'; break;
    default:
      if (*p == quote) { c= quote; break; }
      else {
	if (sscanf(p, "%o", &c) == 1 && 0 < c && c < CHAR_MAX+1) {
	  int tmp;
	  p++;
	  while (sscanf((p+1), "%o", &tmp) == 1) { p++; }
	  break; }
	else { p--; c= '\\'; } } } }

  UFappendBuffer(b,bl,c); p++;
  *src= p; *dst= b; *dlen= bl;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int UFItemGetQ(up, bp, buffer, bufLen, quote)
     UF_t *up;
     char **bp;
     char *buffer;
     int bufLen;
     char quote;
{
  char *b= buffer;
  int bl= bufLen;
  char *p= *bp;

  while (*p && bl > 1 && UFUnquoteChar(&p, &b, &bl, quote)) { ; }

  if (bl < 1) {
    UFoverflow(up,"UFItemGetQuoted"); return FALSE; }
  else if (*p == quote) {
    *bp= ++p;			/* skip quote */
    *b= '\0'; return TRUE; }
  else { UFsetErrNo(UFEOS); return FALSE; } /* quote not found */
}
/* ---------------------------------------------------------------------- */
int UFItemGetV(up, bp, buffer, bufLen)
     UF_t *up;
     char **bp;
     char *buffer;
     int bufLen;
{
  int stat= FALSE;
  char *p;
  char *b= buffer;
  int bl= bufLen;

  if (!up || !bp || !*bp || !buffer) {
    UFsetErrNo(UFPOINT); UFItemTyp(up)= UFIERROR; return FALSE; }
  else if (bufLen <= 0) {
    UFoverflow(up,"UFItemGet"); return FALSE; }

  if ((p= UFSkipToTest(up, *bp, UFQuotes(up)))) {
    char q= *p;
    UFappendBuffer(b,bl,q);
    stat= UFItemGetQ(up, &p, buffer, bufLen, q);
    UFappendBuffer(b,bl,q);
    UFItemTyp(up)= UFIQUOTES;
    UFQuote(up)= q;
    *bp= p; }
  else if ((p= UFSkipToTest(up, *bp, UFOParentheses(up)))) {
    char c;
    char o= *p;
    char *op= strchr(UFOParentheses(up), *p);
    c= UFCParentheses(up)[op - UFOParentheses(up)];
    UFappendBuffer(b,bl,o);
    stat= UFItemGetP(up, &p, buffer, bufLen, o, c);
    UFappendBuffer(b,bl,c);
    UFItemTyp(up)= UFIPARENTHESES;
    UFOParenthesis(up)= o;
    UFCParenthesis(up)= c;
    *bp= p; }
  else {
    stat= UFItemCopy(up, bp, buffer, bufLen);
    UFItemTyp(up)= *buffer ? UFITEXT : UFINONE; }

  return stat;
}
/* ---------------------------------------------------------------------- */
char *UFItemSPrint(item, buffer, bufLen, quote)
     char *item;
     char *buffer;
     int bufLen;
     int quote;
{
  char *i= item;
  char *b= buffer;
  int bl= bufLen;

  if (!item || !buffer || !bufLen) { return NULL; }

  *buffer= '\0';

  while (*i && bl > 1 && UFQuoteChar(*i, &b, &bl, quote)) { i++; }
  return buffer;
}
/* ---------------------------------------------------------------------- */
int UFItemTest(up, unexpected)
     UF_t *up;
     int unexpected;
{
  if (!up) { UFsetErrNo(UFPOINT); return UFIERROR; }
  else {
    int i= UFBufIdx(up);
    while (i >= 0 &&
	   UFStringEmpty(up, UFBufferP(up,i)) &&
	   UFBufferTyp(up,i) == UFBSCRATCH) { i--; }
    if (i < 0) { UFsetErrNo(UFNOBUF); return UFIERROR; }
    return UFItemTestString(up, UFBufferP(up,i), unexpected); }
}
/* ---------------------------------------------------------------------- */
int UFItemTestString(up, b, unexpected)
     UF_t *up;
     char *b;
     int unexpected;
{
  int i;
  double r;
  double p;
  char *stp;
  if (!up || !b) { return UFIERROR; }
  else if (UFIntTest(up, b, unexpected, &i, &stp)) {
    return UFIINT; }
  else if (UFRealTest(up, b, unexpected, &r, &p, &stp)) {
    return UFIREAL; }
  else if (UFSkipToTest(up, b, UFQuotes(up))) {
    return UFIQUOTES; }
  else if (UFSkipToTest(up, b, UFOParentheses(up))) {
    return UFIPARENTHESES; }
  else if (UFStringEmpty(up, b)) {
    return UFINONE; }
  else {
    return UFITEXT; }
}
/* ---------------------------------------------------------------------- */
int UFMenuLoop(up, startMenu, prompt)
     UF_t *up;
     Men_t *startMenu;
     char *prompt;
{
  Cmd_t *cp= NULL;
  int startIdx, brkIdx;

  

  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFMenLocked(up)) { UFsetErrNo(UFLOCKED); return FALSE; }
  else if (!UFMenuNext(up, startMenu, TRUE, prompt)) { return FALSE; }

  brkIdx= UFFilBrk(up);
  startIdx= UFMenIdx(up);

  while (startIdx <= UFMenIdx(up) && brkIdx <= UFFilIdx(up)) {
    MenStat_t *msp= UFMenu(up,UFMenIdx(up)); /* may change in loop !!! */
    Men_t *mp= MenStatMenu(msp);


    AlcCheck();

    if (MenStatModeExit(msp)) {	/* exit immediatly */
      MenStatLoopPart(msp)= UFLPEXIT; }

    switch (MenStatLoopPart(msp)) {
    case UFLPENTER:
      /*      printf("in uflpenter\n");*/
      MenStatLoopPart(msp)= UFLPENTRY;
      UFOperate(UFSpecialCmd(mp, UFEENTER), up);
      break;
    case UFLPENTRY:
      /*      printf("in uflpentry\n");*/
      MenStatLoopPart(msp)= UFLPHEAD;
      if (UFUpdateQueueBreak(up) && (cp= UFSpecialCmd(mp, UFEENTRYQB))) {
	UFOperate(cp, up);
	break; }		/* else: no special => continue */
    case UFLPHEAD:
      /*      printf("in uflphead\n");*/
      MenStatLoopPart(msp)= UFLPCORE;
      if ((cp= UFSpecialCmd(mp, UFELOOPHEAD))) {
	UFOperate(cp, up);
	break; }		/* else: no special => continue */
    case UFLPCORE: {
      int legalFct= FALSE;
      /*      printf("in uflpcore\n");*/
      switch (UFLockedRead(up, UFPrompt(up))) {
      case UFUEOF:    cp= UFSpecialCmd(mp, UFEEOF); break;
      case UFUERROR:  cp= UFSpecialCmd(mp, UFEERROR); break;
      case UFUCANCEL: cp= UFSpecialCmd(mp, UFECANCEL); break;
      case UFUQBREAK: cp= UFSpecialCmd(mp, UFELOOPQB); break;
      case UFUTEXT:
	legalFct= TRUE;
	if ((cp= UFCmd(up, mp))) {
	  if (UFQuestionArgs(up, cp)) { cp= NULL; continue; }
	  break; }
	else if (UFQuestionMenu(up)) {
	  continue; }	/* always new input on question */
	else if ((cp= UFIntCmd(up, mp))) { break; }
	else if ((cp= UFRealCmd(up, mp))) { break; }
      default:
	legalFct= TRUE;
	if ((cp= UFSpecialCmd(mp, UFEDEFAULT))) { ; }
	else if ((cp= UFSpecialCmd(mp,UFESTANDARD))) { ; }
	else { UFReset(up); } }
      MenStatLoopPart(msp)= UFLPTAIL;
      if (cp) {			/* any command found */
	UFOperate(cp, up);
	if (legalFct && !MenStatModeLoop(msp) &&
	    (CmdTyp(cp) == UFOFCT || CmdTyp(cp) == UFOFACEFCT)) {
	  UFUpdateQueueBreak(up); } } }
      break;
    case UFLPTAIL:
      MenStatLoopPart(msp)= UFLPHEAD;
      if (MenStatModeSingle(msp) || MenStatModeSingleLoop(msp) ) {
	MenStatMode(msp)= UFLEXIT; }
      UFOperate(UFSpecialCmd(mp, UFELOOPTAIL), up);
      break;
    case UFLPEXIT:
      UFOperate(UFSpecialCmd(mp, UFEEXIT), up);
      if (!UFMenuPrev(up)) { return FALSE; } }
    switch (UFUpdateStat(up)) {
    case UFUEOF:
    case UFUERROR:
    case UFUCANCEL:
      UFUpdateStat(up)= UFUREQINP; break;
    }
  }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int UFMenuLoopFile(up, file, menu, prompt)
     UF_t *up;
     char *file;
     Men_t *menu;
     char *prompt;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else {
    int startIdx= UFMenIdx(up);

    if (!UFFileOpen(up, file, TRUE, FALSE)) {
      return FALSE; }
    else {
      int ret_val;
      int filBrk= UFFilBrk(up);
      UFFilBrk(up)= UFFilIdx(up);
      ret_val= UFMenuLoop(up, menu, prompt);
      UFUpdateStat(up)= UFUQBREAK;
      while (UFMenIdx(up) > startIdx) { UFMenuPrev(up); }
      UFFilBrk(up)= filBrk;
      return ret_val; } }
}
/* ---------------------------------------------------------------------- */
int UFMenuLoopContinue()
{
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int UFMenuLoopExit(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFMenLocked(up)) { UFsetErrNo(UFLOCKED); return FALSE; }
  else { MenStatMode(UFMenu(up,UFMenIdx(up))) = UFLEXIT; return TRUE; }
}
/* ---------------------------------------------------------------------- */
int UFMenuLoopExitQBreak(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFMenLocked(up)) { UFsetErrNo(UFLOCKED); return FALSE; }
  else if ((UFUpdateStat(up) == UFUQBREAK || UFSkipEmpty(up)) &&
	   (MenStatMode(UFMenu(up,UFMenIdx(up))) == UFLLOOP/* ||
	    MenStatMode(UFMenu(up,UFMenIdx(up))) == UFLLOOPQB*/)) {
    return UFMenuLoopExit(up); }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
int UFRootLoopQBreak(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFMenLocked(up)) { UFsetErrNo(UFLOCKED); return FALSE; }
  else if (UFMenIdx(up) > 0 &&
	   (UFUpdateStat(up) == UFUQBREAK || UFSkipEmpty(up))) {
    return UFMenuLoopExit(up); }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
int UFMenuLoopLoop(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFMenLocked(up)) { UFsetErrNo(UFLOCKED); return FALSE; }
  else if (MenStatModeSingle(UFMenu(up,UFMenIdx(up)))) { return FALSE; }
  else { MenStatMode(UFMenu(up,UFMenIdx(up))) = UFLLOOPQB; return TRUE; }
}
/* ---------------------------------------------------------------------- */
int UFMenuLoopSingle(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFMenLocked(up)) { UFsetErrNo(UFLOCKED); return FALSE; }
  else { MenStatMode(UFMenu(up,UFMenIdx(up))) = UFLSINGLE; return TRUE; }
}
/* ---------------------------------------------------------------------- */
static int UFMenuNext(up, mp, loopStart, prompt)
     UF_t *up;
     Men_t *mp;
     int loopStart;
     char *prompt;
{
  if (!up || !mp) { UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFMenLocked(up)) { UFsetErrNo(UFLOCKED); return FALSE; }
  else {
    int men= UFMenIdx(up) + 1;

    men = MAX(0,men);

    if (men >= UFMenNum(up)) {
      UFPrintE(up, "UFMenuNext-error: menu stack exceeded");
      UFReset(up); UFsetErrNo(UFMENNUM);
      return FALSE; }
    else {
      UFMenIdx(up)			= men;
      MenStatMenu(UFMenu(up,men))	= mp;
      MenStatPrompt(UFMenu(up,men))	= prompt;
      MenStatMode(UFMenu(up,men))	= MenEntryMode(mp);
      MenStatLoopStart(UFMenu(up,men))	= loopStart;
      MenStatInFunction(UFMenu(up,men))
	= ((men > 0) ? MenStatInFunction(UFMenu(up,men-1)) : FALSE);
      MenStatLoopPart(UFMenu(up,men))	= UFLPENTER;
      return TRUE; } }
}
/* ---------------------------------------------------------------------- */
static int UFMenuPrev(up)
     UF_t *up;
{
  if (UFMenIdx(up) < 0) { return FALSE; }
  else {
    return (--UFMenIdx(up) >= 0); }
}
/* ---------------------------------------------------------------------- */
int UFNoArgs(up)
     UF_t *up;
{
  return (UFUpdateStat(up) == UFUQBREAK ||
	  UFSkipEmpty(up) || UFUpdateQueueBreak(up));
}
/* ---------------------------------------------------------------------- */
UF_t *UFOpen(bufSiz, bufNum, filNum, menNum, inputLoopFct,
	     printFct, printPagedFct, printStdOut, printStdErr,
	     path)
     int bufSiz;
     int bufNum;
     int filNum;
     int menNum;
     pfv_t inputLoopFct;
     pfi_t printFct;
     pfi_t printPagedFct;
     void *printStdOut;
     void *printStdErr;
     char *path;
{
  UF_t *up;

  if (bufSiz <= 0 || bufNum <= 0 || filNum < 0 || menNum < 0) {
    UFsetErrNo(UFPARVAL); }
  if (!(up= (UF_t *)Calloc(1,sizeof(UF_t))) ||
      !(UFBuffers(up)= (UFBuf_t *)Calloc((size_t)bufNum, sizeof(UFBuf_t))) ||
				/* allocate input buffers */
      !(UFBufferB(up,0)= (char *)Malloc(bufSiz * sizeof(char))) ||
      (filNum &&
       !(UFFiles(up)= (UFFil_t *)Calloc((size_t)filNum, sizeof(UFFil_t)))) ||
      (menNum &&
       !(UFMenus(up)=
	 (MenStat_t *)Calloc((size_t)menNum, sizeof(MenStat_t)))) ||
      (path && *path && !(UFPath(up)= Strdup(path)))) {
    UFClose(up); up= NULL;
    UFsetErrNo(UFALLOC); }
  else {
    UFInit(up);
    UFInputLoop(up)= inputLoopFct;
    UFPrint(up)= printFct;
    UFPrintPaged(up)= printPagedFct;
    UFPrintStdOut(up)= printStdOut;
    UFPrintStdErr(up)= printStdErr;
    UFOutFile(up)= NULL;
    UFCmdFile(up)= NULL;
    UFOutFileName(up)= NULL;
    UFCmdFileName(up)= NULL;
    UFStdOut(up)= NULL;
    UFStdErr(up)= NULL;
    UFSockOut (up) = NULL;

    UFBufNum(up)= bufNum;
    UFFilNum(up)= filNum;
    UFMenNum(up)= menNum;
    UFBufSiz(up)= bufSiz;
    UFBufIdx(up)= -1;
    UFFilIdx(up)= -1;
    UFFilBrk(up)= -1;
    UFMenIdx(up)= -1;
    UFMenLocked(up)= FALSE; }

  if (!up || !UFBufferNext(up, UFBTERM, -1)) {
    extern int errno;

    fprintf(stderr, "fatal: can not initialize user interface\n");
    fprintf(stderr, "  %s\n", UFError(UFErrNo));
    if (errno) { fprintf(stderr, "  system: %s\n", strerror(errno)); }
    if (up) { UFClose(up); up= NULL; } }

  return up;
}
/* ---------------------------------------------------------------------- */
static int UFOperate(cp, up)
     Cmd_t *cp;
     UF_t *up;
{
  int men= UFMenIdx(up);
  MenStat_t *msp= UFMenu(up,men);
  if (cp) {
    int ret_val;
    switch (CmdTyp(cp)) {
    case UFOMENU:		/* new menu branch */
      if (!UFMenuNext(up, CmdMenu(cp), FALSE, CmdCommand(cp))) {
	return FALSE; }
      else { return TRUE; }
    case UFOFCT:		/* exec function */
      MenStatInFunction(msp)	= TRUE;
      ret_val			= CmdFunction(cp)();
      MenStatInFunction(msp)
	= ((men > 0) ? MenStatInFunction(UFMenu(up,men-1)) : FALSE);
      return ret_val;
    case UFOFACEFCT:		/* exec user face function */
      MenStatInFunction(msp)	= TRUE;
      ret_val			= CmdFunction(cp)(up);
      MenStatInFunction(msp)
	= ((men > 0) ? MenStatInFunction(UFMenu(up,men-1)) : FALSE);
      return ret_val;
    case UFOSTRING:		/* exec string starting on same level */
      if (!UFBufferNext(up, UFBSCRATCH, -1)) { return FALSE; }
      if (strlen(CmdString(cp)) > UFBufferLen(up,UFBufIdx(up))) {
	UFoverflow(up,"UFOperate"); return FALSE; }
      else { strcpy(UFBufferB(up,UFBufIdx(up)), CmdString(cp)); }
      if (!MenStatModeLoop(msp) &&
	  !UFStringEmpty(up,UFBufferB(up,UFBufIdx(up)))) {
	MenStatMode(msp)= UFLLOOPQB; }
      return TRUE;
    default:
      UFsetErrNo(UFOPTYP); UFReset(up); return FALSE; } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
char *UFPrompt(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return NULL; }
  else if (UFMenIdx(up) < 0) { UFsetErrNo(UFNOMENU); return NULL; }
  else if (UFMenLocked(up)) {
    char *pmt= UFLockedPrompt(up);
    return (pmt ? pmt : ""); }
  else {
    char *pmt= up->prompt;
    int pl= UFMAXBUFLEN-2;
    int l;
    int i;
    *pmt= '\0';
    for (i= UFMenIdx(up); !MenStatLoopStart(UFMenu(up,i)); i--) { ; }
    if (i < UFMenIdx(up)) { i++; }
    for (; (i <= UFMenIdx(up)
	    && (l= strlen(MenStatPrompt(UFMenu(up,i)))) < pl);
	 i++) {
      if (pmt > up->prompt) { *pmt++ = ' '; pl--; }
      strcpy(pmt, MenStatPrompt(UFMenu(up,i)));
      pmt += l; pl -= l; }
    return up->prompt; }
}
/* ---------------------------------------------------------------------- */
static int UFQuestionArgs(up, cp)
     Cmd_t *cp;
     UF_t *up;
{
  if ((CmdTyp(cp) == UFOFCT || CmdTyp(cp) == UFOFACEFCT ||
       CmdTyp(cp) == UFOSTRING) &&
      UFQuestionSkip(up)) {
    UFBufferClear(up, UFBufIdx(up));

    UFPrintP(up,   "usage: %s %s ", UFPrompt(up), CmdCommand(cp));

    if (CmdArgs(cp)) { UFPrintP(up, "%s\n", CmdArgs(cp)); }
    else { UFPrintP(up, "<no arguments>\n"); }

    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int UFQuestionMenu(up)
     UF_t *up;
{
  Men_t *mp= MenStatMenu(UFMenu(up,UFMenIdx(up)));

  if (!UFQuestionSkip(up)) { return FALSE; }

  UFBufferClear(up, UFBufIdx(up));

  if (!mp) {
    UFPrintM(up, "no menu defined\n"); } /* ... but continue */
  else if (MenArgs (mp)){
    UFPrintP (up, "%s\n", MenArgs (mp));}
  else {
    if (VecNum(MenAt(mp))) {
      int i;
      CmdVec_t a= MenAt(mp);
      Cmd_t *cp= VecP(a);

      UFPrintP(up, "Aliases:");

      for (i= 0; i< VecNum(a); i++, cp++) {
	if (CmdEntry(cp) == UFECMD) {
	  UFPrintP(up, " %s%s", CmdCommand(cp), 
		   (CmdUnexpected(cp) ? "." : "")); } }

      UFPrintP(up, "\n"); }

    if (VecNum(MenCt(mp))) {
      int i;
      CmdVec_t c= MenCt(mp);
      Cmd_t *cp= VecP(c);
      if (CmdEntry(cp) != UFECOMMENT) { UFPrintP(up, "Commands:"); }

      for (i= 0; i< VecNum(c); i++, cp++) {
	if (CmdEntry(cp) == UFECMD) {
	  UFPrintP(up, " %s%s", CmdCommand(cp),
		   (CmdUnexpected(cp) ? "." : "")); }
	else if (CmdEntry(cp) == UFECOMMENT) {
	  UFPrintP(up, "%s", CmdCommand(cp)); } }
      UFPrintP(up, "\n");
      if ((cp= UFSpecialCmd(mp, UFEINT))) {
	UFPrintP(up, "Integer default: %s\n", CmdCommand(cp)); }
      if ((cp= UFSpecialCmd(mp, UFEREAL))) {
	UFPrintP(up, "Real default: %s\n", CmdCommand(cp)); } }

    { Cmd_t *cp;
      if ((cp= UFSpecialCmd(mp, UFEDEFAULT))) {
	UFPrintP(up, "Default: %s\n", CmdCommand(cp)); } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int UFQuestionSkip(up)
     UF_t *up;
{
  char *b;

  UFSkipEmpty(up);		/* discard empty scratch buffers */

  if ((b= UFSkipToTest(up, UFBufferP(up,UFBufIdx(up)), UFQuestion(up)))) {
    b++;
    if (UFstopTyp(up, *b) != UFSUNEXPECTED) { /* ?-char part of keyword */
      UFBufferP(up,UFBufIdx(up))= b;
      UFSkipTo(up, UFQueueBreak(up));
      return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static Cmd_t *UFRealCmd(up, mp)
     UF_t *up;
     Men_t *mp;
{
  Cmd_t *cp;
  if ((cp= UFSpecialCmd(mp, UFEREAL))) {
    double r;
    double p;
    char *stp;
    if (UFRealTest(up, UFBufferP(up,UFBufIdx(up)), CmdUnexpected(cp),
		   &r, &p, &stp)) {
      return cp; } }
  return NULL;
}
/* ---------------------------------------------------------------------- */
int UFRealGet(up, bp, unexpected, number, precision)
     UF_t *up;
     char **bp;
     int unexpected;
     double *number;
     double *precision;
{
  char *stp;
  /*  printf("UFRealGet\n");*/
  if (!up || !bp || !*bp || !number || !precision) {
    UFsetErrNo(UFPOINT); return FALSE; }
  else if (UFRealTest(up, *bp, unexpected, number, precision, &stp)) {
    *bp= stp; UFItemTyp(up)= UFIREAL; return TRUE; }
  else {
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int UFRealTest(up, buffer, unexpected, r, p, stp)
     UF_t *up;
     char *buffer;
     int unexpected;
     double *r;
     double *p;
     char **stp;
{
  char *b=buffer;
  int digitCount= 0;
  int sign= 1;
  double base= 10.;
  double prec= 1.;
  double tmp= 0.;

  /*  printf("UFRealTest %s\n", b);*/
  while (!UFisSign(*b) && !UFisDecDigit(*b) && *b != '.') {
    if (strchr(UFWhiteSpace(up), *b)) { b++; }
    else { return FALSE; } }

  if (UFisSign(*b)) {
    if (*b++ == '-') { sign = -1; } }

  while (*b) {
    if (UFisDecDigit(*b)) {
      UFappendDigit(tmp,base,*b);
      digitCount++;
      b++;
    }
    else if (*b == '.') {	/* beyond decimal point */
      b++;
      while (*b && UFisDecDigit(*b)) {
	prec *= 0.1;
	UFappendFraction(tmp,prec,*b);
	digitCount++;
	b++;
      }
      break;
    }
    else {
      break;
    }
  }

  if (*b == 'e' || *b == 'E') {
    int digitCountE= 0;
    int signE= 1;
    double exponent= 0;

    b++;
    if (UFisSign(*b)) {
      if (*b++ == '-') {
	signE= -1;
      }
    }

    while (*b) {
      if (UFisDecDigit(*b)) {
	UFappendDigit(exponent,10.,*b);
	digitCountE++;
	b++;
      }
      else {
	break;
      }
    }

    if (digitCountE == 0 ||	/* no valid digits found */
	isnan(tmp)) {
      return FALSE; }

    exponent *= signE;
    exponent= pow(10., exponent);
    prec *= exponent;
    tmp *= exponent;
  }

  if (digitCount == 0 ||	/* no valid digits found */
      (!unexpected && UFstopTyp(up,*b) == UFSUNEXPECTED) ||
      isnan(tmp)) {
    return FALSE;
  }

  *r= tmp * sign;
  *p= prec;
  *stp= b;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int UFReset(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return FALSE; }
  else {
    while (UFFilIdx(up) > 0) { UFFileClose(up); }
    while (UFBufIdx(up) > 0) { UFBufferPrev(up); }
    /* DUKE (-e):    while (UFBufIdx(up) >= 0) { UFBufferPrev(up); }  so nicht ! */
    UFBufferPrev(up);
    UFBufferClear(up, UFBufIdx(up));
    UFUpdateStat(up)= UFUREQINP;
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int UFResetIllegal(up)
     UF_t *up;
{
  if (up == NULL) { UFsetErrNo(UFPOINT); return FALSE; }
  else {
    if (UFBufIdx(up) < 0) {
      UFPrintE(up, "fatal: internal reset error\n"); }
    else {
      char *p= UFBufferP(up, UFBufIdx(up));

      if (*p) {
	char *pmt= UFPrompt(up);

	if (p[strlen(p)-1] == '\n') { p[strlen(p)-1]= '\0'; }
	if (!pmt) { pmt= ""; }
	UFPrintE(up, "fatal: illegal input (%s) '%s'\n", pmt, p); } }
/*
    return UFReset(up); 

    stattdessen untige 2 Zeilen
*/
    UFUpdateStat(up)= UFUREQINP;
    return TRUE;
  }
}
/* ---------------------------------------------------------------------- */
static void InputLoop(up)
     UF_t *up;
{
  /*  printf("InputLoop\n");*/
  if (UFMenIdx(up) >= 0) {
    char buffer[UFINPBUFLEN];
    int bufLen= 0;

    while (UFUpdateStat(up) == UFUREQINP) {
      if (UFTermScan(up, buffer+bufLen, UFINPBUFLEN-bufLen)) {
	bufLen= strlen(buffer);
	if (bufLen < 1 || strncmp(buffer+bufLen-2, "\\\n", 2)) {
	  UFBufferSet(up, buffer); bufLen= 0;
	  break; } } } }
  return;
}
/* ---------------------------------------------------------------------- */
void UFSimpleInit(up)
     UF_t *up;
{
  UFInputLoop(up)= InputLoop;
  return;
}
/* ---------------------------------------------------------------------- */
int UFSkipEmpty(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return TRUE; }
  else {
    int i= UFBufIdx(up);
    /* DUKE (-e)   while (i >= 0 && wahrscheinlich so nicht*/
    while (i > 0 &&
	   UFStringEmpty(up, UFBufferP(up,i)) &&
	   UFBufferTyp(up,i) == UFBSCRATCH &&
	   UFBufferPrev(up)) {
      i= UFBufIdx(up); }
    if (UFBufIdx(up) < 0) { UFsetErrNo(UFNOBUF); return TRUE; }
    return UFStringEmpty(up, UFBufferP(up,i)); }
}
/* ---------------------------------------------------------------------- */
int UFSkipTo(up, s)
     UF_t *up;
     char *s;
{
  char *p;

  if (!up) { UFsetErrNo(UFPOINT); return 0; }
  else {
    int i= UFBufIdx(up);
    while (i >= 0 &&
	   !(p= UFSkipToTest(up, UFBufferP(up,i), s)) &&
	   UFStringEmpty(up, UFBufferP(up,i)) &&
	   UFBufferTyp(up,i) == UFBSCRATCH) { i--; }
    if (i < 0) { UFsetErrNo(UFNOBUF); return 0; }
    else if (p) {
      char c= *p++; 
      /* DUKE (-e)      while (UFBufIdx(up) >= i) { UFBufferPrev(up); } so nicht */
      while (UFBufIdx(up) > i) { UFBufferPrev(up); }
      UFBufferP(up,i)= p;
      return (int)c; }
    else { return 0; } }
}
/* ---------------------------------------------------------------------- */
char *UFSkipToTest(up, b, s)
     UF_t *up;
     char *b;
     char *s;
{
  if (!up || !b) { UFsetErrNo(UFPOINT); return NULL; }
  else {
    while (*b) {
      if (strchr(s,*b)) { return b; }
      else if (strchr(UFWhiteSpace(up), *b)) { b++; }
      else if (!strncmp(b, "\\\n", 2)) { b += 2; }
      else { break; } }
    return NULL; }
}
/* ---------------------------------------------------------------------- */
static Cmd_t *UFSpecialCmd(mp, entry)
     Men_t *mp;
     int entry;
{
  if (mp) {
    if (VecNum(MenCt(mp))) {
      int i;
      CmdVec_t c= MenCt(mp);
      Cmd_t *cp= VecP(c);
      for (i= 0; i< VecNum(c); i++, cp++) {
	if (CmdEntry(cp) == entry) {
	  return (cp); } } }
    if (VecNum(MenDt(mp))) {
      int i;
      CmdVec_t c= MenDt(mp);
      Cmd_t *cp= VecP(c);
      for (i= 0; i< VecNum(c); i++, cp++) {
	if (CmdEntry(cp) == entry) {
	  return (cp); } } } }
  return NULL;
}
/* ---------------------------------------------------------------------- */
int UFStopTyp(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return UFSUNEXPECTED; }
  else {
    int i= UFBufIdx(up);
    /* DUKE (-e)    while (i >= 0 && !*UFBufferP(up,i) && wahrscheinlich so nicht*/
    while (i > 0 && !*UFBufferP(up,i) &&
	   UFBufferTyp(up,i) == UFBSCRATCH &&
	   UFBufferPrev(up)) {
      i= UFBufIdx(up); }
    return UFstopTyp(up, *UFBufferP(up,i)); }
}
/* ---------------------------------------------------------------------- */
static int UFStringEmpty(up, s)
     UF_t *up;
     char *s;
{
  if (!s) { return TRUE; }
  while (*s && strchr(UFWhiteSpace(up), *s)) { s++; }
  return (*s == '\0');
}
/* ---------------------------------------------------------------------- */
static int ufOutputSuspended= FALSE;
static int ufPosCol= 0;
static int ufPosLin= 0;
static int ufColumns= 80;
static int ufLines= 24;
/* ---------------------------------------------------------------------- */
static int UFTermPrint(up, fp, paged, line)
     UF_t *up;
     FILE *fp;
     int paged;
     char *line;
{
  if (!paged) { ufPosLin= 1; }
  if (ufOutputSuspended) { return TRUE; }
  else {
    char *lp= line;

    while (!ufOutputSuspended && *lp) {
      int col= ufColumns - ufPosCol;
      char *p= UFTermTextBreak(up, lp, col);
      char b= *p;

      *p= '\0';
      fputs(lp, fp);
      ufPosCol= b ? 0 : ufPosCol + strlen(lp);
      *p= b;
      lp= (b == '\n') ? p+1 : p;

      if (paged && ufPosLin > ufLines) {
	int c;

	c= fgetc(stdin);
	if (c == 'q') {
	  ufOutputSuspended= TRUE;
	  fputs("\nskipping ...\n", fp);
	  ufPosLin= 1;
	  return TRUE; }
	else if (c == ' ') { ufPosLin= 1; } }

      if (ufPosCol == 0) {
	fputc('\n', fp);	/* delayed newline */
	if (paged) { ufPosLin++; } } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int UFTermScan(up, buffer, bufLen)
     UF_t *up;
     char *buffer;
     int bufLen;
{
#ifdef HAS_GNU_READLINE
  char *inputline;
  extern void add_history();	/* that does not depend on location of */
  extern char *readline();	/* include files readline.h history.h */
  char prompt[UFMAXBUFLEN];

  sprintf(prompt, "%s ", UFPrompt(up));

  /*  printf("UFTermScan\n");*/
  if ((inputline= readline(prompt))) {
    char *s;
    int l= strlen(inputline);
    if ((l && inputline[l-1] != '\n' && l+1 >= bufLen) ||
	l >= bufLen) {
      UFPrintE(up, "line length exceeds internal buffer length\n");
      *buffer= '\0';
      return FALSE; }
    else if ((s= UFSkipToTest(up, inputline, UFQueueBreak(up))) && !*(s+1)) {
      add_history(inputline); }
    strcpy(buffer, inputline);
    if (!l || buffer[l-1] != '\n') {
      buffer[l]= '\n'; buffer[l+1]= '\0'; } } /* append newline */
#else
  fprintf(stdout, "%s ", UFPrompt(up));
  if (fgets(buffer, bufLen, stdin)) {
    int l= strlen(buffer);
    if (l && l >= bufLen-1 && buffer[l-1] != '\n') {
      fprintf(stderr, "internal buffer overflow during read\n");
      *buffer= '\0';
      return FALSE; } }
#endif

  else {
    buffer[0]= '\004'; buffer[1]= '\0'; /* ctrl-d */
    fputc('\n', stdout); }
  ufPosLin= 0;
  ufPosCol= 0;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static char *UFTermTextBreak(up, text, col)
     UF_t *up;
     char *text;
     int col;
{
  if (!text || !*text) { return text; }
  else {
    int i;
    char *t= NULL;
    int l= MIN(strlen(text),col);

    for (i= 0; i< l && text[i] != '\n'; i++) {
      if (strchr(UFWhiteSpace(up), text[i]) ||
	  strchr(UFQueueBreak(up), text[i])) {
	t= text + i; } }
    if (text[i] == '\n') { return (text + i); }
    else if (t && l < strlen(text)) { return (t + 1); }
    else { return (text + l); } }
}
/* ---------------------------------------------------------------------- */
static int UFUpdateBuffer(up)
     UF_t *up;
{
  if (!up) { UFsetErrNo(UFPOINT); return UFUERROR; }
  else {
    int b;

    /*    printf("UFUpdateBuffer\n");*/
    while ((b= UFBufIdx(up)) >= 0) {
      switch (UFUpdateStat(up)) {
      case UFUCANCEL:
      case UFUEOF:
      case UFUERROR:
      case UFUREQINP:
	return UFUpdateStat(up);
      default:
	if (!UFUpdateVar(up)) {
	  return (UFUpdateStat(up)= UFUERROR); }
	else if (UFUpdateQueueBreak(up)) {
	  return (UFUpdateStat(up)= UFUQBREAK); }
	else if (UFSkipTo(up, UFShell(up))) {
	  UFExecuteShell(up); }
	else if (UFSkipTo(up, UFComment(up))) {
	  UFBufferClear(up,b); }
	else if (UFSkipTo(up, UFConditional(up))) {
	  if (UFNoConditional(up)) {
	    UFBufferClear(up,b); }
	  else {
	    continue; } }
	else if (UFSkipTo(up, UFFile(up))) {
	  char file[MAXPATHLEN];

	  if (UFItemRead(up, file, MAXPATHLEN, "command input file")) {
	    extern int errno;
	    errno= 0;
	    if (!UFFileOpen(up, file, TRUE, TRUE)) {
	      UFPrintM(up,
		       "error: command input file '%s' not opened\n", file);
	      if (UFErrNo && UFErrNo != UFCMDOPEN) {
		UFPrintM(up, "%s\n", UFError(UFErrNo)); }
	      if (errno) {
		UFPrintM(up, "system: %s\n", strerror(errno)); }
	      return (UFUpdateStat(up)= UFUERROR); } }


	}
	else if (UFSkipEmpty(up)) { UFUpdateInput(up); }
	else { return (UFUpdateStat(up)= UFUTEXT); } } }
    UFsetErrNo(UFNOBUF);
    return (UFUpdateStat(up)= UFUERROR); }
}
/* ---------------------------------------------------------------------- */
static int UFUpdateInput(up)
     UF_t *up;
{
  int b;

  UFSkipEmpty(up);		/* remove UFBSCRATCH-buffers */
  b= UFBufIdx(up);
  UFBufferClear(up,b);
  switch (UFBufferTyp(up,b)) {
  case UFBFILE: {
    int continuation= TRUE;
    int f= UFBufferFilIdx(up,b);

    while (continuation && f >= 0 && b >= 0) {
      char *s;

      AlcCheck();

      if ((s= fgets(UFBufferB(up,b), UFBufferLen(up,b), UFFileFp(up,f)))) {
	int l= strlen(s);

	UFFileLine(up,f)++;

	if (l && l >= UFBufferLen(up,b)-1 && UFBufferB(up,b)[l-1] != '\n') {
	  UFoverflow(up,"UFUpdateRead"); 
	  return (UFUpdateStat(up)= UFUERROR); }
	else { continuation= (l > 1 && UFBufferB(up,b)[l-2] == '\\'); }

	if (UFFileProtocol(up,f)) {
	  UFPrintM(up, "%s ", UFPrompt(up));
	  UFPrintM(up, s); }
	return (UFUpdateStat(up)= UFUTEXT); }
      else if (UFFileAutoEof(up,f)) {
	UFBufferPrev(up);
	if (strlen(UFBufferB(up,b))) {
	  printf ("passiert das ? strlen(UFBufferB(up,b))\n");
	  return (UFUpdateStat(up)= UFUTEXT); }
	else {
	  UFSkipEmpty(up);	/* remove UFBSCRATCH-buffers */
/* Auskommentierungen im Zuge von DUKE (-e)
   keine Ahnung, ob das nicht irgendwelche boesen Auswirkungen hat
   getest: commandfile aufruf (geschachtelt (1-fach)) geht!
   -e geht auch
   also lassen wir es erstmal so (os, schmidt)
   */
#if 0
///	  b= UFBufIdx(up);
//	  UFBufferClear(up,b);
//	  f= UFBufferFilIdx(up,b);
//	  continuation= TRUE; } }
//      return (UFUpdateStat(up)= UFUTEXT); } } ist alles egal
//      return (UFUpdateStat(up)= UFUQBREAK); } } das geht wohl auch
#endif
return (UFUpdateStat(up)= UFUEMPTY); } }
      else {
	UFBufferPrev(up);
	return (UFUpdateStat(up)= UFUEOF); } } }
  case UFBTERM:
  default:
    return (UFUpdateStat(up)= UFUREQINP); }
}
/* ---------------------------------------------------------------------- */
int UFUpdateQueueBreak(up)
     UF_t *up;
{
  if (UFSkipTo(up, UFQueueBreak(up))) {
    UFUpdateStat(up)= UFUQBREAK;
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int UFUpdateVar(up)
     UF_t *up;
{
  int i= UFBufIdx(up);
  char arg[UFMAXARGLEN];
  
  if (UFArgGet(up, &UFBufferP(up,i), arg, UFMAXARGLEN)) {
    return (UFBufferNext(up, UFBSCRATCH, -1) &&
	    UFArgCopy(up, i-1, arg, UFMAXARGLEN,
		      UFBufferP(up,i+1), UFBufferLen(up,i+1))); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */

#ifdef UltrixArchitecture

/* --- Server --- */
static SERVICE *service1, *service2;
static int ServerMode;
static char net_request[65536];

#define ON 1
#define OFF 0
#define ERROR -1
#define NORMAL 1

int Offer_UDP_Service ()
{
  service1 = add_service(CN_FLAG_SERVICE_BY_PORT, 25001);
  if (service1 == NULL){
    print_error(ERROR_STACK);
    return ERROR;}
  service2 = add_service(CN_FLAG_LOCAL_SERVICE, "tv.udp");
  if (service2 == NULL){
    print_error(ERROR_STACK);
    remove_service(service1);
    return ERROR;}
  
  puts ("added service tv.udp (port 25001)\n");
   if (fcntl (service1->sd, F_SETFL, FASYNC)<0){
     puts("no fasync on service1");
     return ERROR;}
   if (fcntl (service2->sd, F_SETFL, FASYNC)<0){
     puts("no fasync on service2");
     return ERROR;}
  
  return NORMAL;
}

int Remove_UDP_Services (void)
{
  remove_service(service1);
  remove_service(service2);
  return NORMAL;
}

int Wait_UDP_Request (void)
{
  CONNECTION *c;
  
  for (;;){
    c = wait_connection();
    if (c != NULL){
      int size;
      if (recv_connection(c, net_request, &size, 1024) < 0) {
	print_error(ERROR_STACK); }
      else {			/* antworten */
	if (send_connection(c, "EOT", 1024)){
	  print_error(ERROR_STACK);}}}}
}

/* --- Client --- */

/* Return values: length of answer string
                  ERROR on error */

int Request_UDP_Service (answer, request, host, service)
     char *answer;		/* answer from server */
     char *request;		/* request to server */
     char *host;		/* host the service is running on */
     char *service;		/* name of service */
{
  
  CONNECTION *c;

  if (!strcmp (host, "local")){
    c = open_connection(CN_LOCAL_HOST, CN_FLAG_LOCAL_SERVICE, service);}
  else{
    c = open_connection(host, CN_FLAG_SERVICE_BY_PORT, 25001);}
  if (c == NULL){
    print_error(ERROR_STACK);
    exit(0);    }
  else {
    set_timeout(c, 5);}

  if (send_connection(c, request, (signed)(strlen (request) + 1)) < 0) {
    print_error(ERROR_STACK);}
  else {
    do {
      int size;
      if (recv_connection(c, answer, &size, 1024) < 0){
	print_error(ERROR_STACK);
	return -1;}
      printf ("Received answer from server %s: %s\n", 
	      c->servername,
	      answer);}
    while (!strcmp (answer, "EOT"));}
  close_all_connections();
  return strlen (answer);
}

int Enter_ServerMode (){
  ServerMode = ON;
  Offer_UDP_Service ();
  return TRUE;
}

int Leave_ServerMode (){
  ServerMode = OFF;
  Remove_UDP_Services ();
  return TRUE;
}

#endif
