/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsUserFace.h,v 1.4 1994/12/08 20:44:40 vs Exp vs $ */

#ifndef _vsUserFace_h
#define _vsUserFace_h

#include <stdio.h>
#include <string.h>
#include <sys/param.h>

#ifdef __STDC__
# include <stdarg.h>
#else
# include <varargs.h>
#endif

#include <tv/vsConfig.h>

#ifndef TRUE
# define TRUE	1
# define FALSE	0
#endif

#ifndef NULL
# define NULL	0
#endif

#ifndef ABS
# define ABS(x)			(((x) < 0) ? -(x) : (x))
#endif
#ifndef MIN
# define MIN(x,y)		(((x) < (y)) ? (x) : (y))
#endif
#ifndef MAX
# define MAX(x,y)		(((x) > (y)) ? (x) : (y))
#endif
#ifndef NINT
# define NINT(x)		((int)((x < 0.) ? (x - .5) : (x + .5)))
#endif

/* max. length of character lists */
#define UFMAXCHAR		128
#define UFMAXKEY		128
#define UFMAXBUFLEN		8192
#define UFMAXARGLEN		1024
#define UFMAXPMTLEN		1024
#define UFINPBUFLEN		1024

/* type of buffer */
#define UFBTERM			1
#define UFBFILE			2 /* os Annahme: indirektes File (auch command file genannt) */
#define UFBSCRATCH		3

/* types of pointers to be operated */
#define UFOMENU			1
#define UFOFCT			2
#define UFOFACEFCT		3
#define UFOSTRING		4

/* loop modes */
#define UFLLOOP			1
#define UFLLOOPQB		2
#define UFLSINGLELOOP		3
#define UFLSINGLE		4
#define UFLEXIT			5

/* loop part */
#define UFLPENTER		1
#define UFLPENTRY		2
#define UFLPHEAD		3
#define UFLPCORE		4
#define UFLPTAIL		5
#define UFLPEXIT		6

/* menu entries */
#define UFEDEFAULT		1
#define UFEREAL			2
#define UFEINT			3
#define UFEEXIT			4
#define UFEENTER		5
#define UFEERROR		6
#define UFECANCEL		7
#define UFELOOPQB		8
#define UFEENTRYQB		9
#define UFESTANDARD		10
#define UFECMD			11
#define UFEEOF			12
#define UFELOOPHEAD		13
#define UFELOOPTAIL		14
#define UFECOMMENT		15

/* scan stop modes */
#define UFSQBREAK		1
#define UFSWHITESPACE		2
#define UFSUNEXPECTED		3
#define UFSSTRINGEND		4

/* item types */
#define UFIERROR		1
#define UFINONE			2
#define UFITEXT			3
#define UFIINT			4
#define UFIREAL			5
#define UFIQUOTES		6
#define UFIPARENTHESES		7

/* update status */
#define UFUERROR		1
#define UFUQBREAK		2
#define UFUTEXT			3
#define UFUEOF			4
#define UFUCANCEL		5
#define UFUEMPTY		6
#define UFUREQINP		7

/* error codes */
#define UFNOERR		 0 /* "vsUserFace: no error" */
#define UFPOINT		 1 /* "vsUserFace: illegal NULL-pointer" */
#define UFALLOC		 2 /* "vsUserFace: memory allocation failed" */
#define UFBUFEXC	 3 /* "vsUserFace: maximal buffer length exceeded" */
#define UFBUFNUM	 4 /* "vsUserFace: maximal buffer number exceeded" */
#define UFFILNUM	 5 /* "vsUserFace: maximal file number exceeded" */
#define UFMENNUM	 6 /* "vsUserFace: maximal menu number exceeded" */
#define UFPARVAL	 7 /* "vsUserFace: illegal setup parameter value" */
#define UFOPTYP		 8 /* "vsUserFace: illegal operation type" */
#define UFNOBUF		 9 /* "vsUserFace: no buffer available" */
#define UFEOS		10 /* "vsUserFace: unexpected end of string found" */
#define UFCMDOPEN	11 /* "vsUserFace: command file not opened" */
#define UFNOTERM	12 /* "vsUserFace: no terminal read defined" */
#define UFNOFILE	13 /* "vsUserFace: no legal file specified" */
#define UFPRINT		14 /* "vsUserFace: internal print failed" */
#define UFNOMENU	15 /* "vsUserFace: no menu specified", */
#define UFLOCKED	16 /* "vsUserFace: locked -- waiting for input", */

#define UFsetErrNo(n)		{ UFErrNo= n; }

#ifdef _vsUserFace_c
int UFErrNo= UFNOERR;
#else
extern int UFErrNo;
#endif

typedef struct {
  char *title;
  int (*iFctn)();
} Fct_t;

typedef struct {
  int typ;
  pfi_t function;
  struct Men_t_ *menu;
  char *string;
} Op_t;

typedef struct {		/* command */
  int entry;
  int unexpected;
  int abbreviation;
  Op_t op;
  char *command;
  char *args;
} Cmd_t;

#define CmdEntry(cp)		((cp)->entry)
#define CmdUnexpected(cp)	((cp)->unexpected)
#define CmdAbbreviation(cp)	((cp)->abbreviation)
#define CmdOp(cp)		(&(cp)->op)
#define CmdCommand(cp)		((cp)->command)
#define CmdArgs(cp)		((cp)->args)

#define CmdTyp(cp)		(CmdOp(cp)->typ)
#define CmdFunction(cp)		(CmdOp(cp)->function)
#define CmdMenu(cp)		(CmdOp(cp)->menu)
#define CmdString(cp)		(CmdOp(cp)->string)

typedef struct {		/* vector of Cmd_t's */
  VecCorePart	core;
  Cmd_t		*p;
} CmdVecRec, *CmdVec_t;

struct Men_t_ {
  int entryMode;		/* UFLLOOP/UFLSINGLE/UFLSINGLELOOP/UFL... */
  char *args;			/* usage message */
  CmdVecRec at;			/* table of aliases */
  CmdVecRec ct;			/* table of commands */
  CmdVecRec dt;			/* table of default special menu entries */
};

#define MenEntryMode(mp)	((mp)->entryMode)
#define MenArgs(mp)		((mp)->args)
#define MenAt(mp)		(&(mp)->at)
#define MenCt(mp)		(&(mp)->ct)
#define MenDt(mp)		(&(mp)->dt)

typedef struct {
  int mode;
  int loopPart;			/* UFLPHEAD/UFLPCORE/UFLPTAIL */
  int loopStart;
  int inFunction;
  char *prompt;
  Men_t *menu;
} MenStat_t;

#define MenStatMode(m)		((m)->mode)
#define MenStatLoopPart(m)	((m)->loopPart)
#define MenStatLoopStart(m)	((m)->loopStart)
#define MenStatInFunction(m)	((m)->inFunction)
#define MenStatPrompt(m)	((m)->prompt)
#define MenStatMenu(m)		((m)->menu)

#define MenStatModeLoop(mp)	(MenStatMode(mp) == UFLLOOP)
#define MenStatModeSingle(mp)	(MenStatMode(mp) == UFLSINGLE)
#define MenStatModeSingleLoop(mp)	(MenStatMode(mp) == UFLSINGLELOOP)
#define MenStatModeExit(mp)	(MenStatMode(mp) == UFLEXIT)

#if 0				/* for future use */
typedef struct {
  Vec_t functions;
  Vec_t menus;
  Vec_t cmdTables;
  Vec_t aliasTables;
} UFEnv_t;
#endif				/* 0 */

typedef struct {
  int filIdx;
  int typ;
  int len;
  char *a;
  char *b;
  char *p;
} UFBuf_t;

typedef struct {
  FILE *fp;
  char *name;
  int autoEof;
  int protocol;
  int line;
} UFFil_t;

struct UF_t_ {
				/* input buffer section */
  int bufSiz;
  int bufNum;
  int bufIdx;
  UFBuf_t *buffers;
  int updateStat;
  /*  int inputMode; wird nicht verwendet DUKE */
  int keyProtocol;
				/* menu section */
  int menNum;
  int menIdx;
  int menLocked;
  char *lockedPrompt;
  char prompt[UFMAXBUFLEN];
  MenStat_t *menus;
				/* indirect file section */
  char *path;
  int filNum;
  int filIdx;
  int filBrk;
  UFFil_t *files;
				/* input parameter section */
  int noConditional;
  int itemTyp;			/* last special character */
  int stopTyp;
  char stopChar;
  char quote;
  char oParenthesis;
  char cParenthesis;
  char queueBreak[UFMAXCHAR];	/* special character sets */
  char whiteSpace[UFMAXCHAR];
  char comment[UFMAXCHAR];
  char shell[UFMAXCHAR];
  char conditional[UFMAXCHAR];
  char oParentheses[UFMAXCHAR];
  char cParentheses[UFMAXCHAR];
  char quotes[UFMAXCHAR];
  char file[UFMAXCHAR];
  char question[UFMAXCHAR];
  char stdPth[UFMAXCHAR];
  pfv_t inputLoop;		/* input loop for read int/item/real */
  pfi_t print;			/* output functions */
  pfi_t printPaged;
  void *printStdOut;		/* output destination */
  void *printStdErr;
  FILE *outFile;		/* destinations */
  FILE *cmdFile;
  char *outFileName;
  char *cmdFileName;
  FILE *stdOut;
  FILE *stdErr;
  void (*sockOut)(char*);
};

#define UFBufSiz(up)		((up)->bufSiz)
#define UFBufNum(up)		((up)->bufNum)
#define UFBufIdx(up)		((up)->bufIdx)
#define UFBuffers(up)		((up)->buffers)
#define UFBufferLen(up,i)	(UFBuffers(up)[i].len)
#define UFBufferA(up,i)		(UFBuffers(up)[i].a)
#define UFBufferB(up,i)		(UFBuffers(up)[i].b)
#define UFBufferP(up,i)		(UFBuffers(up)[i].p)
#define UFBufferTyp(up,i)	(UFBuffers(up)[i].typ)
#define UFBufferFilIdx(up,i)	(UFBuffers(up)[i].filIdx)

#define UFUpdateStat(up)	((up)->updateStat)
/* #define UFInputMode(up)		((up)->inputMode) wird nicht verwendet DUKE */

#define UFKeyProtocol(up)	((up)->keyProtocol)

#define UFMenNum(up)		((up)->menNum)
#define UFMenIdx(up)		((up)->menIdx)
#define UFMenLocked(up)		((up)->menLocked)
#define UFLockedPrompt(up)	((up)->lockedPrompt)
#define UFMenus(up)		((up)->menus)
#define UFMenu(up,i)		(UFMenus(up)+i)

#define UFPath(up)		((up)->path)
#define UFFilNum(up)		((up)->filNum)
#define UFFilIdx(up)		((up)->filIdx)
#define UFFilBrk(up)		((up)->filBrk)
#define UFFiles(up)		((up)->files)
#define UFFileFp(up,i)		(UFFiles(up)[i].fp)
#define UFFileName(up,i)	(UFFiles(up)[i].name)
#define UFFileAutoEof(up,i)	(UFFiles(up)[i].autoEof)
#define UFFileProtocol(up,i)	(UFFiles(up)[i].protocol)
#define UFFileLine(up,i)	(UFFiles(up)[i].line)

#define UFNoConditional(up)	((up)->noConditional)

#define UFItemTyp(up)		((up)->itemTyp)

#define UFStopChar(up)		((up)->stopChar)

#define UFQuote(up)		((up)->quote)
#define UFOParenthesis(up)	((up)->oParenthesis)
#define UFCParenthesis(up)	((up)->cParenthesis)

#define UFQueueBreak(up)	((up)->queueBreak)
#define UFWhiteSpace(up)	((up)->whiteSpace)
#define UFComment(up)		((up)->comment)
#define UFShell(up)		((up)->shell)
#define UFConditional(up)	((up)->conditional)
#define UFOParentheses(up)	((up)->oParentheses)
#define UFCParentheses(up)	((up)->cParentheses)
#define UFQuotes(up)		((up)->quotes)
#define UFFile(up)		((up)->file)
#define UFQuestion(up)		((up)->question)
#define UFStdPth(up)		((up)->stdPth)

#define UFInputLoop(up)		((up)->inputLoop)
#define UFPrint(up)		((up)->print)
#define UFPrintPaged(up)	((up)->printPaged)
#define UFPrintStdOut(up)	((up)->printStdOut)
#define UFPrintStdErr(up)	((up)->printStdErr)
#define UFOutFile(up)		((up)->outFile)
#define UFCmdFile(up)		((up)->cmdFile)
#define UFOutFileName(up)	((up)->outFileName)
#define UFCmdFileName(up)	((up)->cmdFileName)
#define UFStdOut(up)		((up)->stdOut)
#define UFStdErr(up)		((up)->stdErr)
#define UFSockOut(up)		((up)->sockOut)

#define UFPrintVarArgs(line,linLen,fmt,ap,status) \
{ *line= '\0';\
  if (fmt) {\
    vsprintf(line, fmt, ap);\
    if (!(status= (strlen(line) < linLen))) { UFsetErrNo(UFBUFEXC); } } }

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern int UFIntRead P_((UF_t *up, int unexpected, int *number,
			 char *fmt, ...));
extern int UFIntReadV P_((UF_t *up, int unexpected, int *number, char *fmt,
			  va_list ap));
extern int UFItemRead P_((UF_t *up, char *buffer, int bufLen,
			  char *fmt, ...));
extern int UFItemReadV P_((UF_t *up, char *buffer, int bufLen, char *fmt,
			   va_list ap));
extern int UFPrintE P_((UF_t *up, char *fmt, ...));
extern int UFPrintEV P_((UF_t *up, char *fmt, va_list ap));
extern int UFPrintM P_((UF_t *up, char *fmt, ...));
extern int UFPrintMV P_((UF_t *up, char *fmt, va_list ap));
extern int UFPrintP P_((UF_t *up, char *fmt, ...));
extern int UFPrintPV P_((UF_t *up, char *fmt, va_list ap));
extern int UFRealRead P_((UF_t *up, int unexpected, double *number,
			  double *precision, char *expectfmt, ...));
extern int UFRealReadV P_((UF_t *up, int unexpected, double *number,
			   double *precision, char *fmt, va_list ap));

#include <tv/vsUserFaceF.h>

#undef P_

#endif				/* _vsUserFace_h */
