/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsXuserFace.c,v 1.4 1994/12/08 20:44:42 vs Exp vs $ */

#define _vsXuserFace_c
#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif


#include <tv/vsConfig.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>

#include <X11/IntrinsicP.h>

/* BUG IN X11 include files !!!! */

#ifdef HAS_XAW3D
#include <X11/Xaw3d/Paned.h>
#include <X11/Xaw3d/Label.h>
#include <X11/Xaw3d/Box.h>
#else
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Box.h>
#endif
				/* ======================== */
				/* vs library include files */
				/* ======================== */
#include "vsTypes.h"
#include "vsAlloc.h"
#include "vsKey.h"
#include "vsUserFace.h"

#ifdef HAS_XAW3D
# include <X11/Xaw3d/AsciiText.h>
#else
# include "AsciiText.h"
#endif

#include "vsXuserFace.h"
#include "vsXuserFaceP.h"
#include "OsConnection.h"
/* ---------------------------------------------------------------------- */
#define MAXKEYSEQLEN	255
static XawTextBlock xufTextBlock= { 0, 0, NULL, 0 };
static UF_t *xuf= NULL;
static Keytable_t xufKeytable= NULL;
static Widget xufIO= NULL;
static Widget xufIOPaned= NULL;
/*static Widget xufViewIO= NULL;*/
static Widget xufKeyWidget= NULL;
static Widget xufKeyLabel= NULL;
static int xufKeyX= -1;
static int xufKeyY= -1;
static Boolean xufKeyrequest= FALSE;
static XtAppContext xufApp= NULL;
static char *xufString= NULL;
static char xufKeysequence[MAXKEYSEQLEN+1] = { '\0', };
static int xufIllegalKey= FALSE;
static XawTextPosition xufStringLength= 0;
static XawTextPosition xufStringMinReserve= 0;
static XawTextPosition xufStringMaxReserve= 0;
static Boolean xufPrompted= FALSE;
static XtActionsRec xufActions[] = {
  { "cancel-keyrequest", CancelKeyrequest },
  { "cancel-keysequence", CancelKeysequence },
  { "execute-command", ExecuteCommand },
  { "execute-keysequence", ExecuteKeysequence },
  { "execute-string", ExecuteString },
};
/* ---------------------------------------------------------------------- */
static Boolean Append(text, length)
     char *text;
     int length;
{
  if (!text) { return FALSE; }
  else {
    int status;
    XawTextPosition eot= strlen(xufString);

    length= length ? length : strlen(text);
    xufTextBlock.length= length;
    xufTextBlock.ptr= text;
#ifdef HAS_XAW3D
    status= (XawTextReplace(xufIO, eot, eot, &xufTextBlock) == XawEditDone);
#else
    status= (TvXawTextReplace(xufIO, eot, eot, &xufTextBlock) == XawEditDone);
#endif
    return status; }
}
/* ---------------------------------------------------------------------- */
static Boolean CheckReserve()
{
  XawTextPosition eot= strlen(xufString);

  if (xufStringLength - eot < xufStringMinReserve) {
    int status;
    xufTextBlock.length= xufStringLength - xufStringMaxReserve;
    xufTextBlock.ptr= xufString + xufStringMaxReserve - xufStringLength + eot;
#ifdef HAS_XAW3D
    status= (XawTextReplace(xufIO, 0, eot, &xufTextBlock) == XawEditDone);
#else
    status= (TvXawTextReplace(xufIO, 0, eot, &xufTextBlock) == XawEditDone);
#endif
    return status; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static void CancelKeyrequest(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
  xufKeyrequest= FALSE;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static void CancelKeysequence(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
  xufIllegalKey= FALSE;
  if (*xufKeysequence) { *xufKeysequence= '\0'; SetLabel(); }
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static void ExecuteCommand(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
  if (w != xufIO) { return; }
  else {
    XawTextPosition eot;	/* end of text */
    XawTextPosition bol;	/* begin of line */
    XawTextPosition eol;	/* end of line */
    int pmtLen= 0;
    char *prompt= UFPrompt(xuf);

    eot= strlen(xufString);
#ifdef HAS_XAW3D
    bol= eol= XawTextGetInsertionPoint(w);
#else
    bol= eol= TvXawTextGetInsertionPoint(w);
#endif

    if (bol > eot) { bol= eol= eot; }

    while (bol > 0 && xufString[bol-1] != '\n') { bol--; }
    while (xufString[eol] && xufString[eol] != '\n') { eol++; }

    if (prompt && !strncmp(xufString + bol, prompt, strlen(prompt))) {
      char *p;
      pmtLen= strlen(prompt); 
      p= xufString + bol + pmtLen;
      while (*p && strchr(UFWhiteSpace(xuf), *p)) { p++; pmtLen++; } }

    if (eol == eot) { Append("\n", 1); eot= bol + pmtLen; }
    else {
      UpdatePrompt(); eot += strlen(xufString + eot);
      Append(xufString + bol + pmtLen, eol - bol - pmtLen + 1); }
    xufPrompted= FALSE;
    UFBufferSet(xuf, xufString + eot);
    CheckReserve();

    xufKeyX= -1;		/* reset coordinates for */
    xufKeyY= -1;		/* text input processing */

    return; }
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static void ExecuteKeysequence(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
  switch (event->type) {
  case KeyPress:
  case KeyRelease: {
    XawTextPosition eok;

    xufKeyX= event->xkey.x;
    xufKeyY= event->xkey.y;
    xufKeyWidget= w;

    if (xufIllegalKey) { CancelKeysequence(w, event, params, num_params); }
      
    if (xufKeyrequest) { return; }

    if ((eok= strlen(xufKeysequence)) == MAXKEYSEQLEN-1) {
      *xufKeysequence= '\0'; }
    else {
      String buf;
      String keystring= xufKeysequence + eok;
      int klen;
      KeySym keysym;

      if (xufKeytable &&
	  (klen= XLookupString((XKeyEvent *)event,
			       keystring, MAXKEYSEQLEN - eok - 1,
			       &keysym, NULL))) {
	keystring[klen]= '\0';
	switch (KTGetKeyAlias(xufKeytable, xufKeysequence, &buf)) {
	case KTINCOMPL:
	  if (strlen(xufKeysequence) == MAXKEYSEQLEN-1) {
	    *xufKeysequence= '\0'; }
	  break;
	case KTKEYFOUND:
	  xufKeyX= event->xkey.x;
	  xufKeyY= event->xkey.y;
	  xufKeyWidget= w;

	  UpdatePrompt();

	  Print(NULL, buf);
	  UFBufferSet(xuf, buf);
	  CheckReserve();
	  *xufKeysequence= '\0';
	  break;
	case KTILLKEY:
	  xufIllegalKey= TRUE;
	  break;
	default:
	  *xufKeysequence= '\0'; break; } } }
    if (strlen(xufKeysequence) != eok) { SetLabel(); } }
  default:			/* no key event => do nothing */
    return; }
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static void ExecuteString(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
  xufKeyX= event->xkey.x;
  xufKeyY= event->xkey.y;
  xufKeyWidget= w;

  if (xufKeyrequest || *num_params != 1) { return; }

  UpdatePrompt();

  Print(NULL, params[0]);
  UFBufferSet(xuf, params[0]);
  CheckReserve();
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static void FreeString(w, unused, unused_too)
     Widget w;
     XtPointer unused;
     XtPointer unused_too;
{
  Free(xufString);
  xufStringLength= 0;
  return;
}
/* ---------------------------------------------------------------------- */
static int GetKeyCoordinate(coord)
     int *coord;
{
  if (*coord < 0) {
    XEvent event;
    Arg arg;

    xufKeyrequest= TRUE;
    XtSetArg(arg, XtNeditType, XawtextRead); XtSetValues(xufIO, &arg, 1);
    while (*coord < 0 && xufKeyrequest) {
      XtAppNextEvent(xufApp, &event);
      XtDispatchEvent(&event); }
    XtSetArg(arg, XtNeditType, XawtextEdit); XtSetValues(xufIO, &arg, 1);
    xufKeyrequest= FALSE; }
  { int r= *coord; *coord= -1; return r; }
}
/* ---------------------------------------------------------------------- */
static void InputLoop(up)
     UF_t *up;
{
  XEvent event;

  SetInsertionPoint();
#if HAS_CONNECTIONOS
  tvConnectionSendACK ();	/* is done only if there is someone waiting */
#endif
  while (UFUpdateStat(up) == UFUREQINP) {
    if (!xufPrompted) { PrintPrompt(); }
    XtAppNextEvent(xufApp, &event);
    XtDispatchEvent(&event); 
  }
  return;
}
/* ---------------------------------------------------------------------- */
static void UpdatePrompt()
{
  String prompt;
  XawTextPosition bol;
  XawTextPosition eot= strlen(xufString);
  prompt= UFPrompt(xuf);
  bol= eot;
  while (bol > 0 && xufString[bol-1] != '\n') { bol--; }

  if (prompt) {
    int pmtLen= strlen(prompt);
    if (strncmp(xufString + bol, prompt, (unsigned int)pmtLen)) {
      PrintPrompt(); }
    else {
      char *p= xufString + bol + pmtLen;
      if (*p == '\0') { Append(" ", 1); }
      else {
	while (*p) {
	  if (strchr(UFWhiteSpace(xuf), *p)) { p++; }
	  else { PrintPrompt(); return; } } } } }
  else if (bol != eot) { PrintPrompt(); }
  return;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static int Print(dummy, text)
     void *dummy;
     char *text;
{
  CheckReserve();
  xufPrompted= FALSE;
  return Append(text, 0);
}
/* ---------------------------------------------------------------------- */
static Boolean PrintPrompt()
{
  XawTextPosition eot;
  Boolean status;

  status= CheckReserve();

  if ((eot= strlen(xufString)) && xufString[eot-1] != '\n') {
    UFPrintM(xuf, "\n"); }

  SetInsertionPoint();  
  { XEvent event;
    while (XtAppPending(xufApp)) {
      XtAppNextEvent(xufApp, &event);
      XtDispatchEvent(&event); } }
  status = (status && UFPrintM(xuf, "%s ", UFPrompt(xuf)));
  SetInsertionPoint();  
  xufPrompted= TRUE;
  return status;
}
/* ---------------------------------------------------------------------- */
static void SetInsertionPoint()
{
  int eot= strlen(xufString);
#if 0
  TextWidget tw= (TextWidget)xufIO;

  if (tw->text.lt.lines > 0 &&
      tw->text.lt.info[tw->text.lt.lines].position < eot) {
    XawTextSetInsertionPoint(xufIO, eot);
				/* bug fix for text widget:
				 * positioning does not work for wrapping
				 */

    while (tw->text.lt.lines > 0 &&
	   tw->text.lt.info[tw->text.lt.lines].position < eot) {
      Arg arg;
      XtSetArg(arg, XtNdisplayPosition,
	       tw->text.lt.info[tw->text.lt.lines].position);
      XtSetValues(xufIO, &arg, 1); } }
#endif			/* 0 */
#ifdef HAS_XAW3D
  XawTextSetInsertionPoint(xufIO, eot);
#else
  TvXawTextSetInsertionPoint(xufIO, eot);
#endif
  /*XawViewportSetLocation(xufViewIO, (double)0.0, (double)1.0);*/
}
/* ---------------------------------------------------------------------- */
static void SetLabel()
{
  if (!xufKeytable) { XtUnmanageChild(xufKeyLabel); *xufKeysequence= '\0'; }
  else {
    Arg args[1];
    char label[UFINPBUFLEN];
    char seq[UFINPBUFLEN];

    sprintf(label, "%s: \"%s\"", KeytableTitle(xufKeytable),
	    UFItemSPrint(xufKeysequence, seq, UFINPBUFLEN, '"'));
    if (xufIllegalKey) { strncat(label, " illegal", UFINPBUFLEN); }
    XtSetArg(args[0], XtNlabel, label);
    XtSetValues(xufKeyLabel, args, XtNumber(args));
    XtManageChild(xufKeyLabel); }
}
/* ---------------------------------------------------------------------- */
Widget XUFCreateWidget(name, parent,
		       bufferlength, min_reserve, max_reserve)
     char *name;
     Widget parent;
     int bufferlength;
     int min_reserve;
     int max_reserve;
{
  Widget w= NULL;
  /*Widget vw= NULL;*/
  Widget pw= NULL;
  static XtCallbackRec callbacks[]= {
    { FreeString, NULL },
  };

  xufStringLength= bufferlength;
  if ((xufString= (String)Malloc(bufferlength * sizeof(char)))) {
    Widget sw;

    *xufString= '\0';

    pw= XtVaCreateManagedWidget(name, panedWidgetClass, parent,
				XtNrefigureMode, FALSE,
				NULL);
    sw= XtVaCreateManagedWidget("status", boxWidgetClass, pw, NULL);
    xufKeyLabel= XtVaCreateWidget("keysequence", labelWidgetClass, sw, NULL);
    /*    vw = XtVaCreateManagedWidget("view", viewportWidgetClass, pw,
				 NULL);*/
#ifdef HAS_XAW3D
    w= XtVaCreateManagedWidget("text", asciiTextWidgetClass,
#else
    w= XtVaCreateManagedWidget("text", TvasciiTextWidgetClass,
#endif
			       pw,
			       XtNscrollVertical, XawtextScrollAlways,
#ifdef HAS_XAW3D
			       /*
				* X11R6 under Linux has problems with wrapping
				*/
			       XtNscrollHorizontal, XawtextScrollWhenNeeded,
			       XtNwrap, XawtextWrapNever,
#endif
			       XtNtype, XawAsciiString,
			       XtNuseStringInPlace, TRUE,
			       XtNeditType, XawtextEdit,
			       XtNstring, xufString,
			       XtNlength, xufStringLength,
			       XtNdestroyCallback, callbacks,
			       NULL);
    if (xufIOPaned) { XtDestroyWidget(xufIOPaned); }
    else {
      xufApp= XtWidgetToApplicationContext(parent);
      XtAppAddActions(xufApp, xufActions, XtNumber(xufActions)); }
    XawPanedSetRefigureMode(pw, (Boolean)TRUE);
    xufStringMaxReserve= MIN(bufferlength, max_reserve);
    xufStringMinReserve= MIN(xufStringMaxReserve, min_reserve);
    xufPrompted= FALSE;
    xufTextBlock.format= FMT8BIT;
    /*xufViewIO= vw;*/
    xufIOPaned= pw;
    xufIO= w; }
  return w;
}
/* ---------------------------------------------------------------------- */
Widget XUFGetKeyWidget()
{
  if (!xufKeyWidget) {
    XEvent event;
    Arg arg;

    xufKeyrequest= TRUE;
    XtSetArg(arg, XtNeditType, XawtextRead); XtSetValues(xufIO, &arg, 1);
    while (!xufKeyWidget && xufKeyrequest) {
      XtAppNextEvent(xufApp, &event);
      XtDispatchEvent(&event); }
    XtSetArg(arg, XtNeditType, XawtextEdit); XtSetValues(xufIO, &arg, 1);
    xufKeyrequest= FALSE; }
  return xufKeyWidget;
}
/* ---------------------------------------------------------------------- */
int XUFGetKeyX()
{
  return GetKeyCoordinate(&xufKeyX);
}
/* ---------------------------------------------------------------------- */
int XUFGetKeyY()
{
  return GetKeyCoordinate(&xufKeyY);
}
/* ---------------------------------------------------------------------- */
void XUFInit(up)
     UF_t *up;
{
  UFPrintStdOut(up)= (void *)up;
  UFPrintStdErr(up)= (void *)up;
  xuf= up;

  UFInputLoop(up)= InputLoop;
  UFPrint(up)= Print;
  UFPrintPaged(up)= Print;

  return;
}
/* ---------------------------------------------------------------------- */
void XUFSetKeytable(keytable)
     Keytable_t keytable;
{
  xufKeytable= keytable;
  SetLabel();
}
/* ---------------------------------------------------------------------- */
