/* $Header: /usr/files/home/Gamma/vs/tv/edit/prg/RCS/VdAxis.c,v 1.1 1993/09/17 14:53:34 vs Exp vs $ */

#define _VdAxis_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsTypes.h>
#include <Gow/GowFramWidget.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdAxis.h"
#include "VdAxisP.h"

#define SetFloatArg(a,n,v)	XtSetArg(a, n, *(XtArgVal *)(&v))

/* ---------------------------------------------------------------------- */
/* ================================= */
/* initialize display axis module */
/* ================================= */

void DA_Init(axis, ap)
     DrawAxis_t axis;
     Vact_t ap;
{
  { int i;
    Cal_t cal= VcalsCal(&vCal,VactSpcIdx(ap));
    for (i= 0; i< AXIS_NUM; i++) {
      axis[i].cal= cal;
      axis[i].unit= NULL;
      axis[i].cal_l= axis[i].cal_s= CalId; } }

  if (VactCalibrated(VactScale(ap))) {
    axis[DrawAxisBottom].unit= CalUnit;

    axis[DrawAxisTop].unit= CalChn;
    axis[DrawAxisTop].cal_s= CalP;
    axis[DrawAxisTop].cal_l= CalC; }
  else {
    axis[DrawAxisBottom].unit= CalChn;

    axis[DrawAxisTop].unit= CalUnit;
    axis[DrawAxisTop].cal_s= CalC;
    axis[DrawAxisTop].cal_l= CalP; }
}
/* ---------------------------------------------------------------------- */
int DA_ChangeActSpc(frm, axis, ap)
     Widget frm;
     DrawAxis_t axis;
     Vact_t ap;
{
  if (frm) {
    int i;
    Cal_t cal= VcalsCal(&vCal,VactSpcIdx(ap));
    int redisplay= !CalEqual(CAL_POS, cal, axis[i].cal);

    for (i= 0; i< AXIS_NUM; i++) { axis[i].cal= cal; }
    if (redisplay) { GowFrameRedisplay(frm, DrawAxisAll); return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
void DA_ChangedCal(frm, ap, idx)
     Widget frm;
     Vact_t ap;
     int idx;
{
  if (frm && idx == VactSpcIdx(ap)) {
    GowFrameRedisplay(frm, DrawAxisAll); }
}
/* ---------------------------------------------------------------------- */
void DA_ChangedScale(frm, axis, ap)
     Widget frm;
     DrawAxis_t axis;
     Vact_t ap;
{
  if (frm) {
    DA_Init(axis, ap);
    GowFrameRedisplay(frm, DrawAxisAll); }
}
/* ---------------------------------------------------------------------- */
int DA_Frame()
{
  VdSetup setup;
  if ((setup= DW_GetSetup()) && setup->frm) {
    int t= -1, b= -1, l= -1, r= -1;
    Arg args[4];
    if (UF_NoArgs()) {
      XtSetArg(args[0], XtNleftFrame, &l);
      XtSetArg(args[1], XtNrightFrame, &r);
      XtSetArg(args[2], XtNbottomFrame, &b);
      XtSetArg(args[3], XtNtopFrame, &t);
      XtGetValues(setup->frm, args, 4);
      UF_PrintM
	("%s\n left: %d, right: %d, bottom: %d, top: %d\n",
	 "frame widths [char-size]:", l, r, b, t); }
    if (UF_IntRead(FALSE, &l, "left frame width [char-size]") &&
	UF_IntRead(FALSE, &r, "right frame width [char-size]") &&
	UF_IntRead(FALSE, &b, "bottom frame width [char-size]") &&
	UF_IntRead(FALSE, &t, "top frame width [char-size]")) {
      Cardinal a= 0;
      if (l >= 0) { XtSetArg(args[a], XtNleftFrame, l); a++; }
      if (r >= 0) { XtSetArg(args[a], XtNrightFrame, r); a++; }
      if (b >= 0) { XtSetArg(args[a], XtNbottomFrame, b); a++; }
      if (t >= 0) { XtSetArg(args[a], XtNtopFrame, t); a++; }
      if (a) { XtSetValues(setup->frm, args, a); return TRUE; } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DA_Tic()
{
  VdSetup setup;
  if ((setup= DW_GetSetup()) && setup->frm) {
    float s= -1.0, m= -1.0, l= -1.0, al= -1.0;
    double ds, dm, dl, da, p;
    Arg args[4];
    if (UF_NoArgs()) {
      XtSetArg(args[0], XtNticShort, &s);
      XtSetArg(args[1], XtNticMedium, &m);
      XtSetArg(args[2], XtNticLong, &l);
      XtSetArg(args[3], XtNticSpace, &al);
      XtGetValues(setup->frm, args, 4);
      UF_PrintM("tic length [char-size]:\nshort: %f, medium: %f, long: %f\n",
		s, m, l);
      UF_PrintM("axis-label distance [char-size]: %f\n", al); }
    if (UF_RealRead(FALSE, &ds, &p, "short tic length [char-size]") &&
	UF_RealRead(FALSE, &dm, &p, "medium tic length [char-size]") &&
	UF_RealRead(FALSE, &dl, &p, "long tic length [char-size]") &&
	UF_RealRead(FALSE, &da, &p, "axis-label distance [char-size]")) {
      Cardinal a= 0;
      if (ds >= 0.0) { s= ds; SetFloatArg(args[a], XtNticShort, s); a++; }
      if (dm >= 0.0) { m= dm; SetFloatArg(args[a], XtNticMedium, m); a++; }
      if (dl >= 0.0) { l= dl; SetFloatArg(args[a], XtNticLong, l); a++; }
      if (da >= 0.0) { al= da; SetFloatArg(args[a], XtNticSpace, al); a++; }
      if (a) { XtSetValues(setup->frm, args, a); return TRUE; } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DA_Distance()
{
  VdSetup setup;
  if ((setup= DW_GetSetup()) && setup->frm) {
    float t= -1.0, l= -1.0;
    double dt, dl, p;
    Arg args[2];
    if (UF_NoArgs()) {
      XtSetArg(args[0], XtNticTic, &t);
      XtSetArg(args[1], XtNticLabel, &l);
      XtGetValues(setup->frm, args, 2);
      UF_PrintM("min. distance [char-size]: tic: %f, label: %f\n", t, l); }
    if (UF_RealRead(FALSE, &dt, &p, "min. tic distance [char-size]") &&
	UF_RealRead(FALSE, &dl, &p, "min. label distance [char-size]")) {
      Cardinal a= 0;
      if (dt > 0.0) {
	t= dt; SetFloatArg(args[a], XtNticTic, t); a++; }
      if (dl > 0.0) {
	l= dl; SetFloatArg(args[a], XtNticLabel, l); a++; }
      if (a) { XtSetValues(setup->frm, args, a); return TRUE; } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
