/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdBin.c,v 1.2 1994/05/26 19:50:54 vs Exp vs $ */

#define _VdBin_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowWidget.h>
#include <Gow/GowVMark.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsFitIo.h"
#include "VsMark.h"
#include "VsNorm.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdBin.h"
#include "VdBinP.h"
/* ---------------------------------------------------------------------- */
/* ================================= */
/* initialize display bin module */
/* ================================= */

GowVMark DB_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  GowVMark d;

  if ((d= (GowVMark)Malloc(sizeof(GowVMarkRec)))) {
    Widget b;

    if ((b= XtVaCreateWidget("bin-list", gowVMarkObjectClass,
			     parent, NULL))) {
      DrawVMarkInit(&d->mrk);
      d->goo= b;
      d->gow= parent;

      GowInsertSubobject(b, (GowAppDrawdata)d, GowHideSubobj);

      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
      DB_ChangeActSpc(d, ap);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw bin-list-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
int DB_ChangeActSpc(d, ap)
     GowVMark d;
     Vact_t ap;
{
  if (d) {
    int a= VactSpcIdx(ap);

    DrawVMrkMrk(&d->mrk)= FioBinMrk(VfiosFFio(&vFio,a));
    DrawVMrkGCIdx(&d->mrk)= a;
    DrawVMrkCal(&d->mrk)= VcalsCal(&vCal,a);

    DB_Changed(d, ap, a);
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DB_ManageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowVMark d= setup->dbin;

    if (d && DB_ChangeActSpc(d, setup->act)) {
      GowManageChild(d->goo); } }
}
/* ---------------------------------------------------------------------- */
void DB_UnmanageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowUnmanageChild(setup->dbin->goo); }
}
/* ---------------------------------------------------------------------- */
int DB_Manage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DB_ManageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DB_Unmanage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DB_UnmanageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
void DB_Changed(d, ap, idx)
     GowVMark d;
     int idx;
     Vact_t ap;
{
  if (d && idx == VactSpcIdx(ap)) {
    GowSubobjStat status;
    Boolean visible;

    Widget o= d->goo;

    if (GowGetSubobjectStat(o, (GowAppDrawdata)d, &status, &visible) &&
	visible) {
      GowRedisplayObjectWidget(o); }
    else {
      GowChangeSubobjectStat(o, (GowAppDrawdata)d, GowDrawSubobj); } }
}
/* ---------------------------------------------------------------------- */
