/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdCursor.c,v 1.1 1994/05/26 19:50:55 vs Exp vs $ */

#define _VdCursor_c

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>

#include <Gow/GowVsWidget.h>

#include "VsUserFace.h"
#include "VsActiv.h"
#include "VsCal.h"

#include "VdWidget.h"

#include "VdCursor.h"
#include "VdCursorP.h"
/* ---------------------------------------------------------------------- */
/* ARGSUSED */ /* XtEventHandler */
static void ShellCursorCross(w, unused, event, unused_too)
     Widget w;
     XtPointer unused;
     XEvent *event;
     Boolean *unused_too;
{
  VdSetup w_setup;
  if ((w_setup= DW_GetSetupOfWidget(w))) {
    int x, y;
    Widget shell= w_setup->shell;

    switch (event->type) {
    case MotionNotify:
      x= event->xmotion.x;
      y= event->xmotion.y;
      break;
    case EnterNotify:
      x= event->xcrossing.x;
      y= event->xcrossing.y;
      break;
    default: {
      VdSetup setup;
      ForAllSetups(setup) {
	if (setup->shell == shell && setup->gow != w) {
	  GowWidgetUndisplayCursor(w); } } }
      return; }

    { int conv_x, conv_y;
      double u_x, u_y, c_x;
      VdSetup setup;

      { GowScale x_scale, y_scale;
	GowUserFunc user;
	GowScaleConversion conv;
	Arg args[2];
	XtSetArg(args[0], XtNxScale, &x_scale);
	XtSetArg(args[1], XtNyScale, &y_scale);
	XtGetValues(w, args, 2);
	conv_x= (x_scale &&
		 GowInitializeWidgetScales(w, TRUE, FALSE) &&
		 (user= GowGetScaleUserFunction(x_scale)) &&
		 (conv= user(x_scale, x, &u_x)) != GowToSmall &&
		 conv != GowToLarge);
	conv_y= (y_scale &&
		 GowInitializeWidgetScales(w, FALSE, TRUE) &&
		 (user= GowGetScaleUserFunction(y_scale)) &&
		 (conv= user(y_scale, y, &u_y)) != GowToSmall &&
		 conv != GowToLarge); }
      if (VactCalibrated(VactScale(w_setup->act))) {
	c_x= CalC(VcalsCal(&vCal, VactSpcIdx(w_setup->act)), u_x); }
      else {
	c_x= u_x;
	u_x= CalC(VcalsCal(&vCal, VactSpcIdx(w_setup->act)), c_x); }

      ForAllSetups(setup) {
	if (setup->shell == shell && setup->gow != w) {
	  GowWidgetCrossHair(setup->gow,
			     (VactCalibrated(VactScale(setup->act))
			      ? u_x : c_x),
			     conv_x, u_y, conv_y); 
} } } }
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */ /* XtEventHandler */
static void ShellCursorVert(w, unused, event, unused_too)
     Widget w;
     XtPointer unused;
     XEvent *event;
     Boolean *unused_too;
{
  VdSetup w_setup;
  if ((w_setup= DW_GetSetupOfWidget(w))) {
    int x, y;
    Widget shell= w_setup->shell;

    switch (event->type) {
    case MotionNotify:
      x= event->xmotion.x;
      y= event->xmotion.y;
      break;
    case EnterNotify:
      x= event->xcrossing.x;
      y= event->xcrossing.y;
      break;
    default: {
      VdSetup setup;
      ForAllSetups(setup) {
	if (setup->shell == shell && setup->gow != w) {
	  GowWidgetUndisplayCursor(w); } } }
      return; }

    { int conv_x;
      double u_x, c_x;
      VdSetup setup;

      { GowScale x_scale, y_scale;
	GowUserFunc user;
	GowScaleConversion conv;
	Arg args[2];
	XtSetArg(args[0], XtNxScale, &x_scale);
	XtSetArg(args[1], XtNyScale, &y_scale);
	XtGetValues(w, args, 2);
	conv_x= (x_scale &&
		 GowInitializeWidgetScales(w, TRUE, FALSE) &&
		 (user= GowGetScaleUserFunction(x_scale)) &&
		 (conv= user(x_scale, x, &u_x)) != GowToSmall &&
		 conv != GowToLarge); }
      if (VactCalibrated(VactScale(w_setup->act))) {
	c_x= CalC(VcalsCal(&vCal, VactSpcIdx(w_setup->act)), u_x); }
      else {
	c_x= u_x;
	u_x= CalC(VcalsCal(&vCal, VactSpcIdx(w_setup->act)), c_x); }

      ForAllSetups(setup) {
	if (setup->shell == shell && setup->gow != w) {
	  GowWidgetCrossHair(setup->gow,
			     (VactCalibrated(VactScale(setup->act))
			      ? u_x : c_x),
			     conv_x, 0.0, FALSE); } } } }
}
/* ---------------------------------------------------------------------- */
static void RemoveShellCursor(shell)
     Widget shell;
{
  VdSetup setup;
  ForAllSetups(setup) {
    if (setup->shell == shell) {
      GowWidgetUndisplayCursor(setup->gow);
      XtRemoveEventHandler(setup->gow,
			   (unsigned int)(PointerMotionMask |
					  EnterWindowMask |
					  LeaveWindowMask),
			   FALSE, ShellCursorCross, NULL);
      XtRemoveEventHandler(setup->gow,
			   (unsigned int)(PointerMotionMask |
					  EnterWindowMask |
					  LeaveWindowMask),
			   FALSE, ShellCursorVert, NULL); } }
}
/* ---------------------------------------------------------------------- */
int DCs_GridCursor()
{
  int num;
  double offset, prec;
  VdSetup setup;
  if (UF_IntRead(FALSE, &num, "element number") &&
      UF_RealRead(FALSE, &offset, &prec, "offset") &&
      (setup= DW_GetSetup())) {
    RemoveShellCursor(setup->shell);
    GowWidgetCursorGrid(setup->gow, num, offset);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
/* Declares a Doppler Cursor, which consists of the usual cross hair cursor plus two additional
  * vertical lines at the doppler shifted energies (forward and backward)
  */

int DCs_DopplerCursor()
{
  double doppler_factor, prec;
  VdSetup setup;
  if (UF_RealRead(FALSE, &doppler_factor, &prec, "doppler factor") &&
      (setup= DW_GetSetup())) {
    RemoveShellCursor(setup->shell);
    GowWidgetCursorGrid(setup->gow, 0, 0.0);
    GowWidgetCursorDoppler(setup->gow, doppler_factor);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DCs_CrossHairCursor()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    RemoveShellCursor(setup->shell);
    GowWidgetCursorGrid(setup->gow, 0, 0.0);
    GowWidgetCursorCrossHair(setup->gow);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DCs_ShellCursorCross()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) {
    Widget shell= setup->shell;
    RemoveShellCursor(shell);
    ForAllSetups(setup) {
      if (setup->shell == shell) {
	XtAddEventHandler(setup->gow,
			  (unsigned int)(PointerMotionMask |
					 EnterWindowMask |
					 LeaveWindowMask),
			  FALSE, ShellCursorCross, NULL); } }
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DCs_ShellCursorVert()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) {
    Widget shell= setup->shell;
    RemoveShellCursor(shell);
    ForAllSetups(setup) {
      if (setup->shell == shell) {
	XtAddEventHandler(setup->gow,
			  (unsigned int)(PointerMotionMask |
					 EnterWindowMask |
					 LeaveWindowMask),
			  FALSE, ShellCursorVert, NULL); } }
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
