/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdCut.c,v 1.3 1994/12/08 20:44:55 vs Exp vs $ */

#define _VdCut_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsTools.h>
#include <Gow/GowWidget.h>
#include <Gow/GowVMark.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsCut.h"
#include "VsMark.h"
#include "VsUserFace.h"

#include "VdWidget.h"
#include "VdNotify.h"
#include "VdCutLabel.h"

#include "VdCut.h"
#include "VdCutP.h"
/* ---------------------------------------------------------------------- */
typedef struct _VdCutRec {
  GowVMarkRec gate;
  GowVMarkRec bg;
  PVecRec gateMrk;
  PVecRec bgGateMrk;
} VdCutRec;
/* ---------------------------------------------------------------------- */
/* ================================= */
/* initialize display cut module */
/* ================================= */

VdCut DC_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  VdCut d;

  if ((d= (VdCut)Malloc(sizeof(VdCutRec)))) {
    Widget g, gb;

    VecInit(&d->gateMrk, sizeof(Pair_t));
    VecInit(&d->bgGateMrk, sizeof(Pair_t));

    if ((g= XtVaCreateWidget("cut-gate", gowVMarkObjectClass,
			     parent, NULL)) &&
	(gb= XtVaCreateWidget("cut-bg-gate", gowVMarkObjectClass,
			      parent, NULL))) {
      GowVMark gate= &d->gate;
      GowVMark bg= &d->bg;

      DrawVMarkInit(&gate->mrk);
      DrawVMarkInit(&bg->mrk);
      DrawVMrkMrk(&gate->mrk)= &d->gateMrk;
      DrawVMrkMrk(&bg->mrk)= &d->bgGateMrk;
      gate->goo= g;
      bg->goo= gb;

      gate->gow= bg->gow= parent;

      GowInsertSubobject(g, (GowAppDrawdata)gate, GowHideSubobj);
      GowInsertSubobject(gb, (GowAppDrawdata)bg, GowHideSubobj);

      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
      DC_ChangeActCut(d, ap);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw cut-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
int DC_ChangeActCut(d, ap)
     VdCut d;
     Vact_t ap;
{
  if (d) {
    int a= VactCutIdx(ap);
    GowVMark gate= &d->gate;
    GowVMark bg= &d->bg;
    Vcut_t *vc= VcutsC(&vCut) + a;
    Cut_t cp= VcutCut(vc);
    Cut_CpGatToMrk(DrawVMrkMrk(&gate->mrk), CutGate(cp));
    Cut_CpGatToMrk(DrawVMrkMrk(&bg->mrk), CutBgGate(cp));
    DrawVMrkGCIdx(&gate->mrk)= DrawVMrkGCIdx(&bg->mrk)= a;
    DrawVMrkCal(&gate->mrk)=
      DrawVMrkCal(&bg->mrk)= VcalsCal(&vCal,VcutProIdx(vc));
    DC_Changed(d, ap, a);
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DC_ManageGatesSetup(setup)
     VdSetup setup;
{
  if (setup) {
    VdCut d= setup->dcut;

    if (d && DC_ChangeActCut(d, setup->act)) {
      Widget w[2];

      w[0]= d->gate.goo;
      w[1]= d->bg.goo;

      GowManageChildren(w, XtNumber(w));

      GowChangeSubobjectStat(w[0], (GowAppDrawdata)&d->gate, GowDrawSubobj);
      GowChangeSubobjectStat(w[1], (GowAppDrawdata)&d->bg, GowDrawSubobj); } }
}
/* ---------------------------------------------------------------------- */
void DC_UnmanageGatesSetup(setup)
     VdSetup setup;
{
  if (setup) {
    VdCut d= setup->dcut;
    Widget w[2];

    w[0]= d->gate.goo;
    w[1]= d->bg.goo;

    GowUnmanageChildren(w, XtNumber(w)); }
}
/* ---------------------------------------------------------------------- */
int DC_ManageGates()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DC_ManageGatesSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DC_UnmanageGates()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DC_UnmanageGatesSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DC_ManageCutOnly()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) {
    int a;

    if (!setup->dpro) {
      VdSetup cut;
      ForAllSetups(cut) { if (setup == cut->dpro) { setup= cut; break; } } }
    if (!UF_IntRead(FALSE, &a,
		    "%s: cut index to manage", setup->gow_name)) {
      return FALSE; }
    else if (a < 0 || a >= VactNum(vAct)) {
      ErrPrintR("fatal: %s: index %d out of Range [%d,%d]\n",
		setup->gow_name, a, 0, VactNum(vAct)-1);
      return FALSE; }
    else { DC_ManageCut(setup, a); }
    return TRUE; }
  else { return FALSE; }
    
}
/* ---------------------------------------------------------------------- */
void DC_Changed(d, ap, idx)
     VdCut d;
     Vact_t ap;
     int idx;
{
  if (d && idx == VactCutIdx(ap)) {
    Widget w= d->gate.goo;

    GowChangeSubobjectStat(w, (GowAppDrawdata)&d->gate, GowDrawSubobj);
    GowChangeSubobjectStat(w, (GowAppDrawdata)&d->bg, GowDrawSubobj); }
}
/* ---------------------------------------------------------------------- */
void DC_ManageCut(setup, cutIdx)
     VdSetup setup;
     int cutIdx;
{
  if (setup) {
    Vcut_t *vcp= VcutsC(&vCut) + cutIdx;
    DN_Delay(TRUE);
    Act_SetActCut(setup->act, cutIdx);
    Act_ManageOnly(setup->act, VcutSpcIdx(vcp));
    if (setup->dpro) {
      Act_SetActCut(setup->dpro->act, cutIdx);
      DC_ManageProSetup(setup->dpro); }
    DN_Delay(FALSE); }
}
/* ---------------------------------------------------------------------- */
void DC_ManageProSetup(setup)
     VdSetup setup;
{
  if (setup) {
    Vact_t ap= setup->act;
    DN_Delay(TRUE);
    DC_ManageGatesSetup(setup);
    DCL_ManageSetup(setup);
    Act_ManageOnly(ap, VcutProIdx(VcutsC(&vCut) + VactCutIdx(ap)));
    DN_Delay(FALSE); }
}
/* ---------------------------------------------------------------------- */
int DC_ManagePro()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DC_ManageProSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
