/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdCutLabel.c,v 1.2 1994/05/26 19:51:09 vs Exp vs $ */

#define _VdCutLabel_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsPath.h>
#include <Gow/GowWidget.h>
#include <Gow/GowLabel.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsCut.h"
#include "VsNorm.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdCutLabel.h"
#include "VdCutLabelP.h"
/* ---------------------------------------------------------------------- */
/* ================================== */
/* initialize display CutLabel module */
/* ================================== */

GowLabel DCL_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  GowLabel d;

  if ((d= (GowLabel)Malloc(sizeof(GowLabelRec)))) {
    Widget cl;

    if ((cl= XtVaCreateWidget("cut-label", gowLabelObjectClass,
			      parent, NULL))) {
      static DrawLblFctRec fct= {
	NextLabel,
	PrevLabel,
	NULL,
	LabelTxt,
	LabelPos,
	LabelCalibrated, };
      DrawLbl_t l= &d->lbl;

      DrawLabelInit(l);
      DrawLblFct(l)		= &fct;
      DrawLblPosCalib(l)	= FALSE;
      DrawLblPosUncalib(l)	= FALSE;
      DrawLblString(l)		= TRUE;
      d->goo			= cl;
      d->gow			= parent;
      GowInsertSubobject(cl, (GowAppDrawdata)d, GowHideSubobj);

      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
      DCL_ChangeActCut(d, ap);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw cut-label-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
static void *NextLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  CDIR *cdp= VcutPathCdp((VcutPath_t *)dlbl);
  if (!cdp || !CDirNum(cdp)) { return NULL; }
  else if (!l) { return (void *)CDirP(cdp); }
  else {
    CDirEntry_t *cde= ((CDirEntry_t *)l) + 1;
    return ((cde > CDirP(cdp) + CDirNum(cdp) - 1) ? NULL : (void *)cde); }
}
/* ---------------------------------------------------------------------- */
static void *PrevLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  CDIR *cdp= VcutPathCdp((VcutPath_t *)dlbl);
  if (!cdp || !CDirNum(cdp)) { return NULL; }
  else if (!l) { return (void *)(CDirP(cdp) + CDirNum(cdp) - 1); }
  else {
    CDirEntry_t *cde= ((CDirEntry_t *)l) - 1;
    return ((cde < CDirP(cdp)) ? NULL : (void *)cde); }
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static double LabelPos(dlbl, l)
     void *dlbl;
     void *l;
{
  CDirEntry_t *ce= (CDirEntry_t *)l;
  return (CDirEntryGateX1(ce) + CDirEntryGateX2(ce)) * 0.5;
}
/* ---------------------------------------------------------------------- */
static char *LabelTxt(dlbl, l)
     void *dlbl;
     void *l;
{
  char entry[MAXPATHLEN];
  CDIR *cdp= VcutPathCdp((VcutPath_t *)dlbl);
  CDirEntry_t *ce= (CDirEntry_t *)l;

  if (CutCDirEntry(cdp, CDirEntryIdx1(ce), CDirEntryIdx2(ce), entry)) {
    return PthTail(entry); }
  else { return NULL; }
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static Boolean LabelCalibrated(dlbl)
     void *dlbl;
{
  return FALSE;
}
/* ---------------------------------------------------------------------- */
void DCL_ManageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowLabel d= setup->dcutlbl;

    if (d && DCL_ChangeActCut(d, setup->act)) {
      GowManageChild(d->goo); } }
}
/* ---------------------------------------------------------------------- */
void DCL_UnmanageSetup(setup)
     VdSetup setup;
{
  if (setup) { GowUnmanageChild(setup->dcutlbl->goo); }
}
/* ---------------------------------------------------------------------- */
int DCL_Manage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DCL_ManageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DCL_Unmanage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DCL_UnmanageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DCL_ChangeActCut(d, ap)
     GowLabel d;
     Vact_t ap;
{
  if (d) {
    int a= VactCutIdx(ap);
    Vcut_t *vc= VcutsC(&vCut) + a;
    int cpi= VcutCutPathIdx(vc);
    int pi= VcutProIdx(vc);
    DrawLbl_t l= &d->lbl;
    if (DrawLblLbl(l) != (void *)(VcutsP(&vCut) + cpi) ||
	DrawLblCal(l) != VcalsCal(&vCal,pi) ||
	DrawLblSpc(l) != VspcsSpc(&vSpc,pi) ||
	DrawLblNorm(l) != &VnrmsFac(&vNrm,pi)) {
      DrawLblGCIdx(l)		= 0;
      DrawLblLbl(l)		= (void *)(VcutsP(&vCut) + cpi);
      DrawLblCal(l)		= VcalsCal(&vCal,pi);
      DrawLblSpc(l)		= VspcsSpc(&vSpc,pi);
      DrawLblNorm(l)	= &VnrmsFac(&vNrm,pi);
      GowRedisplayObjectWidget(d->goo); }
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DCL_Changed(d, pathIdx)
     GowLabel d;
     int pathIdx;
{
  if (d) {
    if (DrawLblLbl(&d->lbl) == (void *)(VcutsP(&vCut) + pathIdx)) {
      if (!VcutPathCdp(VcutsP(&vCut) + pathIdx)) {
	GowRedisplayObjectWidget(d->goo); }
      else {
	GowChangeSubobjectStat(d->goo, (GowAppDrawdata)d, GowDrawSubobj); } } }
}
/* ---------------------------------------------------------------------- */
void DCL_ChangedCal(d, idx)
     GowLabel d;
     int idx;
{
  if (d) {
    GowSubobjStat status;
    Boolean visible;

    if (DrawLblPosCalib(&d->lbl) &&
	DrawLblCal(&d->lbl) == VcalsCal(&vCal,idx) &&
	GowGetSubobjectStat(d->goo, (GowAppDrawdata)d, &status, &visible) &&
	visible) {
      GowRedisplayObjectWidget(d->goo); } }
}
/* ---------------------------------------------------------------------- */
int DCL_GetIndex(idx)
     int *idx;
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) {
    if (setup->dcutlbl) {
      Widget w;
      int px, py;
      if (DW_GetCursor(&w, &px, &py)) {
	*idx= DrawLabelGetIndex(&setup->dcutlbl->lbl, px, py);
	return (*idx >= 0); } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
