/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdDecomp.c,v 1.2 1994/05/26 19:51:11 vs Exp vs $ */

#define _VdDecomp_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowWidget.h>
#include <Gow/GowDecomp.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsMark.h"
#include "VsNorm.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdDecomp.h"
#include "VdDecompP.h"
/* ---------------------------------------------------------------------- */
/* ================================= */
/* initialize display decomp module */
/* ================================= */

GowDecomp DD_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  GowDecomp d;

  if ((d= (GowDecomp)Malloc(sizeof(GowDecompRec)))) {
    Widget f;

    if ((f= XtVaCreateWidget("decomposition", gowDecompObjectClass,
			    parent, NULL))) {
      DrawDecompGCPos(&d->decomp)= 0;
      DrawDecompGCNeg(&d->decomp)= 1;
      d->goo= f;
      d->gow= parent;

      GowInsertSubobject(f, (GowAppDrawdata)d, GowHideSubobj);

      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
      DD_ChangeActSpc(d, ap);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw decomposition-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
int DD_ChangeActSpc(d, ap)
     GowDecomp d;
     Vact_t ap;
{
  if (d) {
    int a= VactSpcIdx(ap);

    DrawDecompFit(&d->decomp)= VfitsFFit(&vFit,a);
    DrawDecompCal(&d->decomp)= VcalsCal(&vCal,a);
    DrawDecompNorm(&d->decomp)= &VnrmsFac(&vNrm,a);
    DD_Changed(d, ap, a);
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DD_ManageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowDecomp d= setup->ddecomp;

    if (d && DD_ChangeActSpc(d, setup->act)) {
      GowManageChild(d->goo); } }
}
/* ---------------------------------------------------------------------- */
void DD_UnmanageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowUnmanageChild(setup->ddecomp->goo); }
}
/* ---------------------------------------------------------------------- */
int DD_Manage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DD_ManageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DD_Unmanage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DD_UnmanageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
void DD_Changed(d, ap, idx)
     GowDecomp d;
     int idx;
     Vact_t ap;
{
  if (d && idx == VactSpcIdx(ap)) {
    GowSubobjStat status;
    Boolean visible;

    Widget o= d->goo;

    if (GowGetSubobjectStat(o, (GowAppDrawdata)d, &status, &visible) &&
	visible) {
      GowRedisplayObjectWidget(o); }
    else {
      GowChangeSubobjectStat(o, (GowAppDrawdata)d, GowDrawSubobj); } }
}
/* ---------------------------------------------------------------------- */
