/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdFit.c,v 1.3 1994/09/20 14:48:32 vs Exp vs $ */

#define _VdFit_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowWidget.h>
#include <Gow/GowFit.h>
#include <Gow/GowVMark.h>
#include <Gow/GowLabel.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsMark.h"
#include "VsNorm.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdFit.h"
#include "VdFitP.h"
/* ---------------------------------------------------------------------- */
typedef struct _VdFitRec {
  GowFitRec fit;
  GowFitRec bg;
  GowVMarkRec fitmrk;
  GowVMarkRec bgmrk;
  GowLabelRec peak;
} VdFitRec;
/* ---------------------------------------------------------------------- */
/* ================================= */
/* initialize display fit module */
/* ================================= */

VdFit DF_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  VdFit d;

  if ((d= (VdFit)Malloc(sizeof(VdFitRec)))) {
    Widget f, fm, b, bm, p;

    if ((f= XtVaCreateWidget("fit-function",
			     gowFitObjectClass, parent, NULL)) &&
	(fm= XtVaCreateWidget("fit-region", gowVMarkObjectClass,
			      parent, NULL)) &&
	(b= XtVaCreateWidget("bg-function",
			     gowFitObjectClass, parent, NULL)) &&
	(bm= XtVaCreateWidget("bg-region", gowVMarkObjectClass,
			      parent, NULL)) &&
	(p= XtVaCreateWidget("fit-label", gowLabelObjectClass,
			      parent, NULL))) {
      { GowFit fit= &d->fit;
	GowFit bg= &d->bg;

	DrawFitTyp(&fit->fit)= GowRegionFit;
	DrawFitTyp(&bg->fit)= GowBgFit;
	DrawFitFct(&fit->fit)= FitFunction;
	DrawFitFct(&bg->fit)= FitTotalBgFunction;
	fit->goo= f;
	bg->goo= b;

	DrawFitFctSetup(&fit->fit)
	  = DrawFitFctSetup(&bg->fit)= FitFunctionSetup;
	DrawFitFctFinish(&fit->fit)
	  = DrawFitFctFinish(&bg->fit)= FitFunctionFinish;
	fit->gow= bg->gow= parent;

	GowInsertSubobject(f, (GowAppDrawdata)fit, GowHideSubobj);
	GowInsertSubobject(b, (GowAppDrawdata)bg, GowHideSubobj); }

      { GowVMark fit= &d->fitmrk;
	GowVMark bg= &d->bgmrk;

	DrawVMarkInit(&fit->mrk);
	DrawVMarkInit(&bg->mrk);
	fit->goo= fm;
	bg->goo= bm;

	fit->gow= bg->gow= parent;

	GowInsertSubobject(fm, (GowAppDrawdata)fit, GowHideSubobj);
	GowInsertSubobject(bm, (GowAppDrawdata)bg, GowHideSubobj); }

      { static DrawLblFctRec fct= {
	NextLabel,
	PrevLabel,
	NULL,
	NULL,
	LabelPos,
	LabelCalibrated, };

	GowLabel pk= &d->peak;
	DrawLbl_t l= &pk->lbl;

	DrawLabelInit(l);
	DrawLblFct(l)		= &fct;
	DrawLblPosCalib(l)	= TRUE;
	DrawLblPosUncalib(l)	= TRUE;
	DrawLblString(l)	= FALSE;
	pk->goo= p;
	pk->gow= parent;
	GowInsertSubobject(p, (GowAppDrawdata)pk, GowHideSubobj); }

      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
      DF_ChangeActSpc(d, ap);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw fit-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
static void *NextLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  Fit_t fp= (Fit_t)dlbl;
  Par_t pp= FitPar(fp);
  if (!FitPeakNum(fp)) { return NULL; }
  else if (!l) { return (void *)FitPPos(pp,0); }
  else {
    ParV_t *p= ((ParV_t *)l) + FIT_PEAKPAR;
    return ((p > FitPPos(pp,(FitPeakNum(fp)-1))) ? NULL : (void *)p); }
}
/* ---------------------------------------------------------------------- */
static void *PrevLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  Fit_t fp= (Fit_t)dlbl;
  Par_t pp= FitPar(fp);
  if (!FitPeakNum(fp)) { return NULL; }
  else if (!l) { return (void *)FitPPos(pp,(FitPeakNum(fp)-1)); }
  else {
    ParV_t *p= ((ParV_t *)l) - FIT_PEAKPAR;
    return ((p < FitPPos(pp,0)) ? NULL : (void *)p); }
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static double LabelPos(dlbl, l)
     void *dlbl;
     void *l;
{
  return ParVVal((ParV_t *)l);
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static Boolean LabelCalibrated(dlbl)
     void *dlbl;
{
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DF_ChangeActSpc(d, ap)
     VdFit d;
     Vact_t ap;
{
  if (d) {
    int a= VactSpcIdx(ap);

    Cal_t cal= VcalsCal(&vCal,a);
    Fit_t fp= VfitsFFit(&vFit,a);

    { DrawFit_t f= &d->fit.fit, b= &d->bg.fit;
      DrawFitGCIdx(f)	= DrawFitGCIdx(b)	= a;
      DrawFitFit(f)	= DrawFitFit(b)		= fp;
      DrawFitCal(f)	= DrawFitCal(b)		= cal;
      DrawFitNorm(f)	= DrawFitNorm(b)	= &VnrmsFac(&vNrm,a); }

    { DrawVMrk_t fm= &d->fitmrk.mrk, bm= &d->bgmrk.mrk;
      DrawVMrkMrk(fm)	= FitRegMrk(fp);
      DrawVMrkMrk(bm)	= FitBgMrk(fp);
      DrawVMrkGCIdx(fm)	= DrawVMrkGCIdx(bm)	= a;
      DrawVMrkCal(fm)	= DrawVMrkCal(bm)	= cal;
      DrawVMrkCalibrated(fm)= DrawVMrkCalibrated(bm)= FALSE; }

    { DrawLbl_t l= &d->peak.lbl;
      DrawLblGCIdx(l)	= a;
      DrawLblLbl(l)	= fp;
      DrawLblCal(l)	= cal;
      DrawLblSpc(l)	= VspcsSpc(&vSpc,a);
      DrawLblNorm(l)	= &VnrmsFac(&vNrm,a); }

    DF_Changed(d, ap, a);

    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DF_ManageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    VdFit d= setup->dfit;

    if (d && DF_ChangeActSpc(d, setup->act)) {
      Widget w[5];

      w[0]= d->fit.goo;
      w[1]= d->fitmrk.goo;
      w[2]= d->bg.goo;
      w[3]= d->bgmrk.goo;
      w[4]= d->peak.goo;

      GowManageChildren(w, XtNumber(w)); } }
}
/* ---------------------------------------------------------------------- */
void DF_UnmanageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    VdFit d= setup->dfit;
    Widget w[5];

    w[0]= d->fit.goo;
    w[1]= d->fitmrk.goo;
    w[2]= d->bg.goo;
    w[3]= d->bgmrk.goo;
    w[4]= d->peak.goo;

    GowUnmanageChildren(w, XtNumber(w)); }
}
/* ---------------------------------------------------------------------- */
int DF_Manage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DF_ManageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DF_Unmanage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DF_UnmanageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
void DF_Changed(d, ap, idx)
     VdFit d;
     Vact_t ap;
     int idx;
{
  if (d && idx == VactSpcIdx(ap)) {
    GowSubobjStat status;
    Boolean visible;

    if ((GowGetSubobjectStat(d->fit.goo, (GowAppDrawdata)&d->fit,
			     &status, &visible) && visible) ||
	(GowGetSubobjectStat(d->fitmrk.goo, (GowAppDrawdata)&d->fitmrk,
			     &status, &visible) && visible) ||
	(GowGetSubobjectStat(d->bg.goo, (GowAppDrawdata)&d->bg,
			     &status, &visible) && visible) ||
	(GowGetSubobjectStat(d->bgmrk.goo, (GowAppDrawdata)&d->bgmrk,
			     &status, &visible) && visible) ||
	(GowGetSubobjectStat(d->peak.goo, (GowAppDrawdata)&d->peak,
			     &status, &visible) && visible)) {
      GowRedisplayObjectWidget(d->fit.goo); }
    else {
      GowChangeSubobjectStat(d->fit.goo, (GowAppDrawdata)&d->fit,
			     GowDrawSubobj);
      GowChangeSubobjectStat(d->fitmrk.goo, (GowAppDrawdata)&d->fitmrk,
			     GowDrawSubobj);
      GowChangeSubobjectStat(d->bg.goo, (GowAppDrawdata)&d->bg,
			     GowDrawSubobj);
      GowChangeSubobjectStat(d->bgmrk.goo, (GowAppDrawdata)&d->bgmrk,
			     GowDrawSubobj);
      GowChangeSubobjectStat(d->peak.goo, (GowAppDrawdata)&d->peak,
			     GowDrawSubobj); } }
}
/* ---------------------------------------------------------------------- */
GowLabel DF_GetLabel(d)
     VdFit d;
{
  return &d->peak;
}
/* ---------------------------------------------------------------------- */
void DF_ChangedCal(d, idx)
     VdFit d;
     int idx;
{
  if (d) {
    GowSubobjStat status;
    Boolean visible;

    Widget o= d->peak.goo;

    if (DrawLblPosCalib(&d->peak.lbl) &&
	DrawLblCal(&d->peak.lbl) == VcalsCal(&vCal,idx) &&
	GowGetSubobjectStat(o, (GowAppDrawdata)&d->peak, &status, &visible) &&
	visible) {
      GowRedisplayObjectWidget(o); } }
}
/* ---------------------------------------------------------------------- */
