/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdFitLabel.c,v 1.2 1994/05/26 19:51:14 vs Exp vs $ */

#define _VdFitLabel_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsPath.h>
#include <Gow/GowVsWidget.h>
#include <Gow/GowLabel.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsNorm.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdFitLabel.h"
#include "VdFitLabelP.h"
/* ---------------------------------------------------------------------- */
/* ================================== */
/* initialize display FitLabel module */
/* ================================== */

GowLabel DFL_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  GowLabel d;

  if ((d= (GowLabel)Malloc(sizeof(GowLabelRec)))) {
    Widget pl;

    if ((pl= XtVaCreateWidget("peak-label", gowLabelObjectClass,
			     parent, NULL))) {
      static DrawLblFctRec fct= {
	NextLabel,
	PrevLabel,
	NULL,
	NULL,
	LabelPos,
	LabelCalibrated, };
      DrawLbl_t l= &d->lbl;

      DrawLabelInit(l);
      DrawLblLbl(l)		= (void *)VfitsWorkFit(&vFit);
      DrawLblFct(l)		= &fct;
      DrawLblPosCalib(l)	= TRUE;
      DrawLblPosUncalib(l)	= TRUE;
      DrawLblString(l)		= FALSE;
      d->goo			= pl;
      d->gow			= parent;
      GowInsertSubobject(pl, (GowAppDrawdata)d, GowHideSubobj);

      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
      DFL_ChangeActSpc(d, ap);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw fit-peak-label-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
static void *NextLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  Fit_t fp= (Fit_t)dlbl;
  Par_t pp= FitPar(fp);
  if (!FitPeakNum(fp)) { return NULL; }
  else if (!l) { return (void *)FitPPos(pp,0); }
  else {
    ParV_t *p= ((ParV_t *)l) + FIT_PEAKPAR;
    return ((p > FitPPos(pp,(FitPeakNum(fp)-1))) ? NULL : (void *)p); }
}
/* ---------------------------------------------------------------------- */
static void *PrevLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  Fit_t fp= (Fit_t)dlbl;
  Par_t pp= FitPar(fp);
  if (!FitPeakNum(fp)) { return NULL; }
  else if (!l) { return (void *)FitPPos(pp,(FitPeakNum(fp)-1)); }
  else {
    ParV_t *p= ((ParV_t *)l) - FIT_PEAKPAR;
    return ((p < FitPPos(pp,0)) ? NULL : (void *)p); }
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static double LabelPos(dlbl, l)
     void *dlbl;
     void *l;
{
  return ParVVal((ParV_t *)l);
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static Boolean LabelCalibrated(dlbl)
     void *dlbl;
{
  return VactCalibrated(VfitsWorkScale(&vFit));
}
/* ---------------------------------------------------------------------- */
void DFL_ManageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowLabel d= setup->dfitlbl;

    if (d && DFL_ChangeActSpc(d, setup->act)) {
      GowManageChild(d->goo); } }
}
/* ---------------------------------------------------------------------- */
void DFL_UnmanageSetup(setup)
     VdSetup setup;
{
  if (setup) { GowUnmanageChild(setup->dfitlbl->goo); }
}
/* ---------------------------------------------------------------------- */
int DFL_Manage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DFL_ManageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DFL_Unmanage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DFL_UnmanageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DFL_ChangeActSpc(d, ap)
     GowLabel d;
     Vact_t ap;
{
  if (d) {
    int a= VactSpcIdx(ap);
    DrawLbl_t l= &d->lbl;

    DrawLblGCIdx(l)		= 0;
    DrawLblCal(l)		= VcalsCal(&vCal,a);
    DrawLblSpc(l)		= VspcsSpc(&vSpc,a);
    DrawLblNorm(l)		= &VnrmsFac(&vNrm,a);

    DFL_Changed(d);
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DFL_Changed(d)
     GowLabel d;
{
  if (d) {
    GowChangeSubobjectStat(d->goo, (GowAppDrawdata)d, GowDrawSubobj); }
}
/* ---------------------------------------------------------------------- */
void DFL_ChangedCal(d, ap, idx)
     GowLabel d;
     Vact_t ap;
     int idx;
{
  if (d && VactSpcIdx(ap) == idx) {
    GowSubobjStat status;
    Boolean visible;
    Widget parent= d->gow;
    Boolean s_calibrated, l_calibrated;
    DrawLbl_t l= &d->lbl;

    l_calibrated= DrawLblCalibrated(l)(l);
    { Arg args[1];
      XtSetArg(args[0], XtNxScaleCalibrated, &s_calibrated);
      XtGetValues(parent, args, XtNumber(args)); }

    if (s_calibrated != l_calibrated ||
	(DrawLblPosCalib(&d->lbl) && !l_calibrated) ||
	(DrawLblPosUncalib(&d->lbl) && l_calibrated)) {
      if (GowGetSubobjectStat(d->goo, (GowAppDrawdata)d, &status, &visible) &&
	  visible) {
	GowRedisplayObjectWidget(d->goo); }
      else {
	GowChangeSubobjectStat(d->goo, (GowAppDrawdata)d, GowDrawSubobj); } } }
}
/* ---------------------------------------------------------------------- */
