/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdLabel.c,v 1.2 1994/05/26 19:51:18 vs Exp vs $ */
#define _VdLabel_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <tv/vsTypes.h>
#include <tv/vsAlloc.h>
#include <tv/vsAscii.h>
#include <tv/vsPath.h>
#include <Gow/GowVsWidget.h>
#include <Gow/GowLabel.h>

typedef struct _VdLblRec {	/* lbl */
  double x;			/* x-position */
  char *txt;			/* label string */
  int gc;			/* GC-index */
  struct _VdLblRec *next;	/* next entry */
  struct _VdLblRec *prev;	/* previous entry */
} VdLblRec, *VdLbl_t;

#define VdLblX(kp)		((kp)->x)
#define VdLblTxt(kp)		((kp)->txt)
#define VdLblGC(kp)		((kp)->gc)
#define VdLblNext(kp)		((kp)->next)
#define VdLblPrev(kp)		((kp)->prev)

typedef struct _LabellistRec {	/* labellist */
  char *title;
  char *file;
  VdLbl_t first;
  VdLbl_t last;
  VdLbl_t current;
  int scale;			/* scaling of positions */
} LabellistRec, *Labellist_t;

#define LabellistTitle(kp)	((kp)->title)
#define LabellistFile(kp)	((kp)->file)
#define LabellistFirst(kp)	((kp)->first)
#define LabellistLast(kp)	((kp)->last)
#define LabellistCurrent(kp)	((kp)->current)
#define LabellistScale(kp)	((kp)->scale)

typedef struct _VdLabelRec {
  LabellistRec tmp;
  GowLabelRec lbls;
} VdLabelRec;

typedef struct _VdLabelListRec {
  Labellist_t lbls;
  struct _VdLabelListRec *next;
  struct _VdLabelListRec *prev;
} VdLabellistRec, *VdLabellist;

#define ForAllLabellists(vll)	for (vll= root; vll; vll= vll->next)

#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsMark.h"
#include "VsNorm.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdWidget.h"
#include "VdFit.h"

#include "VdLabel.h"
#include "VdLabelP.h"

/* ---------------------------------------------------------------------- */
static VdLabellist root= NULL;
static DrawLblFctRec fct= {
	NextLabel,
	PrevLabel,
	LabelGC,
	LabelTxt,
	LabelPos,
	LabelCalibrated, };
/* ---------------------------------------------------------------------- */
VdLabel DL_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  VdLabel d;
  Widget o;

  if ((d= (VdLabel)Malloc(sizeof(VdLabelRec)))) {
    if ((o= XtVaCreateWidget("user-label", gowLabelObjectClass,
			     parent, NULL))) {
      Labellist_t ll= &d->tmp;
      LabellistTitle(ll)	= "tmp";
      LabellistFile(ll)		= "";
      LabellistScale(ll)	= ACT_SDEFAULT;
      LabellistFirst(ll)
	= LabellistLast(ll)
	  = LabellistCurrent(ll)= NULL;

      { DrawLbl_t l= &d->lbls.lbl;

	DrawLabelInit(l);
	DrawLblFct(l)		= &fct;
	DrawLblPosCalib(l)	= TRUE;
	DrawLblPosUncalib(l)	= TRUE;
	DrawLblString(l)	= TRUE;
	DrawLblLbl(l)		= (void *)ll;
	d->lbls.goo		= o;
	d->lbls.gow		= parent; }

      GowInsertSubobject(o, (GowAppDrawdata)(&d->lbls), GowHideSubobj); }

    XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
    DL_ChangeActSpc(d, ap);
    return d; }
  else {
    ErrPrintR("fatal: can not initialize draw labellist-module\n");
    return NULL; }
}
/* ---------------------------------------------------------------------- */
VdLabel DL_PosInit(parent, ap)
     Widget parent;
     Vact_t ap;
{
  VdLabel d;
  Widget o;

  if ((d= (VdLabel)Malloc(sizeof(VdLabelRec)))) {
    if ((o= XtVaCreateWidget("position-label", gowLabelObjectClass,
			     parent, NULL))) {
      Labellist_t ll= &d->tmp;
      LabellistTitle(ll)	= "position";
      LabellistFile(ll)		= "";
      LabellistScale(ll)	= ACT_SDEFAULT;
      LabellistFirst(ll)
	= LabellistLast(ll)
	  = LabellistCurrent(ll)= NULL;

      { DrawLbl_t l= &d->lbls.lbl;

	DrawLabelInit(l);
	DrawLblFct(l)		= &fct;
	DrawLblPosCalib(l)	= TRUE;
	DrawLblPosUncalib(l)	= TRUE;
	DrawLblString(l)	= TRUE;
	DrawLblLbl(l)		= (void *)ll;
	d->lbls.goo		= o;
	d->lbls.gow		= parent; }

      GowInsertSubobject(o, (GowAppDrawdata)(&d->lbls), GowHideSubobj); }

    XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
    DL_ChangeActSpc(d, ap);
    GowManageChild(o);
    return d; }
  else {
    ErrPrintR("fatal: can not initialize draw labellist-module\n");
    return NULL; }
}
/* ---------------------------------------------------------------------- */
int DL_ChangeActSpc(d, ap)
     VdLabel d;
     Vact_t ap;
{
  if (d) {
    int a= VactSpcIdx(ap);
    DrawLbl_t l= &d->lbls.lbl;

    DrawLblGCIdx(l)	= a;
    DrawLblCal(l)	= VcalsCal(&vCal,a);
    DrawLblSpc(l)	= VspcsSpc(&vSpc,a);
    DrawLblNorm(l)	= &VnrmsFac(&vNrm,a);
    if (d) {
      GowChangeSubobjectStat(d->lbls.goo,
			     (GowAppDrawdata)&d->lbls, GowDrawSubobj); }
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DL_ChangedCal(d, ap, idx)
     VdLabel d;
     Vact_t ap;
     int idx;
{
  if (d && VactSpcIdx(ap) == idx) {
    GowSubobjStat status;
    Boolean visible;
    Widget parent= d->lbls.gow;
    Boolean s_calibrated, l_calibrated;
    DrawLbl_t l= &d->lbls.lbl;

    l_calibrated= DrawLblCalibrated(l)(l);
    { Arg args[1];
      XtSetArg(args[0], XtNxScaleCalibrated, &s_calibrated);
      XtGetValues(parent, args, XtNumber(args)); }

    if (s_calibrated != l_calibrated ||
	(DrawLblPosCalib(&d->lbls.lbl) && !l_calibrated) ||
	(DrawLblPosUncalib(&d->lbls.lbl) && l_calibrated)) {
      if (GowGetSubobjectStat(d->lbls.goo, (GowAppDrawdata)&d->lbls,
			      &status, &visible) &&
	  visible) {
	GowRedisplayObjectWidget(d->lbls.goo); }
      else {
	GowChangeSubobjectStat(d->lbls.goo, (GowAppDrawdata)&d->lbls,
			       GowDrawSubobj); } } }
}
/* ---------------------------------------------------------------------- */
int DL_Activate()
{
  char title[IOBUFLEN];

  if (UF_ItemRead(title, IOBUFLEN, "labellist title") && *title) {
    VdLabellist vll;
    if ((vll= GetLabellist(title))) {
      UseLabellist(DW_GetSetup(), vll->lbls); return TRUE; }
    else if (!strcmp(title, "tmp")) {
      UseLabellist(DW_GetSetup(), NULL); return TRUE; }
    UF_PrintE("warning: labellist '%s' not found\n", title); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_Create()
{
  char title[IOBUFLEN];

  if (UF_ItemRead(title, IOBUFLEN, "title of labellist to create") &&
      *title) {
    VdLabellist vll;

    if ((vll= GetLabellist(title))) {
      UF_PrintE("warning: labellist '%s' already exists\n", title);
      return TRUE; }
    else {
      Labellist_t ll;
      if ((ll= CreateLabellist(title, ""))) {
	return InsertLabellist(ll); }
      else {
	ErrPrintR("fatal: can not create labellist '%s'\n", title); } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_Delete()
{
  char title[IOBUFLEN];

  if (UF_ItemRead(title, IOBUFLEN, "title of labellist to delete") &&
      *title) {
    VdLabellist destroy;

    if ((destroy= GetLabellist(title))) {
      if (destroy->prev) { destroy->prev->next= destroy->next; }
      else { root= destroy->next; }
      if (destroy->next) { destroy->next->prev= destroy->prev; }

      DestroyLabellist(destroy->lbls);
      Free(destroy);
      UF_PrintM("labellist '%s' deleted\n", title);
      return TRUE; }
    else if (!strcmp(title, "tmp")) {
      VdSetup setup;
      if ((setup= DW_GetSetup()) && setup->dlbl) {
	DeleteLabels(&setup->dlbl->tmp);
	UF_PrintM("%s: temporary labellist '%s' deleted\n",
		  XtName(setup->frm), title); }
      return TRUE; }
    UF_PrintE("warning: labellist '%s' not found\n", title); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_ReadMerge()
{
  return ReadFile(TRUE);
}
/* ---------------------------------------------------------------------- */
int DL_ReadReplace()
{
  return ReadFile(FALSE);
}
/* ---------------------------------------------------------------------- */
int DL_ShowActCut()
{
  VdSetup setup;;

  ForAllSetups(setup) {
    if (setup->dcutlbl) {
      DrawLbl_t d= &setup->dcutlbl->lbl;
      UF_PrintM("%-16s: cut-label: ", XtName(setup->frm));
      PrintLabelParam(d); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DL_ShowActFit()
{
  VdSetup setup;;

  ForAllSetups(setup) {
    if (setup->dfitlbl) {
      DrawLbl_t d= &setup->dfitlbl->lbl;
      UF_PrintM("%-16s: fit-label: ", XtName(setup->frm));
      PrintLabelParam(d); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DL_ShowActPeaklist()
{
  VdSetup setup;;

  ForAllSetups(setup) {
    if (setup->dpeaklbl) {
      DrawLbl_t d= &setup->dpeaklbl->lbl;
      UF_PrintM("%-16s: peaklist-label: ", XtName(setup->frm));
      PrintLabelParam(d); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DL_ShowActUser()
{
  VdSetup setup;;

  ForAllSetups(setup) {
    if (setup->dlbl) {
      DrawLbl_t d= &setup->dlbl->lbls.lbl;
      Labellist_t ll= DrawLblLbl(d);
      UF_PrintM("%-16s: title: %-16s file: %-30s",
		XtName(setup->frm),
		LabellistTitle(ll), PthShort(LabellistFile(ll)));
      PrintLabelParam(d); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DL_ShowLists()
{
  VdLabellist vll;

  ForAllLabellists(vll) {
    UF_PrintM("title: %-16s file: %-30s\n",
	      LabellistTitle(vll->lbls), PthShort(LabellistFile(vll->lbls))); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DL_WriteCut()
{
  char file[IOBUFLEN];

  if (UF_ItemRead(file, IOBUFLEN, "labellist output file") && *file) {
    char *path;

    if ((path= PthExpand(file))) {
      VdSetup setup;

      if ((setup= DW_GetSetup())) {
	if (WriteDrawLabel(&setup->dcutlbl->lbl, path)) {
	  UF_PrintM("cut labels of '%s' written to '%s'\n",
		    setup->gow_name, PthShort(path));
	  return TRUE; }
	else {
	  ErrPrint("error: can not write cut labels of '%s' to '%s'\n",
		   setup->gow_name, PthShort(path));
	  return FALSE; } } }
    else { ErrPrint("error: can not expand '%s'\n", file); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_WriteFit()
{
  char file[IOBUFLEN];

  if (UF_ItemRead(file, IOBUFLEN, "labellist output file") && *file) {
    char *path;

    if ((path= PthExpand(file))) {
      VdSetup setup;

      if ((setup= DW_GetSetup())) {
	if (WriteDrawLabel(&setup->dfitlbl->lbl, path)) {
	  UF_PrintM("fit labels of '%s' written to '%s'\n",
		    setup->gow_name, PthShort(path));
	  return TRUE; }
	else {
	  ErrPrint("error: can not write fit labels of '%s' to '%s'\n",
		   setup->gow_name, PthShort(path));
	  return FALSE; } } }
    else { ErrPrint("error: can not expand '%s'\n", file); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_WritePeaklist()
{
  char file[IOBUFLEN];

  if (UF_ItemRead(file, IOBUFLEN, "labellist output file") && *file) {
    char *path;

    if ((path= PthExpand(file))) {
      VdSetup setup;

      if ((setup= DW_GetSetup())) {
	if (WriteDrawLabel(&setup->dpeaklbl->lbl, path)) {
	  UF_PrintM("peaklabels of '%s' written to '%s'\n",
		    setup->gow_name, PthShort(path));
	  return TRUE; }
	else {
	  ErrPrint("error: can not write peaklabels of '%s' to '%s'\n",
		   setup->gow_name, PthShort(path));
	  return FALSE; } } }
    else { ErrPrint("error: can not expand '%s'\n", file); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_WriteUser()
{
  char title[IOBUFLEN];
  char file[IOBUFLEN];

  if (UF_ItemRead(file, IOBUFLEN, "labellist output file") && *file &&
      UF_ItemRead(title, IOBUFLEN, "labellist title") && *title) {
      
    char *path;

    if ((path= PthExpand(file))) {
      VdLabellist vll;

      if ((vll= GetLabellist(title))) {
	if (WriteLabellist(vll->lbls, path)) {
	  UF_PrintM("labellist '%s' written to '%s'\n",
		    title, PthShort(path));
	  return TRUE; }
	else {
	  ErrPrint("error: can not write labellist '%s' to '%s'\n",
		   title, PthShort(path));
	  return FALSE; } }
      else { UF_PrintE("warning: labellist '%s' not found\n", title); } }
    else { ErrPrint("error: can not expand '%s'\n", file); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_PosInsert(setup, pos)
     VdSetup setup;
     double pos;
{
  if (setup->dpos) {
    GowLabel d= &setup->dpos->lbls;
    if (!InsertLabel(DrawLblLbl(&d->lbl), pos, 0, NULL)) {
      ErrPrintR("fatal: can not insert label at %g\n", pos);
      return FALSE; }
    else if (setup->dpos) {
      GowChangeSubobjectStat(d->goo, (GowAppDrawdata)d, GowDrawSubobj); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
void DL_PosDelete(setup)
     VdSetup setup;
{
  if (setup->dpos)
    DeleteLabels(DrawLblLbl(&setup->dpos->lbls.lbl));
}
/* ---------------------------------------------------------------------- */
int DL_EnterLabel()
{
  char txt[IOBUFLEN];
  VdSetup setup;

  if ((setup= DW_GetSetup()) && setup->dlbl) {
    Labellist_t current= DrawLblLbl(&setup->dlbl->lbls.lbl);
    int gc;
    int ret_val;
    double pos;

    if (!Mrk_EnterSingleV(LabellistScale(current),
			  DrawLblCal(&setup->dlbl->lbls.lbl), &pos,
			  "enter label position")) { return FALSE; }
    if (UF_NoArgs()) {
      ret_val= InsertLabel(current, pos, 0, NULL); }
    else if (!UF_IntRead(FALSE, &gc, "gc-index")) { return FALSE; }
    else if (UF_NoArgs()) {
      ret_val= InsertLabel(current, pos, gc, NULL); }
    else if (!UF_ItemRead(txt, IOBUFLEN, "label-text")) { return FALSE; }
    else { ret_val= InsertLabel(current, pos, gc, txt); }

    if (ret_val) { DL_ManageSetup(setup); return TRUE; }
    else { ErrPrintR("fatal: can not insert label at %g\n", pos); } }
  else { UF_PrintE("error: no labellist defined\n"); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_DeleteLabelAll()
{
  VdSetup setup;

  if ((setup= DW_GetSetup()) && setup->dlbl) {
    DeleteLabels(DrawLblLbl(&setup->dlbl->lbls.lbl)); return TRUE; }
  else { UF_PrintE("error: no labellist defined\n"); return FALSE; }
}
/* ---------------------------------------------------------------------- */
int DL_DeleteLabelCursor()
{
  VdSetup setup;

  if ((setup= DW_GetSetup()) && setup->dlbl) {
    Widget w;
    int px, py;
    Labellist_t current= DrawLblLbl(&setup->dlbl->lbls.lbl);

    if (DW_GetCursor(&w, &px, &py)) {
      int idx= DrawLabelGetIndex(&setup->dlbl->lbls.lbl, px, py);
      if (idx >= 0) {
	DeleteLabelIdx(current, idx);
	return TRUE; }
      else {
	UF_PrintE("warning: no label deleted in '%s'\n",
		  LabellistTitle(current)); } } }
  else { UF_PrintE("error: no labellist defined\n"); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
void DL_ManageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowLabel d= &setup->dlbl->lbls;
    if (d && DL_ChangeActSpc(setup->dlbl, setup->act)) {
      GowManageChild(d->goo); } }
}
/* ---------------------------------------------------------------------- */
void DL_UnmanageSetup(setup)
     VdSetup setup;
{
  if (setup) { GowUnmanageChild(setup->dlbl->lbls.goo); }
}
/* ---------------------------------------------------------------------- */
int DL_Manage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DL_ManageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DL_Unmanage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DL_UnmanageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DL_Scale()
{
  char title[IOBUFLEN];

  if (UF_ItemRead(title, IOBUFLEN, "labellist title") && *title) {
    Labellist_t ll;
    VdLabellist vll;
    VdSetup setup;
    if ((vll= GetLabellist(title))) {
      ll= vll->lbls; }
    else if (!strcmp(title, "tmp") && (setup= DW_GetSetup())) {
      ll= &setup->dlbl->tmp; }
    else {
      UF_PrintE("warning: labellist '%s' not found\n", title);
      return FALSE; }
    if (Act_Scale(&LabellistScale(ll), title)) {
      ChangedLabellist(ll); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_CutCalib() { return CutCalib(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_CutNoCalib() { return CutCalib(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_FitCalib() { return FitCalib(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_FitNoCalib() { return FitCalib(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_PeaklistCalib() { return PeaklistCalib(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_PeaklistNoCalib() { return PeaklistCalib(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_UserCalib() { return UserCalib(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_UserNoCalib() { return UserCalib(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_CutUncalib() { return CutUncalib(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_CutNoUncalib() { return CutUncalib(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_FitUncalib() { return FitUncalib(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_FitNoUncalib() { return FitUncalib(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_PeaklistUncalib() { return PeaklistUncalib(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_PeaklistNoUncalib() { return PeaklistUncalib(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_UserUncalib() { return UserUncalib(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_UserNoUncalib() { return UserUncalib(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_CutString() { return CutString(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_CutNoString() { return CutString(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_FitString() { return FitString(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_FitNoString() { return FitString(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_PeaklistString() { return PeaklistString(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_PeaklistNoString() { return PeaklistString(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_UserString() { return UserString(TRUE); }
/* ---------------------------------------------------------------------- */
int DL_UserNoString() { return UserString(FALSE); }
/* ---------------------------------------------------------------------- */
int DL_CutLibrary()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelLibrary(setup->dcutlbl); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_FitLibrary()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    return (LabelLibrary(setup->dfitlbl) &
	    LabelLibrary(DF_GetLabel(setup->dfit))); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_PeaklistLibrary()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelLibrary(setup->dpeaklbl); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DL_UserLibrary()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelLibrary(&setup->dlbl->lbls); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int CutCalib(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelCalib(setup->dcutlbl, on); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int FitCalib(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    return (LabelCalib(setup->dfitlbl, on) &
	    LabelCalib(DF_GetLabel(setup->dfit), on)); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int PeaklistCalib(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelCalib(setup->dpeaklbl, on); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int UserCalib(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelCalib(&setup->dlbl->lbls, on); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int LabelCalib(gl, on)
     GowLabel gl;
     int on;
{
  if (DrawLblPosCalib(&gl->lbl) != on) {
    DrawLblPosCalib(&gl->lbl)= on;
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowHideSubobj);
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowDrawSubobj); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int CutUncalib(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelUncalib(setup->dcutlbl, on); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int FitUncalib(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    return (LabelUncalib(setup->dfitlbl, on) &
	    LabelUncalib(DF_GetLabel(setup->dfit), on)); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int PeaklistUncalib(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelUncalib(setup->dpeaklbl, on); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int UserUncalib(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelUncalib(&setup->dlbl->lbls, on); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int LabelUncalib(gl, on)
     GowLabel gl;
     int on;
{
  if (DrawLblPosUncalib(&gl->lbl) != on) {
    DrawLblPosUncalib(&gl->lbl)= on;
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowHideSubobj);
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowDrawSubobj); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int CutString(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelString(setup->dcutlbl, on); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int FitString(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    return (LabelString(setup->dfitlbl, on) &
	    LabelString(DF_GetLabel(setup->dfit), on)); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int PeaklistString(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelString(setup->dpeaklbl, on); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int UserString(on)
     int on;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { return LabelString(&setup->dlbl->lbls, on); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int LabelString(gl, on)
     GowLabel gl;
     int on;
{
  if (DrawLblString(&gl->lbl) != on) {
    DrawLblString(&gl->lbl)= on;
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowHideSubobj);
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowDrawSubobj); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static void PrintLabelParam(d)
     DrawLbl_t d;
{
  if (DrawLblLib(d) && DrawLblFct(d)) {
    UF_PrintM(" library: %s",
	      LabellistTitle((Labellist_t)DrawLblLib(d))); }
  UF_PrintM("%s%s%s\n",
	    DrawLblPosCalib(d) ? " calibrated" : "",
	    DrawLblPosUncalib(d) ? " uncalibrated" : "",
	    DrawLblString(d) ? " string" : "");
}
/* ---------------------------------------------------------------------- */
static int LabelLibrary(gl)
     GowLabel gl;
{
  char library[IOBUFLEN];
  VdLabellist vll;
  void *lib;
  if (UF_NoArgs()) { lib= NULL; }
  else if (!UF_ItemRead(library, IOBUFLEN, "labellist")) { return FALSE; }
  else if (!(vll= GetLabellist(library))) {
    UF_PrintE("error: labellist '%s' not found\n", library); return FALSE; }
  else { lib= vll->lbls; }
  UseLibrary(gl, lib);
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static VdLabellist GetLabellist(title)
     char *title;
{
  VdLabellist vll;

  ForAllLabellists(vll) {
    if (!strcmp(title, LabellistTitle(vll->lbls))) { return vll; } }
  return NULL;
}
/* ---------------------------------------------------------------------- */
static Labellist_t CreateLabellist(title, path)
     char *title;
     char *path;
{
  Labellist_t l;

  if ((l= (Labellist_t)Malloc(sizeof(LabellistRec)))) {
    LabellistTitle(l)	= Strdup(title);
    LabellistFile(l)	= Strdup(path ? path : "");
    LabellistFirst(l)
      = LabellistLast(l)
	= LabellistCurrent(l)= NULL;
    { VdSetup setup;
      if ((setup= DW_GetSetup())) { LabellistScale(l)= VactScale(setup->act); }
      else { LabellistScale(l)= ACT_SDEFAULT; } } }
  return l;
}
/* ---------------------------------------------------------------------- */
static void DeleteLabels(labellist)
     Labellist_t labellist;
{
  if (labellist) {
    VdLbl_t lbl= LabellistFirst(labellist);
    int changed= FALSE;

    while (lbl) {
      VdLbl_t next= VdLblNext(lbl);

      changed= TRUE;
      Free(VdLblTxt(lbl));
      Free(lbl);
      lbl= next; }
    LabellistFirst(labellist)
      = LabellistLast(labellist)
	= LabellistCurrent(labellist)= NULL;
    if (changed) { ChangedLabellist(labellist); } }
}
/* ---------------------------------------------------------------------- */
static Labellist_t DestroyLabellist(labellist)
     Labellist_t labellist;
{
  if (labellist) {
    VdSetup setup;
    void *dl= labellist;
    ForAllSetups(setup) {
      if (setup->dlbl) {
	if (DrawLblLbl(&setup->dlbl->lbls.lbl) == dl) {
	  UseLabellist(setup, NULL); }
	UseNotLibrary(&setup->dlbl->lbls, dl); }
      if (setup->dcutlbl) { UseNotLibrary(setup->dcutlbl, dl); }
      if (setup->dfitlbl) { UseNotLibrary(setup->dfitlbl, dl); }
      if (setup->dfit) { UseNotLibrary(DF_GetLabel(setup->dfit), dl); }
      if (setup->dpeaklbl) { UseNotLibrary(setup->dpeaklbl, dl); } }
    DeleteLabels(labellist);
    Free(LabellistTitle(labellist));
    Free(LabellistFile(labellist));
    Free(labellist); }
  return NULL;
}
/* ---------------------------------------------------------------------- */
static int InsertLabellist(ll)
     Labellist_t ll;
{
  VdLabellist new;

  if ((new= (VdLabellist)Malloc(sizeof(VdLabellistRec)))) {
    new->next= new->prev= NULL;
    new->lbls= ll;
    if (root) {
      VdLabellist vll;

      ForAllLabellists(vll) {
	if (!vll->next) { vll->next= new; new->prev= vll; break; } } }
    else { root= new; }
    UF_PrintM("labellist '%s'(%s) created\n",
	      LabellistTitle(ll), PthShort(LabellistFile(ll)));
    UseLabellist(DW_GetSetup(), new->lbls);
    return TRUE; }
  else {
    ErrPrintR("fatal: can not create labellist entry for '%s'\n",
	      LabellistTitle(ll));
    DestroyLabellist(ll);
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static void *NextLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  return (void *)(l ? VdLblNext((VdLbl_t)l) :
		  LabellistFirst((Labellist_t)dlbl));
}
/* ---------------------------------------------------------------------- */
static void *PrevLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  return (void *)(l ? VdLblPrev((VdLbl_t)l) :
		  LabellistLast((Labellist_t)dlbl));
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static int LabelGC(dlbl, l)
     void *dlbl;
     void *l;
{
  return VdLblGC((VdLbl_t)l);
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static double LabelPos(dlbl, l)
     void *dlbl;
     void *l;
{
  return VdLblX((VdLbl_t)l);
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static char *LabelTxt(dlbl, l)
     void *dlbl;
     void *l;
{
  return VdLblTxt((VdLbl_t)l);
}
/* ---------------------------------------------------------------------- */
static Boolean LabelCalibrated(dlbl)
     void *dlbl;
{
  return VactCalibrated(LabellistScale((Labellist_t)dlbl));
}
/* ---------------------------------------------------------------------- */
static void UseLabellist(setup, ll)
     VdSetup setup;
     Labellist_t ll;
{
  if (setup && setup->dlbl) {
    DrawLbl_t l= &setup->dlbl->lbls.lbl;
    ll= ll ? ll : &setup->dlbl->tmp;

    if (ll != DrawLblLbl(l)) {
      DeleteLabels(&setup->dlbl->tmp);
      DrawLblLbl(l)= (void *)ll;
      DL_UnmanageSetup(setup);
      ChangedLabellist(ll);
      DL_ManageSetup(setup); }
    UF_PrintM("%s: using labellist '%s'(%s)\n",
	      XtName(setup->frm),
	      LabellistTitle(ll), PthShort(LabellistFile(ll))); }
}
/* ---------------------------------------------------------------------- */
static void UseLibrary(gl, lib)
     GowLabel gl;
     void *lib;
{
  if (DrawLblLib(&gl->lbl) != lib) {
    DrawLblLib(&gl->lbl)= lib;
    DrawLblLibFct(&gl->lbl)= &fct;
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowHideSubobj);
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowDrawSubobj); }
}
/* ---------------------------------------------------------------------- */
static void UseNotLibrary(gl, lib)
     GowLabel gl;
     void *lib;
{
  if (DrawLblLib(&gl->lbl) == lib) {
    DrawLblLib(&gl->lbl)= NULL;
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowHideSubobj);
    GowChangeSubobjectStat(gl->goo, (GowAppDrawdata)gl, GowDrawSubobj); }
}
/* ---------------------------------------------------------------------- */
static int ReadFile(merge)
     int merge;
{
  char title[IOBUFLEN];
  char file[IOBUFLEN];

  if (UF_ItemRead(file, IOBUFLEN, "labellist input file") && *file) {
    if (UF_NoArgs()) { *title= '\0'; }
    else if (!UF_ItemRead(title, IOBUFLEN, "title of labellist to read")) {
      return FALSE; }

    { char *path;

      if ((path= UF_Find(file))) {
	return ReadLabellist(title, path, merge); }
      else {
	ErrPrintR("fatal: can not find labellist file '%s'\n", file); } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int ReadLabellist(title, file, merge)
     char *title;
     char *file;
     int merge;
{
  char path[MAXPATHLEN];

  strcpy(path, PthExpand(file));

  if (!ReadTitle(title, path)) { ; }
  else {
    FILE *fp;
    if ((fp= fopen(path, "r"))) {
      char line[IOBUFLEN];
      char token[IOBUFLEN];
      Labellist_t ll, old;
      VdLabellist vll;

      old= ((vll= GetLabellist(title)) && merge) ? vll->lbls : NULL;
      if (!(ll= (old && merge) ? old : CreateLabellist(title, path))) {
	ErrPrintR("fatal: can not create labellist '%s'\n", title);
	fclose(fp); return FALSE; }

      while (fgets(line, IOBUFLEN, fp)) {
	double x;
	int gc;
	char *txt= token;
	if (*line == '#') { continue; }

	switch(sscanf(line, "%lf %d %[ -}]", &x, &gc, token)) {
	case 1: gc= 0;
	case 2: txt= NULL;
	case 3:
	  if (!InsertLabelSilent(ll, x, gc, txt)) {
	    ErrPrintR("fatal: can not insert label %g in labellist '%s'\n",
		      x, title);
	    fclose(fp);
	    if (!old || !merge) { DestroyLabellist(ll); }
	    return FALSE; }
	  break;
	default: break; } }

      fclose(fp);
      if (vll) {
	if (merge) {
	  UF_PrintM("labellist '%s'(%s) merged\n",
		    LabellistTitle(ll), PthShort(LabellistFile(ll)));
	  return TRUE; }
	else { return ReplaceLabellist(vll, ll); } }
      else { return InsertLabellist(ll); } } }
  ErrPrintR("fatal: can not read labellist '%s'(%s)\n",
	    title, PthShort(path));
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int InsertLabel(labellist, x, gc, txt)
     Labellist_t labellist;
     double x;
     int gc;
     char *txt;
{
  if (InsertLabelSilent(labellist, x, gc, txt)) {
    ChangedLabellist(labellist); return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int InsertLabelSilent(labellist, x, gc, txt)
     Labellist_t labellist;
     double x;
     int gc;
     char *txt;
{
  VdLbl_t new;

  if (!(new= (VdLbl_t)Malloc(sizeof(VdLblRec)))) { return FALSE; }
  else {
    VdLbl_t l= (LabellistCurrent(labellist) ? LabellistCurrent(labellist) :
		LabellistFirst(labellist));

    VdLblX(new)= x;
    VdLblGC(new)= gc;
    VdLblTxt(new)= txt ? Strdup(txt) : NULL;

    if (l) {
      while (VdLblX(l) <= x && VdLblNext(l)) { l= VdLblNext(l); }
      while (VdLblX(l) >  x && VdLblPrev(l)) { l= VdLblPrev(l); }
      if (VdLblX(l) > x) {
	LabellistFirst(labellist)= new;
	VdLblPrev(new)= NULL; VdLblNext(new)= l; VdLblPrev(l)= new; }
      else {
	VdLblPrev(new)= l; VdLblNext(new)= VdLblNext(l);
	if (VdLblNext(l)) { VdLblPrev(VdLblNext(l))= new; }
	else { LabellistLast(labellist)= new; }
	VdLblNext(l)= new; } }
    else {
      LabellistFirst(labellist)= LabellistLast(labellist)= new;
      VdLblPrev(new)= VdLblNext(new)= NULL; }
    LabellistCurrent(labellist)= new; 
   return TRUE; }
}
/* ---------------------------------------------------------------------- */
static void DeleteLabelIdx(labellist, idx)
     Labellist_t labellist;
     int idx;
{
  if (labellist) {
    VdLbl_t l;
    int i;
    for (i= 0, l= LabellistFirst(labellist); l; i++, l= VdLblNext(l)) {
      if (i == idx) {
	if (l == LabellistCurrent(labellist)) {
	  LabellistCurrent(labellist)
	    = VdLblNext(LabellistCurrent(labellist)); }
	if (VdLblNext(l)) { VdLblPrev(VdLblNext(l))= VdLblPrev(l); }
	else { LabellistLast(labellist)= VdLblPrev(l); }
	if (VdLblPrev(l)) { VdLblNext(VdLblPrev(l))= VdLblNext(l); }
	else { LabellistFirst(labellist)= VdLblNext(l); }
	Free(VdLblTxt(l)); Free(l);
	ChangedLabellist(labellist);
	return; } } }
}
/* ---------------------------------------------------------------------- */
static int WriteLabellist(labellist, file)
     Labellist_t labellist;
     char *file;
{
  FILE *fp;
  char *path;

  path= PthExpand(file);
  if (NULL == (fp= fopen(file, "w"))) { return FALSE; }
  else {
    if (fprintf(fp, "#labellist %s\n", LabellistTitle(labellist)) < 0) {
      fclose(fp); return FALSE; }
    else {
      VdLbl_t l= LabellistFirst(labellist);

      while (l) {
	if (fprintf(fp, "%g %d %s\n", VdLblX(l), VdLblGC(l),
		    VdLblTxt(l) ? VdLblTxt(l) : "") < 0) {
	  fclose(fp); return FALSE; }
	l= VdLblNext(l); }

      fclose(fp);
      Free(LabellistFile(labellist));
      LabellistFile(labellist)= Strdup(path);
      return TRUE; } }
}
/* ---------------------------------------------------------------------- */
static int WriteDrawLabel(dlbl, file)
     DrawLbl_t dlbl;
     char *file;
{
  FILE *fp;
  char *path;

  path= PthExpand(file);
  if (NULL == (fp= fopen(file, "w"))) { return FALSE; }
  else {
    if (fprintf(fp, "#labellist %s\n", PthTail(path)) < 0) {
      fclose(fp); return FALSE; }
    else {
      void *l= NULL;

      while ((l= DrawLblNext(dlbl)(DrawLblLbl(dlbl), l))) {

	if (fprintf(fp, "%g %d %s\n",
		    DrawLblPos(dlbl)(DrawLblLbl(dlbl), l),
		    (DrawLblGC(dlbl) ?
		     DrawLblGC(dlbl)(DrawLblLbl(dlbl), l) :
		     DrawLblGCIdx(dlbl)),
		    (DrawLblTxt(dlbl) ?
		     DrawLblTxt(dlbl)(DrawLblLbl(dlbl), l) : "")) < 0) {
	  fclose(fp); return FALSE; } }

      fclose(fp);
      return TRUE; } }
}
/* ---------------------------------------------------------------------- */
static void ChangedLabellist(labellist)
     Labellist_t labellist;
{
  VdSetup setup;
  ForAllSetups(setup) {
    if (setup->dlbl) {
      GowLabel d= &setup->dlbl->lbls;
      if (DrawLblLbl(&d->lbl) == labellist) {
	GowChangeSubobjectStat(d->goo, (GowAppDrawdata)d, GowDrawSubobj); } } }
}
/* ---------------------------------------------------------------------- */
static int ReplaceLabellist(vll, ll)
     VdLabellist vll;
     Labellist_t ll;
{
  DestroyLabellist(vll->lbls);
  vll->lbls= ll;
  ChangedLabellist(ll);
  UF_PrintM("labellist '%s' replaced\n", LabellistTitle(ll));
  UseLabellist(DW_GetSetup(), ll);
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int ReadTitle(title, file)
     char *title;
     char *file;
{
  FILE *fp;

  if (!title || !file) { return FALSE; }
  else if (*title) { return TRUE; }
  else if (!(fp= fopen(file, "r"))) { return FALSE; }
  else {
    if (fscanf(fp, "#labellist %s", title) <= 0) {
      strcpy(title, PthTail(file)); }
    fclose(fp);
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
