/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdMark.c,v 1.3 1994/09/20 14:48:42 vs Exp vs $ */

#define _VdFit_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowVsWidget.h>
#include <Gow/GowHMark.h>
#include <Gow/GowVMark.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsMark.h"
#include "VsUserFace.h"

#include "VdNotify.h"
#include "VdWidget.h"

#include "VdMark.h"
#include "VdMarkP.h"
/* ---------------------------------------------------------------------- */
typedef struct _VdMarkRec {
  GowHMark hmrk;
  GowVMark vmrk;
} VdMarkRec;
/* ---------------------------------------------------------------------- */
/* ============================== */
/* initialize display mark module */
/* ============================== */

VdMark DM_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  VdMark d;

  if ((d= (VdMark)Malloc(sizeof(VdMarkRec)))) {
    d->hmrk= (GowHMark)Malloc(sizeof(GowHMarkRec));
    d->vmrk= (GowVMark)Malloc(MRK_NUM * sizeof(GowVMarkRec));
    if (d->hmrk && d->vmrk) {
      GowVMark v= d->vmrk;
      int i;
      int a= VactSpcIdx(ap);

      for (i= 0; i< MRK_NUM; i++) { /* all types of vertical marks */
	Vmrk_t *m= VmrksMrks(&vMrk) + i;
	Widget goo;

	if (i == MRK_RANGE) { continue; }
	else if ((goo= XtVaCreateWidget(VmrkName(m), gowVMarkObjectClass,
				       parent, NULL))) {
	  DrawVMarkInit(&v[i].mrk);
	  DrawVMrkGCIdx(&v[i].mrk)= 0;
	  DrawVMrkMrk(&v[i].mrk)= VmrkMrk(m);
	  DrawVMrkSgl(&v[i].mrk)= VmrkSgl(m);
	  DrawVMrkCalibrated(&v[i].mrk)= VmrkCalibrated(m);
	  DrawVMrkCal(&v[i].mrk)= VcalsCal(&vCal,a);
	  v[i].gow= parent;
	  v[i].goo= goo;
	  GowInsertSubobject(goo,
			     (GowAppDrawdata)(v + i), GowDrawSubobj); } }

      { Widget goo;		/* horizontal marks */
	Vmrk_t *m= VmrksHorizontal(&vMrk);

	if ((goo= XtVaCreateWidget(VmrkName(m), gowHMarkObjectClass,
				  parent, NULL))) {
	  GowHMark h= d->hmrk;

	  DrawHMarkInit(&h->mrk);
	  DrawHMrkGCIdx(&h->mrk)= 0;
	  DrawHMrkMrk(&h->mrk)= VmrkMrk(m);
	  DrawHMrkSgl(&h->mrk)= VmrkSgl(m);
	  h->gow= parent;
	  h->goo= goo;
	  GowInsertSubobject(goo,
			     (GowAppDrawdata)h, GowDrawSubobj); } }

      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d->hmrk);
      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d->vmrk);
      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
      DM_ChangeActSpc(d, ap);
      return d; }
    else { Free(d->hmrk); Free(d->vmrk); Free(d); } }

  ErrPrintR("fatal: can not initialize draw-mark-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
int DM_ChangeActSpc(d, ap)
     VdMark d;
     Vact_t ap;
{
  if (d) {
    GowVMark v= d->vmrk;
    Widget parent= v->gow;
    Cal_t cal= VcalsCal(&vCal,VactSpcIdx(ap));
    int i;
    Boolean redisplay= FALSE;
    Boolean calibrated;

    { Arg args[1];
      XtSetArg(args[0], XtNxScaleCalibrated, &calibrated);
      XtGetValues(parent, args, XtNumber(args)); }

    for (i= 0; i< MRK_NUM; i++) { /* all types of vertical marks */
      Widget o= v[i].goo;
      GowSubobjStat status;
      Boolean visible;

      if (i != MRK_RANGE &&
	  !redisplay &&
	  calibrated != VmrkCalibrated(VmrksMrks(&vMrk) + i) &&
	  GowGetSubobjectStat(o, (GowAppDrawdata)(v + i),
			      &status, &visible) &&
	  visible &&
	  !CalEqual(CAL_POS, DrawVMrkCal(&v[i].mrk), cal)) {
	GowChangeSubobjectStat(o, (GowAppDrawdata)(v + i), GowDrawSubobj); }
      DrawVMrkCal(&v[i].mrk)= cal; }
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DM_Manage(d, p)
     VdMark d;
     PVec_t p;
{
  if (d) {
    GowVMark v= d->vmrk;
    GowHMark h= d->hmrk;
    if (v) {
      int i;
      for (i= 0; i< MRK_NUM; i++) {
	if (DrawVMrkMrk(&v[i].mrk) == p) { break; } }
      switch (i) {
      case MRK_VERTICAL:
	GowManageChild(v[MRK_VERTICAL].goo); return;
      case MRK_RCL:
	GowManageChild(v[MRK_RCL].goo); return;
      case MRK_GATE:
      case MRK_GATEBG:
	GowManageChild(v[MRK_GATE].goo);
	GowManageChild(v[MRK_GATEBG].goo); return;
      case MRK_FITBG:
	GowManageChild(v[MRK_FITBG].goo); return;
      case MRK_FITREG:
      case MRK_FITBIN:
	GowManageChild(v[MRK_FITBG].goo);
	GowManageChild(v[MRK_FITREG].goo);
	GowManageChild(v[MRK_FITBIN].goo); return;
      case MRK_FITSEA:
	GowManageChild(v[MRK_FITSEA].goo); return;
      case MRK_NORM:
      case MRK_NORMBG:
	GowManageChild(v[MRK_NORM].goo);
	GowManageChild(v[MRK_NORMBG].goo); return; } }

    if (h) {
      if (DrawHMrkMrk(&h->mrk) == p) {
	GowManageChild(h->goo); return; } } }
}
/* ---------------------------------------------------------------------- */
int DM_ManageRcl()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowManageChild(v[MRK_RCL].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_ManageCut()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowManageChild(v[MRK_GATE].goo);
    GowManageChild(v[MRK_GATEBG].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_ManageFit()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowManageChild(v[MRK_FITBG].goo);
    GowManageChild(v[MRK_FITREG].goo);
    GowManageChild(v[MRK_FITBIN].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_ManageSea()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowManageChild(v[MRK_FITSEA].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_ManageNrm()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowManageChild(v[MRK_NORM].goo);
    GowManageChild(v[MRK_NORMBG].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
void DM_Unmanage(d, p)
     VdMark d;
     PVec_t p;
{
  if (d) {
    GowVMark v= d->vmrk;
    GowHMark h= d->hmrk;
    if (h) {
      if (DrawHMrkMrk(&h->mrk) == p) {
	GowUnmanageChild(h->goo); return; } }
    if (v) {
      int i;
      for (i= 0; i< MRK_NUM; i++) {
	if (DrawVMrkMrk(&v[i].mrk) == p) { break; } }
      switch (i) {
      case MRK_VERTICAL:
	GowUnmanageChild(v[MRK_VERTICAL].goo); break;
      case MRK_RCL:
	GowUnmanageChild(v[MRK_RCL].goo); break;
      case MRK_GATE:
      case MRK_GATEBG:
	GowUnmanageChild(v[MRK_GATE].goo);
	GowUnmanageChild(v[MRK_GATEBG].goo); break;
      case MRK_FITBG:
      case MRK_FITREG:
      case MRK_FITBIN:
	GowUnmanageChild(v[MRK_FITBG].goo);
	GowUnmanageChild(v[MRK_FITREG].goo);
	GowUnmanageChild(v[MRK_FITBIN].goo); break;
      case MRK_FITSEA:
	GowUnmanageChild(v[MRK_FITSEA].goo); break;
      case MRK_NORM:
      case MRK_NORMBG:
	GowUnmanageChild(v[MRK_NORM].goo);
	GowUnmanageChild(v[MRK_NORMBG].goo); break; } } }
  return;
}
/* ---------------------------------------------------------------------- */
int DM_UnmanageRcl()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowUnmanageChild(v[MRK_RCL].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_UnmanageCut()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowUnmanageChild(v[MRK_GATE].goo);
    GowUnmanageChild(v[MRK_GATEBG].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_UnmanageFit()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowUnmanageChild(v[MRK_FITBG].goo);
    GowUnmanageChild(v[MRK_FITREG].goo);
    GowUnmanageChild(v[MRK_FITBIN].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_UnmanageSea()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowUnmanageChild(v[MRK_FITSEA].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_UnmanageNrm()
{
  VdSetup setup;
  VdMark d;
  GowVMark v;
  if ((setup= DW_GetSetup()) && (d= setup->dmrk) && (v= d->vmrk)) {
    GowUnmanageChild(v[MRK_NORM].goo);
    GowUnmanageChild(v[MRK_NORMBG].goo);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_GetVMark(x, calibrated)
     double *x;
     int *calibrated;
{
  int px;
  Widget w;
  if (DW_GetCursor(&w, &px, NULL)) {
    VdSetup setup;
    if ((setup= DW_GetSetupOfWidget(w)) && GowGetUserX(w, px, x)) {
      Arg args[1];
      Boolean cal;

      XtSetArg(args[0], XtNxScaleCalibrated, &cal);
      XtGetValues(w, args, XtNumber(args));
      *calibrated= cal;
      return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DM_GetHMark(y)
     double *y;
{
  int py;
  Widget w;
  if (DW_GetCursor(&w, NULL, &py)) {
    VdSetup setup;
    if ((setup= DW_GetSetupOfWidget(w)) && GowGetUserY(w, py, y)) {
      return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
void DM_Changed(d, p)
     VdMark d;
     PVec_t p;
{
  if (d) {
    GowVMark v= d->vmrk;
    GowHMark h= d->hmrk;
    if (v) {
      int i;
      for (i= 0; i< MRK_NUM; i++, v++) {
	if (i == MRK_RANGE) { continue; }
	else if (DrawVMrkMrk(&v->mrk) == p) {
	  GowChangeSubobjectStat(v->goo, (GowAppDrawdata)v, GowDrawSubobj);
	  return; } } }
    if (h) {
      if (DrawHMrkMrk(&h->mrk) == p) {
	GowChangeSubobjectStat(h->goo, (GowAppDrawdata)h, GowDrawSubobj);
	return; } } }
}
/* ---------------------------------------------------------------------- */
void DM_ChangedScale(d, p)
     VdMark d;
     PVec_t p;
{
  if (d) {
    GowVMark v= d->vmrk;
    if (v) {
      int i;

      for (i= 0; i< MRK_NUM; i++, v++) {
	Vmrk_t *m= VmrksMrks(&vMrk) + i;
	if (DrawVMrkCalibrated(&v->mrk) != VmrkCalibrated(m)) {
	  if (i != MRK_RANGE &&
	      (!p || DrawVMrkMrk(&v->mrk) == p)) {
	    GowChangeSubobjectStat(v->goo, (GowAppDrawdata)v,
				   GowDrawSubobj);
	    if (p) { i= MRK_NUM; } } }
	DrawVMrkCalibrated(&v->mrk)= VmrkCalibrated(m); } } }
}
/* ---------------------------------------------------------------------- */
int DM_ChangedCal(d, ap, idx)
     VdMark d;
     Vact_t ap;
     int idx;
{
  if (d && VactSpcIdx(ap) == idx) {
    GowVMark v= d->vmrk;
    Widget parent= v->gow;
    Boolean redisplay= FALSE;
    Boolean calibrated;
    int i;

    { Arg args[1];
      XtSetArg(args[0], XtNxScaleCalibrated, &calibrated);
      XtGetValues(parent, args, XtNumber(args)); }

    for (i= 0; i< MRK_NUM; i++) { /* all types of vertical marks */
      Widget o= v[i].goo;
      GowSubobjStat status;
      Boolean visible;

      if (i != MRK_RANGE &&
	  !redisplay &&
	  calibrated != VmrkCalibrated(VmrksMrks(&vMrk) + i) &&
	  GowGetSubobjectStat(o, (GowAppDrawdata)(v + i),
			      &status, &visible) &&
	  visible) {
	GowChangeSubobjectStat(o, (GowAppDrawdata)(v + i), GowDrawSubobj); } }
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
