/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdNotify.c,v 1.2 1994/05/26 19:51:24 vs Exp vs $ */

#define _VdMain_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <sys/param.h>

#include <Gow/GowVsWidget.h>
#include <Gow/GowObject.h>
#include <Gow/GowFit.h>

#include "VsActiv.h"
#include "VsMark.h"
#include "VsNorm.h"

#include "VdWidget.h"
#include "VdAxis.h"
#include "VdBin.h"
#include "VdCut.h"
#include "VdCutLabel.h"
#include "VdDecomp.h"
#include "VdFit.h"
#include "VdFitLabel.h"
#include "VdLabel.h"
#include "VdMark.h"
#include "VdResid.h"
#include "VdPeakLabel.h"
#include "VdPeakList.h"
#include "VdSpectra.h"
#include "VdSpecList.h"
#include "VdStatus.h"

#include "VdNotify.h"
#include "VdNotifyP.h"
/* ---------------------------------------------------------------------- */
void DN_ChangedManaged(ap)
     Vact_t ap;
{
  VdSetup setup;
  DN_Delay(TRUE);
  ForAllSetups(setup) {
    if (setup->act == ap) {
      if (setup->dspc) { DS_ChangeManaged(setup->dspc, ap); } } }
  DN_Delay(FALSE);
}
/* ---------------------------------------------------------------------- */
void DN_ChangedActCut(ap)
     Vact_t ap;
{
  VdSetup setup;

  DN_Delay(TRUE);
  ForAllSetups(setup) {
    if (setup->act == ap) {
      DSt_UpdateStatus(setup);
      if (setup->dcut) { DC_ChangeActCut(setup->dcut, ap); }
      if (setup->dcutlbl) { DCL_ChangeActCut(setup->dcutlbl, ap); } } }
  DN_Delay(FALSE);
}
/* ---------------------------------------------------------------------- */
void DN_ChangedCutPathIdx(cutIdx)
     int cutIdx;
{
  VdSetup setup;
  ForAllSetups(setup) {
    if (VactCutIdx(setup->act) == cutIdx) {
      if (setup->dcutlbl) {
	DCL_ChangeActCut(setup->dcutlbl, setup->act); } } }
}
/* ---------------------------------------------------------------------- */
void DN_ChangedCutPath(pathIdx)
     int pathIdx;
{
  VdSetup setup;
  ForAllSetups(setup) {
    if (setup->dcutlbl) {
      DSt_UpdateStatus(setup);
      DCL_Changed(setup->dcutlbl, pathIdx); } }
}
/* ---------------------------------------------------------------------- */
void DN_ChangedActSpc(ap)
     Vact_t ap;
{
  VdSetup setup;

  DN_Delay(TRUE);

  Nrm_Update();
  ForAllSetups(setup) {
    if (setup->act == ap) {
      DSt_UpdateStatus(setup);
      DA_ChangedScale(setup->frm, setup->axis, setup->act);
      if (setup->dmrk) {
	DM_ChangeActSpc(setup->dmrk, ap); }
      if (setup->dres) {
	DR_ChangeActSpc(setup->dres, ap); }
      if (setup->dfit) {
	DF_ChangeActSpc(setup->dfit, ap); }
      if (setup->ddecomp) {
	DD_ChangeActSpc(setup->ddecomp, ap); }
      if (setup->dbin) {
	DB_ChangeActSpc(setup->dbin, ap); }
      if (setup->dfitlbl) {
	DFL_ChangeActSpc(setup->dfitlbl, ap); }
      if (setup->dlbl) {
	DL_ChangeActSpc(setup->dlbl, ap); }
      if (setup->dpeaklbl) {
	DPL_ChangeActSpc(setup->dpeaklbl, ap); }
      if (setup->dpeaks) {
	DPS_ChangeActSpc(setup->dpeaks, ap); } } }

  DN_Delay(FALSE);
}
/* ---------------------------------------------------------------------- */
void DN_ChangedMark(p, s)
     PVec_t p;
     Val_t s;
{
  DN_Delay(TRUE);
  { VdSetup setup;
    if ((setup= DW_GetSetup())) {
      if (ValDefined(s) || VecNum(p)) { DM_Manage(setup->dmrk, p); } } }

  if (p == VmrkMrk(VmrksNorm(&vMrk))) { Nrm_Update(); }

  { VdSetup setup;
    ForAllSetups(setup) {
      if (setup->dmrk) { DM_Changed(setup->dmrk, p); } } }
  DN_Delay(FALSE);
}
/* ---------------------------------------------------------------------- */
void DN_ChangedMarkScale(p, s)
     PVec_t p;
     Val_t s;
{
  DN_Delay(TRUE);
  if (!p || p == VmrkMrk(VmrksNorm(&vMrk))) { Nrm_Update(); }

  { VdSetup setup;
    ForAllSetups(setup) {
      if (setup->dmrk) { DM_ChangedScale(setup->dmrk, p); } } }
  DN_Delay(FALSE);
}
/* ---------------------------------------------------------------------- */
void DN_ChangedSpectrum(idx)
     int idx;
{
  VdSetup setup;

  DN_Delay(TRUE);
  Nrm_Update();
  DSL_Changed(idx);
  ForAllSetups(setup) {
    if (setup->dspc) { DS_Changed(setup->dspc, setup->act, idx); }
    if (setup->dres) { DR_Changed(setup->dres, setup->act, idx); } }
  DN_Delay(FALSE);
}
/* ---------------------------------------------------------------------- */
void DN_ChangedCut(idx)
     int idx;
{
  VdSetup setup;
  ForAllSetups(setup) {
    if (setup->dcut) { DC_Changed(setup->dcut, setup->act, idx); } }
}
/* ---------------------------------------------------------------------- */
void DN_ChangedFit(idx)
     int idx;
{
  VdSetup setup;
  DN_Delay(TRUE);
  ForAllSetups(setup) {
    if (setup->ddecomp) { DD_Changed(setup->ddecomp, setup->act, idx); }
    if (setup->dfit) { DF_Changed(setup->dfit, setup->act, idx); }
    if (setup->dres) { DR_Changed(setup->dres, setup->act, idx); } }
  DN_Delay(FALSE);
}
/* ---------------------------------------------------------------------- */
void DN_ChangedWorkPeak()
{
  VdSetup setup;
  DN_Delay(TRUE);
  DFL_Manage();
  ForAllSetups(setup) {
    if (setup->dfitlbl) { DFL_Changed(setup->dfitlbl); } }
  DN_Delay(FALSE);
}
/* ---------------------------------------------------------------------- */
void DN_ChangedPeak(idx)
     int idx;
{
  VdSetup setup;

  DN_Delay(TRUE);

  ForAllSetups(setup) {
    if (setup->dpeaklbl) {
      DPL_Changed(setup->dpeaklbl, setup->act, idx);
    }
    if (setup->dpeaks) {
      DPS_Changed(setup->dpeaks, setup->act, idx);
    }
    if (setup->dbin) {
      DB_Changed(setup->dbin, setup->act, idx);
    }
  }

  DN_Delay(FALSE);
}
/* ---------------------------------------------------------------------- */
void DN_ChangedScale(ap)
     Vact_t ap;
{
  VdSetup setup;
  Arg args[1];
  Boolean cal= VactCalibrated(VactScale(ap));

  XtSetArg(args[0], XtNxScaleCalibrated, cal);

  if (ap == vActDefault) { DN_Delay(TRUE); }

  ForAllSetups(setup) {
    if (setup->act == ap ||
	(ap == vActDefault && VactScale(setup->act) == ACT_SDEFAULT)) {
      DA_ChangedScale(setup->frm, setup->axis, setup->act);
      XtSetValues(setup->gow, args, XtNumber(args)); } }

  if (ap == vActDefault) {	/* scale used by displayed objects */
    DN_ChangedMarkScale(NULL, NULL); }

  if (ap == vActDefault) { DN_Delay(FALSE); }
}
/* ---------------------------------------------------------------------- */
void DN_ChangedCal(idx)
     int idx;
{
  VdSetup setup;

  ForAllSetups(setup) {
    DA_ChangedCal(setup->frm, setup->act, idx);
    if (VactCalibrated(VactScale(setup->act))) {
      GowRedisplayWidget(setup->gow); }
    else {
      Arg args[1];
      GowScaleModificationType ymod;
      XtSetArg(args[0], XtNyScaleModification, &ymod);
      XtGetValues(setup->gow, args, XtNumber(args));
      if (ymod == GowMefficiency) { GowRedisplayWidget(setup->gow); }
      else {
	GowDelayWidgetOutput(setup->gow, TRUE);
	if (setup->dfit) { DF_ChangedCal(setup->dfit, idx); }
	if (setup->dcutlbl) { DCL_ChangedCal(setup->dcutlbl, idx); }
	if (setup->dpeaklbl) { DPL_ChangedCal(setup->dpeaklbl, idx); }
	if (setup->dfitlbl) {
	  DFL_ChangedCal(setup->dfitlbl, setup->act, idx); }
	if (setup->dlbl) {
	  DL_ChangedCal(setup->dlbl, setup->act, idx); }
	if (setup->dmrk) { DM_ChangedCal(setup->dmrk, setup->act, idx); }
	GowDelayWidgetOutput(setup->gow, FALSE); } } }
}
/* ---------------------------------------------------------------------- */
void DN_ChangedNorm()
{
  VdSetup setup;
  ForAllSetups(setup) {
    Widget w= setup->gow;
    if (XtIsSubclass(w, gowVsWidgetClass)) {
      Arg args[1];
      Boolean normalized;
      XtSetArg(args[0], XtNspectraNormalized, &normalized);
      XtGetValues(setup->gow, args, XtNumber(args));
      if (normalized) {	GowRedisplayWidget(w); } } }
}
/* ---------------------------------------------------------------------- */
void DN_Delay(delay_output)
     int delay_output;
{
  VdSetup setup;
  ForAllSetups(setup) { GowDelayWidgetOutput(setup->gow, delay_output); }
  DSL_Delay(delay_output);
}
/* ---------------------------------------------------------------------- */
void DN_ResumeForced()
{
  VdSetup setup;
  Arg args[1];

  XtSetArg(args[0], XtNdelayOutput, GowDelayReset);
  ForAllSetups(setup) { XtSetValues(setup->gow, args, XtNumber(args)); }
  DSL_ResumeForced();
}
/* ---------------------------------------------------------------------- */
void DN_ChangedCwd()
{
  DSL_ChangedAll();
}
/* ---------------------------------------------------------------------- */
