/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdPeakLabel.c,v 1.2 1994/05/26 19:51:26 vs Exp vs $ */

#define _VdPeakLabel_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsPath.h>
#include <Gow/GowWidget.h>
#include <Gow/GowLabel.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsFitIo.h"
#include "VsNorm.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdPeakLabel.h"
#include "VdPeakLabelP.h"
/* ---------------------------------------------------------------------- */
/* ================================== */
/* initialize display PeakLabel module */
/* ================================== */

GowLabel DPL_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  GowLabel d;

  if ((d= (GowLabel)Malloc(sizeof(GowLabelRec)))) {
    Widget pl;

    if ((pl= XtVaCreateWidget("peaklist-label", gowLabelObjectClass,
			     parent, NULL))) {
      static DrawLblFctRec fct= {
	NextLabel,
	PrevLabel,
	NULL,
	NULL,
	LabelPos,
	LabelCalibrated, };
      DrawLbl_t l= &d->lbl;

      DrawLabelInit(l);
      DrawLblFct(l)		= &fct;
      DrawLblPosCalib(l)	= TRUE;
      DrawLblPosUncalib(l)	= TRUE;
      DrawLblString(l)		= TRUE;
      d->goo			= pl;
      d->gow			= parent;
      GowInsertSubobject(pl, (GowAppDrawdata)d, GowHideSubobj);

      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
      DPL_ChangeActSpc(d, ap);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw peak-label-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
static void *NextLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  return (void *)FioNextPeak((Fio_t)dlbl, 0.0, -1.0,
			     (FioCurPeak_t)l);
}
/* ---------------------------------------------------------------------- */
static void *PrevLabel(dlbl, l)
     void *dlbl;
     void *l;
{
  return (void *)FioPrevPeak((Fio_t)dlbl, 0.0, -1.0,
			     (FioCurPeak_t)l);
}
/* ---------------------------------------------------------------------- */
static double LabelPos(dlbl, l)
     void *dlbl;
     void *l;
{
  FioCurPeak_t cur= (FioCurPeak_t)l;
  Fio_t fio= (Fio_t)dlbl;
  switch (FioCurPeakTyp(cur)) {
  case FIO_PBIN:
    return FioPeaPChn(FioPea(fio), FioCurPeakPeaIdx(cur));
  case FIO_PSEA:
    return SeaPos(FioCurPeakSeaPeak(cur));
  default: return 0.0; }
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static Boolean LabelCalibrated(dlbl)
     void *dlbl;
{
  return FALSE;
}
/* ---------------------------------------------------------------------- */
void DPL_ManageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowLabel d= setup->dpeaklbl;

    if (d && DPL_ChangeActSpc(d, setup->act)) {
      GowManageChild(d->goo); } }
}
/* ---------------------------------------------------------------------- */
void DPL_UnmanageSetup(setup)
     VdSetup setup;
{
  if (setup) { GowUnmanageChild(setup->dpeaklbl->goo); }
}
/* ---------------------------------------------------------------------- */
int DPL_Manage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DPL_ManageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DPL_Unmanage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DPL_UnmanageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DPL_ChangeActSpc(d, ap)
     GowLabel d;
     Vact_t ap;
{
  if (d) {
    int a= VactSpcIdx(ap);
    DrawLbl_t l= &d->lbl;

    DrawLblGCIdx(l)	= a;
    DrawLblLbl(l)	= (void *)VfiosFFio(&vFio,a);
    DrawLblCal(l)	= VcalsCal(&vCal,a);
    DrawLblSpc(l)	= VspcsSpc(&vSpc,a);
    DrawLblNorm(l)	= &VnrmsFac(&vNrm,a);
    DPL_Changed(d, ap, a);
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DPL_Changed(d, ap, idx)
     GowLabel d;
     Vact_t ap;
     int idx;
{
  if (d && idx == VactSpcIdx(ap)) {
    GowSubobjStat status;
    Boolean visible;

    Widget o= d->goo;

    if (GowGetSubobjectStat(o, (GowAppDrawdata)d, &status, &visible) &&
	visible) {
      GowRedisplayObjectWidget(o); }
    else {
      GowChangeSubobjectStat(o, (GowAppDrawdata)d, GowDrawSubobj); } }
}
/* ---------------------------------------------------------------------- */
void DPL_ChangedCal(d, idx)
     GowLabel d;
     int idx;
{
  if (d) {
    GowSubobjStat status;
    Boolean visible;

    Widget o= d->goo;

    if (DrawLblPosCalib(&d->lbl) &&
	DrawLblCal(&d->lbl) == VcalsCal(&vCal,idx) &&
	GowGetSubobjectStat(o, (GowAppDrawdata)d, &status, &visible) &&
	visible) {
      GowRedisplayObjectWidget(o); } }
}
/* ---------------------------------------------------------------------- */
