/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdPeakList.c,v 1.2 1994/05/26 19:51:27 vs Exp vs $ */

#define _VdPeakList_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowWidget.h>
#include <Gow/GowPeakList.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsFitIo.h"
#include "VsNorm.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdPeakList.h"
#include "VdPeakListP.h"
/* ---------------------------------------------------------------------- */
/* ================================== */
/* initialize display PeakList module */
/* ================================== */

GowPeakList DPS_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  GowPeakList d;

  if ((d= (GowPeakList)Malloc(sizeof(GowPeakListRec)))) {
    Widget p;

    if ((p= XtVaCreateWidget("peaklist-function", gowPeakListObjectClass,
			     parent, NULL))) {
      DrawPeakListGCPos(&d->peaks)= 0;
      DrawPeakListGCNeg(&d->peaks)= 1;
      d->goo= p;
      d->gow= parent;

      GowInsertSubobject(p, (GowAppDrawdata)d, GowHideSubobj);

      XtAddCallback(parent, XtNdestroyCallback, DW_FreeCallback, d);
      DPS_ChangeActSpc(d, ap);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw peak-list-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
int DPS_ChangeActSpc(d, ap)
     GowPeakList d;
     Vact_t ap;
{
  if (d) {
    int a= VactSpcIdx(ap);
    DrawPeakListFio(&d->peaks)= VfiosFFio(&vFio,a);
    DrawPeakListCal(&d->peaks)= VcalsCal(&vCal,a);
    DrawPeakListNorm(&d->peaks)= &VnrmsFac(&vNrm,a);
    DPS_Changed(d, ap, a);
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void DPS_ManageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowPeakList d= setup->dpeaks;

    if (d && DPS_ChangeActSpc(d, setup->act)) {
      GowManageChild(d->goo); } }
}
/* ---------------------------------------------------------------------- */
void DPS_UnmanageSetup(setup)
     VdSetup setup;
{
  if (setup) {
    GowUnmanageChild(setup->dpeaks->goo); }
}
/* ---------------------------------------------------------------------- */
int DPS_Manage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DPS_ManageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DPS_Unmanage()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) { DPS_UnmanageSetup(setup); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
void DPS_Changed(d, ap, idx)
     GowPeakList d;
     Vact_t ap;
     int idx;
{
  if (d && idx == VactSpcIdx(ap)) {
    GowSubobjStat status;
    Boolean visible;
    Widget o= d->goo;

    if (GowGetSubobjectStat(o, (GowAppDrawdata)d, &status, &visible) &&
	 visible) {
      GowRedisplayObjectWidget(o); }
    else {
      GowChangeSubobjectStat(o, (GowAppDrawdata)d, GowDrawSubobj); } }
}
/* ---------------------------------------------------------------------- */
