/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdPlot.c,v 1.3 1994/09/20 14:48:50 vs Exp vs $ */

#define _VdPlot_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <tv/vsPath.h>
#include <Gow/GowPlot.h>

#include "VsUserFace.h"
#include "VsIndex.h"
#include "VsError.h"
#include "VsPath.h"

#include "VdWidget.h"
#include "VdStatus.h"

#include "VdPlot.h"
#include "VdPlotP.h"

static int x_px= 1024, y_px= 725;
static int x_pts= 72, y_pts= 72;
static double fontscale= 1.0;

#define CM_PER_INCH		2.54
/* ---------------------------------------------------------------------- */
int DP_PlotXfig()
{
  switch (Pth_TokenRead(PTH_TUNDEF, PTH_PLT,
			"xfig plot file | wc [%s]", PTH_PLT)) {
  case PTH_TPATTERN:
  case PTH_TPATH:
    if (!Idx_SetActSpc()) {
      return FALSE;
    }
    return Pth_LoopIndices(PlotXfigExec, PlotFinish);
  default:
    return FALSE;
  }
}
/* ---------------------------------------------------------------------- */
int DP_PlotUnix()
{
  switch (Pth_TokenRead(PTH_TUNDEF, PTH_PLT,
			"unix plot file | wc [%s]", PTH_PLT)) {
  case PTH_TPATTERN:
  case PTH_TPATH:
    if (!Idx_SetActSpc()) { return FALSE; }
    return Pth_LoopIndices(PlotUnixExec, PlotFinish);
  default: return FALSE; }
}
/* ---------------------------------------------------------------------- */
int DP_CmFormat()
{
  double p;
  double x_cm= (double)x_px / (double)x_pts * CM_PER_INCH;
  double y_cm= (double)y_px / (double)y_pts * CM_PER_INCH;

  if (UF_NoArgs()) {
    UF_PrintM("current plot format %.1gcm x %.1gcm\n", x_cm, y_cm); }
  if (UF_RealRead(FALSE, &x_cm, &p, "x [cm]") &&
      UF_RealRead(FALSE, &y_cm, &p, "y [cm]") &&
      x_cm > 0.0 && y_cm > 0.0) {
    x_px= (int)(x_cm * (double)x_pts / CM_PER_INCH);
    y_px= (int)(y_cm * (double)y_pts / CM_PER_INCH);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DP_PxFormat()
{
  int nx, ny;

  if (UF_NoArgs()) {
    UF_PrintM("current plot format %dpx x %dpx\n", x_px, y_px); }
  if (UF_IntRead(FALSE, &nx, "x [px]") &&
      UF_IntRead(FALSE, &ny, "y [px]") &&
      nx > 0 && ny > 0) {
    x_px= nx; y_px= ny; return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DP_PtsPerInch()
{
  int nx, ny;

  if (UF_NoArgs()) {
    UF_PrintM("current point/inch %d x %d\n", x_pts, y_pts); }
  if (UF_IntRead(FALSE, &nx, "x-points/inch") &&
      UF_IntRead(FALSE, &ny, "y-points/inch") &&
      nx > 0 && ny > 0) {
    x_pts= nx; y_pts= ny; return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DP_Fontscale()
{
  double fs, p;

  if (UF_NoArgs()) {
    UF_PrintM("current fontscale-factor %f\n", fontscale); }
  if (UF_RealRead(FALSE, &fs, &p, "fontscale-factor") && fs > 0.0) {
    fontscale= fs; return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int PlotXfigExec(idx, num)
     int idx;
     int num;
{
  return Plot("xfig");
}
/* ---------------------------------------------------------------------- */
static int PlotUnixExec(idx, num)
     int idx;
     int num;
{
  return Plot("unix-plot");
}
/* ---------------------------------------------------------------------- */
static int Plot(type)
     char *type;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    Widget w	= (setup == vdSetupRoot) ? setup->frm : setup->status->parent;

    if (!XtIsRealized(w)) {
      UF_PrintM("error: '%s' not yet realized -- can not plot\n",
		XtName(setup->shell));
    }
    else if (GowPlot(w, VpthPath(&vPth), type, x_px, y_px, fontscale)) {
      UF_PrintM("%s plot of %s written to %s\n",
		type, XtName(setup->shell), PthShort(VpthPath(&vPth)));
      return IDX_EDONE;
    }
    else {
      ErrPrint("error: can not write %s plot of '%s' to '%s'\n",
	       type, XtName(setup->shell), PthShort(VpthPath(&vPth)));
    }
  }
  return IDX_EERROR;
}
/* ---------------------------------------------------------------------- */
static int PlotFinish(num) int num; { return num; }
/* ---------------------------------------------------------------------- */
