/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdResid.c,v 1.2 1994/05/26 19:51:31 vs Exp vs $ */

#define _VdResid_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <Gow/GowWidget.h>
#include <Gow/GowResid.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsNorm.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdResid.h"
#include "VdResidP.h"
/* ---------------------------------------------------------------------- */
/* ================================= */
/* initialize display resid module */
/* ================================= */

GowResid DR_Init(parent, ap)
     Widget parent;
     Vact_t ap;
{
  GowResid d;

  if ((d= (GowResid)Malloc(sizeof(GowResidRec)))) {
    Widget goo;

    if ((goo= XtVaCreateManagedWidget("residuum", gowResiduumObjectClass,
				     parent, NULL))) {
      DrawResidType(&d->res)= DrawResidAbs;
      DrawResidFct(&d->res)= FitFunction;
      DrawResidFctSetup(&d->res)= FitFunctionSetup;
      DrawResidFctFinish(&d->res)= FitFunctionFinish;
      d->gow= parent;
      d->goo= goo;
      GowInsertSubobject(goo, (GowAppDrawdata)d, GowHideSubobj);

      XtAddCallback(goo, XtNdestroyCallback, DW_FreeCallback, d);
      DR_ChangeActSpc(d, ap);
      GowInsertSubobject(goo, (GowAppDrawdata)d, GowDrawSubobj);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw residuum-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
static int DrawNormalized(dres, normalized)
     GowResid dres;
     int normalized;
{
  if (dres) {
    Widget parent= dres->gow;
    Arg arg;
    XtSetArg(arg, XtNnormalized, (int)normalized);
    GowDelayWidgetOutput(parent, TRUE);
    XtSetValues(dres->goo, &arg, 1);
    GowDelayWidgetOutput(parent, FALSE); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DR_ChangeActSpc(d, ap)
     GowResid d;
     Vact_t ap;
{
  if (d) {
    int a= VactSpcIdx(ap);
    DrawResidGCIdx(&d->res)= a;
    DrawResidFit(&d->res)= VfitsFFit(&vFit,a);
    DrawResidSpc(&d->res)= VspcsSpc(&vSpc,a);
    DrawResidCal(&d->res)= VcalsCal(&vCal,a);
    DrawResidNorm(&d->res)= &VnrmsFac(&vNrm,a);

    DR_Changed(d, ap, a);
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
int DR_DrawUnnormalized(setup)
     VdSetup setup;
{
  if (setup->dres) {
    DrawNormalized(setup->dres, FALSE); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DR_DrawNormalized(setup)
     VdSetup setup;
{
  if (setup->dres) {
    DrawNormalized(setup->dres, TRUE); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
void DR_Changed(d, ap, idx)
     GowResid d;
     int idx;
     Vact_t ap;
{
  if (d && idx == VactSpcIdx(ap) && VactManaged(ap,idx)) {
    GowRedisplayObjectWidget(d->goo); }
}
/* ---------------------------------------------------------------------- */
