/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdScale.c,v 1.2 1994/05/26 19:51:33 vs Exp vs $ */

#define _VdScale_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <Gow/GowDest.h>
#include <Gow/GowScale.h>
#include <Gow/GowVsWidget.h>
#include <Gow/GowObject.h>

#include "VsActiv.h"
#include "VsCal.h"
#include "VsMark.h"
#include "VsUserFace.h"

#include "VdWidget.h"
#include "VdLabel.h"
#include "VdNotify.h"
#include "VdStatus.h"

#include "VdScale.h"
#include "VdScaleP.h"
/* ---------------------------------------------------------------------- */
static GowScale GetScale(w, name)
     Widget w;
     char *name;
{
  GowScale scale= NULL;
  Arg args[1];
  XtSetArg(args[0], name, &scale);
  XtGetValues(w, args, XtNumber(args));
  return scale;
}
/* ---------------------------------------------------------------------- */
int DSc_Expand()
{
  VdSetup setup;

  if ((setup= DW_GetSetup())) {
    Widget w= setup->gow;
    GowScale x_scale;
    GowScale y_scale;
    Vmrk_t *v= VmrksVertical(&vMrk);
    PVec_t vp= VmrkMrk(v);
    PVec_t hp= VmrkMrk(VmrksHorizontal(&vMrk));

    x_scale= GetScale(w, XtNxScale);
    y_scale= GetScale(w, XtNyScale);
  
    if (VecNum(vp)) {
      double (*fct)();
      Cal_t cal= VcalsCal(&vCal,VactSpcIdx(setup->act));

      if (VmrkCalibrated(v) == VactCalibrated(VactScale(setup->act))) {
	fct= CalId; }
      else { fct= VmrkCalibrated(v) ? CalC : CalP; }

      GowNewScaleValue(x_scale, fct(cal, PVecX1(vp,0)), GowFifoValue);
      GowNewScaleValue(x_scale, fct(cal, PVecX2(vp,0)), GowFifoValue); }

    if (VecNum(hp)) {
      GowNewScaleValue(y_scale, PVecX1(hp,0), GowFifoValue);
      GowNewScaleValue(y_scale, PVecX2(hp,0), GowFifoValue); }

    Mrk_Reset(VmrksVertical(&vMrk));
    Mrk_Reset(VmrksHorizontal(&vMrk));

    DN_Delay(TRUE);
    GowExpandScalesOfWidget(w, TRUE, TRUE);
    DN_Delay(FALSE);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_Center()
{
  double x, y;
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    Widget w= setup->gow;
    Cal_t cal= VcalsCal(&vCal,VactSpcIdx(setup->act));
    
    if (Mrk_EnterSingleV(VactScale(setup->act), cal, &x, "x-center") &&
	Mrk_EnterSingleH(VactScale(setup->act), &y, "y-center")) {
      GowWidgetCenter(w, x, y, TRUE, TRUE);
      return TRUE;
    }
  }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_CenterX()
{
  double x;
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    Widget w= setup->gow;
    Cal_t cal= VcalsCal(&vCal,VactSpcIdx(setup->act));

    if (Mrk_EnterSingleV(VactScale(setup->act), cal, &x, "x-center")) {
      GowWidgetCenter(w, x, 0.0, TRUE, FALSE);
      return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_CenterY()
{
  double y;
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    Widget w= setup->gow;

    if (Mrk_EnterSingleH(VactScale(setup->act), &y, "y-center")) {
      GowWidgetCenter(w, 0.0, y, FALSE, TRUE);
      return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_Shift()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    double x_perc, y_perc, precision;
    Widget w= setup->gow;
    
    if (!UF_RealRead(FALSE, &x_perc, &precision, "%s", "x-percent") ||
	!UF_RealRead(FALSE, &y_perc, &precision, "%s", "y_percent")) {
      UF_Reset(); return FALSE; }

    GowWidgetShift(w, x_perc, y_perc);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_Stretch()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    double x_fac, y_fac, precision;
    double x, y;
    Widget w= setup->gow;
    Cal_t cal= VcalsCal(&vCal,VactSpcIdx(setup->act));
    
    if (!UF_RealRead(FALSE, &x_fac, &precision, "%s", "-log2(x-factor)") ||
	(x_fac != 0.0 && 
	 !Mrk_EnterSingleV(VactScale(setup->act), cal, &x, "x-center")) ||
	!UF_RealRead(FALSE, &y_fac, &precision, "%s", "-log2(y-factor)") ||
	(y_fac != 0.0 && 
	 !Mrk_EnterSingleH(VactScale(setup->act), &y, "y-center"))) {
      UF_Reset(); return FALSE; }
    GowWidgetStretch(w, x_fac, x, y_fac, y);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_Position()
{
  double width, precision;
  double value;
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    Widget w= setup->gow;
    Cal_t cal= VcalsCal(&vCal,VactSpcIdx(setup->act));

    if (!UF_RealRead(FALSE, &width, &precision, "%s", "maximal width") ||
	width == 0.0) {
      UF_Reset(); return FALSE; }
    width= ABS(width);
    if (Mrk_EnterSingleV(VactScale(setup->act), cal, &value, "position")) {
      GowScale x_scale;
      double user_min, user_max;
      double new_min= value - width * 0.5;
      double new_max= value + width * 0.5;

      x_scale= GetScale(w, XtNxScale);
      GowGetScaleUserRange(x_scale, &user_min, &user_max);
      if (user_max - user_min > new_max - new_min ||
	  value < user_min || user_max < value) {
	GowNewScaleValue(x_scale, new_min, GowFifoValue);
	GowNewScaleValue(x_scale, new_max, GowFifoValue);
	DN_Delay(TRUE);
	GowExpandScalesOfWidget(w, TRUE, TRUE);
	DN_Delay(FALSE); }

      return DL_PosInsert(setup, value); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_Redisplay()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    Widget w= setup->gow;
    GowScale x_scale;
    GowScale y_scale;

    x_scale= GetScale(w, XtNxScale);
    y_scale= GetScale(w, XtNyScale);
    DN_Delay(TRUE);
    Mrk_Reset(VmrksVertical(&vMrk));
    Mrk_Reset(VmrksHorizontal(&vMrk));
    DL_PosDelete(setup);
    GowResetNewScale(x_scale);
    GowResetNewScale(y_scale);
    GowRedisplayWidget(w);
    DN_Delay(FALSE); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int ScaleModification(modification)
     int modification;
{
  Widget w;
  if ((w= DW_GetWidget())) {
    Arg args[1];
    XtSetArg(args[0], XtNyScaleModification, modification);
    XtSetValues(w, args, XtNumber(args));
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
int DSc_ModificationNone()
{
  return ScaleModification(GowMnone);
}
/* ---------------------------------------------------------------------- */
int DSc_ModificationEfficiency()
{
  return ScaleModification(GowMefficiency);
}
/* ---------------------------------------------------------------------- */
int DSc_ModificationMultiplied()
{
  return ScaleModification(GowMmultiplied);
}
/* ---------------------------------------------------------------------- */
static int ScaleType(type)
     int type;
{
  Widget w;
  if ((w= DW_GetWidget())) {
    GowScale y_scale= GetScale(w, XtNyScale);
    if (y_scale) { GowNewScaleType(y_scale, type); return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_Linear()
{
  return ScaleType(GowLinearScale);
}
/* ---------------------------------------------------------------------- */
int DSc_Logarithmic()
{
  return ScaleType(GowLogarithmicScale);
}
/* ---------------------------------------------------------------------- */
int DSc_Squared()
{
  return ScaleType(GowSquaredScale);
}
/* ---------------------------------------------------------------------- */
static int FullScale(x_full, y_full)
     int x_full, y_full;
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    GowWidgetFull(setup->gow, x_full, y_full);
    DSt_UpdateStatus(setup);
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_Full()
{
  return FullScale(TRUE, TRUE);
}
/* ---------------------------------------------------------------------- */
int DSc_FullX()
{
  return FullScale(TRUE, FALSE);
}
/* ---------------------------------------------------------------------- */
int DSc_FullY()
{
  return FullScale(FALSE, TRUE);
}
/* ---------------------------------------------------------------------- */
static int ResetScale(xr, yr)
     int xr, yr;
{
  Widget w;
  if ((w= DW_GetWidget())) {
    GowWidgetResetScales(w, xr, yr); return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DSc_Reset()
{
  return ResetScale(TRUE, TRUE);
}
/* ---------------------------------------------------------------------- */
int DSc_ResetX()
{
  return ResetScale(TRUE, FALSE);
}
/* ---------------------------------------------------------------------- */
int DSc_ResetY()
{
  return ResetScale(FALSE, TRUE);
}
/* ---------------------------------------------------------------------- */
