/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdSpectra.c,v 1.4 1994/12/02 21:23:57 vs Exp vs $ */

#define _VdSpectra_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsPath.h>
#include <Gow/GowWidget.h>
#include <Gow/GowSpectrum.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsNorm.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdWidget.h"

#include "VdSpectra.h"
#include "VdSpectraP.h"
/* ---------------------------------------------------------------------- */
/* ================================= */
/* initialize display spectra module */
/* ================================= */

GowSpc DS_Init(parent, num)
     Widget parent;
     int num;
{
  GowSpc d;

  if ((d= (GowSpc)Malloc(num * sizeof(GowSpcRec)))) {
    Widget goo;

    if ((goo= XtVaCreateManagedWidget("spectrum", gowSpectrumObjectClass,
				     parent, NULL))) {
      int i;

      for (i= num-1; i >= 0; i--) {
	DrawSpcGCIdx(&d[i].spc)= i;
	DrawSpcSpc(&d[i].spc)= VspcsSpc(&vSpc,i);
	DrawSpcCal(&d[i].spc)= VcalsCal(&vCal,i);
	DrawSpcNorm(&d[i].spc)= &VnrmsFac(&vNrm,i);
	DrawSpcName(&d[i].spc)= NULL;
	d[i].gow= parent;
	d[i].goo= goo;
	GowInsertSubobject(goo,
			   (GowAppDrawdata)(d + i), GowHideSubobj); }
      XtAddCallback(goo, XtNdestroyCallback, DW_FreeCallback, d);
      return d; }
    else { Free(d); } }

  ErrPrintR("fatal: can not initialize draw spectra-module\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
static void SetLine(d, ap)
     GowSpc d;
     Vact_t ap;
{
  if (VactNames(ap)) {
    int i, line= 1;
    for (i= 0; i< VactNum(ap); i++) {
      if (VactManaged(ap,i) && SpcNum(VspcsSpc(&vSpc,i))) {
	Free(DrawSpcName(&d[i].spc));
	DrawSpcName(&d[i].spc)
	  = (char *)Strdup(PthTail(SpcFile(VspcsSpc(&vSpc,i))));
	DrawSpcLine(&d[i].spc)= line; line++; } } }
  else {
    int i; for (i= 0; i< VactNum(ap); i++) { DrawSpcLine(&d[i].spc)= 0; } }
}
/* ---------------------------------------------------------------------- */
static int CompressMode(dspc, num, compress)
     GowSpc dspc;
     int num;
     DrawCompressMode compress;
{
  if (num && dspc) {
    Widget parent= dspc->gow;
    int i;
    Arg arg;
    XtSetArg(arg, XtNcompressMode, compress);
    GowDelayWidgetOutput(parent, TRUE);
    for (i= 0; i< num; i++, dspc++) { XtSetValues(dspc->goo, &arg, 1); }
    GowDelayWidgetOutput(parent, FALSE); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DS_ChangeManaged(d, ap)
     GowSpc d;
     Vact_t ap;
{
  if (d) {
    int i;

    SetLine(d, ap);
    for (i= 0; i< VactNum(ap); i++, d++) {
      GowChangeSubobjectStat(d->goo, (GowAppDrawdata)d,
			     (unsigned int)(VactManaged(ap,i) ?
					    GowDrawSubobj :
					    GowHideSubobj)); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
void DS_ManageNamesSetup(setup)
     VdSetup setup;
{
  if (!VactNames(setup->act)) {
    VactNames(setup->act)= TRUE;
    if (setup->dspc) { SetLine(setup->dspc, setup->act); }
    GowRedisplayWidget(setup->gow); }
}
/* ---------------------------------------------------------------------- */
void DS_UnmanageNamesSetup(setup)
     VdSetup setup;
{
  if (VactNames(setup->act)) {
    VactNames(setup->act)= FALSE;
    if (setup->dspc) { SetLine(setup->dspc, setup->act); }
    GowRedisplayWidget(setup->gow); }
}
/* ---------------------------------------------------------------------- */
int DS_ManageNames()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { DS_ManageNamesSetup(setup); return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DS_UnmanageNames()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) { DS_UnmanageNamesSetup(setup); return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DS_DrawEach()
{
  VdSetup setup;

  ForAllSetups(setup) {
    if (setup->dspc) {
      CompressMode(setup->dspc, setup->num, DrawEach); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DS_DrawFirstFound()
{
  VdSetup setup;

  ForAllSetups(setup) {
    if (setup->dspc) {
      CompressMode(setup->dspc, setup->num, DrawFirstFound); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DS_DrawMinMax()
{
  VdSetup setup;

  ForAllSetups(setup) {
    if (setup->dspc) {
      CompressMode(setup->dspc, setup->num, DrawMinMax); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
void DS_Changed(d, ap, idx)
     GowSpc d;
     int idx;
     Vact_t ap;
{
  if (d && idx < VactNum(ap) && VactManaged(ap,idx)) {
    Widget o= d[idx].goo;
    Widget w= d[idx].gow;
    GowSubobjStat status;
    Boolean visible;

    SetLine(d, ap);

    if (VactExpandAutomatic(VactExpand(ap))) {
      GowScale y_scale= NULL;
      Arg args[1];
      XtSetArg(args[0], XtNyScale, &y_scale);
      XtGetValues(w, args, XtNumber(args));
      if (y_scale) {
	GowNewScaleValue(y_scale, 0.0, GowFullScale);
	GowExpandScalesOfWidgetOnUpdate(w, FALSE, TRUE); } }

    if (GowGetSubobjectStat(o, (GowAppDrawdata)(d+idx), &status, &visible) &&
	visible) {
      GowRedisplayWidget(w); }
    else { 
      GowChangeSubobjectStat(o, (GowAppDrawdata)(d+idx), GowDrawSubobj); } }
}
/* ---------------------------------------------------------------------- */
