/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdStatus.c,v 1.2 1994/09/20 14:48:58 vs Exp vs $ */

#include <Gow/GowConfig.h>

#ifdef HAS_XT_GRAPHIC

#include <math.h>
#include <stdio.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include <X11/Xaw/XawInit.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Paned.h>

#include <X11/Xmu/Initer.h>
#include <X11/Xmu/CharSet.h>

#include <Gow/GowScaleP.h>
#include <Gow/GowWidgetP.h>
#include <Gow/GowObjectP.h>
#include <tv/vsAlloc.h>

#include "VsActiv.h"
#include "VsCal.h"
#include "VsCut.h"

#include "VdWidget.h"
#include "VdStatus.h"

#define MAXLABELLEN		512

#ifndef ABS
# define ABS(a)              (((a) < (0)) ? -(a) : (a))
#endif				/* ABS */
/* ---------------------------------------------------------------------- */
static VdSetup locked= NULL;
/* ---------------------------------------------------------------------- */
static void PositionHandler(), PrintCoord(), SetLabel();
static void UpdateStatus();
static GowScaleConversion GetCoord();
/* ---------------------------------------------------------------------- */
/*      Function Name: CursorPosition
 *      Description: event handler to print cursor position.
 *      Arguments: w - the gow widget.
 *      Returns: none.
 */

/* ARGSUSED */
static void PositionHandler(w, p_setup, event, unused)
     Widget w;
     XtPointer p_setup;
     XEvent *event;
     Boolean *unused;
{
  VdSetup setup= (VdSetup)p_setup;
  VdStatus st= setup->status;
  Widget pw= (Widget)st->position;
  GowWidget gow= (GowWidget)setup->gow;
  GowScale x_scale= gow->gow_widget.x_scale;
  GowScale y_scale= gow->gow_widget.y_scale;
  GowDestination d= gow->destination_widget.destination;
  char label[MAXLABELLEN];
  String l= label;

  switch (event->type) {
  case MotionNotify:
  case EnterNotify:
  case FocusIn:
    *l= '\0';
    if (GowNewScaleFull(x_scale)) { *l++ = 'x'; }
    if (GowNewScaleFull(y_scale)) { *l++ = 'y'; }
    *l= '\0';
    if (*label) {
      SetLabel(st->full, label);
      XtManageChild(st->full); }
    else { XtUnmanageChild(st->full); }

    l= label; *l= '\0';

    if (gow->gow_widget.cursor_show) {
      GowScaleConversion conv_x, conv_y;
      double x, dx, y, dy;
      Vact_t ap= setup->act;
      Cal_t cal= VcalsCal(&vCal, VactSpcIdx(ap));

      conv_x= GetCoord(&x, &dx, event->xmotion.x,
		       x_scale, GowDXDirection(d),
		       GowDXOffset(d), GowDXRange(d),
		       (double)gow->gow_widget.x_clip_min,
		       (double)gow->gow_widget.x_clip_max);
      conv_y= GetCoord(&y, &dy, event->xmotion.y,
		       y_scale, GowDYDirection(d),
		       GowDYOffset(d), GowDYRange(d),
		       (double)gow->gow_widget.y_clip_min,
		       (double)gow->gow_widget.y_clip_max);
      PrintCoord(l, x, dx, conv_x);
      l += strlen(l);
      if (CalExists(CAL_POS, cal)) {
	double (*fct)()= VactCalibrated(VactScale(ap)) ? CalC : CalP;
	strcat(l, " ("); l += 2;
	PrintCoord(l, fct(cal, x), fct(cal, dx), conv_x);
	l += strlen(l);
	strcat(l, ") "); l += 2; }
      else { strcat(l, " "); l += 1; }
      PrintCoord(l, y, dy, conv_y); }
    break;
  default:
    strcpy(l, "??? ???");
    break; }

  SetLabel(pw, label);
  return;
}
/* ---------------------------------------------------------------------- */
void DSt_Focus(setup)
     VdSetup setup;
{
  if (locked != setup) {
    locked= setup;
    ForAllSetups(setup) { DSt_UpdateStatus(setup); } }
}
/* ---------------------------------------------------------------------- */
void DSt_ManageStatus(setup)
     VdSetup setup;
{
  if (setup) { UpdateStatus(setup); }
}
/* ---------------------------------------------------------------------- */
void DSt_UnmanageStatus(setup)
     VdSetup setup;
{
  if (setup) {
    VdStatus st= setup->status;
    Widget wu[3];
    wu[0]= st->focus;
    wu[1]= st->full;
    wu[2]= st->activ;
    XtUnmanageChildren(wu, 3); }
}
/* ---------------------------------------------------------------------- */
void DSt_UpdateStatus(setup)
     VdSetup setup;
{
  VdStatus st= setup->status;
  if (XtIsManaged(st->focus)) { UpdateStatus(setup); }
}
/* ---------------------------------------------------------------------- */
static void UpdateStatus(setup)
     VdSetup setup;
{
  VdStatus st= setup->status;
  GowWidget gow= (GowWidget)setup->gow;
  GowScale x_scale= gow->gow_widget.x_scale;
  GowScale y_scale= gow->gow_widget.y_scale;
  char label[MAXLABELLEN];
  String l= label;

  *l= '\0';
  if (GowNewScaleFull(x_scale)) { *l++ = 'x'; }
  if (GowNewScaleFull(y_scale)) { *l++ = 'y'; }
  *l= '\0';
  if (*label) {
    SetLabel(st->full, label);
    XtManageChild(st->full); }
  else { XtUnmanageChild(st->full); }

  if (locked) {
    sprintf(label, "%s->%s", setup->gow_name, locked->gow_name); }
  else { strcpy(label, setup->gow_name); }
  SetLabel(st->focus, label);

  { Vact_t ap= setup->act;
    int cutIdx= VactCutIdx(ap);
    Vcut_t *vcp= VcutsC(&vCut)+cutIdx;
    sprintf(label, "s%d c%d(%d) d%d m%d(%d)", VactSpcIdx(ap),
	    cutIdx, VcutSpcIdx(vcp),
	    VcutCutPathIdx(vcp),
	    VcutMtxIdx(vcp), VmtxProIdx(VcutsM(&vCut) + VcutMtxIdx(vcp)));
    SetLabel(st->activ, label); }
  { Widget w[2];
    w[0]= st->focus;
    w[1]= st->activ;
    XtManageChildren(w, 2); }
}
/* ---------------------------------------------------------------------- */
static void SetLabel(w, label)
     Widget w;
     char *label;
{
  Arg args[2];
  char *old_label;
  XtSetArg(args[0], XtNlabel, &old_label); 
  XtGetValues(w, args, 1);
  if (strcmp(old_label, label)) {
      
    XtSetArg(args[0], XtNlabel, label); 
    XtSetArg(args[1], XtNresize,
	     (strlen(label) > strlen(old_label) ||
	      strlen(label) + 1 < strlen(old_label))); 
    XtSetValues(w, args, XtNumber(args)); }
}
/* ---------------------------------------------------------------------- */
static GowScaleConversion GetCoord(c, dc, event_coord, scale, direction,
				   offset, range, clip_min, clip_max)
     double *c, *dc;
     int event_coord;
     GowScale scale;
     GowScaleDirection direction;
     int offset, range;
     double clip_min, clip_max;
{
  GowUserFunc user;
  GowScaleConversion conv;

  if (scale &&
      GowInitializeScale(scale, direction,
			 offset, range, clip_min, clip_max) &&
      (user= scale->user) &&
      (conv= user(scale, event_coord, c)) != GowToSmall &&
      conv != GowToLarge) {
    if (((conv= user(scale, event_coord+1, dc)) != GowToSmall &&
	 conv != GowToLarge) ||
	((conv= user(scale, event_coord-1, dc)) != GowToSmall &&
	 conv != GowToLarge)) {
      return GowValid; }
    else { *dc= *c; return GowValid; } }
  return GowToSmall;
}
/* ---------------------------------------------------------------------- */
static void PrintCoord(l, c, dc, conv)
     char *l;
     double c, dc;
     int conv;
{
  if (conv == GowValid) {
    dc -= c;
    dc= ABS(dc);

    if (dc >= 1) { sprintf(l, "%.0f", c); return; }
    else {
      char format[64];
      if (dc == 0.0 || (dc= ceil(-log10(dc))) > 12.0) {
	strcpy(format, "%g"); }
      else { sprintf(format, "%%.%df", NINT(dc)); }
      sprintf(l, format, c);
      return; } }
  strcpy(l, "???");
}
/* ---------------------------------------------------------------------- */
VdStatus DSt_CreatePaned(shell, panedName)
     Widget shell;
     char *panedName;
{
  VdStatus st;
  if ((st= (VdStatus)Calloc(1, sizeof(VdStatusRec)))) {
    Widget status;
    st->shell= shell;
    if ((st->parent= XtVaCreateManagedWidget(panedName, panedWidgetClass,
					     shell,
					     XtNorientation, XtorientVertical,
					     XtNrefigureMode, FALSE,
					     NULL)) &&
	(status= XtVaCreateManagedWidget("paned-status", boxWidgetClass,
					 st->parent, NULL)) &&
	(st->focus= XtVaCreateWidget("focus", labelWidgetClass, status,
				     XtNjustify, XtJustifyCenter,
				     NULL)) &&
	(st->activ= XtVaCreateWidget("activ", labelWidgetClass, status,
				     XtNjustify, XtJustifyCenter,
				     NULL)) &&
	(st->full= XtVaCreateWidget("full", labelWidgetClass, status,
				    XtNjustify, XtJustifyCenter,
				    NULL)) &&
	(st->position= XtVaCreateManagedWidget("position", labelWidgetClass,
					       status,
					       XtNjustify, XtJustifyCenter,
					       NULL))) {
     XtAddCallback(st->parent, XtNdestroyCallback, DW_FreeCallback, st);
     return st; }
    else if (st->parent) { XtDestroyWidget(st->parent); }
    Free(st); }
  return NULL;
}
/* ---------------------------------------------------------------------- */
void DSt_AddChild(setup)
     VdSetup setup;
{
  if (XtIsSubclass(setup->gow, gowWidgetClass)) {
    XtAddEventHandler(setup->gow,
		      (unsigned int)(PointerMotionMask |
				     EnterWindowMask |
				     LeaveWindowMask),
		      FALSE, PositionHandler, (caddr_t)setup); }
  return;
}
/* ---------------------------------------------------------------------- */
void DSt_DeleteChild(setup)
     VdSetup setup;
{
  XtRemoveEventHandler(setup->gow,
		       (unsigned int)(PointerMotionMask |
				      EnterWindowMask |
				      LeaveWindowMask),
		       FALSE, PositionHandler, (caddr_t)setup);
}
/* ---------------------------------------------------------------------- */
#endif				/* HAS_XT_GRAPHIC */
