/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdWidget.c,v 1.3 1994/09/20 14:48:59 vs Exp vs $ */

#define _VdWidget_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Paned.h>

#include <tv/vsAlloc.h>
#include <tv/vsSpectra.h>
#include <tv/vsXuserFace.h>
#include <Gow/GowDest.h>
#include <Gow/GowGCs.h>
#include <Gow/GowScale.h>
#include <Gow/GowFramWidget.h>
#include <Gow/GowVsWidget.h>
#include <Gow/GowCutWidget.h>
#include <Gow/GowObject.h>

#include "VsUserFace.h"
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsMark.h"

#include "VdWidget.h"

#include "VdAxis.h"
#include "VdBin.h"
#include "VdCut.h"
#include "VdCutLabel.h"
#include "VdDecomp.h"
#include "VdFit.h"
#include "VdFitLabel.h"
#include "VdLabel.h"
#include "VdMark.h"
#include "VdNotify.h"
#include "VdPeakLabel.h"
#include "VdPeakList.h"
#include "VdResid.h"
#include "VdScale.h"
#include "VdSpectra.h"
#include "VdSpecList.h"
#include "VdStatus.h"
/* ---------------------------------------------------------------------- */
#include "VdWidgetP.h"
/* ---------------------------------------------------------------------- */
static XtAppContext app= NULL;
static io_input_focus= TRUE;
static String panedName="paned";
static VdSetup current= NULL;
static VdSetup locked= NULL;
static Cursor io_cursor;
				/* widget hierarchy */
static Widget appShell;
			/* spectralist */
			/* root-gow */
static Widget		rootPaned;
static Widget 		io;
static Widget 		mouse= NULL;
/* ---------------------------------------------------------------------- */
int DW_Init(num, argc, argv)
     int num;
     int *argc;
     char **argv;
{
  GowScale x_scale;
  GowScale y_scale;
  VdStatus status;
  static XtActionsRec actions[]= {
    { "edit-lock", EditFocusLockAction },
    { "edit-unlock", EditFocusUnlockAction },
    { "lock-widget", LockWidgetAction },
    { "unlock-widget", UnlockWidgetAction },
  };

  typedef struct {
    int num_gcs;
  } AppDataRec, *AppData;

  AppDataRec app_data;

#define Offset(field) XtOffsetOf(AppDataRec,field)

  static XtResource resources[] = {
    { XtNnumGCs, XtCNumGCs, XtRInt, sizeof (int),
	Offset(num_gcs), XtRImmediate, (XtPointer) 1}
  };

  resources[0].default_addr= (XtPointer)MAX(num, MRK_NUM);

  x_scale= GowCreateScale();
  y_scale= GowCreateScale();

#ifndef TVB
#ifdef HAS_XAW3D
  appShell= XtOpenApplication(&app, "Xtv", NULL, 0,
			      argc, argv, NULL,
			      sessionShellWidgetClass, NULL, 0);
#else
  appShell= XtVaAppInitialize(&app, "Xtv", NULL, 0,
			      argc, argv, NULL,
			      NULL);
#endif
#else
#ifdef HAS_XAW3D
  appShell= XtOpenApplication(&app, "Xtvb", NULL, 0,
			      argc, argv, NULL,
			      sessionShellWidgetClass, NULL, 0);
#else
  appShell= XtVaAppInitialize(&app, "Xtvb", NULL, 0,
			      argc, argv, NULL,
			      NULL);
#endif
#endif

#if defined(HAS_CONNECTIONOS)

  {
    extern int tvConnectionInit(void);
    extern void XgetTvConnectionInput__FPvPiPUl(XtPointer client_data, int* fd, XtInputId* inputID);
     /* Fkt.Namen-Anhaengsel wg. versch. Kommunikation zw. cc und c-Compiler */
    int sockfd = tvConnectionInit(); /* init socket and get the fd */

    XtInputId inputId;
    if (sockfd > 0){
      /* register new input source and callback  */
      inputId = XtAppAddInput (app,
			 sockfd, /* listen to the socket's fd ... */
			 (XtPointer)XtInputReadMask, /* if there is something to READ ... */
			 XgetTvConnectionInput__FPvPiPUl, /* and call getTvConnectionInput if so. */
			 (XtPointer)(appShell));}

  }
#endif

  XtGetApplicationResources(appShell,
			    &app_data, resources, XtNumber(resources),
			    NULL, 0);

  GowInitializeGCs(app_data.num_gcs);

  XtAppAddActions(app, actions, XtNumber(actions));

  { Screen *scr= XtScreenOfObject(appShell);
    if (XDefaultDepthOfScreen(scr) == 1) { /* static gray */
      panedName= "monochrome"; }
    else if (XDefaultVisualOfScreen(scr)->class < 2) {
      panedName= "gray"; }
    else {
      panedName= "colored"; } }

  rootPaned= XtVaCreateManagedWidget(panedName, panedWidgetClass,
				     appShell,
				     XtNorientation, XtorientVertical,
				     XtNrefigureMode, FALSE,
				     XtNallowShellResize, FALSE,
				     NULL);

  if (!(status= DSt_CreatePaned(appShell, panedName))) {
    XtDestroyWidget(appShell); return FALSE; }

  DSL_Create(rootPaned, num);
		
  io= XUFCreateWidget("io", rootPaned, 16384, 1024, 2048);
  
  XawPanedSetRefigureMode(rootPaned, TRUE);

  XtRealizeWidget(appShell);

  { char title[IOBUFLEN];
    sprintf (title, "%s-root", XtName(appShell));
    CreateSimpleShell(title);
    Act_ManageAll(vdSetupRoot->act); }

  if (io_input_focus) { DW_InputModeEdit(); }

  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DW_CreateSimpleShell()
{
  char name[IOBUFLEN];

  if (UF_ItemRead(name, IOBUFLEN, "simple shell name") && *name) {
    return CreateSimpleShell(name); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int CreateSimpleShell(name)
     char *name;
{
  Widget shell;
#ifndef HAS_XAW3D
  if ((shell= XtVaCreateWidget(name,
			       topLevelShellWidgetClass,
			       appShell, NULL))) {
#else
  if ((shell= XtCreatePopupShell(name,
			       topLevelShellWidgetClass,
			       appShell, NULL, 0))) {
#endif
    VdStatus status;

    if ((status= DSt_CreatePaned(shell, panedName))) {
      GowScale x_scale;
      GowScale y_scale;
      VdSetup vds;

      x_scale= GowCreateScale();
      y_scale= GowCreateScale();
      XtAddCallback(shell, XtNdestroyCallback,
		    DestroyScaleCallback, x_scale);
      XtAddCallback(shell, XtNdestroyCallback,
		    DestroyScaleCallback, y_scale);

      if ((vds= CreateGowSetup(status, shell, name, name, x_scale, y_scale,
			       '\0', NULL))) {
	InitSpectraGow(vds);
	XawPanedSetRefigureMode(status->parent, TRUE);
#ifdef HAS_XAW3D
	XtPopup(shell, XtGrabNone);
#else
	XtRealizeWidget(shell);
#endif
	Act_ManageAll(vds->act);
	XtManageChild(shell);
	if (io_input_focus) { DW_InputModeEdit(); }
	return TRUE; } }
    XtDestroyWidget(shell); }
  ErrPrintR("error: can not create simple shell '%s'\n", name);
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DW_CreateFitShell()
{
  char name[IOBUFLEN];

  if (UF_ItemRead(name, IOBUFLEN, "fit shell name") && *name) {
    Widget shell;

#ifndef HAS_XAW3D
    if ((shell= XtVaCreateWidget(name,
				topLevelShellWidgetClass,
				appShell, NULL))) {
#else
    if ((shell= XtCreatePopupShell(name,
				topLevelShellWidgetClass,
				appShell, NULL, 0))) {
#endif
      VdStatus status;

      if ((status= DSt_CreatePaned(shell, panedName))) {
	GowScale x_scale;
	GowScale y_scale;
	GowScale yr_scale;
	VdSetup vds, vdsr;
	Vact_t act;

	x_scale= GowCreateScale();
	y_scale= GowCreateScale();
	yr_scale= GowCreateScale();
	XtAddCallback(shell, XtNdestroyCallback,
		      DestroyScaleCallback, x_scale);
	XtAddCallback(shell, XtNdestroyCallback,
		      DestroyScaleCallback, y_scale);
	XtAddCallback(shell, XtNdestroyCallback,
		      DestroyScaleCallback, yr_scale);

	if ((act= Act_Create())) {
	  XtAddCallback(shell, XtNdestroyCallback,
			DestroyActCallback, act);

	  { char title[IOBUFLEN];
	    char rtitle[IOBUFLEN];

	    sprintf(title, "%s-fit", name);
	    sprintf(rtitle, "%s-residuum", name);

	    if ((vds= CreateGowSetup(status, shell, "fit", title,
				     x_scale, y_scale, 'y', act)) &&
		(vdsr= CreateGowSetup(status, shell, "residuum", rtitle,
				      x_scale, yr_scale, 'y', act))) {
	      Arg args_top[1], args_bottom[1];
	      XtSetArg(args_top[0], XtNtopFrame, 0);
	      XtSetArg(args_bottom[0], XtNbottomFrame, 0);
	      XtSetValues(vds->frm, args_bottom, XtNumber(args_bottom));
	      XtSetValues(vdsr->frm, args_top, XtNumber(args_top));
	      InitSpectraGow(vds);
	      InitResidGow(vdsr);
	      VactTitle(act)= vds->gow_name;
	      XawPanedSetRefigureMode(status->parent, TRUE);
	      XtRealizeWidget(shell);
	      Act_ManageOnly(act, VactSpcIdx(vActDefault));
	      DF_ManageSetup(vds);
	      DPL_ManageSetup(vds);
	      XtManageChild(shell);
	      if (io_input_focus) { DW_InputModeEdit(); }
	      return TRUE; } } } }
      XtDestroyWidget(shell); }
    ErrPrintR("error: can not create fit shell '%s'\n", name); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DW_CreateCutShell()
{
  char name[IOBUFLEN];

  if (UF_ItemRead(name, IOBUFLEN, "cut shell name") && *name) {
    Widget shell;

#ifndef HAS_XAW3D
    if ((shell= XtVaCreateWidget(name,
				topLevelShellWidgetClass,
				appShell, NULL))) {
#else
    if ((shell= XtCreatePopupShell(name,
				topLevelShellWidgetClass,
				appShell, NULL, 0))) {
#endif
      VdStatus status;

      if ((status= DSt_CreatePaned(shell, panedName))) {
	XawPanedSetRefigureMode(status->parent, TRUE);
	if ((status->parent= XtVaCreateManagedWidget("cut", gowCutWidgetClass,
						     status->parent, NULL))) {
	  GowScale x_scale;
	  GowScale y_scale;
	  GowScale xp_scale;
	  GowScale yp_scale;
	  VdSetup vds, vdsp;

	  x_scale= GowCreateScale();
	  y_scale= GowCreateScale();
	  xp_scale= GowCreateScale();
	  yp_scale= GowCreateScale();
	  XtAddCallback(shell, XtNdestroyCallback,
			DestroyScaleCallback, x_scale);
	  XtAddCallback(shell, XtNdestroyCallback,
			DestroyScaleCallback, y_scale);
	  XtAddCallback(shell, XtNdestroyCallback,
			DestroyScaleCallback, xp_scale);
	  XtAddCallback(shell, XtNdestroyCallback,
			DestroyScaleCallback, yp_scale);

	  { char title[IOBUFLEN];
	    char ptitle[IOBUFLEN];

	    sprintf(title, "%s-cut", name);
	    sprintf(ptitle, "%s-projection", name);

	    if ((vds= CreateGowSetup(status, shell, "cut", title,
				     x_scale, y_scale, '\0', NULL)) &&
		(vdsp= CreateGowSetup(status, shell, "projection", ptitle,
				      xp_scale, yp_scale, '\0', NULL))) {
	      InitSpectraGow(vds);
	      InitSpectraGow(vdsp);
	      InitCutGow(vds, vdsp);
	      XtRealizeWidget(shell);
	      DC_ManageCut(vds, VactCutIdx(vActDefault));
	      XtManageChild(shell);
	      DS_UnmanageNamesSetup(vds);
	      DS_UnmanageNamesSetup(vdsp);
	      if (io_input_focus) { DW_InputModeEdit(); }
	      return TRUE; } } } }
      XtDestroyWidget(shell); }
    ErrPrintR("error: can not create cut shell '%s'\n", name); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int CreatePaned(name, num, x_link, y_link)
     char *name;
     int num;
     int x_link;
     int y_link;
{
  Widget shell;

#ifndef HAS_XAW3D
  if ((shell= XtVaCreateWidget(name,
			      topLevelShellWidgetClass,
			      appShell, NULL))) {
#else
  if ((shell= XtCreatePopupShell(name,
			      topLevelShellWidgetClass,
			      appShell, NULL, 0))) {
#endif
    VdStatus status;

    if ((status= DSt_CreatePaned(shell, panedName))) {
      int i;
      GowScale x_scale;
      GowScale y_scale;
      Arg args_top[1], args_bottom[1];
      XtSetArg(args_top[0], XtNtopFrame, 0);
      XtSetArg(args_bottom[0], XtNbottomFrame, 0);

      if (x_link) {
	x_scale= GowCreateScale();
	XtAddCallback(shell, XtNdestroyCallback,
		      DestroyScaleCallback, x_scale); }
      if (y_link) {
	y_scale= GowCreateScale();
	XtAddCallback(shell, XtNdestroyCallback,
		      DestroyScaleCallback, y_scale); }

      for (i= 0; i< num; i++) {
	VdSetup vds;
	char pname[IOBUFLEN];
	char ptitle[IOBUFLEN];

	sprintf(pname, "pane-%d", i);
	sprintf(ptitle, "%s-%d", name, i);
	if (!x_link) {
	  x_scale= GowCreateScale();
	  XtAddCallback(shell, XtNdestroyCallback,
			DestroyScaleCallback, x_scale); }
	if (!y_link) {
	  y_scale= GowCreateScale();
	  XtAddCallback(shell, XtNdestroyCallback,
			DestroyScaleCallback, y_scale); }

	if ((vds= CreateGowSetup(status, shell, pname, ptitle,
				 x_scale, y_scale,
				 ((x_link && !y_link) ? 'y' : '\0'),
				 NULL))) {
	  InitSpectraGow(vds);
	  if (i > 0) {
	    XtSetValues(vds->frm, args_top, XtNumber(args_top)); }
	  if (i < num-1) {
	    XtSetValues(vds->frm, args_bottom, XtNumber(args_bottom)); } } }
      XawPanedSetRefigureMode(status->parent, TRUE);
      XtRealizeWidget(shell);
      { VdSetup setup;
	int m= 0;

	ForAllSetups(setup) {
	  if (setup->shell == shell) {
	    Act_SetActSpc(setup->act, m);
	    Act_SetActCut(setup->act, m);
	    m++; } } }
      XtManageChild(shell);
      if (io_input_focus) { DW_InputModeEdit(); }
      return TRUE; }
    XtDestroyWidget(shell); }
  ErrPrintR("error: can not create paned shell '%s'\n", name);
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DW_CreatePanedShell()
{
  int num;
  char name[IOBUFLEN];

  if (UF_ItemRead(name, IOBUFLEN, "paned-shell name") && *name &&
      UF_IntRead(FALSE, &num, "number of panes") && num > 0) {
    return CreatePaned(name, num, FALSE, FALSE); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DW_CreateXPanedShell()
{
  int num;
  char name[IOBUFLEN];

  if (UF_ItemRead(name, IOBUFLEN, "x-scale-linked paned-shell name") &&
      *name &&
      UF_IntRead(FALSE, &num, "number of panes") && num > 0) {
    return CreatePaned(name, num, TRUE, FALSE); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DW_CreateYPanedShell()
{
  int num;
  char name[IOBUFLEN];

  if (UF_ItemRead(name, IOBUFLEN, "xy-scale-linked paned-shell name") &&
      *name &&
      UF_IntRead(FALSE, &num, "number of panes") && num > 0) {
    return CreatePaned(name, num, TRUE, TRUE); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int DW_DestroyShell()
{
  char name[IOBUFLEN];

  if (UF_ItemRead(name, IOBUFLEN, "shell name") && *name) {
    VdSetup setup;

    if ((setup= DW_GetSetupOfShell(name))) { 
      if (setup == vdSetupRoot) {
	ErrPrint("error: can not destroy root shell '%s'\n", name);
	return FALSE; }
      else { XtDestroyWidget(setup->shell); return TRUE; } }
    ErrPrint("error: shell '%s' not found\n", name);
    return FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static VdSetup CreateGowSetup(status, shell, name, title,
			      x_scale, y_scale, inheritable_scale, a)
     VdStatus status;
     Widget shell;
     char *name;
     char *title;
     GowScale x_scale;
     GowScale y_scale;
     int inheritable_scale;
     Vact_t a;
{
  VdSetup new;

  if ((new= (VdSetup)Calloc(1, sizeof(VdSetupRec)))) {
				/* all pointers are NULL !!! */
    new->shell= shell;
    new->status= status;
    new->act= a ? a : Act_Create();
    if (new->act) {
      new->num= VactNum(new->act);
      DA_Init(new->axis, new->act);
      if ((new->frm =
	  XtVaCreateManagedWidget(name, gowFrameWidgetClass, status->parent,
				  XtNleftAxis, new->axis + DrawAxisLeft,
				  XtNrightAxis, new->axis + DrawAxisRight,
				  XtNbottomAxis, new->axis + DrawAxisBottom,
				  XtNtopAxis, new->axis + DrawAxisTop,
				  NULL))) {
	char vsname[IOBUFLEN];
	sprintf(vsname, "%s-sheet", name);

	if ((new->gow = XtVaCreateManagedWidget
	     (vsname, gowVsWidgetClass,
	      new->frm,
	      XtNxScale, x_scale,
	      XtNyScale, y_scale,
	      XtNinheritableScale, inheritable_scale,
	      NULL))) {
	  XtAddCallback(new->gow, XtNdestroyCallback,
			DestroySetupCallback, new);
	  XtAddEventHandler(new->gow,
			    (unsigned int)EnterWindowMask,
			    FALSE, SetCurrentWidget, NULL);
	  DSt_AddChild(new);
	  new->gow_name= Strdup(title);
	  if (!a) {
	    VactTitle(new->act)= new->gow_name;
	    XtAddCallback(new->gow, XtNdestroyCallback,
			  DestroyActCallback, new->act); }
	  if (vdSetupRoot) {
	    VdSetup setup;
	    ForAllSetups(setup) { /* find last setup */
	      if (!setup->next) {
		setup->next= new; break; } } }
	  else {		/* creating root setup */
	    vdSetupRoot= new; }
	  new->cursor= XC_num_glyphs;
	  DN_ChangedScale(new->act);
	  if (io_input_focus) { DW_InputModeEdit(); }
	  return new; }
	XtDestroyWidget(new->frm); }
      if (!a) { Act_Destroy(new->act); } }
    Free(new); }
  return NULL;
}
/* ---------------------------------------------------------------------- */
static void InitSpectraGow(vds)
     VdSetup vds;
{
  vds->dbin= DB_Init(vds->gow, vds->act);
  vds->dcut= DC_Init(vds->gow, vds->act);
  vds->dcutlbl= DCL_Init(vds->gow, vds->act);
  vds->ddecomp= DD_Init(vds->gow, vds->act);
  vds->dfit= DF_Init(vds->gow, vds->act);
  vds->dfitlbl= DFL_Init(vds->gow, vds->act);
  vds->dlbl= DL_Init(vds->gow, vds->act);
  vds->dpos= DL_PosInit(vds->gow, vds->act);
  vds->dmrk= DM_Init(vds->gow, vds->act);
  vds->dpeaklbl= DPL_Init(vds->gow, vds->act);
  vds->dpeaks= DPS_Init(vds->gow, vds->act);
  vds->dspc= DS_Init(vds->gow, vds->num);
}
/* ---------------------------------------------------------------------- */
static void InitResidGow(vds)
     VdSetup vds;
{
  vds->dres= DR_Init(vds->gow, vds->act);
}
/* ---------------------------------------------------------------------- */
static void InitCutGow(vdsc, vdsp)
     VdSetup vdsc;
     VdSetup vdsp;
{
  vdsc->dpro= vdsp;
}
/* ---------------------------------------------------------------------- */
int DW_InputModeEdit()
{
  return InputMode(TRUE, io);
}
/* ---------------------------------------------------------------------- */
int DW_InputModeMouse()
{
  return InputMode(FALSE, mouse);
}
/* ---------------------------------------------------------------------- */
static int InputMode(new_focus, widget)
     int new_focus;
     Widget widget;
{
  VdSetup setup;
  Arg io_args[1];

  if (io) {
    io_input_focus= new_focus;
    XtSetArg(io_args[0], XtNcursor, &io_cursor);
    XtGetValues(io, io_args, XtNumber(io_args));
    XtSetArg(io_args[0], XtNcursor, io_cursor);
    ForAllSetups(setup) {
      if (widget) {
	if (setup->cursor == XC_num_glyphs) {
	  Arg args[1];
	  XtSetArg(args[0], XtNcursor, &setup->cursor);
	  XtGetValues(setup->gow, args, XtNumber(args)); }
	XtSetValues(setup->gow, io_args, XtNumber(io_args)); }
      else if (setup->cursor != XC_num_glyphs) {
	Arg args[1];
	XtSetArg(args[0], XtNcursor, setup->cursor);
	XtSetValues(setup->gow, args, XtNumber(args));
	setup->cursor= XC_num_glyphs; }
      XtSetKeyboardFocus(setup->shell, widget); }
    XtSetKeyboardFocus(appShell, io);
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
int DW_EditFocusLock()
{
  mouse= io;
  if (!io_input_focus) { DW_InputModeMouse(); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DW_EditFocusUnlock()
{
  mouse= NULL;
  if (!io_input_focus) { DW_InputModeMouse(); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */ /* action */
static void EditFocusLockAction(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
  DW_EditFocusLock();
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */ /* action */
static void EditFocusUnlockAction(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
  DW_EditFocusUnlock();
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
void DW_FreeCallback(w, p, unused_too)
     Widget w;
     XtPointer p;
     XtPointer unused_too;
{
  Free(p);
  return;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static void DestroyActCallback(w, p, unused_too)
     Widget w;
     XtPointer p;
     XtPointer unused_too;
{
  Act_Destroy((Vact_t)p);
  return;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static void DestroyScaleCallback(w, p, unused_too)
     Widget w;
     XtPointer p;
     XtPointer unused_too;
{
  GowDestroyScale((GowScale)p);
  return;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static void DestroySetupCallback(w, p, unused_too)
     Widget w;
     XtPointer p;
     XtPointer unused_too;
{
  VdSetup destroy= (VdSetup)p;
  VdSetup setup;

  ForAllSetups(setup) {
    if (setup->next == destroy) { /* root will never become destroyed !! */
      if (destroy == locked || current == destroy) {
	if (current == destroy) {
	  DSt_UnmanageStatus(current);
	  current= NULL; }
	UnlockWidget(); }
      XtRemoveEventHandler(destroy->gow,
			   (unsigned int)EnterWindowMask,
			   FALSE, SetCurrentWidget, NULL);
      Free(destroy->gow_name);
      setup->next= destroy->next;
      Free(destroy);
      if (io_input_focus) { DW_InputModeEdit(); }
      return; } }
  return;
}
/* ---------------------------------------------------------------------- */
static void LockWidget(setup)
     VdSetup setup;
{
  setup = setup ? setup : current;
  if (setup) {
    DSt_Focus(setup);
    locked= setup; Act_Set(setup->act); }
}
/* ---------------------------------------------------------------------- */
static void UnlockWidget()
{
  locked= NULL;
  DSt_Focus(NULL);
  Act_Set(current ? current->act : NULL);
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */ /* action */
static void LockWidgetAction(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
  LockWidget(NULL);
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */ /* action */
static void UnlockWidgetAction(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
  UnlockWidget();
}
/* ---------------------------------------------------------------------- */
int DW_LockWidget()
{
  char name[IOBUFLEN];

  if (UF_ItemRead(name, IOBUFLEN, "lock widget name") && *name) {
    VdSetup setup;

    ForAllSetups(setup) {
      if (!strcmp(name, setup->gow_name)) {
	LockWidget(setup); return TRUE; } }
    ErrPrint("error: widget '%s' not found\n", name);
    return FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int DW_LockWidgetCursor()
{
  LockWidget(NULL); return TRUE;
}
/* ---------------------------------------------------------------------- */
int DW_UnlockWidget()
{
  UnlockWidget();
  return TRUE;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */ /* XtEventHandler */
static void SetCurrentWidget(w, unused, event, unused_too)
     Widget w;
     XtPointer unused;
     XEvent *event;
     Boolean *unused_too;
{
  if (XtIsSubclass(w, gowVsWidgetClass)) {
    VdSetup setup;

    switch (event->type) {
    case EnterNotify:
    case FocusIn:
      ForAllSetups(setup) {
	if (setup->gow == w) {
	  DSt_UnmanageStatus(current);
	  DSt_ManageStatus(setup);
	  current= setup;
	  if (!locked) { Act_Set(setup->act); }
	  return; } } } }
}
/* ---------------------------------------------------------------------- */
Widget DW_GetWidget()
{
  VdSetup setup;
  return ((setup= DW_GetSetup()) ? setup->gow : NULL);
}
/* ---------------------------------------------------------------------- */
VdSetup DW_GetSetup()
{
  if (locked) { return locked; }
  else if (current) { return current; }
  else if (vdSetupRoot) { return vdSetupRoot; }
  else {
    UF_PrintE("fatal internal: can not determine active setup\n");
    return NULL; }
}
/* ---------------------------------------------------------------------- */
VdSetup DW_GetSetupOfShell(name)
     char *name;
{
  VdSetup setup;
  ForAllSetups(setup) {
    if (!strcmp(name, XtName(setup->shell))) { return setup; } }
  return NULL;
}
/* ---------------------------------------------------------------------- */
VdSetup DW_GetSetupOfWidget(w)
     Widget w;
{
  VdSetup setup;
  ForAllSetups(setup) { if (w == setup->gow) { return setup; } }
  return NULL;
}
/* ---------------------------------------------------------------------- */
int DW_GetCursor(w, x, y)
     Widget *w;
     int *x;
     int *y;
{
  if (w || x || y) {
    int io_focus= io_input_focus;

    DW_InputModeMouse();
    if (x && (*x= XUFGetKeyX()) < 0) { return FALSE; }
    if (y && (*y= XUFGetKeyY()) < 0) { return FALSE; }
    if (w && !(*w= XUFGetKeyWidget())) { return FALSE; }
    if (io_focus) { DW_InputModeEdit(); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
