/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsActiv.c,v 1.5 1994/12/21 17:13:45 vs Exp vs $ */
#define _VsActiv_c

				/* library include files */
#include <tv/vsTypes.h>
#include <tv/vsAlloc.h>
#include <tv/vsTools.h>
#include <tv/vsSpectra.h>
#include <tv/vsCut.h>

				/* private include files */
#include "VsCut.h"
#include "VsError.h"
#include "VsIndex.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VsActiv.h"

#include "VdNotify.h"

#include "VsActivP.h"
/* ---------------------------------------------------------------------- */
Vact_t Act_Create()
{
  static int firstCall= TRUE;
  if (!vActDefault) {
    ErrPrintR("fatal internal: active-module not yet initialized\n");
    return NULL; }
  else if (firstCall) { firstCall= FALSE; return vActDefault; }
  else { return Act_CreateIntern(VactNum(vActDefault)); }
}
/* ---------------------------------------------------------------------- */
void Act_Destroy(ap)
     Vact_t ap;
{
  if (ap && ap != vActDefault) { VecFree(VactManagedVec(ap)); Free(ap); }
  return;
}
/* ---------------------------------------------------------------------- */
int Act_Init(num, title)
     int num;
     char *title;
{
  if ((vActDefault= Act_CreateIntern(num))) {
    VactTitle(vActDefault)= title;
    VactScale(vActDefault)= ACT_SCALIBRATED;
    VactExpand(vActDefault)= ACT_EAUTO;
    vAct= vActDefault;
    return TRUE; }
  ErrPrintR("fatal: can not initialize active-module\n");
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static Vact_t Act_CreateIntern(num)
     int num;
{
  Vact_t ap;

  if ((ap= (Vact_t)Malloc(sizeof(VactRec)))) {
    VactNames(ap)= TRUE;
    VactTitle(ap)= "<untitled>";
    VactScale(ap)= ACT_SDEFAULT;
    VactExpand(ap)= ACT_EDEFAULT;
    VactPrevCutIdx(ap)= VactCutIdx(ap)= 0;
    VactPrevSpcIdx(ap)= VactSpcIdx(ap)= 0;
    VecInit(VactManagedVec(ap), sizeof(int));
    if (VecAlloc(VactManagedVec(ap), num)) {
      int i;
      VactNum(ap)= num;
      for (i= 0; i< num; i++) { VactManaged(ap,i)= FALSE; }
      return ap; }
    Free(ap); }
  ErrPrintR("fatal: can not initialize activation management\n");
  return NULL;
}
/* ---------------------------------------------------------------------- */
static int new_expand;
/* ---------------------------------------------------------------------- */
int Act_Expand(expand, name)
     int *expand;
     char *name;
{
  extern Men_t actExpandMen;
  char pmt[IOBUFLEN];

  sprintf(pmt, "expand of %s", name);

  if (UF_NoArgs()) {
    switch (*expand) {
    case ACT_EAUTO:
    case ACT_EREQUEST:
      UF_PrintM("expand of %s takes place %s\n",
		name, VactExpandText(*expand));
      break;
    case ACT_EDEFAULT:
      UF_PrintM("expand of %s follows default expand (currently: %s)\n",
		name, VactExpandText(*expand));
      break; }
    return FALSE; }

  new_expand= *expand;
  UF_MenuLoop(&actExpandMen, pmt);
  if (*expand == new_expand) { return FALSE; }
  else { *expand= new_expand; return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Act_ExpandAuto()
{
  new_expand= ACT_EAUTO; return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_ExpandRequest()
{
  new_expand= ACT_EREQUEST; return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_ExpandDefault()
{
  new_expand= ACT_EDEFAULT; return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_ManageOnly(ap, m)
     Vact_t ap;
     int m;
{
  int u;

  for (u= 0; u< VactNum(ap); u++) { VactManaged(ap,u)= (u == m); }

  DN_ChangedManaged(vAct);

  return Act_SetActSpc(ap, m);
}
/* ---------------------------------------------------------------------- */
int Act_ManageAll(ap)
     Vact_t ap;
{
  int m;

  for (m= 0; m< VactNum(ap); m++) { VactManaged(ap,m)= TRUE; }

  DN_ChangedManaged(ap);

  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_ManageNext()
{
  int m;

  for (m= (VactSpcIdx(vAct) + 1) % VactNum(vAct);
       m != VactSpcIdx(vAct);
       m= (m + 1) % VactNum(vAct)) {
    if (VspcsExists(&vSpc,m)) {
      return Act_ManageOnly(vAct, m); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_ManagePrevious()
{
  int m;

  for (m= (VactSpcIdx(vAct) + VactNum(vAct) - 1) % VactNum(vAct);
       m != VactSpcIdx(vAct);
       m= (m + VactNum(vAct) - 1) % VactNum(vAct)) {
    if (VspcsExists(&vSpc,m)) {
      return Act_ManageOnly(vAct, m); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_Next()
{
  int m;

  for (m= (VactSpcIdx(vAct) + 1) % VactNum(vAct);
       m != VactSpcIdx(vAct);
       m= (m + 1) % VactNum(vAct)) {
    if (VspcsExists(&vSpc,m)) {
      return Act_SetActSpc(vAct, m); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_Previous()
{
  int m;

  for (m= (VactSpcIdx(vAct) + VactNum(vAct) - 1) % VactNum(vAct);
       m != VactSpcIdx(vAct);
       m= (m + VactNum(vAct) - 1) % VactNum(vAct)) {
    if (VspcsExists(&vSpc,m)) {
      return Act_SetActSpc(vAct, m); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_ReadActCut()
{
  int a;

  if (!UF_IntRead(FALSE, &a,
		  "%s: cut index to activate", VactTitle(vAct))) {
    return FALSE; }
  else if (a < 0 || a >= VactNum(vAct)) {
    ErrPrintR("fatal: %s: index %d out of Range [%d,%d]\n",
	      VactTitle(vAct), a, 0, VactNum(vAct)-1);
    return FALSE; }
  else {
    Act_SetActCut(vAct,a);
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Act_ReadManaged()
{
  if (!Idx_Read(1, "%s: show spectrum", VactTitle(vAct))) {
    return FALSE; }
  else {
    int m;
    int num= VactNum(vAct);

    for (m= 0; m< num; m++) {
      int i;

      VactManaged(vAct,m)= FALSE;
      for (i= 0; i< VidxNum(&vIdx); i++) {
	if (m == VidxIdx(&vIdx,i)) { VactManaged(vAct,m)= TRUE; break; } } }

    DN_ChangedManaged(vAct);

    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Act_ReadAdd()
{
  if (!Idx_Read(1, "%s: show also spectrum", VactTitle(vAct))) {
    return FALSE; }
  else {
    int m;
    int num= VactNum(vAct);

    for (m= 0; m< num; m++) {
      int i;

      for (i= 0; i< VidxNum(&vIdx); i++) {
	if (m == VidxIdx(&vIdx,i)) { VactManaged(vAct,m)= TRUE; break; } } }

    DN_ChangedManaged(vAct);

    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Act_ReadSub()
{
  if (!Idx_Read(1, "%s: hide spectrum", VactTitle(vAct))) {
    return FALSE; }
  else {
    int m;
    int num= VactNum(vAct);

    for (m= 0; m< num; m++) {
      int i;

      for (i= 0; i< VidxNum(&vIdx); i++) {
	if (m == VidxIdx(&vIdx,i)) { VactManaged(vAct,m)= FALSE; break; } } }

    DN_ChangedManaged(vAct);

    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Act_ReadActSpc()
{
  int a;

  if (!UF_IntRead(FALSE, &a,
		  "%s: spectrum index to activate", VactTitle(vAct))) {
    return FALSE; }
  else if (a < 0 || a >= VactNum(vAct)) {
    ErrPrintR("fatal: %s: index %d out of Range [%d,%d]\n",
	      VactTitle(vAct), a, 0, VactNum(vAct)-1);
    return FALSE; }
  else if (!VspcsExists(&vSpc,a)) {
    ErrPrintR("fatal: %s: no spectrum #%d defined\n", VactTitle(vAct), a);
    return FALSE; }
  else {
    Act_SetActSpc(vAct, a);
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
static int new_scale;
/* ---------------------------------------------------------------------- */
int Act_Scale(scale, name)
     int *scale;
     char *name;
{
  extern Men_t actScaleMen;
  char pmt[IOBUFLEN];

  sprintf(pmt, "scale of %s", name);

  if (UF_NoArgs()) {
    switch (*scale) {
    case ACT_SCALIBRATED:
    case ACT_SUNCALIB:
      UF_PrintM("scale of %s is %s\n", name, VactScaleText(*scale));
      break;
    case ACT_SDEFAULT:
      UF_PrintM("scale of %s follows default scale (currently: %s)\n",
		name, VactScaleText(*scale));
      break; }
    return FALSE; }

  new_scale= *scale;
  UF_MenuLoop(&actScaleMen, pmt);
  if (*scale == new_scale) { return FALSE; }
  else { *scale= new_scale; return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Act_ScaleCalibrated()
{
  new_scale= ACT_SCALIBRATED; return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_ScaleUncalibrated()
{
  new_scale= ACT_SUNCALIB; return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_ScaleDefault()
{
  new_scale= ACT_SDEFAULT; return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_WidgetScale()
{
  int scale= VactScale(vAct);
  if (Act_Scale(&scale, VactTitle(vAct))) {
    int redisplay= (VactCalibrated(scale) != VactCalibrated(VactScale(vAct)));

    if (vAct == vActDefault) {
      VactScale(vAct)= (VactCalibrated(scale) ?
			ACT_SCALIBRATED : ACT_SUNCALIB); }
    else { VactScale(vAct)= scale; }
    if (redisplay) { DN_ChangedScale(vAct); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_WidgetExpand()
{
  int expand= VactExpand(vAct);
  if (Act_Expand(&expand, VactTitle(vAct))) {
    if (vAct == vActDefault) {
      VactExpand(vAct)= (VactExpandAutomatic(expand) ?
			 ACT_EAUTO : ACT_EREQUEST); }
    else { VactExpand(vAct)= expand; } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_SetDefaultSpc(fatal)
     int fatal;
{
  if (VspcsExists(&vSpc,VactSpcIdx(vAct)) &&
      VactManaged(vAct,VactSpcIdx(vAct))) {
    return TRUE; }		/* active spectrum exists and is managed */
  else {
    int i;
    for (i= 0; i< VactNum(vAct); i++) {
      if (VspcsExists(&vSpc,i) && VactManaged(vAct,i)) {
	Act_SetActSpc(vAct, i);
	return TRUE; } }	/* activate 1st managed & existing spectrum */
    for (i= 0; i< VactNum(vAct); i++) {
      if (VspcsExists(&vSpc,i)) {
	Act_SetActSpc(vAct, i);
	return TRUE; } }	/* activate 1st existing spectrum */
    if (fatal) { ErrPrintR("fatal: no spectrum defined\n"); }
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
void Act_Set(ap)
     Vact_t ap;
{
  if (ap) { vAct= ap; }
  else { vAct= vActDefault; }
}
/* ---------------------------------------------------------------------- */
int Act_Show(ap)
     Vact_t ap;
{
  int m;

  UF_PrintM("%-16s spectrum:%3d; cut:%3d; managed:",
	    VactTitle(ap), VactSpcIdx(ap), VactCutIdx(ap));
  for (m= 0; m< VactNum(ap); m++) {
    if (VactManaged(ap,m)) {
      UF_PrintM((VspcsExists(&vSpc,m) ? " %d" :" (%d)"), m); } }
  UF_PrintM("\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Act_ShowDefault()
{
  return Act_Show(vActDefault);
}
/* ---------------------------------------------------------------------- */
int Act_SetActCut(ap, a)
     Vact_t ap;
     int a;
{
  if (a < 0 || a >= VactNum(ap)) {
    ErrPrintR("fatal: %s: index %d out of Range [%d,%d]\n",
	      VactTitle(ap), a, 0, VactNum(ap)-1);
    return FALSE; }
  else {
    UF_PrintM("%s: cut #%d active\n", VactTitle(ap), a);
    VactPrevCutIdx(ap)= VactCutIdx(ap);
    if (VactCutIdx(ap) != a) {
      VactCutIdx(ap)= a;
      DN_ChangedActCut(ap); }

    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Act_SetActSpc(ap, a)
     Vact_t ap;
     int a;
{
  if (a < 0 || a >= VactNum(ap)) {
    ErrPrintR("fatal: %s: index %d out of Range [%d,%d]\n",
	      VactTitle(ap), a, 0, VactNum(ap)-1);
    return FALSE; }
  else {
    UF_PrintM("%s: spectrum #%d active\n", VactTitle(ap), a);

    VactPrevSpcIdx(ap)= VactSpcIdx(ap);
    VactSpcIdx(ap)= a;
    DN_ChangedActSpc(ap);

    VactManaged(ap,a)= TRUE;

    DN_ChangedManaged(ap);
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
