/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsCut.h,v 1.2 1994/05/26 19:51:48 vs Exp vs $ */

#ifndef _VsCut_h
#define _VsCut_h

#include <tv/SerialId.h>
#include <tv/vsTypes.h>
#include <tv/vsCut.h>
#include <tv/vsSpectra.h>

typedef struct {
  CDIR *cdp;
  int cutIdx;
  char cutFmt[SPC_FMTLEN];
  char *fitExpr;
  char *spcExpr;
  SerialId_t serialId;
} VcutPath_t;

#define VcutPathCdp(p)		((p)->cdp)
#define VcutPathCutIdx(p)	((p)->cutIdx)
#define VcutPathCutFmt(p)	((p)->cutFmt)
#define VcutPathFitExpr(p)	((p)->fitExpr)
#define VcutPathSpcExpr(p)	((p)->spcExpr)
#define VcutPathSerialId(p)	((p)->serialId)

typedef struct {
  int mtxExists;
  SpcFile_t mtx;
  SerialId_t mtxSerialId;
  int proIdx;
} Vmtx_t;

#define VmtxMtxExists(p)	((p)->mtxExists)
#define VmtxMtx(p)		((p)->mtx)
#define VmtxMtxSerialId(p)	((p)->mtxSerialId)
#define VmtxProIdx(p)		((p)->proIdx)

typedef struct {
  CutRec cut;
  int spcExists;
  int spcIdx;
  SerialId_t spcSerialId;
  SerialId_t gatSerialId;
  SerialId_t bgGatSerialId;
  int mtxIdx;
  Vmtx_t *mtx;
  int cutPathIdx;
  VcutPath_t *cutPath;
} Vcut_t;

#define VcutCut(cp)		(&(cp)->cut)
#define VcutSpcIdx(cp)		((cp)->spcIdx)
#define VcutSpcExists(cp)	((cp)->spcExists)
#define VcutSpcSerialId(cp)	((cp)->spcSerialId)
#define VcutGatSerialId(cp)	((cp)->gatSerialId)
#define VcutBgGatSerialId(cp)	((cp)->bgGatSerialId)
#define VcutNormSerialId(cp)	((cp)->normSerialId)
#define VcutBgNormSerialId(cp)	((cp)->bgNormSerialId)
#define VcutMtxIdx(cp)		((cp)->mtxIdx)
#define VcutMtx(cp)		((cp)->mtx)
#define VcutCutPathIdx(cp)	((cp)->cutPathIdx)
#define VcutCutPath(cp)		((cp)->cutPath)

#define VcutProIdx(cp)		VmtxProIdx(VcutMtx(cp))

typedef struct {
  int num;
  int weight;
  double ignore;
  int scale;
  Vcut_t *c;
  Vmtx_t *m;
  VcutPath_t *p;
  PVecRec gate;
  PVecRec bgGate;
  char mtxFmt[SPC_FMTLEN];
  char cutFmt[SPC_FMTLEN];
} Vcuts_t;

#define VcutsNum(cp)		((cp)->num)
#define VcutsWeight(cp)		((cp)->weight)
#define VcutsIgnore(cp)		((cp)->ignore)
#define VcutsScale(cp)		((cp)->scale)
#define VcutsC(cp)		((cp)->c)
#define VcutsM(cp)		((cp)->m)
#define VcutsP(cp)		((cp)->p)
#define VcutsGate(cp)		(&(cp)->gate)
#define VcutsBgGate(cp)		(&(cp)->bgGate)
#define VcutsMtxFmt(cp)		((cp)->mtxFmt)
#define VcutsCutFmt(cp)		((cp)->cutFmt)

#define VcutsCCut(cp,i)		VcutCut(VcutsC(cp)+(i))

#define VcutsCExists(cp,i)	CutExists(VcutsCCut(cp,i))

#ifdef _VsCut_c
Vcuts_t vCut;
#else
extern Vcuts_t vCut;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsCutF.h"

#undef P_

#endif				/* _VsCut_h */
