/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsError.c,v 1.2 1994/05/26 19:51:50 vs Exp vs $ */

#define _VsError_c

#include <tv/vsConfig.h>

#include <errno.h>

#ifndef __STDC__
#	include <varargs.h>
#else
#	include <stdarg.h>
#endif

#ifdef HAS_SHM
#	include <sys/types.h>
#	include <sys/stat.h>
#	include <fcntl.h>
#	include <limits.h>
#	include <sysdep/error.h>
#	include <sysdep/shm_alloc.h>
#endif				/* HAS_SHM */

				/* library include files */
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsUserFace.h>
#include <tv/vsCal.h>
#include <tv/vsCut.h>
#include <tv/vsSpectra.h>
#include <tv/vsCurFit.h>
#include <tv/vsFit.h>
#include <tv/vsFitFmt.h>
#include <tv/vsFitIo.h>
#include <tv/vsFitSetup.h>
#include <tv/vsKey.h>
#include <tv/vsMark.h>
#include <tv/vsPar.h>
#include <tv/vsPath.h>
#include <tv/vsPattern.h>
#include <tv/vsRecal.h>
#include <tv/vsRecord.h>
#include <tv/vsSearch.h>
#include <tv/vsTools.h>

				/* private include files */
#include "VsUserFace.h"
#include "VsError.h"
/* ---------------------------------------------------------------------- */
static int ErrPrintV();
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS1 */
int ErrPrint(char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int ErrPrint(va_alist)
     /* char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { char *fmt= va_arg(ap, char *);
#endif
    ErrPrintV(fmt, ap);
    va_end(ap); }
  return ErrClear();
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS1 */
int ErrPrintR(char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int ErrPrintR(va_alist)
     /* char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { char *fmt= va_arg(ap, char *);
#endif
    ErrPrintV(fmt, ap);
    va_end(ap); }

  UF_ResetIllegal();		/* was:  UF_Reset()*/
  return ErrClear();
}
/* ---------------------------------------------------------------------- */
static int ErrPrintV(fmt, ap)
     char *fmt;
     va_list ap;
{
  UF_PrintEV(fmt, ap);

  if (RclErrNo) { UF_PrintE("  %s\n", RclError(RclErrNo)); }
  if (PatErrNo) { UF_PrintE("  %s\n", PatError(PatErrNo)); }
  if (CalErrNo) { UF_PrintE("  %s\n", CalError(CalErrNo)); }
  if (CutErrNo) { UF_PrintE("  %s\n", CutError(CutErrNo)); }
  if (FSErrNo)  { UF_PrintE("  %s\n", FSError(FSErrNo)); }
  if (CurErrNo) { UF_PrintE("  %s\n", CurError(CurErrNo)); }
  if (FioErrNo) { UF_PrintE("  %s\n", FioError(FioErrNo)); }
  if (FitErrNo) { UF_PrintE("  %s\n", FitError(FitErrNo)); }
  if (FmtErrNo) { UF_PrintE("  %s\n", FmtError(FmtErrNo)); }
  if (KTErrNo)  { UF_PrintE("  %s\n", KTError(KTErrNo)); }
  if (MrkErrNo) { UF_PrintE("  %s\n", MrkError(MrkErrNo)); }
  if (ParErrNo) { UF_PrintE("  %s\n", ParError(ParErrNo)); }
  if (PthErrNo) { UF_PrintE("  %s\n", PthError(PthErrNo)); }
  if (SeaErrNo) { UF_PrintE("  %s\n", SeaError(SeaErrNo)); }
  if (RecErrNo) { UF_PrintE("  %s\n", RecError(RecErrNo)); }
  if (SpcErrNo) { UF_PrintE("  %s\n", SpcError(SpcErrNo)); }
#ifdef HAS_SHM
  if (SpcSharedMemory && error_level() != -1) { print_error(ERROR_STACK); }
#endif				/* HAS_SHM */
  if (TlsErrNo) { UF_PrintE("  %s\n", TlsError(TlsErrNo)); }
  if (UFErrNo)  { UF_PrintE("  %s\n", UFError(UFErrNo)); }
  if (AlcErrNo) { UF_PrintE("  %s\n", AlcError(AlcErrNo)); }
  if (errno)    { UF_PrintE("  system: %s\n", strerror(errno)); }
  return ErrClear();
}
/* ---------------------------------------------------------------------- */
int ErrClear()
{
  RclErrNo= RCLNOERR;
  SpcErrNo= SPCNOERR;
  PatErrNo= PATNOERR;
  CalErrNo= CALNOERR;
  CutErrNo= CUTNOERR;
  FSErrNo= FSNOERR;
  CurErrNo= CURNOERR;
  FioErrNo= FIONOERR;
  FitErrNo= FITNOERR;
  FmtErrNo= FMTNOERR;
  KTErrNo= KTNOERR;
  MrkErrNo= MRKNOERR;
  ParErrNo= PARNOERR;
  PthErrNo= PTHNOERR;
  RecErrNo= RECNOERR;
  SeaErrNo= RECNOERR;
  TlsErrNo= TLSNOERR;
  UFErrNo= UFNOERR;
  
  errno= 0;

#ifdef HAS_SHM
  if (SpcSharedMemory) { free_error(ERROR_ALLLEVELS); }
#endif				/* HAS_SHM */

  if (AlcErrNo) {
    UF_PrintE("can not clear vsalloc error\n");
    UF_PrintE("  %s\n", AlcError(AlcErrNo));
    return FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
