/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsFit.c,v 1.6 1994/12/21 17:13:54 vs Exp vs $ */

#define _VsFit_c
				/* library include files*/
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsFitInt.h>
#include <tv/vsFitSetup.h>
#include <tv/vsMark.h>
#include <tv/vsPath.h>
#include <tv/vsTools.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFitFct.h"
#include "VsFitPar.h"
#include "VsIndex.h"
#include "VsMark.h"
#include "VsPath.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdNotify.h"

#include "VsFit.h"
#include "VsFitP.h"
/* ---------------------------------------------------------------------- */
void Fit_Changed(idx, sid)
     int idx;
     SerialId_t sid;
{
  Vfit_t *vp= VfitsF(&vFit) + idx;
  DN_ChangedFit(idx);
  if (sid) { SerialIdCp(VfitFitSerialId(vp), sid); }
  else {
    SerialIdGet(VfitFitSerialId(vp));
    SerialIdGet(VfitTocSerialId(vp)); }
  SerialIdCp(VfitSpcSerialId(vp), VspcsSerialId(&vSpc,idx));
}
/* ---------------------------------------------------------------------- */
/* ===================== */
/* initialize fit module */
/* ===================== */

static int Fit_VfitInit(vp)
     Vfit_t *vp;
{
  FitInit(VfitFit(vp));
  VfitScale(vp)= ACT_SUNCALIB;
  SerialIdInit(VfitFitSerialId(vp));
  SerialIdInit(VfitSpcSerialId(vp));
  SerialIdInit(VfitTocSerialId(vp));
  VfitTocIdx(vp)= -1;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Fit_Reset(idx)
     int idx;
{
  Vfit_t *vp= VfitsF(&vFit) + idx;

  Fit_VReset(vp);
  Fit_Changed(idx, VfitFitSerialId(vp));
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Fit_VReset(vp)
     Vfit_t *vp;
{
  FitReset(VfitFit(vp));
  SerialIdGet(VfitFitSerialId(vp));
  SerialIdGet(VfitTocSerialId(vp));
  SerialIdGet(VfitSpcSerialId(vp));
  VfitTocIdx(vp)= -1;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Fit_Init(num)
     int num;
{
  if ((VfitsF(&vFit)= (Vfit_t *)Malloc(num * sizeof(Vfit_t))) &&
      (VfitsBackup(&vFit)= (Vfit_t *)Malloc(num * sizeof(Vfit_t)))) {
    int i;
    for (i= 0; i< num; i++) {
      Fit_VfitInit(VfitsF(&vFit)+i);
      Fit_VfitInit(VfitsBackup(&vFit)+i); }

    VfitsNum(&vFit)		= num;
    VfitsMaxIterations(&vFit)	= CUR_ITERATIONS;
    VfitsLambda(&vFit)		= CUR_LAMBDA;
    VfitsMinLambda(&vFit)	= CUR_MINLAMBDA;
    VfitsMaxLambda(&vFit)	= CUR_MAXLAMBDA;
    VfitsMeasureTyp(&vFit)	= FIT_MDY;
    VfitsPeakSortTyp(&vFit)	= FIT_STPOS;
    VfitsInScale(&vFit)		= ACT_SDEFAULT;
    VfitsOutScale(&vFit)	= ACT_SDEFAULT;

    VecInit(VfitsBin(&vFit), sizeof(Pair_t));
    Fit_VfitInit(VfitsTmpFit(&vFit));
    Fit_VfitInit(VfitsWork(&vFit));
    VfitsWorkScale(&vFit)= VfitsInScale(&vFit);
    Fit_VfitInit(VfitsStore(&vFit));
    CurInit(VfitsCur(&vFit));

    return TRUE; }
  else {
    ErrPrintR("fatal: can not initialize fit-module\n");
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int Fit_Backup(idx)
     int idx;
{
  if (FitTime(VfitsFFit(&vFit,idx))) {
    return Fit_VCopy(VfitsBackup(&vFit)+idx, VfitsF(&vFit)+idx); }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
static int Fit_WorkPutTo(idx)
     int idx;
{
  Vfit_t *vp= VfitsF(&vFit) + idx;

  FitPeakSortTyp(VfitsWorkFit(&vFit))= VfitsPeakSortTyp(&vFit);
  if (!Fit_VCopy(vp, VfitsWork(&vFit)) ||
      !Fit_Rescale(vp, idx, ACT_SUNCALIB)) {
    Fit_Reset(idx); return FALSE; }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Fit_WorkGetFrom(idx)
     int idx;
{
  Vfit_t *vp= VfitsF(&vFit) + idx;

  if (!Fit_VCopy(VfitsWork(&vFit), vp) ||
      !Fit_Rescale(VfitsWork(&vFit), idx, VfitsInScale(&vFit))) {
    DN_ChangedWorkPeak(); Fit_VReset(VfitsWork(&vFit)); return FALSE; }
  else { DN_ChangedWorkPeak(); return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Fit_WorkSetup(idx)
     int idx;
{
  Spc_t spc;
  Vfit_t *vp= VfitsWork(&vFit);
  Fit_t fp= VfitFit(vp);
  Act_SetDefaultSpc(FALSE);
  spc= !VspcsExists(&vSpc,idx) ? NULL : VspcsSpc(&vSpc,idx);

  if (spc == NULL){		/* kein Spektrum ! DUKE */
    return FALSE;}
  Fit_MrkGet(idx);
  Fit_Rescale(vp, idx, ACT_SUNCALIB);
  if (!FSRegSetup(fp, FitRegMrk(fp), spc, VcalsCal(&vCal,idx))) {
    ErrPrint("warning: can not initialize (all) fit parameters\n");
    return FALSE; }
  Fit_Rescale(vp, idx, VfitsInScale(&vFit));
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Fit_Rescale(vp, idx, scale)
     Vfit_t *vp;
     int idx;
     int scale;
{
  Cal_t cal= VcalsCal(&vCal,idx);

  if (VactCalibrated(scale) != VactCalibrated(VfitScale(vp))) {
    if (CalCheck(CAL_POS, cal)) {
      Fit_t fit= VfitFit(vp);
      Par_t pp= FitPar(fit);
      double (*pf)();
      double (*wf)();
      double (*dwf)();
      int i;
      if (VactCalibrated(scale)) { pf= CalP; wf= CalPWidth; dwf= CalPDwidth; }
      else { pf= CalC; wf= CalCWidth; dwf= CalCDwidth; }
      
      FitBgOffset(fit)= pf(cal, FitBgOffset(fit));
      FitBgOffset(fit)= (VactCalibrated(scale) ? FitBgOffset(fit) :
			 (double)NINT(FitBgOffset(fit)));

      Mrk_RescalePVec(FitBgMrk(fit), cal, scale, "bg-region");
      Mrk_RescalePVec(FitRegMrk(fit), cal, scale, "fit-region");

      for (i=0; i< FitPeakNum(fit); i++) {
	double p= FitPPosVal(pp,i);
	double w= FitPWidthVal(pp,i);

	ParVErr(FitPPos(pp,i))	= wf(cal, p, ParVErr(FitPPos(pp,i)));
	ParVErr(FitPWidth(pp,i))= dwf(cal, p, w, ParVErr(FitPWidth(pp,i)));
	FitPPosVal(pp,i)	= pf(cal, p);
	ParUserVal(pp,FitPosIdx(i))= pf(cal, ParUserVal(pp,FitPosIdx(i)));
	FitPWidthVal(pp,i)	= wf(cal, p, w); } }
    VfitScale(vp)= scale; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Fit_Setup(idx)
     int idx;
{
  return (Fit_Backup(idx) && Fit_WorkPutTo(idx));
}
/* ---------------------------------------------------------------------- */
static int Fit_Exec(idx, mrk, fStat, suspendFct, useFct, setupParFct)
     int idx;
     PVec_t mrk;
     FitStat_t *fStat;
     pfi_t suspendFct;
     pfi_t useFct;
     pfi_t setupParFct;
{
  Fit_t fit= VfitsFFit(&vFit,idx);
  Spc_t spc= VspcsSpc(&vSpc,idx);
  Cal_t cal= VcalsCal(&vCal,idx);
  int status= FALSE;
  double offset;

  if (!setupParFct(fit, mrk, spc, cal)) {
    ErrPrintR("fatal: can not setup fit parameters\n");
    Fit_Changed(idx, 0);
    return FALSE; }
  offset= FitBgOffset(fit);
  FF_InitCurFct(fit, VfitsCur(&vFit), offset, idx);
  Fit_ShiftPar(fit, -offset);
  suspendFct(fit);
  if (Fit_CheckValid(fit, idx)) {
    if ((status= Fit_CurSetup(VfitsCur(&vFit), fit, spc, mrk))) {
      if (!(status= CurFit(VfitsCur(&vFit)))) {
	ErrPrintR("fatal: can not execute fit\n"); }
      status= Fit_CurFinish(VfitsCur(&vFit), fit, fStat) && status; } }
  useFct(fit);
  Fit_ShiftPar(fit, offset);
  Fit_Changed(idx, 0);
  return status;
}
/* ---------------------------------------------------------------------- */
static int Fit_Finish(idx)
     int idx;
{
  Fit_t fp= VfitsFFit(&vFit,idx);
  Fit_WorkGetFrom(idx);
  if (!FitTime(fp)) { VecReset(FitRegMrk(fp)); } /* delete unused marks */
  if (!FitBgTime(fp)) { VecReset(FitBgMrk(fp)); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Fit_BgConsistent(idx)
     int idx;
{
  Fit_t fp= VfitsFFit(&vFit,idx);
  if ((FitBgTime(fp) || FitTime(fp)) &&
      SerialIdCmp(VfitsFSpcSerialId(&vFit,idx), VspcsSerialId(&vSpc,idx))) {
    if (!FitResetBg(fp)) {
      ErrPrintR("fatal: can not reset background of fit #%d\n", idx);
      return FALSE; }
    else {
      UF_PrintE("warning: spectrum has changed -- background reset\n"); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Fit_PeakWarn(fit)
     Fit_t fit;
{
  Par_t pp= FitPar(fit);

  { int i, neg= FALSE, inconsistent= FALSE;
    for (i= 0; i< FitPeakNum(fit); i++) {
      if (FitPWidthVal(pp,i) < 0.0) {
	neg= TRUE;
	if (FitTlE(fit) % 2) { FitPTlVal(pp,i)= -FitPTlVal(pp,i); }
	if (FitTrE(fit) % 2) { FitPTrVal(pp,i)= -FitPTrVal(pp,i); }
	FitPShVal(pp,i)= -FitPShVal(pp,i); } }
    if (neg) {
      for (i=0; i<ParNumCorr(pp); i++) {
	int j= ParIcorr(pp,i);
	double old= ParVal(pp,j);
	ParCorrel(pp,j);
	if (old != ParVal(pp,j)) {
	  ParVal(pp,j)= old; inconsistent= TRUE; break; } }
      if (inconsistent) {
	for (i= 0; i< FitPeakNum(fit); i++) {
	  if (FitPWidthVal(pp,i) < 0.0) {
	    UF_PrintE("error: width %f < 0.0 chn for %f\n",
		      FitPWidthVal(pp,i), FitPPosVal(pp,i));
	    if (FitTlE(fit) % 2) { FitPTlVal(pp,i)= -FitPTlVal(pp,i); }
	    if (FitTrE(fit) % 2) { FitPTrVal(pp,i)= -FitPTrVal(pp,i); }
	    FitPShVal(pp,i)= -FitPShVal(pp,i); } } }
      else {
	for (i= 0; i< FitPeakNum(fit); i++) {
	  if (FitPWidthVal(pp,i) < 0.0) {
	    FitPWidthVal(pp,i)= -FitPWidthVal(pp,i); } } } } }

  { int i;
    for (i=0; i< FitPeakNum(fit); i++) {
      double xi= FitPPosVal(pp,i);
      int j;
      if (ParSused(pp,FitPosIdx(i))) {
	for (j= 0; j < i; j++) {
	  double dx= xi-FitPPosVal(pp,j);
	  if (ParSused(pp,FitPosIdx(j))) {
	    if (fabs(dx) < 1.0) { /* two peaks within one channel */
	      UF_PrintE("warning: distance < 1 chn between %f and %f\n",
			FitPPosVal(pp,i), FitPPosVal(pp,j)); }
	    else if (fabs(dx) < (MIN(FitPWidthVal(pp,i), FitPWidthVal(pp,j))
				  * SIGMA_TO_FWHM) &&
		     FitPVolVal(pp,i) * FitPVolVal(pp,j) < 0.0) {
	      UF_PrintE("warning: peaks are cancelling out for %f and %f\n",
			FitPPosVal(pp,i), FitPPosVal(pp,j)); } } } } } }
  { int i;
    PVec_t rp= FitRegMrk(fit);
    for (i=0; i< FitPeakNum(fit); i++) {
      if (ParSused(pp,FitPosIdx(i))) {
	double wi= FitPWidthVal(pp,i) * SIGMA_TO_FWHM;
	double xi= FitPPosVal(pp,i);

	if (wi < 1.0) {		/* more narrow than a channel */
	  UF_PrintE("warning: width %f < 1 chn for %f\n", wi, xi); }

	{ int r; for (r= 0; r< VecNum(rp); r++) {
	  double rle= PVecX1(rp,r);
	  double rge= PVecX2(rp,r);
	  double dr= fabs(rge - rle);
	  if (wi > dr) {	/* broader than region */
	    UF_PrintE("warning: width %f > %f (region width)for %f\n",
		      wi, dr, xi); }
	  if (rle <= xi && xi <= rge &&
	      (xi < rle + wi || rge - wi < xi)) { /* sic */
	    UF_PrintE
	      ("warning: distance to region limits < %f (width) for %f\n",
	       wi, xi); } } } } } }
  if (ParVMhold(FitPBgCoef(pp,0))) {
    int i;
    for (i= 0; i< FitPeakNum(fit); i++) {
      if (ParVUserStat(FitPSh(pp,i)) != FIT_USNONE) {
	UF_PrintE("warning: step height is free while bg[0] is fixed\n");
	break; } } }

  { FitStat_t *fp= FitStatReg(fit);
    if (FitStatIterations(fp) >= FitStatMaxIterations(fp)) {
      UF_PrintE("warning: maximal number of iterations (%d) reached\n",
		FitStatMaxIterations(fp)); } }

  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Fit_PeakConsistent(fit)
     Fit_t fit;
{
  Par_t pp= FitPar(fit);
  PVec_t rp= FitRegMrk(fit);
  int i;

  for (i=FitPeakNum(fit)-1; i>=0; i--) {
    if (ParSused(pp,FitPosIdx(i))) {
      double xi= FitPPosVal(pp,i);
      int r, found= FALSE;
      for (r= 0; r< VecNum(rp); r++) {
	if (!((PVecX1(rp,r) < xi && PVecX2(rp,r) < xi) ||
	      (PVecX1(rp,r) > xi && PVecX2(rp,r) > xi) )){
	  found= TRUE; break; } }
      if (!found) {		/* xi not in Region */
	if (FitDelPeak(fit, i)) {
	  UF_PrintE("warning: peak %f outside of fitregion -- deleted\n",
		    xi); }
	else {
	  ErrPrintR("fatal: peak %f outside of fitregion -- can not delete\n",
		    xi);
	  return FALSE; } } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Fit_Bg()
{
  if (!Act_SetDefaultSpc(TRUE)) { return FALSE; }
  else if (!UF_NoArgs() && !FP_BgGrad()) { return FALSE; }
  else {
    int status= FALSE;
    int idx= VactSpcIdx(vAct);
    Fit_t fit= VfitsFFit(&vFit,idx);
    Fit_t work= VfitsWorkFit(&vFit);
    Spc_t spc= VspcsSpc(&vSpc,idx);

    UF_PrintM("bg-fit of spectrum #%d '%s'\n", idx, PthShort(SpcFile(spc)));
    FitTime(fit)= 0;
    FitBgTime(fit)= 0;
#if 0
    if (!FitResetBg(VfitsWorkFit(&vFit))) {
      ErrPrintR("fatal: can not reset background"); }
    else
#endif				/* 0 */
    if (!Fit_MrkGet(idx) || /* mrk -> work */
	     !Mrk_Consistent(FitBgMrk(work), SpcNum(spc)) ||
	     !Mrk_Check("background", FitBgMrk(work))) {
      return FALSE; }
    else if (!VecNum(FitBgMrk(work))) {
      ErrPrintR("fatal: no bg-fit region defined\n");
      return FALSE; }
    else if (!Fit_Setup(idx)) {	/* work -> fit(idx) */
      ; }
    else {
      FitTime(fit)= 0;
      FitBgTime(fit)= 0;
      if ((status= Fit_Exec(idx, FitBgMrk(fit), FitStatBg(fit),
			   FitSuspendPeaks, FitUsePeaks, FSBgSetup))) {
	Cur_t cur= VfitsCur(&vFit);
	if (!VecCopy(FitBgCovar(fit), CurCovar(cur))) {
	  ErrPrintR("fatal: can not copy covariance matrix of bg\n");
	  FitBgTime(fit)= 0;
	  status= FALSE; }
	else { FitFitTyp(fit)= FIT_FTFIT; } }
      status= Fit_Finish(idx) && status; }
    Fit_Changed(idx, 0);
    return status; }
}
/* ---------------------------------------------------------------------- */
int Fit_Region()
{
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) { return FALSE; } }
  else if (!Idx_Read(1, "fit region for index(s)")) {
    return FALSE; }
  return Idx_Loop(Fit_RegFitExec, Fit_RegFitFinish);
}
/* ---------------------------------------------------------------------- */
static int Fit_RegFitExec(idx, num)
     int idx;
     int num;
{
  if (!VspcsExists(&vSpc,idx)) { return IDX_ESKIPPED; }
  else {
    int status;
    Fit_t fit= VfitsFFit(&vFit,idx);
    Fit_t work= VfitsWorkFit(&vFit);
    Spc_t spc= VspcsSpc(&vSpc,idx);

    UF_PrintM("fit of spectrum #%d '%s'\n",
	      idx, PthShort(VspcsFile(&vSpc,idx)));
    FitTime(fit)= 0;
    if (!Fit_MrkGet(idx) || /* mrk -> work */
	!Mrk_Consistent(FitRegMrk(work), SpcNum(spc)) ||
	!Mrk_Check("fit region", FitRegMrk(work))) {
      return IDX_EERROR; }
    else if (!VecNum(FitRegMrk(work))) {
      ErrPrintR("fatal: no fit region defined\n");
      return FALSE; }
    else if (!Fit_Setup(idx)) {	/* work -> fit(idx) */
      Fit_Changed(idx, 0);
      return IDX_EERROR; }
    Fit_BgConsistent(idx);
    FitTime(fit)= 0;
    if ((status= (Fit_PeakConsistent(VfitsFFit(&vFit,idx)) &&
		 Fit_Exec(idx, FitRegMrk(fit), FitStatReg(fit),
			  FitSuspendBg, FitUseBg, FSRegSetup)))) {
      if (!FitPeakSort(fit, FitPeakSortTyp(fit))) {
	ErrPrintR("fatal: can not sort peaks\n");
	FitTime(fit)= 0;
	status= FALSE; }
      else { FitFitTyp(fit)= FIT_FTFIT; } }
    Fit_PeakWarn(fit);
    status= Fit_Finish(idx) && status;
    Fit_Changed(idx, 0);
    return (status ? IDX_EDONE : IDX_EERROR); }
}
/* ---------------------------------------------------------------------- */
static int Fit_RegFitFinish(num)
     int num;
{
  if (!num) { UF_PrintE("warning: no spectrum fitted\n"); return FALSE; }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Fit_Integrate()
{
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) { return FALSE; } }
  else if (!Idx_Read(1, "integrate region for index(s)")) {
    return FALSE; }

  return Idx_Loop(Fit_IntegrateExec, Fit_IntegrateFinish);
}
/* ---------------------------------------------------------------------- */
static int Fit_IntegrateExec(idx, num)
     int idx;
     int num;
{
  if (!VspcsExists(&vSpc,idx)) { return IDX_ESKIPPED; }
  else {
    Fit_t fit= VfitsFFit(&vFit,idx);
    UF_PrintM("integration of spectrum #%d '%s'\n",
	      idx, PthShort(VspcsFile(&vSpc,idx)));
    FitTime(fit)= 0;
    if (FitTime(fit) && FitFitTyp(fit) == FIT_FTFIT) {
      Fit_Changed(idx, 0); }
    if (!Fit_MrkGet(idx)) { return FALSE; }
    else {
      Spc_t spc= VspcsSpc(&vSpc,idx);

      Mrk_Consistent(FitBgMrk(fit), SpcNum(spc));
      Mrk_Consistent(FitRegMrk(fit), SpcNum(spc));
      if (!Mrk_Check("region", FitRegMrk(VfitsWorkFit(&vFit))) ||
	  !Fit_Setup(idx)) { return FALSE; } }
    if (FitBgTime(VfitsFFit(&vFit,idx))) { Fit_BgConsistent(idx); }
    if (FIIntegrateRegion(fit, VspcsSpc(&vSpc,idx))) {
      SerialIdGet(VfitsFTocSerialId(&vFit,idx));
      SerialIdCp(VfitsFSpcSerialId(&vFit,idx), VspcsSerialId(&vSpc,idx));
      Fit_WorkGetFrom(idx);
      return IDX_EDONE; }
    else { return IDX_ESKIPPED; } }
}
/* ---------------------------------------------------------------------- */
static int Fit_IntegrateFinish(num)
     int num;
{
  if (!num) { UF_PrintE("warning: no spectrum integrated\n"); return FALSE; }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
static int Fit_VCopy(t, f)
     Vfit_t *t;
     Vfit_t *f;
{
  if (!FitCopy(VfitFit(t), VfitFit(f))) {
    ErrPrintR("fatal: can not copy fit data\n");
    Fit_VReset(t);
    return FALSE; }
  VfitScale(t)= VfitScale(f);
  VfitTocIdx(t)= VfitTocIdx(f);
  SerialIdCp(VfitTocSerialId(t), VfitTocSerialId(f));
  SerialIdCp(VfitFitSerialId(t), VfitFitSerialId(f));
  SerialIdCp(VfitSpcSerialId(t), VfitSpcSerialId(f));
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Fit_Delete()
{
  if (UF_NoArgs()) {
    if (Fit_VReset(VfitsWork(&vFit)) &&
	Mrk_Reset(VmrksFitBg(&vMrk)) &&
	Mrk_Reset(VmrksFitReg(&vMrk))) {
      DN_ChangedWorkPeak(); return TRUE; }
    else {
      DN_ChangedWorkPeak();
      ErrPrintR("fatal: can not delete fit\n");
      return FALSE; } }
  else if (!Idx_Read(1, "delete fit for index(s)")) {
    return FALSE; }
  else {
    return Idx_Loop(Fit_DeleteExec, Fit_DeleteFinish); }
}
/* ---------------------------------------------------------------------- */
int Fit_DeleteExec(idx, num)
     int idx;
     int num;
{
  Fit_Backup(idx);

  if (Fit_Reset(idx)) { return IDX_EDONE; }
  else {
    ErrPrintR("fatal: can not delete fit #%d\n", idx); return IDX_EERROR; }
}
/* ---------------------------------------------------------------------- */
static int Fit_DeleteFinish(num)
     int num;
{
  if (num) { return TRUE; }
  else { UF_PrintE("warning: no fit deleted\n"); return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int Fit_MrkGet(idx)
     int idx;
{
  Fit_t f= VfitsWorkFit(&vFit);
  Vmrk_t *b= VmrksFitBg(&vMrk);
  Vmrk_t *r= VmrksFitReg(&vMrk);

  return (Mrk_Get(FitBgMrk(f), b, idx, VfitsInScale(&vFit)) &&
	  Mrk_Get(FitRegMrk(f), r, idx, VfitsInScale(&vFit)));
}
/* ---------------------------------------------------------------------- */
int Fit_MrkPut()
{
  Fit_t f= VfitsWorkFit(&vFit);
  Vmrk_t *b= VmrksFitBg(&vMrk);
  Vmrk_t *r= VmrksFitReg(&vMrk);
  int idx= VactSpcIdx(vAct);

  return (Mrk_Put(b, FitBgMrk(f), idx, VfitsInScale(&vFit)) &&
	  Mrk_Put(r, FitRegMrk(f), idx, VfitsInScale(&vFit)));
}
/* ---------------------------------------------------------------------- */
int Fit_Store()
{
  return (Act_SetDefaultSpc(TRUE) &&
	  Fit_MrkGet(VactSpcIdx(vAct)) &&
	  Fit_VCopy(VfitsStore(&vFit), VfitsWork(&vFit)));
}
/* ---------------------------------------------------------------------- */
int Fit_Restore()
{
  int ret_val;
  ret_val= (Fit_VCopy(VfitsWork(&vFit), VfitsStore(&vFit)) &&
	    Fit_MrkPut());
  DN_ChangedWorkPeak();
  return ret_val;
}
/* ---------------------------------------------------------------------- */
int Fit_Recover()
{
  int ret_val;
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) { return FALSE; } }
  else if (!Idx_Read(1, "recover fit for index(s)")) {
    return FALSE; }

  if ((ret_val= Idx_Loop(Fit_RecoverExec, Fit_RecoverFinish))) {
    if (VidxNum(&vIdx) == 1) { return Fit_WorkGetFrom(VidxIdx(&vIdx,0)); } }
  return ret_val;
}
/* ---------------------------------------------------------------------- */
static int Fit_RecoverExec(idx, num)
     int idx;
     int num;
{
  Vfit_t *vp= VfitsF(&vFit) + idx;
  Vfit_t *bp= VfitsBackup(&vFit) + idx;

  if (SerialIdCmp(VfitFitSerialId(vp), VfitFitSerialId(bp))) {
    if (!FitTime(VfitFit(bp))) {
      return IDX_ESKIPPED; }
    else if (Fit_VCopy(vp, bp)) {
      Fit_Changed(idx, VfitFitSerialId(vp));
      UF_PrintM("fit recovered for #%d\n", idx);
      return IDX_EDONE; }
    return IDX_EERROR; }
  return IDX_EDONE;
}
/* ---------------------------------------------------------------------- */
static int Fit_RecoverFinish(num)
     int num;
{
  if (num) { return TRUE; }
  else { UF_PrintE("warning: no fit recovered\n"); return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Fit_Use()
{
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) { return FALSE; } }
  else if (!Idx_ReadOne("use fitdata of index")) { return FALSE; }

  return (Fit_WorkGetFrom(VidxSingle(&vIdx)) && Fit_MrkPut());
}
/* ---------------------------------------------------------------------- */
int Fit_InScale()
{
  int scale= VfitsInScale(&vFit);
  if (Act_Scale(&scale, "fit input-scale")) {
    VfitsInScale(&vFit)= scale;
    if (!Idx_SetActSpc()) { return FALSE; }
    Fit_Rescale(VfitsWork(&vFit), VidxSingle(&vIdx), scale);
    DN_ChangedWorkPeak(); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Fit_OutScale()
{
  int scale= VfitsOutScale(&vFit);
  if (Act_Scale(&scale, "fit output-scale")) {
    VfitsOutScale(&vFit)= scale; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */

/* ============================ */
/* setup and finish curfit */
/* ============================ */

static int Fit_CurSetup(cp, fp, sp, mp)
     Cur_t cp;
     Fit_t fp;
     Spc_t sp;
     PVec_t mp;
{
  if (fp == NULL || cp == NULL || sp == NULL || mp == NULL) {
    ErrPrintR("fatal internal: illegal NULL-pointer in Fit_CurSetup()\n");
    return FALSE; }
  else {
    CurLambda(cp) = VfitsLambda(&vFit);
    CurMaxIterations(cp) = VfitsMaxIterations(&vFit);
    CurMinLambda(cp) = VfitsMinLambda(&vFit);
    CurMaxLambda(cp) = VfitsMaxLambda(&vFit);
    CurDecLambda(cp) = 0.0;
    CurIncLambda(cp) = 0.0;
    CurPar(cp)= FitPar(fp);
    if (FitBgTime(fp)) {
      return Fit_CopyDataBg(cp, fp, mp, sp,
			    -VfitsOffset(&vFit), VfitsMeasureTyp(&vFit)); }
    else {
      return Fit_CopyData(cp, mp, sp,
			  -VfitsOffset(&vFit), VfitsMeasureTyp(&vFit)); } }
}
/* ---------------------------------------------------------------------- */
static int Fit_CurFinish(cp, fp, fStat)
     Cur_t cp;
     Fit_t fp;
     FitStat_t *fStat;
{
  if (fp == NULL || cp == NULL) {
    ErrPrintR("fatal internal: illegal NULL-pointer in Fit_CurFinish()\n");
    return FALSE; }
  else {
    FitStatTime(fStat)= time(NULL);
    FitStatMeasure(fStat) = CurMeasure(cp);
    FitStatDMeasure(fStat) = CurDMeasure(cp);
    FitStatIterations(fStat)= CurIterations(cp);
    FitStatMaxIterations(fStat)= CurMaxIterations(cp);
    FitStatMeasureTyp(fStat)= VfitsMeasureTyp(&vFit);
    FitStatFreedom(fStat)= CurFreedom(cp);
    FitStatStartLambda(fStat)= CurLambda(cp);
    FitStatMinLambda(fStat)= CurMinLambda(cp);
    FitStatMaxLambda(fStat)= CurMaxLambda(cp);
    return TRUE; }
}
/* ---------------------------------------------------------------------- */

/* =============================== */
/* check validity of fitparameters */
/* =============================== */

static int Fit_CheckValid(fp, idx)
     Fit_t fp;
     int idx;
{
  int i;
  int result= TRUE;
  Par_t pp= FitPar(fp);

  for (i=0; i< ParNum(pp); i++) {
    if (ParSused(pp,i) && ParUserStat(pp,i) == FIT_USUNDEF) {
      ErrPrintR("fatal internal: undefined userStat[%d] in Fit_CheckValid()\n",
		i);
      result= FALSE; } }
  for (i=0; i< FitPeakNum(fp); i++) {
    if (ParSused(pp,FitPosIdx(i))) {
      double xi= FitPPosVal(pp,i) + VfitsOffset(&vFit);
      if (ParSused(pp,FitTrIdx(i)) && FitPTrVal(pp,i) < 0.0) {
	UF_PrintE("warning: negative right tail %f of %f\n", FitPTrVal(pp,i),
		  xi); }
      if (ParSused(pp,FitSwIdx(i)) && FitPSwVal(pp,i) < 0.0) {
	UF_PrintE("warning: negative step width %f of %f\n",
		  FitPSwVal(pp,i), xi); }
      if (FitPWidthVal(pp,i) < 0.0) {
	UF_PrintE("warning: negative width %f of %f\n", FitPWidthVal(pp,i),
		  xi); }
      if (ParSused(pp,FitTlIdx(i)) && FitPTlVal(pp,i) < 0.0) {
	UF_PrintE("warning: negative left tail %f of %f\n", FitPTlVal(pp,i),
		  xi); }

      if ((ParVUserStat(FitPWidth(pp,i)) == FIT_USCAL ||
	   ParVUserStat(FitPWidth(pp,i)) == FIT_USCALUNDEF) &&
	  !CalCheck(CAL_WIDTH, VcalsCal(&vCal, idx))) {
	result = FALSE;
	UF_PrintE("error: no calibration available for width of %f\n", xi); } 
      if ((ParVUserStat(FitPTl(pp,i)) == FIT_USCAL ||
	   ParVUserStat(FitPTl(pp,i)) == FIT_USCALUNDEF) &&
	  !CalCheck(CAL_TL, VcalsCal(&vCal, idx))) {
	result = FALSE;
	UF_PrintE("error: no calibration available for left tail of %f\n",
		  xi); } 
      if ((ParVUserStat(FitPTr(pp,i)) == FIT_USCAL ||
	   ParVUserStat(FitPTr(pp,i)) == FIT_USCALUNDEF) &&
	  !CalCheck(CAL_TR, VcalsCal(&vCal, idx))) {
	result = FALSE;
	UF_PrintE("error: no calibration available for right tail of %f\n",
		  xi); } 
      if ((ParVUserStat(FitPSw(pp,i)) == FIT_USCAL ||
	   ParVUserStat(FitPSw(pp,i)) == FIT_USCALUNDEF) &&
	  !CalCheck(CAL_SW, VcalsCal(&vCal, idx))) {
	result = FALSE;
	UF_PrintE("error: no calibration available for step width of %f\n",
		  xi); }
      if ((ParVUserStat(FitPSh(pp,i)) == FIT_USCAL ||
	   ParVUserStat(FitPSh(pp,i)) == FIT_USCALUNDEF) &&
	  !CalCheck(CAL_SH, VcalsCal(&vCal, idx))) {
	result = FALSE;
	UF_PrintE("error: no calibration available for step height of %f\n",
		  xi); } } }

  return result;
}
/* ---------------------------------------------------------------------- */

/* ============================================= */
/* copy data to be fitted with respect to offset */
/* ============================================= */

static int Fit_CopyData(cp, mp, sp, offset, measureTyp)
     Cur_t cp;
     PVec_t mp;
     Spc_t sp;
     double offset;
     int measureTyp;
{
  CurPntVec_t cdp= CurData(cp);
  int dataPoints;
  if ((dataPoints= MrkRange(mp)) == 0 || (SpcNum(sp)) == 0) {
    ErrPrintR("fatal: no data to copy\n"); return FALSE; }
  else if (!CurAlloc(cp, dataPoints)) {
    ErrPrintR("fatal: can not copy data\n"); return FALSE; }
  else {
    int i, d;
    SpcReal_t *sb= SpcBufReal(SpcSpc(sp));
    SpcReal_t *sw;
    SpcReal_t w_min;
    int o= NINT(offset);
    int incremented= TRUE;

    switch (measureTyp) {
    case FIT_MY:
      sw= SpcBufReal(SpcSpc(sp)); CurMeasureTyp(cp) = CUR_CHI; break;
    case FIT_MDY:
      sw= SpcBufReal(SpcDSpc(sp)); CurMeasureTyp(cp) = CUR_CHI; break;
    case FIT_MPOI:
      sw= SpcBufReal(SpcSpc(sp)); CurMeasureTyp(cp) = CUR_POI; break;
    default:
      ErrPrintR("fatal internal: illegal weight type in Fit_CopyData()\n");
      return FALSE; }

    w_min= sw[NPVecX1(mp,0)-o];

    for (i=0, d=0; i< VecNum(mp); i++) {
      int j;
      int jEnd= NPVecX2(mp,i); 
      for (j= NPVecX1(mp,i); j<= jEnd; j++) {
	CurPntVecX(cdp,d) = (double)j;
	CurPntVecY(cdp,d) = sb[j-o];
	if (sw[j-o] < w_min) { w_min= sw[j-o]; }
	incremented &= (sw[j-o] == sb[j-o]);
	CurPntVecW(cdp,d) = (sw[j-o] == 0.0) ? 1.0 : 1.0 / sw[j-o];
	CurPntVecO(cdp,d)= 0.0;
	d++; } }
    if (incremented) {
      if (w_min < 10.0 && CurMeasureTyp(cp) != CUR_POI) {
	UF_PrintE("warning: a channel contents < 10 counts;\n"
		  "         use of poisson distribution recommended\n"); } }
    else if (w_min < 10.0) {
      UF_PrintE("warning: small deviations < sqrt(10);\n"
		"         this can lead to incorrect fit results\n"); }
    VecNum(cdp)= dataPoints; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Fit_CopyDataBg(cp, fp, mp, sp, offset, measureTyp)
     Cur_t cp;
     Fit_t fp;
     PVec_t mp;
     Spc_t sp;
     double offset;
     int measureTyp;
{
  CurPntVec_t cdp= CurData(cp);
  int dataPoints;
  if ((dataPoints= MrkRange(mp)) == 0 || (SpcNum(sp)) == 0) {
    ErrPrintR("fatal: no data to copy\n"); return FALSE; }
  else if (!CurAlloc(cp, dataPoints)) {
    ErrPrintR("fatal: can not copy data\n"); return FALSE; }
  else {
    int i, d;
    SpcReal_t *sb= SpcBufReal(SpcSpc(sp));
    SpcReal_t *sw;
    SpcReal_t w_min;
    int o= NINT(offset);
    int incremented= TRUE;

    if (!FitBgFunctionSetup(fp, NULL)) {
      ErrPrintR("fatal: can not initialize fit-function\n"); return FALSE; }

    switch (measureTyp) {
    case FIT_MY:
      sw= SpcBufReal(SpcSpc(sp)); CurMeasureTyp(cp) = CUR_CHI; break;
    case FIT_MDY:
      sw= SpcBufReal(SpcDSpc(sp)); CurMeasureTyp(cp) = CUR_CHI; break;
    case FIT_MPOI:
      sw= SpcBufReal(SpcSpc(sp)); CurMeasureTyp(cp) = CUR_POI; break;
    default:
      ErrPrintR("fatal internal: illegal weight type in Fit_CopyDataBg()\n");
      return FALSE; }

    w_min= sw[NPVecX1(mp,0)-o];

    for (i=0, d=0; i< VecNum(mp); i++) {
      int j;
      int jEnd= NPVecX2(mp,i);
      for (j= NPVecX1(mp,i); j<= jEnd; j++) {
	double w= sw[j-o] + FitDBg2Function(fp, (double)j);
	CurPntVecX(cdp,d) = (double)j;
	CurPntVecY(cdp,d) = sb[j-o];
	if (sw[j-o] < w_min) { w_min= sw[j-o]; }
	incremented &= (sw[j-o] == sb[j-o]);
	CurPntVecW(cdp,d) = (w == 0.0) ? 1.0 : 1.0 / w;
	CurPntVecO(cdp,d)= w;
	d++; } }
    if (incremented) {
      if (w_min < 10.0 && CurMeasureTyp(cp) != CUR_POI) {
	UF_PrintE("warning: a channel contents < 10 counts;\n"
		  "         use of poisson distribution recommended!\n"); } }
    else if (w_min < 10.0) {
      UF_PrintE("warning: small deviations < sqrt(10);\n"
		"         this can lead to incorrect fit results\n"); }
    VecNum(cdp)= dataPoints; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Fit_ShiftPar(fp, offset)
     Fit_t fp;
     double offset;
{
  FitBgOffset(fp) = FitBgOffset(fp) + offset;

  { int i;			/* shift bg-marks */
    PVec_t mp= FitBgMrk(fp);
    for (i= 0; i< VecNum(mp); i++) {
      PVecX1(mp,i) += offset; PVecX2(mp,i) += offset; } }

  { int i;			/* shift region-marks */
    PVec_t mp= FitRegMrk(fp);
    for (i= 0; i< VecNum(mp); i++) {
      PVecX1(mp,i) += offset; PVecX2(mp,i) += offset; } }
  
  { int i;			/* shift peak positions */
    Par_t pp= FitPar(fp);
    for (i= 0; i< FitPeakNum(fp); i++) {
      ParV_t *pvp= FitPPos(pp,i);
      ParVVal(pvp) += offset;
      if (ParVMcorr(pvp)) {	/* update correlated peak positions */
	ParVCorr(pvp)[0] += offset * (1.0 + ParVCorr(pvp)[1]);
	ParCorrel(pp,FitPosIdx(i)); } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
