/* $Header: /usr/files/home/Gamma/vs/tv/edit/prg/RCS/VsFit.h,v 1.1 1993/09/17 14:53:34 vs Exp vs $ */

#ifndef _VsFit_h
#define _VsFit_h

#include <tv/SerialId.h>
#include <tv/vsTypes.h>
#include <tv/vsCurFit.h>
#include <tv/vsFit.h>

typedef struct {
  FitRec fit;
  int scale;
  SerialId_t fitSerialId;
  SerialId_t spcSerialId;
  SerialId_t tocSerialId;
  int tocIdx;
} Vfit_t;

#define VfitFit(p)		(&(p)->fit)
#define VfitScale(p)		((p)->scale)
#define VfitFitSerialId(p)	((p)->fitSerialId)
#define VfitSpcSerialId(p)	((p)->spcSerialId)
#define VfitTocSerialId(p)	((p)->tocSerialId)
#define VfitTocIdx(p)		((p)->tocIdx)

typedef struct {
  int num;			/* number */
  Vfit_t *f;			/* spectra specific fits [channel] */
  Vfit_t *backup;		/* spectra specific fit backups */
  Vfit_t work;			/* fit at work [keV/channel] */
  Vfit_t store;			/* stored fit [kev/channel] */
  Vfit_t tmpFit;		/* intermediate fit [channel]*/
  PVecRec bin;			/* bin marks */
  int peakSortTyp;		/* peak sort typ for i/o */
  int measureTyp;		/* measure typ for extremization in curfit */
  int maxIterations;		/* maximal number of iterations */
  double lambda;		/* start value for lambda */
  double minLambda;		/* minimal value for lambda */
  double maxLambda;		/* maximal value for lambda */
  CurRec cur;			/* variables for curfit */
  double offset;		/* actual offset */
  int idx;			/* actual index */
  Cal_t cal;			/* used calibration */
  Fit_t fit;			/* used Fit_t struct for fitting */
				/* parameter parsing */
  int inScale;			/* actual default i/o-scale */
  int outScale;			/* actual default i/o-scale */
  char *parName;		/* name of actual parameter */
  int parTyp;			/* type of actual parameter */
  int opTyp;			/* found operator type */
  int lhsIdx;			/* left hand side index */
  int rhsIdx;			/* right hand side index */
  int numIdx;			/* number of indices */
  int parMode;			/* new parameter mode */
  int parStat;			/* new parameter stat */
  int userStat;			/* new parameter userStat */
  int change;			/* change parameter */
  double coef[2];		/* new correlation coefficients */
  double prec;			/* precision of coef[0] */
  int offsetScale;
  int sign;
} Vfits_t;

#define VfitsNum(fp)		((fp)->num)
#define VfitsF(fp)		((fp)->f)
#define VfitsBackup(fp)		((fp)->backup)
#define VfitsIo(fp)		((fp)->io)
#define VfitsWork(fp)		(&(fp)->work)
#define VfitsStore(fp)		(&(fp)->store)
#define VfitsTmpFit(fp)		(&(fp)->tmpFit)
#define VfitsBin(fp)		(&(fp)->bin)
#define VfitsPeakSortTyp(fp)	((fp)->peakSortTyp)
#define VfitsMeasureTyp(fp)	((fp)->measureTyp)
#define VfitsMaxIterations(fp)	((fp)->maxIterations)
#define VfitsLambda(fp)		((fp)->lambda)
#define VfitsMinLambda(fp)	((fp)->minLambda)
#define VfitsMaxLambda(fp)	((fp)->maxLambda)
#define VfitsCur(fp)		(&(fp)->cur)
#define VfitsPre(fp)		(&(fp)->pre)
#define VfitsOffset(fp)		((fp)->offset)
#define VfitsIdx(fp)		((fp)->idx)
#define VfitsFit(fp)		((fp)->fit)
#define VfitsCal(fp)		((fp)->cal)
#define VfitsInScale(fp)	((fp)->inScale)
#define VfitsOutScale(fp)	((fp)->outScale)
#define VfitsParName(fp)	((fp)->parName)
#define VfitsParTyp(fp)		((fp)->parTyp)
#define VfitsOpTyp(fp)		((fp)->opTyp)
#define VfitsLhsIdx(fp)		((fp)->lhsIdx)
#define VfitsRhsIdx(fp)		((fp)->rhsIdx)
#define VfitsNumIdx(fp)		((fp)->numIdx)
#define VfitsParMode(fp)	((fp)->parMode)
#define VfitsParStat(fp)	((fp)->parStat)
#define VfitsUserStat(fp)	((fp)->userStat)
#define VfitsChange(fp)		((fp)->change)
#define VfitsCoef(fp)		((fp)->coef)
#define VfitsPrec(fp)		((fp)->prec)
#define VfitsOffsetScale(fp)	((fp)->offsetScale)
#define VfitsSign(fp)		((fp)->sign)

#define VfitsWorkFit(fp)	VfitFit(VfitsWork(fp))
#define VfitsWorkScale(fp)	VfitScale(VfitsWork(fp))
#define VfitsWorkFitSerialId(fp)	VfitFitSerialId(VfitsWork(fp))
#define VfitsWorkSpcSerialId(fp)	VfitSpcSerialId(VfitsWork(fp))
#define VfitsWorkTocSerialId(fp)	VfitTocSerialId(VfitsWork(fp))
#define VfitsWorkTocIdx(fp)	VfitTocIdx(VfitsWork(fp))

#define VfitsFFit(fp,i)		VfitFit(VfitsF(fp)+(i))
#define VfitsFScale(fp,i)	VfitScale(VfitsF(fp)+(i))
#define VfitsFFitSerialId(fp,i)	VfitFitSerialId(VfitsF(fp)+(i))
#define VfitsFSpcSerialId(fp,i)	VfitSpcSerialId(VfitsF(fp)+(i))
#define VfitsFTocSerialId(fp,i)	VfitTocSerialId(VfitsF(fp)+(i))
#define VfitsFTocIdx(fp,i)	VfitTocIdx(VfitsF(fp)+(i))

#ifdef _VsFit_c
Vfits_t vFit;
#else
extern Vfits_t vFit;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsFitF.h"

#undef P_

#endif				/* _VsFit_h */
