/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsFitFct.c,v 1.3 1994/12/08 20:45:30 vs Exp vs $ */
/*---------------------------------------------------------------------------*/
#define _VsFitFct_c
				/* library include files*/
#include <tv/vsTypes.h>
#include <tv/vsCurFit.h>
#include <tv/vsFit.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsUserFace.h"

#include "VsFitFct.h"
#include "VsFitFctP.h"

/* ---------------------------------------------------------------------- */
/* =========================== */
/* functions for use in CurFit */
/* =========================== */

int FF_InitCurFct(fp, cp, offset, idx)
     Cur_t cp;
     Fit_t fp;
     double offset;
     int idx;
{
  if (fp == NULL || cp == NULL) {
    ErrPrintR("fatal internal: illegal NULL-pointer in FF_Init()\n");
    return FALSE; }
  VfitsOffset(&vFit)= offset;
  VfitsIdx(&vFit)= idx;
  VfitsFit(&vFit)= fp;
  CurFunctionSetup(cp)= FF_FunctionSetup;
  CurFunctionFinish(cp)= FF_FunctionFinish;
  CurFunction(cp)= FF_Function;
#if 1
  CurDerivationSetup(cp)= FF_DerivationSetup;
  CurDerivationFinish(cp)= FF_DerivationFinish;
  CurDerivation(cp)= FF_Derivation;
#endif				/* 1 */
  CurChangeTry(cp)= FF_ChangeTry;
  CurProtocol(cp)= FF_Protocol;
  return TRUE;
}
/* ------------------------------------------------------------------------- */
static int FF_FunctionSetup(pp)
     Par_t pp;
{
  return FitFunctionSetup(VfitsFit(&vFit), pp);
}
/* ------------------------------------------------------------------------- */
static int FF_FunctionFinish()
{
  return FitFunctionFinish(VfitsFit(&vFit));
}
/* ------------------------------------------------------------------------- */
static int FF_DerivationSetup(pp)
     Par_t pp;
{
  return FitDerivationSetup(VfitsFit(&vFit), pp);
}
/* ------------------------------------------------------------------------- */
static int FF_DerivationFinish()
{
  return FitDerivationFinish(VfitsFit(&vFit));
}
/* ------------------------------------------------------------------------- */
static double FF_Function(x)
     double x;
{
  return FitFunction(VfitsFit(&vFit), x);
}
/* ------------------------------------------------------------------------- */
static int FF_Derivation(x, grad)
     double x;
     double *grad;
{
  return FitDerivation(VfitsFit(&vFit), x, grad);
}
/* ------------------------------------------------------------------------- */
#define CHANGE_TRY(fp,tp,pp,dp,j,rp,chg) \
{\
  switch (ParUserTyp(pp,j)) {\
  case FIT_UTPOS:\
    { double w= ABS(ParVal(pp,j+1));\
      if (ABS(dp) > w) {\
	dp= (dp > 0) ? w : -w; chg= TRUE; } } /* dx > width */\
    { int r; for (r= 0; r< VecNum(rp); r++) {\
      double rle= PVecX1(rp,r);\
      double rge= PVecX2(rp,r);\
      if (rle <= ParVal(pp,j) && ParVal(pp,j) <= rge) {	/* old x in region */\
	if (ParVal(tp,j) < rle) {\
	  dp= (rle - ParVal(pp,j)) * 0.5; chg= TRUE; } /* new x in region*/\
	else if (rge < ParVal(tp,j)) {\
	  dp= (ParVal(pp,j) - rge) * 0.5; chg= TRUE; }\
	break; } } }\
    break;\
  case FIT_UTSW:\
    if (FitPeakTyp(fp) == FIT_PKAE) {\
      double w= 2.0 * ABS(ParVal(pp,j));\
      if (ABS(dp) > w) { /* change widths slowly */\
        dp= 0.0; chg= TRUE; } /* convergence is very bad */\
      else if (ParVal(tp,j) == 0.0) {\
        dp = 1.0; chg= TRUE; } /* widths != 0.0 and 1.0 is normally ok */\
      break; } /* else use width algorithm */\
  case FIT_UTWIDTH: {\
    double w= 2.0 * ABS(ParVal(pp,j));\
    if (ABS(dp) > w) { /* change widths slowly */\
      dp= (dp > 0) ? w : -w; chg= TRUE; }\
    else if (ParVal(tp,j) == 0.0) {\
      dp *= 0.5; chg= TRUE; } } /* widths != 0.0 */\
    break;\
  case FIT_UTTL:\
  case FIT_UTTR:\
    if (FitPeakTyp(fp) == FIT_PKCA && ParVal(tp,j) == 0.0) {\
      dp *= 0.5; chg= TRUE; }\
    break; }\
}
/* ---------------------------------------------------------------------- */
static int FF_ChangeTry(cp, delta)
     Cur_t cp;
     double *delta;
{
  Par_t pp= CurPar(cp);
  Par_t tp= CurTry(cp);
  Fit_t fp= VfitsFit(&vFit);
  int chg, chg_cnt= 0;
  PVec_t rp= FitRegMrk(fp); /* for region boundaries for peak positions */

  do {
    int i;
    chg= FALSE;

    for (i=0; i<ParNumFree(pp); i++) {
      int j= ParIfree(pp,i);
      ParVal(tp,j)= ParVal(pp,j) + delta[i];
      CHANGE_TRY(fp, tp, pp, delta[i], j, rp, chg);
      ParUserStat(tp,j) = FIT_USFIT; }
    for (i=0; i<ParNumCorr(pp); i++) {
      int j= ParIcorr(pp,i);
      double dp_old, dp;
      ParCorrel(tp,j);
      dp_old= dp= ParVal(tp,j) - ParVal(pp,j);
      CHANGE_TRY(fp, tp, pp, dp, j, rp, chg);
      if (chg) { delta[ParCorrIndex(tp,j)] *= dp / dp_old; } }
    if (chg_cnt > 1000) {
      UF_PrintE
	("fatal internal: restricted parameter change algorithmus failed\n");
      return FALSE; }
    else { chg_cnt++; }
  } while (chg);

  { int i;		/* change calibrated parameters */
    for (i=0; i<FitPeakNum(fp); i++) {
      int j= FitWidthIdx(i);
      if (ParSused(pp,j) && ParUserStat(pp,j) == FIT_USCAL) {
	  ParVal(tp,j) = CalS(VcalsCal(&vCal, VfitsIdx(&vFit)),
			      ParVal(tp,j-1) + VfitsOffset(&vFit)); }
      j= FitTlIdx(i);
      if (ParSused(pp,j) && ParUserStat(pp,j) == FIT_USCAL) {
	ParVal(tp,j) = CalTl(VcalsCal(&vCal, VfitsIdx(&vFit)),
			     ParVal(tp,j-1) + VfitsOffset(&vFit)); }
      j= FitTrIdx(i);
      if (ParSused(pp,j) && ParUserStat(pp,j) == FIT_USCAL) {
	ParVal(tp,j) = CalTr(VcalsCal(&vCal, VfitsIdx(&vFit)),
			     ParVal(tp,j-1) + VfitsOffset(&vFit)); }
      j= FitShIdx(i);
      if (ParSused(pp,j) && ParUserStat(pp,j) == FIT_USCAL) {
	ParVal(tp,j) = CalSh(VcalsCal(&vCal, VfitsIdx(&vFit)),
			     ParVal(tp,j-1) + VfitsOffset(&vFit)); }
      j= FitSwIdx(i);
      if (ParSused(pp,j) && ParUserStat(pp,j) == FIT_USCAL) {
	ParVal(tp,j) = CalSw(VcalsCal(&vCal, VfitsIdx(&vFit)),
			     ParVal(tp,j-1) + VfitsOffset(&vFit)); } } }

  return TRUE;
}
#undef CHANGE_TRY
/* ---------------------------------------------------------------------- */
static int FF_Protocol(cp)
     Cur_t cp;
{
  return TRUE;
}
/* ---------------------------------------------------------------------- */
