/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsFitIo.c,v 1.4 1994/12/21 17:13:57 vs Exp vs $ */

# define _VsFitIo_c
				/* library include files */
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsCurFit.h>
#include <tv/vsPath.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsIndex.h"
#include "VsMark.h"
#include "VsPath.h"
#include "VsSearch.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdNotify.h"

#include "VsFitIo.h"
#include "VsFitIoP.h"
/* ---------------------------------------------------------------------- */

#define FIO_FIRST		1
#define FIO_LAST		2
#define FIO_NEXT		3
#define FIO_PREVIOUS		4

/* ---------------------------------------------------------------------- */
int Fio_FileInit(idx, expr)
     int idx;
     char *expr;
{
  char *r;
  Fio_VReset(VfiosF(&vFio)+idx);
  if (VspcsExists(&vSpc,idx) && expr && *expr &&
      (r= PthSubstitute(VspcsFile(&vSpc,idx), expr))) {
    strcpy(VfiosFFile(&vFio,idx), r);
    return TRUE; }
  else {
    ErrPrint("error: can not initialize fit i/o file name\n");
    *VfiosFFile(&vFio,idx)= '\0'; return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Fio_Open()
{
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) {
      return FALSE;
    }
  }
  else if (!Idx_Read(1, "open fitfile for index(s)")) {
    return FALSE;
  }

  return Idx_Loop(Fio_OpenExec, Fio_OpenFinish);
}
/* ---------------------------------------------------------------------- */
static int Fio_OpenExec(idx, num)
     int idx;
     int num;
{
  if (!Fio_Reopen(idx, "r")) {
    ErrPrint("warning: can not open fit file of #%d\n", idx);
    return IDX_ESKIPPED;
  }
  else {
    Fio_PeakReadExec(idx, num);
    Sea_ReadExec(idx, num);
    return IDX_EDONE;
  }
}
/* ---------------------------------------------------------------------- */
static int Fio_OpenFinish(num)
     int num;
{
  if (!num) {
    ErrPrintR("fatal: no fit file opened\n");
    return FALSE;
  }
  else {
    return TRUE;
  }
}
/* ---------------------------------------------------------------------- */
int Fio_Close(idx)
     int idx;
{
  if (idx < 0) {
    return TRUE;
  }
  else if (Fit_DeleteExec(idx, 0) != IDX_EDONE) {
    return FALSE;
  }
  else {
    Vfio_t *vp= VfiosF(&vFio)+idx;

    if (!FioRfp(VfioFio(vp))) {
      Fio_VReset(vp);
      return TRUE;
    }
    else if (!FioClose(VfioFio(vp))) {
      ErrPrintR("fatal: can not close fit i/o file '%s'\n",
		PthShort(VfioFile(vp)));
      return FALSE;
    }
    else {
      Fio_VReset(vp);
      DN_ChangedPeak(idx);
      return TRUE;
    }
  }
}
/* ---------------------------------------------------------------------- */
int Fio_Init(num)
     int num;
{
  if ((VfiosF(&vFio)= (Vfio_t *)Malloc(num * sizeof(Vfio_t)))) {
    int i;
    for (i= 0; i< num; i++) { Fio_VfioInit(VfiosF(&vFio)+i); }

    VfiosNum(&vFio)= num;

    return TRUE; }
  else {
    ErrPrintR("fatal: can not initialize fit i/o\n");
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int Fio_VfioInit(vp)
     Vfio_t *vp;
{
  FioInit(VfioFio(vp));
  Fio_VReset(vp);
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int fioAnswer;
int Fio_No() { fioAnswer= FALSE; return TRUE; }
int Fio_Yes() { fioAnswer= TRUE; return TRUE; }
/* ---------------------------------------------------------------------- */
Vfio_t *Fio_Reopen(idx, mode)
     int idx;
     char *mode;
{
  /*  printf("Fio_Reopen\n");*/
  if (idx >= 0) {
    Vfio_t *vp= VfiosF(&vFio)+idx;
    if (!FioRfp(VfioFio(vp))) {
      SerialIdGet(VfioPeakSerialId(vp));
      SerialIdGet(VfioBinSerialId(vp));
    }
    else if (strchr(mode, '+') && /* must be open for writing */
	     !strchr(RFilMode(FioRfp(VfioFio(vp))), '+')) { /* readonly */
      FioClose(VfioFio(vp));
    }

    if (!FioRfp(VfioFio(vp))) {
      if (strchr(mode, 'w') || /* create file -> create directory */
	  strchr(mode, 'a') ||
	  strchr(mode, 'A') ||
	  (strcmp((const char *)mode, "r+") == 0)) {
	if (!PthCreateRecursive(PthHead(VfioFile(vp)))) {
	  ErrPrint("error:can not mkdir '%s'\n", PthHead(VfioFile(vp)));
	  return NULL;
	}
      }
      while (!FioOpen(VfioFio(vp), VfioFile(vp), mode)) {
	int recErrNo= RecErrNo;
	ErrPrint("error: can not open fit i/o file '%s'\n",
		 PthShort(VfioFile(vp)));
	if (recErrNo == RECLOCKED) {
	  extern Men_t fioAskMen;
	  fioAnswer= FALSE;
	  UF_MenuLoop(&fioAskMen, "recover fit i/o file ? [y/n]");
	  if (fioAnswer) {
	    if (!RecRecover(VfioFile(vp))) {
	      ErrPrint("error: can not recover fit i/o file '%s'\n",
		       PthShort(VfioFile(vp)));
	      return NULL;
	    }
	  }
	  else {
	    return NULL;
	  }
	}
	else {
	  return NULL;
	}
      }
    }
    return vp;
  }
  return NULL;
}
/* ---------------------------------------------------------------------- */
static int Fio_VReset(vp)
     Vfio_t *vp;
{
  FioReset(VfioFio(vp));
  /*
   * Writing fits does not work if next line is uncommented
   */
  /*  *VfioFile(vp)= '\0';*/
  VfioPeakPos(vp)= -1.0;
  VfioBinIdx(vp)= -1;
  VfioFitIdx(vp)= -1;
  VfioIntegralIdx(vp)= -1;
  VfioRecIdx(vp)= -1;
  SerialIdInit(VfioPeakSerialId(vp));
  SerialIdInit(VfioBinSerialId(vp));
  return TRUE;
}
/* ---------------------------------------------------------------------- */
/*
 * Function for command "fit write"
 */
int Fio_Write()
{
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) {
      return FALSE;
    }
  }
  else if (!Idx_Read(1, "write fit for index(s)")) {
    return FALSE;
  }

  return Idx_Loop(Fio_WriteExec, Fio_WriteFinish);
}
/* ---------------------------------------------------------------------- */
static int Fio_WriteExec(idx, num)
     int idx;
     int num;
{
  Fit_t fit= VfitFit(VfitsF(&vFit)+idx);
  PVec_t b= VfitsBin(&vFit);
  PVec_t r= FitRegMrk(fit);

  if (!FitTime(fit) || !VspcsExists(&vSpc,idx)) {
    return IDX_ESKIPPED;
  }
  else if (!Mrk_Get(b, VmrksFitBin(&vMrk), idx, ACT_SUNCALIB)) {
    return IDX_EERROR;
  }
  else {
    Vfio_t *vp;
    Pair_t *bin;
    if (VecNum(b)) {
      if (PVecX1(b,0) < PVecX1(r,0) || PVecX2(r,0) < PVecX2(b,0)) {
	UF_PrintE("warning: region does not contain valid bin marker\n");
	bin= VecP(r);
      }
      else {
	bin= VecP(b);
      }
    }
    else {
      bin= VecP(r);
    }

    if (SerialIdCmp(VfitsFTocSerialId(&vFit,idx),
		    VfitsFFitSerialId(&vFit,idx))) {
      VfitsFTocIdx(&vFit,idx)= -1;
    }

    if (!(vp= Fio_Reopen(idx, "r+")) ||
	!FioWriteFit(VfioFio(vp), &VfitsFTocIdx(&vFit,idx), fit, bin)) {
      ErrPrint("warning: can not write fit of #%d\n", idx);
      return IDX_ESKIPPED;
    }
    else {
      SerialIdCp(VfitsFTocSerialId(&vFit,idx), VfitsFFitSerialId(&vFit,idx));
      switch (FitFitTyp(fit)) {
      case FIT_FTFIT:
	UF_PrintM("fit of #%d written to '%s'\n", idx,
		  PthShort(VfioFile(vp)));
	DN_ChangedPeak(idx);
	/* Close fitfile after writing the fit */
	if (!Fio_Close(idx)) {
	  ErrPrint("warning: can not close fitfile of #%d\n", idx);
	  return IDX_ESKIPPED;
	}
	break;
      case FIT_FTINT:
	UF_PrintM("integral of #%d written to '%s'\n", idx,
		  PthShort(VfioFile(vp)));
	/* Close fitfile after writing the integration */
	if (!Fio_Close(idx)) {
	  ErrPrint("warning: can not close fitfile of #%d\n", idx);
	  return IDX_ESKIPPED;
	}
	break;
      }
      return IDX_EDONE;
    }
  }
}
/* ---------------------------------------------------------------------- */
static int Fio_WriteFinish(num)
     int num;
{
  if (!num) {
    ErrPrintR("fatal: no fit written\n");
    return FALSE;
  }
  else {
    return TRUE;
  }
}
/* ---------------------------------------------------------------------- */
int Fio_PeakRead()
{
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) { return FALSE; } }
  else if (!Idx_Read(1, "read peak list for index(s)")) {
    return FALSE; }

  return Idx_Loop(Fio_PeakReadExec, Fio_PeakReadFinish);
}
/* ---------------------------------------------------------------------- */
static int Fio_PeakReadExec(idx, num)
     int idx;
     int num;
{
  Vfio_t *vp;

  if (!(vp= Fio_Reopen(idx, "r")) ||
      !FioPeakRead(VfioFio(vp), VfitFit(VfitsTmpFit(&vFit)))) {
    ErrPrint("warning: can not read peak list for #%d\n", idx);
    return IDX_ESKIPPED;
  }
  else {
    UF_PrintM("list of %d peaks read for #%d\n",
	      VecNum(FioPea(VfioFio(vp))), idx);
    DN_ChangedPeak(idx);
    return IDX_EDONE;
  }
}
/* ---------------------------------------------------------------------- */
static int Fio_PeakReadFinish(num)
     int num;
{
  if (!num) {
    ErrPrint("error: no peak list read\n");
    return FALSE;
  }
  else {
    return TRUE;
  }
}
/* ---------------------------------------------------------------------- */
int Fio_ReadFit(spcIdx, tocIdx, vp)
     int spcIdx;
     int tocIdx;
     Vfit_t *vp;
{
  if (spcIdx < VfiosNum(&vFio)) {
    Vfit_t *fit= vp ? vp : VfitsF(&vFit)+spcIdx;
    Vfio_t *fio= VfiosF(&vFio)+spcIdx;

    if (tocIdx == VfitTocIdx(fit) &&
	tocIdx > 0 &&
	!SerialIdCmp(VfitTocSerialId(fit), VfitFitSerialId(fit))) {
      return TRUE; }		/* fit already read and not changed */
    else if (FioReadFit(VfioFio(fio), tocIdx, VfitFit(fit))) {
      if (fit == VfitsF(&vFit)+spcIdx) { Fit_Changed(spcIdx, 0); }
      else {
	SerialIdGet(VfitFitSerialId(fit));
	SerialIdCp(VfitSpcSerialId(fit), VspcsSerialId(&vSpc,spcIdx)); }
      VfitTocIdx(fit)= tocIdx;
      SerialIdCp(VfitTocSerialId(fit), VfitFitSerialId(fit));
      return TRUE; }
    else {
      if (fit == VfitsF(&vFit)+spcIdx) { Fit_Reset(spcIdx); }
      else {
	SerialIdGet(VfitFitSerialId(fit));
	SerialIdCp(VfitSpcSerialId(fit),
		   VspcsSerialId(&vSpc,spcIdx)); } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int Fio_ReadIntern(idx, tocIdx)
     int idx;
     int tocIdx;
{
  Vfio_t *vp= VfiosF(&vFio) + idx;

  if (!Fio_ReadFit(idx, tocIdx, NULL)) {
    ErrPrintR("fatal: can not read fit record %d for #%d from '%s'\n",
	      tocIdx, idx, PthShort(VfioFile(vp)));
    return FALSE; }
  else {
    UF_PrintM("fit record %d read for #%d from '%s'\n",
	      tocIdx, idx, PthShort(VfioFile(vp)));
    return (Fit_WorkGetFrom(idx) && Fit_MrkPut()); }
}
/* ---------------------------------------------------------------------- */
int Fio_ReadRecIndex()
{
  Vfio_t *vp;
  if (Act_SetDefaultSpc(TRUE) &&
      (vp= Fio_Reopen(VactSpcIdx(vAct), "r"))) {
    int i;
    int num= VecNum(FioToc(VfioFio(vp)));
    if (UF_IntRead(FALSE, &i, "fit record index [0,%d]", num-1)) {
      if (i < 0 || num <= i) {
	ErrPrintR("fatal: illegal record index %d not in [0,%d]\n", i, num-1);
	return FALSE; }
      VfioRecIdx(vp)= i;
      return Fio_ReadIntern(VactSpcIdx(vAct), i); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Fio_ReadBin(spcIdx, binIdx, fit)
     int spcIdx;
     int binIdx;
     Vfit_t *fit;
{
  if (spcIdx < VfiosNum(&vFio)) {
    Vfio_t *fio= VfiosF(&vFio)+spcIdx;
    int tocIdx= BinPTocIdx(FioBin(VfioFio(fio)),binIdx);
    return Fio_ReadFit(spcIdx, tocIdx, fit); }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Fio_ReadBinIndex()
{
  Vfio_t *vp;
  if (Act_SetDefaultSpc(TRUE) &&
      (vp= Fio_Reopen(VactSpcIdx(vAct), "r"))) {
    int i;
    BinVec_t bp= FioBin(VfioFio(vp));
    int num= VecNum(bp);
    if (UF_IntRead(FALSE, &i, "bin index [0,%d]", num-1)) {
      if (i < 0 || num <= i) {
	ErrPrintR("fatal: illegal bin index %d not in [0,%d]\n", i, num-1);
	return FALSE; }
      else {
	VfioBinIdx(vp)= i;
	i= BinPTocIdx(bp,i);
	VfioRecIdx(vp)= i;
	return Fio_ReadIntern(VactSpcIdx(vAct), i); } } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Fio_ReadBinPos()
{
  Vfio_t *vp;
  if (Act_SetDefaultSpc(TRUE) &&
      (vp= Fio_Reopen(VactSpcIdx(vAct), "r"))) {
    double pos;
    Cal_t cal= VcalsCal(&vCal,VactSpcIdx(vAct));

    if (Mrk_EnterSingleV(VfitsOutScale(&vFit), cal, &pos, "bin position")) {
      int i;
      BinVec_t bp= FioBin(VfioFio(vp));
      PVec_t mp= FioBinMrk(VfioFio(vp));
      int num= VecNum(mp);
      double chn= (VactCalibrated(VfitsOutScale(&vFit)) ?
		   CalC(cal, pos) : pos);
      for (i= 0; i< num; i++) {
	if (PVecX1(mp,i) <= chn && chn <= PVecX2(mp,i)) {
	  VfioBinIdx(vp)= i;
	  i= BinPTocIdx(bp,i);
	  VfioRecIdx(vp)= i;
	  return Fio_ReadIntern(VactSpcIdx(vAct), i); } }

      ErrPrintR("fatal: no bin found at %.1f channels for #%d\n",
		chn, VactSpcIdx(vAct)); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int Fio_ReadBinP(incTyp)
     int incTyp;
{
  Vfio_t *vp;
  if (Act_SetDefaultSpc(TRUE) &&
      (vp= Fio_Reopen(VactSpcIdx(vAct), "r"))) {
    BinVec_t bp= FioBin(VfioFio(vp));
    int num= VecNum(bp);
    int i;
    switch (incTyp) {
    case FIO_FIRST: i= 0; break;
    case FIO_LAST: i= num-1; break;
    case FIO_NEXT: i= VfioBinIdx(vp)+1; break;
    case FIO_PREVIOUS: i= VfioBinIdx(vp)-1; break; }

    if (i < 0 || num <= i) {
      UF_PrintE("error: no further bin found\n");
      return FALSE; }
    else {
      VfioBinIdx(vp)= i;
      i= BinPTocIdx(bp,i);
      VfioRecIdx(vp)= i;
      return Fio_ReadIntern(VactSpcIdx(vAct), i); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Fio_ReadBinFirst()
{
  return Fio_ReadBinP(FIO_FIRST);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadBinLast()
{
  return Fio_ReadBinP(FIO_LAST);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadBinNext()
{
  return Fio_ReadBinP(FIO_NEXT);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadBinPrevious()
{
  return Fio_ReadBinP(FIO_PREVIOUS);
}
/* ---------------------------------------------------------------------- */
static int Fio_ReadToc(typ, incTyp)
     int typ;
     int incTyp;
{
  Vfio_t *vp;
  if (Act_SetDefaultSpc(TRUE) &&
      (vp= Fio_Reopen(VactSpcIdx(vAct), "r"))) {
    FioTocVec_t tp= FioToc(VfioFio(vp));
    int num= VecNum(FioToc(VfioFio(vp)));
    int start;
    int inc;
    int i;

    switch (typ) {
    case FIT_FTFIT: start= VfioFitIdx(vp); break;
    case FIT_FTINT: start= VfioIntegralIdx(vp); break;
    case FIT_FTUNDEF: start= VfioRecIdx(vp); break; }

    switch (incTyp) {
    case FIO_FIRST: start= -1; inc= 1; break;
    case FIO_LAST: start= num; inc= -1; break;
    case FIO_NEXT: inc= 1; break;
    case FIO_PREVIOUS: inc= -1; break; }

    for (i= start+inc; 0 <= i && i < num; i += inc) {
      if (FioTocPTyp(tp,i) == typ || typ == FIT_FTUNDEF) { break; } }
    if (i < 0 || num <= i) {
      UF_PrintE("error: no further record found\n");
      return FALSE; }
    else {
      switch (typ) {
      case FIT_FTFIT: VfioFitIdx(vp)= i; break;
      case FIT_FTINT: VfioIntegralIdx(vp)= i; break; }
      VfioRecIdx(vp)= i;
      return Fio_ReadIntern(VactSpcIdx(vAct), i); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Fio_ReadFitFirst()
{
  return Fio_ReadToc(FIT_FTFIT, FIO_FIRST);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadFitLast()
{
  return Fio_ReadToc(FIT_FTFIT, FIO_LAST);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadFitNext()
{
  return Fio_ReadToc(FIT_FTFIT, FIO_NEXT);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadFitPrevious()
{
  return Fio_ReadToc(FIT_FTFIT, FIO_PREVIOUS);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadIntFirst()
{
  return Fio_ReadToc(FIT_FTINT, FIO_FIRST);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadIntLast()
{
  return Fio_ReadToc(FIT_FTINT, FIO_LAST);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadIntNext()
{
  return Fio_ReadToc(FIT_FTINT, FIO_NEXT);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadIntPrevious()
{
  return Fio_ReadToc(FIT_FTINT, FIO_PREVIOUS);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadRecFirst()
{
  return Fio_ReadToc(FIT_FTUNDEF, FIO_FIRST);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadRecLast()
{
  return Fio_ReadToc(FIT_FTUNDEF, FIO_LAST);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadRecNext()
{
  return Fio_ReadToc(FIT_FTUNDEF, FIO_NEXT);
}
/* ---------------------------------------------------------------------- */
int Fio_ReadRecPrevious()
{
  return Fio_ReadToc(FIT_FTUNDEF, FIO_PREVIOUS);
}
/* ---------------------------------------------------------------------- */
