/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsFitIo.h,v 1.2 1994/12/08 20:45:32 vs Exp vs $ */

#ifndef _VsFitIo_h
#define _VsFitIo_h

#include <tv/SerialId.h>
#include <tv/vsTypes.h>
#include <tv/vsFitIo.h>

typedef struct {
  FioRec fio;			/* fit i/o-struct */
  char file[MAXPATHLEN];	/* file name */
  double peakPos;		/* position of last peak */
  int binIdx;			/* index of last bin */
  int fitIdx;			/* index of last fit record */
  int integralIdx;		/* index of last integral record */
  int recIdx;			/* index of last record */
  SerialId_t peakSerialId;	/* change of a peak */
  SerialId_t binSerialId;	/* change of a bin */
} Vfio_t;

#define VfioFio(p)		(&(p)->fio)
#define VfioFile(p)		((p)->file)
#define VfioPeakPos(p)		((p)->peakPos)
#define VfioBinIdx(p)		((p)->binIdx)
#define VfioFitIdx(p)		((p)->fitIdx)
#define VfioIntegralIdx(p)	((p)->integralIdx)
#define VfioRecIdx(p)		((p)->recIdx)
#define VfioPeakSerialId(p)	((p)->peakSerialId)
#define VfioBinSerialId(p)	((p)->binSerialId)

typedef struct {
  int num;
  Vfio_t *f;			/* spectra specific fit I/O */
} Vfios_t;

#define VfiosNum(p)		((p)->num)
#define VfiosF(p)		((p)->f)

#define VfiosFFio(p,i)		VfioFio(VfiosF(p)+i)
#define VfiosFFile(p,i)		VfioFile(VfiosF(p)+i)
#define VfiosFPeakPos(p,i)	VfioPeakPos(VfiosF(p)+i)
#define VfiosFBinIdx(p,i)	VfioBinIdx(VfiosF(p)+i)
#define VfiosFFitIdx(p,i)	VfioFitIdx(VfiosF(p)+i)
#define VfiosFIntegralIdx(p,i)	VfioIntegralIdx(VfiosF(p)+i)
#define VfiosFRecIdx(p,i)	VfioRecIdx(VfiosF(p)+i)
#define VfiosFPeakSerialId(p)	VfioPeakSerialId(VfiosF(p)+i)
#define VfiosFBinSerialId(p)	VfioBinSerialId(VfiosF(p)+i)

#ifdef _VsFitIo_c
Vfios_t vFio;
#else
extern Vfios_t vFio;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsFitIoF.h"

#undef P_

#endif				/* _VsFitIo_h */
