/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsFitPar.c,v 1.5 1994/12/08 20:45:34 vs Exp vs $ */

#define _VsFitPar_c

				/* library include files */
#include <tv/vsTypes.h>
#include <tv/vsUserFace.h>
#include <tv/vsCurFit.h>
#include <tv/vsTools.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsMark.h"
#include "VsUserFace.h"

#include "VdNotify.h"

#include "VsFitPar.h"
#include "VsFitParP.h"
/* ---------------------------------------------------------------------- */
#define FP_CUNDEF	1
#define FP_CSTAT	2
#define FP_CPARAM	3

#define FP_OUNDEF	1
#define FP_OSPACED	2
#define FP_OEQUAL	3
#define FP_OFREE	4
#define FP_OHOLD	5
#define FP_OCAL		6
#define FP_OSET		7
#define FP_ONONE	8
#define FP_ODEGREE	9
#define FP_OEXPNUM	10
#define FP_OCORR	11

/* ---------------------------------------------------------------------- */
static int FP_Init(parName, parTyp, cal, numIdx)
     char *parName;
     int parTyp;
     Cal_t cal;
     int numIdx;
{
  Act_SetDefaultSpc(FALSE);
  VfitsParName(&vFit)	= parName;
  VfitsParTyp(&vFit)	= parTyp;
  VfitsOpTyp(&vFit)	= FP_OUNDEF;
  VfitsCal(&vFit)	= cal;
  VfitsLhsIdx(&vFit)	= -1;
  VfitsRhsIdx(&vFit)	= -1;
  VfitsNumIdx(&vFit)	= numIdx;
  VfitsParMode(&vFit)	= PAR_MUNDEF;
  VfitsParStat(&vFit)	= PAR_SUNDEF;
  VfitsUserStat(&vFit)	= FIT_USUNDEF;
  VfitsChange(&vFit)	= FP_CUNDEF;
  VfitsSign(&vFit)	= 1;
  VfitsCoef(&vFit)[0]	= 0.0;
  VfitsCoef(&vFit)[1]	= 0.0;
  VfitsPrec(&vFit)	= 0.0;
  Fit_WorkSetup(VactSpcIdx(vAct));
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_Position()
{
  extern Men_t parPosMen;
  extern char *parPosition;
  int ret_val;

  ret_val= (FP_Init(parPosition, FIT_UTPOS, VcalsCal(&vCal, VactSpcIdx(vAct)),
		    FitPeakNum(VfitsWorkFit(&vFit))) &&
	    FP_Operate(&parPosMen) != FP_OUNDEF &&
	    FP_SetPeak(FIT_UTPOS));
  DN_ChangedWorkPeak();
  return ret_val;
}
/* ---------------------------------------------------------------------- */
int FP_Width()
{
  extern Men_t parWidthMen;
  extern char *parWidth;

  return (FP_Init(parWidth, FIT_UTWIDTH, VcalsCal(&vCal, VactSpcIdx(vAct)),
		  FitPeakNum(VfitsWorkFit(&vFit))) &&
	  FP_Operate(&parWidthMen) != FP_OUNDEF &&
	  FP_SetPeak(FIT_UTWIDTH));
}
/* ---------------------------------------------------------------------- */
int FP_Volume()
{
  extern Men_t parVolumeMen;
  extern char *parVolume;

  return (FP_Init(parVolume, FIT_UTVOL, NULL,
		  FitPeakNum(VfitsWorkFit(&vFit))) &&
	  FP_Operate(&parVolumeMen) != FP_OUNDEF &&
	  FP_SetPeak(FIT_UTVOL));
}
/* ---------------------------------------------------------------------- */
int FP_Tl()
{
  extern Men_t parStepTailMen;
  extern char *parTl;

  return (FP_Init(parTl, FIT_UTTL, NULL, FitPeakNum(VfitsWorkFit(&vFit))) &&
	  FP_Operate(&parStepTailMen) != FP_OUNDEF &&
	  FP_SetPeak(FIT_UTTL));
}
/* ---------------------------------------------------------------------- */
int FP_Tr()
{
  extern Men_t parStepTailMen;
  extern char *parTr;

  return (FP_Init(parTr, FIT_UTTR, NULL, FitPeakNum(VfitsWorkFit(&vFit))) &&
	  FP_Operate(&parStepTailMen) != FP_OUNDEF &&
	  FP_SetPeak(FIT_UTTR));
}
/* ---------------------------------------------------------------------- */
int FP_Sh()
{
  extern Men_t parStepTailMen;
  extern char *parSh;

  return (FP_Init(parSh, FIT_UTSH, NULL, FitPeakNum(VfitsWorkFit(&vFit))) &&
	  FP_Operate(&parStepTailMen) != FP_OUNDEF  &&
	  FP_SetPeak(FIT_UTSH));
}
/* ---------------------------------------------------------------------- */
int FP_Sw()
{
  extern Men_t parStepTailMen;
  extern char *parSw;

  return (FP_Init(parSw, FIT_UTSW, NULL, FitPeakNum(VfitsWorkFit(&vFit))) &&
	  FP_Operate(&parStepTailMen) != FP_OUNDEF &&
	  FP_SetPeak(FIT_UTSW));
}
/* ---------------------------------------------------------------------- */
int FP_Bg()
{
  extern Men_t parBgMen;
  extern char *parBg;

  return (FP_Init(parBg, FIT_UTBGPOL, NULL, FIT_BGGRD) &&
	  FP_Operate(&parBgMen) != FP_OUNDEF &&
	  FP_SetBg(FIT_UTBGPOL));
}
/* ---------------------------------------------------------------------- */
int FP_BgExp()
{
  extern Men_t parBgMen;
  extern char *parBgExp;

  return (FP_Init(parBgExp, FIT_UTBGEXP, NULL, FIT_BGMEXP) &&
	  FP_Operate(&parBgMen) != FP_OUNDEF &&
	  FP_SetBg(FIT_UTBGEXP));
}
/* ---------------------------------------------------------------------- */
int FP_BgFac()
{
  extern Men_t parBgMen;
  extern char *parBgFac;

  return (FP_Init(parBgFac, FIT_UTBGFAC, NULL, FIT_BGMEXP) &&
	  FP_Operate(&parBgMen) != FP_OUNDEF &&
	  FP_SetBg(FIT_UTBGFAC));
}
/* ---------------------------------------------------------------------- */
static int FP_Index(idx)
     int *idx;
{
  int idx_min, idx_max;

  idx_min= 0; idx_max= VfitsNumIdx(&vFit);
    
  if (VfitsNumIdx(&vFit) > 0 && UF_Unexpected() &&
      UF_IntRead(TRUE, idx, "%s parameter index [%d,%d]",
		VfitsParName(&vFit), idx_min, idx_max)) {
    if (*idx < idx_min || idx_max <= *idx) {
      ErrPrintR("fatal: index %d out of range [%d,%d]\n",
		*idx, idx_min, idx_max-1);
      return FALSE; } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int FP_Operate(mp)
     Men_t *mp;
{
  char pmt[IOBUFLEN];
				/* get index if indexed variable */
  if (!FP_Index(&VfitsLhsIdx(&vFit))) { return FP_OUNDEF; }
  else if (VfitsLhsIdx(&vFit) >= 0) {
    sprintf(pmt, "%s[%d]", VfitsParName(&vFit), VfitsLhsIdx(&vFit)); }
  else { sprintf(pmt, "%s", VfitsParName(&vFit)); }

  if (VfitsParTyp(&vFit) == FIT_UTBGPOL && VfitsLhsIdx(&vFit) < 0) {
    extern Men_t parBgAllMen;
    UF_MenuLoop(&parBgAllMen, pmt); } /* get change operation */
  else if ((VfitsParTyp(&vFit) == FIT_UTBGFAC ||
	    VfitsParTyp(&vFit) == FIT_UTBGEXP)
	   && VfitsLhsIdx(&vFit) < 0) {
    extern Men_t parBgExpAllMen;
    UF_MenuLoop(&parBgExpAllMen, pmt); } /* get change operation */
  else {
    UF_MenuLoop(mp, pmt); }		/* get change operation */

  return VfitsOpTyp(&vFit);
}
/* ---------------------------------------------------------------------- */
int FP_Free()
{
  VfitsOpTyp(&vFit)= FP_OFREE;
  VfitsParStat(&vFit)= PAR_SUSED;
  VfitsUserStat(&vFit)= FIT_USUSER;
    VfitsParMode(&vFit)= PAR_MFREE;
  if (UF_NoArgs()) {
    VfitsChange(&vFit)= FP_CSTAT; return TRUE; }
  else if (FP_Expression()) {
    VfitsParMode(&vFit)= PAR_MFREE;
    return TRUE; }
  else { VfitsOpTyp(&vFit)= FP_OUNDEF; return FALSE; }
}
/* ---------------------------------------------------------------------- */
int FP_Hold()
{
  VfitsOpTyp(&vFit)= FP_OHOLD;
  VfitsParStat(&vFit)= PAR_SUSED;
  VfitsParMode(&vFit)= PAR_MHOLD;
  if (UF_NoArgs()) {
    VfitsChange(&vFit)= FP_CSTAT; return TRUE; }
  else if (FP_Expression()) {
    VfitsUserStat(&vFit)= FIT_USUSER;
    return TRUE; }
  else { VfitsOpTyp(&vFit)= FP_OUNDEF; return FALSE; }
}
/* ---------------------------------------------------------------------- */
int FP_Calibrated()
{
  VfitsOpTyp(&vFit)= FP_OCAL;
  VfitsParMode(&vFit)= PAR_MHOLD;
  VfitsParStat(&vFit)= PAR_SUSED;
  VfitsUserStat(&vFit)= FIT_USCALUNDEF;
  VfitsChange(&vFit)= FP_CSTAT;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_None()
{
  VfitsOpTyp(&vFit)= FP_ONONE;
  VfitsParMode(&vFit)= PAR_MHOLD;
  VfitsParStat(&vFit)= PAR_SSUSP;
  VfitsUserStat(&vFit)= FIT_USNONE;
  VfitsChange(&vFit)= FP_CSTAT;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_Set()
{
  VfitsOpTyp(&vFit)= FP_OSET;
  VfitsParStat(&vFit)= PAR_SUSED;
  VfitsUserStat(&vFit)= FIT_USUSER;

  if (FP_Expression()) { return TRUE; }
  else { VfitsOpTyp(&vFit)= FP_OUNDEF; return FALSE; }
}
/* ---------------------------------------------------------------------- */
int FP_Corr()
{
  VfitsOpTyp(&vFit)= FP_OCORR;
  VfitsParStat(&vFit)= PAR_SUSED;
  VfitsUserStat(&vFit)= FIT_USUSER;
  VfitsParMode(&vFit)= PAR_MCORR;

  if (FP_Expression()) { return TRUE; }
  else { VfitsOpTyp(&vFit)= FP_OUNDEF; return FALSE; }
}
/* ---------------------------------------------------------------------- */
int FP_Equal()
{
  VfitsOpTyp(&vFit)= FP_OEQUAL;
  VfitsParStat(&vFit)= PAR_SUSED;
  VfitsUserStat(&vFit)= FIT_USUSER;
  VfitsChange(&vFit)= FP_CPARAM;
  VfitsParMode(&vFit)= PAR_MCORR;
  if (UF_NoArgs()) {
    if (!FitPeakNum(VfitsWorkFit(&vFit))) { VfitsRhsIdx(&vFit)= 0; }
    else if (!FitMaxPeakIdx(VfitsWorkFit(&vFit), &VfitsRhsIdx(&vFit))) {
      ErrPrintR("fatal: can not determine largest peak\n");
      VfitsOpTyp(&vFit)= FP_OUNDEF;
      return FALSE; }
    VfitsCoef(&vFit)[0]= 0.0; VfitsCoef(&vFit)[1]= 1.0;
    return TRUE; }
  else if (FP_Expression()) {
    return TRUE; }
  else { VfitsOpTyp(&vFit)= FP_OUNDEF; return FALSE; }
}
/* ---------------------------------------------------------------------- */
int FP_Spaced()
{
  VfitsOpTyp(&vFit)= FP_OSPACED;
  VfitsParStat(&vFit)= PAR_SUSED;
  VfitsUserStat(&vFit)= FIT_USUSER;
  if (UF_NoArgs()) {
    if (!FitMaxPeakIdx(VfitsWorkFit(&vFit), &VfitsLhsIdx(&vFit))) {
      ErrPrintR("fatal: can not determine largest peak\n");
      VfitsOpTyp(&vFit)= FP_OUNDEF;
      return FALSE; } }
  else if (!FP_Expression()) { VfitsOpTyp(&vFit)= FP_OUNDEF; return FALSE; }
  else if (VfitsCoef(&vFit)[0] != 0.0 || VfitsCoef(&vFit)[1] != 1.0) {
    ErrPrintR("fatal: illegal argument specified\n");
    VfitsOpTyp(&vFit)= FP_OUNDEF;
    return FALSE; }
  else if (VfitsLhsIdx(&vFit) == VfitsRhsIdx(&vFit)) {
    ErrPrintR("fatal: no condition specified\n");
    VfitsOpTyp(&vFit)= FP_OUNDEF;
    return FALSE; }
  VfitsParMode(&vFit)= PAR_MCORR;
  VfitsChange(&vFit)= FP_CPARAM;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int FP_ParGet(pp, idx, pvp)
     Par_t pp;
     int idx;
     ParV_t *pvp;
{
  if (!ParGet(pp, idx, pvp)) {
    ErrPrintR("fatal: can not get old parameters\n");
    VfitsOpTyp(&vFit)= FP_OUNDEF;
    return FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int FP_ParSet(pp, idx, pvp, check_corr)
     Par_t pp;
     int idx;
     ParV_t *pvp;
     int check_corr;
{
  if (!ParSet(pp, idx, pvp, check_corr)) {
    ErrPrintR("fatal: can not set new parameters\n");
    VfitsOpTyp(&vFit)= FP_OUNDEF;
    return FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_BgGrad()
{
  Fit_t fp= VfitsWorkFit(&vFit);
  ParV_t pv;
  int d;

  ParVInit(&pv);
  ParVUserStat(&pv)	= FIT_USUNDEF;
  ParVStat(&pv)		= PAR_SUSED;
  ParVUserTyp(&pv)	= FIT_UTBGPOL;
  ParVMode(&pv)		= PAR_MFREE;

  VfitsOpTyp(&vFit)= FP_ODEGREE; /* nothing further to be done */
  VfitsParMode(&vFit)= PAR_MUNDEF;
  VfitsChange(&vFit)= FP_CSTAT;

  if (UF_IntRead(FALSE, &d, "degree of bg-polynom [%d]", FitBgGrad(fp)) != 1) {
    return FALSE; }
  else if (++d > FIT_BGGRD) {
    ErrPrintR("fatal: maximal degree is %d\n", FIT_BGGRD);
    return FALSE; }
  else if (FitBgGrad(fp) != d) {
    Par_t pp= FitPar(fp);
    int i;

    FitTime(fp)= 0;
    FitBgTime(fp)= 0;
    for (i= FitBgGrad(fp); i< d; i++) {
      if (!FP_ParSet(pp, i, &pv, FALSE)) { return FALSE; } }
    FitBgGrad(fp)= d;
    FitSetupBg(fp); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_BgExpNum()
{
  Fit_t fp= VfitsWorkFit(&vFit);
  ParV_t pv;
  int d;

  ParVInit(&pv);
  ParVUserStat(&pv)	= FIT_USUNDEF;
  ParVStat(&pv)		= PAR_SUSED;
  ParVMode(&pv)		= PAR_MFREE;

  VfitsOpTyp(&vFit)= FP_OEXPNUM; /* nothing further to be done */
  VfitsParMode(&vFit)= PAR_MUNDEF;
  VfitsChange(&vFit)= FP_CSTAT;

  if (UF_IntRead(FALSE, &d, "number of bg-exponentials [%d]",
		 FitBgExpNum(fp)) != 1) {
    return FALSE; }
  else if (d > FIT_BGMEXP) {
    ErrPrintR("fatal: maximal number of bg-exponentials is %d\n", FIT_BGMEXP);
    return FALSE; }
  else if (FitBgExpNum(fp) != d) {
    Par_t pp= FitPar(fp);
    int i, p;

    FitTime(fp)= 0;
    FitBgTime(fp)= 0;
    for (i= FitBgExpNum(fp), p= FIT_BGGRD + i * 2; i< d; i++) {
      ParVUserTyp(&pv)	= FIT_UTBGFAC;
      if (!FP_ParSet(pp, p, &pv, FALSE)) { return FALSE; }
      p++;
      ParVUserTyp(&pv)	= FIT_UTBGEXP;
      if (!FP_ParSet(pp, p, &pv, FALSE)) { return FALSE; }
      p++; }
    FitBgExpNum(fp)= d;
    FitSetupBg(fp); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_BgFunctionActPol()
{
  if (FitBgTyp(VfitsWorkFit(&vFit)) == FIT_BGPOL) { return TRUE; }
  else {
    ErrPrintR("fatal internal: can not change background function\n");
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int FP_FunctionActCA()
{
  if (FitPeakTyp(VfitsWorkFit(&vFit)) == FIT_PKCA) { return TRUE; }
  else if (!FitFunctionChange(VfitsWorkFit(&vFit), FIT_PKCA)) {
    ErrPrintR("fatal internal: can not change fit function\n");
    return FALSE; }
  else {
    SerialIdGet(VfitsWorkFitSerialId(&vFit));
    FitTime(VfitsWorkFit(&vFit))= 0;
    DN_ChangedWorkPeak(); return TRUE; }
}
/* ---------------------------------------------------------------------- */
int FP_BgFunctionDefPol()
{
  UF_PrintM("definition of background function with\n");
  UF_PrintM("polynom and exponentials\n");
  UF_PrintM("  BG(x)= SUM(n=0..degree, Bn * (x-x0)**n)\n");
  UF_PrintM("         + SUM(i= 0..expnumber, FACi * exp(-(x-x0) * EXPi))\n");
  UF_PrintM("    Bn   :  background coefficient (parameter)\n");
  UF_PrintM("    x0   :  offset for numerical optimization during fit\n");
  UF_PrintM("    FACi :  factor of exponential term\n");
  UF_PrintM("    EXPi :  scaling of exponential term\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_FunctionDefCA()
{
  UF_PrintM("definition of fit function with\n");
  UF_PrintM("continuous exponential tail and arctan-step:\n");
  UF_PrintM("  F(x) =  BG(x) + SUM(i=0..peaknumber, PEAKi(x))\n");
  UF_PrintM("  BG(x)   : background function\n");
  UF_PrintM("peak function of i-th peak\n");
  UF_PrintM("  PEAKi(x)= Vi / NORMi * (GAUSMi(x-Pi) + STEPi(x-Pi))\n");
  UF_PrintM("    Pi    :  position of i-th peak (parameter)\n");
  UF_PrintM("    Vi    :  volume of i-th peak (parameter)\n");
  UF_PrintM("    NORMi :  numeric INTEGRAL(GAUSMi)\n");
  UF_PrintM("modified gauss function of i-th peak\n");
  UF_PrintM
    ("               / exp(SLi / Si**2 * (dx + SLi/2)   for dx<-SLi\n");
  UF_PrintM
    ("  GAUSMi(dx)= {  exp(-dx**2 / (2 * Si**2))        for -SLi<dx<SRi\n");
  UF_PrintM
    ("               \\ exp(-SRi / Si**2 * (dx - SRi/2) for SRi<dx\n");
  UF_PrintM("    Si    :  sigma of gaussian part of i-th peak (parameter)\n");
  UF_PrintM("    SLi   :  TLi * Si**ELi\n");
  UF_PrintM("    SRi   :  TRi * Si**ERi\n");
  UF_PrintM("    TLi   :  left tail of i-th peak (parameter)\n");
  UF_PrintM("    TRi   :  right tail of i-th peak (parameter)\n");
  UF_PrintM("    ELi   :  exponent of sigma-weight of TLi [0..2]\n");
  UF_PrintM("    ERi   :  exponent of sigma-weight of TRi [0..2]\n");
  UF_PrintM("step function of i-th peak\n");
  UF_PrintM("  STEPi(dx)= SHi * (pi/2 + arctan(SWi * dx / (Si * sqrt(2))))\n");
  UF_PrintM("    SHi   :  step height of i-th peak (parameter)\n");
  UF_PrintM("    SWi   :  step width of i-th peak (parameter)\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_FunctionActAE()
{
  if (FitPeakTyp(VfitsWorkFit(&vFit)) == FIT_PKAE) { return TRUE; }
  else if (!FitFunctionChange(VfitsWorkFit(&vFit), FIT_PKAE)) {
    ErrPrintR("fatal internal: can not change fit function\n");
    return FALSE; }
  else {
    SerialIdGet(VfitsWorkFitSerialId(&vFit));
    FitTime(VfitsWorkFit(&vFit))= 0;
    DN_ChangedWorkPeak(); return TRUE; }
}
/* ---------------------------------------------------------------------- */
int FP_FunctionDefAE()
{
  UF_PrintM
    ("definition of fit function with additive tail and erf-step:\n");
  UF_PrintM("  F(x) =  BG(x) + SUM(i=0..peaknumber, PEAKi(x))\n");
  UF_PrintM("  BG(x)   : background function\n");
  UF_PrintM("peak function of i-th peak\n");
  UF_PrintM("  PEAKi(x)= Vi / NORMi\n");
  UF_PrintM("            * (  (1 + TAILi(x-Pi)) * GAUSSi(x-Pi)))\n");
  UF_PrintM("               + STEPi(x-Pi)))  )\n");
  UF_PrintM("    Pi    :  position of i-th peak (parameter)\n");
  UF_PrintM("    Vi    :  volume of i-th peak (parameter)\n");
  UF_PrintM("    NORMi :  Si * (SQRT(2 * PI) + TLi + TRi)\n");
  UF_PrintM("gauss function of i-th peak\n");
  UF_PrintM("  GAUSSi(dx)= exp(-dx**2 / (2 * Si**2))\n");
  UF_PrintM("    Si    :  sigma of gaussian part of i-th peak (parameter)\n");
  UF_PrintM("additional tail factor of i-th peak\n");
  UF_PrintM
    ("              / TLi * (|dx| / Si)**ELi / (FACFAC(ELi)  for dx<0\n");
  UF_PrintM
    ("  TAILi(dx)= {\n");
  UF_PrintM
    ("              \\ TRi * (|dx| / Si)**ERi / (FACFAC(ERi)  for dx>=0\n");
  UF_PrintM("    TLi   :  left tail of i-th peak (parameter)\n");
  UF_PrintM("    TRi   :  right tail of i-th peak (parameter)\n");
  UF_PrintM("    ELi   :  exponent of left tail [2..16]\n");
  UF_PrintM("    ERi   :  exponent of right tail [2..16]\n");
  UF_PrintM("for simplification of integral\n");
  UF_PrintM("              / (n-1)!!                 for n= 3,5,7,...\n");
  UF_PrintM("  FACFAC(n)= {\n");
  UF_PrintM("              \\ (n-1)!! * sqrt(pi / 2)  for n= 2,4,6,...\n");
  UF_PrintM("step function of i-th peak\n");
  UF_PrintM("  STEPi(dx)= 1/2 * SHi * (1 - erf(dx / (SWi * Si * sqrt(2))))\n");
  UF_PrintM("    SHi   :  step height of i-th peak (parameter)\n");
  UF_PrintM("    SWi   :  step width of i-th peak (parameter)\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_ExponentTl()
{
  return TailExponent(&FitTlE(VfitsWorkFit(&vFit)), "left");
}
/* ---------------------------------------------------------------------- */
int FP_ExponentTr()
{
  return TailExponent(&FitTrE(VfitsWorkFit(&vFit)), "right");
}
/* ---------------------------------------------------------------------- */
static int TailExponent(te, side)
     int *te;
     char *side;
{
  int d;
  switch (FitPeakTyp(VfitsWorkFit(&vFit))) {
  case FIT_PKCA:
    if (UF_IntRead(FALSE, &d, "exponent in sigma dependence of %s tail [%d]",
		   side, *te) != 1) {
      return FALSE; }
    else if (d < 0 || 2 < d) {
      ErrPrintR("fatal: maximal range is [0,2]\n"); return FALSE; }
    break;
  case FIT_PKAE:
    if (UF_IntRead(FALSE, &d, "exponential dependence of %s tail [%d]",
		   side, *te) != 1) {
      return FALSE; }
    else if (d < 2 || 15 < d) {
      ErrPrintR("fatal: maximal range is [2,15]\n"); return FALSE; }
    break;
  default: return FALSE; }
  if (*te != d) {
    SerialIdGet(VfitsWorkFitSerialId(&vFit));
    FitTime(VfitsWorkFit(&vFit))= 0;
    *te= d; DN_ChangedWorkPeak(); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int FP_SetPeak(userTyp)
     int userTyp;
{ 
  Fit_t fp= VfitsWorkFit(&vFit);
  Par_t pp= FitPar(fp);
  int s, e;
  int rpi;
  int check_corr;

  SerialIdGet(VfitsWorkFitSerialId(&vFit));
  FitTime(VfitsWorkFit(&vFit))= 0;
  if (VfitsLhsIdx(&vFit) < 0) {
    check_corr= FALSE;
    if (userTyp == FIT_UTPOS) {
      if (VfitsUserStat(&vFit) == FIT_USNONE) {
	if (FitResetPeaks(fp)) { return TRUE; }
	else { ErrPrintR("fatal: can not delete peak(s)\n"); return FALSE; } }
      else if (VfitsRhsIdx(&vFit) < 0 &&
	       VfitsCoef(&vFit)[1] == 0.0 &&
	       VfitsChange(&vFit) == FP_CPARAM) {	/* new peak */
	if (FitSetPeak(fp, VfitsCoef(&vFit)[0])) {
	  return TRUE; }
	else {
	  ErrPrintR("fatal: can not insert new peak\n"); return FALSE; } }
      else { s= 0; e= FitPeakNum(fp); } }
    else { s= 0; e= FitPeakNum(fp); } }
  else {
    check_corr= TRUE;
    s= FitPeakSIdx(fp,VfitsLhsIdx(&vFit));
    if (VfitsUserStat(&vFit) == FIT_USNONE && userTyp == FIT_UTPOS) {
      if (FitDelPeak(fp, s)) { return TRUE; }
      else { ErrPrintR("fatal: can not delete peak\n"); return FALSE; } }
    else { e= s+1; } }

  if (VfitsRhsIdx(&vFit) >= 0) {
    int ri= (!FitPeakNum(VfitsWorkFit(&vFit)) ?
	     0 : FitPeakSIdx(fp,VfitsRhsIdx(&vFit)));
    switch (userTyp) {
    case FIT_UTPOS: rpi= FitPosIdx(ri); break;
    case FIT_UTWIDTH: rpi= FitWidthIdx(ri); break;
    case FIT_UTVOL: rpi= FitVolIdx(ri); break;
    case FIT_UTTL: rpi= FitTlIdx(ri); break;
    case FIT_UTTR: rpi= FitTrIdx(ri); break;
    case FIT_UTSH: rpi= FitShIdx(ri); break;
    case FIT_UTSW: rpi= FitSwIdx(ri); break; } }

  if (VfitsParMode(&vFit) == PAR_MCORR) {
    int c= (VfitsOpTyp(&vFit) == FP_OEQUAL) ? rpi : -1;
    switch (userTyp) {
    case FIT_UTWIDTH:	FitWCorr(fp)= c; break;
    case FIT_UTTL:	FitTlCorr(fp)= c; break;
    case FIT_UTTR:	FitTrCorr(fp)= c; break;
    case FIT_UTSH:	FitShCorr(fp)= c; break;
    case FIT_UTSW:	FitSwCorr(fp)= c; break; } }
  { int li;

    for (li= s; li< e; li++) {
      ParV_t pv;
      int lpi;

      switch (userTyp) {
      case FIT_UTPOS: lpi= FitPosIdx(li); break;
      case FIT_UTWIDTH: lpi= FitWidthIdx(li); break;
      case FIT_UTVOL: lpi= FitVolIdx(li); break;
      case FIT_UTTL: lpi= FitTlIdx(li); break;
      case FIT_UTTR: lpi= FitTrIdx(li); break;
      case FIT_UTSH: lpi= FitShIdx(li); break;
      case FIT_UTSW: lpi= FitSwIdx(li); break; }

      if (VfitsUserStat(&vFit) == FIT_USNONE) {
	VfitsUserStat(&vFit)= FIT_USUNDEF;
	FitDisablePar(fp, li, userTyp, check_corr); }
      else {
	if (ParUserStat(pp,lpi) == FIT_USNONE &&
	    VfitsChange(&vFit) == FP_CSTAT) {
	  VfitsUserStat(&vFit)= FIT_USINIT; }
	FitEnablePar(fp, li, userTyp, check_corr); }

      if (!FP_ParGet(pp, lpi, &pv)) { return FALSE; }
      else {
	if (VfitsRhsIdx(&vFit) < 0) { rpi= lpi; }

	if (VfitsParMode(&vFit) == PAR_MCORR && lpi == rpi) { continue; }

	if (VfitsParStat(&vFit) != PAR_SUNDEF) {
	  ParVStat(&pv)= VfitsParStat(&vFit); }
	if (VfitsParMode(&vFit) != PAR_MUNDEF) {
	  ParVMode(&pv)= VfitsParMode(&vFit); }
	if (VfitsUserStat(&vFit) != FIT_USUNDEF) {
	  ParVUserStat(&pv)= VfitsUserStat(&vFit); }

	switch (VfitsChange(&vFit)) {
	case FP_CPARAM:	/* only changes */
	  if (VfitsWorkScale(&vFit) != VmrksScale(&vMrk)) {
	    double c0= VfitsCoef(&vFit)[0]; /* transform offset with calib */
	    if (VfitsParTyp(&vFit) == FIT_UTPOS &&
		VfitsCoef(&vFit)[1] != 0.0) {
	      double p0= FitPPosVal(pp,rpi) * VfitsCoef(&vFit)[1];
	      c0= (VactCalibrated(VfitsWorkScale(&vFit)) ?
		   CalPWidth(VfitsCal(&vFit),
			     CalC(VfitsCal(&vFit), p0), c0) :
		   CalCWidth(VfitsCal(&vFit),
			     CalP(VfitsCal(&vFit), p0), c0)); }
	    else if (VfitsParTyp(&vFit) == FIT_UTWIDTH) {
	      c0 *= SIGMA_TO_FWHM;
	      c0= (VactCalibrated(VfitsWorkScale(&vFit)) ?
		   CalPWidth(VfitsCal(&vFit),
			     CalC(VfitsCal(&vFit), FitPPosVal(pp,li)), c0) :
		   CalCWidth(VfitsCal(&vFit),
			     CalP(VfitsCal(&vFit), FitPPosVal(pp,li)), c0));
	      c0 *= FWHM_TO_SIGMA; }
	    VfitsCoef(&vFit)[0]= c0; }

	  if (ParVMode(&pv) == PAR_MCORR) {
	    ParVCorrIndex(&pv)= rpi;
	    switch (VfitsOpTyp(&vFit)) {
	    case FP_OSPACED:
	      ParVCorr(&pv)[0]= ParVal(pp,lpi) - ParVal(pp,rpi);
	      ParVCorr(&pv)[1]= 1.0;
	      FitPCorr(fp)= rpi;
	      break;
	    case FP_OEQUAL:
	      ParVCorr(&pv)[0]= VfitsCoef(&vFit)[0];
	      ParVCorr(&pv)[1]= VfitsCoef(&vFit)[1];
	      break;
	    default:
	      ParVCorr(&pv)[0]= VfitsCoef(&vFit)[0];
	      ParVCorr(&pv)[1]= VfitsCoef(&vFit)[1];
	      break; } }
	  ParVVal(&pv)= VfitsCoef(&vFit)[0];
	  if (VfitsCoef(&vFit)[1] != 0.0) {
	    ParVVal(&pv) += VfitsCoef(&vFit)[1] * ParVal(pp,rpi); }
	  else { ParVErr(&pv)= VfitsPrec(&vFit); }
	  break;
	case FP_CSTAT:
	  break;
	default:
	  ErrPrintR("fatal internal: illegal change type\n");
	  return FALSE; }
	
	if (ParVCmp(&pv,ParV(pp,lpi))) {
	  if (!FP_ParSet(pp, lpi, &pv, check_corr)) { return FALSE; } } } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int FP_SetBg(userTyp)
     int userTyp;
{
  Par_t pp= FitPar(VfitsWorkFit(&vFit));
  int s, e;
  int check_corr;

  SerialIdGet(VfitsWorkFitSerialId(&vFit));
  FitTime(VfitsWorkFit(&vFit))= 0;

  if (VfitsOpTyp(&vFit) == FP_ODEGREE) { return TRUE; }
  else {
    switch (userTyp) {
    case FIT_UTBGFAC:
      if (VfitsLhsIdx(&vFit) < 0) {
	check_corr= FALSE; s= 0; e= FitBgExpNum(VfitsWorkFit(&vFit)); }
      else { check_corr= TRUE; s= VfitsLhsIdx(&vFit); e= s+1; }
      break;
    case FIT_UTBGEXP:
      if (VfitsLhsIdx(&vFit) < 0) {
	check_corr= FALSE; s= 0; e= FitBgExpNum(VfitsWorkFit(&vFit)); }
      else { check_corr= TRUE; s= VfitsLhsIdx(&vFit); e= s+1; }
      break;
    case FIT_UTBGPOL:
      if (VfitsLhsIdx(&vFit) < 0) {
	check_corr= FALSE;
	s= 0; e= FitBgGrad(VfitsWorkFit(&vFit)); }
      else { check_corr= TRUE; s= VfitsLhsIdx(&vFit); e= s+1; }
      break; } }

  { int i;
    for (i= s; i< e; i++) {
      ParV_t pv;
      int j;
      int resetBgTime= FALSE;

      switch (userTyp) {
      case FIT_UTBGPOL:
	j= i; break;
      case FIT_UTBGFAC:
	j= FIT_BGGRD + 2 * i; break;
      case FIT_UTBGEXP:
	j= FIT_BGGRD + 2 * i + 1; break;
      default: continue; }

      if (!FP_ParGet(pp, j, &pv)) { return FALSE; }
      else {
	if (VfitsParStat(&vFit) != PAR_SUNDEF &&
	    ParVStat(&pv) != VfitsParStat(&vFit)) {
	  resetBgTime= TRUE;
	  ParVStat(&pv)= VfitsParStat(&vFit); }
	if (VfitsParMode(&vFit) != PAR_MUNDEF &&
	    ParVMode(&pv) != VfitsParMode(&vFit)) {
	  if (VfitsParMode(&vFit) != PAR_MHOLD) {
	    resetBgTime= TRUE; }
	  ParVMode(&pv)= VfitsParMode(&vFit); }

	switch (VfitsChange(&vFit)) {
	case FP_CPARAM:		/* only changes */
	  resetBgTime= TRUE;
	  if (VfitsUserStat(&vFit) != FIT_USUNDEF) {
	    ParVUserStat(&pv)= VfitsUserStat(&vFit); }
	  ParVVal(&pv)= (VfitsCoef(&vFit)[0] +
			 VfitsCoef(&vFit)[1] * ParVVal(&pv));
	  ParVErr(&pv)= 0.0;
	  ParVStat(&pv)= VfitsParStat(&vFit);
	  ParVUserStat(&pv)= VfitsUserStat(&vFit);
	case FP_CSTAT:
	  if (VfitsUserStat(&vFit) != FIT_USUNDEF &&
	      ParVUserStat(&pv) != VfitsUserStat(&vFit)) {
	    resetBgTime= TRUE;
	    if (ParVUserStat(&pv) != FIT_USNONE) {
	      ParVUserStat(&pv)= VfitsUserStat(&vFit); }
	    else {
	      ParVUserStat(&pv)= FIT_USUNDEF; } }
	  break;		/* no parameter values to change */
	default: ErrPrintR("fatal: illegal change type\n"); return FALSE; }

	if (ParVCmp(&pv,ParV(pp,j))) {
	  if (resetBgTime) { FitBgTime(VfitsWorkFit(&vFit))= 0; }
	  if (!FP_ParSet(pp, j, &pv, check_corr)) { return FALSE; } } } } }

  if (userTyp == FIT_UTBGPOL) { /* reset bgGrad to real value */
    int i;

    for (i= FitBgGrad(VfitsWorkFit(&vFit)); i >= 0; i--) {
      ParV_t pv;

      if (!FP_ParGet(pp, i, &pv)) { return FALSE; }
      else {
	if (ParVMode(&pv) != PAR_MHOLD || ParVVal(&pv) != 0.0) { break; }
	else {
	  FitBgGrad(VfitsWorkFit(&vFit))--;
	  ParVUserStat(&pv) = FIT_USNONE;
	  ParVStat(&pv)     = PAR_SSUSP;

	  if (ParVCmp(&pv,ParV(pp,i))) {
	    if (!FP_ParSet(pp, i, &pv, check_corr)) {
	      return FALSE; } } } } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */

/* ============================= */
/* decode correlation expression */
/* ============================= */

int FP_Div()
{
  double v;
  double p;
  if (UF_RealRead(TRUE, &v, &p, "dividend")) {
    if (v == 0.0) { VfitsCoef(&vFit)[1] /= v; return TRUE; }
    else { ErrPrintR("fatal: can not divide by 0.0\n"); } }
  VfitsOpTyp(&vFit)= FP_OUNDEF;
  return FALSE;
}

int FP_Mul()
{
  double v;
  double p;
  if (!UF_RealRead(TRUE, &v, &p, "factor")) {
    VfitsCoef(&vFit)[1] /= v; return TRUE; }
  VfitsOpTyp(&vFit)= FP_OUNDEF;
  return FALSE;
}

int FP_Add() { VfitsSign(&vFit)= 1; return TRUE; }

int FP_Sub() { VfitsSign(&vFit)= -1; return TRUE; }

/* ---------------------------------------------------------------------- */
static int FP_Expression()
{
  if (UF_NoArgs()) { return FALSE; }
  else {
    extern Men_t parNameMen;
    extern Men_t parSignMen;

    VfitsSign(&vFit)= 1;	/* will be set in FP_Product too */
    UF_MenuLoop(&parSignMen, "parameter sign");

    CmdCommand(VecP(MenCt(&parNameMen)))= VfitsParName(&vFit);
    CmdUnexpected(VecP(MenCt(&parNameMen)))= (VfitsNumIdx(&vFit) != 0);

    UF_MenuLoop(&parNameMen, "parameter name");

    if (!UF_NoArgs()) {
      extern Men_t parSignMen;
      UF_MenuLoop(&parSignMen, "parameter sign"); }

    if (!UF_NoArgs()) {
      double value;
      double precision;
      if (VfitsParTyp(&vFit) == FIT_UTPOS && VfitsCoef(&vFit)[1] == 0.0) {
	if (!Mrk_EnterSingleV(VfitsWorkScale(&vFit), VfitsCal(&vFit), &value,
			      "enter peak position")) {
	  return FALSE; } }
      else if (!UF_RealRead(FALSE,
			    &value, &precision, "parameter value")) {
	UF_ResetIllegal();
	return FALSE; }
      else {
	VmrksScale(&vMrk)= VfitsWorkScale(&vFit);
	if ((VfitsParTyp(&vFit) == FIT_UTPOS ||
	     VfitsParTyp(&vFit) == FIT_UTWIDTH) &&
	    !UF_NoArgs()) {
	  extern Men_t mrkUnitMen;
	  UF_MenuLoop(&mrkUnitMen, "marker unit"); }
	if (VfitsParTyp(&vFit) == FIT_UTWIDTH) {
	  value *= FWHM_TO_SIGMA; } }
      VfitsCoef(&vFit)[0]= VfitsSign(&vFit) * value;
      VfitsPrec(&vFit)= precision; }
    VfitsChange(&vFit)= FP_CPARAM;
    if (VfitsParMode(&vFit) == PAR_MUNDEF &&
	VfitsLhsIdx(&vFit) != VfitsRhsIdx(&vFit) &&
	VfitsRhsIdx(&vFit) >= 0) {
      VfitsParMode(&vFit)= PAR_MCORR; }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int FP_Product() 
{
  VfitsCoef(&vFit)[1]= VfitsSign(&vFit);
  VfitsSign(&vFit)= 1;
  if (!FP_Index(&VfitsRhsIdx(&vFit))) { return FALSE; }
  else if (!UF_NoArgs()) {
    extern Men_t parProductMen;
    UF_MenuLoop(&parProductMen, "parameter product"); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_InsertPeak()
{
  do {
    double value;
    if (!Mrk_EnterSingleV(VfitsWorkScale(&vFit),
			  VcalsCal(&vCal, VactSpcIdx(vAct)), &value,
			  "enter peak position")) { return FALSE; }
    SerialIdGet(VfitsWorkFitSerialId(&vFit));
    FitTime(VfitsWorkFit(&vFit))= 0;
    if (!FitSetPeak(VfitsWorkFit(&vFit), value)) {
      ErrPrintR("fatal: can not insert new peak\n"); return FALSE; }
    else { DN_ChangedWorkPeak(); }
  } while (!UF_NoArgs());
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_DeletePeak()
{
  int del= FALSE;
  int range = Mrk_EnterRange(VfitsInScale(&vFit), VfitsWorkScale(&vFit), VactSpcIdx(vAct));
  if (range){}
  Fit_WorkSetup(VactSpcIdx(vAct));
  { int m;
    int p;
    PVec_t mp= VmrkMrk(VmrksRange(&vMrk));
    Fit_t fp= VfitsWorkFit(&vFit);

    for (m= VecNum(mp)-1, p= FitPeakNum(fp)-1; m >= 0 && p >= 0; ) {
      if (PVecX2(mp,m) < FitPosVal(fp,p)) {	/* mmm   */
	p--; }					/*     p */
      else if (FitPosVal(fp,p) < PVecX1(mp,m)) { /* p      */
	m--; }					 /*   mmm */
      if (FitDelPeak(VfitsWorkFit(&vFit), p)) { del= TRUE; p--; }
      else {
	if (del) { DN_ChangedWorkPeak(); }
	ErrPrintR("fatal: cannot delete peak\n");
	return FALSE; } } }
  if (del) { DN_ChangedWorkPeak(); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_MeasurePoisson()
{
  VfitsMeasureTyp(&vFit)= FIT_MPOI;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_MeasureChiY()
{
  VfitsMeasureTyp(&vFit)= FIT_MY;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_MeasureChiDy()
{
  VfitsMeasureTyp(&vFit)= FIT_MDY;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_MeasureDefChiDy()
{
  UF_PrintM("minimization of chi-square weighted by data errors:\n");
  UF_PrintM("(maximization of a gauss-distribution):\n");
  UF_PrintM("  chi(f)**2= SUM(i=0..numdata, ((f(Xi) - Yi) / dYi)**2)\n");
  UF_PrintM("    f    : fit function\n");
  UF_PrintM("    Xi   : channel\n");
  UF_PrintM("    Yi   : spectrum-value at channel Xi\n");
  UF_PrintM("    dYi  : error of Yi\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_MeasureDefChiY()
{
  UF_PrintM("minimization of chi-square weighted by data\n");
  UF_PrintM("(maximization of a gauss-distribution):\n");
  UF_PrintM("  chi(f)**2= SUM(i=0..numdata, (f(Xi) - Yi)**2 / abs(Yi))\n");
  UF_PrintM("    f    : fit function\n");
  UF_PrintM("    Xi   : channel\n");
  UF_PrintM("    Yi   : spectrum-value at channel Xi\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FP_MeasureDefPoisson()
{
  UF_PrintM("maximization of a poisson-distribution:\n");
  UF_PrintM("  P(f)= PRODUCT(i=0..numdata, f(Xi)**Yi / Yi! * exp(-f(Xi)))\n");
  UF_PrintM("    f    : fit function\n");
  UF_PrintM("    Xi   : channel\n");
  UF_PrintM("    Yi   : spectrum-value at channel Xi\n");
  UF_PrintM("the really maximized and printed measure is the function\n");
  UF_PrintM("  G(f)= ln(P(f)) - C\n");
  UF_PrintM("      = SUM(i=0..numdata, Yi * ln(f(Xi)) - f(Xi))\n");
  UF_PrintM("    C    : SUM(i=0..numdata, -ln(Yi!))\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
