/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsFitWrite.c,v 1.4 1994/12/02 21:24:15 vs Exp vs $ */

# define _VsFitWrite_c

#include <math.h>

				/* library include files */
#include <tv/vsTypes.h>
#include <tv/vsAlloc.h>
#include <tv/vsCurFit.h>
#include <tv/vsPath.h>
#include <tv/vsUserFace.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsIndex.h"
#include "VsMark.h"
#include "VsSearch.h"
#include "VsFit.h"
#include "VsFitIo.h"
#include "VsSpectra.h"
#include "VsUserFace.h"
/* ---------------------------------------------------------------------- */
#include "VsFitWrite.h"
#include "VsFitWriteP.h"
/* ---------------------------------------------------------------------- */
#define DFLT_FMTFIT "\
'spectrum #' I '%d: ' fs '%s' '\n\n'\n\
'background ' mb Db ' fitted %s' '%s' '\n'\n\
Mbt '%s: ' Mbv p2 '%s ' ' iterations: ' Nbn '%d/' Nbm '%d' '\n\n'\n\
'region ' mr Dr ' fitted %.24s' '%s' '\n'\n\
Mrt '%s: ' Mrv p2 '%s ' ' iterations: ' Nrn '%d/' Nrm '%d' '\n\n'\n\
'offset: ' o '%.0f [Chn]\n\n'\n\
b '\n'\n\
'peaklist ' u '[%s]' '\n'\n\
p '\n'"

#define DFLT_FMTINT "\
'spectrum #' I '%d: ' fs '%s' '\n\n'\n\
'region ' mr Dr ' integrated %.24s' '%s' '\n'\n\
it '\n'\n\
ib '\n'\n\
is '\n'"

#define DFLT_FMTPKF "\
i '#%-2d'\n\
pv p2'p %16s ' ps '%3.3s' pci '[%d]' '%-4s '\n\
wv p2'w %12s ' ws '%3.3s' wci '[%d]' '%-4s '\n\
vv p2'v %14s ' vs '%3.3s' vci '[%d]' '%-4s' '\n'\n\
'                   '\n\
tlv p2'tl %12s ' tls '%3.3s' tlci '[%d]' '%-4s'\n\
trv p2'tr %12s ' trs '%3.3s' trci '[%d]' '%-4s' '\n'\n\
'                   '\n\
shv p2'sh %12s ' shs '%3.3s' shci '[%d]' '%-4s'\n\
swv p2'sw %12s ' sws '%3.3s' swci '[%d]' '%-4s' '\n'"

#define DFLT_FMTPKS "\
p 'p %12.1f ' w 'w %8.1f ' vv p2'v %14s ' % '%6.2f %%' '\n'"

#define DFLT_FMTPKI "\
i '%3.3s: ' pv p2'%16s ' wv p2'%12s ' vv p2'%14s ' sv p2'%12s'"

#define DFLT_FMTLSF "\
pv p2'p %16s ' wv p2'w %12s ' vv p2'v %14s ' '\n'"

#define DFLT_FMTLSS "\
p 'p %16.1f ' w 'w %12.3f ' vv p2'v %14s ' '\n'"

#define DFLT_FMTBGPOL "\
'f[' i '%d' ']=' fv p2'%12s ' fs '%3.3s' fci '[%d]' '%-4s' '   '\n\
'e[' i '%d' ']=' ev p2'%12s ' es '%3.3s' eci '[%d]' '%-4s' '\n'"

#define DFLT_FMTBGEXP "\
'b[' i '%d' ']=' bv p2'%12s ' bs '%3.3s' bci '[%d]' '%-4s' '\n'"

#define DFLT_FMTMRK "\
l '(%.0f,' r '%.0f) '"

/* ---------------------------------------------------------------------- */
static char *print_init[FMT_NUM];
static char *list_init[FMT_NUM];
static char *short_init[FMT_NUM];
static char *def_init[FMT_NUM];
/* ---------------------------------------------------------------------- */
static int PrintString(fmt, s)
     char *fmt;
     char *s;
{
  if (VfwProtocol(&vFw)) {
    if (fprintf(VfwFp(&vFw), fmt, s) == EOF) {
      ErrPrint("can not write to protocol file\n", s);
      return FALSE; } }
  else { UF_PrintM(fmt, s); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static void PrintFormat(pfct, fmt)
     int (*pfct)();
     char *fmt;
{
  char item[IOBUFLEN];
  char *i= item;
  int il= IOBUFLEN;

  *item= '\0';

  /*  printf("PrintFormat\n");*/
  pfct("\"");
  while (*fmt) {
    switch (*fmt) {
    case '\'':
      *i++= *fmt++; il--; *i= '\0';
      while (*fmt && il > 1 && (*fmt != '\'' || fmt[-1] == '\\') &&
	     UFQuoteChar(*fmt, &i, &il, '\'')) { fmt++; }
      if (il > 1) { *i++ = *fmt++; il--; *i= '\0'; }
      break;
    case '\n': fmt++;
      pfct("%s\n", item);
      i= item; il= IOBUFLEN; *item= '\0';
      break;
    default: *i++ = *fmt++; il--; *i= '\0'; } }

  pfct("%s\"", item);
}
/* ---------------------------------------------------------------------- */
int FW_Init()
{
  VfwProtocol(&vFw)		= FALSE;
  VfwFp(&vFw)			= NULL;
  { int i; for (i= 0; i< FMT_NUM; i++) {
    VfwFmt(&vFw)[i]	= NULL;
    VfwList(&vFw)[i]	= NULL; } }

  { char **p= print_init;
    *p++ = ".tvfithd.p";
    *p++ = ".tvinthd.p";
    *p++ = ".tvfitpk.p";
    *p++ = ".tvseapk.p";
    *p++ = ".tvintpk.p";
    *p++ = ".tvpklfit.p";
    *p++ = ".tvpklsea.p";
    *p++ = ".tvbgpol.p";
    *p++ = ".tvbgexp.p";
    *p++ = ".tvmrk.p"; };
  { char **l= list_init;
    *l++ = ".tvfithd.l";
    *l++ = ".tvinthd.l";
    *l++ = ".tvfitpk.l";
    *l++ = ".tvseapk.l";
    *l++ = ".tvintpk.l";
    *l++ = ".tvpklfit.l";
    *l++ = ".tvpklsea.l";
    *l++ = ".tvbgpol.l";
    *l++ = ".tvbgexp.l";
    *l++ = ".tvmrk.l"; };
  { char **l= short_init;
    *l++ = ".tvfithd.s";
    *l++ = ".tvinthd.s";
    *l++ = ".tvfitpk.s";
    *l++ = ".tvseapk.s";
    *l++ = ".tvintpk.s";
    *l++ = ".tvpklfit.s";
    *l++ = ".tvpklsea.s";
    *l++ = ".tvbgpol.s";
    *l++ = ".tvbgexp.s";
    *l++ = ".tvmrk.s"; };
  { char **d= def_init;
    *d++ = DFLT_FMTFIT;
    *d++ = DFLT_FMTINT;
    *d++ = DFLT_FMTPKF;
    *d++ = DFLT_FMTPKS;
    *d++ = DFLT_FMTPKI;
    *d++ = DFLT_FMTLSF;
    *d++ = DFLT_FMTLSS;
    *d++ = DFLT_FMTBGPOL;
    *d++ = DFLT_FMTBGEXP;
    *d++ = DFLT_FMTMRK; };
  return (FileInit(VfwList(&vFw), list_init) &
	  FileInit(VfwShList(&vFw), short_init) &
	  FileInit(VfwFmt(&vFw), print_init));
}
/* ---------------------------------------------------------------------- */
static int FileInit(fmt, fil)
     char **fmt;
     char **fil;
{
  int i, ret= TRUE;

  for (i= 0; i< FMT_NUM; i++) {
    ret &= FormatFileInit(fmt, fil, i); }
  return ret;
}
/* ---------------------------------------------------------------------- */
static int FormatFileInit(fmt, fil, idx)
     char **fmt;
     char **fil;
     int idx;
{
  char *path;

  if (fil && (path= UF_Find(fil[idx])) && FmtRead(fmt + idx, path)) {
    return TRUE;
  }
  else if (fil != list_init &&
	   (path= UF_Find(list_init[idx])) && FmtRead(fmt + idx, path)) {
    return TRUE;
  }
  else {
    return FmtEnter(fmt, def_init[idx], FALSE);
  }
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefFit()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_FIT], def_init[FMT_FIT], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefInt()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_INT], def_init[FMT_INT], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefPeakFit()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_PKF], def_init[FMT_PKF], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefPeakSea()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_PKS], def_init[FMT_PKS], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefPeakInt()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_PKI], def_init[FMT_PKI], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefListFit()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_LSF], def_init[FMT_LSF], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefListSea()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_LSS], def_init[FMT_LSS], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefBgExp()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_BGEXP], def_init[FMT_BGEXP], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefBgPol()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_BGPOL], def_init[FMT_BGPOL], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtDefMark()
{
  return FmtEnter(&VfwFmt(&vFw)[FMT_MRK], def_init[FMT_MRK], FALSE);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadFit()
{
  return FormatRead("fit", &VfwFmt(&vFw)[FMT_FIT]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadInt()
{
  return FormatRead("integration", &VfwFmt(&vFw)[FMT_INT]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadPeakFit()
{
  return FormatRead("peak-fit", &VfwFmt(&vFw)[FMT_PKF]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadPeakSea()
{
  return FormatRead("peak-search", &VfwFmt(&vFw)[FMT_PKS]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadPeakInt()
{
  return FormatRead("peak-integration", &VfwFmt(&vFw)[FMT_PKI]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadListFit()
{
  return FormatRead("list-fit", &VfwFmt(&vFw)[FMT_LSF]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadListSea()
{
  return FormatRead("list-search", &VfwFmt(&vFw)[FMT_LSS]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadBgPol()
{
  return FormatRead("bg-polynom", &VfwFmt(&vFw)[FMT_BGPOL]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadBgExp()
{
  return FormatRead("bg-exponential", &VfwFmt(&vFw)[FMT_BGEXP]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtReadMark()
{
  return FormatRead("mark", &VfwFmt(&vFw)[FMT_MRK]);
}
/* ---------------------------------------------------------------------- */
static int FormatRead(title, fmt)
     char *title;
     char **fmt;
{
  char file[IOBUFLEN];

  if (UF_ItemRead(file, IOBUFLEN, "%s-format input file", title) && *file) {
    char *path;
    if ((path= UF_Find(file))) {
      if (FmtRead(fmt, path)) { return TRUE; }
      else {
	ErrPrintR("fatal: can not read %s-format file '%s'\n",
		  title, PthShort(path)); } }
    else {
      ErrPrintR("fatal: can not find %s-format file '%s'\n", title, file); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterFit()
{
  /*  printf("FW_FmtEnterFit\n");*/
  return FormatEnter("fit", &VfwFmt(&vFw)[FMT_FIT]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterInt()
{
  return FormatEnter("integration", &VfwFmt(&vFw)[FMT_INT]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterPeakFit()
{
  return FormatEnter("peak-fit", &VfwFmt(&vFw)[FMT_PKF]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterPeakSea()
{
  return FormatEnter("peak-search", &VfwFmt(&vFw)[FMT_PKS]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterPeakInt()
{
  return FormatEnter("peak-integration", &VfwFmt(&vFw)[FMT_PKI]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterListFit()
{
  return FormatEnter("list-fit", &VfwFmt(&vFw)[FMT_LSF]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterListSea()
{
  return FormatEnter("list-search", &VfwFmt(&vFw)[FMT_LSS]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterBgPol()
{
  return FormatEnter("bg-polynom", &VfwFmt(&vFw)[FMT_BGPOL]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterBgExp()
{
  return FormatEnter("bg-exponential", &VfwFmt(&vFw)[FMT_BGEXP]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtEnterMark()
{
  return FormatEnter("mark", &VfwFmt(&vFw)[FMT_MRK]);
}
/* ---------------------------------------------------------------------- */
static int FormatEnter(title, fmt)
     char *title;
     char **fmt;
{
  char item[IOBUFLEN];

  /*  printf("FormatEnter\n");*/
  if (UF_NoArgs()) {
    FormatShow(title, *fmt);
  }
  if (UF_ItemRead(item, IOBUFLEN, "%s-format", title)) {
    FmtEnter(fmt, item, TRUE);
    return TRUE;
  }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int FW_FmtWriteFit()
{
  return FormatWrite("fit", VfwFmt(&vFw)[FMT_FIT]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtWriteInt()
{
  return FormatWrite("integration", VfwFmt(&vFw)[FMT_INT]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtWritePeakFit()
{
  return FormatWrite("peak-fit", VfwFmt(&vFw)[FMT_PKF]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtWritePeakSea()
{
  return FormatWrite("peak-search", VfwFmt(&vFw)[FMT_PKS]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtWritePeakInt()
{
  return FormatWrite("peak-integration", VfwFmt(&vFw)[FMT_PKI]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtWriteListFit()
{
  return FormatWrite("list-fit", VfwFmt(&vFw)[FMT_LSF]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtWriteListSea()
{
  return FormatWrite("list-search", VfwFmt(&vFw)[FMT_LSS]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtWriteBgPol()
{
  return FormatWrite("bg-polynom", VfwFmt(&vFw)[FMT_BGPOL]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtWriteBgExp()
{
  return FormatWrite("bg-exponential", VfwFmt(&vFw)[FMT_BGEXP]);
}
/* ---------------------------------------------------------------------- */
int FW_FmtWriteMark()
{
  return FormatWrite("mark", VfwFmt(&vFw)[FMT_MRK]);
}
/* ---------------------------------------------------------------------- */
static int FormatWrite(title, fmt)
     char *title;
     char *fmt;
{
  char file[IOBUFLEN];

  if (UF_ItemRead(file, IOBUFLEN, "%s-format output file", title) && *file) {
    char *path;
    if ((path= PthExpand(file))) {
      if (FmtWrite(fmt, file)) { return TRUE; }
      else { ErrPrintR("fatal: can not write %s-format file '%s'\n",
		       title, PthShort(path)); } }
    else { ErrPrintR("fatal: can not expand %s-format file name '%s'\n",
		     title, file); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int FormatShow(title, fmt)
     char *title, *fmt;
{
  UF_PrintM("%s-format:\n", title);
  PrintFormat((int (*)())UF_PrintM, fmt);
  UF_PrintM("\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FW_FmtShow()
{
  FormatShow("fit", VfwFmt(&vFw)[FMT_FIT]);
  FormatShow("integration", VfwFmt(&vFw)[FMT_INT]);
  FormatShow("fit-peak", VfwFmt(&vFw)[FMT_PKF]);
  FormatShow("search-peak", VfwFmt(&vFw)[FMT_PKS]);
  FormatShow("integration-peak", VfwFmt(&vFw)[FMT_PKI]);
  FormatShow("fit-list", VfwFmt(&vFw)[FMT_LSF]);
  FormatShow("search-list", VfwFmt(&vFw)[FMT_LSS]);
  FormatShow("bg-polynom", VfwFmt(&vFw)[FMT_BGPOL]);
  FormatShow("bg-exponential", VfwFmt(&vFw)[FMT_BGEXP]);
  FormatShow("mark", VfwFmt(&vFw)[FMT_MRK]);
  return TRUE;
}
/* ---------------------------------------------------------------------- */
/*
 * Function for command "fit status full" ...
 */
int FW_ShowFit()
{
  int scale= VfitsOutScale(&vFit);
  int ret_val, idx;

  /*
   * { int tmp= scale; scale= VfitsOutScale(&vFit); VfitsOutScale(&vFit)= tmp; }
   */
  Act_SetDefaultSpc(FALSE);
  idx= VactSpcIdx(vAct);
  if (!FitTime(VfitsWorkFit(&vFit)) ||
      !VspcsExists(&vSpc,idx) ||
      SerialIdCmp(VfitsWorkSpcSerialId(&vFit),
		  VspcsSerialId(&vSpc,idx))) {
    Fit_WorkSetup(VactSpcIdx(vAct));
  }
  FW_CurPar();
  UF_PrintP("\n");
  ret_val= PrintFit(VfwList(&vFw), VfitsWork(&vFit), idx);
  VfitsOutScale(&vFit)= scale;	/* restore old contents */
  return ret_val;
}
/* ---------------------------------------------------------------------- */
/*
 * Function for command "fit status short" ...
 */
int FW_ShortFit()
{
  int scale= VfitsOutScale(&vFit);
  int ret_val, idx;

  /*  int tmp= scale; scale= VfitsOutScale(&vFit); VfitsOutScale(&vFit)= tmp;*/

  /*  printf("FW_ShortFit\n");*/
  Act_SetDefaultSpc(FALSE);
  idx= VactSpcIdx(vAct);
  if (!FitTime(VfitsWorkFit(&vFit)) ||
      !VspcsExists(&vSpc,idx) ||
      SerialIdCmp(VfitsWorkSpcSerialId(&vFit),
		  VspcsSerialId(&vSpc,idx))) {
    Fit_WorkSetup(VactSpcIdx(vAct));
  }
  ret_val= PrintFit(VfwShList(&vFw), VfitsWork(&vFit), idx);
  VfitsOutScale(&vFit)= scale;	/* restore old contents */
  return ret_val;
}
/* ---------------------------------------------------------------------- */
int FW_CloseFile()
{
  if (VfwFp(&vFw)) {
    UF_PrintM("closing protocol file '%s'\n", PthShort(VfwFile(&vFw)));
    fclose(VfwFp(&vFw));
    VfwFp(&vFw)= NULL;
    Free(VfwFile(&vFw));
  }
  else {
    UF_PrintM("warning: no protocol file open\n");
  }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FW_OpenFile()
{
  return OpenFile("w");
}
/* ---------------------------------------------------------------------- */
int FW_AppendFile()
{
  return OpenFile("a");
}
/* ---------------------------------------------------------------------- */
static int OpenFile(mode)
     char *mode;
{
  char file[IOBUFLEN];

  if (VfwFp(&vFw)) {
    if (UF_NoArgs()) {
      UF_PrintM("protocol file '%s' still open\n",
		PthShort(VfwFile(&vFw)));
    }
  }
  if (UF_ItemRead(file, IOBUFLEN, "protocol output file") && *file) {
    char *path;
    if (VfwFp(&vFw)) {
      FW_CloseFile();
    }
    if ((path= PthExpand(file))) {
      if ((VfwFp(&vFw)= fopen(path, mode))) {
	VfwFile(&vFw)= Strdup(path);
	UF_PrintM("protocol file '%s' opened\n", PthShort(VfwFile(&vFw)));
	return TRUE;
      }
      else {
	ErrPrint("error: can not open protocol file '%s'\n",
		      PthShort(path));
      }
    }
    else {
      ErrPrint("error: can not parse filename '%s'\n", file);
    }
  }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int FW_ListFit()
{
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) { return FALSE; } } /* default if no further input */
  else if (!Idx_Read(1, "list fit for index(s)")) {
    return FALSE; }

  { int i;
    int fitNum= 0;
    
    for (i= 0; i< VidxNum(&vIdx); i++) {
      int idx= VidxIdx(&vIdx,i);
      if (VspcsExists(&vSpc,idx) &&
	  !SerialIdCmp(VfitsFSpcSerialId(&vFit,idx),
		       VspcsSerialId(&vSpc,idx))) {
	PrintFit(VfwList(&vFw), VfitsF(&vFit)+idx, idx);
	fitNum++; } }
    if (!fitNum) {
      UF_PrintE("warning: no fits found to list\n"); return FALSE; } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FW_PrintFit()
{
  if (!VfwFp(&vFw)) {
    UF_PrintE("error: no protocol file open\n");
    return FALSE;
  }
  else if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) { return FALSE; } } /* default if no further input */
  else if (!Idx_Read(1, "list fit for index(s)")) {
    return FALSE; }

  { int i;
    int fitNum= 0;
    
    VfwProtocol(&vFw)= TRUE;
    for (i= 0; i< VidxNum(&vIdx); i++) {
      int idx= VidxIdx(&vIdx,i);
      if (VspcsExists(&vSpc,idx) &&
	  !SerialIdCmp(VfitsFSpcSerialId(&vFit,idx),
		       VspcsSerialId(&vSpc,idx))) {
	PrintFit(VfwFmt(&vFw), VfitsF(&vFit)+idx, idx);
	fitNum++; } }
    VfwProtocol(&vFw)= FALSE;
    if (!fitNum) {
      UF_PrintE("warning: no fits found to list\n"); return FALSE; } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int PrintFit(fmt, vp, idx)
     char **fmt;
     Vfit_t *vp;
     int idx;
{
  Fit_t fp= VfitFit(vp);
  char *ret;

  /*  printf("PrintFit\n");*/
  if ((ret= FmtParseFit(PrintString, fmt, fp, idx,
		       VspcsFile(&vSpc,idx), VcalsCal(&vCal,idx),
		       VactCalibrated(VfitScale(vp)),
		       VactCalibrated(VfitsOutScale(&vFit))))) {
    UF_PrintE("error: can not print with format:\n");
    PrintFormat((int (*)())UF_PrintE, ret);
    ErrPrint("\n");
    return FALSE;
  }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FW_ShowSea()
{
  int i, num;

  UF_PrintM("result(s) of automatic search:\n");

  for (i= 0, num= 0; i< VseasNum(&vSea); i++) {
    if (VseasSea(&vSea,i) && VspcsExists(&vSpc,i) &&
	!SerialIdCmp(VseasSpcSerialId(&vSea,i), VspcsSerialId(&vSpc,i))) {
      UF_PrintM("%d peaks found in #%d '%s'\n",
		SeaListNum(VseasSea(&vSea,i)),
		i, PthShort(VspcsFile(&vSpc,i)));
      num++; } }
  if (num) { return TRUE; }

  ErrPrintR("warning: no valid search list found\n");
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int FW_ListSea()
{
  return PrintSea(VfwList(&vFw), "list");
}
/* ---------------------------------------------------------------------- */
int FW_PrintSea()
{
  if (!VfwFp(&vFw)) {
    UF_PrintE("error: no protocol file open\n"); return FALSE; }
  else {
    int ret_val;
    VfwProtocol(&vFw)= TRUE;
    ret_val= PrintSea(VfwFmt(&vFw), "print");
    VfwProtocol(&vFw)= FALSE;
    return ret_val; }
}
/* ---------------------------------------------------------------------- */
static int PrintSea(fmt, action)
     char **fmt;
     char *action;
{
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) { return FALSE; } } /* default if no further input */
  else if (!Idx_ReadOne("%s searchlist for index", action)) {
    return FALSE; }

  { int idx= VidxSingle(&vIdx);
    Spc_t spc= VspcsSpc(&vSpc,idx);
    int left, right;
    
    if (!VseasSea(&vSea,idx) || !VspcsExists(&vSpc,idx) ||
	SerialIdCmp(VseasSpcSerialId(&vSea,idx), VspcsSerialId(&vSpc,idx))) {
      ErrPrintR("fatal: no valid search list found for #%d\n", idx);
      return FALSE; }
    else {
      UF_PrintM("%d peaks found in #%d '%s'\n",
		SeaListNum(VseasSea(&vSea,idx)), idx, VspcsFile(&vSpc,idx)); }


    if (!UF_NoArgs() &&
	Mrk_EnterRange(VfitsInScale(&vFit), ACT_SUNCALIB, idx) &&
	Mrk_Get(VseasMrk(&vSea), VmrksRange(&vMrk), idx, ACT_SUNCALIB) &&
	Mrk_Consistent(VseasMrk(&vSea), SpcNum(spc)) &&
	VecNum(VseasMrk(&vSea))) {
      left= PVecX1(VseasMrk(&vSea),0);
      right= PVecX2(VseasMrk(&vSea),0); }
    else { left= 0; right= SpcNum(spc) - 1; }

    { SeaPeak p;
      ForAllSeaPeaks(VseasSea(&vSea,idx), p) {
	if (left <= SeaPos(p) && SeaPos(p) <= right) {
	  if (!PrintSeaPeak(fmt[FMT_PKS], p, idx)) {
	    return FALSE; } } } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int PrintSeaPeak(fmt, p, idx)
     char *fmt;
     SeaPeak p;
     int idx;
{
  char *ret;
  if ((ret= FmtParseSea(PrintString, fmt, p, idx,
		       VspcsFile(&vSpc,idx), VcalsCal(&vCal,idx),
		       ACT_SUNCALIB,
		       VactCalibrated(VfitsOutScale(&vFit))))) {
    UF_PrintE("error: can not print with format:\n");
    PrintFormat((int (*)())UF_PrintE, ret);
    ErrPrint("\n");
    return FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int FW_ListPeaklist()
{
  return PrintPeaklist(VfwList(&vFw), "list");
}
/* ---------------------------------------------------------------------- */
int FW_PrintPeaklist()
{
  if (!VfwFp(&vFw)) {
    UF_PrintE("error: no protocol file open\n"); return FALSE; }
  else {
    int ret_val;
    VfwProtocol(&vFw)= TRUE;
    ret_val= PrintPeaklist(VfwFmt(&vFw), "print");
    VfwProtocol(&vFw)= FALSE;
    return ret_val; }
}
/* ---------------------------------------------------------------------- */
static int PrintPeaklist(fmt, action)
     char **fmt;
     char *action;
{
  if (UF_NoArgs()) {
    if (!Idx_SetActSpc()) { return FALSE; } }
  else if (!Idx_ReadOne("list peaklist for index(s)")) {
    return FALSE; }

  { int idx= VidxSingle(&vIdx);
    Spc_t spc= VspcsSpc(&vSpc,idx);
    double left, right;

    if (!VspcsExists(&vSpc,idx)) {
      ErrPrintR("fatal: no valid peak list found for #%d\n", idx);
      return FALSE; }
    else {
      UF_PrintM("peak list for #%d '%s'\n",
		idx, PthShort(VspcsFile(&vSpc,idx))); }

    if (!UF_NoArgs() &&
	Mrk_EnterRange(VfitsOutScale(&vFit), ACT_SUNCALIB, idx) &&
	Mrk_Get(VseasMrk(&vSea), VmrksRange(&vMrk), idx, ACT_SUNCALIB) &&
	Mrk_Consistent(VseasMrk(&vSea), SpcNum(spc)) &&
	VecNum(VseasMrk(&vSea))) {
      left= PVecX1(VseasMrk(&vSea),0);
      right= PVecX2(VseasMrk(&vSea),0); }
    else { left= 0.0; right= (double)(SpcNum(spc) - 1); }

    { Vfio_t *vfio= VfiosF(&vFio) + idx;
      Fio_t fio= VfiosFFio(&vFio,idx);
      FioCurPeak_t cur= NULL;

      while ((cur= FioNextPeak(fio, left, right, cur))) {
	switch (FioCurPeakTyp(cur)) {
	case FIO_PBIN: {
	  FioPeaVec_t pea= FioPea(VfioFio(vfio));
	  int peaIdx= FioCurPeakPeaIdx(cur);
	  int binIdx= FioPeaPBinIdx(pea,peaIdx);
	  int peakIdx= FioPeaPPeakIdx(pea,peaIdx);
	  Vfit_t *vfit= VfitsTmpFit(&vFit);
	  Fit_t fit= VfitFit(vfit);

	  if (!Fio_ReadBin(idx, binIdx, vfit)) {
	    ErrPrintR("fatal: can not read bin %d for #%d from '%s'\n",
		      binIdx, idx, PthShort(VfioFile(vfio)));
	    return FALSE; }
	  else {
	    char *ret;
	    if ((ret= FmtParseFitPeak(PrintString, fmt[FMT_LSF],
				     fit, peakIdx, idx,
				     VspcsFile(&vSpc,idx),
				     VcalsCal(&vCal,idx),
				     ACT_SUNCALIB,
				     VactCalibrated(VfitsOutScale(&vFit))))) {
	      UF_PrintE("error: can not print with format:\n");
	      PrintFormat((int (*)())UF_PrintE, ret);
	      ErrPrint("\n");
	      return FALSE; } } }
	  break;
	case FIO_PSEA:
	  if (!PrintSeaPeak(fmt[FMT_LSS], FioCurPeakSeaPeak(cur), idx)) {
	    return FALSE; }
	  break; } } } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
/*
 * Print current fit parameters
 */

static int FW_CurPar()
{
  char *wt;
  char *st;

  switch (VfitsMeasureTyp(&vFit)) {
  case FIT_MY: wt= "abs(y)"; break;
  case FIT_MDY: wt= "dy**2"; break;
  case FIT_MPOI: wt= "abs(f(x))"; break;
  default: wt= "unknown"; break; }

  switch (VfitsPeakSortTyp(&vFit)) {
  case FIT_STPOS: st= "positions"; break;
  case FIT_STHIST: st= "input order"; break;
  case FIT_STVOL: st= "volumes"; break;
  default: st= "unknown"; break; }

  UF_PrintP("fit is weighted by %s, peaks are sorted on %s\n", wt, st);
  UF_PrintP("lambda: start: %lg  limits: [%lg,%lg]\n",
	    VfitsLambda(&vFit), VfitsMinLambda(&vFit), VfitsMaxLambda(&vFit));
  UF_PrintP("max. iterations: %d\n", VfitsMaxIterations(&vFit));
  return TRUE;
}
/* ---------------------------------------------------------------------- */
