/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsIndex.c,v 1.2 1994/09/20 14:49:25 vs Exp vs $ */

#define _VsIndex_c

#ifdef __STDC__
# include <stdarg.h>
#else
# include <varargs.h>
#endif

				/* library include files */
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsSpectra.h>
#include <tv/vsUserFace.h>
#include <tv/vsTools.h>

				/* private include files */
#include "VsUserFace.h"

#include "VsActiv.h"
#include "VsError.h"
#include "VsSpectra.h"

#include "VdNotify.h"

#include "VsIndex.h"
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS1 */
int Idx_Read(int min_num, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int Idx_Read(va_alist)
     /* int min_num, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { int min_num= va_arg(ap, int);
    char *fmt= va_arg(ap, char *);
#endif
    char pmt[IOBUFLEN];
    int status= TRUE;
    UFPrintVarArgs(pmt, IOBUFLEN, fmt, ap, status);
    va_end(ap);

    if (!status) { return FALSE; }
    else {
      extern Men_t indexMen;
      VecReset(VidxVec(&vIdx));
      UF_MenuLoop(&indexMen, pmt); }
    if (VidxNum(&vIdx) < min_num) {
      VidxNum(&vIdx)= 0; return FALSE; }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS1 */
int Idx_ReadOne(char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int Idx_ReadOne(va_alist)
     /* char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { char *fmt= va_arg(ap, char *);
#endif
    char pmt[IOBUFLEN];
    int status= TRUE;
    int i;
    UFPrintVarArgs(pmt, IOBUFLEN, fmt, ap, status);
    va_end(ap);

    if (!status) { return -1; }
    else if (UF_IntRead(FALSE, &i, pmt)) {
      int m= VidxMax(&vIdx);
      if (0 <= i && i< m) { VidxSingle(&vIdx)= i; return TRUE; }
      else {
	ErrPrintR("fatal: illegal index value %d not in [0,%d]\n", i, m-1);
	VidxSingle(&vIdx)= -1;
	return FALSE; } }
    else if (!UF_NoArgs()) {
      UF_ResetIllegal(); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Idx_GetOneFree()
{
  int i;
  int m= VidxMax(&vIdx);
  for (i= 0; i< m; i++) {
    if (!VspcsExists(&vSpc, i)) {
      VidxSingle(&vIdx)= i;
      return TRUE; } }
  VidxSingle(&vIdx)= -1;
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Idx_Init(num)
     int num;
{
  VecInit(VidxVec(&vIdx), sizeof(int));
  VidxSingle(&vIdx)= -1;
  if (!VecAlloc(VidxVec(&vIdx), num)) {
    ErrPrintR("fatal: can not allocate index vector\n");
    return FALSE; }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Idx_Loop(execFct, finishFct)
     int (*execFct)();
     int (*finishFct)();
{
  int num= 0;
  int i;
  if (VidxNum(&vIdx)) {
    DN_Delay(TRUE);
    for (i= 0; i< VidxNum(&vIdx); i++) {
      int idx= VidxIdx(&vIdx,i);
      switch ((*execFct)(idx, num)) {
      case IDX_ESKIPPED: break; /* No valid fit or writing failed */
      case IDX_EDONE:    num++; break;
      case IDX_EERROR:   DN_Delay(FALSE); return FALSE;
      }
    }
    DN_Delay(FALSE);
  }
  return (*finishFct)(num);
}
/* ---------------------------------------------------------------------- */
int Idx_Loop2(execFct, finishFct)
     int (*execFct)();
     int (*finishFct)();
{
  int num= 0;

  if (0 <= VidxSingle(&vIdx) && VidxSingle(&vIdx) < VidxMax(&vIdx)) {
    int i;
    int idx0= VidxSingle(&vIdx);
    if (VidxNum(&vIdx)) {
      DN_Delay(TRUE);
      for (i= 0; i< VidxNum(&vIdx); i++) {
	int idx= VidxIdx(&vIdx,i);
	if (idx != idx0) {
	  switch ((*execFct)(idx0, idx, num)) {
	  case IDX_ESKIPPED: break;
	  case IDX_EDONE:    num++; break;
	  case IDX_EERROR:   DN_Delay(FALSE); return FALSE; } } }
      DN_Delay(FALSE); } }
  return (*finishFct)(num);
}
/* ---------------------------------------------------------------------- */
int Idx_Loop3(execFct, finishFct)
     int (*execFct)();
     int (*finishFct)();
{
  int num= 0;

  if (0 <= VidxSingle(&vIdx) && VidxSingle(&vIdx) < VidxMax(&vIdx)) {
    int i;
    int idx0= VidxSingle(&vIdx);
    if (VidxNum(&vIdx)) {
      DN_Delay(TRUE);
      for (i= 0; i< VidxNum(&vIdx); i++) {
	int idx= VidxIdx(&vIdx,i);
	switch ((*execFct)(idx0, idx, num)) {
	case IDX_ESKIPPED: break;
	case IDX_EDONE:    num++; break;
	case IDX_EERROR:   DN_Delay(FALSE); return FALSE; } } }
    DN_Delay(FALSE); } 
  return (*finishFct)(num);
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
int Idx_ReadInt(up, mp)
     UF_t *up;
     Men_t *mp;
{
  int i;
  int m= VidxMax(&vIdx);

  if (UF_IntRead(FALSE, &i, NULL)) {
    if (0 <= i && i< m) {
      int j;
      for (j= 0; j< VidxNum(&vIdx); j++) {
	if (VidxIdx(&vIdx,j) == i) { return TRUE; } }
      VidxIdx(&vIdx,VidxNum(&vIdx))= i; VidxNum(&vIdx)++;
      return TRUE; }
    else {
      UF_PrintE("warning: ignoring illegal index value %d\n", i);
      return FALSE; } }
  MenStatMode(UFMenu(up,UFMenIdx(up)))= UFLEXIT;
  VidxNum(&vIdx)= 0;
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Idx_SetActSpc()
{
  if (!Act_SetDefaultSpc(TRUE)) {
    VidxNum(&vIdx)= 0;
    return FALSE;
  }
  else {
    VidxIdx(&vIdx,0)= VactSpcIdx(vAct);
    VidxNum(&vIdx)= 1;
    return TRUE;
  }
}
/* ---------------------------------------------------------------------- */
int Idx_SetAll()
{
  int i;
  VidxNum(&vIdx)= VidxMax(&vIdx);
  for (i= 0; i< VidxNum(&vIdx); i++) { VidxIdx(&vIdx,i)= i; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Idx_SetManaged()
{
  int a, i;
  int num= MIN(VidxMax(&vIdx), VactNum(vAct));
  for (a= 0, i= 0; a< num; a++) {
    if (VactManaged(vAct,a)) {
      VidxIdx(&vIdx,i)= a; i++;
    }
  }
  VidxNum(&vIdx)= i;
  return (i > 0);
}
/* ---------------------------------------------------------------------- */
int Idx_SetVisible()
{
  int a, i;
  int num= MIN(VidxMax(&vIdx), VactNum(vAct));
  for (a= 0, i= 0; a< num; a++) {
    if (VactManaged(vAct,a) && VspcsExists(&vSpc,a)) {
      VidxIdx(&vIdx,i)= a; i++; } }
  VidxNum(&vIdx)= i;
  return (i > 0);
}
/* ---------------------------------------------------------------------- */
