/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsMain.c,v 1.3 1994/09/20 14:49:27 vs Exp vs $ */ 

#define _VsMain_c

/* ============================ */
/* vs initialization and main() */
/* ============================ */

				/* library include files */
#include <tv/vsAlloc.h>
#include <tv/vsArg.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsCut.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsFitIo.h"
#include "VsFitWrite.h"
#include "VsIndex.h"
#include "VsMark.h"
#include "VsNorm.h"
#include "VsPath.h"
#include "VsRecal.h"
#include "VsSearch.h"
#include "VsSpectra.h"
#include "VsUserFace.h"
#include "VsVersion.h"

#include "VdWidget.h"
#include "VdKey.h"
#include "VsNet.h"

				/* interface definition */
#include "VsMain.h"
#include "VsMainP.h"

#define TVPATH			"TVPATH"

#define TVRC			".tvrc"
#define STVRC			"site.tvrc"
#define TVKEYS			".tvkeys"

/*#define SPC_DFLTNUM		16*/
/* now set in tv/Imake.Config */

#define copyRight \
"tv: program version %s (c) (1992-1994),\n\
     J.Theuerkauf, S.Albers, S.Esser, S.Krink, M.Luig, N.Nicolay,\n\
     O.Stuch, R.Wirowski, H.Wolters,\n\
     Institute of Nuclear Physics, University of Cologne.\n\
     All rights reserved. Copying of this Software is authorized to users\n\
     who have executed the true and proper \"License Agreement for TV\"\n\
     with the Institute of Nuclear Physics, University of Cologne\n\
     Especially the program may be used free of charge,\n\
     provided that the following conditions are met:\n\
     - There is no warranty of any kind for all parts of the code.\n\
     - If the use of the program is connected to any form of\n\
       publication, the authors must be cited correctly:\n\
\n\
       > J.Theuerkauf, S.Albers, S.Esser, S.Krink, M.Luig, N.Nicolay,\n\
       > O.Stuch, R.Wirowski, H.Wolters; program tv (version %s).\n\
\n\
     - The authors prohibit, that any unauthorized person give away \n\
       or sell copies of this software. Copies are given by the authors\n\
       under the following postal address: Universitaet zu Koeln,\n\
       Zuelpicherstr. 77, D-50937 Koeln, Fed. Rep. of Germany;\n\
       or under the email address: postmaster@ikp.uni-koeln.de.\n"


static char *pname;

int main(argc, argv, envp)
     int argc;
     char **argv;
     char *envp[];
{
#if defined(MALLOC_DEBUG) && defined(HAS_MALLOC_DEBUG)
  { int level;
    extern malloc_debug();

    malloc_debug(0);
    if (ArgRmOptionInt(&argc, argv, "-malloc_debug", &level) > 0) {
      if (0 <= level && level <= 2) {
	fprintf(stderr, "malloc-debug-level %d -> %d\n",
		malloc_debug(level), level); }
      else {
	fprintf(stderr, "malloc-debug-level %d not in [0,2]\n", level);
	exit(1); } } }
#endif

  AlcOpen("Tv.protocol", "w", 200000);
  pname= argv[0];

  Version_Init();

  if (!UF_Init(TVPATH)) {
    exit(1); }

  if (ArgRmOption(&argc, argv, "-v") > 0) {
    MainVersion();
    exit(0); }
    
  if (!MainInit(&argc, argv)) {	/* set start & default values   */
    UF_PrintE("\n");
    AlcClose();
    exit(1); }

  ErrClear();

  /* UDP-TESTS */

  UF_Loop();

  AlcClose();

#ifdef HAS_SHM
  if (SpcSharedMemory) { extern void shm_free_all(); shm_free_all(); }
#endif

  exit(0);
}
/* ---------------------------------------------------------------------- */
int MainInit(argc, argv)
     int *argc;
     char **argv;
{
  int spcNum= SPC_DFLTNUM;
  int r;
  int e;
  int m;
  int s;
  char *cmd;
				/* initialize dimensions */
  if (ArgRmOptionInt(argc, argv, "-s", &spcNum) < 0 ||
#ifdef HAVE_ALLOCA
      ArgRmOptionInt(argc, argv, "-res", &SpcMaxRes) < 0 ||
#endif
#ifdef HAS_SHM
      (m= ArgRmOption(argc, argv, "-shm")) < 0 ||
#endif HAS_SHM
      (e= ArgRmOptionString(argc, argv, "-e", &cmd)) < 0 ||

      (r= ArgRmOption(argc, argv, "-rc")) < 0 ||

      (s= ArgRmOption(argc, argv, "-src")) < 0 ||

      ArgRmOption(argc, argv, "-help") ||
      ArgRmOption(argc, argv, "-?")) {
    MainUsage();
    return FALSE; }

  if (e != 0 && !UF_BufferSet(cmd)) { /* startup command */
    ErrPrint("");
    return FALSE; }
  if (m > 0) { SpcSharedMemory= TRUE; }

  if (!Pth_Init()){
    return FALSE;}
    
  if (r == 0) {
    UF_FileOpen(TVRC, TRUE, TRUE); }
  if (s == 0) {
    UF_FileOpen(STVRC, TRUE, TRUE); }

  ErrClear();


  if (Act_Init(spcNum, "tv-root") &&
      Spc_Init(spcNum) &&
      Cal_Init(spcNum) &&
      Cut_Init(spcNum) &&	/* needs initialized vSpc (Spc_Init()) */
      Fio_Init(spcNum) &&
      Fit_Init(spcNum) &&
      FW_Init() &&
      Idx_Init(spcNum) &&
      Mrk_Init() &&
      Nrm_Init(spcNum) &&
      Sea_Init(spcNum) &&
      Rcl_Init(spcNum)
#ifndef NO_VD_GRAPHIC
      && DW_Init(spcNum, argc, argv) /* initialize graphic */
#endif				/* NO_VD_GRAPHIC */
      ) {
#ifndef NO_VD_GRAPHIC
    UF_GraphicInit();
    ErrClear();
    KT_ReadFile("default", TVKEYS, FALSE, TRUE);
#endif
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
int MainReadMe()
{
  MainVersion();
  MainUsage();
  Interface();
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int MainUsage()
{
  UF_PrintE("usage: %s <options>", pname);
  UF_PrintE("  the following options are available:\n");
  UF_PrintE("    -? or -help : display this message\n");
  UF_PrintE("    -shm        : use shared memory spectra\n");
  UF_PrintE("    -src        : ignore 'site.tvrc'\n");
  UF_PrintE("    -rc         : ignore '.tvrc'\n");
  UF_PrintE("    -v          : print information on version\n");
  UF_PrintE("    -s <ns>     : set number of spectra buffer to <ns>\n");
#ifdef HAVE_ALLOCA
  UF_PrintE("    -res <mr>   : set maximal spectra resolution to <mr>\n");
#endif				/* not available on all operating systems */
  UF_PrintE("    -e <string> : execute command string <string>\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int MainVersion()
{
  UF_PrintM("This is tv version %s created %s %s\n",
	    vsVersionRevision, vsVersionDate, vsVersionTime);
  UF_PrintM(copyRight, vsVersionRevision, vsVersionRevision);
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Interface()
{
#if 0
Interface Menu

Strings should be enclosed in double quotes '"' to ensure their
interpretation. The backslash '\\' quotes special characters in strings
where the C-syntax is used, e.g. '\n' or '\033'.

Some special characters can be used on all menu levels
@<command file> opens the command file <command file>

%<system command string> executes <system command string>. If string
contains any blanks ' ' it must be enclosed in double quotes '"'.

 #<comment string> the rest of the line is ignored.

? gives some minimal help on requested input:
menu> ?               menu alternatives
menu> <function> ?    function argument syntax
parameter> ?          valid input for a requested parameter


  customization

edit mode   alias unalias
cursor mode tvkeys keyalias keyunalias

Resources Xtv*GowVsWidget.Translations Xtv*io*text*Translations

For an efficient usage you must appropriately configure tv to minimize
the keyboard input, i.e.  you should predefine frequently used command
sequences in aliases, keydefinitions, and command files.

Command files and aliases accept parameters $(0) $(1) ...  Non numeric
expressions of the form $(env) tv tries to substitute by the value of
an environment variable.

example:
  alias "read" "$(1) read"
  "read spectrum" expands to "spectrum read"
  "read fit" expands to "fit read"



environment variables $(env)
#endif
  return TRUE;
}
/* ---------------------------------------------------------------------- */
