/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsMark.c,v 1.4 1994/12/08 20:45:39 vs Exp vs $ */ 

#define _VsMark_c

				/* library include files */
#include <tv/vsTypes.h>
#include <tv/vsMark.h>
#include <tv/vsPath.h>
#include <tv/vsTools.h>
#include <tv/vsUserFace.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsPath.h"
#include "VsUserFace.h"

#include "VdNotify.h"

#include "VsMark.h"
#include "VsMarkP.h"
/* ---------------------------------------------------------------------- */
#define MAX_PREC		16
#define VmrkScaleText(p)	VactScaleText(VmrkScale(p))
/* ---------------------------------------------------------------------- */
static void Mrk_Changed(vp, sid)
     Vmrk_t *vp;
     SerialId_t sid;
{
  DN_ChangedMark(VmrkMrk(vp), VmrkSgl(vp));
  if (sid) { SerialIdCp(VmrkMrkSerialId(vp), sid); }
  else { SerialIdGet(VmrkMrkSerialId(vp)); }
}
/* ---------------------------------------------------------------------- */
int Mrk_Check(name, mp)
     char *name;
     PVec_t mp;
{
  if (!VecNum(mp)) {
    ErrPrintR("fatal: no %s marker available\n", name);
    return FALSE; }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Mrk_Compress(mp, name)
     PVec_t mp;
     char *name;
{
  double c= MrkRange(mp);
  MrkCompress(mp);
  if (c != MrkRange(mp)) {
    UF_PrintE("warning: compressing overlapping %s\n", name); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_Consistent(mrk, maxVal)
     PVec_t mrk;
     int maxVal;
{
  int i;
  double r= MrkRange(mrk);
  for (i= 0; i< VecNum(mrk); i++) {
    if (PVecX2(mrk,i) < 0 || maxVal <= PVecX1(mrk,i)) {
      VecDelete(mrk, i, 1); }
    else {
      if (maxVal <= PVecX2(mrk,i)) { PVecX2(mrk,i)= maxVal-1; }
      if (PVecX1(mrk,i) < 0) { PVecX1(mrk,i)= 0; } } }
  if (r != MrkRange(mrk)) {
    UF_PrintE("warning: marker range exceeded channel range [0,%d]\n",
	      maxVal-1);
    return FALSE; }
  else { return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Mrk_CursorH()
{
#ifndef NO_VD_GRAPHIC
  extern int DM_GetHMark();
  double value;

  if (!DM_GetHMark(&value)) {
    UF_Reset();
    return FALSE; }
  else {
    Mrk_WorkEnter(value, FALSE);
    return TRUE; }
#else
  ErrPrintR("fatal: cursor not available\n");
  return FALSE;
#endif
}
/* ---------------------------------------------------------------------- */
int Mrk_CursorV()
{
#ifndef NO_VD_GRAPHIC
  extern int DM_GetVMark();
  double value;
  int calibrated;

  if (!DM_GetVMark(&value, &calibrated)) {
    UF_Reset(); return FALSE; }
  else {
    if (VmrkCalibrated(VmrksWork(&vMrk)) != calibrated) {
      value= (calibrated ?
	      CalC(VmrksCal(&vMrk), value) :
	      CalP(VmrksCal(&vMrk), value)); }
    Mrk_WorkEnter(value, TRUE);
    return TRUE; }
#else
  ErrPrintR("fatal: cursor not available\n");
  return FALSE;
#endif
}
/* ---------------------------------------------------------------------- */
static int Mrk_Delete(vp)
     Vmrk_t *vp;
{
  PVec_t mp= VmrkMrk(vp);
  int o= VmrkOdd(vp);
  double c= MrkRange(mp);

  VmrksWork(&vMrk)= vp;

  if (!VmrkOdd(vp) && !VecNum(mp)) {
    UF_PrintE("warning: no %s to delete\n", VmrkName(vp));
    UF_SkipArgs();
    return TRUE; }
  else {
    extern Men_t mrkWorkDeleteMen;
    char pmt[IOBUFLEN];

    Act_SetDefaultSpc(FALSE);
    sprintf(pmt, "delete %s [%s]", VmrkName(vp), VmrkScaleText(vp));

    VmrksCal(&vMrk)= VcalsCal(&vCal,VactSpcIdx(vAct));
    VmrksScale(&vMrk)= VmrkScale(vp);
    UF_MenuLoop(&mrkWorkDeleteMen, pmt);

    if (o == VmrkOdd(vp) && c == MrkRange(mp)) {
      UF_PrintE("warning: no %s deleted\n", VmrkName(vp)); return FALSE; }
    if (o != VmrkOdd(vp) || c != MrkRange(mp)) { Mrk_Changed(vp, 0); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_DeleteVertical()
{
  UF_SkipArgs(); return Mrk_Reset(VmrksVertical(&vMrk));
}
/* ---------------------------------------------------------------------- */
int Mrk_DeleteHorizontal()
{
  UF_SkipArgs(); return Mrk_Reset(VmrksHorizontal(&vMrk));
}
/* ---------------------------------------------------------------------- */
int Mrk_DeleteRcl() { return Mrk_Delete(VmrksRcl(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_DeleteCut()
{
  int ret_val;
  DN_Delay(TRUE);
  ret_val= (Mrk_Reset(VmrksGate(&vMrk)) && Mrk_Reset(VmrksGateBg(&vMrk)));
  DN_Delay(FALSE);
  return ret_val;
}
/* ---------------------------------------------------------------------- */
int Mrk_DeleteGate() { return Mrk_Delete(VmrksGate(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_DeleteBgGate() { return Mrk_Delete(VmrksGateBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_DeleteFit()
{
  int ret_val;
  DN_Delay(TRUE);
  ret_val= (Mrk_Reset(VmrksFitBg(&vMrk)) &&
	    Mrk_Reset(VmrksFitReg(&vMrk)) &&
	    Mrk_Reset(VmrksFitBin(&vMrk)));
  DN_Delay(FALSE);
  return ret_val;
}
/* ---------------------------------------------------------------------- */
int Mrk_DeleteFitBg() { return Mrk_Delete(VmrksFitBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_DeleteFitReg() { return Mrk_Delete(VmrksFitReg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_DeleteFitBin() { return Mrk_Delete(VmrksFitBin(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_DeleteFitSea() { return Mrk_Delete(VmrksFitSea(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_DeleteNorm()
{
  int ret_val;
  DN_Delay(TRUE);
  ret_val= (Mrk_Reset(VmrksNorm(&vMrk)) &&
	    Mrk_Reset(VmrksNormBg(&vMrk)));
  DN_Delay(FALSE);
  return ret_val;
}
/* ---------------------------------------------------------------------- */
static int Mrk_IgnoreOdd(vp)
     Vmrk_t *vp;
{
  if (VmrkOdd(vp)) {
    UF_PrintE("warning: ignoring odd %s at ", VmrkName(vp));
    UF_PrintE(VmrksFmt(&vMrk), VmrkSingle(vp));
    UF_PrintE(" %s\n", VmrkScaleText(vp));
    return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Mrk_Get(t, f, idx, scale)
     PVec_t t;
     Vmrk_t *f;
     int idx;
     int scale;
{
  if (t == NULL || f == NULL) {
    ErrPrintR("fatal internal: illegal NULL-pointer in Mrk_Get()\n");
    return FALSE; }
  else {
    PVec_t mp= VmrkMrk(f);

    if (!VmrkCalibrated(f)) { Mrk_Compress(mp, VmrkName(f)); }

    if (!VecCopy(t, mp)) {
      ErrPrintR("fatal: can not get actual %s\n", VmrkName(f));
      return FALSE; }

    if (VmrkCalibrated(f) != VactCalibrated(scale)) {
      Mrk_RescalePVec(t, VcalsCal(&vCal,idx), scale, VmrkName(f)); }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
#define MRKINIT(n,vp,m,s) \
{ VmrkName(vp)= n;\
  VmrkMaxNum(vp)= m;\
  VecInit(VmrkMrk(vp), sizeof(Pair_t));\
  VecInit(VmrkStore(vp), sizeof(Pair_t));\
  VmrkScale(vp)= s;\
  SerialIdInit(VmrkMrkSerialId(vp));\
  SerialIdInit(VmrkStoreSerialId(vp)); }

int Mrk_Init()
{
  MRKINIT("vertical-marker", VmrksVertical(&vMrk), 1, ACT_SDEFAULT);

  MRKINIT("horizontal-marker", VmrksHorizontal(&vMrk), 1, ACT_SUNCALIB);

  MRKINIT("recalibration-marker", VmrksRcl(&vMrk), 0, ACT_SUNCALIB);

  MRKINIT("gate-marker", VmrksGate(&vMrk), 0, ACT_SDEFAULT);

  MRKINIT("bg-gate-marker", VmrksGateBg(&vMrk), 0, ACT_SDEFAULT);

  MRKINIT("fit-bg-marker", VmrksFitBg(&vMrk), 0, ACT_SDEFAULT);

  MRKINIT("fit-region-marker", VmrksFitReg(&vMrk), 1, ACT_SDEFAULT);

  MRKINIT("fit-bin-marker", VmrksFitBin(&vMrk), 1, ACT_SDEFAULT);

  MRKINIT("peak-search-marker", VmrksFitSea(&vMrk), 1, ACT_SDEFAULT);

  MRKINIT("normalization-marker", VmrksNorm(&vMrk), 1, ACT_SDEFAULT);

  MRKINIT("normalization-bg-marker", VmrksNormBg(&vMrk), 0, ACT_SDEFAULT);

  MRKINIT("range-marker", VmrksRange(&vMrk), 1, ACT_SDEFAULT);

  VmrksDfltRange(&vMrk)= 1.0;
  VmrksLastVMark(&vMrk)= 0.0;	/* offset 0.0 channels */
  VmrksLastVCalib(&vMrk)= FALSE;
  strcpy(VmrksFmt(&vMrk), "%.1f");

  return TRUE;
}
#undef MRKINIT
/* ---------------------------------------------------------------------- */
int Mrk_FitRegSingle()
{
  VmrkMaxNum(VmrksFitReg(&vMrk))= 1;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_FitRegMultiple()
{
  VmrkMaxNum(VmrksFitReg(&vMrk))= 0;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_Precision()
{
  int precision;
  if (UF_IntRead(FALSE, &precision, "precision of marker output format [%s]",
		 VmrksFmt(&vMrk))) {
    if (precision < 0 || MAX_PREC < precision) {
      UF_PrintE("warning: precision range is [0,%d]", MAX_PREC);
      return FALSE; }
    else { sprintf(VmrksFmt(&vMrk), "%%.%df", precision); return TRUE; } }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Mrk_Put(t, f, idx, scale)
     Vmrk_t *t;
     PVec_t f;
     int idx;
     int scale;
{
  if (t == NULL || f == NULL) {
    ErrPrintR("fatal internal: illegal NULL-pointer in Mrk_Put()\n");
    return FALSE; }
  else {
    PVec_t mp= VmrkMrk(t);

    DN_Delay(TRUE);
    Mrk_Reset(t);

    if (!VactCalibrated(scale)) { Mrk_Compress(f, VmrkName(t)); }

    if (!VecCopy(mp, f)) {
      ErrPrintR("fatal: can not copy %s\n", VmrkName(t));
      DN_Delay(FALSE);
      return FALSE; }

    if (VmrkCalibrated(t) != VactCalibrated(scale)) {
      Mrk_RescalePVec(mp, VcalsCal(&vCal,idx), VmrkScale(t), VmrkName(t)); }
    else if (!VmrkCalibrated(t)) { Mrk_Compress(mp, VmrkName(t)); }

    Mrk_Changed(t, 0);
    DN_Delay(FALSE);
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
static int Mrk_List(vp)
     Vmrk_t *vp;
{
  PVec_t mp= VmrkMrk(vp);

  if (VecNum(mp) == 0 && !VmrkOdd(vp)) {
    UF_PrintM("info: no %s\n", VmrkName(vp)); }
  else {
    int i;

    UF_PrintM("%s [%s]:", VmrkName(vp), VmrkScaleText(vp));

    for (i= 0; i< VecNum(mp); i++) {
      UF_PrintM(" (");
      UF_PrintM(VmrksFmt(&vMrk), PVecX1(mp,i));
      UF_PrintM(", ");
      UF_PrintM(VmrksFmt(&vMrk), PVecX2(mp,i));
      UF_PrintM(")"); }
    if (VmrkOdd(vp)) {
      UF_PrintM(" (");
      UF_PrintM(VmrksFmt(&vMrk), VmrkSingle(vp));
      UF_PrintM(", ...)"); }
    UF_PrintM("\n"); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_ListVertical() { return Mrk_List(VmrksVertical(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ListHorizontal()
{
  Vmrk_t *vp= VmrksHorizontal(&vMrk);
  PVec_t mp= VmrkMrk(vp);

  if (VecNum(mp) == 0 && !VmrkOdd(vp)) {
    UF_PrintM("info: no %s\n", VmrkName(vp)); }
  else {
    int i;

    UF_PrintM("%s:", VmrkName(vp));

    for (i= 0; i< VecNum(mp); i++) {
      UF_PrintM(" (");
      UF_PrintM(VmrksFmt(&vMrk), PVecX1(mp,i));
      UF_PrintM(", ");
      UF_PrintM(VmrksFmt(&vMrk), PVecX2(mp,i));
      UF_PrintM(")"); }
    if (VmrkOdd(vp)) {
      UF_PrintM(" (");
      UF_PrintM(VmrksFmt(&vMrk), VmrkSingle(vp));
      UF_PrintM(", ...)"); }
    UF_PrintM("\n"); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_ListRcl() { return Mrk_List(VmrksRcl(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ListGate() { return Mrk_List(VmrksGate(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ListBgGate() { return Mrk_List(VmrksGateBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ListFitBg() { return Mrk_List(VmrksFitBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ListFitReg() { return Mrk_List(VmrksFitReg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ListFitBin() { return Mrk_List(VmrksFitBin(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ListFitSea() { return Mrk_List(VmrksFitSea(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ListNorm()
{
  return (Mrk_List(VmrksNorm(&vMrk)) & Mrk_List(VmrksNormBg(&vMrk)));
}
/* ---------------------------------------------------------------------- */
static int Mrk_Read(vp)
     Vmrk_t *vp;
{
  DN_Delay(TRUE);
  Mrk_Reset(vp);
  if (VecRead(VpthPath(&vPth), VmrkName(vp), VmrkMrk(vp), TlsScanPVec)) {
    UF_PrintM("%s [%s] read from '%s'\n",
	      VmrkName(vp), VmrkScaleText(vp), PthShort(VpthPath(&vPth)));
    DN_Delay(FALSE);
    return TRUE; }
  else {
    ErrPrintR("fatal: can not read %s from '%s'\n",
	      VmrkName(vp), PthShort(VpthPath(&vPth)));
    UF_Reset();
    DN_Delay(FALSE);
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int Mrk_ReadQuery(vp)
     Vmrk_t *vp;
{
  if (Pth_TokenRead (PTH_TPATH, "", "%s input file", VmrkName(vp)) ==
      PTH_TPATH) {
    return Mrk_Read(vp); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Mrk_ReadVertical() { return Mrk_ReadQuery(VmrksVertical(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ReadHorizontal() { return Mrk_ReadQuery(VmrksHorizontal(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ReadRcl() { return Mrk_ReadQuery(VmrksRcl(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ReadGate() { return Mrk_ReadQuery(VmrksGate(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ReadBgGate() { return Mrk_ReadQuery(VmrksGateBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ReadFitBg() { return Mrk_ReadQuery(VmrksFitBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ReadFitReg() { return Mrk_ReadQuery(VmrksFitReg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ReadFitBin() { return Mrk_ReadQuery(VmrksFitBin(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ReadFitSea() { return Mrk_ReadQuery(VmrksFitSea(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ReadNorm()
{
  return (Mrk_ReadQuery(VmrksNorm(&vMrk)) &&
	  Mrk_Read(VmrksNormBg(&vMrk)));
}
/* ---------------------------------------------------------------------- */
static int Mrk_RescaleVmrk(vp, cal, scale)
     Vmrk_t *vp;
     Cal_t cal;
     int scale;
{
  if (VmrkCalibrated(vp) != VactCalibrated(scale)) {
    pfd_t calFct= VactCalibrated(scale) ? CalP : CalC;

    VmrkSingle(vp)= calFct(cal, VmrkSingle(vp));
    Mrk_RescalePVec(VmrkMrk(vp), cal, scale, VmrkName(vp)); }
  VmrkScale(vp)= scale;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_RescalePVec(pp, cal, scale, name)
     PVec_t pp;
     Cal_t cal;
     int scale;
     char *name;
{
  pfd_t calFct= VactCalibrated(scale) ? CalP : CalC;
  int i;

  for (i= 0; i< VecNum(pp); i++) {
    PVecX1(pp,i)= calFct(cal, PVecX1(pp,i));
    PVecX2(pp,i)= calFct(cal, PVecX2(pp,i)); }
  if (!VactCalibrated(scale)) {
    for (i= 0; i< VecNum(pp); i++) {
      PVecX1(pp,i)= NINT(PVecX1(pp,i));
      PVecX2(pp,i)= NINT(PVecX2(pp,i)); }
    Mrk_Compress(pp, name); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_Reset(vp)
     Vmrk_t *vp;
{
  int changed= (VecNum(VmrkMrk(vp)) || VmrkOdd(vp));
  VecReset(VmrkMrk(vp));
  VmrkOdd(vp)= FALSE;
  if (changed) {
    Mrk_Changed(vp, 0);
  }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Mrk_Restore(vp)
     Vmrk_t *vp;
{
  if (!VecNum(VmrkStore(vp))) {
    UF_PrintE("warning: no %s stored\n", VmrkName(vp)); }

  if (VecCopy(VmrkMrk(vp), VmrkStore(vp))) {
    Mrk_Changed(vp, VmrkStoreSerialId(vp));
    return TRUE; }
  else {
    ErrPrintR("fatal: can not restore %s\n", VmrkName(vp));
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Mrk_RestoreVertical() { return Mrk_Restore(VmrksVertical(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_RestoreHorizontal() { return Mrk_Restore(VmrksHorizontal(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_RestoreRcl() { return Mrk_Restore(VmrksRcl(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_RestoreGate() { return Mrk_Restore(VmrksGate(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_RestoreBgGate() { return Mrk_Restore(VmrksGateBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_RestoreFitBg() { return Mrk_Restore(VmrksFitBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_RestoreFitReg() { return Mrk_Restore(VmrksFitReg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_RestoreFitBin() { return Mrk_Restore(VmrksFitBin(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_RestoreFitSea() { return Mrk_Restore(VmrksFitSea(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_RestoreNorm()
{
  return (Mrk_Restore(VmrksNorm(&vMrk)) && Mrk_Restore(VmrksNormBg(&vMrk)));
}
/* ---------------------------------------------------------------------- */
static int Mrk_Enter(vp)
     Vmrk_t *vp;
{
  extern Men_t mrkWorkEnterVMen;
  char pmt[IOBUFLEN];

  Act_SetDefaultSpc(FALSE);
  VmrksWork(&vMrk)= vp;
  sprintf(pmt, "enter %s [%s]", VmrkName(vp), VmrkScaleText(vp));

  VmrksCal(&vMrk)= VcalsCal(&vCal,VactSpcIdx(vAct));

  UF_MenuLoop(&mrkWorkEnterVMen, pmt);

  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterVertical()
{
  return Mrk_Enter(VmrksVertical(&vMrk)); 
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterHorizontal()
{
  Vmrk_t *vp= VmrksHorizontal(&vMrk);
  extern Men_t mrkWorkEnterHMen;
  char pmt[IOBUFLEN];

  Act_SetDefaultSpc(FALSE);
  VmrksWork(&vMrk)= vp;
  sprintf(pmt, "enter %s", VmrkName(vp));

  VmrksCal(&vMrk)= NULL;

  UF_MenuLoop(&mrkWorkEnterHMen, pmt);

  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterRcl()
{
  return Mrk_Enter(VmrksRcl(&vMrk));
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterGate()
{
  return Mrk_Enter(VmrksGate(&vMrk));
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterBgGate()
{
  return Mrk_Enter(VmrksGateBg(&vMrk));
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterCut()
{
  if (VecNum(VmrkMrk(VmrksGate(&vMrk)))) { return Mrk_EnterBgGate(); }
  else { return Mrk_EnterGate(); }
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterFitBg()
{
  return Mrk_Enter(VmrksFitBg(&vMrk));
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterFitReg()
{
  return Mrk_Enter(VmrksFitReg(&vMrk));
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterFitBin()
{
  return Mrk_Enter(VmrksFitBin(&vMrk));
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterFitSea()
{
  return Mrk_Enter(VmrksFitSea(&vMrk));
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterNorm()
{
  if (VecNum(VmrkMrk(VmrksNorm(&vMrk)))) {
    return Mrk_Enter(VmrksNormBg(&vMrk)); }
  else {
    return Mrk_Enter(VmrksNorm(&vMrk)); }
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterRange(dflt_scale, range_scale, idx)
     int dflt_scale;
     int range_scale;
     int idx;
{
  Vmrk_t *rp= VmrksRange(&vMrk);
  Cal_t cal= VcalsCal(&vCal,idx);
  Mrk_Reset(rp);
  VmrkScale(rp)= dflt_scale;
  if (!Mrk_Enter(rp)) { return FALSE; }
  if (VmrkOdd(rp)) {
    VmrkOdd(rp)= FALSE;
    if (!MrkInsert(VmrkMrk(rp),
		   VmrkSingle(rp)-VmrksDfltRange(&vMrk),
		   VmrkSingle(rp)+VmrksDfltRange(&vMrk))) {
      ErrPrintR("fatal: can not insert %s at ", VmrkName(rp));
      UF_PrintE(VmrksFmt(&vMrk), VmrkSingle(rp));
      UF_PrintE("\n");
      return FALSE; } }
  else if (!VecNum(VmrkMrk(rp))) {
    return FALSE;
  }
  Mrk_RescaleVmrk(rp, cal, range_scale);
  Mrk_Changed(rp, 0);
  MrkCompress(VmrkMrk(rp));
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterSingleV(scale, cal, value, pmt)
     int scale;
     Cal_t cal;
     double *value;
     char *pmt;
{
  extern Men_t mrkEnterSingleVMen;
  Vmrk_t *mp= VmrksRange(&vMrk);

  Mrk_Reset(mp);
  VmrkScale(mp)= VmrksScale(&vMrk)= scale;
  VmrksCal(&vMrk)= cal;
  VmrksWork(&vMrk)= VmrksRange(&vMrk);
  UF_MenuLoop(&mrkEnterSingleVMen, pmt);
  if (VmrkOdd(mp)) {
    *value= VmrkSingle(mp);
    return TRUE;
  }
  else {
    return FALSE;
  }
}
/* ---------------------------------------------------------------------- */
int Mrk_EnterSingleH(scale, value, pmt)
     int scale;
     double *value;
     char *pmt;
{
  extern Men_t mrkEnterSingleHMen;
  Vmrk_t *mp= VmrksRange(&vMrk);

  Mrk_Reset(mp);
  VmrkScale(mp)= VmrksScale(&vMrk)= scale;
  VmrksWork(&vMrk)= VmrksRange(&vMrk);
  UF_MenuLoop(&mrkEnterSingleHMen, pmt);
  if (VmrkOdd(mp)) {
    *value= VmrkSingle(mp);
    return TRUE;
  }
  else {
    return FALSE;
  }
}
/* ---------------------------------------------------------------------- */
static int Mrk_Store(vp)
     Vmrk_t *vp;
{
  if (!VecNum(VmrkMrk(vp))) {
    UF_PrintE("warning: no %s\n", VmrkName(vp)); return TRUE; }

  if (VecCopy(VmrkStore(vp), VmrkMrk(vp))) {
    Mrk_IgnoreOdd(vp);
    SerialIdCp(VmrkStoreSerialId(vp), VmrkMrkSerialId(vp));
    return TRUE; }
  else {
    ErrPrintR("fatal: can not store %s\n", VmrkName(vp));
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Mrk_StoreVertical() { return Mrk_Store(VmrksVertical(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_StoreHorizontal() { return Mrk_Store(VmrksHorizontal(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_StoreRcl() { return Mrk_Store(VmrksRcl(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_StoreGate() { return Mrk_Store(VmrksGate(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_StoreBgGate() { return Mrk_Store(VmrksGateBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_StoreFitBg() { return Mrk_Store(VmrksFitBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_StoreFitReg() { return Mrk_Store(VmrksFitReg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_StoreFitBin() { return Mrk_Store(VmrksFitBin(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_StoreFitSea() { return Mrk_Store(VmrksFitSea(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_StoreNorm()
{
  return (Mrk_Store(VmrksNorm(&vMrk)) &&
	  Mrk_Store(VmrksNormBg(&vMrk)));
}
/* ---------------------------------------------------------------------- */
static int Mrk_Scale(vp)
     Vmrk_t *vp;
{
  int scale= VmrkScale(vp);
  return (Act_Scale(&scale, VmrkName(vp)) && Mrk_SetScale(vp, scale));
}
/* ---------------------------------------------------------------------- */
static int Mrk_SetScale(vp, scale)
     Vmrk_t *vp;
     int scale;
{
  if (VactCalibrated(VmrkScale(vp)) != VactCalibrated(scale)) {
    Act_SetDefaultSpc(FALSE);
    Mrk_RescaleVmrk(vp, VcalsCal(&vCal,VactSpcIdx(vAct)), scale);
    DN_ChangedMarkScale(VmrkMrk(vp), VmrkSgl(vp)); }
  else { VmrkScale(vp)= scale; }

  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_ScaleCut()
{
  int ret_val;
  int scale= VmrkScale(VmrksGate(&vMrk));
  DN_Delay(TRUE);
  ret_val= (Act_Scale(&scale, "cut") &&
	    Mrk_SetScale(VmrksGate(&vMrk), scale) &&
	    Mrk_SetScale(VmrksGateBg(&vMrk), scale));
  DN_Delay(FALSE);
  return ret_val;
}
/* ---------------------------------------------------------------------- */
int Mrk_ScaleFit()
{
  int ret_val;
  int scale= VmrkScale(VmrksFitBg(&vMrk));
  DN_Delay(TRUE);
  ret_val= (Act_Scale(&scale, "fit") &&
	    Mrk_SetScale(VmrksFitBg(&vMrk), scale) &&
	    Mrk_SetScale(VmrksFitReg(&vMrk), scale) &&
	    Mrk_SetScale(VmrksFitBin(&vMrk), scale));
  DN_Delay(FALSE);
  return ret_val;
}
/* ---------------------------------------------------------------------- */
int Mrk_ScaleFitSea() { return Mrk_Scale(VmrksFitSea(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_ScaleNorm()
{
  int ret_val;
  int scale= VmrkScale(VmrksNorm(&vMrk));
  DN_Delay(TRUE);
  ret_val= (Act_Scale(&scale, "normalization") &&
	    Mrk_SetScale(VmrksNorm(&vMrk), scale) &&
	    Mrk_SetScale(VmrksNormBg(&vMrk), scale));
  DN_Delay(FALSE);
  return ret_val;
}
/* ---------------------------------------------------------------------- */
int Mrk_UnitCalib()
{
  VmrksScale(&vMrk)= ACT_SCALIBRATED;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_UnitUncalib()
{
  VmrksScale(&vMrk)= ACT_SUNCALIB;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Mrk_ValueRead(scale, cal, value, name)
     int scale;
     Cal_t cal;
     double *value;
     char *name;
{
  double precision;

  if (!UF_RealRead(FALSE, value, &precision, "%s [%s]", name,
		   (VactCalibrated(scale) ? "calibrated" : "uncalibrated"))) {
    UF_ResetIllegal();
    return FALSE; }
  else {
    VmrksScale(&vMrk)= scale;
    if (!UF_NoArgs()) {
      extern Men_t mrkUnitMen;
      UF_MenuLoop(&mrkUnitMen, "marker unit"); }
    if (VactCalibrated(VmrksScale(&vMrk)) != VactCalibrated(scale)) {
      *value= (VactCalibrated(scale) ?
	       CalP(cal, *value) : CalC(cal, *value)); }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Mrk_ValueReadOffset(scale, cal, value, name)
     int scale;
     Cal_t cal;
     double *value;
     char *name;
{
  double precision;

  if (!UF_RealRead(FALSE, value, &precision, "%s [%s]", name,
		   (VactCalibrated(scale) ? "calibrated" : "uncalibrated"))) {
    UF_ResetIllegal();
    return FALSE; }
  else {
    VmrksScale(&vMrk)= scale;
    if (!UF_NoArgs()) {
      extern Men_t mrkUnitMen;
      UF_MenuLoop(&mrkUnitMen, "marker unit"); }
    if (VactCalibrated(VmrksScale(&vMrk)) != VmrksLastVCalib(&vMrk)) {
      *value= (VmrksLastVCalib(&vMrk) ?
	       CalP(cal, *value) : CalC(cal, *value)); }
    *value += VmrksLastVMark(&vMrk);
    if (VmrksLastVCalib(&vMrk) != VactCalibrated(scale)) {
      *value= (VactCalibrated(scale) ?
	       CalP(cal, *value) : CalC(cal, *value)); }
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Mrk_WorkDelete()
{
  Vmrk_t *wp= VmrksWork(&vMrk);
  PVec_t rp= VmrkMrk(VmrksRange(&vMrk));
  Mrk_EnterRange(VmrkScale(wp), VmrkScale(wp), VactSpcIdx(vAct));
  if (VmrkOdd(wp) && VecNum(rp)) {
    if (PVecX1(rp,0) <= VmrkSingle(wp) && VmrkSingle(wp) <= PVecX2(rp,0)) {
      VmrkOdd(wp)= FALSE; } }
  return MrkDelete(VmrkMrk(wp), rp);
}
/* ---------------------------------------------------------------------- */
int Mrk_WorkReadH()
{
  double value;
  double precision;

  return (UF_RealRead(FALSE, &value, &precision, "") &&
	  Mrk_WorkEnter(value, FALSE));
}
/* ---------------------------------------------------------------------- */
int Mrk_WorkReadV()
{
  double value;

  return (Mrk_ValueRead(VmrkScale(VmrksWork(&vMrk)), VmrksCal(&vMrk),
			&value, "") &&
	  Mrk_WorkEnter(value, TRUE));
}
/* ---------------------------------------------------------------------- */
int Mrk_WorkReadVOffset()
{
  double value;

  return (Mrk_ValueReadOffset(VmrkScale(VmrksWork(&vMrk)), VmrksCal(&vMrk),
			      &value, "") &&
	  Mrk_WorkEnter(value, TRUE));
}
/* ---------------------------------------------------------------------- */
int Mrk_WorkReset()
{
  return Mrk_Reset(VmrksWork(&vMrk));
}
/* ---------------------------------------------------------------------- */
static int Mrk_WorkEnter(value, vertical)
     double value;
     int vertical;
{
  Vmrk_t *wp= VmrksWork(&vMrk);
  PVec_t pp= VmrkMrk(wp);

  if (VmrkOdd(wp)) {
    VmrkOdd(wp)= FALSE;
    if (!MrkInsert(pp, value, VmrkSingle(wp))) {
      ErrPrintR("fatal: can not insert %s at ", VmrkName(wp));
      UF_PrintE(VmrksFmt(&vMrk), value);
      UF_PrintE("\n");
      return FALSE; }
    VmrkSingle(wp)= value;	/* store last mark in Single */
    Mrk_Changed(wp, 0); }
  else {
    VmrkOdd(wp)= TRUE;

    switch (VmrkMaxNum(wp)) {
    case 0: break;		/* no limit */
    case 1:			/* one pair */
      if (VecNum(pp)) {	/* use always 2 most recent entered marks */
	VmrkOdd(wp)= FALSE;
	PVecX1(pp,0)= MIN(VmrkSingle(wp), value);
	PVecX2(pp,0)= MAX(VmrkSingle(wp), value);
	Mrk_Changed(wp, 0); }
      break;
    default: break; }		/* no limit */
    VmrkSingle(wp)= value;	/* store last mark in Single */
    Mrk_Changed(wp, VmrkMrkSerialId(wp)); } /* do not change serial Id */
  if (vertical) {
    VmrksLastVMark(&vMrk)= value;
    VmrksLastVCalib(&vMrk)= VmrkCalibrated(wp); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Mrk_Write(vp, mode)
     Vmrk_t *vp;
     char *mode;
{
  Mrk_IgnoreOdd(vp);
  if (VecWrite(VpthPath(&vPth), mode, VmrkName(vp), VmrkMrk(vp),
	       TlsPrintPVec)) {
    UF_PrintM("%s written to '%s'\n",
	      VmrkName(vp), PthShort(VpthPath(&vPth)));
    return TRUE; }
  else {
    ErrPrintR("fatal: can not write %s to '%s'\n",
	      VmrkName(vp), PthShort(VpthPath(&vPth)));
    UF_Reset();
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int Mrk_WriteQuery(vp)
     Vmrk_t *vp;
{
  if (Pth_TokenRead (PTH_TPATH, "", "%s output file", VmrkName(vp)) ==
      PTH_TPATH) {
    return Mrk_Write(vp, "w"); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int Mrk_WriteVertical() { return Mrk_WriteQuery(VmrksVertical(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_WriteHorizontal() { return Mrk_WriteQuery(VmrksHorizontal(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_WriteRcl() { return Mrk_WriteQuery(VmrksRcl(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_WriteGate() { return Mrk_WriteQuery(VmrksGate(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_WriteBgGate() { return Mrk_WriteQuery(VmrksGateBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_WriteFitBg() { return Mrk_WriteQuery(VmrksFitBg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_WriteFitReg() { return Mrk_WriteQuery(VmrksFitReg(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_WriteFitBin() { return Mrk_WriteQuery(VmrksFitBin(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_WriteFitSea() { return Mrk_WriteQuery(VmrksFitSea(&vMrk)); }
/* ---------------------------------------------------------------------- */
int Mrk_WriteNorm()
{
  return (Mrk_WriteQuery(VmrksNorm(&vMrk)) &&
	  Mrk_Write(VmrksNormBg(&vMrk), "a"));
}
/* ---------------------------------------------------------------------- */
