/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsMark.h,v 1.3 1994/09/20 14:49:30 vs Exp vs $ */ 
/* -------------------------------------------------------------------------
 *                    VsMark.h
 */
#ifndef _VsMark_h
#define _VsMark_h

#include <tv/SerialId.h>
#include <tv/vsTypes.h>

typedef struct {		/* mark */
  SerialId_t mrkSerialId;	/* last SerialId on mrk */
  SerialId_t storeSerialId;	/* last SerialId on store */
  int scale;			/* scaling of marks */
  char *name;			/* name for prompt during input */
  int maxNum;
  ValRec sgl;			/* single value */
  PVecRec mrk;			/* for actual input */
  PVecRec store;		/* stored marks */
} Vmrk_t;

#define VmrkMrkSerialId(mp)	((mp)->mrkSerialId)
#define VmrkStoreSerialId(mp)	((mp)->storeSerialId)
#define VmrkScale(mp)		((mp)->scale)
#define VmrkCalibrated(mp)	VactCalibrated(VmrkScale(mp))
#define VmrkName(mp)		((mp)->name)
#define VmrkMaxNum(mp)		((mp)->maxNum)
#define VmrkSgl(mp)		(&(mp)->sgl)
#define VmrkOdd(mp)		ValDefined(VmrkSgl(mp))
#define VmrkSingle(mp)		ValValue(VmrkSgl(mp))
#define VmrkMrk(mp)		(&(mp)->mrk)
#define VmrkStore(mp)		(&(mp)->store)

#define MRK_VERTICAL	0	/* vertical (default) */
#define MRK_RCL		1	/* recalibration */
#define MRK_GATE	2	/* cut */
#define MRK_GATEBG	3
#define MRK_FITBG	4	/* fit */
#define MRK_FITREG	5
#define MRK_FITBIN	6
#define MRK_FITSEA	7	/* peak search range */
#define MRK_NORM	8	/* normalization */
#define MRK_NORMBG	9
#define MRK_RANGE	10	/* range */

#define MRK_NUM		11

typedef struct {
  Vmrk_t mrks[MRK_NUM];
  Vmrk_t horizontal;
  Vmrk_t *work;
  double dfltRange;		/* offset for single mark of range */
  int scale;
  Cal_t cal;
  double lastVMark;
  int lastVCalib;
  char fmt[16];
} Vmrks_t;

#define VmrksMrks(mp)		((mp)->mrks)
#define VmrksVertical(mp)	(VmrksMrks(mp)+MRK_VERTICAL)
#define VmrksRcl(mp)		(VmrksMrks(mp)+MRK_RCL)
#define VmrksGate(mp)		(VmrksMrks(mp)+MRK_GATE)
#define VmrksGateBg(mp)		(VmrksMrks(mp)+MRK_GATEBG)
#define VmrksFitBg(mp)		(VmrksMrks(mp)+MRK_FITBG)
#define VmrksFitReg(mp)		(VmrksMrks(mp)+MRK_FITREG)
#define VmrksFitBin(mp)		(VmrksMrks(mp)+MRK_FITBIN)
#define VmrksFitSea(mp)		(VmrksMrks(mp)+MRK_FITSEA)
#define VmrksNorm(mp)		(VmrksMrks(mp)+MRK_NORM)
#define VmrksNormBg(mp)		(VmrksMrks(mp)+MRK_NORMBG)
#define VmrksRange(mp)		(VmrksMrks(mp)+MRK_RANGE)
#define VmrksHorizontal(mp)	(&(mp)->horizontal)
#define VmrksWork(mp)		((mp)->work)
#define VmrksDfltRange(mp)	((mp)->dfltRange)
#define VmrksScale(mp)		((mp)->scale)
#define VmrksCal(mp)		((mp)->cal)
#define VmrksLastVMark(mp)	((mp)->lastVMark)
#define VmrksLastVCalib(mp)	((mp)->lastVCalib)
#define VmrksFmt(mp)		((mp)->fmt)

#ifdef _VsMark_c
Vmrks_t vMrk;
#else
extern Vmrks_t vMrk;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsMarkF.h"

#undef P_

#endif				/* _VsMark_h */
/* ------------------------------------------------------------------------- */
