/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsNet.c,v 1.2 1994/05/26 19:52:08 vs Exp vs $ */
/* vs module to read spectra via Ethernet from VME analyzer system */

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <fcntl.h>
/* --- TCP includes --- */
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#if 0
/* --- UDP (via sysdep (c) by IKP) includes --- */
#if defined(__STDC__)
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#error Adjust this includes and add check for them(VsNet.c)
#include <local/sysdep/types.h>
#include <local/sysdep/error.h>
#include <local/sysdep/connection.h>
#include <local/sysdep/transerr.h>
#endif /* 0 */

#include "VsError.h"

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsNet.h"
#include "VsNetP.h"

#undef P_

#define BUF_SIZE (128)
#define IN_PORT 20001 /* SPectraDaemon */
#define ONE_MORE  0
#define LAST      1
#define NET_ERR   -1
/* ------------------------------------------------------------------------- */
int Net_ReadSpc(hostname, sname, buffer)
     char *hostname;
     char *sname;
     char *buffer;
{
  struct hostent *host;
  int s /*, total, count, expected*/;
  struct sockaddr_in sockname;
  u_long fl;
  int sp_res;
  extern int socket();
  extern int bind();
  extern int connect();
  extern int write();
  extern int close();

/*   printf("Net_ReadSpc reading spectrum %s from host %s\n", sname, hostname); */

  if ((host = gethostbyname(hostname)) == (struct hostent *) 0) {
    ErrPrint("can not find entry for host\n");
    return -1; }

  if ((s = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    ErrPrint("socket call failed"); 
    return -1;  }

  sockname.sin_family = AF_INET;
  sockname.sin_port = 0;
  sockname.sin_addr.s_addr = INADDR_ANY;
  if (bind(s,(struct sockaddr *) &sockname, sizeof(sockname)) < 0) {
    ErrPrint("socket bind failed");
    return -1; }

  memcpy(&sockname.sin_addr.s_addr, host->h_addr, 4); 
  sockname.sin_port = htons (IN_PORT); 

  if (connect(s,(struct sockaddr *) &sockname, sizeof(sockname)) < 0) {
    return -1; }
  /*total = 0;*/
  fl = htonl (strlen(sname) + 1);
  write (s, &fl, sizeof (long));
  write (s, sname, ntohl (fl));
  
  sp_res = Net_GetSp(s, buffer);
  close (s);
  return sp_res;
}  /* end of main */
/* ------------------------------------------------------------------------- */
static int Net_GetSp (s, buffer)
     int s;
     char *buffer;
{
  u_long mode;
  int total = 0;

/*   printf("Net_GetSp\n"); */

  do {
    Net_Read (s, (char *)&mode, sizeof (long));
/*     printf("Net_Read finished\n"); */
    mode = ntohl (mode);
    if (mode == NET_ERR) {
      /*      printf("NET_ERR detected\n");*/
      return -1;
    }
    if (mode == ONE_MORE) {
      Net_Read (s, buffer, BUF_SIZE);
/*       printf("Net_Read finished\n"); */
      total += BUF_SIZE;
      buffer += BUF_SIZE;
    }
  } while (mode == ONE_MORE);
  return (total / sizeof (long));
}
/* ------------------------------------------------------------------------- */
static int Net_Read (s, b, n)
     int s;
     char *b;
     int n;
{
  int received;
  extern int read();

/*   printf("Net_Read "); */

  while (n > 0 && (received = read (s, b, n)) > 0) {
    n -= received;
    b += received;
/*     printf("%d "); */
  }
/*   printf("\n"); */
  if (received < 0) { return -1; }
  else return (0);
}
/* ------------------------------------------------------------------------- */
