/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsNorm.c,v 1.2 1994/05/26 19:52:09 vs Exp vs $ */
#define _VsNorm_c
				/* library include files */
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsSpectra.h>
#include <tv/vsMark.h>
#include <tv/vsTools.h>
				/* private include files */
#include "VsError.h"
#include "VsIndex.h"
#include "VsMark.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdNotify.h"

#include "VsNorm.h"
#include "VsNormP.h"

/* ---------------------------------------------------------------------- */
int Nrm_Init(num)
     int num;
{
  if (NULL == (VnrmsP(&vNrm)= (Vnrm_t *)Malloc(num * sizeof(Vnrm_t)))) {
    ErrPrintR("fatal: can not initialize normalization buffers\n");
    return FALSE; }
  else {
    int i;
    VnrmsNum(&vNrm)= num;
    for (i= 0; i< num; i++) { Nrm_VnrmInit(VnrmsP(&vNrm) + i); }
    VecInit(VnrmsMrk(&vNrm), sizeof(Pair_t));
    VecInit(VnrmsMrkBg(&vNrm), sizeof(Pair_t));
    SerialIdInit(VnrmsMrkSerialIda(&vNrm));
    SerialIdInit(VnrmsMrkBgSerialIda(&vNrm));

    return TRUE; }
}
/* ---------------------------------------------------------------------- */
static int Nrm_VnrmInit(n)
     Vnrm_t *n;
{
  SerialIdInit(VnrmSpcSerialIda(n));
  VnrmFac(n)= 1.0;
  VnrmSum(n)= 0.0;
  VnrmTyp(n)= NRM_MAX;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Nrm_TypFactor()
{
  double p;
  if (!UF_RealRead(FALSE, &VnrmsLoopFac(&vNrm), &p,
		   "normalization factor")) { return FALSE; }
  else if (UF_NoArgs()) {
    Idx_SetAll(); }		/* default if no further input */
  else if (!Idx_Read(1, "index(s) for normalization by factor")) {
    return FALSE; }

  return Idx_Loop(Nrm_TypExec, Nrm_Finish);
}
/* ---------------------------------------------------------------------- */
int Nrm_TypMaximum()
{
  if (UF_NoArgs()) {
    Idx_SetAll(); }		/* default if no further input */
  else if (!Idx_Read(1, "index(s) for normalization to maximum")) {
    return FALSE; }

  VnrmsLoopTyp(&vNrm)= NRM_MAX;
  return Idx_Loop(Nrm_TypExec, Nrm_Finish);
}
/* ---------------------------------------------------------------------- */
int Nrm_TypOff()
{
  if (UF_NoArgs()) {
    Idx_SetAll(); }		/* default if no further input */
  else if (!Idx_Read(1, "index(s) without normalization")) {
    return FALSE; }

  VnrmsLoopTyp(&vNrm)= NRM_OFF;
  return Idx_Loop(Nrm_TypExec, Nrm_Finish);
}
/* ---------------------------------------------------------------------- */
int Nrm_TypReference()
{
  if (!Idx_ReadOne("normalization reference index") ||
      !Idx_Read(1, "index(s) for normalization to #%d", VidxSingle(&vIdx))) {
    return FALSE; }
  else {
    VnrmsLoopTyp(&vNrm)= NRM_REF;
    return Idx_Loop3(Nrm_Typ2Exec, Nrm_Finish); }
				/* was: return Idx_Loop2(Nrm_Typ2Exec, Nrm_Finish); } 
				 dann kann man aber nicht sowas wie norm 0 all sagen,
				 sodass der normierungsfaktor fuer Spektrum 0 1 wird
				 (es passiert folgendes: 0 wird auf das maximum Spektrum
				 bezogen (bekommt also im allgemeinen einen von 1
				 verschieden norm-faktor), die anderen spektren werden
				 dann auf das UMNORMIERTE Spektrum 0 bezogen)*/
}
/* ---------------------------------------------------------------------- */
int Nrm_TypUnity()
{
  if (UF_NoArgs()) {
    Idx_SetAll(); }		/* default if no further input */
  else if (!Idx_Read(1, "index(s) for normalization to unity")) {
    return FALSE; }

  VnrmsLoopTyp(&vNrm)= NRM_MAX;
  return Idx_Loop(Nrm_TypExec, Nrm_Finish);
}
/* ---------------------------------------------------------------------- */
static int Nrm_Typ2Exec(idx0, idx, num)
     int idx0;
     int idx;
     int num;
{
  VnrmsRef(&vNrm,idx)= idx0;
  VnrmsTyp(&vNrm,idx)= VnrmsLoopTyp(&vNrm);

  return IDX_EDONE;
}
/* ---------------------------------------------------------------------- */
static int Nrm_TypExec(idx, num)
     int idx;
     int num;
{
  VnrmsTyp(&vNrm,idx)= VnrmsLoopTyp(&vNrm);

  switch (VnrmsLoopTyp(&vNrm)) {
  case NRM_FAC:
    VnrmsRef(&vNrm,idx)= idx;
    VnrmsFac(&vNrm,idx)= VnrmsLoopFac(&vNrm);
    break;
  case NRM_OFF:
    VnrmsRef(&vNrm,idx)= idx;
    VnrmsFac(&vNrm,idx)= 1.0;
    break;
  default:
    break; }
  return IDX_EDONE;
}
/* ---------------------------------------------------------------------- */
static int Nrm_Finish(num) int num; { return TRUE; }
/* ---------------------------------------------------------------------- */
int Nrm_Show()
{
  static char *Nrm_TypName[]= {
    "off      ",
    "maximum  ",
    "unity    ",
    "reference",
    "factor   ", };
  int i;

  Nrm_Update();
  for (i= 0; i< VnrmsNum(&vNrm); i++) {
    UF_PrintM("#%d(%d): status %s; factor %f (subtracted mean: %f)\n",
	      i, VnrmsRef(&vNrm,i), Nrm_TypName[VnrmsTyp(&vNrm,i)],
	      VnrmsFac(&vNrm,i), VnrmsSum(&vNrm,i)); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Nrm_Update()
{
  int fullRange= FALSE;
  int maxIdx;
  double maxSum= 0.0;

  { int idx;

    for (idx= 0; idx< VspcsNum(&vSpc); idx++) { /* initializing norm'sums */
      if (!VspcsExists(&vSpc,idx)) { VnrmsSum(&vNrm,idx)= 0.0; }
      else if (SerialIdCmp(VspcsSerialId(&vSpc,idx),
			   VnrmsSpcSerialIda(&vNrm,idx)) ||
	       SerialIdCmp(VmrkMrkSerialId(VmrksNorm(&vMrk)),
			   VnrmsMrkSerialIda(&vNrm)) ||
	       SerialIdCmp(VmrkMrkSerialId(VmrksNormBg(&vMrk)),
			   VnrmsMrkBgSerialIda(&vNrm))) {
	double sum;

	if (!Mrk_Get(VnrmsMrk(&vNrm), VmrksNorm(&vMrk), idx, ACT_SUNCALIB) ||
	    !Mrk_Get(VnrmsMrkBg(&vNrm), VmrksNormBg(&vMrk), idx,
		     ACT_SUNCALIB)) {
	  ErrPrintR("fatal: can not get normalization marks\n");
	  return FALSE; }
	else if (!fullRange && VecNum(VnrmsMrk(&vNrm)) == 0) {
	  fullRange= TRUE; }

	if (fullRange) {
	  SpcIntegrate(VspcsSpc(&vSpc,idx),
		       0.0, (double)SpcNum(VspcsSpc(&vSpc,idx)),
		       &sum, NULL); }
	else {
	  double sumBg;
	  double range, rangeBg;

	  SpcIntegratePVec(VspcsSpc(&vSpc,idx), VnrmsMrk(&vNrm),
			   &sum, NULL);
	  SpcIntegratePVec(VspcsSpc(&vSpc,idx), VnrmsMrkBg(&vNrm),
			   &sumBg, NULL);

	  range= MrkRange(VnrmsMrk(&vNrm));
	  rangeBg= MrkRange(VnrmsMrkBg(&vNrm));

	  if (range != 0.0) { sum /= range; }
	  if (rangeBg != 0.0) { sumBg /= rangeBg; }
	  
	  sum -= sumBg; }
	VnrmsSum(&vNrm,idx)= sum;
	if (ABS(sum) > maxSum) { maxSum= ABS(sum); maxIdx= idx; } } } }

  { int idx;
    int changed= FALSE;

    for (idx= 0; idx< VspcsNum(&vSpc); idx++) { /* updating norm'factors */
      double old_fac= VnrmsFac(&vNrm,idx);

      switch (VnrmsTyp(&vNrm,idx)) {
      case NRM_MAX:
	if (maxSum == 0.0) {
	  VnrmsRef(&vNrm,idx)= idx; VnrmsFac(&vNrm,idx)= 1.0; }
	else {
	  VnrmsRef(&vNrm,idx)= maxIdx;
	  if (VnrmsSum(&vNrm,idx) == 0.0) { VnrmsFac(&vNrm,idx)= 1.0; }
	  else{
	    VnrmsFac(&vNrm,idx)= (VnrmsSum(&vNrm,maxIdx)
				  / VnrmsSum(&vNrm,idx)); } }
	break;
      case NRM_UNITY:
	VnrmsRef(&vNrm,idx)= idx;
	if (VnrmsSum(&vNrm,idx) == 0.0) { VnrmsFac(&vNrm,idx)= 1.0; }
	else{
	  VnrmsFac(&vNrm,idx)= (VnrmsSum(&vNrm,maxIdx)
				/ VnrmsSum(&vNrm,idx)); }
	break;
      case NRM_REF:
	if (VnrmsSum(&vNrm,idx) == 0.0) { VnrmsFac(&vNrm,idx)= 1.0; }
	else{
	  VnrmsFac(&vNrm,idx)= (VnrmsSum(&vNrm,VnrmsRef(&vNrm,idx))
				/ VnrmsSum(&vNrm,idx)); }
	break;
      case NRM_FAC:
	break;
      case NRM_OFF:
      default:
	break; }
      if (old_fac != VnrmsFac(&vNrm,idx)) { changed= TRUE; } }
    if (changed) { DN_ChangedNorm(); } }

  return TRUE;
}
/* ---------------------------------------------------------------------- */
