/* $Header: /usr/files/home/Gamma/vs/tv/edit/prg/RCS/VsNorm.h,v 1.1 1993/09/17 14:53:34 vs Exp vs $ */ 
/* -------------------------------------------------------------------------
 *                    VsNorm.h
 */
#ifndef _VsNorm_h
#define _VsNorm_h

#define NRM_OFF			0
#define NRM_MAX			1
#define NRM_UNITY		2
#define NRM_REF			3
#define NRM_FAC			4

typedef struct {		/* norm */
  SerialId_t spcSerialIda;	/* last SerialId on spc */
  double fac;			/* normalization factor */
  double sum;			/* bg-subtracted marker integral */
  int typ;			/* typ of normalization */
  int ref;			/* factor relativ to reference index */
} Vnrm_t;

#define VnrmSpcSerialIda(n)	((n)->spcSerialIda)
#define VnrmFac(n)		((n)->fac)
#define VnrmSum(n)		((n)->sum)
#define VnrmTyp(n)		((n)->typ)
#define VnrmRef(n)		((n)->ref)

typedef struct {
  int num;			/* number */
  Vnrm_t *p;			/* normalization vector */
  int loopTyp;			/* typ to be set in loop */
  double loopFac;		/* factor to be set in loop */
  PVecRec mrk;			/* temporary vector of norm'marks */
  PVecRec mrkBg;		/* temporary vector of norm'bg-marks */
  SerialId_t mrkSerialIda;	/* last SerialId on mrkNorm */
  SerialId_t mrkBgSerialIda;	/* last SerialId on mrkNormBg */
} Vnrms_t;

#define VnrmsNum(n)		((n)->num)
#define VnrmsP(n)		((n)->p)
#define VnrmsLoopTyp(n)		((n)->loopTyp)
#define VnrmsLoopFac(n)		((n)->loopFac)
#define VnrmsMrk(n)		(&(n)->mrk)
#define VnrmsMrkBg(n)		(&(n)->mrkBg)
#define VnrmsMrkSerialIda(n)	((n)->mrkSerialIda)
#define VnrmsMrkBgSerialIda(n)	((n)->mrkBgSerialIda)

#define VnrmsSpcSerialIda(n,i)		VnrmSpcSerialIda(VnrmsP(n) + (i))
#define VnrmsFac(n,i)			VnrmFac(VnrmsP(n) + (i))
#define VnrmsSum(n,i)			VnrmSum(VnrmsP(n) + (i))
#define VnrmsTyp(n,i)			VnrmTyp(VnrmsP(n) + (i))
#define VnrmsRef(n,i)			VnrmRef(VnrmsP(n) + (i))

#ifdef _VsNorm_c
Vnrms_t vNrm;
#else
extern Vnrms_t vNrm;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsNormF.h"

#undef P_

#endif				/* _VsNorm_h */
/* ------------------------------------------------------------------------- */
