/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsPath.c,v 1.5 1994/12/08 20:45:44 vs Exp vs $ */

#define _VsPath_c

#ifdef __STDC__
# include <stdarg.h>
#else
# include <varargs.h>
#endif
#include <errno.h>

				/* library include files */
#include <tv/vsTypes.h>
#include <tv/vsUserFace.h>
#include <tv/vsSpectra.h>
#include <tv/vsPath.h>

				/* private include files */
#include "VsError.h"
#include "VsIndex.h"
#include "VsPath.h"
#include "VsPathP.h"
#include "VsSpectra.h"
#include "VsUserFace.h"

#include "VdNotify.h"
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS4 */
int Pth_LoopTokens(int pthTyp, pfi_t execFct, pfi_t finishFct, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int Pth_LoopTokens(va_alist)
     /* int pthTyp, pfi_t execFct, pfi_t finishFct, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { int pthTyp= va_arg(ap, int);
    pfi_t execFct= va_arg(ap, pfi_t);
    pfi_t finishFct= va_arg(ap, pfi_t);
    char *fmt= va_arg(ap, char *);
#endif
    int num= 0;
    int pthStat= IDX_EDONE;
    char pmt[IOBUFLEN];
    int status= TRUE;

    UFPrintVarArgs(pmt, IOBUFLEN, fmt, ap, status);
    va_end(ap);

    if (!status) { return FALSE; }

    DN_Delay(TRUE);
    do {
      switch (Pth_TokenFormatRead(pthTyp, "", pmt)) {
      case PTH_TUNDEF: DN_Delay(FALSE); return FALSE;
      case PTH_TSKIP:
      case PTH_TSKIPPED: break;
      case PTH_TPATH:
      case PTH_TPATTERN:
	{
	  FILE *fp_ls;
	  char shell_command[1024];
	  char lines_from_ls[65536]; /* should be place for 1000 filenames ... */
	  int chars_read;
	  int status = FALSE;

	  {
	    /*
	     * First search on host via network for the requested
	     * spectra
	     */
	    if(VspcsQueryHost(&vSpc) && *VspcsNetHost(&vSpc) &&
	       !strchr(VpthToken(&vPth), '/') && (chars_read<=0))
	      {
		switch (pthStat= (*execFct)(pthStat)) {
		case IDX_ESKIPPED:	break;
		case IDX_ESKIP:		pthTyp= PTH_TSKIP; break;
		case IDX_EDONE:		num++; status=TRUE; break;
		case IDX_EERROR:	DN_Delay(FALSE); return FALSE;
		default:
		  ErrPrintR("fatal internal: illegal value returned by execFct()\n");
		  DN_Delay(FALSE);
		  return FALSE; }	/* switch */
	      }
	    /*
	     * If spectra not found on network host
	     * search for the spectra to be loaded in the
	     * directory given in variable VpthPath(&vPth)
	     */
	    if (!status) {
	      sprintf (shell_command, "%s %s", "/bin/ls", VpthPath(&vPth));
	      fp_ls = popen (shell_command, "r");
	      while ( (chars_read = fread (lines_from_ls, 1, 10240, fp_ls)) > 0){
		int i=0;
		char *p = lines_from_ls;
		while (i < chars_read){
		  while (i < chars_read && lines_from_ls[i++] != '\n');
		  lines_from_ls[i-1] = '\0'; /* remove \n */
		  strcpy (VpthPath(&vPth), p); 
		  switch (pthStat= (*execFct)(pthStat)) {
		  case IDX_ESKIPPED:	break;
		  case IDX_ESKIP:		pthTyp= PTH_TSKIP; break;
		  case IDX_EDONE:		num++; break;
		  case IDX_EERROR:	DN_Delay(FALSE); return FALSE;
		  default:
		    ErrPrintR("fatal internal: illegal value returned by execFct()\n");
		    DN_Delay(FALSE);
		    return FALSE; }	/* switch */
		  p = &lines_from_ls[i];
		}
	      }
	      pclose (fp_ls);
	    }
	  }
	}
	break;
      default:
	ErrPrintR("fatal internal: illegal value returned by getToken()\n");
	DN_Delay(FALSE);
	return FALSE; }
    } while (!UF_NoArgs());
    DN_Delay(FALSE);
    return (*finishFct)(num); }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS4 */
int Pth_MLoopTokens(int pthTyp, pfi_t execFct, pfi_t finishFct, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int Pth_MLoopTokens(va_alist)
     /* int pthTyp, pfi_t execFct, pfi_t finishFct, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { int pthTyp= va_arg(ap, int);
    pfi_t execFct= va_arg(ap, pfi_t);
    pfi_t finishFct= va_arg(ap, pfi_t);
    char *fmt= va_arg(ap, char *);
#endif
    int num= 0;
    int pthStat= IDX_EDONE;
    char pmt[IOBUFLEN];
    int status= TRUE;

    UFPrintVarArgs(pmt, IOBUFLEN, fmt, ap, status);
    va_end(ap);

    if (!status) { return FALSE; }

    VpthMStat(&vPth)= PTH_SUNDEF;

    DN_Delay(TRUE);
    do {
      switch (Pth_TokenFormatMRead(pthTyp, pmt)) {
      case PTH_TUNDEF: DN_Delay(FALSE); return FALSE;
      case PTH_TSKIP:
      case PTH_TSKIPPED: break;
      case PTH_TPATH:
      case PTH_TPATTERN:
	switch (pthStat= (*execFct)(pthStat)) {
	case IDX_ESKIPPED:	break;
	case IDX_ESKIP:
	  VpthMStat(&vPth)= PTH_SUNDEF;
	  pthTyp= PTH_TSKIP; break;
	case IDX_EDONE:		num++; break;
	case IDX_EERROR:	DN_Delay(FALSE); return FALSE;
	default:
	  ErrPrintR("fatal internal: illegal value returned by execFct()\n");
	  DN_Delay(FALSE);
	  return FALSE; }
	break;
      default:
	ErrPrintR("fatal internal: illegal value returned by getToken()\n");
	DN_Delay(FALSE);
	return FALSE; }
    } while (VpthMStat(&vPth) == PTH_SDECLOOP ||
	     VpthMStat(&vPth) == PTH_SINCLOOP ||
	     (!UF_NoArgs()));
    DN_Delay(FALSE);
    return (*finishFct)(num); }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS3 */
int Pth_TokenFormatRead(int typ, char *dflt, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int Pth_TokenFormatRead(va_alist)
     /* int typ, char *dflt, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { int typ= va_arg(ap, int);
    char *dflt= va_arg(ap, char *);
    char *fmt= va_arg(ap, char *);
#endif
    char token[IOBUFLEN];
    char pmt[IOBUFLEN];
    int status= TRUE;

    UFPrintVarArgs(pmt, IOBUFLEN, fmt, ap, status);
    va_end(ap);
    if (!status) { VpthTyp(&vPth)= PTH_TUNDEF; return PTH_TUNDEF; }

    if (Pth_TokenRead(PTH_TUNDEF, dflt, pmt) == PTH_TUNDEF) {
      if (typ != PTH_TSKIP) { return PTH_TUNDEF; } }
    else { strcpy(token, VpthToken(&vPth)); }
  
    if (typ == PTH_TSKIP) {
      VpthTyp(&vPth)= PTH_TSKIP; return PTH_TSKIP; }
    else {
      return Pth_TokenFormatSet(typ, token); } }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS3 */
int Pth_TokenRead(int typ, char *dflt, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int Pth_TokenRead(va_alist)
     /* int typ, char *dflt, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { int typ= va_arg(ap, int);
    char *dflt= va_arg(ap, char *);
    char *fmt= va_arg(ap, char *);
#endif
    char buffer[IOBUFLEN];
    char pmt[IOBUFLEN];
    int status= TRUE;
    /*    printf("Pth_TokenRead\n");*/
    UFPrintVarArgs(pmt, IOBUFLEN, fmt, ap, status);
    va_end(ap);

    *VpthComment(&vPth)= '\0';
    VpthTyp(&vPth)= PTH_TUNDEF; 

    if (!status) {
      return PTH_TUNDEF;
    }
    else if (!UF_ItemRead(buffer, IOBUFLEN, pmt) ||
	     !*buffer) {
      switch (UF_UpdateStat()) {
      case UFUERROR:
	ErrPrint("error: update error\n");
	return PTH_TUNDEF;
      case UFUQBREAK:
	if (dflt && *dflt) {
	  if (strlen(dflt) >= IOBUFLEN) {
	    ErrPrint("error: default '%s' too long\n");
	  }
	  else {
	    strcpy(buffer, dflt);
	    break;
	  }
	}
	return PTH_TUNDEF;
      default:
	return PTH_TUNDEF;
      }
    }

    return Pth_TokenSet(typ,buffer);
  }
}
/* ---------------------------------------------------------------------- */
int Pth_ChDir()
{
  extern int chdir();
#if defined(HAS_GETWD)
  extern char *getwd();
#else
  extern char *getcwd();
#endif
  
  
#if defined(HAS_GETWD)
  char oldWd[MAXPATHLEN];
  if (!getwd(oldWd)) {
#else
  char oldWd[MAXPATHLEN+2];
  if (!getcwd(oldWd, MAXPATHLEN+2)) 
    {
#endif
    UF_PrintE("   warning: can not get cwd\n ");
    UF_PrintE("   system: %s\n", strerror(errno));
    strcpy (VpthPath(&vPth), oldWd);
    chdir (oldWd);
    DN_ChangedCwd();
    PthChangedCwd(oldWd);
    UF_PrintM("new cwd: %s\n", VpthPath(&vPth)); 
    UF_SkipArgs ();}
  else 
    if (Pth_TokenRead(PTH_TPATH, oldWd, "new cwd [%s]", oldWd) !=
	PTH_TPATH) { return FALSE; }
    else 
      if (strcmp(VpthPath(&vPth), oldWd)) {
	if (chdir(VpthPath(&vPth))) {
	  ErrPrintR("fatal: can not change cwd to %s\n", VpthPath(&vPth));
	  chdir(oldWd);
	  PthChangedCwd(oldWd);
	  return FALSE; }
	PthChangedCwd(VpthPath(&vPth));
	DN_ChangedCwd();
	UF_PrintM("new cwd: %s\n", VpthPath(&vPth)); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Pth_FormatRead(name, fmt)
     char *name;
     char *fmt;
{
  char newFmt[SPC_FMTLEN];

  if (UF_ItemRead(newFmt, SPC_FMTLEN, "%s format [%s]", name, fmt)) {
    return Pth_FormatSet(fmt, newFmt); }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int Pth_FormatSet(t, f)
     char *t;
     char *f;
{
  if (*f && msetfmt(NULL, f) < 0) {
    ErrPrintR("fatal: illegal format '%s' specified\n", f);
    return FALSE; }
  strcpy(t,f);
  return TRUE;
}
/* ---------------------------------------------------------------------- */

/* ====================== */
/* initialize path module */
/* ====================== */

int Pth_Init()
{
  if (!PatInit(VpthPattern(&vPth)) ||
      !PatRealloc(VpthPattern(&vPth), PTH_NUM_PREDEFINED) ||
      !Pth_PatternStandard(VpthPattern(&vPth))) {
    ErrPrintR("fatal: can not initialize path patterns\n");
    return FALSE; }
  VpthTyp(&vPth)= PTH_TUNDEF;
  *VpthToken(&vPth)= '\0';
  *VpthComment(&vPth)= '\0';
  *VpthPath(&vPth)= '\0';
  *VpthFormat(&vPth)= '\0';

  *VpthMFile(&vPth)= '\0';
  VpthMStat(&vPth)= PTH_SUNDEF;
  VpthMPosition(&vPth)= -1;	/* begin of file */
  VpthMFp(&vPth)= NULL;

#ifdef AVOID_GETWD
  {
#if defined(HAS_GETWD)
    char ref[MAXPATHLEN];
    if (getwd(ref) != NULL) {
      PthChangedCwd (ref);}
#else
    /* getcwd requires 2 more bytes! */
    char ref[MAXPATHLEN+2];
    if (getcwd(ref,MAXPATHLEN+2) != NULL) {
      PthChangedCwd (ref);}
#endif
  else{
    ErrPrintR("fatal: can not initialize rememberCwd\n");
    return FALSE;}
    }
#endif
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Pth_LoopIndices(execFct, finishFct)
     int (*execFct)();
     int (*finishFct)();
{
  int i;
  int num= 0;

  *VpthComment(&vPth)= '\0';
  switch(VpthTyp(&vPth)) {
  case PTH_TPATTERN:
    if (VidxNum(&vIdx)) {
      DN_Delay(TRUE);
      for (i= 0; i< VidxNum(&vIdx); i++) {
	int idx= VidxIdx(&vIdx,i);
	if (VspcsExists(&vSpc,idx)) {
	  char *p= Pth_SpectrumSubstitute(idx, VpthToken(&vPth));
	  if (p == NULL) { continue; }
	  else {
	    switch ((*execFct)(idx, num, p)) {
	    case IDX_ESKIPPED:
	      break;
	    case IDX_EDONE:
	      num++; break;
	    case IDX_EERROR:
	      DN_Delay(FALSE); return FALSE; } } } }
      DN_Delay(FALSE); }
    return (*finishFct)(num);
  case PTH_TPATH:
    if (VidxNum(&vIdx)) {
      DN_Delay(TRUE);
      for (i= 0; i< VidxNum(&vIdx); i++) {
	int idx= VidxIdx(&vIdx,i);
	switch ((*execFct)(idx, num, VpthPath(&vPth))) {
	case IDX_ESKIPPED:
	  break;
	case IDX_EDONE:
	  num++; break;
	case IDX_EERROR:
	  DN_Delay(FALSE); return FALSE; } }
      DN_Delay(FALSE); }
    return (*finishFct)(num);
  default:
    ErrPrintR("fatal internal: illegal pattern type in Pth_LoopIndices()\n");
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Pth_MClose()
{
  if (VpthMFp(&vPth)) {
    if (VpthMPosition(&vPth) >= 0) {
      UF_PrintM("ls-file '%s' closed at line #%d\n",
		PthShort(VpthMFile(&vPth)), VpthMPosition(&vPth)); }
    else {
      UF_PrintM("ls-file '%s' closed at begin of file\n",
		PthShort(VpthMFile(&vPth))); }
    *VpthMFile(&vPth)= '\0';
    fclose(VpthMFp(&vPth)); VpthMFp(&vPth)= NULL; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Pth_MDec()
{
  if (Pth_MSkip(VpthMPosition(&vPth)-2)) {
    VpthMStat(&vPth)= PTH_SREAD; return TRUE; }
  else {
    VpthMStat(&vPth)= PTH_SUNDEF; return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Pth_MDecLoop()
{
  VpthMStat(&vPth)= PTH_SDECLOOP; return TRUE;
}
/* ---------------------------------------------------------------------- */
int Pth_MInc()
{
  if (!VpthMFp(&vPth)) {
    ErrPrintR("fatal: no ls-file open\n");
    VpthMStat(&vPth)= PTH_SUNDEF;
    return FALSE; }
  else {
    VpthMStat(&vPth)= PTH_SREAD; return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Pth_MIncLoop()
{
  if (!Pth_MInc()) { return FALSE; }
  else { VpthMStat(&vPth)= PTH_SINCLOOP; return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Pth_MList()
{
  strcpy(VpthFormat(&vPth), VspcsInFmt(&vSpc));

  if (!UF_NoArgs()) {
    int ret;
    ret= Pth_MLoopTokens(PTH_TPATH, Pth_MListExec, Pth_MListFinish,
			 "list ls-file '%s'", PthShort(VpthMFile(&vPth))); }
  if (VpthMFp(&vPth)) {
    if (VpthMPosition(&vPth) >= 0) {
      UF_PrintM("ls-file '%s' positioned at line #%d\n",
		PthShort(VpthMFile(&vPth)), VpthMPosition(&vPth)); }
    else {
      UF_PrintM("ls-file '%s' positioned at begin of file\n",
		PthShort(VpthMFile(&vPth))); } }
  else { UF_PrintM("no ls-file open\n"); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static int Pth_MListExec(pthStat)
     int pthStat;
{
  UF_PrintM("%d: %s'%s\n",
	    VpthMPosition(&vPth), /* already incremented during last read */
	    VpthPath(&vPth), VpthFormat(&vPth));
  return IDX_EDONE;
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static int Pth_MListFinish(num)
     int num;
{
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Pth_MOpen()
{
  if (Pth_TokenFormatRead(PTH_TPATH, "", "new ls-file") == PTH_TPATH) {
    Pth_MClose();
    if ((VpthMFp(&vPth)= fopen(VpthPath(&vPth), "r"))) {
      UF_PrintM("ls-file '%s' opened\n", PthShort(VpthPath(&vPth)));
      strcpy(VpthMFile(&vPth), VpthPath(&vPth));
      VpthMPosition(&vPth)= -1;
      VpthMStat(&vPth)= PTH_SOPENED;
      return TRUE; }
    else {
      ErrPrintR("fatal: can not open ls-file '%s'\n", PthShort(VpthPath(&vPth)));
      VpthMStat(&vPth) = PTH_SUNDEF; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int Pth_MRead(buffer, bufLen)
     char *buffer;
     int bufLen;
{
  if (!VpthMFp(&vPth)) {
    ErrPrintR("fatal: no ls-file open\n");
    return FALSE; }
  else {
    while (fgets(buffer, bufLen, VpthMFp(&vPth))) {
      if (*buffer != '\n') { VpthMPosition(&vPth)++; return TRUE; } }

    ErrPrint("warning: end of ls-file '%s' reached\n", VpthMFile(&vPth));
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Pth_MSet()
{
  int i;
  if (UF_IntRead(FALSE, &i, "index of next file")) {
    i= ABS(i);
    if (Pth_MSkip(i-1)) { VpthMStat(&vPth)= PTH_SREAD; return TRUE; } }
  else { VpthMStat(&vPth)= PTH_SUNDEF; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int Pth_MSkip(i)
     int i;
{
  if (!VpthMFp(&vPth)) {
    ErrPrintR("fatal: no ls-file open\n");
    return FALSE; }
  else if (fseek(VpthMFp(&vPth), 0, SEEK_SET) < 0) {
    ErrPrintR("fatal: can not rewind ls-file '%s'\n", VpthMFile(&vPth));
    UF_Reset();
    return FALSE; }
  else {
    VpthMPosition(&vPth)= -1;
    if (i < -1) {
      UF_PrintE("warning: begin of ls-file '%s' reached\n",
		VpthMFile(&vPth));
      return FALSE; }
    else {
      char buffer[IOBUFLEN];
      while (i >= 0) {
	if (Pth_MRead(buffer, IOBUFLEN)) { i--; } 
	else { return FALSE; } }
      return TRUE; } }
}
/* ---------------------------------------------------------------------- */
int Pth_PatternDel()
{
  char pat[IOBUFLEN];

  if (UF_ItemRead(pat, IOBUFLEN, "wildcard to delete") && *pat) {
    if (!PatDel(VpthPattern(&vPth), pat)) {
      ErrPrint("warning: can not delete wildcard '%s'\n", pat);
      return FALSE; } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Pth_PatternSet()
{
  char pat[IOBUFLEN];
  char expr[IOBUFLEN];

  if (UF_ItemRead(pat, IOBUFLEN, "new wildcard") && *pat &&
      UF_ItemRead(expr, IOBUFLEN, "expression for '%s'", pat) &&
      *expr) {
    if (!PatSet(VpthPattern(&vPth), pat, expr)) {
      ErrPrint("error: can not set wildcard '%s' as \"%s\"\n", pat, expr);
      return FALSE; } }
  return Pth_PatternStandard(VpthPattern(&vPth));
}
/* ---------------------------------------------------------------------- */
int Pth_PatternShow()
{
  int i;
  PatVec_t pp= VpthPattern(&vPth);
  UF_PrintP("wildcards:\n");
  for (i= 0; i< VecNum(pp); i++) {
    if (PatVecPatt(pp,i) != NULL) {
      UF_PrintP("%s :: %s\n", PatVecPatt(pp,i), PatVecExpr(pp,i)); } }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
#define GUARANTEE_PATTERN(pp, pat, std) \
  (*PatGet(pp,pat) || PatSet(pp,pat,std))

#define PTH_STDFIT	"!h/!t.fit"
#define PTH_STDCAL	"!r.cal"
#define PTH_STDRCL	"!r.rcl"
#define PTH_STDPLT	"!r.fig"
#define PTH_STDMTX	"!f/!t.mtx"
#define PTH_STDPROSPC	"!f/!t.pry"
#define PTH_STDPROCAL	"!f/!t.pry.cal"
#define PTH_STDCUTDIR	"!f/!t.cutdir"
#define PTH_STDCUTCAL	"!f/!t.cut.cal"
#define PTH_STDCUTGAT	"!f/!t.gate"
#define PTH_STDCUTSSPC	"!f/!t.cut"
#define PTH_STDCUTSGAT	"!f/!t.gt"
#define PTH_STDCUTSBG	"!f/!t.bg"
#define PTH_STDCUTSCL	"!f/!t.cl"
#define PTH_STDCUTSCR	"!f/!t.cr"

static int Pth_PatternStandard(pp)
     PatVec_t pp;
{
  if (GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_FIT, PTH_STDFIT) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_CAL, PTH_STDCAL) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_PLT, PTH_STDPLT) &&

      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_RCL, PTH_STDRCL) &&

      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_MTX, PTH_STDMTX) &&

      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_PROSPC, PTH_STDPROSPC) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_PROCAL, PTH_STDPROCAL) &&

      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_CUTDIR, PTH_STDCUTDIR) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_CUTCAL, PTH_STDCUTCAL) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_CUTGAT, PTH_STDCUTGAT) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_CUTSPC, PTH_STDCUTSSPC) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_CUTSPCGAT, PTH_STDCUTSGAT) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_CUTSPCBG, PTH_STDCUTSBG) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_CUTSPCCL, PTH_STDCUTSCL) &&
      GUARANTEE_PATTERN(VpthPattern(&vPth), PTH_CUTSPCCR, PTH_STDCUTSCR)) {
    return TRUE; }
  else {
    ErrPrint("error: can not set standard patterns\n");
    return FALSE; }
}
#undef GUARANTEE_PATTERN
/* ---------------------------------------------------------------------- */
int Pth_Pwd()
{
#if defined(HAS_GETWD)
  extern char *getwd();
#else
  extern char *getcwd();
#endif
  char cwd[MAXPATHLEN];

#if defined(HAS_GETWD)
  if (!getwd(cwd)) {
#else
  if (!getcwd(cwd, MAXPATHLEN)) {
#endif
    ErrPrint("error: can not get cwd\n  system: %s\n", cwd);
    return FALSE; }
  else {
    UF_PrintM("%s\n", cwd);
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
char *Pth_SpectrumSubstitute(idx, pat)
     int idx;
     char *pat;
{
  char *p;
  char *r;
  if (VspcsExists(&vSpc,idx) &&
      (p= PatGet(VpthPattern(&vPth), pat)) && *p &&
      (r= PthSubstitute(VspcsFile(&vSpc,idx), p))) {
    *VpthComment(&vPth)= '\0';
    strcpy(VpthPath(&vPth), r);
    return r; }

  ErrPrint("error: can not substitute pattern '%s' for spectrum #%d '%s'\n",
	   pat, idx, PthShort(VspcsFile(&vSpc,idx)));
  return NULL;
}
/* ---------------------------------------------------------------------- */
int Pth_TokenFormatMRead(typ, pmt)
     int typ;
     char *pmt;
{
  char buffer[IOBUFLEN];

  VpthTyp(&vPth)= PTH_TUNDEF;
  *VpthComment(&vPth)= '\0';

  if (typ == PTH_TSKIP) { return Pth_TokenRead(typ, "", pmt); }
  else if (VpthMStat(&vPth) == PTH_SUNDEF ||
	   VpthMStat(&vPth) == PTH_SOPENED) {
    extern Men_t mFileLoopMen;

    UF_MenuLoop(&mFileLoopMen, pmt); }

  switch (VpthMStat(&vPth)) {
  case PTH_SUNDEF: VpthTyp(&vPth)= PTH_TUNDEF; break;
  case PTH_SOPENED: VpthTyp(&vPth)= PTH_TSKIPPED; break;
  case PTH_SREAD:
    VpthMStat(&vPth)= PTH_SUNDEF;
  case PTH_SDECLOOP:
    if (VpthMStat(&vPth) == PTH_SDECLOOP) {
      if (!Pth_MSkip(VpthMPosition(&vPth)-2)) {	return PTH_TUNDEF; } }
  case PTH_SINCLOOP:
    if (Pth_MRead(buffer, IOBUFLEN)) {
      char *b= buffer;
      char token[IOBUFLEN];
      char comment[IOBUFLEN];
      if (!UF_ItemGet(&b, token, IOBUFLEN)) { break; }
      else if (typ == PTH_TSKIP) {
	VpthMStat(&vPth)= PTH_SUNDEF;
	VpthTyp(&vPth)= PTH_TSKIP;
	return PTH_TSKIP; }
      else {
	if (!UF_ItemGet(&b, comment, IOBUFLEN)) { ; }
	else if (strlen(comment) > MAXPATHLEN) {
	  UF_PrintE("error: comment '%s' too long\n", comment);
	  *VpthComment(&vPth)= '\0'; }
	else { strcpy(VpthComment(&vPth), comment); }

	return Pth_TokenFormatSet(typ, token); } }
  default:
    break; }

  return VpthTyp(&vPth);
}
/* ---------------------------------------------------------------------- */
static int Pth_TokenFormatSet(typ, token)
     int typ;
     char *token;
{
  char *p= strchr(token, '\'');
  if (p && !Pth_FormatSet(VpthFormat(&vPth), p+1)) { return PTH_TUNDEF; }
  else {
    if (p) { *p= '\0'; }
    Pth_TokenSet(typ, token);
    if (p) { *p= '\''; }
    return VpthTyp(&vPth); }
}
/* ---------------------------------------------------------------------- */
int Pth_TokenSet(typ, token)
     int typ;
     char *token;
{
  /*  printf("Pth_TokenSet\n");*/
  if (strlen(token) > MAXPATHLEN) {
    UF_PrintE("error: pattern '%s' too long\n", token);
    VpthTyp(&vPth)= PTH_TUNDEF;
    return PTH_TUNDEF;
  }
  else {
    *VpthPath(&vPth)= '\0';
    strcpy(VpthToken(&vPth), token);
  }

  if (typ == PTH_TUNDEF || typ == PTH_TPATTERN) {
    if (*PatGet(VpthPattern(&vPth), token)) {
      strcpy(VpthToken(&vPth), token);
      VpthTyp(&vPth)= PTH_TPATTERN;
      return PTH_TPATTERN;
    }
    else if (typ == PTH_TPATTERN) {
      UF_PrintE("error: no pattern found\n");
      VpthTyp(&vPth)= PTH_TUNDEF;
      return PTH_TUNDEF; }
    else { PatErrNo= PATNOERR; } }
  else if (typ == PTH_TSKIP) { return PTH_TSKIP; }
  {
    char *p= PthExpand(token);
    if (!*p) {
      ErrPrint("error: can not expand path '%s'\n", token);
      VpthTyp(&vPth)= PTH_TUNDEF;
      return PTH_TUNDEF; }
    else if (strlen(p) > MAXPATHLEN) {
      UF_PrintE("error: path '%s' too long\n", p);
      VpthTyp(&vPth)= PTH_TUNDEF;
      return PTH_TUNDEF; }
    else {
      strcpy(VpthPath(&vPth), p);
      VpthTyp(&vPth)= PTH_TPATH;
      return PTH_TPATH; } }
}
/* ---------------------------------------------------------------------- */
