/* $Header: /usr/files/home/Gamma/vs/tv/edit/prg/RCS/VsPath.h,v 1.1 1993/09/17 14:53:34 vs Exp vs $ */

#ifndef _VsPath_h
#define _VsPath_h

#include <tv/vsTypes.h>
#include <tv/vsPattern.h>
#include <tv/vsSpectra.h>

				/* predefined patterns used by vs */
#define PTH_FIT			"*fit"
#define PTH_CAL			"*cal"
#define PTH_RCL			"*rcl"
#define PTH_PLT			"*plt"
#define PTH_MTX			"*mtx"
#define PTH_PROSPC		"*prospc"
#define PTH_PROCAL		"*procal"
#define PTH_CUTDIR		"*cutdir"
#define PTH_CUTCAL		"*cutcal"
#define PTH_CUTGAT		"*cutgat"
#define PTH_CUTSPC		"*cutspc"
#define PTH_CUTSPCGAT		"*cutspcgat"
#define PTH_CUTSPCBG		"*cutspcbg"
#define PTH_CUTSPCCL		"*cutspccl"
#define PTH_CUTSPCCR		"*cutspccr"
#define PTH_NUM_PREDEFINED      15

				/* token types */
#define PTH_TUNDEF		1
#define PTH_TPATH		2
#define PTH_TPATTERN		3
#define PTH_TSKIP		4
#define PTH_TSKIPPED		5

				/* mFile status */
#define PTH_SUNDEF		1
#define PTH_SDECLOOP		2
#define PTH_SINCLOOP		3
#define PTH_SREAD		4
#define PTH_SOPENED		5

typedef struct {
  int typ;
  char comment[MAXPATHLEN];
  char token[MAXPATHLEN];
  char path[MAXPATHLEN];
  char format[SPC_FMTLEN];
  PatVecRec pattern;

  char mFile[MAXPATHLEN];
  int mPosition;
  int mStat;
  FILE *mFp;
} Vpth_t;

#define VpthTyp(pp)		((pp)->typ)
#define VpthComment(pp)		((pp)->comment)
#define VpthToken(pp)		((pp)->token)
#define VpthPath(pp)		((pp)->path)
#define VpthFormat(pp)		((pp)->format)
#define VpthPattern(pp)		(&(pp)->pattern)
#define VpthMFile(pp)		((pp)->mFile)
#define VpthMStat(pp)		((pp)->mStat)
#define VpthMPosition(pp)	((pp)->mPosition)
#define VpthMFp(pp)		((pp)->mFp)

#ifdef _VsPath_c
Vpth_t vPth;
#else
extern Vpth_t vPth;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern int Pth_LoopTokens P_((int pthTyp, int (*execFct)(), int (*finishFct)(), char *pmtfmt, ...));
extern int Pth_MLoopTokens P_((int pthTyp, int (*execFct)(), int (*finishFct)(), char *pmtfmt, ...));
extern int Pth_TokenFormatRead P_((int typ, char *dflt, char *pmtfmt, ...));
extern int Pth_TokenRead P_((int typ, char *dflt, char *pmtfmt, ...));


#include "VsPathF.h"

#undef P_

#endif				/* _VsPath_h */
