/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsSpectra.c,v 1.4 1994/12/02 21:24:28 vs Exp vs $ */
#define _VsSpectra_c

#include <fcntl.h>
#include <ctype.h>
#include <sys/types.h>

#include <sys/stat.h>
				/* library include files */
#include <tv/vsAlloc.h>
#include <tv/vsTypes.h>
#include <tv/vsUserFace.h>
#include <tv/vsEndian.h>
#include <tv/vsCurFit.h>
#include <tv/vsPath.h>
#include <tv/vsTools.h>

				/* private include files */
#include "VsActiv.h"
#include "VsCal.h"
#include "VsError.h"
#include "VsFit.h"
#include "VsFitIo.h"
#include "VsIndex.h"
#include "VsNet.h"
#include "VsNorm.h"
#include "VsPath.h"
#include "VsUserFace.h"

#include "VdNotify.h"

#include "VsSpectra.h"
#include "VsSpectraP.h"
/* ---------------------------------------------------------------------- */
static int tilTyp, tilStat, tilNum, tilStatus;
static pfi_t tkFct;
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS4 */
static int Spc_TokenIdxLoop(int pthTyp, pfi_t tokenFct, pfi_t idxFct,
		     pfi_t finishFct, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  tkFct= tokenFct;
  {
#else
static int Spc_TokenIdxLoop(va_alist)
     /* int pthTyp, pfi_t tokenFct, pfi_t idxFct,
	pfi_t finishFct, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  tilTyp= va_arg(ap, int);
  tkFct= va_arg(ap, pfi_t);
  {
    pfi_t idxFct= va_arg(ap, pfi_t);
    pfi_t finishFct= va_arg(ap, pfi_t);
    char *fmt= va_arg(ap, char *);
#endif
    char pmt[IOBUFLEN];
    tilStatus= TRUE;
    tilStat= IDX_EDONE;

    UFPrintVarArgs(pmt, IOBUFLEN, fmt, ap, tilStatus);
    va_end(ap);

    if (!tilStatus) { return FALSE; }

    DN_Delay(TRUE);

    VecReset(VidxVec(&vIdx));
    { extern Men_t spcTokenLoopMen;
      UF_MenuLoop(&spcTokenLoopMen, pmt); }
    tilStatus= Idx_Loop2(idxFct, finishFct);

    DN_Delay(FALSE);
    return tilStatus; }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS4 */
static int Spc_MGetLoop(int pthTyp, pfi_t execFct, pfi_t finishFct, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
static int Spc_MGetLoop(va_alist)
     /* int pthTyp, pfi_t execFct, pfi_t finishFct, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { int pthTyp= va_arg(ap, int);
    pfi_t execFct= va_arg(ap, pfi_t);
    pfi_t finishFct= va_arg(ap, pfi_t);
    char *fmt= va_arg(ap, char *);
#endif
    int num= 0;
    int pthStat= IDX_EDONE;
    char pmt[IOBUFLEN];
    int status= TRUE;

    UFPrintVarArgs(pmt, IOBUFLEN, fmt, ap, status);
    va_end(ap);

    if (!status) { return FALSE; }

    VpthMStat(&vPth)= PTH_SUNDEF;

    DN_Delay(TRUE);
    do {
      if (pthTyp == PTH_TSKIP) { if (UF_NoArgs()) { break; } }
      else {
	if (!Idx_GetOneFree()) {
	  UF_PrintE("warning: no free spectrum available\n");
	  VpthMStat(&vPth)= PTH_SUNDEF;
	  pthTyp= PTH_TSKIP;
	  continue; } }
      switch (Pth_TokenFormatMRead(pthTyp, pmt)) {
      case PTH_TUNDEF: DN_Delay(FALSE); return FALSE;
      case PTH_TSKIP:
      case PTH_TSKIPPED: break;
      case PTH_TPATH:
      case PTH_TPATTERN:
	switch (pthStat= (*execFct)(pthStat)) {
	case IDX_ESKIPPED:	break;
	case IDX_ESKIP:
	  VpthMStat(&vPth)= PTH_SUNDEF;
	  pthTyp= PTH_TSKIP; break;
	case IDX_EDONE:		num++; break;
	case IDX_EERROR:	DN_Delay(FALSE); return FALSE;
	default:
	  ErrPrintR("fatal internal: illegal value returned by execFct()\n");
	  DN_Delay(FALSE);
	  return FALSE; }
	break;
      default:
	ErrPrintR("fatal internal: illegal value returned by getToken()\n");
	DN_Delay(FALSE);
	return FALSE; }
    } while (VpthMStat(&vPth) == PTH_SDECLOOP ||
	     VpthMStat(&vPth) == PTH_SINCLOOP ||
	     (!UF_NoArgs()));
    DN_Delay(FALSE);
    return (*finishFct)(num); }
}
/* ---------------------------------------------------------------------- */
static int Spc_TokenIdxFinish(num)
     int num;
{
  if (tilStatus && (num + tilNum)) { return TRUE; }
  else {
    UF_PrintE("warning: spectrum not %s\n", VspcsAction(&vSpc));
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Spc_TokenExec()
{
  switch (Pth_TokenFormatRead(tilTyp, "", "")) {
  case PTH_TUNDEF: DN_Delay(FALSE); tilStatus= FALSE; return FALSE;
  case PTH_TSKIP:
  case PTH_TSKIPPED: break;
  case PTH_TPATH:
  case PTH_TPATTERN:
    if (tilStatus) {
      switch (tilStat= (*tkFct)(tilStat)) {
      case IDX_ESKIPPED:	break;
      case IDX_ESKIP:		tilTyp= PTH_TSKIP; break;
      case IDX_EDONE:		tilNum++; break;
      case IDX_EERROR:	DN_Delay(FALSE); tilStatus= FALSE; return FALSE;
      default:
	ErrPrintR("fatal internal: illegal value returned by execFct()\n");
	DN_Delay(FALSE); tilStatus= FALSE; return FALSE; } }
    break;
  default:
    ErrPrintR("fatal internal: illegal value returned by getToken()\n");
    DN_Delay(FALSE);
    return tilStatus= FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static void Spc_Changed(idx, sid)
     int idx;
     SerialId_t sid;
{
  Vspc_t *vp= VspcsP(&vSpc) + idx;
  DN_ChangedSpectrum(idx);
  if (sid) { SerialIdCp(VspcSerialId(vp), sid); }
  else { SerialIdGet(VspcSerialId(vp)); }
}
/* ---------------------------------------------------------------------- */
int Spc_Add()
{
  int status= FALSE;

  if (Idx_ReadOne("sum spectrum index")) {
    strcpy(VpthFormat(&vPth), VspcsInFmt(&vSpc));
    VspcsFileFct(&vSpc)= SpcReadAdd;
    VspcsFct(&vSpc)= SpcAdd;
    VspcsAction(&vSpc)= "incremented";
    VspcsChangeFlag(&vSpc)= SPC_CADD;
    status= Spc_TokenIdxLoop(PTH_TPATH,
			     Spc_FileExec, Spc_IndexExec, Spc_TokenIdxFinish,
			     "add spectrum(s) to #%d", VidxSingle(&vIdx));
    strcpy(VspcsInFmt(&vSpc), VpthFormat(&vPth)); }
  return status;
}
/* ---------------------------------------------------------------------- */
int Spc_Copy()
{
  if (!Idx_ReadOne("spectrum copy source index") ||
      !Idx_Read(1, "copy destination index(s) for #%d", VidxSingle(&vIdx))) {
    return FALSE; }
  else {
    return Idx_Loop2(Spc_CopyExec, Spc_CopyFinish); }
}
/* ---------------------------------------------------------------------- */
static int Spc_CopyExec(idx0, idx, num) /* reverse order !!! */
     int idx0;
     int idx;
     int num;
{
  if (!VspcsExists(&vSpc,idx0)) {
    ErrPrintR("fatal: spectrum #%d not defined\n", idx0);
    return IDX_EERROR; }
  else if (SpcCopy(VspcsSpc(&vSpc,idx), VspcsSpc(&vSpc,idx0))) {
    UF_PrintM("spectrum #%d copied to #%d\n", idx0, idx);
    VspcsExists(&vSpc,idx)= TRUE;
    VspcsChange(&vSpc,idx)=	VspcsChange(&vSpc,idx0);
    VspcsOrigin(&vSpc,idx)=	VspcsOrigin(&vSpc,idx0);
    VspcsMin(&vSpc,idx)=	VspcsMin(&vSpc,idx0);
    VspcsMax(&vSpc,idx)=	VspcsMax(&vSpc,idx0);
    VspcsMinPos(&vSpc,idx)=	VspcsMinPos(&vSpc,idx0);
    VspcsMaxNeg(&vSpc,idx)=	VspcsMaxNeg(&vSpc,idx0);
    VspcsSum(&vSpc,idx)=	VspcsSum(&vSpc,idx0);
    VspcsSumAbs(&vSpc,idx)=	VspcsSumAbs(&vSpc,idx0);
    Spc_Changed(idx, VspcsSerialId(&vSpc,idx0));
    Fio_FileInit(idx, PatGet(VpthPattern(&vPth), PTH_FIT));
    return IDX_EDONE; }
  else {
    Spc_ResetIntern(idx);
    ErrPrintR("fatal: can not copy #%d to #%d\n", idx0, idx);
    return IDX_EERROR; }
}
/* ---------------------------------------------------------------------- */
static int Spc_CopyFinish(num)
     int num;
{
  if (num) { return TRUE; }
  else { UF_PrintE("warning: no spectrum copied\n"); return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Spc_Create()
{
  int res;
  if (PTH_TUNDEF ==
      Pth_TokenFormatRead(PTH_TPATH, "", "spectrum name")) {
    UF_Reset();
    return FALSE; }
  else if (!UF_IntRead(FALSE, &res, "resolution of new spectrum") ||
	   !Idx_ReadOne("create spectrum for index")) {
    return FALSE; }
  else {
    int idx= VidxSingle(&vIdx);
    Spc_t sp= VspcsSpc(&vSpc,idx);

    if (!SpcAlloc(sp, res)) {
      ErrPrintR("fatal: can not create spectrum '%s' from host '%s'\n",
		VpthToken(&vPth), VspcsNetHost(&vSpc));
      Spc_Changed(idx, 0);
      return FALSE; }
    else {
      VspcsOrigin(&vSpc,idx)= SPC_OMEMORY;
      Free(SpcFile(sp));
      SpcFile(sp)= Strdup(VpthToken(&vPth));
      strcpy(SpcFormat(sp), "created");
      SpcClear(sp);
      SpcBufNum(SpcSpc(sp))= res;
      return TRUE; } }
}
/* ---------------------------------------------------------------------- */
int Spc_Delete()
{
  if (UF_NoArgs()) { Spc_ShowNames(); }
  if (!Idx_Read(1, "delete spectrum for index(s)")) {
    return FALSE; }
  else {
    return Idx_Loop(Spc_DeleteExec, Spc_DeleteFinish); }
}
/* ---------------------------------------------------------------------- */
static int Spc_DeleteExec(idx, num)
     int idx;
     int num;
{
  if (VspcsExists(&vSpc,idx)) {
    if (!Spc_ResetIntern(idx)) { return IDX_EERROR; }
    UF_PrintM("spectrum #%d deleted\n", idx);
    return IDX_EDONE; }
  return IDX_ESKIPPED;
}
/* ---------------------------------------------------------------------- */
static int Spc_DeleteFinish(num)
     int num;
{
  if (num) { return TRUE; } 
  else {
    UF_PrintE("warning: no spectrum found to delete\n");
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Spc_Enter()
{
  if (!Idx_ReadOne("spectrum index to enter value")) {
    return FALSE; }
  else {
    int chn, idx= VidxSingle(&vIdx);
    double val, err, p;
    Spc_t spc= VspcsSpc(&vSpc,idx);

    if (!VspcsExists(&vSpc,idx)) {
      UF_PrintE("fatal: spectrum #%d does not exist\n", idx);
      UF_Reset();
      return FALSE; }
    else if (!UF_IntRead(FALSE, &chn,
			 "channel to enter value [0,%d]", SpcNum(spc)-1)) {
      return FALSE; }
    else if (chn < 0 || SpcNum(spc) <= chn) {
      UF_PrintE("error: channel %d out of range [0,%d]\n", chn, SpcNum(spc)-1);
      return FALSE; }
    else if (!UF_RealRead(FALSE, &val, &p, "new value of #%d[%d]", idx, chn)) {
      return FALSE; }
    if (UF_NoArgs()) { err= ABS(val); }
    else if (!UF_RealRead(FALSE, &err, &p, "new error of #%d[%d]", idx, chn)) {
      return FALSE; }
    SpcBufReal(SpcSpc(spc))[chn]= val;
    SpcBufReal(SpcDSpc(spc))[chn]= err;
    return TRUE; }
}
/* ---------------------------------------------------------------------- */
static int Spc_FileExec(pthStat)
     int pthStat;
{
  int idx= VidxSingle(&vIdx);

  if (!VspcsExists(&vSpc,idx)) {
    if (Spc_ReadExec(idx, 0) == IDX_EDONE) { return IDX_ESKIPPED; }
    else { return IDX_EERROR; } }
  else {
    char fmt[SPC_FMTLEN];

    strcpy(fmt, VpthFormat(&vPth));
    if ((*VspcsFileFct(&vSpc))(VspcsSpc(&vSpc,idx), VpthPath(&vPth), fmt)) {
      UF_PrintM("spectrum  #%d %s by %s'%s\n",
		idx, VspcsAction(&vSpc), PthShort(VpthPath(&vPth)), fmt);
      VspcsExists(&vSpc,idx)= TRUE;
      VspcsChange(&vSpc,idx) |= VspcsChangeFlag(&vSpc);
      Spc_Statistics(VspcsP(&vSpc) + idx);
      Spc_Changed(idx, 0);
      return IDX_EDONE; }
    else {
      Spc_ResetIntern(idx);
      ErrPrintR("fatal: spectrum #%d not %s by %s'%s\n",
		idx, VspcsAction(&vSpc),
		PthShort(VpthToken(&vPth)), VpthFormat(&vPth));
      return IDX_EERROR; } }
}
/* ---------------------------------------------------------------------- */
static int Spc_FileFinish(num)
     int num;
{
  if (!num) {
    UF_PrintE("warning: spectrum not %s\n", VspcsAction(&vSpc));
    return FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Spc_FormatIn()
{
  return Pth_FormatRead("input", VspcsInFmt(&vSpc));
}
/* ---------------------------------------------------------------------- */
int Spc_FormatOut()
{
  return Pth_FormatRead("output", VspcsOutFmt(&vSpc));
}
/* ---------------------------------------------------------------------- */
int Spc_Get()
{
  int status;

  strcpy(VpthFormat(&vPth), VspcsInFmt(&vSpc));
  status= Pth_LoopTokens(PTH_TPATH, Spc_GetExec, Spc_GetFinish,
			 "spectrum input file(s)");
  strcpy(VspcsInFmt(&vSpc), VpthFormat(&vPth));
  return status;
}
/* ---------------------------------------------------------------------- */
static int Spc_GetExec(status)
     int status;
{
  /*  printf("Spc_GetExec\n");*/
  if (status == IDX_ESKIP) {
    return IDX_ESKIP;
  } else
    if (Idx_GetOneFree()) {
    return Spc_ReadIntern(VidxSingle(&vIdx));
    } else {
      UF_PrintE("warning: no free spectrum available\n");
      return IDX_ESKIP;
    }
}
/* ---------------------------------------------------------------------- */
static int Spc_GetFinish(num)
     int num;
{
  if (num) { return TRUE; }
  else {
    UF_PrintE("warning: no spectrum got\n");
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Spc_Host()
{
  char host[MAXHOSTNAMELEN];

  if (UF_ItemRead(host, MAXHOSTNAMELEN,
		  "hostname [%s]", VspcsNetHost(&vSpc))) {
    VspcsQueryHost(&vSpc)= (*host != '\0');
    strcpy(VspcsNetHost(&vSpc), host); return TRUE; }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int Spc_IndexExec(idx0, idx, num)
     int idx0;
     int idx;
     int num;
{
  if (!VspcsExists(&vSpc,idx)) { return IDX_ESKIPPED; }
  else {
    if (!VspcsExists(&vSpc,idx0)) {
      if (Spc_CopyExec(idx, idx0, num) == IDX_EDONE) {
	UF_PrintM("\n");
	return IDX_ESKIPPED; }
      else { return IDX_EERROR; } }
    else if ((*VspcsFct(&vSpc))(
				VspcsSpc(&vSpc,idx0), VspcsSpc(&vSpc,idx),
				VcalsCal (&vCal, idx0), VcalsCal (&vCal, idx))) {
      UF_PrintM("spectrum #%d %s by #%d\n", idx0, VspcsAction(&vSpc), idx);
      VspcsChange(&vSpc,idx) |= VspcsChangeFlag(&vSpc);
      Spc_Statistics(VspcsP(&vSpc) + idx0);
      Spc_Changed(idx0, 0);
      return IDX_EDONE; }
    else {
      ErrPrintR("fatal: spectrum #%d not %s by #%d\n",
		idx0, VspcsAction(&vSpc), idx);
      return IDX_EERROR; } }
}

/* ---------------------------------------------------------------------- */
static int Spc_IndexFinish(num)
     int num;
{
  if (num) { return TRUE; }
  else {
    UF_PrintE("warning: no spectrum %s\n", VspcsAction(&vSpc)); return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Spc_Init(num)
     int num;
{
  if (NULL == (VspcsP(&vSpc)= (Vspc_t *)Malloc(num * sizeof(Vspc_t)))) {
    ErrPrintR("can not initialize spectrum buffers\n");
    return FALSE; }
  else {
    int i;
    VspcsNum(&vSpc)= num;
    for (i= 0; i< num; i++) { Spc_VspcInit(VspcsP(&vSpc) + i); }

    *VspcsInFmt(&vSpc)= '\0';
    *VspcsOutFmt(&vSpc)= '\0';
    *VspcsNetHost(&vSpc)= '\0';
    VspcsQueryHost(&vSpc)= FALSE;

    return TRUE; }
}
/* ---------------------------------------------------------------------- */
static int Spc_VspcInit(sp)
     Vspc_t *sp;
{
  VspcComment(sp)= NULL;
  VspcOrigin(sp)= SPC_OUNDEF;
  VspcChange(sp)= 0;
  SerialIdInit(VspcSerialId(sp));
  VspcExists(sp)= FALSE;
  SpcShmInit(VspcSpc(sp), SPC_REAL); /* main buffers in shared memory */
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Spc_MAdd()
{
  int status;

  if (Idx_ReadOne("sum spectrum index")) {
    strcpy(VpthFormat(&vPth), VspcsInFmt(&vSpc));
    VspcsFileFct(&vSpc)= SpcReadAdd;
    VspcsAction(&vSpc)= "incremented";
    VspcsChangeFlag(&vSpc)= SPC_CADD;
    status= Pth_MLoopTokens(PTH_TPATH, Spc_FileExec, Spc_FileFinish,
			    "add to #%d", VidxSingle(&vIdx));
    strcpy(VspcsInFmt(&vSpc), VpthFormat(&vPth)); }
  return status;
}
/* ---------------------------------------------------------------------- */
int Spc_Maximum()
{
  if (!Idx_ReadOne("maximum spectrum index") ||
      !Idx_Read(1, "spectrum index(s) for maximization")) {
    return FALSE; }
  else {
    VspcsFct(&vSpc)= SpcMax;
    VspcsAction(&vSpc)= "maximized";
    VspcsChangeFlag(&vSpc)= SPC_CMIN;
    return Idx_Loop2(Spc_IndexExec, Spc_IndexFinish); }
}
/* ---------------------------------------------------------------------- */
int Spc_MSubtract()
{
  int status;

  if (Idx_ReadOne("decremented spectrum index")) {
    strcpy(VpthFormat(&vPth), VspcsInFmt(&vSpc));
    VspcsFileFct(&vSpc)= SpcReadSub;
    VspcsAction(&vSpc)= "decremented";
    VspcsChangeFlag(&vSpc)= SPC_CADD;
    status
      = Pth_MLoopTokens(PTH_TPATH, Spc_FileExec, Spc_FileFinish,
		"subtract from #%d", VidxSingle(&vIdx));
    strcpy(VspcsInFmt(&vSpc), VpthFormat(&vPth)); }
  return status;
}
/* ---------------------------------------------------------------------- */
int Spc_MGet()
{
  int status;

  strcpy(VpthFormat(&vPth), VspcsInFmt(&vSpc));
  status
    = Spc_MGetLoop(PTH_TPATH, Spc_GetExec, Spc_GetFinish,
		   "get spectrum(s)");
  strcpy(VspcsInFmt(&vSpc), VpthFormat(&vPth));
  return status;
}
/* ---------------------------------------------------------------------- */
int Spc_MCommandGet()
{
  char file[MAXPATHLEN];
  if (VspcsMFile(&vSpc)) {
    UF_PrintE("fatal: can not open multiple mcommand-files\n"); UF_Reset(); }
  else if (UF_ItemRead(file, MAXPATHLEN, "mcommand file")) {
    if ((VspcsMFile(&vSpc)= Strdup(file))) {
      int status;

      strcpy(VpthFormat(&vPth), VspcsInFmt(&vSpc));
      status
	= Spc_MGetLoop(PTH_TPATH, Spc_CmdFileExec, Spc_GetFinish,
		       "operate '%s' on spectrum(s)");
      strcpy(VspcsInFmt(&vSpc), VpthFormat(&vPth));
      Free(VspcsMFile(&vSpc));
      return status; }
    else { ErrPrintR("fatal: can not setup mcommand-loop\n"); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
static int Spc_CmdFileExec(status)
     int status;
{
  if (IDX_EDONE == (status= Spc_GetExec(status))) {
    if (!UF_MCommand(VspcsMFile(&vSpc))) { return IDX_EERROR; } }
  return status;
}
/* ---------------------------------------------------------------------- */
int Spc_Minimum()
{
  if (!Idx_ReadOne("minimum spectrum index") ||
      !Idx_Read(1, "spectrum index(s) for minimization")) {
    return FALSE; }
  else {
    VspcsFct(&vSpc)= SpcMin;
    VspcsAction(&vSpc)= "minimized";
    VspcsChangeFlag(&vSpc)= SPC_CMIN;
    return Idx_Loop2(Spc_IndexExec, Spc_IndexFinish); }
}
/* ---------------------------------------------------------------------- */
int Spc_Multiply()
{
  double p;
  if (!UF_RealRead(FALSE, &VspcsValue(&vSpc), &p, "factor") ||
      !Idx_Read(1, "index(s) for multiplication")) {
    return FALSE; }
  else {
    VspcsFct(&vSpc)= SpcMultiply;
    VspcsAction(&vSpc)= "multiplied";
    VspcsChangeFlag(&vSpc)= SPC_CMULT;
    return Idx_Loop(Spc_ValueExec, Spc_ValueFinish); }
}
/* ---------------------------------------------------------------------- */
int Spc_Norm()
{
  if (!Nrm_Update()) { UF_SkipArgs(); return FALSE; }
  else if (!Idx_Read(1, "index(s) for normalization")) {
    return FALSE; }
  else {
    VspcsChangeFlag(&vSpc)= SPC_CMULT;
    return Idx_Loop(Spc_NormExec, Spc_NormFinish); }
}
/* ---------------------------------------------------------------------- */
static int Spc_NormExec(idx, num)
     int idx;
     int num;
{
  if (VspcsExists(&vSpc,idx)) {
    SpcMultiply(VspcsSpc(&vSpc,idx), VnrmsFac(&vNrm,idx));

    UF_PrintM("spectrum #%d multiplied by %f\n", idx, VnrmsFac(&vNrm,idx));
    VspcsChange(&vSpc,idx) |= VspcsChangeFlag(&vSpc);
    Spc_Statistics(VspcsP(&vSpc) + idx);
    Spc_Changed(idx, 0);
    return IDX_EDONE; }
  else { return IDX_ESKIPPED; }
}
/* ---------------------------------------------------------------------- */
static int Spc_NormFinish(num)
     int num;
{
  if (num) { return TRUE; }
  else {
    UF_PrintE("warning: no spectrum normalized\n");
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Spc_Offset()
{
  double p;
  if (!UF_RealRead(FALSE, &VspcsValue(&vSpc), &p, "offset") ||
      !Idx_Read(1, "index(s) for offset addition")) {
    return FALSE; }
  else {
    VspcsFct(&vSpc)= SpcOffset;
    VspcsAction(&vSpc)= "incremented";
    VspcsChangeFlag(&vSpc)= SPC_CADD;
    return Idx_Loop(Spc_ValueExec, Spc_ValueFinish); }
}
/* ---------------------------------------------------------------------- */
int Spc_InitCut(idx, name, fitExpr, origin)
     int idx;
     char *name;
     char *fitExpr;
     int origin;
{
  Spc_t sp= VspcsSpc(&vSpc,idx);

  Free(SpcFile(sp));
  SpcFile(sp)= Strdup(name);
  VspcsExists(&vSpc,idx)= TRUE;
  VspcsChange(&vSpc,idx) |= SPC_CCUT;
  VspcsOrigin(&vSpc,idx)= origin;
  Fio_FileInit(idx, fitExpr);
  Spc_Changed(idx, 0);
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Spc_Read()
{
  strcpy(VpthFormat(&vPth), VspcsInFmt(&vSpc));
  if (PTH_TUNDEF ==
      Pth_TokenFormatRead(PTH_TPATH, "", "spectrum input file")) {
    UF_Reset();
    return FALSE; }
  else if (!Idx_Read(1, "read spectrum for index(s)")) {
    return FALSE; }
  strcpy(VspcsInFmt(&vSpc), VpthFormat(&vPth));

  return Idx_Loop(Spc_ReadExec, Spc_ReadFinish);
}
/* ---------------------------------------------------------------------- */
int Spc_ReadExec(idx, num)
     int idx;
     int num;
{
  if (!num) {			/* first spectrum must be read */
    return Spc_ReadIntern(idx); }
  else {			/* copy the read spectrum to other buffers */
    return Spc_CopyExec(VidxIdx(&vIdx,0), idx, num-1); }
}
/* ---------------------------------------------------------------------- */
static int Spc_ReadFinish(num)
     int num;
{
  if (num > 1) { return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int Spc_ReadIntern(idx)
     int idx;
{
  char fmt[SPC_FMTLEN];
  int status= FALSE;
  int success=FALSE;

  Spc_ResetIntern(idx);
  strcpy(fmt, VpthFormat(&vPth));
  if (VspcsQueryHost(&vSpc) && *VspcsNetHost(&vSpc) &&
      !strchr(VpthToken(&vPth), '/')) {
    /* read spectrum from foreign host via network */
    Spc_t sp= VspcsSpc(&vSpc,idx);
    int nc;
    int StackAlloc(int, buffer, SpcMaxRes, SPC_MR);
    if (!buffer) {
      ErrPrintR("fatal: can not alloc tmp-buffer\n");
      Spc_Changed(idx, 0);
      return IDX_EERROR;
    }
    if ((nc= Net_ReadSpc(VspcsNetHost(&vSpc), VpthToken(&vPth),
			 (char *)buffer))> 0) {
      if (nc > SpcMaxRes) {
	ErrPrintR("fatal: Net_ReadSpc() has written beyond array limits\n");
	UF_PrintM("info:  %d channels received\n", nc);
	Spc_Changed(idx, 0);
	return IDX_EERROR;
      } else
	if (!SpcAlloc(sp, nc)) {
	  ErrPrintR("fatal: can not read spectrum '%s' from host '%s'\n",
		    VpthToken(&vPth), VspcsNetHost(&vSpc));
	  Spc_Changed(idx, 0);
	  return IDX_EERROR;
	} else {
	  VspcsOrigin(&vSpc,idx)= SPC_OHOST;
	  Free(SpcFile(sp));
	  SpcFile(sp)= Strdup(VpthToken(&vPth));
	  strcpy(SpcFormat(sp), "host");
	  {
	    int i;
	    SpcReal_t *s= SpcBufReal(SpcSpc(sp));
	    SpcReal_t *dS= SpcBufReal(SpcDSpc(sp));
	    for (i=0; i<nc; i++) {
	      s[i]= GETHE4(buffer[i]);
	      dS[i]= ABS(s[i]);
	    }
	  }
	  SpcBufNum(SpcSpc(sp))= nc;
 	  SpcBufNum(SpcDSpc(sp))= nc;
#if 0
				/* currently useless;
				 * must not be copied to SpcFile(sp)
				 * since SpcFile is used in Spc_UpdateExec()
				 */
	  strcpy(VpthPath(&vPth), VspcsNetHost(&vSpc));
	  strcat(VpthPath(&vPth), "::");
	  strcat(VpthPath(&vPth), VpthToken(&vPth));
#endif /* 0 */
	  status= TRUE;
	}
    }
  }
  if (!status) {
    if (status= SpcRead(VspcsSpc(&vSpc,idx), VpthPath(&vPth), fmt)) {
      VspcsOrigin(&vSpc,idx)= SPC_ODISK;
    }
  }
  if (status) {
    VspcsComment(&vSpc,idx)= Strdup(VpthComment(&vPth));
    UF_PrintM("spectrum %s'%s %s read to #%d\n",
	      PthShort(VspcsFile(&vSpc,idx)), VspcsFormat(&vSpc,idx), 
	      (VspcsComment(&vSpc,idx) ? VspcsComment(&vSpc,idx) : ""), idx);
    VspcsExists(&vSpc,idx)= TRUE;
    Fio_FileInit(idx, PatGet(VpthPattern(&vPth), PTH_FIT));
    Spc_Statistics(VspcsP(&vSpc) + idx);
    Spc_Changed(idx, 0);
    return IDX_EDONE;
  } else {
    ErrPrintR("fatal: can not read spectrum %s'%s\n",
	      PthShort(VpthToken(&vPth)), fmt);
    Spc_Changed(idx, 0);
    return IDX_EERROR;
  }
}
/* ---------------------------------------------------------------------- */
int Spc_Reset(idx)
     int idx;
{
  if (!Spc_ResetIntern(idx)) { return FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int Spc_ResetIntern(idx)
     int idx;
{
  if (VspcsExists(&vSpc,idx)) {
    if (!Fio_Close(idx)) { return FALSE; }
    SpcReset(VspcsSpc(&vSpc,idx));
    Free(VspcsComment(&vSpc,idx));
    VspcsExists(&vSpc,idx)= FALSE;
    VspcsChange(&vSpc,idx)= 0;
    VspcsOrigin(&vSpc,idx)= SPC_OUNDEF;
    Spc_Changed(idx, 0); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Spc_Resolution()
{
  if (!Idx_ReadOne("spectrum index to change resolution")) {
    return FALSE; }
  else {
    int idx= VidxSingle(&vIdx);
    if (!VspcsExists(&vSpc,idx)) {
      UF_PrintE("fatal: spectrum #%d does not exist\n", idx);
      UF_Reset();
      return FALSE; }
    else {
      int res;
      Spc_t spc= VspcsSpc(&vSpc,idx);
      int oldres= SpcNum(spc);
      if (UF_NoArgs()) {
	UF_PrintM("resolution of spectrum #%d '%s': %d\n", idx, 
		  PthShort(SpcFile(spc)), oldres); }
      if (!UF_IntRead(FALSE, &res, "new resolution of #%d", idx)) {
	return FALSE; }
      if (res <= 0) {
	UF_PrintM("fatal: illegal resolution <= 0 specified\n");
	return FALSE; }
      else if (res == oldres) { return TRUE; }
      else if (res > oldres) {
	if (!SpcRealloc(spc, res)) {
	  ErrPrintR("can not change resolution of #%d\n", idx);
	  return FALSE; }
	else {
	  memset(SpcBufReal(SpcSpc(spc)) + oldres, 0,
		 (size_t)((res - oldres) * sizeof(SpcReal_t)));
	  memset(SpcBufReal(SpcDSpc(spc)) + oldres, 0,
		 (size_t)((res - oldres) * sizeof(SpcReal_t))); } }
      SpcBufNum(SpcDSpc(spc))= SpcBufNum(SpcSpc(spc))= res;
      VspcsChangeFlag(&vSpc)= SPC_CEDIT;
      return TRUE; } }
}
/* ---------------------------------------------------------------------- */
int Spc_Show()
{
  char *query= (VspcsQueryHost(&vSpc)) ? "" : "do not ";
  UF_PrintM("formats: input \"%s\", output \"%s\"\n",
	    VspcsInFmt(&vSpc), VspcsOutFmt(&vSpc));
  UF_PrintM("%squery host %s\n", query, VspcsNetHost(&vSpc));
  return Spc_ShowNames();
}
/* ---------------------------------------------------------------------- */
int Spc_ShowNames()
{
  int i;
  int spcNum;
  for (i= 0; i< VspcsNum(&vSpc); i++) {
    if (VspcsExists(&vSpc,i)) {
      char spcStat[SPC_STATLEN];
      if (!Spc_Info(i, spcStat)) { return FALSE; }
      spcNum++;
      UF_PrintM("#%d: %s'%s (%d) %s  %s\n", i,
		PthShort(VspcsFile(&vSpc,i)), VspcsFormat(&vSpc,i),
		SpcNum(VspcsSpc(&vSpc,i)),
		spcStat,
		(VspcsComment(&vSpc,i) ? VspcsComment(&vSpc,i) : "")); } }
  
  if (spcNum) { return TRUE; }
  else { UF_PrintE("warning: no spectra available\n"); return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int Spc_Statistics(sp)
     Vspc_t *sp;
{
  if (!VspcExists(sp)) { return FALSE; }
  else {
    int i;
    int spcNum;
    SpcReal_t minS;
    SpcReal_t maxS;
    SpcReal_t minPos;
    SpcReal_t maxNeg;
    SpcReal_t sum;
    SpcReal_t sumAbs;
    SpcReal_t *s;

    for (i= 0, spcNum= SpcNum(VspcSpc(sp)), s= SpcBufReal(SpcSpc(VspcSpc(sp))),
	 minS= s[0], maxS= s[0],
	 minPos= 0.0, maxNeg= 0.0,
	 sum= 0.0, sumAbs= 0.0;
	 i< spcNum; i++) {
      if (s[i] < minS) { minS= s[i]; }
      else if (s[i] > maxS) { maxS= s[i]; }
      sum += s[i];

      if (s[i] < 0.0) {
	if (maxNeg == 0.0 || s[i] > maxNeg) { maxNeg= s[i]; }
	sum += s[i];
	sumAbs -= s[i]; }
      else if (s[i] > 0.0) {
	if (minPos == 0.0 || s[i] < minPos) { minPos= s[i]; }
	sumAbs += s[i]; } }

    VspcMin(sp)= minS;
    VspcMax(sp)= maxS;
    VspcMinPos(sp)= minPos;
    VspcMaxNeg(sp)= maxNeg;
    VspcSum(sp)= sum;
    VspcSumAbs(sp)= sumAbs;

    return TRUE; }
}
/* ---------------------------------------------------------------------- */
int Spc_Info(idx, info)
     int idx;
     char *info;
{
  if (!VspcsExists(&vSpc,idx)) {
    ErrPrintR("fatal: spectrum #%d not defined\n", idx);
    return FALSE; }
  switch (VspcsOrigin(&vSpc,idx)) {
  case SPC_OHOST:   strcpy(info, ":"); break;
  case SPC_ODISK:   strcpy(info, "@"); break;
  case SPC_OMEMORY: strcpy(info, "~"); break;
  default:
    ErrPrintR("fatal internal: illegal status value for spectrum #%d\n", idx);
    return FALSE; }
  if (VspcsChange(&vSpc,idx) & SPC_CADD)   { strcat(info, "+"); }
  if (VspcsChange(&vSpc,idx) & SPC_CMULT)  { strcat(info, "*"); }
  if (VspcsChange(&vSpc,idx) & SPC_CRECAL) { strcat(info, "<"); }
  if (VspcsChange(&vSpc,idx) & SPC_CEDIT)  { strcat(info, "|"); }
  if (VspcsChange(&vSpc,idx) & SPC_CCUT)   { strcat(info, "^"); }
  if (VspcsChange(&vSpc,idx) & SPC_CMIN)   { strcat(info, "&"); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int Spc_Subtract()
{
  int status;
  
  if (Idx_ReadOne("decremented spectrum index")) {
    strcpy(VpthFormat(&vPth), VspcsInFmt(&vSpc));
    VspcsFileFct(&vSpc)= SpcReadSub;
    
    VspcsFct(&vSpc)= SpcSub;
    VspcsAction(&vSpc)= "decremented";
    VspcsChangeFlag(&vSpc)= SPC_CADD;
    status= Spc_TokenIdxLoop(PTH_TPATH,
			     Spc_FileExec, Spc_IndexExec, Spc_TokenIdxFinish,
			     "subtract spectrum(s) from #%d",
			     VidxSingle(&vIdx));
    strcpy(VspcsInFmt(&vSpc), VpthFormat(&vPth)); }
  return status;
}

/* ---------------------------------------------------------------------- */
int Spc_Update()
{
  if (UF_NoArgs()) {
    Idx_SetAll(); }		/* default if no further input */
  else if (!Idx_Read(1, "update spectrum for index(s)")) {
    return FALSE; }

  return Idx_Loop(Spc_UpdateExec, Spc_UpdateFinish);
}
/* ---------------------------------------------------------------------- */
static int Spc_UpdateExec(idx, num)
     int idx;
     int num;
{
  if (!VspcsExists(&vSpc,idx) ||
      VspcsOrigin(&vSpc,idx) == SPC_OMEMORY) {
    return IDX_ESKIPPED; }
  else {
    strcpy(VpthPath(&vPth), VspcsFile(&vSpc,idx));
    strcpy(VpthToken(&vPth), VspcsFile(&vSpc,idx));
    strcpy(VpthFormat(&vPth), VspcsFormat(&vSpc,idx));
    return Spc_ReadIntern(idx); }
}
/* ---------------------------------------------------------------------- */
static int Spc_UpdateFinish(num)
     int num;
{
  if (num) { return TRUE; }
  else {
    UF_PrintE("warning: no spectrum updated\n");
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
static int Spc_ValueExec(idx, num)
     int idx;
     int num;
{
  if (VspcsExists(&vSpc,idx)) {
    (*VspcsFct(&vSpc))(VspcsSpc(&vSpc,idx), VspcsValue(&vSpc));
    
    UF_PrintM("spectrum #%d %s by %f\n",
	      idx, VspcsAction(&vSpc), VspcsValue(&vSpc));
    VspcsChange(&vSpc,idx) |= VspcsChangeFlag(&vSpc);
    Spc_Statistics(VspcsP(&vSpc) + idx);
    Spc_Changed(idx, 0);
    return IDX_EDONE; }
  else { return IDX_ESKIPPED; }
}
/* ---------------------------------------------------------------------- */
static int Spc_ValueFinish(num)
     int num;
{
  if (num) { return TRUE; }
  else {
    UF_PrintE("warning: no spectrum %s\n", VspcsAction(&vSpc));
    return FALSE; }
}
/* ---------------------------------------------------------------------- */
int Spc_Write()
{
  strcpy(VpthFormat(&vPth), VspcsOutFmt(&vSpc));
  if (PTH_TUNDEF ==		/* read vPth.token */
      Pth_TokenFormatRead(PTH_TUNDEF, "", "spectrum output file | wc")) {
    UF_Reset();
    return FALSE; }
  else if (!Idx_Read(1, "write spectrum for index(s)")) {
    return FALSE; }
  strcpy(VspcsOutFmt(&vSpc), VpthFormat(&vPth));

  return Pth_LoopIndices(Spc_WriteExec, Spc_WriteFinish);
}
/* ---------------------------------------------------------------------- */
/* ARGSUSED */
static int Spc_WriteExec(idx, num)
     int idx;
     int num;
{
  char fmt[SPC_FMTLEN];

  strcpy(fmt, VspcsOutFmt(&vSpc));

  if (SpcWrite(VspcsSpc(&vSpc,idx), VpthPath(&vPth), fmt)) {
    UF_PrintM("spectrum written to %s'%s for #%d\n",
	      PthShort(VpthPath(&vPth)), fmt, idx);
    VspcsOrigin(&vSpc,idx)= SPC_OMEMORY;
    return IDX_EDONE; }
  else {
    ErrPrint("error: can not write spectrum to %s'%s for #%d\n",
	     PthShort(VpthPath(&vPth)), fmt, idx);
    return IDX_ESKIPPED; }
}
/* ---------------------------------------------------------------------- */
static int Spc_WriteFinish(num)
     int num;
{
  if (num) { return TRUE; }
  else {
    UF_PrintE("warning: no spectrum written for %s'%s\n",
	      VpthToken(&vPth), VpthFormat(&vPth));
    UF_Reset();
    return FALSE; }
}
