/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsSpectra.h,v 1.2 1994/09/20 14:49:43 vs Exp vs $ */
#ifndef _VsSpectra_h
#define _VsSpectra_h

#include <tv/SerialId.h>
#include <tv/vsTypes.h>
#include <tv/vsSpectra.h>

				/* spectrum origin */
#define SPC_OUNDEF		1
#define SPC_OHOST		2
#define SPC_ODISK		3
#define SPC_OMEMORY		4

				/* spectrum changes */
#define SPC_CADD		(1 << 0)
#define SPC_CMULT		(1 << 1)
#define SPC_CRECAL		(1 << 2)
#define SPC_CEDIT		(1 << 3)
#define SPC_CCUT		(1 << 4)
#define SPC_CMIN		(1 << 5)

#define SPC_STATLEN		64

typedef struct {
  SpcRec spc;			/* spectrum */
  char *comment;		/* comment */
  SerialId_t serialId;		/* SerialId */
  int change;			/* modifications */
  int origin;			/* origin */
  int exists;			/* spectrum is defined */
  SpcReal_t min;		/* minimum of spectrum */
  SpcReal_t max;		/* maximum of spectrum */
  SpcReal_t minPos;		/* minimal negativ value of spectrum */
  SpcReal_t maxNeg;		/* maximal negativ value of spectrum */
  SpcReal_t sum;		/* integral of spectrum */
  SpcReal_t sumAbs;		/* integral of abs(spectrum) */
} Vspc_t;

#define VspcSpc(sp)		(&((sp)->spc))
#define VspcComment(sp)		((sp)->comment)
#define VspcSerialId(sp)	((sp)->serialId)
#define VspcChange(sp)		((sp)->change)
#define VspcOrigin(sp)		((sp)->origin)
#define VspcExists(sp)		((sp)->exists)
#define VspcMin(sp)		((sp)->min)
#define VspcMax(sp)		((sp)->max)
#define VspcMinPos(sp)		((sp)->minPos)
#define VspcMaxNeg(sp)		((sp)->maxNeg)
#define VspcSum(sp)		((sp)->sum)
#define VspcSumAbs(sp)		((sp)->sumAbs)

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 1024
#endif

typedef struct {		/* spectra information */
  int num;			/* number */
  Vspc_t *p;			/* spectrum vector */
  char inFmt[SPC_FMTLEN];	/* user given input format */
  char outFmt[SPC_FMTLEN];	/* user given ouput format */
  char netHost[MAXHOSTNAMELEN];	/* host name for spectra from net */
  int queryHost;		/* query host on each spectrum input */
  pfi_t fct;			/* executed function in loop in VsSpectra */
  pfi_t fileFct;		/* executed function in loop in VsSpectra */
  int changeFlag;		/* flag entry for change */
  char *action;			/* title of executed action in VsSpectra */
  int editChannel;		/* channel to edit */
  double value;			/* new value */
  char *mFile;			/* mcommand file */
} Vspcs_t;

#define VspcsNum(sp)		((sp)->num)
#define VspcsP(sp)		((sp)->p)
#define VspcsInFmt(sp)		((sp)->inFmt)
#define VspcsOutFmt(sp)		((sp)->outFmt)
#define VspcsNetHost(sp)	((sp)->netHost)
#define VspcsQueryHost(sp)	((sp)->queryHost)
#define VspcsFct(sp)		((sp)->fct)
#define VspcsFileFct(sp)	((sp)->fileFct)
#define VspcsAction(sp)		((sp)->action)
#define VspcsChangeFlag(sp)	((sp)->changeFlag)
#define VspcsEditChannel(sp)	((sp)->editChannel)
#define VspcsValue(sp)		((sp)->value)
#define VspcsMFile(sp)		((sp)->mFile)

#define VspcsSpc(sp,i)		VspcSpc(VspcsP(sp)+(i))
#define VspcsComment(sp,i)	VspcComment(VspcsP(sp)+(i))
#define VspcsSerialId(sp,i)	VspcSerialId(VspcsP(sp)+(i))
#define VspcsChange(sp,i)	VspcChange(VspcsP(sp)+(i))
#define VspcsOrigin(sp,i)	VspcOrigin(VspcsP(sp)+(i))
#define VspcsExists(sp,i)	VspcExists(VspcsP(sp)+(i))
#define VspcsMin(sp,i)		VspcMin(VspcsP(sp)+(i))
#define VspcsMax(sp,i)		VspcMax(VspcsP(sp)+(i))
#define VspcsMinPos(sp,i)	VspcMinPos(VspcsP(sp)+(i))
#define VspcsMaxNeg(sp,i)	VspcMaxNeg(VspcsP(sp)+(i))
#define VspcsSum(sp,i)		VspcSum(VspcsP(sp)+(i))
#define VspcsSumAbs(sp,i)	VspcSumAbs(VspcsP(sp)+(i))

#define VspcsFile(sp,i)		SpcFile(VspcsSpc(sp,i))
#define VspcsFormat(sp,i)	SpcFormat(VspcsSpc(sp,i))
#define VspcsFile(sp,i)		SpcFile(VspcsSpc(sp,i))

#ifdef _VsSpectra_c
Vspcs_t vSpc;
#else
extern Vspcs_t vSpc;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsSpectraF.h"

#undef P_

#endif				/* _VsSpectra_h */

