/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsUserFace.c,v 1.3 1994/09/20 14:49:46 vs Exp vs $ */ 

#define _VsUserFace_c

				/* system include files */
#ifdef __STDC__
# include <stdarg.h>
#else
# include <varargs.h>
#endif
				/* library include files */
#include <tv/vsTypes.h>
#include <tv/vsUserFace.h>
#include <tv/vsPath.h>

				/* private include files */
#include "VsUserFace.h"

#define UF_INPBUFLEN		32768 /* Gesamtbuffergroesse ! */
#define UF_INPBUFNUM		64
#define UF_CMDFILNUM		16
#define UF_MENUNUM		64

/* ---------------------------------------------------------------------- */
 UF_t *vUp= NULL;


/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS3 */
int UF_IntRead(int unexpected, int *number, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UF_IntRead(va_alist)
     /* int unexpected, int *number, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { int unexpected= va_arg(ap, int);
    int *number= va_arg(ap, int *);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFIntReadV(vUp, unexpected, number, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS3 */
int UF_ItemRead(char *buffer, int bufLen, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UF_ItemRead(va_alist)
     /* char *buffer, int bufLen, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { char *buffer= va_arg(ap, char *);
    int bufLen= va_arg(ap, int);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFItemReadV(vUp, buffer, bufLen, fmt, ap);
    va_end(ap);
    return status;
 }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS1 */
int UF_PrintE(char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UF_PrintE(va_alist)
     /* char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { char *fmt= va_arg(ap, char *);
#endif
    int status= UFPrintEV(vUp, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
int UF_PrintEV(fmt, ap)
     char *fmt;
     va_list ap;
{
  /*  printf("UFPrintEV\n");*/
  return UFPrintEV(vUp, fmt, ap);
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS1 */
int UF_PrintM(char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UF_PrintM(va_alist)
     /* char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { char *fmt= va_arg(ap, char *);
#endif
    int status= UFPrintMV(vUp, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS1 */
int UF_PrintP(char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UF_PrintP(va_alist)
     /* char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { char *fmt= va_arg(ap, char *);
#endif
    int status= UFPrintPV(vUp, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
#ifdef __STDC__
/* VARARGS4 */
int UF_RealRead(int unexpected,
		double *number, double *precision, char *fmt, ...)
{
  va_list ap;
  va_start(ap, fmt);
  {
#else
int UF_RealRead(va_alist)
     /* int unexpected, double *number, double *precision, char *fmt, ... */
     va_dcl
{
  va_list ap;
  va_start(ap);
  { int unexpected= va_arg(ap, int);
    double *number= va_arg(ap, double *);
    double *precision= va_arg(ap, double *);
    char *fmt= va_arg(ap, char *);
#endif
    int status= UFRealReadV(vUp, unexpected, number, precision, fmt, ap);
    va_end(ap);
    return status; }
}
/* ---------------------------------------------------------------------- */
int UF_MenuLoop(mp, prompt)
     Men_t *mp;
     char *prompt;
{
  /*printf("UF_MenuLoop\n")*/
  return UFMenuLoop(vUp, mp, prompt);
}
/* ---------------------------------------------------------------------- */
int UF_Unexpected()
{
  return (UFStopTyp(vUp) == UFSUNEXPECTED);
}
/* ---------------------------------------------------------------------- */
int UF_NoArgs()
{
  return UFNoArgs(vUp);
}
/* ---------------------------------------------------------------------- */
int UF_BufferSet(buf)
     char *buf;
{
  return UFBufferSet(vUp, buf);
}
/* ---------------------------------------------------------------------- */
int UF_FileOpen(file, protocol, autoEof)
     char *file;
     int protocol;
     int autoEof;
{
  return UFFileOpen(vUp, file, protocol, autoEof);
}
/* ---------------------------------------------------------------------- */
int UF_Loop()
{
  extern Men_t rootTvMen;

  UFMenuLoop(vUp, &rootTvMen, "tv>");
  UF_PrintM("\n");
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int UF_MCommand(file)
     char *file;
{
  extern Men_t rootTvMen;

  return UFMenuLoopFile(vUp, file, &rootTvMen, "tv>");
}      
/* ---------------------------------------------------------------------- */
int UF_UpdateStat()
{
  return UFUpdateStat(vUp);
}
/* ---------------------------------------------------------------------- */
int UF_ItemGet(bp, buffer, bufLen)
     char **bp;
     char *buffer;
     int bufLen;
{
  return UFItemGet(vUp, bp, buffer, bufLen);
}
/* ---------------------------------------------------------------------- */
int UF_Reset()
{
  return UFReset(vUp);
}
/* ---------------------------------------------------------------------- */
int UF_ResetIllegal()
{
  return UFResetIllegal(vUp);
}
/* ---------------------------------------------------------------------- */
int UF_Init(path)
     char *path;
{
  if ((vUp= UFOpen(UF_INPBUFLEN, UF_INPBUFNUM,
		   UF_CMDFILNUM, UF_MENUNUM,
		   NULL, NULL, NULL, NULL, NULL, path))) {
    UFSimpleInit(vUp);
    return TRUE; }
  else { return FALSE; }
}
/* ---------------------------------------------------------------------- */
void UF_GraphicInit()
{
#ifndef NO_VD_GRAPHIC
  extern void XUFInit(); XUFInit(vUp);
#endif				/* NO_VD_GRAPHIC */
}
/* ---------------------------------------------------------------------- */
int UF_FileOpenM()
{
  char file[MAXPATHLEN];

  if (UFItemRead(vUp, file, MAXPATHLEN, "command file")) {
    if (UF_FileOpen(file, TRUE, TRUE)) {
      return TRUE; }
    else {
      UF_PrintE("fatal: can not open command file '%s'\n", file);
      UF_Reset(); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int UF_OpenCmdFile(up)
     UF_t *up;
{
  char file[MAXPATHLEN];

  if (UFItemRead(up, file, MAXPATHLEN, "new input protocol file")) {
    if (UFCmdFile(up)) { UF_CloseCmdFile(up); }
    if (UFFileOpenCmd(up, file, "w")) {
      UFPrintM(up, "input protocol file '%s' created\n",
	       PthShort(UFCmdFileName(up)));
      return TRUE; }
    else {
      UFPrintE(up, "fatal: can not open input protocol file '%s'\n", file);
      UFReset(up); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int UF_OpenOutFile(up)
     UF_t *up;
{
  char file[MAXPATHLEN];

  if (UFItemRead(up, file, MAXPATHLEN, "new protocol file")) {
    if (UFOutFile(up)) { UF_CloseOutFile(up); }
    if (UFFileOpenOut(up, file, "w")) {
      UFPrintM(up, "protocol file '%s' created\n",
	       PthShort(UFOutFileName(up)));
      return TRUE; }
    else {
      UFPrintE(up, "fatal: can not open protocol file '%s'\n", file);
      UFReset(up); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int UF_OpenStdFile(up)
     UF_t *up;
{
  UFStdOut(up)= stdout;		/* protocol to stdout/stderr */
  UFStdErr(up)= stderr;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int UF_AppendCmdFile(up)
     UF_t *up;
{
  char file[MAXPATHLEN];

  if (UFItemRead(up, file, MAXPATHLEN, "old input protocol file")) {
    if (UFCmdFile(up)) { UF_CloseCmdFile(up); }
    if (UFFileOpenCmd(up, file, "a")) {
      UFPrintM(up, "input protocol file '%s' (re)opened\n",
	       PthShort(UFCmdFileName(up)));
      return TRUE; }
    else {
      UFPrintE(up, "fatal: can not open input protocol file '%s'\n", file);
      UFReset(up); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int UF_AppendOutFile(up)
     UF_t *up;
{
  char file[MAXPATHLEN];

  if (UFItemRead(up, file, MAXPATHLEN, "old protocol file")) {
    if (UFOutFile(up)) { UF_CloseOutFile(up); }
    if (UFFileOpenOut(up, file, "a")) {
      UFPrintM(up, "protocol file '%s' (re)opened\n",
	       PthShort(UFOutFileName(up)));
      return TRUE; }
    else {
      UFPrintE(up, "fatal: can not open protocol file '%s'\n", file);
      UFReset(up); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int UF_CloseCmdFile(up)
     UF_t *up;
{
  if (UFCmdFile(up)) {
    UFPrintM(up, "closing input protocol file '%s'\n",
	     PthShort(UFCmdFileName(up)));
    return UFFileCloseCmd(up); }
  else {
    UFPrintE(up, "warning: no input protocol file open\n"); return FALSE; }
}
/* ---------------------------------------------------------------------- */
int UF_CloseOutFile(up)
     UF_t *up;
{
  if (UFOutFile(up)) {
    UFPrintM(up, "closing protocol file '%s'\n",
	     PthShort(UFOutFileName(up)));
    return UFFileCloseOut(up); }
  else { UFPrintE(up, "warning: no protocol file open\n"); return FALSE; }
}
/* ---------------------------------------------------------------------- */
int UF_CloseStdFile(up)
     UF_t *up;
{
  UFStdOut(up)= NULL;		/* protocol to stdout/stderr */
  UFStdErr(up)= NULL;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
char *UF_Find(file)
     char *file;
{
  char *path;
  char *searchPath;
  extern char *getenv();

  if (
      (
       (
	UFPath(vUp) && 
	(searchPath= getenv(UFPath(vUp))) && 
	strlen (searchPath) != 0
	) ||
       (searchPath= UFStdPth(vUp)) ||
       (searchPath= getenv("PATH"))
       )
      &&
      (path= PthFind(file, searchPath)) 
      && *path
      ) {
    return path; }
  else { return NULL; }
}
/* ---------------------------------------------------------------------- */
int UF_SkipArgs()
{
  char item[UFMAXBUFLEN];

  while (!UFNoArgs(vUp) && UFItemRead(vUp, item, UFMAXBUFLEN, "")) { ; }
  return UFNoArgs(vUp);
}
/* ---------------------------------------------------------------------- */
int UF_Which()
{
  char file[UFMAXBUFLEN];
  char *searchPath;

  if (UFNoArgs(vUp)) {
    if ((UFPath(vUp) && (searchPath= getenv(UFPath(vUp)))) ||
	(searchPath= UFStdPth(vUp)) ||
	(searchPath= getenv("PATH"))) {
      UF_PrintM("search path for configuration and command files: %s\n",
		searchPath);
      return TRUE; }
    else { UF_PrintM("no search path defined\n"); } }
  else if (UFItemRead(vUp, file, UFMAXBUFLEN, "file name")) {
    char *path;
    if ((path= UF_Find(file))) {
      UF_PrintM("%s\n", path); return TRUE; }
    else if ((UFPath(vUp) && (searchPath= getenv(UFPath(vUp)))) ||
	     (searchPath= UFStdPth(vUp)) ||
	     (searchPath= getenv("PATH"))) {
      UF_PrintE("%s not found in %s\n", file, searchPath); }
    else { UF_PrintE("%s not found\n", file); } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
